program main
	use SM_const
	use HCOUP_SM
	implicit none

	integer model,OREW,ORQCD
	double precision:: para1(100)
	integer:: i
	
	open(1, file='./inputs/in_main.txt')
	do i = 1, 100
		if (i <= 6) then
			read (1,'()') 
		else
			read (1,*,end=10) para1(i-6)
		endif
	enddo

10	model = para1(1)
	OREW  = para1(2)
	ORQCD = para1(3)

	call header_terminal(6)
	call sm_input()

	if (mh < 124.d0 .or. 126.d0 < mh) then
		write(*,*) "ERROR: Input h mass can not be used."
		stop
	endif

	if (model == 1) then
		call HCOUP_HSM(OREW,ORQCD)
	else if (model == 2) then 
		call HCOUP_THDM(OREW,ORQCD,1) !Type-I
	else if (model == 3) then
		call HCOUP_THDM(OREW,ORQCD,2) !Type-II
	else if (model == 4) then
		call HCOUP_THDM(OREW,ORQCD,3) !Type-X
	else if (model == 5) then
		call HCOUP_THDM(OREW,ORQCD,4) !Type-Y
	else if (model == 6) then
		call HCOUP_IDM(OREW,ORQCD)
	else
		write(*,*) "Wrong model..."
		stop
	endif

	contains 
!#############################################################
	subroutine sm_input()
		use SM_const
		double precision::   para1(100)
		integer:: i

		open(1, file='./inputs/in_sm.txt')
		do i = 1, 100
			if (i <= 6) then
				read (1,'()') 
			else
				read (1,*,end=30) para1(i-6)
			endif
		enddo

30    alpha_em    = 1.d0/para1(1)
		mz          = para1(2)
		G_F         = para1(3)
		delta_alpha = para1(4)
		alpha_s     = para1(5)
		mh          = para1(6)
		mt          = para1(7)
		mb          = para1(8)
		mc          = para1(9)
		mb_MS       = para1(10)
		mc_MS       = para1(11)
		mtau        = para1(12)
		mmu         = para1(13)

		!--------------------------------------------------------------
		sw  = sqrt(1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
		cw  = sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
		g   = 2.d0*mz&
				*sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))*(sqrt(sqrt(2.d0)*G_F))
		gz  = 2.d0*mz&
				*sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))*(sqrt(sqrt(2.d0)*G_F))&
				/sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
		mw  = mz*sqrt(1.d0-1.d0/2.d0*(1.d0-sqrt(1.d0-4.d0*pi*(1.d0/(sqrt(2.d0)*G_F))*alpha_em/mz**2)))
		vev = 1.d0/(sqrt(sqrt(2.d0)*G_F))

		vt  = (It-2.d0*sw**2*Qt)/2.d0
		at  = It/2.d0
		vb  = (Ib-2.d0*sw**2*Qb)/2.d0
		ab  = Ib/2.d0
		vnu = It/2.d0
		anu = It/2.d0
		ve  = (Ie-2.d0*sw**2*Qe)/2.d0
		ae  = Ie/2.d0

	end subroutine sm_input

end program main

	include "models/HCOUP_HSM.F90"
	include "models/HCOUP_THDM.F90"
	include "models/HCOUP_IDM.F90"
