module SM_const
	implicit none

!------ Fundermental constants (See inputs/in_sm.txt) ------------------------
	double precision:: alpha_em
	double precision:: G_F
	double precision:: mZ
	double precision:: delta_alpha
	double precision:: alpha_s
!-----------------------------------------------------------------------------
	double precision:: mh
	double precision:: mt
	double precision:: mb
	double precision:: mc
	double precision,parameter:: ms  = 0.1d0 !For H+->ts decay where we used massive QCD formula
	! double precision,parameter:: ms  = 0.d0
	double precision,parameter:: md  = 0.d0
	double precision,parameter:: mup = 0.d0
	double precision:: mtau
	double precision:: mmu
	double precision,parameter:: me  = 0.5109989461d-3
!------ MS-bar quark mass ----------------------------------------------------
	double precision,parameter:: mt_MS = 162.2d0
	double precision:: mb_MS
	double precision,parameter:: ms_MS = 0.093d0  ! at scale of 2 GeV [PDG2020]
	double precision:: mc_MS
!------ Outputs --------------------------------------------------------------
	double precision:: sw
	double precision:: cw
	double precision:: g
	double precision:: gz
	double precision:: mw
	double precision:: vt
	double precision:: vb
	double precision:: ve
	double precision:: at
	double precision:: ab
	double precision:: ae
	double precision:: vev
	double precision:: vnu
	double precision:: anu
!------ CKM matrix elements (Eq.(12.27) in Chap.12 [PDG2020])---------------------
	double precision,parameter:: Vtb = 0.999172d0
	double precision,parameter:: Vts = 0.03978d0
	double precision,parameter:: Vtd = 0.00854d0
	double precision,parameter:: Vcb = 0.04053d0
	double precision,parameter:: Vcs = 0.97320d0
	double precision,parameter:: Vcd = 0.22636d0
	double precision,parameter:: Vub = 0.00361d0
	double precision,parameter:: Vus = 0.22650d0
	double precision,parameter:: Vud = 0.97401d0
!------   Fermion electric charge, etc.  --------------------------------------
 	double precision,parameter:: Qt=2.d0/3.d0, Qb=-1.d0/3.d0, Qe=-1.d0
	double precision,parameter:: It=1.d0/2.d0, Ib=-1.d0/2.d0, In=1.d0/2.d0, Ie=-1.d0/2.d0
	double precision,parameter:: Nc=3.d0, CF=4.d0/3.d0
	double precision,parameter:: femtb  = 3.89379372d0*1.d11		! 1/GeV^2 > fb
	double precision,parameter:: second = 1.519295d24				! second > 1/GeV
	double precision,parameter:: pi = atan(1.d0)*4.d0
	double precision,parameter:: m0 = 0.d0
	complex, parameter        :: ii = (0.d0,1.d0)
	double precision          :: QED = 1.d0
	! double precision          :: QED = 0.d0
	double precision          :: mphoton=0.d0
	! double precision,parameter:: mphoton=1.d0
	! double precision          :: mphoton=1.d-6
	double precision,parameter:: msir = 0.095d0	! current mass in PDG
	double precision,parameter:: zeta2 = (atan(1.d0)*4.d0)**2/6.d0
	double precision,parameter:: zeta3 = 1.2020569031595942d0
	double precision,parameter:: zeta4 = 1.0823232337111381d0
!------- lambda_QCD at eqch active flavor number ------------------------------
	double precision,parameter:: lam_QCD6  = 89.d0*10**(-3.d0)            ! [1]
	double precision,parameter:: lam_QCD5  = 210.d0*10**(-3.d0)           ! [1]
	double precision,parameter:: lam_QCD4  = 292.d0*10**(-3.d0)           ! [1]
	double precision,parameter:: lam_QCD3  = 332.d0*10**(-3.d0)           !
!------- lambda_QCD in 2HDMC --------------------------------------------------
	! double precision,parameter:: lam_QCD5   = 209.537d0*10**(-3.d0)
	! double precision,parameter:: lam_QCD4   = 297.174d0*10**(-3.d0)
	! double precision,parameter:: lam_QCD3   = 353.804d0*10**(-3.d0)
!------ Electroweak STU parameter [1803.01853] ---------------
	double precision,parameter:: Del_chisq68 = 2.30d0   ! Delta chisq value giving 68% CL with m=2
	double precision,parameter:: Del_chisq95 = 5.99d0   ! Delta chisq value giving 95% CL with m=2
	double precision,parameter:: s_cent  = 0.04d0       ! Central Value of S
	double precision,parameter:: t_cent  = 0.08d0       ! Central Value of T 
	double precision,parameter:: sigma_s = 0.08d0       ! Standard Deviation of S
	double precision,parameter:: sigma_t = 0.07d0       ! Standard Deviation of T
	double precision,parameter:: rho_st  = 0.92d0       ! Correlation Factor in the case of Del U=0
!------ Switch -----
	logical:: main_prog = .True.
	! logical:: main_prog  = .False.

	contains
!#############################################################
	end module SM_const
