module func_forQCDco
use SM_const

	implicit none
	contains
!--------------------------------------------------
	double precision function C_ms(x)
	double precision, intent(in):: x
	! This expressions have been implimented in [9703278]

	C_ms=(x)**(4.d0/9.d0)*(1.d0+ 0.895062d0*x+1.37143d0*x**2+1.95168d0*x**3)

	end function
!--------------------------------------------------
	double precision function C_mc(x)
	double precision, intent(in):: x
	! This expressions have been implimented in report of A.Djouadi

	C_mc=(x)**(12.d0/25.d0)*(1.d0+1.014d0*x+1.389d0*x**2+1.091d0*x**3)

	end function
!--------------------------------------------------
	double precision function C_mb(x)
	double precision, intent(in):: x
	! This expressions have been implimented in report of A.Djouadi

	C_mb=(x)**(12.d0/23.d0)*(1.d0+1.175d0*x+1.501d0*x**2+0.1725d0*x**3)

	end function
!--------------------------------------------------
	double precision function C_mt(x)
	double precision, intent(in):: x
	! This expressions have been implimented in [9703278]

	C_mt=(x)**(4.d0/7.d0)*(1.d0+1.39796d0*x+1.79348d0*x**2-0.683433d0*x**3)

	end function
!------------------------------------------------
	double precision function mq_bar(mu,alpha_s_mu,alpha_s_mq,mq_MS_mq)
	double precision, intent(in):: mu,alpha_s_mq,alpha_s_mu,mq_MS_mq
	double precision :: mu_ms

	!===== top quark mass =====
	if (mq_MS_mq .eq. mt_MS) then
		if (mt < mu) then
			mq_bar=C_mt(alphas(lam_QCD6,mu,6.d0)/pi)/C_mt(alphas(lam_QCD6,mt,6.d0)/pi)&
			*mt_MS
		elseif (mu <= mt) then
			mq_bar = mt_MS
		endif
	!===== bottom quark mass =====
	elseif (mq_MS_mq .eq. mb_MS) then
		! if (mu .ge. mt_MS) then
		! 	mq_bar=C_mt(alphas(lam_QCD6,mu,6.d0)/pi)/C_mt(alphas(lam_QCD6,mt_MS,6.d0)/pi)&
		! 	*C_mb(alphas(lam_QCD5,mt_MS,5.d0)/pi)/C_mb(alphas(lam_QCD5,mb_MS,5.d0)/pi)&
		! 	*mb_MS
		! else if (mu .lt. mt_MS .and. mu .ge. mb_MS) then
		! 	mq_bar=C_mb(alphas(lam_QCD5,mu,5.d0)/pi)/C_mb(alphas(lam_QCD5,mb_MS,5.d0)/pi)&
		! 	*mb_MS
		! endif
		if (mt < mu) then
			mq_bar = C_mt(alphas(lam_QCD6,mu,6.d0)/pi)/C_mt(alphas(lam_QCD6,mt,6.d0)/pi)&
			*C_mb(alphas(lam_QCD5,mt,5.d0)/pi)/C_mb(alphas(lam_QCD5,mb,5.d0)/pi)&
			*mb_MS
		else if (mb < mu .and. mu <= mt) then
			mq_bar=C_mb(alphas(lam_QCD5,mu,5.d0)/pi)/C_mb(alphas(lam_QCD5,mb,5.d0)/pi)&
			*mb_MS
		endif
	!===== charm quark mass =====
	elseif (mq_MS_mq .eq. mc_MS) then
		if (mu .ge. mt) then
			mq_bar=C_mt( alphas(lam_QCD6,mu,6.d0)/pi)/C_mt( alphas(lam_QCD6,mt,6.d0)/pi)&
			*C_mb( alphas(lam_QCD5,mt,5.d0)/pi)/C_mb( alphas(lam_QCD5,mb,5.d0)/pi)&
			*C_mc( alphas(lam_QCD4,mb,4.d0)/pi)/C_mc( alphas(lam_QCD4,mc,4.d0)/pi)&
			*mc_MS
		else if (mu .lt. mt .and. mu .ge. mb) then
			mq_bar=C_mb(alphas(lam_QCD5,mu,5.d0)/pi)/C_mb(alphas(lam_QCD5,mb,5.d0)/pi)&
			*C_mc(alphas(lam_QCD4,mb,4.d0)/pi)/C_mc(alphas(lam_QCD4,mc,4.d0)/pi)&
			*mc_MS
		else
			mq_bar=C_mc(alphas(lam_QCD4,mu,4.d0)/pi)/C_mc(alphas(lam_QCD4,mc,4.d0)/pi)&
			*mc_MS
		endif
	!===== strange quark mass =====
	elseif (mq_MS_mq .eq. ms_MS) then
		mu_ms=2.d0 !>mc
		if (mu .ge. mt) then
			mq_bar=C_mt( alphas(lam_QCD6,mu,6.d0)/pi)/C_mt(alphas(lam_QCD6,mt,6.d0)/pi)&
			*C_mb(alphas(lam_QCD5,mt,5.d0)/pi)/C_mb(alphas(lam_QCD5,mb,5.d0)/pi)&
			*C_mc(alphas(lam_QCD4,mb,4.d0)/pi)/C_mc(alphas(lam_QCD4,mu_ms,4.d0)/pi)&
			*ms_MS
		else if (mu .lt. mt .and. mu .ge. mb) then
			mq_bar=C_mb(alphas(lam_QCD5,mu,5.d0)/pi)/C_mb(alphas(lam_QCD5,mb,5.d0)/pi)&
			*C_mc(alphas(lam_QCD4,mb,4.d0)/pi)/C_mc(alphas(lam_QCD4,mu_ms,4.d0)/pi)&
			*ms_MS
		else if (mu .lt. mb .and. mu .ge. mc) then
			mq_bar=C_mc(alphas(lam_QCD4,mu,4.d0)/pi)/C_mc(alphas(lam_QCD4,mu_ms,4.d0)/pi)&
			*ms_MS
		endif
	endif

	end function
!-------------------------------------------------
	double precision function alphas(lam_QCD,mu,N_af)
	double precision, intent(in):: mu,N_af,lam_QCD
	double precision:: beta0,beta1,beta2,ell_mu
	double precision:: as_mb,xi,as_match,mratio

	beta0=11.d0-2.d0/3.d0*N_af
	beta1=51.d0-19.d0/3.d0*N_af
	beta2=2857.d0-5033.d0/9.d0*N_af+325.d0/27.d0*N_af**2
	ell_mu=log(mu**2/lam_QCD**2)

	alphas=&
	4.d0*pi/beta0/ell_mu*(&
		1.d0-2.d0*beta1/beta0**2*log(ell_mu)/ell_mu&
		+4.d0*beta1**2/beta0**4/ell_mu**2*(&
			(log(ell_mu)-1.d0/2.d0)**2+beta2*beta0/8.d0/beta1**2-5.d0/4.d0&
		)&
	)

	end function
!-------------------------------------------------
	double precision function deltaHpm_qcd(mui,muj,pom)
	double precision,intent(in):: mui,muj
	double precision:: xi,xj,lamij,Bij
	integer,intent(in):: pom
#include "looptools.h"

	lamij=(1.d0-mui-muj)**2-4.d0*mui*muj
	xi=2.d0*mui/(1.d0-mui-muj+sqrt(lamij))
	xj=2.d0*muj/(1.d0-mui-muj+sqrt(lamij))

	Bij=(1.d0-mui-muj)/sqrt(lamij)*(&
		4.d0*Li2(xi*xj)-2.d0*Li2(-xi)-2.d0*Li2(-xj)+2.d0*log(xi*xj)*log(1.d0-xi*xj)&
		-log(xi)*log(1.d0+xi)-log(xj)*log(1.d0+xj))-4.d0*(log(1.d0-xi*xj)+xi*xj/(1.d0-xi*xj)*log(xi*xj))&
		+(sqrt(lamij)+mui-muj)/sqrt(lamij)*(log(1.d0+xi)-xi/(1.d0+xi)*log(xi) )&
		+(sqrt(lamij)-mui+muj)/sqrt(lamij)*(log(1.d0+xj)-xj/(1.d0+xj)*log(xj) )

	if (muj .ne. 0.d0 .and. pom .eq. 1) then
		deltaHpm_qcd=9.d0/4.d0+(3.d0-2.d0*mui+2.d0*muj)/4.d0*log(mui/muj)&
			+((3.d0/2.d0-mui-muj)*lamij+5.d0*mui*muj)/(2.d0*sqrt(lamij)*(1.d0-mui-muj) )*log(xi*xj)+Bij
	else if (muj .ne. 0.d0 .and. pom .eq. -1) then
		deltaHpm_qcd=3.d0+(muj-mui)/2.d0*log(mui/muj)&
			+(lamij+2.d0*(1.d0-mui-muj) )/(2.d0*sqrt(lamij) )*log(xi*xj)+Bij
	else if (muj .eq. 0.d0 .and. pom .eq. 1) then
		deltaHpm_qcd = 9.d0/4.d0+(3.d0-7.d0*mui+2.d0*mui**2)/(2.d0*(1.d0-mui))*log(mui/(1.d0-mui))&
			-2.d0*Li2(-mui/(1.d0-mui))-log(1.d0-mui)/(1.d0-mui)+log(1.d0-mui)*log(mui/(1.d0-mui))
	else
		deltaHpm_qcd=0.d0
	end if

	end function
!-------------------------------------------------
	double precision function Delta_t_H(mu)
	double precision,intent(in):: mu
	double precision:: beta_t,rho_t,LL
#include "looptools.h"

	beta_t = sqrt(1.d0-4.d0*mt**2/mu**2)
	rho_t = (1.d0-beta_t)/(1.d0+beta_t)
	LL = (1.d0+beta_t**2)*(&
		4.d0*Li2(rho_t)+2.d0*Li2(-rho_t)&
		+3.d0*log(rho_t)*log(2.d0/(1.d0+beta_t))&
		+2.d0*log(rho_t)*log(beta_t))&
		-3.d0*beta_t*log(4.d0/(1.d0-beta_t**2))-4.d0*beta_t*log(beta_t)

	Delta_t_H = alphas(lam_QCD6,mu,6.d0)/pi*CF&
	*(LL/beta_t-1.d0/(16.d0*beta_t**3)*(3.d0+34.d0*beta_t**2-13.d0*beta_t**4)*log(rho_t)&
	+3.d0/(8.d0*beta_t**2)*(7.d0*beta_t**2-1.d0))

	end function
!--------------------------------------------------------------------------
	double precision function Delta_t_A(mu)
	double precision, intent(in):: mu
	double precision beta_t, rho_t, LL
#include "looptools.h"

	beta_t = sqrt(1.d0-4.d0*mt**2/mu**2)
	rho_t = (1.d0-beta_t)/(1.d0+beta_t)
	LL = (1.d0+beta_t**2)*(&
		+4.d0*Li2(rho_t)+2.d0*Li2(-rho_t)&
		+3.d0*log(rho_t)*log(2.d0/(1.d0+beta_t))&
		+2.d0*log(rho_t)*log(beta_t))&
		-3.d0*beta_t*log(4.d0/(1.d0-beta_t**2))-4.d0*beta_t*log(beta_t) 

	Delta_t_A = alphas(lam_QCD6,mu,6.d0)/pi*CF&
	*(LL/beta_t-1.d0/(16.d0*beta_t)*(19.d0+2.d0*beta_t**2+3.d0*beta_t**4)*log(rho_t)&
	+3.d0/8.d0*(7.d0-beta_t**2))

	end function 
!================= NLO QCD corrections for Phi -> GamGam ==========================
	complex (kind(0d0)) function f_tau(tau)   
	double precision, intent(in):: tau

	if (tau <= 1.d0) then
		f_tau = asin(sqrt(tau))**2
	else if (1.d0 < tau) then
		f_tau = -1.d0/4.d0*(log((1.d0+sqrt(1.d0-1.d0/tau))/(1.d0-sqrt(1.d0-1.d0/tau)))-ii*pi)**2
	endif 

 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function fp_tau(tau)   
	double precision, intent(in):: tau

	if (tau <= 1.d0) then
		fp_tau = asin(sqrt(tau))/(Sqrt((1.d0-tau)*tau))
	else if (1.d0 < tau) then
		fp_tau = (ii*pi-2.d0*log(sqrt(tau)+sqrt(tau-1.d0)))/(2.d0*sqrt(tau*(tau-1.d0)))
	endif 

	end function fp_tau
!--------------------------------------------------------------------------
	double precision function linear_interpolation(x_dat,y_dat,num_dat,x)
	integer, intent(in):: num_dat
	double precision, intent(in):: x_dat(num_dat),y_dat(num_dat),x
	double precision:: y0,y1,x0,x1
	integer:: i,j,index0

	do i = 1, num_dat
		if(0 <= x-x_dat(i)) then
			index0 = i
		endif
	end do

	x0 = x_dat(index0);   y0 = y_dat(index0)
	x1 = x_dat(index0+1); y1 = y_dat(index0+1)

	linear_interpolation = y0+(y1-y0)/(x1-x0)*(x-x0)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0_H(tau)
	double precision, intent(in):: tau
	! 4.d0/3.d0*F0_H = -I_f(mH,mt); Note the overall minus sign.

	F0_H = 3.d0/4.d0*(2.d0/tau**2*(tau+(tau-1.d0)*f_tau(tau)))

	end function F0_H
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0HC1H(tau)
	double precision, intent(in):: tau
	double precision,allocatable:: dat(:,:)
	integer:: num_dat,i
	double precision:: C1H_Re,C1H_Im

	if (tau <= 0.01d0) then
		C1H_Re = -1.d0; C1H_Im = 0.d0
	else if (0.001d0 < tau .and. tau < 1000.d0) then
		open(100, file='./modules/dat/Hgamgam_NLOQCD_C1H.dat')
		read(100, *) !skip first line
		num_dat = 501
		allocate(dat(3,num_dat))
	
		do i = 1, num_dat
			read(100, *) dat(:,i)
		end do

		! translate x into log10(x) for interpolation
		dat(1,:) = log10(dat(1,:))

		C1H_Re = linear_interpolation(dat(1,:),dat(2,:),num_dat,log10(tau))
		C1H_Im = linear_interpolation(dat(1,:),dat(3,:),num_dat,log10(tau))

		deallocate(dat)
		close(100)
	else if (1000.d0 <= tau) then
		C1H_Re =&
			-(&
				5.d0*log(4.d0*tau)**6&
				+60.d0*log(4.d0*tau)**5&
				+5.d0*(-4.d0+9.d0*pi**2)*log(4.d0*tau)**4&
				+80.d0*(pi**2-12.d0*(1.d0+zeta3))*log(4.d0*tau)**3&
				+(-40.d0*pi**2+87.d0*pi**4-240.d0*(-5.d0+zeta3))*log(4.d0*tau)**2&
				+20.d0*(144.d0+8.d0*pi**2+pi**4-48.d0*(-4.d0+pi**2)*zeta3)*log(4.d0*tau)&
				+(4.d0+pi**2)*(23.d0*pi**4+240.d0*(-5.d0+zeta3))&
			)&
			/(90.d0*((4.d0+pi**2)**2+2.d0*(-4.d0+pi**2)*log(4.d0*tau)**2+log(4.d0*tau)**4))

		C1H_Im =&
			pi*(&
				5.d0*log(4.d0*tau)**5&
				+30.d0*log(4.d0*tau)**4&
				+10.d0*(-4.d0+pi**2)*log(4.d0*tau)**3&
				+80.d0*(pi**2+6.d0*zeta3)*log(4.d0*tau)**2&
				-(120.d0*pi**2+7.d0*pi**4-240.d0*(-5.d0+zeta3))*log(4.d0*tau)&
				+10.d0*(4.d0+pi**2)*(36.d0+5.d0*pi**2+48.d0*zeta3)&
			)&
			/(45.d0*((4.d0+pi**2)**2+2.d0*(-4.d0+pi**2)*log(4.d0*tau)**2+log(4.d0*tau)**4))
	endif

	F0HC1H = F0_H(tau)*(C1H_Re+ii*C1H_Im)

 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0HC2H(tau) !F0H*C2H given in Eq. (2.7) of arXiv:0509189
	double precision, intent(in):: tau
 
	F0HC2H = 3.d0/tau**2*(tau+(tau-2.d0)*f_tau(tau)-(tau-1.d0)*tau*fp_tau(tau))

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0HCH(mbH,mf,mu)
	double precision, intent(in):: mbH,mf,mu
	double precision:: tau

	tau = mbH**2/(4.d0*mf**2)

	F0HCH = 4.d0/3.d0*(F0HC1H(tau)+F0HC2H(tau)*log(mu**2/mf**2))

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0_A(tau)
	double precision, intent(in):: tau    
	! F0_A = +I_A(mH,mt)/2.d0

	F0_A = f_tau(tau)/tau

	end function F0_A
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0AC1A(tau)
	double precision, intent(in):: tau
	double precision,allocatable:: dat(:,:)
	integer:: num_dat,i
	double precision:: C1A_Re,C1A_Im

	if (tau <= 0.01d0) then
		C1A_Re = 0.d0; C1A_Im = 0.d0
	else if (0.001d0 < tau .and. tau < 1000.d0) then
		open(100, file='./modules/dat/Agamgam_NLOQCD_C1A.dat')
		read(100, *) !skip first line
		num_dat = 501
		allocate(dat(3,num_dat))
	
		do i = 1, num_dat
			read(100, *) dat(:,i)
		end do

		! translate x into log10(x) for interpolation
		dat(1,:) = log10(dat(1,:))

		C1A_Re = linear_interpolation(dat(1,:),dat(2,:),num_dat,log10(tau))
		C1A_Im = linear_interpolation(dat(1,:),dat(3,:),num_dat,log10(tau))

		if (0.99d0 < tau .and. tau < 1.01d0) then
			write(*,*) 'Warning!: QCD corrections to A -> gamgam is singular at tau = 1. The output value is not reliable.'
			write(*,*) 'tau =', tau
		endif

		deallocate(dat)
		close(100)
	else if (1000.d0 <= tau) then
		C1A_Re =&
			-(&
				5.d0*log(4.d0*tau)**6&
				+60.d0*log(4.d0*tau)**5&
				+45.d0*pi**2*log(4.d0*tau)**4&
				+80.d0*(pi**2-12.d0*zeta3)*log(4.d0*tau)**3&
				+3.d0*(29.d0*pi**4-80.d0*zeta3)*log(4.d0*tau)**2&
				+20.d0*(pi**4-48.d0*pi**2*zeta3)*log(4.d0*tau)&
				+23.d0*pi**6+240.d0*pi**2*zeta3&
			)&
			/(90.d0*(pi**2+log(4.d0*tau)**2)**2)

		C1A_Im =&
			pi*(&
				5.d0*log(4.d0*tau)**5&
				+30.d0*log(4.d0*tau)**4&
				+10.d0*pi**2*log(4.d0*tau)**3&
				+80.d0*(pi**2+6.d0*zeta3)*log(4.d0*tau)**2&
				+(-7.d0*pi**4+240.d0*zeta3)*log(4.d0*tau)&
				+50.d0*pi**4+480.d0*pi**2*zeta3&
			)&
			/(45.d0*(pi**2+log(4.d0*tau)**2)**2)
	endif

	F0AC1A = F0_A(tau)*(C1A_Re+ii*C1A_Im)

 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0AC2A(tau) !F0A*C2A given in Eq. (2.19) in arXiv:0509189
	double precision, intent(in):: tau

	F0AC2A = 2.d0/tau*(f_tau(tau)-tau*fp_tau(tau))

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0ACA(mA,mf,mu)
	double precision, intent(in):: mA,mf,mu
	double precision:: tau

	tau = mA**2/(4.d0*mf**2)

	F0ACA = F0AC1A(tau)+F0AC2A(tau)*log(mu**2/mf**2)

	end function
!================= NLO QCD corrections for Phi -> Glu Glu ==========================
	complex (kind(0d0)) function F0HB1H(tau)
	double precision, intent(in):: tau
	double precision,allocatable:: dat(:,:)
	integer:: num_dat,i
	double precision:: B1H_Re,B1H_Im

	if (tau <= 0.01d0) then
		B1H_Re = 11.d0/2.d0; B1H_Im = 0.d0
	else if (0.001d0 < tau .and. tau < 1000.d0) then
		open(100, file='./modules/dat/Hgg_NLOQCD_B1H.dat')
		read(100, *) !skip first line
		num_dat = 501
		allocate(dat(3,num_dat))
	
		do i = 1, num_dat
			read(100, *) dat(:,i)
		end do

		! translate x into log10(x) for interpolation
		dat(1,:) = log10(dat(1,:))

		B1H_Re = linear_interpolation(dat(1,:),dat(2,:),num_dat,log10(tau))
		B1H_Im = linear_interpolation(dat(1,:),dat(3,:),num_dat,log10(tau))

		deallocate(dat)
		close(100)
	else if (1000.d0 <= tau) then
		B1H_Re =&
			(&
				25.d0*log(4.d0*tau)**6&
				-240.d0*log(4.d0*tau)**5&
				+5.d0*(88.d0+9.d0*pi**2)*log(4.d0*tau)**4&
				-80.d0*(-48.d0+4.d0*pi**2+33.d0*zeta3)*log(4.d0*tau)**3& 
				+(1600.d0*pi**2+63.d0*pi**4+240.d0*(-56.d0+31.d0*zeta3))*log(4.d0*tau)**2&
				-80.d0*(144.d0+8.d0*pi**2+pi**4+33.d0*(-4.d0+pi**2)*zeta3)*log(4.d0*tau)&
				-(4.d0+pi**2)*(-540.d0*pi**2+53.d0*pi**4+240.d0*(-47.d0+31.d0*zeta3))&
			)&
			/(180.d0*((4.d0+pi**2)**2+2.d0*(-4.d0+pi**2)*log(4.d0*tau)**2+log(4.d0*tau)**4))

		B1H_Im =&
			pi*(&
				-25.d0*log(4.d0*tau)**5&
				+120.d0*log(4.d0*tau)**4&
				-50.d0*(-4.d0+pi**2)*log(4.d0*tau)**3&
				+40.d0*(8.d0*pi**2-33.d0*zeta3)*log(4.d0*tau)**2&
				+(-9120.d0-120.d0*pi**2+23.d0*pi**4+7440.d0*zeta3)*log(4*tau)&
				+40.d0*(4.d0+pi**2)*(36.d0+5.d0*pi**2-33.d0*zeta3)&
			)&
			/(90.d0*((4.d0+pi**2)**2+2.d0*(-4.d0+pi**2)*log(4.d0*tau)**2+log(4.d0*tau)**4))
	endif

	F0HB1H = F0_H(tau)*(B1H_Re+ii*B1H_Im)

 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0HB2H(tau) !F0H*B2H given in Eq. (3.6) of arXiv:0509189
	double precision, intent(in):: tau
 
	F0HB2H = 2.d0*F0HC2H(tau)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0HBH(mbH,mf,mu)
	double precision, intent(in):: mbH,mf,mu
	double precision:: tau

	tau = mbH**2/(4.d0*mf**2)

	F0HBH = F0HB1H(tau)+F0HB2H(tau)*log(mu**2/mf**2)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0AB1A(tau)
	double precision, intent(in):: tau
	double precision,allocatable:: dat(:,:)
	integer:: num_dat,i
	double precision:: B1A_Re,B1A_Im

	if (tau <= 0.01d0) then
		B1A_Re = 6.d0; B1A_Im = 0.d0
	else if (0.001d0 < tau .and. tau < 1000.d0) then
		open(100, file='./modules/dat/Agg_NLOQCD_B1A.dat')
		read(100, *) !skip first line
		num_dat = 501
		allocate(dat(3,num_dat))
	
		do i = 1, num_dat
			read(100, *) dat(:,i)
		end do

		! translate x into log10(x) for interpolation
		dat(1,:) = log10(dat(1,:))

		B1A_Re = linear_interpolation(dat(1,:),dat(2,:),num_dat,log10(tau))
		B1A_Im = linear_interpolation(dat(1,:),dat(3,:),num_dat,log10(tau))

		if (0.99d0 < tau .and. tau < 1.01d0) then
			write(*,*) 'Warning!: QCD corrections to A -> gg is singular at tau = 1. The output value is not reliable.'
			write(*,*) 'tau =', tau
		endif

		deallocate(dat)
		close(100)
	else if (1000.d0 <= tau) then
		B1A_Re =&
			(&
				25.d0*log(4.d0*tau)**6&
				-240.d0*log(4.d0*tau)**5&
				+45.d0*(12.d0+pi**2)*log(4.d0*tau)**4&
				-80.d0*(4.d0*pi**2+33.d0*zeta3)*log(4.d0*tau)**3&
				+3.d0*(360.d0*pi**2+21.d0*pi**4+2480.d0*zeta3)*log(4.d0*tau)**2&
				-80.d0*(pi**4+33.d0*pi**2*zeta3)*log(4.d0*tau)&
				+540.d0*pi**4-53.d0*pi**6-7440.d0*pi**2*zeta3&
			)&
			/(180.d0*(pi**2+log(4.d0*tau)**2)**2)

		B1A_Im =&
			pi*(&
				-25.d0*log(4.d0*tau)**5&
				+120.d0*log(4.d0*tau)**4&
				-50.d0*pi**2*log(4.d0*tau)**3&
				+40.d0*(8.d0*pi**2-33.d0*zeta3)*log(4.d0*tau)**2&
				+(23.d0*pi**4+7440.d0*zeta3)*log(4.d0*tau)&
				+40.d0*(5.d0*pi**4-33.d0*pi**2*zeta3)&
			)&
			/(90.d0*(pi**2+log(4.d0*tau)**2)**2)
	endif

	F0AB1A = F0_A(tau)*(B1A_Re+ii*B1A_Im)

 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0AB2A(tau) !F0A*B2A given in Eq. (3.6) in arXiv:0509189
	double precision, intent(in):: tau

	F0AB2A = 2.d0*F0AC2A(tau)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function F0ABA(mA,mf,mu)
	double precision, intent(in):: mA,mf,mu
	double precision:: tau

	tau = mA**2/(4.d0*mf**2)

	F0ABA = F0AB1A(tau)+F0AB2A(tau)*log(mu**2/mf**2)

	end function
!##################################################################################
!  You need to install CHAPLIN [1106.5739] to use following polylog functions
!##################################################################################
! !================= POLYLOG FUNCTIONS =======================
! 	complex (kind(0d0)) function Li2(z)
! 	complex (kind(0d0)), intent(in):: z
! 	complex (kind(0d0)) HPL2

! 	Li2 = HPL2(0,1,z)

!  	end function
! !--------------------------------------------------------
! 	complex (kind(0d0)) function Li3(z)
! 	complex (kind(0d0)), intent(in):: z
! 	complex (kind(0d0)) HPL3

! 	Li3 = HPL3(0,0,1,z)

!  	end function
! !--------------------------------------------------------
! 	complex (kind(0d0)) function Li4(z)
! 	complex (kind(0d0)), intent(in):: z
! 	complex (kind(0d0)) HPL4

! 	Li4 = HPL4(0,0,0,1,z)

! 	end function
! !--------------------------------------------------------
! 	complex (kind(0d0)) function H10m10(z)
! 	complex (kind(0d0)), intent(in):: z
! 	complex (kind(0d0)) HPL4

! 	H10m10 = HPL4(1,0,-1,0,z)

!  	end function
! !================= NLO QCD corrections for Phi -> GamGam ==========================
! 	complex (kind(0d0)) function C1_H(tau) ! F0H*C1H given in Eq. (2.8) of arXiv:0509189
! 	double precision, intent(in):: tau
! 	complex (kind(0d0))::theta,z
! 	z = cmplx(1.d0,0.d0,(kind(0d0)))

! 	if (tau <= 1.d0) then
! 		theta = (ii*sqrt(1.d0/tau-1.d0)-z)/(ii*sqrt(1.d0/tau-1.d0)+z)
! 	else if (1.d0 < tau) then
! 		theta = (sqrt(1.d0-1.d0/tau)-z)/(sqrt(1.d0-1.d0/tau)+z)
! 	endif

! 	C1_H =&
! 		-theta*(1.d0+theta+theta**2+theta**3)/(1.d0-theta)**5&
! 		*(&
! 			108.d0*Li4(theta)+144.d0*Li4(-theta)-64.d0*Li3(theta)*log(theta)&
! 			-64.d0*Li3(-theta)*log(theta)+14.d0*Li2(theta)*log(theta)**2&
! 			+8.d0*Li2(-theta)*log(theta)**2+log(theta)**4/12.d0&
! 			+4.d0*zeta2*log(theta)**2+16.d0*zeta3*log(theta)+18.d0*zeta4&
! 		)&
! 		+theta*(1.d0+theta)**2/(1.d0-theta)**4&
! 		*(&
! 			-32.d0*Li3(-theta)+16.d0*Li2(-theta)*log(theta)-4.d0*zeta2*log(theta)&
! 		)&
! 		-4.d0*theta*(7.d0-2.d0*theta+7.d0*theta**2)/(1.d0-theta)**4*Li3(theta)&
! 		+8.d0*theta*(3.d0-2.d0*theta+3.d0*theta**2)/(1.d0-theta)**4*Li2(theta)*log(theta)&
! 		+2.d0*theta*(5.d0-6.d0*theta+5.d0*theta**2)/(1.d0-theta)**4*log(1.d0-theta)*log(theta)**2&
! 		+theta*(3.d0+25.d0*theta-7.d0*theta**2+3.d0*theta**3)/(3.d0*(1.d0-theta)**5)*log(theta)**3&
! 		+4.d0*theta*(1.d0-14.d0*theta+theta**2)/(1.d0-theta)**4*zeta3&
! 		+12.d0*theta**2/(1.d0-theta)**4*log(theta)**2&
! 		-12.d0*theta*(1.d0+theta)/(1.d0-theta)**3*log(theta)&
! 		-20.d0*theta/(1.d0-theta)**2

! 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function C1_H(tau)
	double precision, intent(in):: tau

	C1_H = F0HC1H(tau)

 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function C2_H(tau) !F0H*C2H given in Eq. (2.7) of arXiv:0509189
	double precision, intent(in):: tau

	C2_H = 3.d0/tau**2*(tau+(tau-2.d0)*f_tau(tau)-(tau-1.d0)*tau*fp_tau(tau))

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function C_H(mbH,mf,mu)
	double precision, intent(in):: mbH,mf,mu
	double precision:: tau

	tau = mbH**2/(4.d0*mf**2)

	C_H = 4.d0/3.d0*(C1_H(tau)+C2_H(tau)*log(mu**2/mf**2))

	end function
! !----------------------------------------------------------------------------------
! 	complex (kind(0d0)) function  C1_A(tau) ! F0A*C1A given in Eq. (2.20) of arXiv:0509189
! 	double precision, intent(in):: tau
! 	complex (kind(0d0))::theta,z
! 	z = cmplx(1.d0,0.d0,(kind(0d0)))

! 	if (dble(tau) .ge. 1.d0) then 
! 		theta = (sqrt(1.d0 - 1.d0/tau) - z)/(sqrt(1.d0 - 1.d0/tau) + z)
! 	else 
! 		theta = (sqrt(1.d0/tau -1.d0)*ii - z)/(sqrt(1.d0/tau -1.d0)*ii + z)
! 	endif 

! 	C1_A =&
! 		-theta*(1.d0+theta**2)/(1.d0-theta)**3/(1.d0+theta)*(&
! 			72.d0*Li4(theta)&
! 			+96.d0*Li4(-theta)&
! 			-128.d0/3.0*(Li3(theta)+Li3(-theta))*log(theta)&
! 			+28.d0/3.d0*Li2(theta)*log(theta)**2&
! 			+16.d0/3.d0*Li2(-theta)*log(theta)**2&
! 			+log(theta)**4/18.d0&
! 			+8.d0/3.d0*zeta2*log(theta)**2&
! 			+32.d0/3.d0*zeta3*log(theta)&
! 			+12.d0*zeta4&
! 		)&
! 		+theta/(1.d0-theta)**2*(&
! 			-56.d0/3.d0*Li3(theta)&
! 			-64.d0/3.d0*Li3(-theta)&
! 			+16.d0*Li2(theta)*Log(theta)&
! 			+32.d0/3.d0*Li2(-theta)*Log(theta)&
! 			+20.d0/3.d0*log(1.d0-theta)*log(theta)**2&
! 			-8.d0/3.d0*zeta2*log(theta) + 8.d0/3.d0*zeta3&
! 		)&
! 		+2.d0*theta*(1.d0+theta)/3.d0/(1.d0-theta)**3*log(theta)**3

! 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function C1_A(tau)
	double precision, intent(in):: tau

	C1_A = F0AC1A(tau)

 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function  C2_A(tau) ! F0A*C2A given in Eq. (2.19) of arXiv:0509189
	double precision, intent(in):: tau
	complex (kind(0d0))::theta, F0A

	C2_A = 2.d0/tau*(f_tau(tau)-tau*fp_tau(tau))

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function C_A(mA,mf,mu)
	double precision, intent(in):: mA,mf,mu
	double precision:: tau

	tau = mA**2/(4.d0*mf**2)

	C_A = C1_A(tau)+C2_A(tau)*log(mu**2/mf**2)

	end function
!================= NLO QCD corrections for Phi -> Glu Glu ==========================
! 	complex (kind(0d0)) function B1_H(tau) ! F0_H B1_H in Eq. (3.7) of arXiv:0509189
! 	double precision, intent(in):: tau
! 	complex (kind(0d0))::theta,z
! 	z = cmplx(1.d0,0.d0,(kind(0d0)))

! 	if (dble(tau) .ge. 1.d0) then 
! 		theta = (sqrt(1.d0-1.d0/tau)-z)/(sqrt(1.d0-1.d0/tau)+z)
! 	else
! 		theta = (sqrt(1.d0/tau-1.d0)*ii-z)/(sqrt(1.d0/tau-1.d0)*ii+z)
! 	endif

! 	B1_H =&
! 		theta*(1.d0+theta)**2/(1.d0-theta)**4*(&
! 			72.d0*H10m10(theta)+6.d0*log(1.d0-theta)*log(theta)**3-36.d0*zeta2*Li2(theta)&
! 			-36.d0*zeta2*log(1.d0-theta)*log(theta)-108.d0*zeta3*log(1.d0-theta)&
! 			-64.d0*Li3(-theta)+32.d0*Li2(-theta)*log(theta)-8.d0*zeta2*log(theta)&
! 		)&
! 		-36.d0*theta*(5.d0+5.d0*theta+11.d0*theta**2+11.d0*theta**3)/(1.d0-theta)**5*Li4(-theta)&
! 		-36.d0*theta*(5.d0+5.d0*theta+7.d0*theta**2+7.d0*theta**3)/(1.d0-theta)**5*Li4(theta)&
! 		+4.d0*theta*(1.d0+theta)*(23.d0+41.d0*theta**2)/(1.d0-theta)**5*(Li3(theta)+Li3(-theta))*log(theta)&
! 		-16.d0*theta*(1.d0+theta+theta**2+theta**3)/(1.d0-theta)**5*Li2(-theta)*log(theta)**2&
! 		-2.d0*theta*(5.d0+5.d0*theta+23.d0*theta**2+23.d0*theta**3)/(1.d0-theta)**5*Li2(theta)*log(theta)**2&
! 		!!
! 		+theta*(5.d0+5.d0*theta-13.d0*theta**2-13.d0*theta**3)/24.d0/(1.d0-theta)**5*log(theta)**4&
! 		+theta*(1.d0+theta-17.d0*theta**2-17.d0*theta**3)/(1.d0-theta)**5*zeta2*log(theta)**2&
! 		+2.d0*theta*(11.d0+11.d0*theta-43.d0*theta**2-43.d0*theta**3)/(1.d0-theta)**5*zeta3*log(theta)&
! 		+36.d0*theta*(1.d0+theta-3.d0*theta**2-3.d0*theta**3)/(1.d0-theta)**5*zeta4&
! 		-2.d0*theta*(55.d0+82.d0*theta+55.d0*theta**2)/(1.d0-theta)**4*Li3(theta)&
! 		+2.d0*theta*(51.d0+74.d0*theta+51.d0*theta**2)/(1.d0-theta)**4*Li2(theta)*log(theta)&
! 		+theta*(47.d0+66.d0*theta+47.d0*theta**2)/(1.d0-theta)**4*log(1.d0-theta)*log(theta)**2& 
! 		+theta*(6.d0+59.d0*theta+58.d0*theta**2+33.d0*theta**3)*log(theta)**3/3.d0/(1.d0-theta)**5&
! 		+2.d0*theta*(31.d0+34.d0*theta+31.d0*theta**2)*zeta3/(1.d0-theta)**4& 
! 		+3.d0*theta*(3.d0+22.d0*theta+3.d0*theta**2)*log(theta)**2/2.d0/(1.d0-theta)**4&
! 		-24.d0*theta*(1.d0+theta)/(1.d0-theta)**3*log(theta)&
! 		-94.d0*theta/(1.d0-theta)**2

! 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function B1_H(tau) ! F0_H B1_H in Eq. (3.7) of arXiv:0509189
	double precision, intent(in):: tau

	B1_H = F0HB1H(tau)

  	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function B2_H(tau) !F0H*B2H given in Eq. (3.6) of arXiv:0509189
	double precision, intent(in):: tau

	B2_H = 2.d0*C2_H(tau)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function B_H(mbH,mf,mu)
	double precision, intent(in):: mbH,mf,mu
	double precision:: tau

	tau = mbH**2/(4.d0*mf**2)

	B_H = B1_H(tau)+B2_H(tau)*log(mu**2/mf**2)
 
	end function
!---------------------------------------------------------------------------------- 
! 	complex (kind(0d0)) function  B1_A(tau) ! F0_H B1_H in Eq. (3.8) of arXiv:0509189
! 	double precision, intent(in):: tau
! 	complex (kind(0d0))::theta,z
! 	z = cmplx(1.d0,0.d0,(kind(0d0)))
   
! 	if (dble(tau) .ge. 1.d0) then 
! 		theta = (sqrt(1.d0 - 1.d0/tau) - z)/(sqrt(1.d0 - 1.d0/tau) + z)
! 	else
! 		theta = (sqrt(1.d0/tau -1.d0)*ii - z)/(sqrt(1.d0/tau -1.d0)*ii + z)
! 	endif

! 	B1_A =  &
! 		theta/(1.d0-theta)**2*(&
! 			48.d0*H10m10(theta)&
! 			+4.d0*log(1.d0-theta)*log(theta)**3-24.d0*zeta2*Li2(theta)&
! 			-24.d0*zeta2*log(1.d0-theta)*log(theta)&
! 			- 72.d0*zeta3*log(1.d0-theta)&
! 			-220.d0/3.d0*Li3(theta)-128.d0/3.d0*Li3(-theta)&
! 			+68.d0*Li2(theta)*log(theta)+64.d0/3.d0*Li2(-theta)*log(theta)&
! 			+94.d0/3.d0*log(1.d0-theta)*log(theta)**2&
! 			-16.d0/3.d0*zeta2*log(theta)+124.d0/3.d0*zeta3+3.d0*log(theta)**2&
! 		)&
! ! !
! 		-24.d0*theta*(5.d0+7.d0*theta**2)*Li4(theta)/(1.d0-theta)**3/(1.d0+theta)&
! 		-24.d0*theta*(5.d0+11.d0*theta**2)/(1.d0-theta)**3/(1.d0+theta)*Li4(-theta)&
! 		+8.d0*theta*(23.d0+41.d0*theta**2)/3.d0/(1.d0-theta)**3/(1.d0+theta)*(Li3(theta)+Li3(-theta))*log(theta)&
! 		-4.d0*theta*(5.d0+23.d0*theta**2)/3.d0/(1.d0-theta)**3/(1.d0+theta)*Li2(theta)*log(theta)**2&
! 		-32.d0*theta*(1.d0+theta**2)/3.d0/(1.d0-theta)**3/(1.d0+theta)*Li2(-theta)*log(theta)**2&
! 		+theta*(5.d0-13.d0*theta**2)/36.d0/(1.d0-theta)**3/(1.d0+theta)*log(theta)**4&
! 		+2.d0*theta*(1.d0-17.d0*theta**2)/3.d0/(1.d0-theta)**3/(1.d0+theta)*zeta2*log(theta)**2&
! 		+4.d0*theta*(11.0-43.d0*theta**2)/3.d0/(1.d0-theta)**3/(1.d0+theta)*zeta3*log(theta)&
! 		+24.d0*theta*(1.d0-3.d0*theta**2)*zeta4/(1.d0-theta)**3/(1.d0+theta)&
! 		+2.d0*theta*(2.d0+11.d0*theta)*log(theta)**3/3.d0/(1.d0-theta)**3
   
! 	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function B1_A(tau) ! F0_H B1_H in Eq. (3.7) of arXiv:0509189
	double precision, intent(in):: tau

	B1_A = F0AB1A(tau)

  	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function B2_A(tau) !F0H*B2H given in Eq. (3.6) of arXiv:0509189
	double precision, intent(in):: tau

	B2_A = 2.d0*C2_A(tau)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function B_A(mA,mf,mu)
	double precision, intent(in):: mA,mf,mu
	double precision:: tau

	tau = mA**2/(4.d0*mf**2)

	B_A = B1_A(tau)+B2_A(tau)*log(mu**2/mf**2)

	end function
!----------------------------------------------------------------------------------
	! double precision function  Delta_E_H(tau,mu,nf) ! Delta E_H in Eq. (C.11) of Spira, Djouadi, Graudenz, Zerwas NPB 453
	! double precision, intent(in):: tau
	! double precision, intent(in):: mu,nf
	! double precision  :: DeltaE_H_ggg=0.d0 , DeltaE_H_gqq=0.d0

	! Delta_E_H = &
	! 	real((B1_H(tau)+(2.d0*C2_H(tau))*log(mu**2/mt**2))/F0_H(tau))-11.d0/2.d0&
	! !--------------- DeltaE_H_virt -----------------------------------------|
	! 	+DeltaE_H_ggg+nf*DeltaE_H_gqq

	! end function Delta_E_H
!----------------------------------------------------------------------------------
	! double precision function  Delta_E_A(mA,mf,mu,nf) ! Delta E_A in Eq. (C.11) of Spira, Djouadi, Graudenz, Zerwas NPB 453
	! double precision, intent(in):: mA,mu,mf,nf
	! double precision  :: tau
	! double precision  :: DeltaE_A_ggg=0.d0 , DeltaE_A_gqq=0.d0
	! tau=mA**2/(4.d0*mf**2)

	! Delta_E_A = &
	! 	real((B1_A(tau)+(2.d0*C2_A(tau))*log(mu**2/mt**2))/F0_A(tau))-6.d0&
	! !--------------- DeltaE_H_virt -----------------------------------!
	! 	+DeltaE_A_ggg+NF*DeltaE_A_gqq

	! end function Delta_E_A

end module func_forQCDco
