module int_romberg
	contains
!---------------------------------------------
	subroutine romberg(int_f,f,a,b)
	double precision:: a,b,f
	double precision:: int_f
	double precision:: dx,s
	double precision,allocatable:: T(:,:)
	integer:: n,i,j,k,m

		! m = 15
		! m = 12
		m = 11   !defalt
		! m = 9
		! m = 7

		allocate(T(1:m,1:m))
		T(1,1)=(f(a)+f(b))*(b-a)/2.d0

		do 100 i=2,m,1
			n = 2**(i-1)
			dx = dble((b-a)/n)
			s = f(a)+f(b)

			do 200  k=1,n-1,1
				s = s+2.d0*f(a+k*dx)
200		end do
			T(i,1)=s*dx/2.d0
			do 300 j =1,i-1,1
 				T(i,j+1)=1.d0/(4.d0**j-1.d0)*(4.d0**j*T(i,j)-T(i-1,j))
300		end do
100	enddo

		int_f = T(m,m)

		deallocate(T)

	end subroutine romberg
!-------------------------------------------
	subroutine romberg2d(int_f,f,a,b,yi,yf)
	implicit none
	double precision:: a,b
	double precision:: f
	double precision:: yi,yf
	double precision:: int_f
	double precision:: x,dx,s
	double precision:: y,dy,sy,sy_a,sy_b
	double precision,allocatable:: T(:,:)
	integer:: n,i,j,k,m,o,l

		! m = 8
		! m = 7
		m = 6   !defalt
		! m = 5

		allocate(T(1:m,1:m))
		T(1,1)=(f(a,yi(a))+f(b,yf(b)))*(b-a)/2.d0*(yf(b)-yi(a))/2.d0

		do 100 i=2,m,1
			n=2**(i-1)
			dx =dble((b-a)/n)
			sy_a=f(a,yi(a))+ f(a,yf(a))
			sy_b=f(b,yi(b))+ f(a,yf(b))

			do 110 o=1,n-1,1
				sy_a =sy_a+2.d0*f(a,yi(a)+dble(o)*dble((yf(a)-yi(a))/n))
				sy_b =sy_b+2.d0*f(b,yi(b)+dble(o)*dble((yf(b)-yi(b))/n))
110		end do
			sy_a=sy_a*dble((yf(a)-yi(a))/n)/2.d0
			sy_b=sy_b*dble((yf(b)-yi(b))/n)/2.d0
			s = sy_a+sy_b

			do 200  k=1,n-1,1
				x = a+k*dx
				dy = dble((yf(x)-yi(x))/n)
				sy = f(x,yi(x))+f(x,yf(x))
				do 210 l=1,n-1,1
					y = yi(x)+dble(l)*dy
					sy=sy+2.d0*f(x,y)
210			end do
				sy = sy*dy/2.d0
				s  = s+2.d0*sy
200		end do
			T(i,1)=s*dx/2.d0
			do 300 j =1,i-1,1
					T(i,j+1)=1.d0/(4.d0**j-1.d0)*(4.d0**j*T(i,j)-T(i-1,j))
300		end do
100	enddo

		int_f = T(m,m)
				
		deallocate(T)

	end subroutine romberg2d
!-----------------------------------
  end module int_romberg
