	module  pv
	use SM_const
	implicit none

	! double precision:: div= 0.d0
	double precision:: div= 1.d0   !Use this to see mu dependence by using mu_r
	! double precision:: div= 1.d+4
	! double precision:: div= 1.d+7
	! double precision:: div= 1.d+10

	contains
!====================== Basic functions ================================
	double complex function a0f(m)
	double precision, intent(in):: m
#include "looptools.h"
	CALL ltini

	a0f = a0(m**2) + div*m**2

	end function
!----------------------------------------------------------------
	double precision function a0f_div(m)
	double precision, intent(in):: m

	a0f_div = m**2*div

	end function
!----------------------------------------------------------------
	double complex function b0f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini

	b0f = b0(qsq,m1**2,m2**2)+div 

	end function 
!----------------------------------------------------------------
  double complex function b1f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini
	
	b1f = b1(qsq,m1**2,m2**2)-div/2.d0

	end function
!----------------------------------------------------------------
  double complex function b2f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini

	b2f = b11(qsq,m1**2,m2**2)+div/3.d0

	end function
!----------------------------------------------------------------
  double complex function b3f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	b3f = -b1f(qsq,m1,m2)-b2f(qsq,m1,m2)

	end function 
!----------------------------------------------------------------
  double complex function b4f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	b4f = -b1f(qsq,m1,m2)*m2**2-b1f(qsq,m2,m1)*m1**2

	end function 
!----------------------------------------------------------------
  double complex function b5f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	b5f = a0f(m1)+a0f(m2)-4.d0*b22f(qsq,m1,m2)

	end function 
!----------------------------------------------------------------
  double complex function b22f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini

	b22f = b00(qsq,m1**2,m2**2)-qsq/12.d0*div+(m1**2+m2**2)/4.d0*div

	end function
!----------------------------------------------------------------
  double complex function db0f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini
	
	db0f = db0(qsq,m1**2,m2**2) 

	end function
!----------------------------------------------------------------
  double complex function db1f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini

	db1f = db1(qsq,m1**2,m2**2)

	!  db1f = -1.d0/(2.d0*qsq**2)*(a0f(m1)-a0f(m2)+(m2**2-m1**2)*b0f(qsq,m1,m2))&
	!  	+(m2**2-m1**2-qsq)/(2.d0*qsq)*db0f(qsq,m1,m2)

	end function
!----------------------------------------------------------------
	double complex function db2f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini

	if(qsq == 0.d0) then
		db2f = db11(qsq,m1**2,m2**2)
	else
		db2f = -1.d0/(3.d0*qsq**2)*(a0f(m2)-m1**2*b0f(qsq,m1,m2)-2.d0*(m1**2-m2**2)*b1f(qsq,m1,m2)&
			-(m1**2+m2**2)/2.d0)&
			+1.d0/(3.d0*qsq)*(-m1**2*db0f(qsq,m1,m2)-2.d0*(m1**2-m2**2+qsq)*db1f(qsq,m1,m2))
	endif

	end function
!----------------------------------------------------------------
	double complex function db3f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
	
	db3f = -db1f(qsq,m1,m2)-db2f(qsq,m1,m2)

	end function 
!----------------------------------------------------------------
	double complex function db4f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	db4f = -db1f(qsq,m1,m2)*m2**2-db1f(qsq,m2,m1)*m1**2

	end function 
!----------------------------------------------------------------
	double complex function db5f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	db5f = -4.d0*db22f(qsq,m1,m2)

	end function
!----------------------------------------------------------------
	double complex function db22f(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2
#include "looptools.h"
	CALL ltini

	db22f = db00(qsq,m1**2,m2**2)-1.d0/12.d0*div

	end function
!--------------------------------------------------------------
	double complex function c0f(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
!	complex (kind(0d0)),allocatable:: dummy(:)
#include "looptools.h"
	CALL ltini

	c0f = c0(p1sq,p2sq,qsq,m1**2,m2**2,m3**2)

!	allocate (dummy(Ncc))

!	call Cput(dummy,p1sq,p2sq,qsq,m1**2,m2**2,m3**2)
!	c0f = dummy(1)

	end function 
!--------------------------------------------------------------
	double complex function c24f(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
#include "looptools.h"
	CALL ltini

	c24f = c0i(cc00,p1sq,p2sq,qsq,m1**2,m2**2,m3**2) + div/4.d0

	end function
!--------------------------------------------------------------
	double complex function c11f(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: X_inv(2,2),f1,f2,p12
	double complex:: vec1(2)
	integer:: j

	p12 = (qsq-p1sq-p2sq)/2.d0
	f1 = m2**2-m1**2-p1sq
	f2 = m3**2-m2**2-qsq+p1sq

	X_inv(1,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p2sq
	X_inv(1,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p1sq

	vec1(1) = b0f(qsq,m1,m3)-b0f(p2sq,m2,m3)+f1*c0f(p1sq,p2sq,qsq,m1,m2,m3)
	vec1(2) = b0f(p1sq,m1,m2)-b0f(qsq,m1,m3)+f2*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	c11f=0.d0

		do 20 j = 1, 2
			c11f=c11f+X_inv(1,j)*vec1(j)
20 	continue

	end function
!--------------------------------------------------------------
	double complex function c12f(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: X_inv(2,2),f1,f2,p12
	double complex:: vec1(2)
	integer:: j

	p12 = (qsq-p1sq-p2sq)/2.d0
	f1  = m2**2-m1**2-p1sq
	f2  = m3**2-m2**2-qsq+p1sq

	X_inv(1,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p2sq
	X_inv(1,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p1sq

	vec1(1) = b0f(qsq,m1,m3)-b0f(p2sq,m2,m3)+f1*c0f(p1sq,p2sq,qsq,m1,m2,m3)
   vec1(2) = b0f(p1sq,m1,m2)-b0f(qsq,m1,m3)+f2*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	c12f=0.d0

		do 20 j=1,2
			c12f=c12f+X_inv(2,j)*vec1(j)
20 	continue

	end function
!--------------------------------------------------------------
	double complex function c21f(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: X_inv(2,2),f1,f2,p12
	double complex:: vec1(2)
	integer:: j

	p12 = (qsq-p1sq-p2sq)/2.d0
	f1  = m2**2-m1**2-p1sq
	f2  = m3**2-m2**2-qsq+p1sq

	X_inv(1,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p2sq
	X_inv(1,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p1sq

	vec1(1) =&
		b1f(qsq,m1,m3)+b0f(p2sq,m2,m3)+f1*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		-2.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)
	vec1(2) = b1f(p1sq,m1,m2)-b1f(qsq,m1,m3)+f2*c11f(p1sq,p2sq,qsq,m1,m2,m3)

	c21f = 0.d0

      do 20 j=1,2
			c21f=c21f+X_inv(1,j)*vec1(j)
20 	continue

	end function
!--------------------------------------------------------------
	double complex function c23f(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: X_inv(2,2),f1,f2,p12
	double complex:: vec1(2)
	integer:: j

	p12 = (qsq-p1sq-p2sq)/2.d0
	f1  = m2**2-m1**2-p1sq
	f2  = m3**2-m2**2-qsq+p1sq

	X_inv(1,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p2sq
	X_inv(1,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p1sq

	vec1(1) =&
		b1f(qsq,m1,m3)+b0f(p2sq,m2,m3)&
		+f1*c11f(p1sq,p2sq,qsq,m1,m2,m3)-2.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)
	vec1(2) =&
		b1f(p1sq,m1,m2)-b1f(qsq,m1,m3)+f2*c11f(p1sq,p2sq,qsq,m1,m2,m3)

	c23f=0.d0

		do 20 j=1,2
			c23f=c23f+X_inv(2,j)*vec1(j)
20 	continue

	end function
!--------------------------------------------------------------
	double complex function c23f_2(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: X_inv(2,2),f1,f2,p12
	double complex:: vec1(2)
	integer:: j

	p12 = (qsq-p1sq-p2sq)/2.d0
	f1  = m2**2-m1**2-p1sq
	f2  = m3**2-m2**2-qsq+p1sq

	X_inv(1,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p2sq
	X_inv(1,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p1sq

	vec1(1) = b1f(qsq,m1,m3)-b1f(p2sq,m2,m3)+f1*c12f(p1sq,p2sq,qsq,m1,m2,m3)
	vec1(2) =&
		-b1f(qsq,m1,m3)+f2*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		-2.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	c23f_2 = 0.d0

		do 20 j=1,2
			c23f_2=c23f_2+X_inv(1,j)*vec1(j)
20 	continue

	end function
!--------------------------------------------------------------
	double complex function c22f(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: X_inv(2,2),f1,f2,p12
	double complex:: vec1(2)
	integer:: j

	p12 = (qsq-p1sq-p2sq)/2.d0
	f1  = m2**2-m1**2-p1sq
	f2  = m3**2-m2**2-qsq+p1sq

	X_inv(1,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p2sq
	X_inv(1,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,1) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*(-2.d0*p12)
	X_inv(2,2) = 1.d0/(4.d0*p1sq*p2sq-4.d0*p12**2)*2.d0*p1sq

	vec1(1) = b1f(qsq,m1,m3)-b1f(p2sq,m2,m3)+f1*c12f(p1sq,p2sq,qsq,m1,m2,m3)
	vec1(2) =&
		-b1f(qsq,m1,m3)+f2*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		-2.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	c22f = 0.d0

		do 20 j=1,2
			c22f=c22f+X_inv(2,j)*vec1(j)
20 	continue

	end function
!--------------------------------------------------------------
	double complex function d0f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
#include "looptools.h"
	CALL ltini

	d0f = d0(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d27f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
#include "looptools.h"
	CALL ltini

	d27f = d0i(dd00,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d11f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c0234,c0123,c0134,c0124
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	call ltini

	d11f=&
		d0i(dd1,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd2,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd3,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d12f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c0234,c0123,c0134,c0124
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d12f =&
		d0i(dd2,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd3,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

   End function
!--------------------------------------------------------------
	double complex function d13f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c0234,c0123,c0134,c0124
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d13f = d0i(dd3,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d21f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c11234,c11123,c11134,c11124,c0234
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d21f=&
		d0i(dd11,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+2.d0*d0i(dd12,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+2.d0*d0i(dd13,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd22,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+2.d0*d0i(dd23,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd33,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d22f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c11234,c12123,c11134,c12124
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d22f=&
		d0i(dd22,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+2.d0*d0i(dd23,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd33,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d23f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c12234,c12123,c12134,c12124
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d23f = d0i(dd33,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d24f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c11234,c11123,c11134,c11124,c0234
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d24f =&
		d0i(dd12,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd13,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd22,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+2.d0*d0i(dd23,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd33,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	End function
!--------------------------------------------------------------
	double complex function d25f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c11234,c11123,c11134,c11124,c0234
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d25f =&
		d0i(dd13,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd23,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd33,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!--------------------------------------------------------------
	double complex function d26f(p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4)
	double precision, intent(in):: p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1,m2,m3,m4
	double precision :: p1p2,p2p3,p1p3,f1,f2,f3,f_X,X_inv(3,3)
	double complex :: c12234,c12123,c12134,c12124
	double complex :: vec(3)
	integer :: j
#include "looptools.h"
	CALL ltini

	d26f =&
		d0i(dd23,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)&
		+d0i(dd33,p1sq,p2sq,p3sq,p4sq,p12sq,p23sq,m1**2,m2**2,m3**2,m4**2)

	end function
!====================== 1PI DIAGRAM ================================
	double complex function ChVV1_VVV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_VVV=&
		18.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-3.d0&
		+p1sq*(&
			2.d0*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
			+3.d0*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
			+c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		)&
		+p2sq*(&
			2.d0*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
			+c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		)&
		+p12*(&
			4.d0*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
			+3.d0*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
			+c11f(p1sq,p2sq,qsq,m1,m2,m3)&
			-4.d0*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		)

	end function
!---------------------------------------------
	double complex function ChVV2_VVV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV2_VVV =&
		10.d0*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		+9.d0*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		+c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+5.d0*c0f(p1sq,p2sq,qsq,m1,m2,m3)
	 
	end function
!---------------------------------------------
	double complex function ChVV1_SVV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_SVV=&
		3.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
		+p1sq*(&
			c21f(p1sq,p2sq,qsq,m1,m2,m3)&
			-c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		)&
		+p2sq*(&
			c22f(p1sq,p2sq,qsq,m1,m2,m3)&
			-2.d0*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
			+c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		)&
		+2.d0*p12*(&
			+c23f(p1sq,p2sq,qsq,m1,m2,m3)&
			-c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		)

	end function
!---------------------------------------------
	double complex function ChVV2_SVV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV2_SVV =&
		4.d0*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		-3.d0*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		-c23f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	double complex function ChVV1_VVS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV1_VVS =&
		3.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
		+p1sq*(&
			c21f(p1sq,p2sq,qsq,m1,m2,m3)&
			+4.d0*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
			+4.d0*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		)&
		+p2sq*(&
			c22f(p1sq,p2sq,qsq,m1,m2,m3)&
			+2.d0*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		)&
		+2.d0*p12*(&
			c23f(p1sq,p2sq,qsq,m1,m2,m3)&
			+2.d0*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
			+c11f(p1sq,p2sq,qsq,m1,m2,m3)&
			+2.d0*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		)

	end function
!---------------------------------------------
	double complex function ChVV2_VVS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV2_VVS =&
		2.d0*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		-5.d0*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		-2.d0*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		-c23f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	double complex function C1223(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	C1223 = c12f(p1sq,p2sq,qsq,m1,m2,m3)+c23f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	double complex function ChVV2_VSS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV2_VSS =&
		2.d0*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		+c23f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	double complex function ChVV2_SSV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	ChVV2_SSV = c23f(p1sq,p2sq,qsq,m1,m2,m3)-c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!=========================================================================
	double complex function Chff_FVF(p1sq,p2sq,qsq,mf,mv)
	double precision, intent(in):: p1sq,p2sq,qsq,mf,mv

	Chff_FVF =&
		mf**2*c0f(p1sq,p2sq,qsq,mf,mv,mf)&
	   +p1sq*(c11f(p1sq,p2sq,qsq,mf,mv,mf)+c21f(p1sq,p2sq,qsq,mf,mv,mf))&
	   +p2sq*(c12f(p1sq,p2sq,qsq,mf,mv,mf)+c22f(p1sq,p2sq,qsq,mf,mv,mf))&
	   +(qsq-p1sq-p2sq)/2.d0*(2.d0*c23f(p1sq,p2sq,qsq,mf,mv,mf)-c0f(p1sq,p2sq,qsq,mf,mv,mf))&
	   +4.d0*c24f(p1sq,p2sq,qsq,mf,mv,mf)-1.d0
	
	end function
!---------------------------------------------
	double complex function Chff_FSF(p1sq,p2sq,qsq,mf,ms)
	double precision, intent(in):: p1sq,p2sq,qsq,mf,ms

	Chff_FSF =&
		mf**2*c0f(p1sq,p2sq,qsq,mf,ms,mf)&
		+p1sq*(c11f(p1sq,p2sq,qsq,mf,ms,mf)+c21f(p1sq,p2sq,qsq,mf,ms,mf))&
		+p2sq*(c12f(p1sq,p2sq,qsq,mf,ms,mf)+c22f(p1sq,p2sq,qsq,mf,ms,mf))&
		+(qsq-p1sq-p2sq)*(c11f(p1sq,p2sq,qsq,mf,ms,mf)+c23f(p1sq,p2sq,qsq,mf,ms,mf))&
		+4.d0*c24f(p1sq,p2sq,qsq,mf,ms,mf)-1.d0/2.d0

	end function
!---------------------------------------------
	double complex function Chff_VFS(p1sq,p2sq,qsq,mv,mf,ms)
	double precision, intent(in):: p1sq,p2sq,qsq,mv,mf,ms

	Chff_VFS =&
		p1sq*(&
			2.d0*c0f(p1sq,p2sq,qsq,mv,mf,ms)+3.d0*c11f(p1sq,p2sq,qsq,mv,mf,ms)&
			+c21f(p1sq,p2sq,qsq,mv,mf,ms)&
		)&
		+p2sq*(&
			2.d0*c12f(p1sq,p2sq,qsq,mv,mf,ms)+c22f(p1sq,p2sq,qsq,mv,mf,ms)&
		)&
		+(qsq-p1sq-p2sq)*(&
			+2.d0*c12f(p1sq,p2sq,qsq,mv,mf,ms)+c23f(p1sq,p2sq,qsq,mv,mf,ms)&
		)&
		+4.d0*c24f(p1sq,p2sq,qsq,mv,mf,ms)-1.d0/2.d0	
	
	end function
!---------------------------------------------
	double complex function Chff_SFV(p1sq,p2sq,qsq,ms,mf,mv)
	double precision, intent(in):: p1sq,p2sq,qsq,ms,mf,mv

	Chff_SFV=&
		p1sq*(&
			-c0f(p1sq,p2sq,qsq,ms,mf,mv)+c21f(p1sq,p2sq,qsq,ms,mf,mv)&
		)&
		+p2sq*(&
			-c12f(p1sq,p2sq,qsq,ms,mf,mv)+c22f(p1sq,p2sq,qsq,ms,mf,mv)&
		)&
		+(qsq-p1sq-p2sq)*(&
			c23f(p1sq,p2sq,qsq,ms,mf,mv)+c12f(p1sq,p2sq,qsq,ms,mf,mv)&
			-c0f(p1sq,p2sq,qsq,ms,mf,mv)-c11f(p1sq,p2sq,qsq,ms,mf,mv)&
		)&
		+4.d0*c24f(p1sq,p2sq,qsq,mv,mf,ms)-1.d0/2.d0	

	end function
!---------------------------------------------
	double complex function Chhh_SVV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_SVV =&
      p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
      +p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
      +2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
      +4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
      -(2.d0*p1sq+p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
      -(p2sq+2.d0*p12)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
      +(p1sq+p12)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		!
      +p1sq*c21f(p1sq,p2sq,qsq,m3,m1,m2)&
      +p2sq*c22f(p1sq,p2sq,qsq,m3,m1,m2)&
      +2.d0*p12*c23f(p1sq,p2sq,qsq,m3,m1,m2)&
      +4.d0*c24f(p1sq,p2sq,qsq,m3,m1,m2)-1.d0/2.d0&
      +(3.d0*p1sq-p12)*c11f(p1sq,p2sq,qsq,m3,m1,m2)&
      +(-p2sq+3.d0*p12)*c12f(p1sq,p2sq,qsq,m3,m1,m2)&
      +(2.d0*p1sq-2.d0*p12)*c0f(p1sq,p2sq,qsq,m3,m1,m2)&
		!
      +p1sq*c21f(p1sq,p2sq,qsq,m2,m3,m1)&
      +p2sq*c22f(p1sq,p2sq,qsq,m2,m3,m1)&
      +2.d0*p12*c23f(p1sq,p2sq,qsq,m2,m3,m1)&
      +4.d0*c24f(p1sq,p2sq,qsq,m2,m3,m1)-1.d0/2.d0&
      +(3.d0*p1sq+4.d0*p12)*c11f(p1sq,p2sq,qsq,m2,m3,m1)&
      +(4.d0*p2sq+3.d0*p12)*c12f(p1sq,p2sq,qsq,m2,m3,m1)&
      +(2.d0*qsq+2.d0*p12+2.d0*p2sq)*c0f(p1sq,p2sq,qsq,m2,m3,m1)

	 end function
!---------------------------------------------
	double complex function Chhh_VSS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_VSS=&
      p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
      +p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
      +2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
      +4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
      +(4.d0*p1sq+2.d0*p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
      +(4.d0*p12+2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
      +4.d0*(p1sq+p12)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		!
      +p1sq*c21f(p1sq,p2sq,qsq,m3,m1,m2)&
      +p2sq*c22f(p1sq,p2sq,qsq,m3,m1,m2)&
      +2.d0*p12*c23f(p1sq,p2sq,qsq,m3,m1,m2)&
      +4.d0*c24f(p1sq,p2sq,qsq,m3,m1,m2)-1.d0/2.d0&
      +(2.d0*p12)*c11f(p1sq,p2sq,qsq,m3,m1,m2)&
      +(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m3,m1,m2)&
      -(p1sq+2.d0*p12)*c0f(p1sq,p2sq,qsq,m3,m1,m2)&
		! 
      +p1sq*c21f(p1sq,p2sq,qsq,m2,m3,m1)&
      +p2sq*c22f(p1sq,p2sq,qsq,m2,m3,m1)&
      +2.d0*p12*c23f(p1sq,p2sq,qsq,m2,m3,m1)&
      +4.d0*c24f(p1sq,p2sq,qsq,m2,m3,m1)-1.d0/2.d0&
      -(2.d0*p12)*c11f(p1sq,p2sq,qsq,m2,m3,m1)&
      -(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m2,m3,m1)&
      -(p1sq-p2sq)*c0f(p1sq,p2sq,qsq,m2,m3,m1)

	end function
!-------------------------------------------------------------
! 	SVS
!-------------------------------------------------------------
	complex (kind(0d0)) function CSVS_SVV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSVS_SVV =&
		4.d0*b0f(p2sq,m2,m3)-4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)&
		-(3.d0*p1sq-p2sq+qsq)*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(p1sq-qsq)*(c12f(p1sq,p2sq,qsq,m1,m2,m3)+c23f(p1sq,p2sq,qsq,m1,m2,m3))&
		-(p1sq+2.d0*p2sq-qsq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(p2sq+4.d0*m1**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSVS_VSS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSVS_VSS =&
		4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(3.d0*p1sq-p2sq+qsq)*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		-2.d0*(p1sq-qsq)*(c12f(p1sq,p2sq,qsq,m1,m2,m3)+c23f(p1sq,p2sq,qsq,m1,m2,m3))&
		+(5.d0*p1sq-3.d0*p2sq+3.d0*qsq+m1**2)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(2.d0*p1sq-2.d0*p2sq+2.d0*qsq+m1**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSVS_SVS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSVS_SVS = c0f(p1sq,p2sq,qsq,m1,m2,m3)-c11f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSVS_SSV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSVS_SSV = c0f(p1sq,p2sq,qsq,m1,m2,m3)-c11f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSVS_SSS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSVS_SSS = c0f(p1sq,p2sq,qsq,m1,m2,m3)+c11f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-------------------------------------------------------------
! 	SSS
!-------------------------------------------------------------
	complex (kind(0d0)) function CSSS_SVS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSSS_SVS=&
		b0f(p1sq,m1,m2)+b0f(p2sq,m2,m3)-b0f(qsq,m1,m3)&
		+(p1sq+p2sq-2.d0*qsq+m1**2-m2**2+m3**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSSS_SSV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSSS_SSV=&
		-b0f(p1sq,m1,m2)+b0f(p2sq,m2,m3)+b0f(qsq,m1,m3)&
		+(-2.d0*p1sq+p2sq+qsq+m1**2+m2**2-m3**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSSS_VSS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSSS_VSS=&
		b0f(p1sq,m1,m2)-b0f(p2sq,m2,m3)+b0f(qsq,m1,m3)&
		+(p1sq-2.d0*p2sq+qsq-m1**2+m2**2+m3**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSSS_VSV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSSS_VSV=&
		-b0f(p1sq,m1,m2)/2.d0-b0f(p2sq,m2,m3)/2.d0+2.d0*b0f(qsq,m1,m3)&
		+(p1sq+p2sq-qsq/2.d0-m1**2/2.d0+2.d0*m2**2-m3**2/2.d0)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSSS_VVS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSSS_VVS=&
		2.d0*b0f(p1sq,m1,m2)-1.d0/2.d0*b0f(p2sq,m2,m3)-1.d0/2.d0*b0f(qsq,m1,m3)&
		+(-p1sq/2.d0+p2sq+qsq-m1**2/2.d0-m2**2/2.d0+2.d0*m3**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSSS_SVV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSSS_SVV=&
		-1.d0/2.d0*b0f(p1sq,m1,m2)+2.d0*b0f(p2sq,m2,m3)-1.d0/2.d0*b0f(qsq,m1,m3)&
		+(p1sq-p2sq/2.d0+qsq+2.d0*m1**2-m2**2/2.d0-m3**2/2.d0)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function

	end module pv