subroutine HCOUP_HSM(OREW,ORQCD)

use SM_const
use pv
use Gauge_boson_2p
use SM_Hdecay
use real_photon_emission
use HCOUP_SM
use func_forQCDco
use int_romberg

	implicit none

	integer:: i,j,k
	integer:: OREW,ORQCD,constraint(6)
	character(4):: C_EW
	character(20):: C_QCD
	double precision:: rmc_mh,rmb_mh

	!========== Model parameters ==========
	double precision:: mbh,alpha,lam_ps,lam_s,mu_s
	double precision:: cutoff,mu_r
	double precision:: para1(100)
	integer:: SCHEME
	!---------- scheme difference ----------
	! 0: Pinched tadpole, del_bM^2
	! 1: KOSY with PT, del_bM^2

	!========== Momentum inputs ==========
	complex (kind(0d0)):: vhZZ(3),vhWW(3),vhtt(8),vhbb(8),vhcc(8),vhll(8),vhmumu(8),vhhh
	complex (kind(0d0)):: vhZZ_sm(3),vhWW_sm(3),vhtt_sm(8),vhbb_sm(8),vhcc_sm(8),vhll_sm(8),vhmumu_sm(8),vhhh_sm
	double precision:: p_hzz(3),p_hww(3),p_htt(3),p_hbb(3),p_hcc(3),p_hll(3),p_hmumu(3),p_hhh(3)
	double precision:: para2(100)

	!========== RGE ==========
	double precision:: nh = 1.d0,ng = 3.d0,gs,gp,yt

	!========== SM Higgs decay ==========
	double precision:: hdecay_SM(-50:50,-50:50)=0.d0
	double precision:: BRh_SM(-50:50,-50:50)=0.d0
	double precision:: vGam_hhh_SM
	double precision:: Gam_h_total_SM
	!---------- h -> ZZ* and h-> WW* ----
	double precision:: vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
	double precision:: vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm

	!========== SM-like Higgs decay ==========
	double precision:: hdecay(-50:50,-50:50)=0.d0
	double precision:: BRh(-50:50,-50:50)=0.d0
	double precision:: vGam_hhh_HSM
	double precision:: Gam_h_total

	!========== additional Higgs decay ==========
	double precision:: bHdecay(-50:50,-50:50)=0.d0
	double precision:: BRbH(-50:50,-50:50)=0.d0
	double precision:: Gam_bH_total

	!========== LoopTools ==========
	double precision:: getmudim,getlambda,getminmass
	double precision:: p1sq,p2sq,qsq

	!========== files ==========
	integer:: flag, ios
	character:: writefile1*128,writefile2*128,writefile3*128,writefile4*128
	character:: readfile1*128
	logical:: hZZ_exist,hWW_exist

	!========== Misc. ==========
	complex (kind(0d0)),allocatable:: dummy(:)
	double precision:: test(100)=0.d0
	complex (kind(0d0)):: ctest(100)

	open(1, file='./inputs/in_hsm.txt')
	do i = 1, 100
		if (i <= 6) then
			read (1,'()')
		else
			read (1,*,end=30) para1(i-6)
		endif
	enddo 

30	mbh    = para1(1)
	alpha  = para1(2)
	lam_ps = para1(3)
	lam_s  = para1(4)
	mu_s   = para1(5)
	cutoff = para1(6)
	mu_r   = para1(7)
	SCHEME = para1(8)

	open(2, file='./inputs/in_momentum.txt')
	do i = 1, 100
		if (i <= 6) then
			read (2,'()')
		else
			read (2,*,end=40) para2(i-6)
		endif
	enddo 

40 p_hzz(1)   = para2(1)
	p_hzz(2)   = para2(2)
	p_hzz(3)   = para2(3)
	!--------------------------------------------------------------------------------------------------------
   p_hww(1)   = para2(4)
   p_hww(2)   = para2(5)
   p_hww(3)   = para2(6)
	!--------------------------------------------------------------------------------------------------------
   p_htt(1)   = para2(7)
   p_htt(2)   = para2(8)
   p_htt(3)   = para2(9)
	!--------------------------------------------------------------------------------------------------------
   p_hbb(1)   = para2(10)
   p_hbb(2)   = para2(11)
   p_hbb(3)   = para2(12)
	!--------------------------------------------------------------------------------------------------------
   p_hcc(1)   = para2(13)
   p_hcc(2)   = para2(14)
   p_hcc(3)   = para2(15)
	!--------------------------------------------------------------------------------------------------------
   p_hll(1)   = para2(16)
   p_hll(2)   = para2(17)
   p_hll(3)   = para2(18)
	!--------------------------------------------------------------------------------------------------------
   p_hmumu(1) = para2(19)
   p_hmumu(2) = para2(20)
   p_hmumu(3) = para2(21)
	!--------------------------------------------------------------------------------------------------------
   p_hhh(1)   = para2(22)
   p_hhh(2)   = para2(23)
   p_hhh(3)   = para2(24)

	call ltini

	if (OREW == 0) then
		C_EW = 'LO'
	else if(OREW == 1) then
		C_EW = 'NLO'
	end if

	if (ORQCD == -1) then
		C_QCD = 'LO(quark mass:OS)'
	else if (ORQCD == 0) then
		C_QCD = 'LO(quark mass:MSbar)'
	else if(ORQCD == 1) then
		C_QCD = 'NLO'
	else if(ORQCD == 2) then
		C_QCD = 'NNLO'
	end if

	gs = sqrt(alpha_s*4.d0*pi)
	gp = g*sw/cw
	yt = sqrt(2.d0)*mt/vev

	! !===== This is needed for calculations with mphoton=0.d0 ====== 
	! QED = 1.d0; mphoton = 0.d0
	! allocate (dummy(300))
	! call Cput(dummy,125.d0**2,80.d0**2,400.d0**2,400.d0**2,80.d0**2,0.d0)
	! call Dput(dummy,msir**2,mc**2,mW**2,mh**2,20.d0**2,10.d0**2,mW**2,mc**2,0.d0,mW**2)
	! !====================================================

	!========== calculate hVVstar_sm (take several minites) and make text file ==========
	if(OREW == 0) then
		call decay_hZZstar_sm(vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD)
		call decay_hWWstar_sm(vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD)
	else if(OREW == 1) then
		inquire (file="modules/dat/hVVstar_sm/hZZstar_sm.txt",exist=hZZ_exist)	
		open(10,file="modules/dat/hVVstar_sm/hZZstar_sm.txt")
		if(hZZ_exist) then
			read(10,*) vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
		else
			call decay_hZZstar_sm(vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD)
			write(10,*) vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
		endif
		close(10)

		inquire (file="modules/dat/hVVstar_sm/hWWstar_sm.txt",exist=hWW_exist)
		open(20,file="modules/dat/hVVstar_sm/hWWstar_sm.txt")

		if(hWW_exist) then
			read(20,*) vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm
		else
			call decay_hWWstar_sm(vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD)
			write(20,*) vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm
		endif
		close(20)
	endif

	!###########################################################################
	! Main
	!###########################################################################
	if(main_prog) then
		!###################################   Constraints   ########################################
		constraint(:) = 0
		if (vs(mbH,alpha,lam_ps,lam_s,mu_s) /= 0.d0) then
			write(*,*) 'Excluded by vacuum stability at tree level'
			constraint(1) = 1
		endif 

		if (pu(mbH,alpha,lam_ps,lam_s,mu_s) /= 0.d0) then 
			write(*,*) 'Excluded by tree-level unitarity'
			constraint(2) = 1
		endif

		if (stu(mbh,alpha) /= 0.d0) then
			write(*,*) 'Excluded by S and T parameters'
			constraint(3) = 1
		endif

		if (wrong(mbH,alpha,lam_ps,lam_s,mu_s) /= 0.d0) then 
			write(*,*) 'Excluded by true vacuum condition'
			constraint(4) = 1
		endif

		if (sqrt(2.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)) >= 1d+3 .and.&
			 cutoff > dsqrt(2.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s))) then
			if (vs_rge_MSM(cutoff,mbH,alpha,lam_ps,lam_s,mu_s) /= 0.d0) then 
				write(*,*) 'Excluded by vacuum stability (RGE improved with the cutoff scale and SM matching)'
				constraint(5) = 1
			endif
			if (triviality_MSM(cutoff,mbH,alpha,lam_ps,lam_s,mu_s) /= 0.d0) then        
				write(*,*) 'Excluded by triviality (with the cutoff scale and SM matching )'        
				constraint(6) = 1
			endif 
		else
			if (vs_rge(cutoff,mbH,alpha,lam_ps,lam_s,mu_s) /= 0.d0) then 
				write(*,*) 'Excluded by vacuum stability (RGE improved with the cutoff scale)'
				constraint(5) = 1
			endif
			if (triviality(cutoff,mbH,alpha,lam_ps,lam_s,mu_s) /= 0.d0) then        
				write(*,*) 'Excluded by triviality (with the cutoff scale)'        
				constraint(6) = 1
			endif 
		end if
	
		!###################################   Effective vertices   ########################################
		open(10,file="outputs/out_sm.txt")
		open(11,file="outputs/out_hsm.txt")

		!============================== SM ==============================
		vhZZ_sm(1)   = rGam1_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhZZ_sm(2)   = rGam2_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhZZ_sm(3)   = rGam3_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhWW_sm(1)   = rGam1_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhWW_sm(2)   = rGam2_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhWW_sm(3)   = rGam3_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhtt_sm(1)   = rGamS_htt_sm(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2)
		vhbb_sm(1)   = rGamS_hbb_sm(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2)
		vhcc_sm(1)   = rGamS_hcc_sm(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2)
		vhll_sm(1)   = rGamS_htautau_sm(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2)
		vhmumu_sm(1) = rGamS_hmumu_sm(p_hmumu(1)**2,p_hmumu(2)**2,p_hmumu(3)**2)
		vhhh_sm      = rGam_hhh_sm(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2)

		write(10,*) "============================== Higgs vertex functions =============================="
		write(10,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ_sm(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ_sm(1))
		write(10,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ_sm(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ_sm(2))
		write(10,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ_sm(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ_sm(3))
		write(10,100) 'Re[rGam_hWW(1)]:', dble(vhWW_sm(1)),'Im[rGam_hWW(1)]:', imag(vhWW_sm(1))
		write(10,100) 'Re[rGam_hWW(2)]:', dble(vhWW_sm(2)),'Im[rGam_hWW(2)]:', imag(vhWW_sm(2))
		write(10,100) 'Re[rGam_hWW(3)]:', dble(vhWW_sm(3)),'Im[rGam_hWW(3)]:', imag(vhWW_sm(3))
		write(10,100) 'Re[rGam_htt(S)]:', dble(vhtt_sm(1)),'Im[rGam_htt(S)]:', imag(vhtt_sm(1))
		write(10,100) 'Re[rGam_hbb(S)]:', dble(vhbb_sm(1)),'Im[rGam_hbb(S)]:', imag(vhbb_sm(1))
		write(10,100) 'Re[rGam_hcc(S)]:', dble(vhcc_sm(1)),'Im[rGam_hcc(S)]:', imag(vhcc_sm(1))
		write(10,100) 'Re[rGam_htautau(S)]:', dble(vhll_sm(1)),'Im[rGam_htautau(S)]:', imag(vhll_sm(1))
		write(10,100) 'Re[rGam_hmumu(S)]:', dble(vhmumu_sm(1)),'Im[rGam_hmumu(S)]:', imag(vhmumu_sm(1))
		write(10,100) 'Re[rGam_hhh]:'   , dble(vhhh_sm),'Im[rGam_hhh]:', imag(vhhh_sm)

		!============================== HSM ==============================
		vhZZ(1)   = rGam1_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhZZ(2)   = rGam2_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhZZ(3)   = rGam3_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhWW(1)   = rGam1_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhWW(2)   = rGam2_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhWW(3)   = rGam3_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhtt(1)   = rGamS_htt(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhbb(1)   = rGamS_hbb(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhbb(1)   = rGamS_hbb(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhcc(1)   = rGamS_hcc(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhll(1)   = rGamS_htautau(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhmumu(1) = rGamS_hmumu(p_hmumu(1)**2,p_hmumu(2)**2,p_hmumu(3)**2,mbH,alpha,lam_ps,lam_s,mu_s)
		vhhh      = rGam_hhh(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)

		write(11,*) "============================== Higgs vertex functions =============================="
		write(11,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ(1))
		write(11,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ(2))
		write(11,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ(3))
		write(11,100) 'Re[rGam_hWW(1)]:', dble(vhWW(1)),'Im[rGam_hWW(1)]:', imag(vhWW(1))
		write(11,100) 'Re[rGam_hWW(2)]:', dble(vhWW(2)),'Im[rGam_hWW(2)]:', imag(vhWW(2))
		write(11,100) 'Re[rGam_hWW(3)]:', dble(vhWW(3)),'Im[rGam_hWW(3)]:', imag(vhWW(3))
		write(11,100) 'Re[rGam_htt(S)]:', dble(vhtt(1)),'Im[rGam_htt(S)]:', imag(vhtt(1))
		write(11,100) 'Re[rGam_hbb(S)]:', dble(vhbb(1)),'Im[rGam_hbb(S)]:', imag(vhbb(1))
		write(11,100) 'Re[rGam_hcc(S)]:', dble(vhcc(1)),'Im[rGam_hcc(S)]:', imag(vhcc(1))
		write(11,100) 'Re[rGam_htautau(S)]:', dble(vhll(1)),'Im[rGam_htautau(S)]:', imag(vhll(1))
		write(11,100) 'Re[rGam_hmumu(S)]:', dble(vhmumu(1)),'Im[rGam_hmumu(S)]:', imag(vhmumu(1))
		write(11,100) 'Re[rGam_hhh]:'   , dble(vhhh),'Im[rGam_hhh]:', imag(vhhh)

		!###################################   Decay branching ratios   ########################################
		100 Format(A24,1PE18.8,A24,1PE18.8)
		200 Format(A20,1PE18.8)

		98 format('# ',A)
		99 format('#')        
		101 format('BLOCK ',A,' #',A)
		102 format(3x,I3,4x,I3,'   # ',A)
		103 format(3x,I3,4x,1PE16.8,'   # ',A)
		104 format(3x,I3,4x,I3,13x,'   # ',A)

		201 format('#',10x,'PDG',10x,'Width')
		! 202 format('DECAY',I9,3x,E16.8,3x,'# ',A) 
		202 format('DECAY',I9,3x,E16.8,3x,'# EW:',A,'QCD:',A)
		203 format('#',10x,'BR',9x,'NDA',7x,'ID1',6x,'ID2')
		213 format('#',10x,'Gamma',6x,'NDA',7x,'ID1',6x,'ID2')
		204 format(3x,1PE16.8,4x,I2,1x,I9,I9,4x'# ',A)

		!===================================   SM OUTPUTS   ========================================
		open(12,file="outputs/outBR_sm.txt")
		call header_outputs(12)
		write(12,101) 'MODEL'
		write(12,102) 1,0,'SM'

		write(12,101) 'SMINPUTS'
		write(12,103) 1,alpha_em,'alpha_em' 
		write(12,103) 2,G_F,'Fermi constant' 
		write(12,103) 3,alpha_s,'alpha_s' 
		write(12,103) 4,mc_MS,'mc(mc) MSbar'
		write(12,103) 5,mb_MS,'mb(mb) MSbar'
		write(12,103) 6,mc,'mc On-shell'
		write(12,103) 7,mb,'mb On-shell'
		
		rmc_mh = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD4,mc_MS,4.d0),mc_MS) 
		rmb_mh = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD5,mb_MS,5.d0),mb_MS)
		
		write(12,101) 'MASS'
		!write(12,103) 1,0.,'md'
		!write(12,103) 2,0.,'mu'
		!write(12,103) 3,0.,'ms'
		write(12,103) 4,rmc_mh,'mc(mh) MSbar'
		write(12,103) 5,rmb_mh,'mb(mh) MSbar'
		write(12,103) 6,mt,'mt'                
		write(12,103) 13,mmu,'mmu'
		write(12,103) 15,mtau,'mtau'
		write(12,103) 23,mz,'mz'
		write(12,103) 24,mw,'mw (calculated,tree)' 
		write(12,103) 24,rmw_SM(),'mw (calculated,1-loop)' 
		write(12,103) 25,mh,'mh'

		!======================================================================
		!  SM Higgs boson'
		!======================================================================
		!========== initialization ==========
		hdecay_SM(:,:) = 0.d0; BRh_SM(:,:) = 0.d0; Gam_h_total_SM = 0.d0

		!========== quark decay ==========
		hdecay_SM(5,-5) = decay_hbb_sm(mh,OREW,ORQCD)
		hdecay_SM(4,-4) = decay_hcc_sm(mh,OREW,ORQCD)

		!========== leptonic decay ==========
		hdecay_SM(15,-15) = decay_htautau_sm(mh,OREW)
		hdecay_SM(13,-13) = decay_hmumu_sm(mh,OREW)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		hdecay_SM(23,23)  = vdecay_hZZstar_sm
		hdecay_SM(24,-24) = vdecay_hWWstar_sm

		!========== loop-induced decay ==========
		hdecay_SM(21,21) = decay_hgg_sm(mh,ORQCD)
		hdecay_SM(22,22) = decay_hgamgam_sm(mh,ORQCD)
		hdecay_SM(22,23) = decay_hZgam_sm(mh,ORQCD)

		!========== total decay width ==========
		Gam_h_total_SM = sum(hdecay_SM)

		!========== decay branching ratio ==========
		BRh_SM = hdecay_SM/Gam_h_total_SM

		write(12,99)
		write(12,98)'Decay branching ratios of the SM Higgs boson by H-COUP #'
		write(12,201)
		write(12,202) 25,Gam_h_total_SM,C_EW,C_QCD
		write(12,203)
		write(12,204) BRh_SM(4,-4),   2,  4,  -4, 'BR(h -> c c~)'
		write(12,204) BRh_SM(5,-5),   2,  5,  -5, 'BR(h -> b b~)'
		write(12,204) BRh_SM(13,-13), 2, 13, -13, 'BR(h -> mu- mu+)'
		write(12,204) BRh_SM(15,-15), 2, 15, -15, 'BR(h -> tau- tau+)'
		write(12,204) BRh_SM(21,21),  2, 21,  21, 'BR(h -> g g)'
		write(12,204) BRh_SM(22,22),  2, 22,  22, 'BR(h -> gam gam)'
		write(12,204) BRh_SM(22,23),  2, 22,  23, 'BR(h -> gam Z)'
		write(12,204) BRh_SM(23,23),  2, 23,  23, 'BR(h -> Z Z*)'
		write(12,204) BRh_SM(24,-24), 2, 24, -24, 'BR(h -> W+ W-*)'
 
		!===================================   HSM OUTPUTS   ========================================
		open(13,file="outputs/outBR_hsm.txt") 
		call header_outputs(13)
		write(13,101) 'MODEL'
		write(13,102) 1,1,'HSM' 
		write(13,102) 2,SCHEME,'MSbar renormalization scheme'

		write(13,101) 'BSMINPUTS'
		write(13,103) 1,alpha,'alpha' 
		write(13,103) 2,lam_ps,'lambda_{phi S}' 
		write(13,103) 3,lam_s,'lambda_S' 
		write(13,103) 4,mu_s,'mu_S (GeV)'
		write(13,103) 5,mu_r,'mu_r (GeV)' 

		write(13,101) 'SMINPUTS'
		write(13,103) 1,alpha_em,'alpha_em' 
		write(13,103) 2,G_F,'Fermi constant' 
		write(13,103) 3,alpha_s,'alpha_s' 
		write(13,103) 4,mc_MS,'mc(mc) MSbar'
		write(13,103) 5,mb_MS,'mb(mb) MSbar'
		write(13,103) 6,mc,'mc On-shell'
		write(13,103) 7,mb,'mb On-shell'
		
		write(13,101) 'MASS'        
		!write(13,103) 1,0.,'md'
		!write(13,103) 2,0.,'mu'
		!write(13,103) 3,0.,'ms'
		write(13,103) 4,rmc_mh,'mc(mh) MSbar'
		write(13,103) 5,rmb_mh,'mb(mh) MSbar'
		write(13,103) 6,mt,'mt'                
		write(13,103) 13,mmu,'mmu'
		write(13,103) 15,mtau,'mtau'
		write(13,103) 23,mz,'mz'
		write(13,103) 24,mw,'mw (calculated,tree)' 
		write(13,103) 24,rmW(mbH,alpha,lam_ps,lam_s,mu_s),'mw (calculated,1-loop)' 
		write(13,103) 25,mh,'mh'
		write(13,103) 35,mbh,'mH' 

		write(13,101) 'CONSTRAINTS'
		write(13,103) 0,cutoff,'The cutoff scale (GeV)'
		write(13,102) 1,constraint(1),'Vacuum stability at tree level [0=OK, 1=No]'
		write(13,102) 2,constraint(2),'Tree-level unitarity [0=OK, 1=No]'
		write(13,102) 3,constraint(3),'S and T parameters [0=OK, 1=No]'
		write(13,102) 4,constraint(4),'True vacuum [0=OK, 1=No]'
		write(13,102) 5,constraint(5),'Vacuum stability (RGE improved with the cutoff scale) [0=OK, 1=No]'
		write(13,102) 6,constraint(6),'Triviality (with the cutoff scale) [0=OK, 1=No]'

		!======================================================================
		!  Lighter CP-even Higgs boson'
		!======================================================================
		!========== initialization ==========
		hdecay(:,:) = 0.d0; brh(:,:) = 0.d0; Gam_h_total = 0.d0

		!========== quark decay ==========
		hdecay(5,-5) = decay_hbb(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
		hdecay(4,-4) = decay_hcc(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)

		!========== leptonic decay ==========
		hdecay(15,-15) = decay_htautau(mbH,alpha,lam_ps,lam_s,mu_s,OREW)
		hdecay(13,-13) = decay_hmumu(mbH,alpha,lam_ps,lam_s,mu_s,OREW)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		call decay_hZZstar(hdecay(23,23),vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD,alpha)
		call decay_hWWstar(hdecay(24,-24),vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD,alpha)

		! ! ---------- SS ----------
		! hdecay(25,25) = decay_hbHbH(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)

		!========== loop-induced decay ==========
		hdecay(21,21) = decay_hgg(mbH,alpha,lam_ps,lam_s,mu_s,ORQCD)
		hdecay(22,22) = decay_hgamgam(mbH,alpha,lam_ps,lam_s,mu_s,ORQCD)
		hdecay(22,23) = decay_hZgam(mbH,alpha,lam_ps,lam_s,mu_s,ORQCD)

		!========== total decay width ==========
		Gam_h_total = sum(hdecay)

		!========== decay branching ratio ==========
		BRh = hdecay/Gam_h_total

		write(13,99)
		write(13,98)'Decay branching ratios of the SM-like Higgs boson by H-COUP #'
		write(13,201)
		write(13,202) 25,Gam_h_total,C_EW,C_QCD
		write(13,203)
		write(13,204) BRh(4,-4),   2,  4,  -4, 'BR(h -> c c~)'
		write(13,204) BRh(5,-5),   2,  5,  -5, 'BR(h -> b b~)'
		write(13,204) BRh(13,-13), 2, 13, -13, 'BR(h -> mu- mu+)'
		write(13,204) BRh(15,-15), 2, 15, -15, 'BR(h -> tau- tau+)'
		write(13,204) BRh(21,21),  2, 21,  21, 'BR(h -> g g)'
		write(13,204) BRh(22,22),  2, 22,  22, 'BR(h -> gam gam)'
		write(13,204) BRh(22,23),  2, 22,  23, 'BR(h -> gam Z)'
		write(13,204) BRh(23,23),  2, 23,  23, 'BR(h -> Z Z*)'
		write(13,204) BRh(24,-24), 2, 24, -24, 'BR(h -> W+ W-*)'

		!======================================================================
		!  Heavier CP-even Higgs boson'
		!======================================================================
		!========== initialization ==========
		bHdecay(:,:) = 0.d0; brbH(:,:) = 0.d0; Gam_bH_total = 0.d0

		!========== quark decay ==========
		bHdecay(6,-6) = Gam_bHtt(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
		bHdecay(5,-5) = Gam_bHqq(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mb)
		bHdecay(4,-4) = Gam_bHqq(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mc)

		!========== leptonic decay ==========
		bHdecay(15,-15) = Gam_bHll(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mtau)
		bHdecay(13,-13) = Gam_bHll(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mmu)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		bHdecay(23,23)  = Gam_bHZZ(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
		bHdecay(24,-24) = Gam_bHWW(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
		!---------- SS ----------
		bHdecay(25,25) = Gam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s,mu_r,OREW,ORQCD,SCHEME)

		!========== loop-induced decay ==========
		bHdecay(21,21) = Gam_bHgg(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
		bHdecay(22,22) = Gam_bHgamgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
		bHdecay(22,23) = Gam_bHZgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)

		!========== total decay width ==========
		Gam_bH_total = sum(bHdecay)

		!========== decay branching ratio ==========
		BRbH = bHdecay/Gam_bH_total

		write(13,99)
		write(13,98)'Decay branching ratios of the additional CP-even Higgs boson bH by H-COUP #'
		write(13,201)
		write(13,202) 35,Gam_bH_total,C_EW,C_QCD
		write(13,203)
		write(13,204) BRbH(6,-6),   2,  6, -6,  'BR(bH -> t t~)'
		write(13,204) BRbH(5,-5),   2,  5, -5,  'BR(bH -> b b~)'
		write(13,204) BRbH(4,-4),   2,  4, -4,  'BR(bH -> c c~)'
		write(13,204) BRbH(13,-13), 2, 13, -13, 'BR(bH -> mu- mu+)'
		write(13,204) BRbH(15,-15), 2, 15, -15, 'BR(bH -> tau- tau+)'
		write(13,204) BRbH(23,23),  2, 23,  23, 'BR(bH -> Z Z)'
		write(13,204) BRbH(24,-24), 2, 24, -24, 'BR(bH -> W+ W-)'
		write(13,204) BRbH(25,25),  2, 25,  25, 'BR(bH -> h h)'
		write(13,204) BRbH(21,21),  2, 21,  21, 'BR(bH -> g g)'
		write(13,204) BRbH(22,22),  2, 22,  22, 'BR(bH -> gam gam)'
		write(13,204) BRbH(22,23),  2, 22,  23, 'BR(bH -> gam Z)'



		!###################################   Partial decay width   ########################################
		!===================================   SM OUTPUTS   ========================================
		open(22,file="outputs/outGamma_sm.txt")
		call header_outputs(22)  
		write(22,101) 'MODEL'
		write(22,102) 1,0,'SM'

		write(22,101) 'SMINPUTS'
		write(22,103) 1,alpha_em,'alpha_em' 
		write(22,103) 2,G_F,'Fermi constant' 
		write(22,103) 3,alpha_s,'alpha_s' 
		write(22,103) 4,mc_MS,'mc(mc) MSbar'
		write(22,103) 5,mb_MS,'mb(mb) MSbar'
		write(22,103) 6,mc,'mc On-shell'
		write(22,103) 7,mb,'mb On-shell'
		
		write(22,101) 'MASS'
		!write(22,103) 1,0.,'md'
		!write(22,103) 2,0.,'mu'
		!write(22,103) 3,0.,'ms'
		write(22,103) 4,rmc_mh,'mc(mh) MSbar'
		write(22,103) 5,rmb_mh,'mb(mh) MSbar'
		write(22,103) 6,mt,'mt'                
		write(22,103) 13,mmu,'mmu'
		write(22,103) 15,mtau,'mtau'
		write(22,103) 23,mz,'mz'
		write(22,103) 24,mw,'mw (calculated,tree)' 
		write(22,103) 24,rmw_SM(),'mw (calculated,1-loop)' 
		write(22,103) 25,mh,'mh'

		!======================================================================
		!  SM Higgs boson'
		!======================================================================
		write(22,99)
		write(22,98)'Partial decay widths of the SM Higgs boson by H-COUP #'
		write(22,201)
		write(22,202) 25,Gam_h_total_SM,C_EW,C_QCD
		write(22,213)
		write(22,204) hdecay_SM(4,-4),   2,  4,  -4, 'Gamma(h -> c c~)'
		write(22,204) hdecay_SM(5,-5),   2,  5,  -5, 'Gamma(h -> b b~)'
		write(22,204) hdecay_SM(13,-13), 2, 13, -13, 'Gamma(h -> mu- mu+)'
		write(22,204) hdecay_SM(15,-15), 2, 15, -15, 'Gamma(h -> tau- tau+)'
		write(22,204) hdecay_SM(21,21),  2, 21,  21, 'Gamma(h -> g g)'
		write(22,204) hdecay_SM(22,22),  2, 22,  22, 'Gamma(h -> gam gam)'
		write(22,204) hdecay_SM(22,23),  2, 22,  23, 'Gamma(h -> gam Z)'
		write(22,204) hdecay_SM(23,23),  2, 23,  23, 'Gamma(h -> Z Z*)'
		write(22,204) hdecay_SM(24,-24), 2, 24, -24, 'Gamma(h -> W+ W-*)'
 
		!===================================   HSM OUTPUTS   ========================================
		open(23,file="outputs/outGamma_hsm.txt") 
		call header_outputs(23)
		write(23,101) 'MODEL'
		write(23,102) 1,1,'HSM' 
		write(23,102) 2,SCHEME,'MSbar renormalization scheme'

		write(23,101) 'BSMINPUTS'
		write(23,103) 1,alpha,'alpha' 
		write(23,103) 2,lam_ps,'lambda_{phi S}' 
		write(23,103) 3,lam_s,'lambda_S' 
		write(23,103) 4,mu_s,'mu_S (GeV)'
		write(23,103) 5,mu_r,'mu_r (GeV)' 

		write(23,101) 'SMINPUTS'
		write(23,103) 1,alpha_em,'alpha_em' 
		write(23,103) 2,G_F,'Fermi constant' 
		write(23,103) 3,alpha_s,'alpha_s' 
		write(23,103) 4,mc_MS,'mc(mc) MSbar'
		write(23,103) 5,mb_MS,'mb(mb) MSbar'
		write(23,103) 6,mc,'mc On-shell'
		write(23,103) 7,mb,'mb On-shell'
		
		write(23,101) 'MASS'        
		!write(23,103) 1,0.,'md'
		!write(23,103) 2,0.,'mu'
		!write(23,103) 3,0.,'ms'
		write(23,103) 4,rmc_mh,'mc(mh) MSbar'
		write(23,103) 5,rmb_mh,'mb(mh) MSbar'
		write(23,103) 6,mt,'mt'                
		write(23,103) 13,mmu,'mmu'
		write(23,103) 15,mtau,'mtau'
		write(23,103) 23,mz,'mz'
		write(23,103) 24,mw,'mw (calculated,tree)' 
		write(23,103) 24,rmW(mbH,alpha,lam_ps,lam_s,mu_s),'mw (calculated,1-loop)' 
		write(23,103) 25,mh,'mh'
		write(23,103) 35,mbh,'mH' 

		write(23,101) 'CONSTRAINTS'
		write(23,103) 0,cutoff,'The cutoff scale (GeV)'
		write(23,102) 1,constraint(1),'Vacuum stability at tree level [0=OK, 1=No]'
		write(23,102) 2,constraint(2),'Tree-level unitarity [0=OK, 1=No]'
		write(23,102) 3,constraint(3),'S and T parameters [0=OK, 1=No]'
		write(23,102) 4,constraint(4),'True vacuum [0=OK, 1=No]'
		write(23,102) 5,constraint(5),'Vacuum stability (RGE improved with the cutoff scale) [0=OK, 1=No]'
		write(23,102) 6,constraint(6),'Triviality (with the cutoff scale) [0=OK, 1=No]'

		!======================================================================
		!  Lighter CP-even Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the SM-like Higgs boson by H-COUP #'
		write(23,201)
		write(23,202) 25,Gam_h_total,C_EW,C_QCD
		write(23,213)
		write(23,204) hdecay(4,-4),   2,  4,  -4, 'Gamma(h -> c c~)'
		write(23,204) hdecay(5,-5),   2,  5,  -5, 'Gamma(h -> b b~)'
		write(23,204) hdecay(13,-13), 2, 13, -13, 'Gamma(h -> mu- mu+)'
		write(23,204) hdecay(15,-15), 2, 15, -15, 'Gamma(h -> tau- tau+)'
		write(23,204) hdecay(21,21),  2, 21,  21, 'Gamma(h -> g g)'
		write(23,204) hdecay(22,22),  2, 22,  22, 'Gamma(h -> gam gam)'
		write(23,204) hdecay(22,23),  2, 22,  23, 'Gamma(h -> gam Z)'
		write(23,204) hdecay(23,23),  2, 23,  23, 'Gamma(h -> Z Z*)'
		write(23,204) hdecay(24,-24), 2, 24, -24, 'Gamma(h -> W+ W-*)'

		!======================================================================
		!  Heavier CP-even Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the additional CP-even Higgs boson bH by H-COUP #'
		write(23,201)
		write(23,202) 35,Gam_bH_total,C_EW,C_QCD
		write(23,213)
		write(23,204) bHdecay(6,-6),   2,  6, -6,  'Gamma(bH -> t t~)'
		write(23,204) bHdecay(5,-5),   2,  5, -5,  'Gamma(bH -> b b~)'
		write(23,204) bHdecay(4,-4),   2,  4, -4,  'Gamma(bH -> c c~)'
		write(23,204) bHdecay(13,-13), 2, 13, -13, 'Gamma(bH -> mu- mu+)'
		write(23,204) bHdecay(15,-15), 2, 15, -15, 'Gamma(bH -> tau- tau+)'
		write(23,204) bHdecay(23,23),  2, 23,  23, 'Gamma(bH -> Z Z)'
		write(23,204) bHdecay(24,-24), 2, 24, -24, 'Gamma(bH -> W+ W-)'
		write(23,204) bHdecay(25,25),  2, 25,  25, 'Gamma(bH -> h h)'
		write(23,204) bHdecay(21,21),  2, 21,  21, 'Gamma(bH -> g g)'
		write(23,204) bHdecay(22,22),  2, 22,  22, 'Gamma(bH -> gam gam)'
		write(23,204) bHdecay(22,23),  2, 22,  23, 'Gamma(bH -> gam Z)'

	endif

 	contains
!#################################################
!
!    SECTION I Parameter translations 
!
!#################################################
	double precision function mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	mu_phis = sin(2.d0*alpha)/(2.d0*vev)*(mbH**2-mh**2)

	end function
!---------------------------------------------
	double precision function lam(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	
	lam = 1.d0/(2.d0*vev**2)*( cos(alpha)**2* mh**2 + sin(alpha)**2* mbH**2) 
	
	end function
!---------------------------------------------
	double precision function mssq(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	mssq = 1.d0/2.d0*(sin(alpha)**2*mh**2 + cos(alpha)**2*mbH**2-vev**2*lam_ps)

	end function
!#################################################
!
!  SECTION II Tree-level couplings
!
!################################################# 
!=================  VVS type =====================
	complex (kind(0d0)) function g_WZGp(alpha)
	double precision, intent(in):: alpha

	g_WZGp = -g*gz/2.d0*sw**2*vev

	end function
!------------------------------------------
	complex (kind(0d0)) function g_ZZh(alpha)
	double precision, intent(in):: alpha

	g_ZZh = gz**2/4.d0*vev*cos(alpha)

	end function
!------------------------------------------
	complex (kind(0d0)) function g_ZZbH(alpha)
	double precision, intent(in):: alpha

	g_ZZbH = gz**2/4.d0*vev*sin(alpha)

	end function
!------------------------------------------
	complex (kind(0d0)) function g_WWh(alpha)
	double precision, intent(in):: alpha

	g_WWh = g**2/2.d0*vev*cos(alpha)

	end function
!------------------------------------------
	complex (kind(0d0)) function g_WWbH(alpha)
	double precision, intent(in):: alpha

	g_WWbH = g**2/2.d0*vev*sin(alpha)

	end function
!========== SSV type ================================
	complex (kind(0d0)) function g_GpGmZ(alpha)
	double precision, intent(in):: alpha

	g_GpGmZ = -gz/2.d0*(cw**2-sw**2)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function g_GhZ(alpha)
	double precision, intent(in):: alpha

	g_GhZ = ii*gz/2.d0*cos(alpha)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function g_GbHZ(alpha)
	double precision, intent(in):: alpha

	g_GbHZ = ii*gz/2.d0*sin(alpha)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function g_GphW(alpha)
	double precision, intent(in):: alpha

	g_GphW = -g/2.d0*cos(alpha)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function g_GpbHW(alpha)
	double precision, intent(in):: alpha

	g_GpbHW = -g/2.d0*sin(alpha)

	end function
!======= VVSS type ======================================
	double precision function g_ZZbHbH(alpha)
	double precision, intent(in):: alpha

	g_ZZbHbH = gz**2/8.d0*sin(alpha)**2

	end function
!--------------------------------------------------------
	double precision function g_ZZhh(alpha)
	double precision, intent(in):: alpha

	g_ZZhh = gz**2/8.d0*cos(alpha)**2

	end function
!--------------------------------------------------------
	double precision function g_ZZbHh(alpha)
	double precision, intent(in):: alpha

	g_ZZbHh = gz**2/4.d0*cos(alpha)*sin(alpha)

	end function
!--------------------------------------------------------
	double precision function g_ZZGG(alpha)
	double precision, intent(in):: alpha

	g_ZZGG = gz**2/8.d0

	end function
!--------------------------------------------------------
	double precision function g_ZZGpGm(alpha)
	double precision, intent(in):: alpha

	g_ZZGpGm = gz**2/4.d0*(cw**2-sw**2)**2

	end function
!--------------------------------------------------------
	double precision function g_WZGph(alpha)
	double precision, intent(in):: alpha

	g_WZGph = -1.d0/2.d0*g*gz*sw**2*cos(alpha)

	end function
!--------------------------------------------------------
	double precision function g_WZGpbH(alpha)
	double precision, intent(in):: alpha

	g_WZGpbH = -1.d0/2.d0*g*gz*sw**2*sin(alpha)

	end function
!======= VVVV type =================================================
	double precision function g_WWZZ(alpha)
	double precision, intent(in):: alpha

	g_WWZZ = -g**2*cw**2/2.d0

	end function
!======= SSS type =================================================
	double precision function lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	lam_hhh =&
		-mh**2*cos(alpha)**3/(2.d0*vev)&
		-vev*cos(alpha)*sin(alpha)**2*lam_ps&
		+sin(alpha)**3*mu_s

	end function
!--------------------------------------------------------
	double precision function lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_bHbHh =&
		-lam_ps /4.d0*vev*(cos(alpha)+3.d0*cos(3.d0*alpha))&
		+3.d0*mu_s*cos(alpha)**2*sin(alpha)&
		-mh**2/2.d0/vev*cos(alpha)*sin(alpha)**2&
		-mbH**2/vev*cos(alpha)*sin(alpha)**2 

	end function
!--------------------------------------------------------
	double precision function lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_bHhh =&
		-mh**2/vev*cos(alpha)**2*sin(alpha)&
		-mbH**2/2.d0 /vev*cos(alpha)**2*sin(alpha)&
		+vev/2.d0 *lam_ps*(1.d0+3.d0*cos(2.d0*alpha))*sin(alpha)&
		-3.d0*mu_s*cos(alpha)*sin(alpha)**2

	end function
!--------------------------------------------------------
	double precision function lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_bHbHbH =&
		-mu_s*cos(alpha)**3&
		-vev*lam_ps*cos(alpha)**2*sin(alpha)&
		-(mbH**2*sin(alpha)**3)/(2.d0*vev)

	end function
!--------------------------------------------------------
	double precision function lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GGh = -mh**2*cos(alpha)/2.d0/vev  

	end function
!--------------------------------------------------------
	double precision function lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GpGmh = -mh**2*cos(alpha)/vev  

	end function
!--------------------------------------------------------
	double precision function lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GGbH = -mbH**2*sin(alpha) /2.d0/vev  
 
	end function
!--------------------------------------------------------
	double precision function lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GpGmbH = -mbH**2*sin(alpha)/vev

	end function
!====== SSSS type ==================================================
	double precision function lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_hhhh =&
		-mh**2/8.d0/vev**2*cos(alpha)**6&
		-mbH**2/8.d0/vev**2*cos(alpha)**4*sin(alpha)**2&
		-lam_s*sin(alpha)**4&
		-lam_ps/8.d0*sin(2.d0*alpha)**2 

	end function
!--------------------------------------------------------
	double precision function lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_bHhhh =&
		- mh**2/2.d0/vev**2*cos(alpha)**5*sin(alpha)&
		+4.d0*lam_s*cos(alpha)*sin(alpha)**3&
		-mbH**2*sin(2.d0*alpha)**3/16.d0/vev**2&
		+lam_ps/4.d0*sin(4.d0*alpha) 

	end function
!--------------------------------------------------------
	double precision function lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_bHbHhh =&
		-lam_ps/8.d0 *(1.d0+3.d0*cos(4.d0*alpha))&
		-3.d0* mh**2*cos(alpha)**4*sin(alpha)**2/4.d0/vev**2&
		-3.d0* mbH**2*cos(alpha)**2*sin(alpha)**4/4.d0/vev**2&
		-6.d0*cos(alpha)**2*sin(alpha)**2*lam_s

	end function
!--------------------------------------------------------
	double precision function lam_bHbHbHh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_bHbHbHh =&
		4.d0*lam_s*cos(alpha)**3*sin(alpha)&
		-mbH**2*cos(alpha)*sin(alpha)**5/2.d0/vev**2&
		-mh**2*sin(2.d0*alpha)**3/16.d0/vev**2&
		-lam_ps/4.d0*sin(4.d0*alpha) 

	end function
!--------------------------------------------------------
	double precision function lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GGhh =&
		-mh**2*cos(alpha)**4/4.d0/vev**2&
		-lam_ps/2.d0*sin(alpha)**2&
		-mbH**2*sin(2.d0*alpha)**2/16.d0/vev**2 

	end function
!--------------------------------------------------------
	double precision function lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GpGmhh =&
		-mh**2*cos(alpha)**4/2.d0/vev**2&
		-lam_ps*sin(alpha)**2&
		-mbH**2*sin(2.d0*alpha)**2/8.d0/vev**2 

	end function
!--------------------------------------------------------
	double precision function lam_GGbHh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GGbHh =&
		lam_ps*cos(alpha)*sin(alpha)&
		-mh**2*cos(alpha)**3*sin(alpha)/2.d0/vev**2&
		-mbH**2*cos(alpha)*sin(alpha)**3/2.d0/vev**2 

	end function
!--------------------------------------------------------
	double precision function lam_GGbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GGbHbH =&
		-lam_ps/2.d0*cos(alpha)**2&
		-mbH**2* sin(alpha)**4/4.d0/vev**2&
		-mh**2*sin(2.d0*alpha)**2/16.d0/vev**2 

	end function
!--------------------------------------------------------
	double precision function lam_GpGmbHh(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GpGmbHh =&
		2.d0*lam_ps*cos(alpha)*sin(alpha)&
		-mh**2*cos(alpha)**3*sin(alpha)/vev**2&
		-mbH**2*cos(alpha)*sin(alpha)**3/vev**2 

	end function
!--------------------------------------------------------
	double precision function lam_GpGmbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GpGmbHbH =&
		-lam_ps*cos(alpha)**2&
		-mbH**2*sin(alpha)**4/2.d0/vev**2&
		-mh**2*sin(2.d0*alpha)**2/8.d0/vev**2 

	end function
!--------------------------------------------------------
	double precision function lam_GpGmGpGm(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_GpGmGpGm =&
		-mh**2*cos(alpha)**2/2.d0/vev**2&
		-mbH**2*sin(alpha)**2/2.d0/vev**2 

	end function
!--------------------------------------------------------
	double precision function lam_bHbHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision mbH,alpha,lam_ps,lam_s,mu_s

	lam_bHbHbHbH =&
		-sin(alpha)**4/(8.d0*vev**2)*(cos(alpha)**2*mh**2+sin(alpha)**2*mbH**2)&
		-cos(alpha)**4*lam_s-sin(2.d0*alpha)**2/8.d0*lam_ps

	end function
!#################################################
!
!  SECTION III: Constraints on parameter space
!
!#################################################
!============== perturbative unitarity ========================
	double precision function x1p(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	x1p =&
		1.d0/16.d0/pi*(&
			3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)+6.d0*lam_s&
			+sqrt((3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)-6.d0*lam_s)**2+4.d0*lam_ps**2)&
		)

	end function
!---------------------------------------------
	double precision function x1m(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	x1m =&
		1.d0/16.d0/pi*(&
			3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)+6.d0*lam_s&
			- sqrt((3.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)-6.d0*lam_s)**2+4.d0*lam_ps**2)&
		)

	end function
!---------------------------------------------
	double precision function y1(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	y1 = 1.d0/8.d0/pi*lam(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!---------------------------------------------
	double precision function y2(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
	y2 = 1.d0/8.d0/pi*lam_ps

	end function
!---------------------------------------------
	double precision function pu(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
	if (x1p(mbH,alpha,lam_ps,lam_s,mu_s) >= 1.d0/2.d0) then 
      pu = 1.d0
	elseif (x1m(mbH,alpha,lam_ps,lam_s,mu_s) >= 1.d0/2.d0) then 
      pu = 2.d0
	elseif (y1(mbH,alpha,lam_ps,lam_s,mu_s) >= 1.d0/2.d0) then 
		pu = 3.d0
	elseif (y2(mbH,alpha,lam_ps,lam_s,mu_s) >= 1.d0/2.d0) then 
      pu = 4.d0
	else
      pu = 0.d0
	endif

	end function
!============== vacuum stability ========================
	double precision function vs(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	if (lam(mbH,alpha,lam_ps,lam_s,mu_s) <= 0.d0) then 
		vs = 1.d0
	else if (lam_s <= 0.d0) then 
		vs = 2.d0
	else if (lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s <= lam_ps**2/4.d0 .and. lam_ps <= 0.d0) then 
		vs = 3.d0
	else
		vs = 0.d0
	endif

	end function
!================= wrong vacuum conditions =======================================
	complex (kind(0d0)) function vpot(mbH,alpha,lam_ps,lam_s,mu_s,phi0sq,s0)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,s0
	complex (kind(0d0)), intent(in):: phi0sq

	vpot  = &
		lam(mbH,alpha,lam_ps,lam_s,mu_s)*(phi0sq/2.d0-vev**2/2.d0)**2& 
		+mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*(phi0sq/2.d0-vev**2/2.d0)*s0&
		+lam_ps*(phi0sq/2.d0-vev**2/2.d0)*s0**2&
		+(mssq(mbH,alpha,lam_ps,lam_s,mu_s)+1.d0/2.d0*vev**2*lam_ps)*s0**2&
		+mu_s*s0**3&
		+lam_s*s0**4

	end function
!---------------------------------------------
	complex (kind(0d0)) function kappa(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision:: Delta0
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	Delta0 =&
		-64.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)**2*(&
			9.d0*mu_s**2-32.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		-48.d0*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*mu_s*vev**2*(&
			18.d0*mu_s**2 -72.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		+27.d0*64.d0*lam_s**2*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)**2*vev**4 

	if (Delta0 >= 0.d0) then
		kappa =&
			-12.d0*mu_s*(18.d0*mu_s**2-72.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s))&
			+27.d0*32.d0*lam_s**2*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*vev**2&
			+12.d0*lam_s*sqrt(3.d0*Delta0)
	else 
		kappa =&
			-12.d0*mu_s*(18.d0*mu_s**2-72.d0*lam_s*mssq(mbH,alpha,lam_ps,lam_s,mu_s))&
			+27.d0*32.d0*lam_s**2*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*vev**2&
			+12.d0*lam_s*sqrt(3.d0*abs(Delta0))*ii
	endif 

	end function
!---------------------------------------------
	double precision function del_vac(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
           
	del_vac =&
		vev**2/64.d0*(&
			3.d0*8.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s)&
      	-3.d0*4.d0*mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps&
		)**2&
		-2.d0*mh**2*mbH**2*(4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s-lam_ps**2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function vpsq(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	vpsq =&
		vev**2-1.d0/lam(mbH,alpha,lam_ps,lam_s,mu_s)*(&
			mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*xp(mbH,alpha,lam_ps,lam_s,mu_s)&
			+lam_ps*xp(mbH,alpha,lam_ps,lam_s,mu_s)**2 &
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function vmsq(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
            
	vmsq =&
		vev**2-1.d0/lam(mbH,alpha,lam_ps,lam_s,mu_s)*(&
			mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*xm(mbH,alpha,lam_ps,lam_s,mu_s)&
      	+lam_ps*xm(mbH,alpha,lam_ps,lam_s,mu_s)**2 &
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function xp(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	if (del_vac(mbH,alpha,lam_ps,lam_s,mu_s) >= 0.d0) then
      xp =&
			(&
				3.d0*vev*(mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps-2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s))&
            +2.d0*sqrt(del_vac(mbH,alpha,lam_ps,lam_s,mu_s))&
			)/(4.d0*vev*(4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s-lam_ps**2))
	else
      xp =&
			(&
				3.d0*vev*( mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps-2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s))&
            +2.d0*ii*sqrt(abs(del_vac(mbH,alpha,lam_ps,lam_s,mu_s)))&
			)/(4.d0*vev*(4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s-lam_ps**2))
	endif

	end function
!---------------------------------------------
	complex (kind(0d0)) function xm(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	if (del_vac(mbH,alpha,lam_ps,lam_s,mu_s) >= 0.d0) then
      xm =&
			(&
				3.d0*vev*(mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps-2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s))&
            -2.d0*sqrt(del_vac(mbH,alpha,lam_ps,lam_s,mu_s))&
			)/(4.d0*vev*(4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s-lam_ps**2))
	else
      xm =&
			(&
				3.d0*vev*(mu_phis(mbH,alpha,lam_ps,lam_s,mu_s)*lam_ps-2.d0*mu_s*lam(mbH,alpha,lam_ps,lam_s,mu_s))&
            -2.d0*ii*sqrt(abs(del_vac(mbH,alpha,lam_ps,lam_s,mu_s)))&
			)/(4.d0*vev*(4.d0*lam(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s-lam_ps**2))  
	endif
      
	end function
!---------------------------------------------
	complex (kind(0d0)) function x01(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
      
	x01 =&
		(&
			(6.d0*mu_s-kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0))**2 &
			-96.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s&
		)/(24.d0*lam_s*kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0))&
		+ mu_s/4.d0/lam_s

	end function
!---------------------------------------------
	complex (kind(0d0)) function x02(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	x02 =&
		(&
			(6.d0*mu_s-kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(2.d0*pi*ii/3.d0))**2 &
			-96.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s&
		)/(24.d0*lam_s*kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(2.d0*pi*ii/3.d0))&
		+mu_s/4.d0/lam_s

	end function
!---------------------------------------------
	complex (kind(0d0)) function x03(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	x03 =&
		(&
			(6.d0*mu_s-kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(4.d0*pi*ii/3.d0))**2&
			-96.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)*lam_s&
		)/(24.d0*lam_s*kappa(mbH,alpha,lam_ps,lam_s,mu_s)**(1.d0/3.d0)*exp(4.d0*pi*ii/3.d0))&
		+mu_s/4.d0/lam_s

	end function
!---------------------------------------------
	double precision function wrong(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	complex (kind(0d0)):: vvpsq,vvmsq,vv0
	double precision:: vxp,vxm,vx01,vx02,vx03
	double precision:: pot_p,pot_m,pot_1,pot_2,pot_3

	vv0   =  (0.d0,0.d0)
	vvpsq =  vpsq(mbH,alpha,lam_ps,lam_s,mu_s)
	vvmsq =  vmsq(mbH,alpha,lam_ps,lam_s,mu_s)
	vxp   =  xp(mbH,alpha,lam_ps,lam_s,mu_s)
	vxm   =  xm(mbH,alpha,lam_ps,lam_s,mu_s)
	vx01  =  x01(mbH,alpha,lam_ps,lam_s,mu_s)
	vx02  =  x02(mbH,alpha,lam_ps,lam_s,mu_s)
	vx03  =  x03(mbH,alpha,lam_ps,lam_s,mu_s)
      
	pot_p = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vvpsq,vxp)
	pot_m = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vvmsq,vxm)
	pot_1 = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vv0,vx01)
	pot_2 = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vv0,vx02)
	pot_3 = vpot(mbH,alpha,lam_ps,lam_s,mu_s,vv0,vx03)

	wrong = 0.d0

	if (del_vac(mbH,alpha,lam_ps,lam_s,mu_s) > 0.d0) then 
      if (pot_p < 0.d0) then
	      wrong =1.d0
      else if (pot_m < 0.d0) then 
 	     wrong =2.d0 
      endif
	endif 

	if (pot_1 < 0.d0) then 
      wrong = 3.d0
	else if (pot_2 < 0.d0) then 
      wrong = 4.d0
	else if (pot_3 < 0.d0) then 
      wrong =5.d0
	endif 

	end function
!======= triviality =================================================
	double precision function triviality(cutoff,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: cutoff,mbH,alpha,lam_ps,lam_s,mu_s
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,vlam,vlamps,vlams,vyt

	vlam   = lam(mbH,alpha,lam_ps,lam_s,mu_s)
	vlamps = lam_ps
	vlams  = lam_s
	vyt    = yt*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))

	no=1000
	t0= Log(mh); tfin=Log(1.d10); h=(tfin-t0)/dble(no)

	do i = 0, no
	   t = t0+h*dble(i)
		call RGE(t0,h,t,vlam,vlamPS,vlamS,vyt)
		max_coup = max(abs(vlam),abs(vlamPS),abs(vlamS),abs(vyt))

		if (exp(t) < cutoff .and. max_coup > 4.d0*pi) then
			triviality = 1.d0
			exit
		else if (exp(t) > cutoff .and. max_coup <= 4.d0*pi) then
			triviality = 0.d0
			exit
		endif
	enddo

	end function
!---------------------------------------------
	double precision function triviality_MSM(cutoff,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: cutoff,mbH,alpha,lam_ps,lam_s,mu_s
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,vlam,vlamps,vlams,vyt,cr,Msq

	Msq=2.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)
	cr=4.d0*pi

	!--------------------- SM RGE --------------------
	vlam = lam(mbH,alpha,lam_ps,lam_s,mu_s)
	vyt  = yt*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))

	triviality_MSM = 0.d0
	no=1000
	t0 = Log(mh); tfin = Log(dsqrt(Msq)); h = (tfin-t0)/dble(no)

	do i = 0,no
		t = t0+h*dble(i)
		call RGE_sm(t0,h,t,vlam,vyt)
		max_coup = max(vlam,vyt)
		if (max_coup > cr) then
			triviality_MSM = 2.d0
			go to 30
		end if
	end do

	t0= 0.d0; tfin= 0.d0; h=0.d0; t=0.d0
	!---------------- HSM RGE ---------------------------
	vlamps = lam_ps
	vlams  = lam_s

	no = 1000
	t0 = Log(dsqrt(Msq)); tfin = Log(1.d10); h = (tfin-t0)/dble(no)

	do i = 0,no
	   t = t0+h*dble(i)
		call RGE(t0,h,t,vlam,vlamPS,vlamS,vyt)
		max_coup = max(abs(vlam),abs(vlamPS),abs(vlamS),abs(vyt))
		if (exp(t) < cutoff .and. max_coup > cr) then 
			triviality_MSM = 1.d0
			exit
		else if (exp(t) > cutoff .and. max_coup <= cr) then 
			triviality_MSM = 0.d0
			exit
		endif           
	enddo

30 continue

	end function
!====== RGE improved vacuum stability ==================================
	double precision function vs_rge(cutoff,mbH,alpha,lam_ps,lam_s,mu_s)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,vlam,vlamps,vlams,vyt
	double precision, intent(in):: cutoff,lam_ps,lam_s,mbH,alpha,mu_s

	vlam   = lam(mbH,alpha,lam_ps,lam_s,mu_s)
	vlamps = lam_ps
	vlams  = lam_s
	vyt    = yt*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))

	no=1000
	t0 = Log(mh); tfin = Log(cutoff); h = (tfin-t0)/dble(no)
	vs_rge = 0.d0

	do i = 0,no
	   t = t0+h*dble(i)
		call RGE(t0,h,t,vlam,vlamps,vlamS,vyt)
		if (vlam <= 0.d0) then 
			vs_rge = 1.d0
		else if (vlams <= 0.d0) then 
			vs_rge = 2.d0
		else if (vlam*vlams <= vlamps**2/4.d0 .and. vlamps <= 0.d0) then 
			vs_rge = 3.d0
		endif
	enddo

	end function
!---------------------------------------------
	double precision function vs_rge_MSM(cutoff,mbH,alpha,lam_ps,lam_s,mu_s)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,vlam,vlamps,vlams,vyt,Msq
	double precision, intent(in):: cutoff,lam_ps,lam_s,mbH,alpha,mu_s
	Msq=2.d0*mssq(mbH,alpha,lam_ps,lam_s,mu_s)

	!--------------------- SM RGE --------------------
	vlam = lam(mbH,alpha,lam_ps,lam_s,mu_s)
	vyt  = yt*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))
	vs_rge_MSM = 0.d0
	no = 1000
	t0 = Log(mh); tfin = Log(dsqrt(Msq)); h = (tfin-t0)/dble(no)

	do i = 0, no
		t = t0+h*dble(i)
		call RGE_sm(t0,h,t,vlam,vyt)
		if (vlam <= 0.d0) then
			vs_rge_MSM = 4.d0
		end if
	end do

	t0=0.d0;tfin=0.d0;h=0.d0;t=0.d0
	!--------------------- HSM RGE --------------------
	vlamps = lam_ps
	vlams  = lam_s

	no=1000
	t0= Log(dsqrt(Msq)); tfin= Log(cutoff); h=(tfin-t0)/dble(no)

	do i = 0, no
	   t=t0+h*dble(i)
		call RGE(t0,h,t,vlam,vlamps,vlamS,vyt)
		if (vlam <= 0.d0) then
			vs_rge_MSM = 1.d0
		else if (vlams <= 0.d0) then 
			vs_rge_MSM = 2.d0
		else if (vlam*vlams <= vlamps**2/4.d0 .and. vlamps <= 0.d0) then 
			vs_rge_MSM = 3.d0
		endif
	enddo

	end function
!====== ST parameters ====================================
	complex (kind(0d0)) function F_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	F_stu = -B5f(qsq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function G_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	G_stu = -4.d0*m2**2*B0f(qsq,m1,m2) - B5f(qsq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function Fp_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	Fp_stu = (F_stu(qsq,m1,m2)-F_stu(0.d0,m1,m2))/qsq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function Gp_stu(qsq,m1,m2)
	double precision, intent(in):: qsq,m1,m2

	Gp_stu = (G_stu(qsq,m1,m2)-G_stu(0.d0,m1,m2))/qsq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function Del_S_HSM(mbh,alpha)
	double precision, intent(in):: mbh,alpha

	Del_S_HSM =&
		sin(alpha)**2/(4.d0*pi)*(&
         Gp_stu(mz**2,mbh,mz)-Gp_stu(mz**2,mh,mz)&
		)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function Del_T_HSM(mbh,alpha)
	double precision, intent(in):: mbh,alpha

	Del_T_HSM =&
		sin(alpha)**2/(16.d0*pi**2*alpha_em*vev**2)*(& 
			-G_stu(0.d0,mh,mw)+G_stu(0.d0,mbh,mw)+G_stu(0.d0,mh,mz)-G_stu(0.d0,mbh,mz)&
		)

	end function
 !--------------------------------------------------------
 	double precision function stu(mbh,alpha)
	double precision:: V_inv(2,2),del_chisq,dels,delt
 	double precision, intent(in):: mbh,alpha 

	dels = Del_S_HSM(mbh,alpha)
	delt = Del_T_HSM(mbh,alpha)
	V_inv(1,1) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_t**2
	V_inv(2,2) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s**2
	V_inv(1,2) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
	V_inv(2,1) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
  
	del_chisq = (dels-s_cent)**2*V_inv(1,1)+(delt-t_cent)**2*V_inv(2,2)+2.d0*(dels-s_cent)*(delt-t_cent)*V_inv(1,2)
	if (del_chisq <= 5.99d0) then 
		stu = 0.d0
	else if (del_chisq > 5.99d0) then 
		stu = 1.d0
	endif

	end function
!#################################################
!
!    SECTION IV 1PI diagrams
!
!#################################################
!====== Loop Functions ==================================================
	complex (kind(0d0)) function Chhh_VSS_full(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_VSS_full =&
		+p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
		+(4.d0*p1sq+2.d0*p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(4.d0*p12+2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*(p1sq+p12)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		!
		+p1sq*c21f(p1sq,p2sq,qsq,m3,m1,m2)&
		+p2sq*c22f(p1sq,p2sq,qsq,m3,m1,m2)&
		+2.d0*p12*c23f(p1sq,p2sq,qsq,m3,m1,m2)&
		+4.d0*c24f(p1sq,p2sq,qsq,m3,m1,m2)-1.d0/2.d0&
		+(2.d0*p12)*c11f(p1sq,p2sq,qsq,m3,m1,m2)&
		+(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m3,m1,m2)&
		-(p1sq+2.d0*p12)*c0f(p1sq,p2sq,qsq,m3,m1,m2)&
		!
		+p1sq*c21f(p1sq,p2sq,qsq,m2,m3,m1)&
		+p2sq*c22f(p1sq,p2sq,qsq,m2,m3,m1)&
		+2.d0*p12*c23f(p1sq,p2sq,qsq,m2,m3,m1)&
		+4.d0*c24f(p1sq,p2sq,qsq,m2,m3,m1)-1.d0/2.d0&
		-(2.d0*p12)*c11f(p1sq,p2sq,qsq,m2,m3,m1)&
		-(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m2,m3,m1)&
		-(p1sq-p2sq)*c0f(p1sq,p2sq,qsq,m2,m3,m1)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Chhh_SSV(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_SSV= &
		+p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
		-(2.d0*p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		-(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		-(p1sq-p2sq)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Chhh_SVS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Chhh_SVS= &
		+p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*p12*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-1.d0/2.d0&
		+(2.d0*p12)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		-(p1sq+2.d0*p12)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!===============================================
	complex (kind(0d0)) function ChVV1_VSV(p1sq,p2sq,qsq,m1,m2,m3,g_V1V3h,g_V1VaS2,g_V3VbS2)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	complex (kind(0d0)), intent(in):: g_V1V3h,g_V1VaS2,g_V3VbS2

	ChVV1_VSV = -g_V1V3h*g_V1VaS2*g_V3VbS2*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_VSS(p1sq,p2sq,qsq,m1,m2,m3,g_V1VaS2,g_S2S3Vb,g_S3hV1)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	complex (kind(0d0)), intent(in):: g_V1VaS2,g_S2S3Vb,g_S3hV1

	ChVV1_VSS = 2.d0*g_V1VaS2*g_S2S3Vb*g_S3hV1*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SSV(p1sq,p2sq,qsq,m1,m2,m3,g_V3VbS2,g_S1S2Va,g_S1hV3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3
	complex (kind(0d0)), intent(in):: g_V3VbS2,g_S1S2Va,g_S1hV3

	ChVV1_SSV = -2.d0*g_V3VbS2*g_S1S2Va*g_S1hV3*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SVS(p1sq,p2sq,qsq,m1,m2,m3,lam,g_V2VaS1,g_V2VbS3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3,lam
	complex (kind(0d0)), intent(in):: g_V2VaS1,g_V2VbS3

	ChVV1_SVS = lam*g_V2VaS1*g_V2VbS3*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SSS(p1sq,p2sq,qsq,m1,m2,m3,lam,g_S1S2Va,g_S2S3Vb)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3,lam
	complex (kind(0d0)), intent(in):: g_S1S2Va,g_S2S3Vb

	ChVV1_SSS = -4.d0*lam*g_S1S2Va*g_S2S3Vb*c24f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_SS(qsq,m1,m2,lam,g_vvss)
	double precision, intent(in):: qsq,m1,m2,lam,g_vvss

	ChVV1_SS = lam*g_vvss*b0f(qsq,m1,m2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_VS(qsq,m1,m2,g_vvss,g_vvs)
	double precision, intent(in):: qsq,m1,m2,g_vvss
	complex (kind(0d0)), intent(in):: g_vvs

	ChVV1_VS = -g_vvss*g_vvs*b0f(qsq,m1,m2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function ChVV1_VV(qsq,m1,m2,g_vvvv,g_vvs)
	double precision, intent(in):: qsq,m1,m2,g_vvvv
	complex (kind(0d0)), intent(in):: g_vvs

	ChVV1_VV = g_vvvv*g_vvs*(6.d0*b0f(qsq,m1,m2)-4.d0)

	end function
!========================================================
	complex (kind(0d0)) function PiWW_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	PiWW_S =&
		g**2/(16.d0*pi**2)*(&
			+cos(alpha)**2*(mw**2*b0f(qsq,mh,mW)+1.d0/4.d0*b5f(qsq,mh,mw))&
			+sin(alpha)**2*(mw**2*b0f(qsq,mbh,mW)+1.d0/4.d0*b5f(qsq,mbh,mw))&
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	PiZZ_S=&
		g**2/cw**2/(16.d0*pi**2)*(&
			+cos(alpha)**2*(mZ**2*b0f(qsq,mh,mZ)+1.d0/4.d0*b5f(qsq,mh,mZ))&
			+sin(alpha)**2*(mZ**2*b0f(qsq,mbh,mZ)+1.d0/4.d0*b5f(qsq,mbh,mZ))&
		)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiWW_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiWW_B = PiWW_B_WOH(qsq)+PiWW_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiGG_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiGG_B = PiGG_B_WOH(qsq)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZG_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiZG_B = PiZG_B_WOH(qsq)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	PiZZ_B = PiZZ_B_WOH(qsq)+PiZZ_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiGG_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s
	
	dPiGG_B = dPiGG_B_WOH(qsq)

 	end function
!--------------------------------------------- added from v2
	complex (kind(0d0)) function dPiZZ_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPiZZ_S =&
		g**2/cw**2/(16.d0*pi**2)*(&
			+cos(alpha)**2*(mZ**2*db0f(qsq,mh,mZ)+1.d0/4.d0*db5f(qsq,mh,mZ))&
			+sin(alpha)**2*(mZ**2*db0f(qsq,mbh,mZ)+1.d0/4.d0*db5f(qsq,mbh,mZ))&
		)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiWW_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPiWW_S=&
		g**2/(16.d0*pi**2)*(&
			+cos(alpha)**2*(mw**2*db0f(qsq,mh,mW)+1.d0/4.d0*db5f(qsq,mh,mw))&
			+sin(alpha)**2*(mw**2*db0f(qsq,mbh,mW)+1.d0/4.d0*db5f(qsq,mbh,mw))&	
		)

	end function
!--------------------------------------------- added from v2
	complex (kind(0d0)) function dPiZZ_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPiZZ_B = dPiZZ_B_WOH(qsq)+dPiZZ_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiWW_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPiWW_B = dPiWW_B_WOH(qsq)+dPiWW_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!-------- Scalar boson 1, 2 and 3 point functions -----------
	complex (kind(0d0)) function Pih_F(mbH,alpha)
	double precision, intent(in):: mbH,alpha

	Pih_F =&
		-4.d0*mt**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mt)*&
		cos(alpha)&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mb)*&
		cos(alpha)&
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mc)*&
		cos(alpha)&        
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(ms)*&
		cos(alpha)&        
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mtau)*&
		cos(alpha)&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mmu)*&
		cos(alpha)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pih_F_div(mbH,alpha)
	double precision, intent(in):: mbH,alpha

	Pih_F_div =&
		-4.d0*mt**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mt)*&
		cos(alpha)&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mb)*&
		cos(alpha)&
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mc)*&
		cos(alpha)&        
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(ms)*&
		cos(alpha)&        
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mtau)*&
		cos(alpha)&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mmu)*&
		cos(alpha)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pih_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s      

	Pih_B =&
		1.d0/(16.d0*pi**2)*(&
			-3.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mh)&
			-lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mbH)&
			-lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mw)&
			-lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mz)&
			-2.d0*mw**2/vev*cos(alpha)*a0f(mw)&
			-mz**2/vev*cos(alpha)*a0f(mz)&
			+2.d0*mw**2/vev*cos(alpha)*(4.d0*a0f(mw)-2.d0*mw**2)&
			+mz**2/vev*cos(alpha)*(4.d0*a0f(mz)-2.d0*mz**2)&
		) 

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pih_B_div(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s      

	Pih_B_div =&
		1.d0/(16.d0*pi**2)*(&
			-3.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mh)&
			-lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mbH)&
			-lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mw)&
			-lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mz)&
			-2.d0*mw**2/vev*cos(alpha)*a0f_div(mw)&
			-mz**2/vev*cos(alpha)*a0f_div(mz)&
			+2.d0*mw**2/vev*cos(alpha)*4.d0*a0f_div(mw)&
			+mz**2/vev*cos(alpha)*4.d0*a0f_div(mz)&
		) 

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibH_F(mbH,alpha)
	double precision, intent(in):: mbH,alpha

	PibH_F =&
		-4.d0*mt**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mt)*&
		sin(alpha)&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mb)*&
		sin(alpha)&
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mc)*&
		sin(alpha)&        
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(ms)*&
		sin(alpha)&
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mtau)*&
		sin(alpha)&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f(mmu)*&
		sin(alpha)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibH_F_div(mbH,alpha)
	double precision, intent(in):: mbH,alpha

	PibH_F_div =&
		-4.d0*mt**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mt)*&
		sin(alpha)&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mb)*&
		sin(alpha)&
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mc)*&
		sin(alpha)&        
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(ms)*&
		sin(alpha)&
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mtau)*&
		sin(alpha)&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2)*&
		1.d0/vev*a0f_div(mmu)*&
		sin(alpha)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PibH_B(mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s      

	PibH_B =&
		1.d0/(16.d0*pi**2)*(&
			-lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mh)&
			-3.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mbH)&
			-lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mw)&
			-lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mz)&
			-2.d0*mw**2/vev*sin(alpha)*a0f(mw)&
			-mz**2/vev*sin(alpha)*a0f(mz)&
			+2.d0*mw**2/vev*sin(alpha)*(4.d0*a0f(mw)-2.d0*mw**2)&
			+mz**2/vev*sin(alpha)*(4.d0*a0f(mz)-2.d0*mz**2)&
		) 

   end function
!---------------------------------------------
	complex (kind(0d0)) function PibH_B_div(mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s      

	PibH_B_div =&
		1.d0/(16.d0*pi**2)*(&
			-lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mh)&
			-3.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mbH)&
			-lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mw)&
			-lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f_div(mz)&
			-2.d0*mw**2/vev*sin(alpha)*a0f_div(mw)&
			-mz**2/vev*sin(alpha)*a0f_div(mz)&
			+2.d0*mw**2/vev*sin(alpha)*4.d0*a0f_div(mw)&
			+mz**2/vev*sin(alpha)*4.d0*a0f_div(mz)&
		)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function Pihh_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,mbH,alpha

	Pihh_F=&
		-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mt)&
			+(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mb)&
			+(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mc)&
			+(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(ms)&
			+(2.d0*ms**2-qsq/2.d0)*b0f(qsq,ms,ms)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mtau)&
			+(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mmu)&
			+(2.d0*mmu**2-qsq/2.d0)*b0f(qsq,mmu,mmu)&
		)*&
		cos(alpha)**2

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function Pihh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
      
	Pihh_B =&
		1.d0/(16.d0*pi**2)*(&
			-2.d0*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mbH)&
			-12.d0*lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mh)&
			-2.d0*lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mw)&
			-2.d0*lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mz)&
			+2.d0*mw**2/vev**2*cos(alpha)**2*(4.d0*a0f(mw)-2.d0*mw**2)&
			+1.d0*mz**2/vev**2*cos(alpha)**2*(4.d0*a0f(mz)-2.d0*mz**2)&
			+1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**2 *b0f(qsq,mw,mw)&
			+2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2 *b0f(qsq,mbH,mbH)&
			+18.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mh,mh)&
			+4.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mh,mbH)&
			+2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mz,mz)&
			+4.d0*mw**4/vev**2*cos(alpha)**2 *(4.d0*b0f(qsq,mw,mw)-2.d0)&
			+2.d0*mz**4/vev**2*cos(alpha)**2 *(4.d0*b0f(qsq,mz,mz)-2.d0)&
			-2.d0*mw**2/vev**2*cos(alpha)**2 *(a0f(mw)+(2.d0*qsq+mw**2)*b0f(qsq,mw,mw))&
			-1.d0*mz**2/vev**2*cos(alpha)**2 *(a0f(mz)+(2.d0*qsq+mz**2)*b0f(qsq,mz,mz))&
			-2.d0*mw**4/vev**2*cos(alpha)**2 *b0f(qsq,mw,mw)&
			-1.d0*mz**4/vev**2*cos(alpha)**2 *b0f(qsq,mz,mz)&
		)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function dPihh_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,alpha,mbH

	dPihh_F=&
		-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
			+(-1.d0/2.d0)*b0f(qsq,mt,mt)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
			+(-1.d0/2.d0)*b0f(qsq,mb,mb)&
		)*&
		cos(alpha)**2&	
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
			+(-1.d0/2.d0)*b0f(qsq,mc,mc)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*ms**2-qsq/2.d0)*db0f(qsq,ms,ms)&
			+(-1.d0/2.d0)*b0f(qsq,ms,ms)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
			+(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
		)*&
		cos(alpha)**2&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mmu**2-qsq/2.d0)*db0f(qsq,mmu,mmu)&
			+(-1.d0/2.d0)*b0f(qsq,mmu,mmu)&
		)*&
		cos(alpha)**2

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function dPihh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
	
	dPihh_B =&
		1.d0/(16.d0*pi**2)*(&
			+1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mw,mw)&
			+2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mbH,mbH)&
			+18.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mh,mh)&
			+4.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mh,mbH)&
			+2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mz,mz)&
			+4.d0*mw**4/vev**2*cos(alpha)**2*4.d0*db0f(qsq,mw,mw)&
			+2.d0*mz**4/vev**2*cos(alpha)**2*4.d0*db0f(qsq,mz,mz)&
			-2.d0*mw**2/vev**2*cos(alpha)**2*(2.d0*qsq+mw**2)*db0f(qsq,mw,mw)&
			-2.d0*mw**2/vev**2*cos(alpha)**2*2.d0*b0f(qsq,mw,mw)&
			-1.d0*mz**2/vev**2*cos(alpha)**2*(2.d0*qsq+mz**2)*db0f(qsq,mz,mz)&
			-1.d0*mz**2/vev**2*cos(alpha)**2*2.d0*b0f(qsq,mz,mz)&
			-2.d0*mw**4/vev**2*cos(alpha)**2*db0f(qsq,mw,mw)&
			-1.d0*mz**4/vev**2*cos(alpha)**2*db0f(qsq,mz,mz)&
		)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibHbH_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,mbH,alpha

	PibHbH_F=&
	-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mt)&
		+(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	)*&
	sin(alpha)**2&
	!
	-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mb)&
		+(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	)*&
	sin(alpha)**2&
	!
	-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mc)&
		+(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	)*&
	sin(alpha)**2&
	!
	-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(ms)&
		+(2.d0*ms**2-qsq/2.d0)*b0f(qsq,ms,ms)&
	)*&
	sin(alpha)**2&
	!
	-4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mtau)&
		+(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	)*&
	sin(alpha)**2&
	!
	-4.d0*mmu**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mmu)&
		+(2.d0*mmu**2-qsq/2.d0)*b0f(qsq,mmu,mmu)&
	)*&
	sin(alpha)**2

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibHbH_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
	
	PibHbH_B =&
		1.d0/(16.d0*pi**2)*(&
			-12.d0*lam_bHbHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mbH)&
			-2.d0*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mh)&
			-2.d0*lam_GpGmbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mw)&
			-2.d0*lam_GGbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mz)&
			+2.d0*mw**2/vev**2*sin(alpha)**2*(4.d0*a0f(mw)-2.d0*mw**2)&
			+1.d0*mz**2/vev**2*sin(alpha)**2*(4.d0*a0f(mz)-2.d0*mz**2)&
			+1.d0*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mw,mw)&
			+18.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mbH,mbH)&
			+2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mh,mh)&
			+4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mh,mbH)&
			+2.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)**2*b0f(qsq,mz,mz)&
			+4.d0*mw**4/vev**2*sin(alpha)**2*(4.d0*b0f(qsq,mw,mw)-2.d0)&
			+2.d0*mz**4/vev**2*sin(alpha)**2*(4.d0*b0f(qsq,mz,mz)-2.d0)&
			-2.d0*mw**2/vev**2*sin(alpha)**2*(a0f(mw)+(2.d0*qsq+mw**2)*b0f(qsq,mw,mw))&
			-1.d0*mz**2/vev**2*sin(alpha)**2*(a0f(mz)+(2.d0*qsq+mz**2)*b0f(qsq,mz,mz))&
			-2.d0*mw**4/vev**2*sin(alpha)**2*b0f(qsq,mw,mw)&
			-1.d0*mz**4/vev**2*sin(alpha)**2*b0f(qsq,mz,mz)&
		)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function dPibHbH_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,alpha,mbH

	dPibHbH_F=&
		-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
			+(-1.d0/2.d0)*b0f(qsq,mt,mt)&
		)*&
		sin(alpha)**2&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
			+(-1.d0/2.d0)*b0f(qsq,mb,mb)&
		)*&
		sin(alpha)**2&
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
			+(-1.d0/2.d0)*b0f(qsq,mc,mc)&
		)*&
		sin(alpha)**2&
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*ms**2-qsq/2.d0)*db0f(qsq,ms,ms)&
			+(-1.d0/2.d0)*b0f(qsq,ms,ms)&
		)*&
		sin(alpha)**2&
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
			+(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
		)*&
		sin(alpha)**2&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			+(2.d0*mmu**2-qsq/2.d0)*db0f(qsq,mmu,mmu)&
			+(-1.d0/2.d0)*b0f(qsq,mmu,mmu)&
		)*&
		sin(alpha)**2

	end function 
!--------------------------------------------------------
	complex (kind(0d0)) function dPibHbH_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
	
	dPibHbH_B =&
		1.d0/(16.d0*pi**2)*(&
			+1.d0*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mw,mw)&
			+18.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mbH,mbH)&
			+2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mh,mh)&
			+4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mh,mbH)&
			+2.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)**2*db0f(qsq,mz,mz)&
			+4.d0*mw**4/vev**2*sin(alpha)**2*(4.d0*db0f(qsq,mw,mw))&
			+2.d0*mz**4/vev**2*sin(alpha)**2*(4.d0*db0f(qsq,mz,mz))&
			-2.d0*mw**2/vev**2*sin(alpha)**2*(2.d0*qsq+mw**2)*db0f(qsq,mw,mw)&
			-1.d0*mz**2/vev**2*sin(alpha)**2*(2.d0*qsq+mz**2)*db0f(qsq,mz,mz)&
			-2.d0*mw**2/vev**2*sin(alpha)**2*(2.d0)*b0f(qsq,mw,mw)&
			-1.d0*mz**2/vev**2*sin(alpha)**2*(2.d0)*b0f(qsq,mz,mz)&
			-2.d0*mw**4/vev**2*sin(alpha)**2*db0f(qsq,mw,mw)&
			-1.d0*mz**4/vev**2*sin(alpha)**2*db0f(qsq,mz,mz)&
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PibHh_F(qsq,mbH,alpha)
	double precision, intent(in):: qsq,mbH,alpha

	PibHh_F=&
		-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mt)&
			+(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
		)*cos(alpha)*sin(alpha)&
		!
		-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mb)&
			+(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
		)*cos(alpha)*sin(alpha)&
		!
		-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mc)&
			+(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
		)*cos(alpha)*sin(alpha)&
		!
		-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(ms)&
			+(2.d0*ms**2-qsq/2.d0)*b0f(qsq,ms,ms)&
		)*cos(alpha)*sin(alpha)&
		!
		-4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mtau)&
			+(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
		)*cos(alpha)*sin(alpha)&
		!
		-4.d0*mmu**2*1.d0/(16.d0*pi**2*vev**2)*&
		(&
			a0f(mmu)&
			+(2.d0*mmu**2-qsq/2.d0)*b0f(qsq,mmu,mmu)&
		)*cos(alpha)*sin(alpha)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibHh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
	
	PibHh_B =&
		1.d0/(16.d0*pi**2)*(&
			-3.d0*lam_bHbHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mbH)&
			-3.d0*lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mh)&
			-1.d0*lam_GpGmbHh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mw)&
			-1.d0*lam_GGbHh(mbH,alpha,lam_ps,lam_s,mu_s)*a0f(mz)&
			+4.d0*mw**2/vev**2*cos(alpha)*sin(alpha)*(4.d0*a0f(mw)-2.d0*mw**2)&
			+2.d0*mz**2/vev**2*cos(alpha)*sin(alpha)*(4.d0*a0f(mz)-2.d0*mz**2)&
			+1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mw,mw)&
			+6.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mbH)&
			+6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mh,mh)&
			+4.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mh,mbH)&
			+2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mz,mz)&
			+4.d0*mw**4/vev**2 *cos(alpha)*sin(alpha)*(4.d0*b0f(qsq,mw,mw)-2.d0)&
			+2.d0*mz**4/vev**2 *cos(alpha)*sin(alpha)*(4.d0*b0f(qsq,mz,mz)-2.d0)&
			-2.d0*mw**2/vev**2 *cos(alpha)*sin(alpha)*(a0f(mw)+(2.d0*qsq+mw**2)*b0f(qsq,mw,mw))&
			-1.d0*mz**2/vev**2 *cos(alpha)*sin(alpha)*(a0f(mz)+(2.d0*qsq+mz**2)*b0f(qsq,mz,mz))&
			-2.d0*mw**4/vev**2*cos(alpha)*sin(alpha)*b0f(qsq,mw,mw)&
			-1.d0*mz**4/vev**2*cos(alpha)*sin(alpha)*b0f(qsq,mz,mz)&
		)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function PibHh_PT(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s      
	
	PibHh_PT =&
		-g**2/(32.d0*pi**2)*(&
			(2.d0*qsq-mh**2-mbH**2)*cos(alpha)*sin(alpha)*b0f(qsq,mW,mW)&
		)&
		-gz**2/(64.d0*pi**2)*(&
			(2.d0*qsq-mh**2-mbH**2)*cos(alpha)*sin(alpha)*b0f(qsq,mZ,mZ)&
		)

	end function
!====== Fermion two-point functions ========
	complex (kind(0d0)) function Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf

	if (mf == mb) then
		vf = vb
		af = ab
		qf = qb
	elseif (mf == mt .or. mf == mc) then 
		vf = vt
		af = at
		qf = qt
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
	endif

	Piff_S =&
		-1.d0/(16.d0*pi**2)*(&
			QED*2.d0*(g*sw)**2*Qf**2*(2.d0*b0f(qsq,mf,mphoton)-1.d0)&
			+2.d0*gz**2*(vf**2-af**2)*(2.d0*b0f(qsq,mf,mZ)-1.d0)&
			+mf**2/vev**2*(&
				b0f(qsq,mf,mz)-cos(alpha)**2*b0f(qsq,mf,mh)-sin(alpha)**2*b0f(qsq,mf,mbh)&
				+2.d0*mfp**2/mf**2*b0f(qsq,mfp,mw)&
			)&
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf

	if (mf == mb) then
		vf = vb
		af = ab
		qf = qb
	elseif (mf == mt .or. mf == mc) then 
		vf = vt
		af = at
		qf = qt
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
	endif

	dPiff_S =&
		-1.d0/(16.d0*pi**2)*(&
			QED*2.d0*(g*sw)**2*Qf**2*(2.d0*db0f(qsq,mf,mphoton))&
			+2.d0*gz**2*(vf**2-af**2)*(2.d0*db0f(qsq,mf,mZ))&
			+mf**2/vev**2*(&
				db0f(qsq,mf,mz)-cos(alpha)**2*db0f(qsq,mf,mh)-sin(alpha)**2*db0f(qsq,mf,mbh)&
				+2.d0*mfp**2/mf**2*db0f(qsq,mfp,mw)&	
			)&
		)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf

	if (mf == mb) then 
		vf = vb
		af = ab
		qf = qb
	elseif (mf == mt .or. mf == mc) then 
		vf = vt
		af = at
		qf = qt
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
	endif

	Piff_V =&
		-1.d0/(16.d0*pi**2)*(&
			QED*(g*sw)**2*Qf**2*(2.d0*b1f(qsq,mf,mphoton)+1.d0)&
			+gz**2*(vf**2+af**2)*(2.d0*b1f(qsq,mf,mZ)+1.d0)&
			+g**2/4.d0*(2.d0*b1f(qsq,mfp,mW)+1.d0)&
			+mf**2/vev**2*(&
				cos(alpha)**2*b1f(qsq,mf,mh)+sin(alpha)**2*b1f(qsq,mf,mbh)+b1f(qsq,mf,mz)&
				+(mfp**2+mf**2)/mf**2*b1f(qsq,mfp,mw)&	
			)&
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf

	if (mf == mb) then 
		vf = vb
		af = ab
		qf = qb
	elseif (mf == mt .or. mf == mc) then 
		vf = vt
		af = at
		qf = qt
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
	endif

	dPiff_V =&
		-1.d0/(16.d0*pi**2)*(&
			QED*(g*sw)**2*Qf**2*(2.d0*db1f(qsq,mf,mphoton))&
			+gz**2*(vf**2+af**2)*(2.d0*db1f(qsq,mf,mZ))&
			+g**2/4.d0*(2.d0*db1f(qsq,mfp,mW))&
			+mf**2/vev**2*(&
				cos(alpha)**2*db1f(qsq,mf,mh)+sin(alpha)**2*db1f(qsq,mf,mbh)+db1f(qsq,mf,mz)&
				+(mfp**2+mf**2)/mf**2*db1f(qsq,mfp,mw)&	
			)&
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pitt_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitt_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pibb_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitautau_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pimumu_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pimumu_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Picc_S = Piff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPitt_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitt_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPibb_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitautau_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPimumu_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPimumu_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPicc_S = dPiff_S(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pitt_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitt_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pibb_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pitautau_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pimumu_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Pimumu_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Picc_V = Piff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPitt_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitt_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPibb_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPitautau_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPimumu_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPimumu_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu,0.d0)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	dPicc_V = dPiff_V(qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	end function
!--------------------------------------------------------
	complex (kind(0d0)) function Gam_hhh_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam_hhh_F =&
		-cos(alpha)**3*8.d0*mt**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
			+(4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mt,mt,mt)&
		)&
		!
		-cos(alpha)**3*8.d0*mb**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
			+(4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mb,mb,mb)&
		)&
		!
		-cos(alpha)**3*8.d0*mc**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
			+(4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mc,mc,mc)&
		)&
		!
		-cos(alpha)**3*8.d0*ms**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,ms,ms)+b0f(p2sq,ms,ms)+b0f(qsq,ms,ms)&
			+(4.d0*ms**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,ms,ms,ms)&
		)&
		!
		-cos(alpha)**3*8.d0*mtau**4*1.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
			+(4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau)&
		)&
		!
		-cos(alpha)**3*8.d0*mmu**4*1.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mmu,mmu)+b0f(p2sq,mmu,mmu)+b0f(qsq,mmu,mmu)&
			+(4.d0*mmu**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mmu,mmu,mmu)&
		)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_hhh_B =&
      1.d0/(16.d0*pi**2)*(&
			16.d0*mw**4/vev**3* cos(alpha)**3*(b0f(qsq,mw,mw)+b0f(p1sq,mw,mw)+ b0f(p2sq,mw,mw) ) &
			- 4.d0*mw**6/vev**3*cos(alpha)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw) &
			- 4.d0*mw**4/vev**3*cos(alpha)**3*2.d0*3.d0&
			+ 8.d0*mz**4/vev**3*cos(alpha)**3*(b0f(qsq,mz,mz)+b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz)) &
			- 2.d0*mz**6/vev**3*cos(alpha)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz) &
			- 2.d0*mz**4/vev**3*cos(alpha)**3*2.d0*3.d0&
			!
         +2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (b0f(qsq,mw,mw)+b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw))&
         +4.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (b0f(qsq,mz,mz)+b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz))&
         +72.d0* lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
         (b0f(qsq,mh,mh)+b0f(p1sq,mh,mh)+b0f(p2sq,mh,mh))&
			!
         +16.d0*mw**6/vev**3*cos(alpha)**3*4.d0*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
         +8.d0*mz**6/vev**3*cos(alpha)**3*4.d0*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
         -2.d0*mz**4/vev**3*cos(alpha)**3*Chhh_SVV(p1sq,p2sq,qsq,mz,mz,mz)&
         -4.d0*mw**4/vev**3*cos(alpha)**3*Chhh_SVV(p1sq,p2sq,qsq,mw,mw,mw) &
         +2.d0*mw**2/vev**2*cos(alpha)**2*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*Chhh_VSS_full(p1sq,p2sq,qsq,mw,mw,mw) &
         +2.d0*mz**2/vev**2*cos(alpha)**2*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*Chhh_VSS_full(p1sq,p2sq,qsq,mz,mz,mz) &
         -2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
         -8.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
         -216.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
			!
			- 24.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				c0f(p1sq,p2sq,qsq,mh,mh,mbH)&
				+c0f(p1sq,p2sq,qsq,mh,mbH,mh)&
				+c0f(p1sq,p2sq,qsq,mbH,mh,mh)&
			)&
			-8.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				c0f(p1sq,p2sq,qsq,mh,mbH,mbH)&
				+c0f(p1sq,p2sq,qsq,mbH,mbH,mh)&
				+c0f(p1sq,p2sq,qsq,mbH,mh,mbH)&
			)&
			- 8.d0* lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mbH,mbH,mbH)&
			!
			+12.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				b0f(qsq,mbH,mh)+b0f(p1sq,mbH,mh)+b0f(p2sq,mbH,mh)&
			)&
         +4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				b0f(qsq,mbH,mbH)+b0f(p1sq,mbH,mbH)+b0f(p2sq,mbH,mbH)&
			)&
		) 
    
	end function
!--------------------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam_bHhh_F = &
		-cos(alpha)**2*sin(alpha)*8.d0*mt**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
			+(4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mt,mt,mt)&
		)&
		!
		-cos(alpha)**2*sin(alpha)*8.d0*mb**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
			+(4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mb,mb,mb)&
		)&
		!
		-cos(alpha)**2*sin(alpha)*8.d0*mc**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
			+(4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mc,mc,mc)&
		)&
		!
		-cos(alpha)**2*sin(alpha)*8.d0*ms**4*3.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,ms,ms)+b0f(p2sq,ms,ms)+b0f(qsq,ms,ms)&
			+(4.d0*ms**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,ms,ms,ms)&
		)&
		!
		-cos(alpha)**2*sin(alpha)*8.d0*mtau**4*1.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
			+(4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau)&
		)&
		!
		-cos(alpha)**2*sin(alpha)*8.d0*mmu**4*1.d0/(16.d0*pi**2)/vev**3*(&
			b0f(p1sq,mmu,mmu)+b0f(p2sq,mmu,mmu)+b0f(qsq,mmu,mmu)&
			+(4.d0*mmu**2-qsq+(qsq-p1sq-p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mmu,mmu,mmu)&
		)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_bHhh_B =&
      1.d0/(16.d0*pi**2)*(&
			16.d0*mw**4/vev**3*cos(alpha)**2*sin(alpha)*(b0f(qsq,mw,mw)+b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw))&
			-4.d0*mw**6/vev**3*cos(alpha)**2*sin(alpha)*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
			-4.d0*mw**4/vev**3*cos(alpha)**2*sin(alpha)*2.d0*3.d0&
			+8.d0*mz**4/vev**3*cos(alpha)**2*sin(alpha)*(b0f(qsq,mz,mz)+b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz))&
			-2.d0*mz**6/vev**3*cos(alpha)**2*sin(alpha)*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
			-2.d0*mz**4/vev**3*cos(alpha)**2*sin(alpha)*2.d0*3.d0&
			!
         +2.d0*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mw,mw)&
         +lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GpGmbHh(mbH,alpha,lam_ps,lam_s,mu_s)&
         	*(b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw))&
         +4.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mz,mz)&
         +2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_GGbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz))&
         +24.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_hhhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mh,mh)&
         +18.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)*(b0f(p1sq,mh,mh)+b0f(p2sq,mh,mh))&
         +12.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mh)&
         +8.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*(b0f(p1sq,mbH,mh)+b0f(p2sq,mbH,mh))&
         +12.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mbH)&
         +6.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHbHbHh(mbH,alpha,lam_ps,lam_s,mu_s)&
				*(b0f(p1sq,mbH,mbH)+b0f(p2sq,mbH,mbH))&
			!
         +16.d0* mw**6/vev**3*cos(alpha)**2*sin(alpha)*4.d0*c0f(p1sq,p2sq,qsq,mW,mW,mW)&
         +8.d0* mz**6/vev**3*cos(alpha)**2*sin(alpha)*4.d0*c0f(p1sq,p2sq,qsq,mZ,mZ,mZ)&
			!
			-4.d0*mw**4/vev**3*cos(alpha)**2*sin(alpha)*(&
				CSSS_VVS(p1sq,p2sq,qsq,mW,mW,mw)+CSSS_VSV(p1sq,p2sq,qsq,mW,mw,mW)+CSSS_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
			)&
			-2.d0*mz**4/vev**3*cos(alpha)**2*sin(alpha)*(&
				CSSS_VVS(p1sq,p2sq,qsq,mZ,mZ,mz)+CSSS_VSV(p1sq,p2sq,qsq,mZ,mz,mZ)+CSSS_SVV(p1sq,p2sq,qsq,mz,mZ,mZ)&
			)&
			!
			+ 2.d0*mw**2/vev**2*cos(alpha)*sin(alpha)*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				CSSS_VSS(p1sq,p2sq,qsq,mW,mw,mw)+CSSS_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
			)&
			+2.d0*mw**2/vev**2*cos(alpha)**2*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*CSSS_SVS(p1sq,p2sq,qsq,mw,mW,mw)&
			+2.d0*mz**2/vev**2*cos(alpha)*sin(alpha)*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				CSSS_VSS(p1sq,p2sq,qsq,mZ,mz,mz)+CSSS_SSV(p1sq,p2sq,qsq,mz,mz,mZ)&
			)&
			+2.d0*mz**2/vev**2*cos(alpha)**2*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*CSSS_SVS(p1sq,p2sq,qsq,mz,mZ,mz)&
			!
         -2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
         -8.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
         -72.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
         -24.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				c0f(p1sq,p2sq,qsq,mbH,mh,mh)+c0f(p1sq,p2sq,qsq,mh,mh,mbH)&
			)&
         -8.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**3*c0f(p1sq,p2sq,qsq,mh,mbH,mh)&
         -24.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mbH,mbH,mbH)&
         -8.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				c0f(p1sq,p2sq,qsq,mh,mbH,mbH)+c0f(p1sq,p2sq,qsq,mbH,mbH,mh)&
			)&
			-24.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)**2*c0f(p1sq,p2sq,qsq,mbH,mh,mbH)&
		) 
    
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam1_hWW_F = cos(alpha)*Gam1_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam2_hWW_F = cos(alpha)*Gam2_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam3_hWW_F = cos(alpha)*Gam3_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam1_hZZ_F = cos(alpha)*Gam1_hZZ_F_SM(p1sq,p2sq,qsq)
	
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam2_hZZ_F =  cos(alpha)*Gam2_hZZ_F_SM(p1sq,p2sq,qsq)
	
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam3_hZZ_F = cos(alpha)*Gam3_hZZ_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam1_hWW_B =&
		1.d0/(16.d0*pi**2)*(&
			!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
			+cos(alpha)*g**3*cw*mz*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
			+cos(alpha)*g**3*cw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
			+cos(alpha)*g**3*sw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
			-cos(alpha)*g**3*sw**2*mw*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)& ! Ghost
			-cos(alpha)*g**3*cw*mz*c24f(p1sq,p2sq,qsq,mz,mw,mz)&         ! Ghost
			-cos(alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mz,mw)&      ! Ghost
			!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
			-cos(alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))& 
			-cos(alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))& 
			-cos(alpha)*g**3/cw**3*mw**2*mZ*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
			-cos(alpha)**3*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mh,mW)&
			-cos(alpha)*sin(alpha)**2*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mbh,mW)&
			!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
			+lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*mw**2*sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
			+lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*sw**2*mw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
			+cos(alpha)**2*6.d0*g**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mw**2*c0f(p1sq,p2sq,qsq,mh,mW,mh)& 
			+sin(alpha)**2*2.d0*g**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mw**2*c0f(p1sq,p2sq,qsq,mbH,mW,mbH)& 
			+sin(alpha)*cos(alpha)*2.d0*g**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*&
			mw**2*(c0f(p1sq,p2sq,qsq,mh,mW,mbH)+c0f(p1sq,p2sq,qsq,mbH,mW,mh))& 
			+cos(alpha)**3*1.d0/2.d0*g**3*mw*(c24f(p1sq,p2sq,qsq,mW,mh,mw)+c24f(p1sq,p2sq,qsq,mw,mh,mW))&
			+cos(alpha)*sin(alpha)**2*1.d0/2.d0*g**3*mw*(c24f(p1sq,p2sq,qsq,mW,mbH,mw)+c24f(p1sq,p2sq,qsq,mw,mbH,mW))&
			+cos(alpha)*1.d0/2.d0*g**3*sw**2/cw**2*mw*(c24f(p1sq,p2sq,qsq,mz,mw,mZ)+c24f(p1sq,p2sq,qsq,mZ,mw,mz))&
			!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
			-cos(alpha)**2*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(c24f(p1sq,p2sq,qsq,mw,mh,mw))&
			-sin(alpha)**2*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(c24f(p1sq,p2sq,qsq,mw,mbh,mw))&
			-lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(c24f(p1sq,p2sq,qsq,mw,mz,mw))&
			-cos(alpha)**2*6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(c24f(p1sq,p2sq,qsq,mh,mw,mh))&
			-sin(alpha)**2*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(c24f(p1sq,p2sq,qsq,mbh,mw,mbh))&
			-sin(alpha)*cos(alpha)*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(&
				c24f(p1sq,p2sq,qsq,mh,mw,mbh)+c24f(p1sq,p2sq,qsq,mbh,mw,mh)&
			)&
			!
			-2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
			!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~!
			-cos(alpha)*3.d0*g**3*mw*b0f(qsq,mW,mW)+cos(alpha)*2.d0*g**3*mW&
			-cos(alpha)*3.d0*g**3*cw*mz*b0f(qsq,mZ,mZ)+cos(alpha)*2.d0*g**3*cw*mZ&
			+1.d0/2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mw,mw)&
			+1.d0/2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mz,mz)&
			+3.d0/2.d0*cos(alpha)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mh,mh)&
			+1.d0/2.d0*sin(alpha)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mbh,mbh)&
			+sin(alpha)*cos(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*b0f(qsq,mbH,mh)&
			-cos(alpha)**3*1.d0/2.d0*g**3*mw*(b0f(p1sq,mW,mh)+b0f(p2sq,mW,mh))&
			-cos(alpha)*sin(alpha)**2*1.d0/2.d0*g**3*mw*(b0f(p1sq,mW,mbH)+b0f(p2sq,mW,mbH))&
			-cos(alpha)*1.d0/2.d0*g**3*mw*sw**4/cw**2*(b0f(p1sq,mZ,mw)+b0f(p2sq,mZ,mw))&
			-cos(alpha)*1.d0/2.d0*g**3*sw**2*mw*(b0f(p1sq,mphoton,mw)+b0f(p2sq,mphoton,mw))&
		)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hWW_B =&
		g**2/(16.d0*pi**2)*mw**2*(&
			+cos(alpha)*g*cw*mz*(ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)-c1223(p1sq,p2sq,qsq,mz,mw,mz)) &
			+cos(alpha)*g*mw*cw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)-c1223(p1sq,p2sq,qsq,mw,mz,mw))& 
			+cos(alpha)*g*mw*sw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)-c1223(p1sq,p2sq,qsq,mw,mphoton,mw))&
			!
			-cos(alpha)*g/2.d0*mw*(sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
			-cos(alpha)*g/2.d0*mw*(sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
			!
			+cos(alpha)**3*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw)&
			+cos(alpha)**3*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)&
			+cos(alpha)*sin(alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mw)&
			+cos(alpha)*sin(alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mbH,mW)&
			+cos(alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz)&
			+cos(alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)&
			!
			-2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
			-1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*cos(alpha)**2*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
			-1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)**2*c1223(p1sq,p2sq,qsq,mw,mbH,mw)&
			-1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
			!
			-6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*cos(alpha)**2*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
			-2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mw,mbH)&
			-2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)*cos(alpha)*c1223(p1sq,p2sq,qsq,mbH,mw,mh)&
			-2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)*cos(alpha)*c1223(p1sq,p2sq,qsq,mh,mw,mbH)&
		)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)  
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam1_hZZ_B =&
		1.d0/(16.d0*pi**2)*(&
			+2.d0*g_WWh(alpha)*g**2*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&
			-2.d0*g_WWh(alpha)*g**2*cw**2*C24f(p1sq,p2sq,qsq,mw,mw,mw)&
			!
			+2.d0*(-g*cw)*g_WZGp(alpha)*(-g_GphW(alpha))*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)&		
			+2.d0*g*cw*g_WZGp(alpha)*g_GphW(alpha)*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&	 	
         +2.d0*ChVV1_VSV(p1sq,p2sq,qsq,mW,mw,mW,g_WWh(alpha),g_WZGp(alpha),g_WZGp(alpha))&
         +8.d0*ChVV1_VSV(p1sq,p2sq,qsq,mZ,mh,mZ,g_ZZh(alpha),g_ZZh(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_VSV(p1sq,p2sq,qsq,mZ,mbH,mZ,g_ZZh(alpha),g_ZZbH(alpha),g_ZZbH(alpha))&
			!
         +2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mw,mw,mW,g_WZGp(alpha),g_GpGmZ(alpha),-g_GphW(alpha))&
         +2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mz,mh,mZ,g_ZZh(alpha),g_GhZ(alpha),g_GhZ(alpha))&
         +2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mz,mbH,mZ,g_ZZbH(alpha),g_GhZ(alpha),g_GbHZ(alpha))&
         +2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mW,mw,mw,g_WZGp(alpha),g_GpGmZ(alpha),g_GphW(alpha)) &
         +2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mZ,mh,mz, g_ZZh(alpha), -g_GhZ(alpha), g_GhZ(alpha))&
         +2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mZ,mbH,mz,g_ZZbH(alpha),-g_GbHZ(alpha),g_GhZ(alpha))&
			!
         +2.d0*ChVV1_SVS(p1sq,p2sq,qsq,mw,mW,mw,lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s),g_WZGp(alpha),g_WZGp(alpha))&
         +24.d0*ChVV1_SVS(p1sq,p2sq,qsq,mh,mZ,mh,lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZh(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mbh,mZ,mbh,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZbH(alpha))&
         +8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mbh,mZ,mh,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mh,mZ,mbh,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZh(alpha))&
			!
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mw,mw,mw,  lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s),g_GpGmZ(alpha), g_GpGmZ(alpha))&
         +6.d0*ChVV1_SSS(p1sq,p2sq,qsq,mh,mz,mh,  lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s),  g_GhZ(alpha),  -g_GhZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mbH,mz,mbH,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_GbHZ(alpha), -g_GbHZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mbH,mz,mh, lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s), g_GbHZ(alpha), -g_GhZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mh,mz,mbH, lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s), g_GhZ(alpha),  -g_GbHZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mz,mh,mz,  lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s),  g_GhZ(alpha),  -g_GhZ(alpha))&
         +2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mz,mbh,mz, lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s),  g_GbHZ(alpha), -g_GbHZ(alpha))&
			!
         +2.d0*ChVV1_VV(qsq,mW,mW,g_WWZZ(alpha),g_WWh(alpha))&
         +4.d0*ChVV1_SS(qsq,mz,mz,lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZGG(alpha))&
         +2.d0*ChVV1_SS(qsq,mw,mw,lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZGpGm(alpha))&
         +4.d0*ChVV1_SS(qsq,mbH,mbH,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbHbH(alpha))&
         +12.d0*ChVV1_SS(qsq,mh,mh,lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZhh(alpha))&
         +4.d0*ChVV1_SS(qsq,mh,mbH,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbHh(alpha))&
         +2.d0*ChVV1_VS(p1sq,mW,mw,g_WZGph(alpha),g_WZGp(alpha))&
         +2.d0*ChVV1_VS(p2sq,mW,mw,g_WZGph(alpha),g_WZGp(alpha))&
         +8.d0*ChVV1_VS(p1sq,mZ,mh,g_ZZhh(alpha),g_ZZh(alpha))&
         +8.d0*ChVV1_VS(p2sq,mZ,mh,g_ZZhh(alpha),g_ZZh(alpha))&
         +4.d0*ChVV1_VS(p1sq,mZ,mbH,g_ZZbHh(alpha),g_ZZbH(alpha))&
         +4.d0*ChVV1_VS(p2sq,mZ,mbH,g_ZZbHh(alpha),g_ZZbH(alpha))&
		)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hZZ_B =&
		gz**2/(16.d0*pi**2)*mz**2*(&
			+cos(alpha)*2.d0*g*mw*cw**4*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW)-C1223(p1sq,p2sq,qsq,mw,mw,mw))&
			!
			+cos(alpha)*g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
			+cos(alpha)*g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
			!
			-cos(alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
			-cos(alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
			+cos(alpha)**3*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz)&
			+cos(alpha)**3*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)&
			+cos(alpha)*sin(alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mz)&
			+cos(alpha)*sin(alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mbH,mZ)&
			!
			-2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&
			-2.d0*cos(alpha)**2*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
			-2.d0*sin(alpha)**2*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mz,mbH,mz)&
			-6.d0*cos(alpha)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
			-2.d0*sin(alpha)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mbH,mz,mbH)&
			-2.d0*sin(alpha)*cos(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mbH,mz,mh)&
			-2.d0*sin(alpha)*cos(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mh,mz,mbH)&
		)

	end function
!========================================================================================
	complex (kind(0d0)) function Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf,mfp
	double precision:: vf,af,qf

	if (mf == mb) then 
		vf = vb
		af = ab
		qf = qb
	elseif (mf == mt .or. mf == mc) then 
		vf = vt
		af = at
		qf = qt
	elseif (mf == mtau .or.mf==mmu) then 
		vf = ve
		af = ae
		qf = qe
	endif

	Gam_hff =&
		1.d0/(16.d0*pi**2)*mf/vev*(&
			-cos(alpha)*4.d0*gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mz)&
			-QED*cos(alpha)*4.d0*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
			+cos(alpha)**3*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
			+cos(alpha)*sin(alpha)**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mbH)&
			-cos(alpha)*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
			-cos(alpha)*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
			-cos(alpha)*2.d0*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			!
			-6.d0*cos(alpha)**2*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
			-2.d0*sin(alpha)**2*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
			-2.d0*cos(alpha)*sin(alpha)*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mbH,mf,mh)+c0f(p1sq,p2sq,qsq,mh,mf,mbH)&
			)&
			+2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
			+2.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
			!
			-cos(alpha)*g**2/4.d0*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
			-cos(alpha)*g**2/4.d0*Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
			-cos(alpha)*gz**2/8.d0*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
			-cos(alpha)*gz**2/8.d0*Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_P(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then 
		vf = vt
		af = at
		qf = qt
		mfp = mb
	elseif (mf == mc) then 
		vf = vt
		af = at
		qf = qt
		mfp = ms
	elseif (mf == mb) then 
		vf  = vb
		af  = ab
		qf  = qb
		mfp = mt
	elseif (mf == mtau .or. mf==mmu) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	endif

	Fhff_P =&
		-1.d0/(16.d0*pi**2)*mf/vev*cos(alpha)*(& 
			-g**2/4.d0*(&
				Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)-Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			-2.d0*gz**2*vf*af*(&
				Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)-Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt
		af = at
		qf = qt
		mfp = mb
	elseif (mf == mc) then 
		vf = vt
		af = at
		qf = qt
		mfp = ms
	elseif (mf == mb) then 
		vf  = vb
		af  = ab
		qf  = qb
		mfp = mt
	elseif (mf == mtau .or. mf==mmu) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	endif

	Fhff_V1 =&
		-1.d0/(16.d0*pi**2)*(& 
			cos(alpha)*2.d0*gz**2*(vf**2+af**2)*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+QED*cos(alpha)*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mphoton,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf)&
			)&
			+cos(alpha)*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			+cos(alpha)**3*mf**4/vev**3*(&
				c0f(p1sq,p2sq,qsq,mf,mh,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf)&
			)&
			+cos(alpha)*sin(alpha)**2*mf**4/vev**3*(&
				c0f(p1sq,p2sq,qsq,mf,mbH,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mbH,mf)&
			)&
			+cos(alpha)*mf**4/vev**3*(&
				c0f(p1sq,p2sq,qsq,mf,mz,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf)&
			)&
			+cos(alpha)*mfp**2/vev**3*(mf**2+mfp**2)*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			-cos(alpha)*gz**4*vev*(vf**2+af**2)*(&
				c0f(p1sq,p2sq,qsq,mZ,mf,mZ)+c11f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			)&
			-cos(alpha)*g**4/4.d0*vev*(&
				c0f(p1sq,p2sq,qsq,mW,mfp,mW)+c11f(p1sq,p2sq,qsq,mW,mfp,mW)&
			)&
			+cos(alpha)**2*6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(&
				c0f(p1sq,p2sq,qsq,mh,mf,mh)+c11f(p1sq,p2sq,qsq,mh,mf,mh)&
			)&
			+sin(alpha)**2*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(&
				c0f(p1sq,p2sq,qsq,mbH,mf,mbH)+c11f(p1sq,p2sq,qsq,mbH,mf,mbH)&
			)&
			+cos(alpha)*sin(alpha)*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(&
				c0f(p1sq,p2sq,qsq,mbH,mf,mh)+c11f(p1sq,p2sq,qsq,mbH,mf,mh)&
				+c0f(p1sq,p2sq,qsq,mh,mf,mbH)+c11f(p1sq,p2sq,qsq,mh,mf,mbH)&
			)&
			+2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(&
				c0f(p1sq,p2sq,qsq,mz,mf,mz)+c11f(p1sq,p2sq,qsq,mz,mf,mz)&
			)&
			+1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2+mfp**2)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mw,mfp,mw)+c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
			)&
			-cos(alpha)*g**2/4.d0*mfp**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			-cos(alpha)*gz**2/8.d0*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt
		af = at
		qf = qt
		mfp = mb
	elseif (mf == mc) then 
		vf = vt
		af = at
		qf = qt
		mfp = ms
	elseif (mf == mb) then 
		vf  = vb
		af  = ab
		qf  = qb
		mfp = mt
	elseif (mf == mtau) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	elseif (mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	endif

	Fhff_V2 =&
	 	-1.d0/(16.d0*pi**2)*(& 
			cos(alpha)*2.d0*gz**2*(vf**2+af**2)*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+QED*cos(alpha)*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mphoton,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf)&
			)&
			+cos(alpha)*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			+cos(alpha)**3*mf**4/vev**3*(&
				c0f(p1sq,p2sq,qsq,mf,mh,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf)&
			)&
			+cos(alpha)*sin(alpha)**2*mf**4/vev**3*(&
				c0f(p1sq,p2sq,qsq,mf,mbH,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mbH,mf)&
			)&
			+cos(alpha)*mf**4/vev**3*(&
				c0f(p1sq,p2sq,qsq,mf,mz,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf)&
			)&
			+cos(alpha)*mfp**2/vev**3*(mf**2+mfp**2)*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			-cos(alpha)*gz**4*vev*(vf**2+af**2)*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
			-cos(alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
			+cos(alpha)**2*6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mh,mf,mh))&
			+sin(alpha)**2*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mbH,mf,mbH))&
			+cos(alpha)*sin(alpha)*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(&
				c12f(p1sq,p2sq,qsq,mbH,mf,mh)+c12f(p1sq,p2sq,qsq,mh,mf,mbH)&
			)&
			+2.d0*lam_GGh(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mz))&
			+1.d0*lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2+mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
			-cos(alpha)*g**2/4.d0*mfp**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c12f(p1sq,p2sq,qsq,mw,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			-cos(alpha)*gz**2/8.d0*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_A1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then 
		vf = vt
		af = at
		qf = qt
		mfp = mb
	elseif (mf == mc) then 
		vf = vt
		af = at
		qf = qt
		mfp = ms
	elseif (mf == mb) then 
		vf  = vb
		af  = ab
		qf  = qb
		mfp = mt
	elseif (mf == mtau) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	elseif (mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	endif

	Fhff_A1 =&
		-1.d0/(16.d0*pi**2)*(& 
			-cos(alpha)*4.d0*gz**2*vf*af*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			-cos(alpha)*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			+cos(alpha)*mfp**2*(mf**2-mfp**2)/vev**3*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			+cos(alpha)*2.d0*gz**4*vf*af*vev*(&
				c0f(p1sq,p2sq,qsq,mZ,mf,mZ)+c11f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			)&
			+cos(alpha)*g**4/4.d0*vev*(&
				c0f(p1sq,p2sq,qsq,mW,mfp,mW)+c11f(p1sq,p2sq,qsq,mW,mfp,mW)&
			)&
			+lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2-mfp**2)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mw,mfp,mw)+c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
			)&
			+cos(alpha)*g**2*mfp**2/(4.d0*vev)*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+cos(alpha)*2.d0*gz**2*vf*af*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_A2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt
		af = at
		qf = qt
		mfp = mb
	elseif (mf == mc) then 
		vf = vt
		af = at
		qf = qt
		mfp = ms
	elseif (mf == mb) then 
		vf  = vb
		af  = ab
		qf  = qb
		mfp = mt
	elseif (mf == mtau) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	elseif (mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	endif

	Fhff_A2 = -1.d0/(16.d0*pi**2)*(&
		-cos(alpha)*4.d0*gz**2*vf*af*mf**2/vev*(&
			c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf)&
		)&
		+cos(alpha)*2.d0*gz**4*vf*af*vev*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
		-cos(alpha)*g**2/2.d0*mfp**2/vev*(&
			c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp)&
		)&
		+cos(alpha)*g**4/4.d0*vev*c12f(p1sq,p2sq,qsq,mW,mfp,mW)&
		!
		+cos(alpha)*mfp**2*(mf**2-mfp**2)/vev**3*(&
			c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp)&
		)&
		+lam_GpGmh(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2-mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
		!
		+cos(alpha)*g**2*mfp**2/(4.d0*vev)*(&
			2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
			-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
		)&
		+cos(alpha)*2.d0*gz**2*vf*af*mf**2/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
			-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
		)&
	)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt
		af = at
		qf = qt
		mfp = mb
	elseif (mf == mc) then 
		vf = vt
		af = at
		qf = qt
		mfp = ms
	elseif (mf == mb) then 
		vf  = vb
		af  = ab
		qf  = qb
		mfp = mt
	elseif (mf == mtau) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	elseif (mf == mmu) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	endif

    Fhff_T =&
	 	-1.d0/(16.d0*pi**2)*(mf/vev)*(&
			cos(alpha)**3*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf))&
			+cos(alpha)*sin(alpha)**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mbH,mf)-c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
			-cos(alpha)*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf))&
			-cos(alpha)*2.d0*mfp**2/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
			+cos(alpha)*g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
				+1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
				-2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+cos(alpha)*gz**2/8.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
				+1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
				-2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)
 
	end function
!------------------------------------------------------------
	complex (kind(0d0)) function Fhff_PT(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt
		af = at
		qf = qt
		mfp = mb
	elseif (mf == mc) then
		vf = vt
		af = at
		qf = qt
		mfp = ms
	elseif (mf == mb) then
		vf  = vb
		af  = ab
		qf  = qb
		mfp = mt
	elseif (mf == mtau) then 
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	elseif (mf == mmu) then
		vf = ve
		af = ae
		qf = qe
		mfp = 0.d0
	endif

	Fhff_PT =&
		1.d0/(16.d0*pi**2)*(mf/vev)*cos(alpha)*(&
			g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)-c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
      		-(c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)-2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW))&
			)&
			+2.d0*gz**2*af*vf*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)-c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-(c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ))&
			)&
		)

	end function
!========================================================================================
	complex (kind(0d0)) function Gam_htautau(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_htautau = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau,0.d0)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function Gam_hmumu(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_hmumu = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu,0.d0)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function Gam_hbb(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_hbb = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb,mt)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function Gam_hcc(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_hcc = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc,ms)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function Gam_htt(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_htt = Gam_hff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mt,mb)

	end function
!========================================================
!  1PI vertices for bH decay
!========================================================
	complex (kind(0d0)) function Gam1_bHWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam1_bHWW_F = sin(alpha)*Gam1_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam2_bHWW_F = sin(alpha)*Gam2_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_bHWW_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam3_bHWW_F = sin(alpha)*Gam3_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHWW_B = 1.d0/(16.d0*pi**2)*(&
		!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+sin(alpha)*g**3*mW*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
		+sin(alpha)*g**3*cw**2*mW*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
		+sin(alpha)*(g*sw)**2*g*mW*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
		-sin(alpha)*g**3*mW*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
		-sin(alpha)*g**3*cw**2*mW*c24f(p1sq,p2sq,qsq,mw,mz,mw)&
		-sin(alpha)*(g*sw)**2*g*mW*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)&
		!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		-sin(alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))& 
		-sin(alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
		-sin(alpha)*g**3*mW**3*(&
			cos(alpha)**2*c0f(p1sq,p2sq,qsq,mW,mh,mW)+sin(alpha)**2*c0f(p1sq,p2sq,qsq,mW,mbH,mW)&
		)&
		-sin(alpha)*g**2*gz*mZ**3*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
		!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+g**2*mw**2*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*(&
			sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
			+sw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
		)&
		+g**2*mw**2*(&
			+sin(alpha)**2*6.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mbH,mW,mbH)&
			+cos(alpha)**2*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mh,mW,mh)&
			+sin(alpha)*cos(alpha)*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				c0f(p1sq,p2sq,qsq,mh,mW,mbH)+c0f(p1sq,p2sq,qsq,mbH,mW,mh)&
			)&
		)&
		+sin(alpha)**3*1.d0/2.d0*g**3*mw*(c24f(p1sq,p2sq,qsq,mW,mbH,mw)+c24f(p1sq,p2sq,qsq,mw,mbH,mW))&
		+sin(alpha)*cos(alpha)**2*1.d0/2.d0*g**3*mw*(c24f(p1sq,p2sq,qsq,mW,mh,mw)+c24f(p1sq,p2sq,qsq,mw,mh,mW))&
		+sin(alpha)*1.d0/2.d0*g**3*sw**2/cw**2*mw*(c24f(p1sq,p2sq,qsq,mz,mw,mZ)+c24f(p1sq,p2sq,qsq,mZ,mw,mz))&
		!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		-lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*g**2*(&
			sin(alpha)**2*c24f(p1sq,p2sq,qsq,mw,mbH,mw)&
			+cos(alpha)**2*c24f(p1sq,p2sq,qsq,mw,mh,mw)&
			+c24f(p1sq,p2sq,qsq,mw,mz,mw)&
		)&
		-g**2*(&
			sin(alpha)**2*6.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*c24f(p1sq,p2sq,qsq,mbH,mw,mbH)&
			+cos(alpha)**2*2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c24f(p1sq,p2sq,qsq,mh,mw,mh)&
			+sin(alpha)*cos(alpha)*2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
				c24f(p1sq,p2sq,qsq,mh,mw,mbH)+c24f(p1sq,p2sq,qsq,mbH,mw,mh)&
			)&
			+2.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
		)&
		!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~!
		-sin(alpha)*3.d0*g**3*mW*(b0f(qsq,mW,mW)-2.d0/3.d0)&
		-sin(alpha)*3.d0*g**3*mW*(b0f(qsq,mZ,mZ)-2.d0/3.d0)&
		+g**2/2.d0*(&
			+lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mw,mw)&
			+lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mz,mz)&
			+3.d0*sin(alpha)**2*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mbH)&
			+cos(alpha)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mh,mh)&
			+2.d0*sin(alpha)*cos(alpha)*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*b0f(qsq,mbH,mh)&
		)&
		-sin(alpha)*g**3/2.d0*mw*(&
			sin(alpha)**2*(b0f(p1sq,mW,mbH)+b0f(p2sq,mW,mbH))&
			+cos(alpha)**2*(b0f(p1sq,mW,mh)+b0f(p2sq,mW,mh))&
		)&
  		-sin(alpha)*g**3/2.d0*mw*(&
			sw**4/cw**2*(b0f(p1sq,mZ,mw)+b0f(p2sq,mZ,mw))&
			+sw**2*(b0f(p1sq,mphoton,mw)+b0f(p2sq,mphoton,mw))&
		)&
	)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam2_bHWW_B = g**2/(16.d0*pi**2)*mw**2*(&
		!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		sin(alpha)*g*mW*(&
			ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
			+cw**2*ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
			+sw**2*ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
		)&
		-sin(alpha)*g*mW*(&
			c1223(p1sq,p2sq,qsq,mz,mw,mz)&
			+cw**2*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
			+sw**2*c1223(p1sq,p2sq,qsq,mw,mphoton,mw)&
		)&
		!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		-sin(alpha)*g/2.d0*mw*sw**2*(ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
		-sin(alpha)*g/2.d0*mw*sw**2*(ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
		!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+g/2.d0*mw*sin(alpha)*(&
			cos(alpha)**2*(&
				ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw)+ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)&
			)&
			+sin(alpha)**2*(&
				ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mw)+ChVV2_SSV(p1sq,p2sq,qsq,mw,mbH,mW)&
			)&
			+sw**2/cw**2*(&
				ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz)+ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)&
			)&
		)&
		!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		-lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*(&
			cos(alpha)**2*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
			+sin(alpha)**2*c1223(p1sq,p2sq,qsq,mw,mbH,mw)&
			+c1223(p1sq,p2sq,qsq,mw,mz,mw)&
		)&
		-6.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mw,mbH)&
		-2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*cos(alpha)**2*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
		-2.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*sin(alpha)*cos(alpha)*(&
			c1223(p1sq,p2sq,qsq,mbH,mw,mh)+c1223(p1sq,p2sq,qsq,mh,mw,mbH)&
		)&
		-2.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
	)

	end function
!========================================================================================
	complex (kind(0d0)) function Gam1_bHZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam1_bHZZ_F = sin(alpha)*Gam1_hZZ_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam2_bHZZ_F =  sin(alpha)*Gam2_hZZ_F_SM(p1sq,p2sq,qsq)
	
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_bHZZ_F(p1sq,p2sq,qsq,mbH,alpha)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha

	Gam3_bHZZ_F = sin(alpha)*Gam3_hZZ_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHZZ_B =1.d0/(16.d0*pi**2)*(&
		!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+2.d0*g_WWbH(alpha)*g**2*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&
		-2.d0*g_WWbH(alpha)*g**2*cw**2*C24f(p1sq,p2sq,qsq,mw,mw,mw)&
		!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+2.d0*(-g*cw)*g_WZGp(alpha)*(-g_GpbHW(alpha))*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)&		
		+2.d0*g*cw*g_WZGp(alpha)*g_GpbHW(alpha)*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
		+2.d0*ChVV1_VSV(p1sq,p2sq,qsq,mW,mw,mW,g_WWbH(alpha),g_WZGp(alpha),g_WZGp(alpha))&
		+8.d0*ChVV1_VSV(p1sq,p2sq,qsq,mZ,mh,mZ,g_ZZbH(alpha),g_ZZh(alpha),g_ZZh(alpha))&
		+8.d0*ChVV1_VSV(p1sq,p2sq,qsq,mZ,mbH,mZ,g_ZZbH(alpha),g_ZZbH(alpha),g_ZZbH(alpha))&
		!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mw,mw,mW,g_WZGp(alpha),g_GpGmZ(alpha),-g_GpbHW(alpha))&
		+2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mz,mh,mZ,g_ZZh(alpha),g_GbHZ(alpha),g_GhZ(alpha))&
		+2.d0*ChVV1_SSV(p1sq,p2sq,qsq,mz,mbH,mZ,g_ZZbH(alpha),g_GbHZ(alpha),g_GbHZ(alpha))&
		+2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mW,mw,mw,g_WZGp(alpha),g_GpGmZ(alpha),g_GpbHW(alpha)) &
		+2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mZ,mh,mz, g_ZZh(alpha), -g_GhZ(alpha), g_GbHZ(alpha))&
		+2.d0*ChVV1_VSS(p1sq,p2sq,qsq,mZ,mbH,mz,g_ZZbH(alpha),-g_GbHZ(alpha),g_GbHZ(alpha))&
		!
		+2.d0*ChVV1_SVS(p1sq,p2sq,qsq,mw,mW,mw,lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s),g_WZGp(alpha),g_WZGp(alpha))&
		+8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mh,mZ,mh,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZh(alpha),g_ZZh(alpha))&
		+24.d0*ChVV1_SVS(p1sq,p2sq,qsq,mbh,mZ,mbh,lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZbH(alpha))&
		+8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mbh,mZ,mh,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZh(alpha))&
		+8.d0*ChVV1_SVS(p1sq,p2sq,qsq,mh,mZ,mbh,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbH(alpha),g_ZZh(alpha))&
		!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mw,mw,mw,  lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s),g_GpGmZ(alpha), g_GpGmZ(alpha))&
		+2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mh,mz,mh,  lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),  g_GhZ(alpha),  -g_GhZ(alpha))&
		+6.d0*ChVV1_SSS(p1sq,p2sq,qsq,mbH,mz,mbH,lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s),g_GbHZ(alpha), -g_GbHZ(alpha))&
		+2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mbH,mz,mh, lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s), g_GbHZ(alpha), -g_GhZ(alpha))&
		+2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mh,mz,mbH, lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s), g_GhZ(alpha),  -g_GbHZ(alpha))&
		+2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mz,mh,mz,  lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s),  g_GhZ(alpha),  -g_GhZ(alpha))&
		+2.d0*ChVV1_SSS(p1sq,p2sq,qsq,mz,mbh,mz, lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s),  g_GbHZ(alpha), -g_GbHZ(alpha))&
		!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~!
		+2.d0*ChVV1_VV(qsq,mW,mW,g_WWZZ(alpha),g_WWbH(alpha))&
		+4.d0*ChVV1_SS(qsq,mz,mz,lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZGG(alpha))&
		+2.d0*ChVV1_SS(qsq,mw,mw,lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZGpGm(alpha))&
		+12.d0*ChVV1_SS(qsq,mbH,mbH,lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbHbH(alpha))&
		+4.d0*ChVV1_SS(qsq,mh,mh,lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZhh(alpha))&
		+4.d0*ChVV1_SS(qsq,mh,mbH,lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s),g_ZZbHh(alpha))&
		+2.d0*ChVV1_VS(p1sq,mW,mw,g_WZGpbH(alpha),g_WZGp(alpha))&
		+2.d0*ChVV1_VS(p2sq,mW,mw,g_WZGpbH(alpha),g_WZGp(alpha))&
		+4.d0*ChVV1_VS(p1sq,mZ,mh,g_ZZbHh(alpha),g_ZZh(alpha))&
		+4.d0*ChVV1_VS(p2sq,mZ,mh,g_ZZbHh(alpha),g_ZZh(alpha))&
		+8.d0*ChVV1_VS(p1sq,mZ,mbH,g_ZZbHbH(alpha),g_ZZbH(alpha))&
		+8.d0*ChVV1_VS(p2sq,mZ,mbH,g_ZZbHbH(alpha),g_ZZbH(alpha))&
	)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam2_bHZZ_B = gz**2/(16.d0*pi**2)*mz**2*(&
		!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+sin(alpha)*2.d0*g*mw*cw**4*ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW)&
		-sin(alpha)*2.d0*g*mw*cw**4*C1223(p1sq,p2sq,qsq,mw,mw,mw)&
		!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		+sin(alpha)*g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
		+sin(alpha)*g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
		!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		-sin(alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
		-sin(alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
		+sin(alpha)**3*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mz)&
		+sin(alpha)**3*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mbH,mZ)&
		+sin(alpha)*cos(alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz)&
		+sin(alpha)*cos(alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)&
		!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
		-2.d0*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&
		-2.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*(&
			sin(alpha)**2*c1223(p1sq,p2sq,qsq,mz,mbH,mz)+cos(alpha)**2*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
		)&
		-6.d0*sin(alpha)**2*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mbH,mz,mbH)&
		-2.d0*cos(alpha)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
		-2.d0*sin(alpha)*cos(alpha)*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
			c1223(p1sq,p2sq,qsq,mbH,mz,mh)+c1223(p1sq,p2sq,qsq,mh,mz,mbH)&
		)&
	)

	end function
!========================================================================================
	complex (kind(0d0)) function Gam_bHff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	Gam_bHff =&
		1.d0/(16.d0*pi**2)*mf/vev*(&
			-4.d0*sin(alpha)*(&
				gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mz)&
				+QED*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
			)&
			+mf**2/vev**2*sin(alpha)*(&
				cos(alpha)**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
				+sin(alpha)**2*Chff_FSF(p1sq,p2sq,qsq,mf,mbH)&
				-Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
			)&
			-sin(alpha)*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
			!
			-sin(alpha)*2.d0*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			!
			-2.d0*mf**2/vev*(&
				3.d0*sin(alpha)**2*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
				+cos(alpha)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
				+cos(alpha)*sin(alpha)*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
					c0f(p1sq,p2sq,qsq,mbH,mf,mh)+c0f(p1sq,p2sq,qsq,mh,mf,mbH)&
				)&
			)&
			+2.d0*lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
			+2.d0*lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
			!
			-sin(alpha)*g**2/4.d0*(&
				Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)+Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			-sin(alpha)*gz**2/8.d0*(&
				Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)+Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function FbHff_P(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	FbHff_P =&
		-1.d0/(16.d0*pi**2)*mf/vev*sin(alpha)*(&
			-g**2/4.d0*(&
				Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)-Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			-2.d0*gz**2*vf*af*(&
				Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)-Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function FbHff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	FbHff_V1 =&
		-1.d0/(16.d0*pi**2)*(&
			sin(alpha)*2.d0*gz**2*(vf**2+af**2)*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+QED*sin(alpha)*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mphoton,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf)&
			)&
			+sin(alpha)*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			!
			+sin(alpha)*mf**4/vev**3*(&
				cos(alpha)**2*(&
					c0f(p1sq,p2sq,qsq,mf,mh,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf)&
				)&
				+sin(alpha)**2*(&
					c0f(p1sq,p2sq,qsq,mf,mbH,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mbH,mf)&
				)&
				+c0f(p1sq,p2sq,qsq,mf,mz,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf)&
			)&
			+sin(alpha)*mfp**2/vev**3*(mf**2+mfp**2)*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			!
			-sin(alpha)*gz**4*vev*(vf**2+af**2)*(&
				c0f(p1sq,p2sq,qsq,mZ,mf,mZ)+c11f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			)&
			-sin(alpha)*g**4/4.d0*vev*(&
				c0f(p1sq,p2sq,qsq,mW,mfp,mW)+c11f(p1sq,p2sq,qsq,mW,mfp,mW)&
			)&
			!
			+2.d0*mf**2/vev**2*(&
				+sin(alpha)**2*3.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*(&
					c0f(p1sq,p2sq,qsq,mbH,mf,mbH)+c11f(p1sq,p2sq,qsq,mbH,mf,mbH)&
				)&
				+cos(alpha)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
					c0f(p1sq,p2sq,qsq,mh,mf,mh)+c11f(p1sq,p2sq,qsq,mh,mf,mh)&
				)&
				+cos(alpha)*sin(alpha)*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
					c0f(p1sq,p2sq,qsq,mbH,mf,mh)+c11f(p1sq,p2sq,qsq,mbH,mf,mh)&
					+c0f(p1sq,p2sq,qsq,mh,mf,mbH)+c11f(p1sq,p2sq,qsq,mh,mf,mbH)&
				)&
				+lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*(&
					c0f(p1sq,p2sq,qsq,mz,mf,mz)+c11f(p1sq,p2sq,qsq,mz,mf,mz)&
				)&
			)&
			+lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2+mfp**2)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mw,mfp,mw)+c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
			)&
			!
			-sin(alpha)*g**2/4.d0*mfp**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			-sin(alpha)*gz**2/8.d0*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function FbHff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	FbHff_V2 =&
		-1.d0/(16.d0*pi**2)*(&
			sin(alpha)*2.d0*gz**2*(vf**2+af**2)*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+QED*sin(alpha)*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mphoton,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf)&
			)&
			+sin(alpha)*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			!
			+sin(alpha)*mf**4/vev**3*(&
				+cos(alpha)**2*(&
					c0f(p1sq,p2sq,qsq,mf,mh,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf)&
				)&
				+sin(alpha)**2*(&
					c0f(p1sq,p2sq,qsq,mf,mbH,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mbH,mf)&
				)&
				+c0f(p1sq,p2sq,qsq,mf,mz,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf)&
			)&
			+sin(alpha)*mfp**2/vev**3*(mf**2+mfp**2)*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			!
			-sin(alpha)*gz**4*vev*(vf**2+af**2)*c12f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			-sin(alpha)*g**4/4.d0*vev*c12f(p1sq,p2sq,qsq,mW,mfp,mW)&
			!
			+2.d0*mf**2/vev**2*(&
				+sin(alpha)**2*3.d0*lam_bHbHbH(mbH,alpha,lam_ps,lam_s,mu_s)*c12f(p1sq,p2sq,qsq,mbH,mf,mbH)&
				+cos(alpha)**2*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*c12f(p1sq,p2sq,qsq,mh,mf,mh)&
				+cos(alpha)*sin(alpha)*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
					c12f(p1sq,p2sq,qsq,mbH,mf,mh)+c12f(p1sq,p2sq,qsq,mh,mf,mbH)&
				)&
				+lam_GGbH(mbH,alpha,lam_ps,lam_s,mu_s)*c12f(p1sq,p2sq,qsq,mz,mf,mz)&
			)&
			+lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2+mfp**2)/vev**2*c12f(p1sq,p2sq,qsq,mw,mfp,mw)&
			!
			-sin(alpha)*g**2/4.d0*mfp**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			-sin(alpha)*gz**2/8.d0*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function FbHff_A1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	FbHff_A1 =&
		-1.d0/(16.d0*pi**2)*(&
			-sin(alpha)*4.d0*gz**2*vf*af*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+sin(alpha)*2.d0*gz**4*vf*af*vev*(&
				c0f(p1sq,p2sq,qsq,mZ,mf,mZ)+c11f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			)&
			-sin(alpha)*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			+sin(alpha)*g**4/4.d0*vev*(&
				c0f(p1sq,p2sq,qsq,mW,mfp,mW)+c11f(p1sq,p2sq,qsq,mW,mfp,mW)&
			)&
			!
			+sin(alpha)*mfp**2*(mf**2-mfp**2)/vev**3*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			+lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2-mfp**2)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mw,mfp,mw)+c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
			)&
			+sin(alpha)*g**2*mfp**2/(4.d0*vev)*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+sin(alpha)*2.d0*gz**2*vf*af*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function FbHff_A2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	FbHff_A2 =&
		-1.d0/(16.d0*pi**2)*(&
			-sin(alpha)*4.d0*gz**2*vf*af*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+sin(alpha)*2.d0*gz**4*vf*af*vev*c12f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			-sin(alpha)*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			+sin(alpha)*g**4/4.d0*vev*c12f(p1sq,p2sq,qsq,mW,mfp,mW)&
			!
			+sin(alpha)*mfp**2*(mf**2-mfp**2)/vev**3*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			+lam_GpGmbH(mbH,alpha,lam_ps,lam_s,mu_s)*(mf**2-mfp**2)/vev**2*c12f(p1sq,p2sq,qsq,mw,mfp,mw)&
			!
			+sin(alpha)*g**2*mfp**2/(4.d0*vev)*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+sin(alpha)*2.d0*gz**2*vf*af*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
	complex (kind(0d0)) function FbHff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	FbHff_T =&
		-1.d0/(16.d0*pi**2)*(mf/vev)*(&
			sin(alpha)*mf**2/vev**2*(&
				cos(alpha)**2*(&
					c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf)&
				)&
				+sin(alpha)**2*(&
					c11f(p1sq,p2sq,qsq,mf,mbH,mf)-c12f(p1sq,p2sq,qsq,mf,mbH,mf)&
				)&
			)&
			-sin(alpha)*mf**2/vev**2*(&
				c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf)&
			)&
			-sin(alpha)*2.d0*mfp**2/vev**2*(&
				c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			+sin(alpha)*g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)-c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)-2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+sin(alpha)*gz**2/8.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)-c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)
 
	end function
!------------------------------------------------------------
	complex (kind(0d0)) function FbHff_PT(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: vf,af,qf,mfp

	if (mf == mt) then
		vf = vt; af = at; qf = qt
		mfp = mb
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb
		mfp = mt
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt
		mfp = ms
	elseif (mf == mtau .or. mf == mmu) then
		vf = ve; af = ae; qf = qe
		mfp = 0.d0
	endif

	FbHff_PT =&
		1.d0/(16.d0*pi**2)*(mf/vev)*sin(alpha)*(&
			g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)-c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-(c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)-2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW))&
			)&
			+2.d0*gz**2*af*vf*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)-c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-(c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ))&
			)&
		)
 
	end function
!========================================================
! Counter terms
!========================================================
	complex (kind(0d0)) function del_Th_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Th_F = -Pih_F(mbH,alpha) 

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_TbH_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_TbH_F = -PibH_F(mbH,alpha)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Ts_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Ts_F = cos(alpha)*del_TbH_F(mbH,alpha,lam_ps,lam_s,mu_s)-sin(alpha)*del_Th_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Tphi_F = sin(alpha)*del_TbH_F(mbH,alpha,lam_ps,lam_s,mu_s)+cos(alpha)*del_Th_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mhsq_F = Pihh_F(mh**2,mbH,alpha)+cos(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mbHsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mbHsq_F = PibHbH_F(mbH**2,mbH,alpha)+sin(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev 

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Zh_F = -dPihh_F(mh**2,mbH,alpha)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZbH_F = -dPibHbH_F(mbH**2,mbH,alpha)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_alpha_F =&
		1.d0/2.d0/(mbH**2-mh**2)*(&
			PibHh_F(mh**2,mbH,alpha)&
			+PibHh_F(mbH**2,mbH,alpha)&
			+2.d0*sin(alpha)*cos(alpha)/vev*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Ch_F = 1.d0/2.d0/(mbH**2-mh**2)*(PibHh_F(mh**2,mbH,alpha)-PibHh_F(mbH**2,mbH,alpha))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_vev_F =&
		vev/2.d0*(&
			PiWW_F(mw**2)/mw**2&
			+cw**2/sw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2)&
			-(PiGG_F(mz**2)/mZ**2+dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
			-2.d0*sw/cw*PiZG_F(0.d0)/mz**2-delta_alpha&
		)

	end function
!----------------------------------------------------(by Kikuchi 2023/08)
	complex (kind(0d0)) function del_M_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME

	del_M_F =&
		-1.d0/(16.d0*pi**2)*cos(alpha)*sin(alpha)**2*(&
			3.d0*(mt**2+mb**2+mc**2+ms**2)&
			+mtau**2+mmu**2&
		)*12.d0*lam_ps/vev*div

	if (SCHEME == 0) then
		del_M_F =&
			del_M_F&
			!====== differences between the standanrd tadpole and alternative tadpole schemes ======
			-24.d0*lam_s*sin(alpha)**3*(&
				cos(alpha)/mbH**2*PibH_F_div(mbH,alpha)&
				-sin(alpha)/mh**2*Pih_F_div(mbH,alpha)&
			)
	else if (SCHEME == 1) then
		return
	endif

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Mp_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME

	del_Mp_F =&
		sin(alpha)/(16.d0*pi**2)*(&
			3.d0*(mt**2+mb**2+mc**2+ms**2)&
			+mtau**2+mmu**2&
		)*2.d0*(1.d0+3.d0*cos(2.d0*alpha))*lam_ps/vev*div

	if (SCHEME == 0) then
		del_Mp_F =&
			del_Mp_F&
			!====== differences between the standanrd tadpole and alternative tadpole schemes ======
			+24.d0*lam_s*sin(alpha)**2*cos(alpha)*(&
				cos(alpha)/mbH**2*PibH_F_div(mbH,alpha)&
				-sin(alpha)/mh**2*Pih_F_div(mbH,alpha)&
			)
	else if (SCHEME == 1) then
		return
	endif

	end function
!----------------------------------------------------(by Kikuchi 2023/08)
	complex (kind(0d0)) function del_lam_hhh_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME

	del_lam_hhh_F =&
		9.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		+6.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		-3.d0*cos(alpha)**3/vev*del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		+3.d0*cos(alpha)/vev**2*(&
			mh**2*cos(alpha)**2-2.d0*sin(alpha)**2*vev**2*lam_ps&
		)*del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		+3.d0*cos(alpha)**2*sin(alpha)*(mh**2-mbH**2)/vev*del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_M_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)

	end function
!----------------------------------------------------(by Kikuchi 2023/08)
	complex (kind(0d0)) function del_lam_bHhh_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME

	del_lam_bHhh_F =&
		2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)&
			*(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0)&
		+(6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)+4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s))&
			*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		- 2.d0*cos(alpha)**2*sin(alpha)/vev*(&
			del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_mbHsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0&
		)&
		+ sin(alpha)/vev**2*(&
			(2.d0*mh**2+mbH**2)*cos(alpha)**2+vev**2*lam_ps*(1.d0 + 3.d0*cos(2.d0*alpha))&
		)*del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		+(mbH**2-mh**2)/(4.d0*vev)*(cos(3.d0*alpha)-5.d0*cos(alpha))*del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_Mp_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mWsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mWsq_F = PiWW_F(mw**2)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZW_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZW_F =&
		-delta_alpha-(PiGG_F(mz**2)/mZ**2+dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
	   +2.d0*cw/sw*PiZG_F(0.d0)/mz**2&
		+cw**2/sw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2) 

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_hWW_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_hWW_F =&
		2.d0*mW**2/vev*cos(alpha)*(&
			del_mWsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/mW**2 &
			+del_ZW_F(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)&
			-del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		)&
		+2.d0*mW**2/vev*sin(alpha)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mZsq_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mZsq_F = PiZZ_F(mz**2)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZZ_F =&
		-delta_alpha-(PiGG_F(mz**2)/mZ**2+dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
	   -2.d0*(cw**2-sw**2)/(cw*sw)*PiZG_F(0.d0)/mz**2&
		+(cw**2-sw**2)/cw**2*(cw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2))/sw**2

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_hZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_hZZ_F =&
		2.d0*mZ**2/vev*cos(alpha)*(&
			del_mZsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/mZ**2& 
			+del_ZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)& 
			-del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		)&
		+2.d0*mZ**2/vev*sin(alpha)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Th_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Th_B = -Pih_B(mbH,alpha,lam_ps,lam_s,mu_s) 

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_TbH_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_TbH_B = -PibH_B(mbH,alpha,lam_ps,lam_s,mu_s) 

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Ts_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Ts_B = cos(alpha)*del_TbH_B(mbH,alpha,lam_ps,lam_s,mu_s)-sin(alpha)*del_Th_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Tphi_B = sin(alpha)*del_TbH_B(mbH,alpha,lam_ps,lam_s,mu_s)+cos(alpha)*del_Th_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mhsq_B = Pihh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)+cos(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev 

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
	del_Zh_B = -dPihh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mbHsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
	del_mbHsq_B = PibHbH_B(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+sin(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev 

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZbH_B = -dPibHbH_B(mbh**2,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_alpha_B =&
		1.d0/2.d0/(mbH**2-mh**2)*(&
			PibHh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
      	+PibHh_B(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)&
      	+2.d0*sin(alpha)*cos(alpha)/vev*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_alpha_PT(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
	del_alpha_PT =&
		1.d0/2.d0/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)&
			+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_Ch_B =&
		1.d0/2.d0/(mbH**2-mh**2)*(&
			PibHh_B(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
			-PibHh_B(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
	del_vev_B  =&
		vev/2.d0*(&
			PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2&
			+cw**2/sw**2*(&
				PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2&
				-PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2&
			)&
			-dPiGG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)&
			-2.d0*sw/cw*PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_M_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME

	del_M_B =&
		-6.d0*sin(alpha)**2/16.d0/pi**2*(&
			-2.d0*cos(alpha)**3/vev**3*(2.d0*mW**4+mZ**4)&
			-3.d0/vev*lam_ps*cos(alpha)*(2.d0*mW**2+mZ**2)&
			+mh**2/4.d0/vev*lam_ps*(11.d0*cos(alpha)+cos(3.d0*alpha))&
			+mbH**2/vev*lam_ps*cos(alpha)*sin(alpha)**2&
			+4.d0*vev*lam_ps*(3.d0*lam_s+lam_ps)*cos(alpha)&
			-36.d0*mu_s*lam_s*sin(alpha)&
		)*div

	if (SCHEME == 0) then
		del_M_B =&
			del_M_B&
			!====== differences between the standanrd tadpole and alternative tadpole schemes ======
			-24.d0*lam_s*sin(alpha)**3*(&
				cos(alpha)/mbH**2*PibH_B_div(mbH,alpha,lam_ps,lam_s,mu_s)&
				-sin(alpha)/mh**2*Pih_B_div(mbH,alpha,lam_ps,lam_s,mu_s)&
			)
	else if (SCHEME == 1) then
		return
	endif

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_Mp_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME

	del_Mp_B =&
		sin(alpha)/(16.d0*pi**2)*(&
			-2.d0*cos(alpha)**2/vev**3*(2.d0*mw**4+mz**4)*(cos(2.d0*alpha)-3.d0)&
			-3.d0/vev*lam_ps*(2.d0*mw**2+mz**2)*(1.d0+3.d0*cos(2.d0*alpha))&
			+3.d0*mh**2/vev*lam_ps*cos(alpha)**2*(3.d0+cos(2.d0*alpha))&
			-6.d0*mbH**2/vev*lam_ps*sin(alpha)**4&
			+12.d0*vev*lam_s*lam_ps*(1.d0+3.d0*cos(2.d0*alpha))&
			+4.d0*lam_ps**2*vev*(1.d0 + 3.d0*cos(2.d0*alpha))&
			-216.d0*mu_s*lam_s*cos(alpha)*sin(alpha)&
		)*div

	if (SCHEME == 0) then
		del_Mp_B =&
			del_Mp_B&
			!====== differences between the standanrd tadpole and alternative tadpole schemes ======
			+24.d0*lam_s*sin(alpha)**2*cos(alpha)*(&
				cos(alpha)/mbH**2*PibH_B_div(mbH,alpha,lam_ps,lam_s,mu_s)&
				-sin(alpha)/mh**2*Pih_B_div(mbH,alpha,lam_ps,lam_s,mu_s)&
			)
	else if (SCHEME == 1) then
		return
	endif

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_lam_hhh_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME 

	del_lam_hhh_B =&
		9.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		+6.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		-3.d0*cos(alpha)**3/vev*del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		+3.d0*cos(alpha)/vev**2*(&
			mh**2*cos(alpha)**2 -2.d0*sin(alpha)**2*vev**2*lam_ps&
		)*del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		+3.d0*cos(alpha)**2*sin(alpha)*(mh**2-mbH**2)/vev*del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_M_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)

	end function
!----------------------------------------------------(by Kikuchi 2023/08)
	complex (kind(0d0)) function del_lam_bHhh_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: SCHEME

	del_lam_bHhh_B =&
		2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*(&
			del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0&
		)&
		+(6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)+4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s))&
			*del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		- 2.d0*cos(alpha)**2*sin(alpha)/vev*(&
			del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s)+del_mbHsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0&
		)&
		+sin(alpha)/vev**2*(&
			(2.d0*mh**2+mbH**2)*cos(alpha)**2&
			+vev**2*lam_ps*(1.d0+3.d0*cos(2.d0*alpha))&
		)*del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		+(mbH**2-mh**2)/(4.d0*vev)*(cos(3.d0*alpha)-5.d0*cos(alpha))*del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_Mp_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mWsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mWsq_B = PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZW_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZW_B =&
	   -(dPiGG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-dPiGG_pinch(0.d0))&
	   +2.d0*cw/sw*(PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(0.d0))/mz**2&
		+cw**2/sw**2*(&
			PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2&
			-PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function  del_mZsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mZsq_B = PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZZ_B =&
		-(dPiGG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-dPiGG_pinch(0.d0))&
		+2.d0*(cw**2-sw**2)/(cw*sw)*(PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(0.d0))/mz**2&
		+(cw**2-sw**2)/cw**2*(&
			cw**2*(&
				PiZZ_B(mz**2,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2&
				-PiWW_B(mw**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2&
			)&
		)/sw**2

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_hWW_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_hWW_B =&
		2.d0*mW**2/vev*cos(alpha)*(&
			del_mWsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/mW**2&
			+ del_ZW_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			-del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		)&
		+2.d0*mW**2/vev*sin(alpha)*del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_hZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_hZZ_B =&
		2.d0*mZ**2/vev*cos(alpha)*(&
			del_mZsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/mZ**2&
			+del_ZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			-del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		)&
		+2.d0*mZ**2/vev*sin(alpha)*del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mb(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mb = mb*(Pibb_V(mb**2,mbh,alpha,lam_ps,lam_s,mu_s)+Pibb_S(mb**2,mbh,alpha,lam_ps,lam_s,mu_s))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZVb(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZVb =&
		-Pibb_V(mb**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		-2.d0*mb**2*(&
			dPibb_V(mb**2,mbh,alpha,lam_ps,lam_s,mu_s)&
			+dPibb_S(mb**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_hbb(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_hbb =&
		-mb/vev*cos(alpha)*(&
			del_mb(mbH,alpha,lam_ps,lam_s,mu_s)/mb&
			-(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
			+del_ZVb(mbH,alpha,lam_ps,lam_s,mu_s)&
			+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0&
			+tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mtau(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mtau = mtau*(Pitautau_V(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s)+Pitautau_S(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZVtau(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZVtau =&
		-Pitautau_V(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		-2.d0*mtau**2*(&
			dPitautau_V(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s)&
			+dPitautau_S(mtau**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_htautau(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_htautau =&
		-mtau/vev*cos(alpha)*(&
			del_mtau(mbH,alpha,lam_ps,lam_s,mu_s)/mtau&
			-(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
			+del_ZVtau(mbH,alpha,lam_ps,lam_s,mu_s)&
			+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0 &
			+tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mmu(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mmu = mmu*(Pimumu_V(mmu**2,mbh,alpha,lam_ps,lam_s,mu_s)+Pimumu_S(mmu**2,mbh,alpha,lam_ps,lam_s,mu_s))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZVmu(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZVmu =&
		-Pimumu_V(mmu**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		-2.d0*mmu**2*(&
			dPimumu_V(mmu**2,mbh,alpha,lam_ps,lam_s,mu_s)+dPimumu_S(mmu**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_hmumu(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_hmumu =&
		-mmu/vev*cos(alpha)*(&
			del_mmu(mbH,alpha,lam_ps,lam_s,mu_s)/mmu&
			-(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
			+del_ZVmu(mbH,alpha,lam_ps,lam_s,mu_s)&
			+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0&
			+tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mt(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mt = mt*(Pitt_V(mt**2,mbh,alpha,lam_ps,lam_s,mu_s)+Pitt_S(mt**2,mbh,alpha,lam_ps,lam_s,mu_s))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZVt(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZVt =&
		-Pitt_V(mt**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		-2.d0*mt**2*(&
			dPitt_V(mt**2,mbh,alpha,lam_ps,lam_s,mu_s)+dPitt_S(mt**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_htt(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_htt =&
		-mt/vev*cos(alpha)*(&
			del_mt(mbH,alpha,lam_ps,lam_s,mu_s)/mt&
			-(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
			+del_ZVt(mbH,alpha,lam_ps,lam_s,mu_s)&
			+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0&
			+tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_mc(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_mc = mc*(Picc_V(mc**2,mbh,alpha,lam_ps,lam_s,mu_s)+Picc_S(mc**2,mbh,alpha,lam_ps,lam_s,mu_s))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_ZVc(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZVc =&
		-Picc_V(mc**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		-2.d0*mc**2*(&
			dPicc_V(mc**2,mbh,alpha,lam_ps,lam_s,mu_s)+dPicc_S(mc**2,mbh,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_hcc(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_hcc =&
		-mc/vev*cos(alpha)*(&
			del_mc(mbH,alpha,lam_ps,lam_s,mu_s)/mc&
			-(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
			+del_ZVc(mbH,alpha,lam_ps,lam_s,mu_s)&
			+(del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0&
			+tan(alpha)*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
		)

	end function
!========================================================
!  Counterterms for bH decay !MA added
!========================================================
	complex (kind(0d0)) function del_bHWW_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_bHWW_F =&
		2.d0*mW**2/vev*sin(alpha)*(&
			del_mWsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/mW**2&
			-del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
			+del_ZW_F(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		+2.d0*mW**2/vev*cos(alpha)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	 complex (kind(0d0)) function del_bHWW_B(mbH,alpha,lam_ps,lam_s,mu_s)
	 double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
	del_bHWW_B =&
		2.d0*mW**2/vev*sin(alpha)*(&
			del_mWsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/mW**2&
			-del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
			+del_ZW_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		+2.d0*mW**2/vev*cos(alpha)*(&
			del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			!........ Terms for gauge invariance  ................
			+del_alpha_PT(mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_bHZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_bHZZ_F =&
		2.d0*mZ**2/vev*sin(alpha)*(&
			del_mZsq_F(mbH,alpha,lam_ps,lam_s,mu_s)/mZ**2&
			-del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
			+del_ZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		+2.d0*mZ**2/vev*cos(alpha)*del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_bHZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
 
	del_bHZZ_B =&
		2.d0*mZ**2/vev*sin(alpha)*(&
			del_mZsq_B(mbH,alpha,lam_ps,lam_s,mu_s)/mZ**2&
			-del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
			+del_ZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			+1.d0/2.d0*del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		+2.d0*mZ**2/vev*cos(alpha)*(&
			del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			!........ Terms for gauge invariance  ................
			+del_alpha_PT(mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!----------------------------------------------------
	complex (kind(0d0)) function del_bHff(mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mf
	complex (kind(0d0)):: del_mf,del_ZVf

	if (mf == mt) then
		del_mf  = del_mt(mbH,alpha,lam_ps,lam_s,mu_s)
		del_ZVf = del_ZVt(mbH,alpha,lam_ps,lam_s,mu_s)
	elseif (mf == mb) then
		del_mf  = del_mb(mbH,alpha,lam_ps,lam_s,mu_s)
		del_ZVf = del_ZVb(mbH,alpha,lam_ps,lam_s,mu_s)
	elseif (mf == mc) then
		del_mf  = del_mc(mbH,alpha,lam_ps,lam_s,mu_s)
		del_ZVf = del_ZVc(mbH,alpha,lam_ps,lam_s,mu_s)
	elseif (mf == mtau) then
		del_mf  = del_mtau(mbH,alpha,lam_ps,lam_s,mu_s)
		del_ZVf = del_ZVtau(mbH,alpha,lam_ps,lam_s,mu_s)
	elseif (mf == mmu) then
		del_mf  = del_mmu(mbH,alpha,lam_ps,lam_s,mu_s)
		del_ZVf = del_ZVmu(mbH,alpha,lam_ps,lam_s,mu_s)	
	endif

	del_bHff =&
		-mf/vev*sin(alpha)*(&
			del_mf/mf&
			-(del_vev_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_vev_B(mbH,alpha,lam_ps,lam_s,mu_s))/vev&
			+del_ZVf&
			+(del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s))/2.d0&
		)&
		-mf/vev*cos(alpha)*(&
			del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			!........ Terms for gauge invariance  ................
			+del_alpha_PT(mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!========================================================
! Renormalized 2-point functions
!========================================================
	complex (kind(0d0)) function hat_Pihh(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	hat_Pihh =&
		Pihh_F(qsq,mbH,alpha)+cos(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		+Pihh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)+cos(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		+(qsq-mh**2)*(&
			del_Zh_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Zh_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		- del_mhsq_F(mbH,alpha,lam_ps,lam_s,mu_s)-del_mhsq_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!--------------------------------------------------------------------
	complex (kind(0d0)) function hat_PibHbH(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	hat_PibHbH =&
		PibHbH_F(qsq,mbH,alpha)+sin(alpha)**2*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		+PibHbH_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)+sin(alpha)**2*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		+ (qsq-mbH**2)*(&
			del_ZbH_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZbH_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		-del_mbHsq_F(mbH,alpha,lam_ps,lam_s,mu_s)-del_mbHsq_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!--------------------------------------------------------------------
	complex (kind(0d0)) function hat_PibHh(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	hat_PibHh =&
		PibHh_F(qsq,mbH,alpha)+sin(alpha)*cos(alpha)*del_Tphi_F(mbH,alpha,lam_ps,lam_s,mu_s)/vev& 
		+PibHh_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)+sin(alpha)*cos(alpha)*del_Tphi_B(mbH,alpha,lam_ps,lam_s,mu_s)/vev&
		+2.d0*qsq*(del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s))&
		+mh**2*(&
			del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			-del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)-del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		-mbH**2*(&
			del_alpha_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_alpha_B(mbH,alpha,lam_ps,lam_s,mu_s)&
			+del_Ch_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_Ch_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!========================================================
! Renormalized hWW coupling
!========================================================
	complex (kind(0d0)) function Gam1_hWW_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_hWW_loop =&
		Gam1_hWW_F(p1sq,p2sq,qsq,mbH,alpha)+del_hWW_F(mbH,alpha,lam_ps,lam_s,mu_s)&
      +Gam1_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hWW_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		!........ Terms for gauge invariance  ................                              
		+2.d0*mW**2/vev*sin(alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam1_hWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam1_hWW = g**2/2.d0*vev*cos(alpha)+Gam1_hWW_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam2_hWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam2_hWW = Gam2_hWW_F(p1sq,p2sq,qsq,mbH,alpha)+Gam2_hWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam3_hWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam3_hWW = Gam3_hWW_F(p1sq,p2sq,qsq,mbH,alpha)

	end function
!========================================================
! Renormalized hZZ coupling
!========================================================
	complex (kind(0d0)) function Gam1_hZZ_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_hZZ_loop =&
		Gam1_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)+del_hZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)& 
      +Gam1_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		!........ Terms for gauge invariance  ................                              
      +2.d0*mZ**2/vev*sin(alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam1_hZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam1_hZZ = gz**2/2.d0*vev*cos(alpha)+Gam1_hZZ_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
	end function
!------------------------------------------
	complex (kind(0d0)) function rGam2_hZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam2_hZZ = Gam2_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)+Gam2_hZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam3_hZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam3_hZZ = Gam3_hZZ_F(p1sq,p2sq,qsq,mbH,alpha)

	end function
!========================================================
! Renormalized htt coupling
!========================================================
	complex (kind(0d0)) function Gam_htt_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_htt_loop =&
		Gam_htt(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_htt(mbH,alpha,lam_ps,lam_s,mu_s)&
		!........ Terms for gauge invariance  ................                              
		-mt/vev*sin(alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)
                                            
	end function
!------------------------------------------
	complex (kind(0d0)) function rGamS_htt(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGamS_htt = -mt/vev*cos(alpha)+Gam_htt_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
	end function
!========================================================
! Renormalized hbb coupling
!========================================================
	complex (kind(0d0)) function Gam_hbb_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_hbb_loop =&
		Gam_hbb(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hbb(mbH,alpha,lam_ps,lam_s,mu_s)&
		!........ Terms for gauge invariance  ................                              
		-mb/vev*sin(alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGamS_hbb(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGamS_hbb = -mb/vev*cos(alpha)+Gam_hbb_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
	end function
!========================================================
! Renormalized hcc coupling
!========================================================
	complex (kind(0d0)) function Gam_hcc_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_hcc_loop =&
		Gam_hcc(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_hcc(mbH,alpha,lam_ps,lam_s,mu_s)&
		!........ Terms for gauge invariance  ................                              
		-mc/vev*sin(alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGamS_hcc(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGamS_hcc = -mc/vev*cos(alpha)+Gam_hcc_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
	end function
!========================================================
! Renormalized htautau coupling
!========================================================
	complex (kind(0d0)) function Gam_htautau_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_htautau_loop =&
		Gam_htautau(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)+del_htautau(mbH,alpha,lam_ps,lam_s,mu_s)&
		!........ Terms for gauge invariance  ................
		-mtau/vev*sin(alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGamS_htautau(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGamS_htautau = -mtau/vev*cos(alpha)+Gam_htautau_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
	end function
!========================================================
! Renormalized hmumu coupling
!========================================================
	complex (kind(0d0)) function Gam_hmumu_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam_hmumu_loop =&
		Gam_hmumu(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_hmumu(mbH,alpha,lam_ps,lam_s,mu_s)&
		!........ Terms for gauge invariance  ................
		-mmu/vev*sin(alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGamS_hmumu(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGamS_hmumu = -mmu/vev*cos(alpha)+Gam_hmumu_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
                                            
	end function
!========================================================
!     Renormalized hhh coupling
!========================================================
	complex (kind(0d0)) function Gam_hhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r
	integer, intent(in):: SCHEME

	Gam_hhh_loop =&
		Gam_hhh_F(p1sq,p2sq,qsq,mbH,alpha)&
		+del_lam_hhh_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)&
		+Gam_hhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_lam_hhh_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)&
		!====== pinch term ======
		-3.d0*sin(alpha)*cos(alpha)**2/(2.d0*vev)*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)&
			+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		!----- Remove extra PT terms ----- (added by Kikuchi 2023/08)
		-6.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_alpha_PT(mbH,alpha,lam_ps,lam_s,mu_s)&
		!===== mu-dependent part =====
		-(del_M_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)+del_M_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME))*log(mu_r**2)

	if (SCHEME == 0) then
		Gam_hhh_loop =&
			Gam_hhh_loop&
			!====== differences between the standanrd tadpole and alternative tadpole schemes ======
			+24.d0*lam_s*sin(alpha)**3*(&
				cos(alpha)/mbH**2*(PibH_F(mbH,alpha)+PibH_B(mbH,alpha,lam_ps,lam_s,mu_s))&
				-sin(alpha)/mh**2*(Pih_F(mbH,alpha)+Pih_B(mbH,alpha,lam_ps,lam_s,mu_s))&
			)
	else if (SCHEME == 1) then
		return	
	endif

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam_hhh(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r
	integer, intent(in):: SCHEME

	rGam_hhh =&
		6.d0*lam_hhh(mbh,alpha,lam_ps,lam_s,mu_s)& 
		+Gam_hhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)

	end function
!========================================================
! Renormalized Hhh coupling
!========================================================
	complex (kind(0d0)) function Gam_bHhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r
	integer, intent(in):: SCHEME

	Gam_bHhh_loop =&
		Gam_bHhh_F(p1sq,p2sq,qsq,mbH,alpha)&
		+del_lam_bHhh_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)&
		+Gam_bHhh_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_lam_bHhh_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)&
		!====== pinch term ======
		+(cos(3.d0*alpha)-5.d0*cos(alpha))/8.d0/vev*(&
			PibHh_PT(mbH**2,mbH,alpha,lam_ps,lam_s,mu_s)&
			+PibHh_PT(mh**2,mbH,alpha,lam_ps,lam_s,mu_s)&
		)&
		!----- Remove extra PT terms ----- (added by Kikuchi 2023/08)
		+6.d0*lam_hhh(mbH,alpha,lam_ps,lam_s,mu_s)*del_alpha_PT(mbH,alpha,lam_ps,lam_s,mu_s)&
		-4.d0*lam_bHbHh(mbH,alpha,lam_ps,lam_s,mu_s)*del_alpha_PT(mbH,alpha,lam_ps,lam_s,mu_s)&
		!===== mu-dependent part =====
		-(del_Mp_F(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME)+del_Mp_B(mbH,alpha,lam_ps,lam_s,mu_s,SCHEME))*log(mu_r**2)

	if (SCHEME == 0) then
		Gam_bHhh_loop =&
			Gam_bHhh_loop&
			!====== differences between the standanrd tadpole and alternative tadpole schemes ======
			-24.d0*lam_s*sin(alpha)**2*cos(alpha)*(&
				cos(alpha)/mbH**2*(PibH_F(mbH,alpha)+PibH_B(mbH,alpha,lam_ps,lam_s,mu_s))&
				-sin(alpha)/mh**2*(Pih_F(mbH,alpha)+Pih_B(mbH,alpha,lam_ps,lam_s,mu_s))&
			)
	else if (SCHEME == 1) then
		return
	endif

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam_bHhh(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r
	integer, intent(in):: SCHEME

	rGam_bhhh =&
		2.d0*lam_bhhh(mbh,alpha,lam_ps,lam_s,mu_s)&
		+Gam_bhhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)

	end function
!========================================================
! Renormalized bHWW coupling
!========================================================
	complex (kind(0d0)) function Gam1_bHWW_loop_F(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHWW_loop_F =&
		Gam1_bHWW_F(p1sq,p2sq,qsq,mbH,alpha)&
		+del_bHWW_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_loop_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHWW_loop_B =&
		Gam1_bHWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_bHWW_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHWW_loop =&
		Gam1_bHWW_loop_F(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
		+Gam1_bHWW_loop_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam1_bHWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam1_bHWW =&
		2.d0*mW**2/vev*sin(alpha)&
		+Gam1_bHWW_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam2_bHWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam2_bHWW =&
		Gam2_bHWW_F(p1sq,p2sq,qsq,mbH,alpha)&
		+Gam2_bHWW_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam3_bHWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam3_bHWW = Gam3_bHWW_F(p1sq,p2sq,qsq,mbH,alpha)

	end function
!========================================================
! Renormalized bHZZ coupling
!========================================================
	complex (kind(0d0)) function Gam1_bHZZ_loop_F(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHZZ_loop_F =&
		Gam1_bHZZ_F(p1sq,p2sq,qsq,mbH,alpha)&
		+del_bHZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_loop_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHZZ_loop_B =&
		Gam1_bHZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
		+del_bHZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	Gam1_bHZZ_loop =&
		Gam1_bHZZ_loop_F(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
		+Gam1_bHZZ_loop_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam1_bHZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam1_bHZZ =&
		2.d0*mZ**2/vev*sin(alpha)&
		+Gam1_bHZZ_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam2_bHZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam2_bHZZ =&
		Gam2_bHZZ_F(p1sq,p2sq,qsq,mbH,alpha)&
		+Gam2_bHZZ_B(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------
	complex (kind(0d0)) function rGam3_bHZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rGam3_bHZZ = Gam3_bHZZ_F(p1sq,p2sq,qsq,mbH,alpha)

	end function
!========================================================
! Renormalized hff coupling
!========================================================
	complex (kind(0d0)) function Gam_bHff_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf

	Gam_bHff_loop =&
		Gam_bHff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
		+del_bHff(mbH,alpha,lam_ps,lam_s,mu_s,mf)
													  
	end function
!------------------------------------------
	complex (kind(0d0)) function rGamS_bHff(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf

	rGamS_bHff =&
		-mf/vev*sin(alpha)&
		+Gam_bHff_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)

	end function
!========================================================
! Loop induced decay rates
!========================================================
	double precision function decay_hgamgam(mbH,alpha,lam_ps,lam_s,mu_s,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: ORQCD

	decay_hgamgam = cos(alpha)**2*decay_hgamgam_sm(mh,ORQCD)

	end function
!----------------------------------------------------------------
	double precision function decay_hZgam(mbH,alpha,lam_ps,lam_s,mu_s,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: ORQCD

	decay_hZgam = cos(alpha)**2*decay_hZgam_sm(mh,ORQCD)

	end function
!----------------------------------------------------------------
	double precision  function decay_hgg(mbH,alpha,lam_ps,lam_s,mu_s,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: ORQCD

	decay_hgg = cos(alpha)**2*decay_hgg_sm(mh,ORQCD)

	end function
!========================================================
!  RGE
!========================================================
!--------- g1 ------------------
	double precision function g1(t0,t)
	double precision, intent(in):: t0,t
	double precision c1

	c1 = 20.d0/9.d0*ng+1.d0/6.d0*nh
	g1 = gp/sqrt(1.d0-2.d0*c1*gp**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g2 ------------------
	double precision function g2(t0,t)
	double precision, intent(in):: t0,t
	double precision c2

	c2 = (-22.d0/3.d0+4.d0/3.d0*ng+1.d0/6.d0*nh)
	g2 = g/sqrt(1.d0-2.d0*c2*g**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g3 ------------------
	double precision function g3(t0,t)
	double precision, intent(in):: t0,t
	double precision c3

	c3 = (-11.d0+4.d0/3.d0*ng)
	g3 = gs/sqrt(1.d0-2.d0*c3*gs**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- beta(lam) ------------------
	double precision function beta_lam(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

	beta_lam =&
		1.d0/(16.d0*pi**2)*(&
			24.d0*lam**2&
			+2.d0*lamPS**2&
			-6.d0*yt**4&
			+9.d0/8.d0*g2(t0,t)**4&
			+3.d0/8.d0*g1(t0,t)**4&
			+3.d0/4.d0*g1(t0,t)**2*g2(t0,t)**2&
			-3.d0*lam*(3.d0*g2(t0,t)**2+g1(t0,t)**2-4.d0*yt**2)&
		)

	end function
!--------- beta(lamPS) ------------------
	double precision function beta_lamPS(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

	beta_lamPS =&
		1.d0/(16.d0*pi**2)*(&
			12.d0*lam*lamPS&
			+8.d0*lamPS**2&
			+24.d0*lamPS*lamS&
			-lamPS*(9.d0/2.d0*g2(t0,t)**2+3.d0/2.d0*g1(t0,t)**2-6.d0*yt**2)&
		)

	end function
!--------- beta(lamS) ------------------
	double precision function beta_lamS(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

	beta_lamS = 1.d0/(16.d0*pi**2)*(2.d0*lamPS**2+72.d0*lamS**2)

	end function
!--------- beta(yt) ------------------
	double precision function beta_yt(t0,t,lam,lamPS,lamS,yt)
	double precision, intent(in)::  t0,t,lam,lamPS,lamS,yt

	beta_yt =&
		1.d0/(16.d0*pi**2)*(&
			+9.d0/2.d0*yt**3&
			-yt*(8.d0*g3(t0,t)**2+9.d0/4.d0*g2(t0,t)**2+17.d0/12.d0*g1(t0,t)**2)&
		)

	end function
!================= SUBROUTINE ==================
	subroutine RGE(t0,h,t,vlam,vlamPS,vlamS,vyt)
	double precision:: rk_lam(4),rk_lamPS(4),rk_lamS(4),rk_yt(4) 
	double precision, intent(in):: t0,t,h
	double precision ::  vlam,vlamPS,vlamS,vyt

	!--------------- STEP 1 ----------------------------------------------------------------------------------
	rk_lam(1)   = beta_lam  (t0,t,vlam,vlamPS,vlamS,vyt)
	rk_lamPS(1) = beta_lamPS(t0,t,vlam,vlamPS,vlamS,vyt)
	rk_lamS(1)  = beta_lamS (t0,t,vlam,vlamPS,vlamS,vyt)
	rk_yt(1)    = beta_yt   (t0,t,vlam,vlamPS,vlamS,vyt)
	!--------------- STEP 2 ----------------------------------------------------------------------------------
	rk_lam(2)   = beta_lam  (t0,t+h/2.d0,vlam+h*rk_lam(1)/2.d0,vlamPS+h*rk_lamPS(1)/2.d0,vlamS+h*rk_lamS(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
	rk_lamPS(2) = beta_lamPS(t0,t+h/2.d0,vlam+h*rk_lam(1)/2.d0,vlamPS+h*rk_lamPS(1)/2.d0,vlamS+h*rk_lamS(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
	rk_lamS(2)  = beta_lamS (t0,t+h/2.d0,vlam+h*rk_lam(1)/2.d0,vlamPS+h*rk_lamPS(1)/2.d0,vlamS+h*rk_lamS(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
	rk_yt(2)    = beta_yt   (t0,t+h/2.d0,vlam+h*rk_lam(1)/2.d0,vlamPS+h*rk_lamPS(1)/2.d0,vlamS+h*rk_lamS(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
	!--------------- STEP 3 ----------------------------------------------------------------------------------
	rk_lam(3)   = beta_lam  (t0,t+h/2.d0,vlam+h*rk_lam(2)/2.d0,vlamPS+h*rk_lamPS(2)/2.d0,vlamS+h*rk_lamS(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
	rk_lamPS(3) = beta_lamPS(t0,t+h/2.d0,vlam+h*rk_lam(2)/2.d0,vlamPS+h*rk_lamPS(2)/2.d0,vlamS+h*rk_lamS(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
	rk_lamS(3)  = beta_lamS (t0,t+h/2.d0,vlam+h*rk_lam(2)/2.d0,vlamPS+h*rk_lamPS(2)/2.d0,vlamS+h*rk_lamS(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
	rk_yt(3)    = beta_yt   (t0,t+h/2.d0,vlam+h*rk_lam(2)/2.d0,vlamPS+h*rk_lamPS(2)/2.d0,vlamS+h*rk_lamS(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
	!--------------- STEP 4 ----------------------------------------------------------------------------------
	rk_lam(4)   = beta_lam  (t0,t+h,vlam+h*rk_lam(3),vlamPS+h*rk_lamPS(3),vlamS+h*rk_lamS(3),vyt+h*rk_yt(3))
	rk_lamPS(4) = beta_lamPS(t0,t+h,vlam+h*rk_lam(3),vlamPS+h*rk_lamPS(3),vlamS+h*rk_lamS(3),vyt+h*rk_yt(3))
	rk_lamS(4)  = beta_lamS (t0,t+h,vlam+h*rk_lam(3),vlamPS+h*rk_lamPS(3),vlamS+h*rk_lamS(3),vyt+h*rk_yt(3))
	rk_yt(4)    = beta_yt   (t0,t+h,vlam+h*rk_lam(3),vlamPS+h*rk_lamPS(3),vlamS+h*rk_lamS(3),vyt+h*rk_yt(3))
	!--------------- SUM ----------------------------------------------------------------------------------
	vlam   = vlam   + h/6.d0*(rk_lam(1)   +2.d0*rk_lam(2)   +2.d0*rk_lam(3)   + rk_lam(4))
	vlamPS = vlamPS + h/6.d0*(rk_lamPS(1) +2.d0*rk_lamPS(2) +2.d0*rk_lamPS(3) + rk_lamPS(4))
	vlamS  = vlamS  + h/6.d0*(rk_lamS(1)  +2.d0*rk_lamS(2)  +2.d0*rk_lamS(3)  + rk_lamS(4))
	vyt    = vyt    + h/6.d0*(rk_yt(1)    +2.d0*rk_yt(2)    +2.d0*rk_yt(3)    + rk_yt(4)  )

	end subroutine
!-----------------------------------------------------------------------------------------
	subroutine RGE_sm(t0,h,t,vlam,vyt)
	double precision:: rk_lam(4),rk_lamPS(4),rk_lamS(4),rk_yt(4) 
	double precision, intent(in):: t0,t,h
	double precision ::  vlam,vlamPS,vlamS,vyt

	!--------------- STEP 1 ----------------------------------------------------------------------------------
	rk_lam(1) = beta_lam(t0,t,vlam,0.d0,0.d0,vyt)
	rk_yt(1)  = beta_yt (t0,t,vlam,0.d0,0.d0,vyt)
	!--------------- STEP 2 ----------------------------------------------------------------------------------
	rk_lam(2) = beta_lam(t0,t+h/2.d0,vlam+h*rk_lam(1)/2.d0,0.d0,0.d0,vyt+h*rk_yt(1)/2.d0)
	rk_yt(2)  = beta_yt (t0,t+h/2.d0,vlam+h*rk_lam(1)/2.d0,0.d0,0.d0,vyt+h*rk_yt(1)/2.d0)
	!--------------- STEP 3 ----------------------------------------------------------------------------------
	rk_lam(3) = beta_lam(t0,t+h/2.d0,vlam+h*rk_lam(2)/2.d0,0.d0,0.d0,vyt+h*rk_yt(2)/2.d0)
	rk_yt(3)  = beta_yt (t0,t+h/2.d0,vlam+h*rk_lam(2)/2.d0,0.d0,0.d0,vyt+h*rk_yt(2)/2.d0)
	!--------------- STEP 4 ----------------------------------------------------------------------------------
	rk_lam(4) = beta_lam(t0,t+h,vlam+h*rk_lam(3),0.d0,0.d0,vyt+h*rk_yt(3))
	rk_yt(4)  = beta_yt (t0,t+h,vlam+h*rk_lam(3),0.d0,0.d0,vyt+h*rk_yt(3))
	!--------------- SUM ----------------------------------------------------------------------------------
	vlam = vlam + h/6.d0*(rk_lam(1) +2.d0*rk_lam(2) +2.d0*rk_lam(3) +rk_lam(4))
	vyt  = vyt  + h/6.d0*(rk_yt(1)  +2.d0*rk_yt(2)  +2.d0*rk_yt(3)  +rk_yt(4) )

	end subroutine
!#########################################################
!#
!#    Decay of the lighter CP even scalar: h
!#
!#########################################################
!======================================================
!     Partial decay width (Fermionic decay)
!======================================================
	double precision function decay_hbb(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,CF,mu,y_hbb,rmb
	p1sq=mb**2; p2sq=mb**2; qsq=mh**2
	CF = 4.d0/3.d0; mu = mh
	rmb = mq_bar(mu,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD5,mb_MS,5.d0),mb_MS) 
	y_hbb = (-mb/vev*cos(alpha))

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_hbb=&
		3.d0*mh/8.d0/pi*(1.d0-4.d0*mb**2/mh**2)**(3.d0/2.d0)*&
		((mb+S_RMSM*(rmb-mb))/vev*cos(alpha))**2&
		*(&
			! LO
			1.d0&
			! NLO Weak correction
			+(-Del_r(mbH,alpha,lam_ps,lam_s,mu_s)&
			+(1.d0/y_hbb)*2.d0*real(&
				Gam_hbb_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
				+mb*(Fhff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb)&
					-Fhff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb))&
				+mh**2*(1.d0-mb**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mb)&
			))*S_NLOEW&
			! NLO QED correction
			! +alpha_em/pi*Qb**2*(17.d0/4.d0&
			! 	+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
			! 	+9.d0/4.d0*log(mu**2/mh**2)**2)*S_NLOEW&
			! NLO QCD correction
			+alphas(lam_QCD5,mh,5.d0)/pi*CF*(17.d0/4.d0&
				+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
				+9.d0/4.d0*log(mu**2/mh**2)**2 )*S_NLOQCD&
			! NNLO QCD correction
			+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
			+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
            +1.d0/9.d0*(log(rmb**2/mh**2))**2)*S_NNLOQCD&
         )&
		+3.d0*((mb+S_RMSM*(rmb-mb))**2/mb**2)*cos(alpha)**2*decay_h_ffgam_sm(mb)*S_NLOEW

	end function
!-----------------------------------------------
	double precision function decay_hcc(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,CF,mu,y_hcc,rmc
	p1sq=mc**2; p2sq=mc**2; qsq=mh**2
	CF = 4.d0/3.d0; mu = mh
	rmc = mq_bar(mu,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD4,mc_MS,4.d0),mc_MS) 
	y_hcc = (-mc/vev*cos(alpha))
	
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_hcc=&
		3.d0*mh/8.d0/pi*(1.d0-4.d0*mc**2/mh**2)**(3.d0/2.d0)*&
		((mc+S_RMSM*(rmc-mc))/vev*cos(alpha))**2&
		*(&
			! LO
			1.d0&
			! NLO Weak correction
			+(&
				-Del_r(mbH,alpha,lam_ps,lam_s,mu_s)&
				+2.d0*(1.d0/y_hcc)*real(&
					Gam_hcc_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
					+mc*(Fhff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc)&
								-Fhff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc) )&
					+mh**2*(1.d0-mc**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mc)&
				)&
			)*S_NLOEW&
			! ! NLO QED correction
			! +alpha_em/pi*Qt**2*(&
			! 	17.d0/4.d0&
			! 	+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
			! 	+9.d0/4.d0*log(mu**2/mh**2)**2&
			! )*S_NLOEW&
			!NLO QCD correction
			+alphas(lam_QCD5,mh,5.d0)/pi*CF*(&
				17.d0/4.d0&
				+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
				+9.d0/4.d0*log(mu**2/mh**2)**2&
			)*S_NLOQCD&
			!NNLO QCD correction
			+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
			+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(&
				1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
            +1.d0/9.d0*(log(rmc**2/mh**2))**2&
			)*S_NNLOQCD&
		)&
		+3.d0*((mc+S_RMSM*(rmc-mc))**2/mc**2)*cos(alpha)**2*decay_h_ffgam_sm(mc)*S_NLOEW

	end function
!-----------------------------------------------
	double precision function decay_htautau(mbH,alpha,lam_ps,lam_s,mu_s,OREW)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW
	doubleprecision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,y_htautau
	p1sq=mtau**2; p2sq=mtau**2; qsq=mh**2
	y_htautau = (-mtau/vev*cos(alpha))
	call Switch_HOEW(OREW,S_NLOEW)
 
	decay_htautau=&
		mh/8.d0/pi*(1.d0-4.d0*mtau**2/mh**2)**(3.d0/2.d0)*&
		y_htautau**2*(&
			! LO
			1.d0&
			! NLO EW correction
         +(&
				-Del_r(mbH,alpha,lam_ps,lam_s,mu_s)&
				+2.d0*(1.d0/y_htautau)*real(&
					Gam_htautau_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
	            +mtau*Fhff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau)&
					-mtau*Fhff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau)&
         	   +mh**2*(1.d0-mtau**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mtau)&
				)&
			)*S_NLOEW&
			! ! NLO QED correction
			! +Del_QED_hff(mtau)*S_NLOEW&
		)&
		+cos(alpha)**2*decay_h_ffgam_sm(mtau)*S_NLOEW
	
	end function
!-----------------------------------------------
	double precision function decay_hmumu(mbH,alpha,lam_ps,lam_s,mu_s,OREW)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW
	doubleprecision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,y_hmumu
	p1sq=mmu**2; p2sq=mmu**2; qsq=mh**2
	y_hmumu = (-mmu/vev*cos(alpha))
	call Switch_HOEW(OREW,S_NLOEW)
 
	decay_hmumu=&
		mh/8.d0/pi*(1.d0-4.d0*mmu**2/mh**2)**(3.d0/2.d0)*&
		y_hmumu**2*(&
			! LO
			1.d0&
			! NLO EW correction
         +(&
				-Del_r(mbH,alpha,lam_ps,lam_s,mu_s)&
				+2.d0*(1.d0/y_hmumu)*real(&
					Gam_hmumu_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s)&
					+mmu*Fhff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu)&
					-mmu*Fhff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu)&
					+mh**2*(1.d0-mmu**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mmu)&
				)&
			)*S_NLOEW&
			! NLO QED correction
			! +Del_QED_hff(mmu)*S_NLOEW&  
		)&
		+cos(alpha)**2*decay_h_ffgam_sm(mmu)*S_NLOEW

	end function
!======================================================
!     Partial decay width (Bosonic decay)
!======================================================
!-------- hZgam hgamgam vertex function at the 1-loop level --------------
	complex (kind(0d0)) function rGam1_hZgam(p1sq,p2sq,qsq,alpha)
	double precision, intent(in):: qsq,p1sq,p2sq,alpha

	rGam1_hZgam=&
		cos(alpha)*(rGam1_hZgam_F_SM(p1sq,p2sq,qsq)+rGam1_hZgam_W_SM(p1sq,p2sq,qsq))

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam2_hZgam(p1sq,p2sq,qsq,alpha)
	double precision, intent(in):: qsq,p1sq,p2sq,alpha

	rGam2_hZgam=&
		cos(alpha)*(rGam2_hZgam_F_SM(p1sq,p2sq,qsq)+rGam2_hZgam_W_SM(p1sq,p2sq,qsq))

	end function
!------------------ dGamma( h-->Zff )/dqsq  at NLO ------------------                                                                                    
	double precision function dGam_dqsq_hZZ_NLO(qsq,vf,af,Iff,Qf,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,vf,af,Iff,Qf
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: epsZ,epsQ,x1,x2,ckin_a,ckin_b,s24,s23

	epsZ=mZ**2/mh**2
	epsQ=qsq/mh**2
	x1=1.d0+epsZ-epsQ
	ckin_a=sqrt(x1**2-4.d0*epsZ)*((x1-6.d0*epsZ)**2+8.d0*epsZ*(1.d0-3.d0*epsZ))

	ckin_b=(x1**2-4.d0*epsZ)**(3.d0/2.d0)*(x1-2.d0*epsZ)*mh**2/2.d0
	! note: this calculation is not included contributuion from hff vertex corrections and box diagrams  

	dGam_dqsq_hZZ_NLO=&
		cos(alpha)**2*mh**3*gz**4/384.d0/pi**3*(vf**2+af**2)/(qsq-mz**2)**2*ckin_a*(&
			1.d0/2.d0&                                                                        ! Tree cont.
			-(Del_r(mbH,alpha,lam_ps,lam_s,mu_s))&                                            ! Delta_r
			-1.d0/2.d0*real(rdPiZZ(mZ**2,mbH,alpha,lam_ps,lam_s,mu_s))&                       ! dPiZZ 
			+1.d0/(cos(alpha)*2.d0*mZ**2/vev)*(&
				+real(Gam1_hZZ_loop(mZ**2,qsq,mh**2,mbH,alpha,lam_ps,lam_s,mu_s))&                  ! hZZ Gam1 NLO cont.
				+ckin_b/ckin_a*real(rGam2_hZZ(mZ**2,qsq,mh**2,mbH,alpha,lam_ps,lam_s,mu_s))/mZ**2&  !hZZ Gam2 NLO cont.
			)&
			-real(rPiZZ(qsq,mbH,alpha,lam_ps,lam_s,mu_s))/(qsq-mZ**2)&                          ! PiZZ cont. 
			+1.d0/(vf**2+af**2)*(&
				(qsq-mZ**2)/(qsq)*vf*Qf*cw*sw*(&
					1.d0/(cos(alpha)*2.d0*mZ**2/vev)*(&
						+real(rGam1_hZgam(mZ**2,qsq,mh**2,alpha))&                                 !hZGam Gam1  
						+ckin_b/ckin_a*real(rGam2_hZgam(mZ**2,qsq,mh**2,alpha))&                   !hZGam Gam2
					)&
					-real(rPiZG(qsq,mbH,alpha,lam_ps,lam_s,mu_s) )/(qsq-mZ**2)&                       ! PiZG cont. 
				)&
				-1.d0/(gz)*(&
					+vf*real(rGamV_Zff_loop_SM(qsq,vf,af,Iff))&                                 ! ZffV NLO cont. 
					-af*real(rGamA_Zff_loop_SM(qsq,vf,af,Iff))&                                  ! ZffA NLO cont.
				)&
			)&
		)

	end function
!dqsq ------------------------------------------------------------------    
	double precision function dGam_dqsq_hZnunu_NLOEW(qsq)
	double precision, intent(in):: qsq

	dGam_dqsq_hZnunu_NLOEW =&
		dGam_dqsq_hZZ_NLO(qsq,vnu,anu,It,0.d0,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------------------------------    
	double precision function dGam_dqsq_hZee_NLOEW(qsq)
	double precision, intent(in):: qsq

	dGam_dqsq_hZee_NLOEW =&
		dGam_dqsq_hZZ_NLO(qsq,ve,ae,Ie,Qe,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------------------------------    
	double precision function dGam_dqsq_hZuu_NLOEW(qsq)
	double precision, intent(in):: qsq

	dGam_dqsq_hZuu_NLOEW =&
		dGam_dqsq_hZZ_NLO(qsq,vt,at,It,Qt,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------------------------------    
	double precision function dGam_dqsq_hZdd_NLOEW(qsq)
	double precision, intent(in):: qsq

	dGam_dqsq_hZdd_NLOEW =&
		dGam_dqsq_hZZ_NLO(qsq,vb,ab,Ib,Qb,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------------------------------ 
	subroutine decay_hZZstar(vhZZstar,vhZnunu_TB,vhZee_TB,vhZuu_TB,vhZdd_TB,OREW,ORQCD,alpha)
	double precision, intent(out):: vhZZstar
	double precision, intent(in):: alpha,vhZnunu_TB,vhZee_TB,vhZuu_TB,vhZdd_TB
	integer, intent(in)::OREW,ORQCD
	double precision:: vhZnunu,vhZee,vhZuu,vhZdd,dummy
	double precision,parameter::epsi=0.0001d0,mm =0.1d0
	vhZZstar=0.d0
	vhZnunu=0.d0;vhZee=0.d0;vhZuu=0.d0;vhZdd=0.d0;dummy=0.d0

	![EW=NLO, QCD=NNLO,NLO,LO], ~~~~~~~~~~~~~~~
	if (OREW == 1 .and. ORQCD >=-1 .and. ORQCD<=2 ) then
		call romberg(vhZnunu,dGam_dqsq_hZnunu_NLOEW,0.d0+epsi,(mh-mZ)**2-epsi) ! h->Znunu 
		vhZnunu=vhZnunu + cos(alpha)**2*vhZnunu_TB

		call romberg(vhZee,dGam_dqsq_hZee_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)  !h->Zee 
		vhZee = vhZee+cos(alpha)**2*vhZee_TB

		call romberg(vhZuu,dGam_dqsq_hZuu_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi) ! h->Zuu
		vhZuu=vhZuu+cos(alpha)**2*vhZuu_TB

		call romberg(vhZdd,dGam_dqsq_hZdd_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)! h->Zdd
		vhZdd = vhZdd+ cos(alpha)**2*vhZdd_TB

		vhZZstar=3.d0*vhZnunu+3.d0*vhZee +6.d0*vhZuu+9.d0*vhZdd

	![EW=LO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	else if (OREW == 0 .and. ORQCD >=-1 .and. ORQCD <=2 ) then 
		call decay_hZZstar_sm(vhZZstar,dummy,dummy,dummy,dummy,OREW,ORQCD)
		vhZZstar = vhZZstar*cos(alpha)**2   
	else
		vhZZstar = 0.d0
	end if

	end subroutine
!------------------ dGamma( h-->Wffp )/dqsq  at NLO ------------------
	double precision function dGam_dqsq_hWW_NLO(qsq,mf,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mf,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: epsW,epsQ,x1,ckin_a,ckin_b
	epsW=mW**2/mh**2
	epsQ=qsq/mh**2
	x1=1.d0+epsW-epsQ
	ckin_a=sqrt(x1**2-4.d0*epsW)*((x1-6.d0*epsW)**2+8.d0*epsW*(1.d0-3.d0*epsW))
	ckin_b=(x1**2-4.d0*epsW)**(3.d0/2.d0)*(x1-2.d0*epsW)*mh**2/2.d0
	!note: this calculation is not included contributuion from hff vertex corrections and box diagrams and QED corrections

	dGam_dqsq_hWW_NLO =&
		cos(alpha)**2*mh**3*(2.d0*mW**2/vev)**2/384.d0/pi**3/vev**2/(qsq-mW**2)**2*ckin_a*(&
			1.d0/2.d0&                                                                              !Tree cont. 
			-(Del_r(mbH,alpha,lam_ps,lam_s,mu_s))&                                                  !Delta_r  
			-1.d0/2.d0*real(rdPiWW(mW**2,mbH,alpha,lam_ps,lam_s,mu_s))&                             !rdPiWW 
			+1.d0/(cos(alpha)*2.d0*mW**2/vev)*(&
				+real(Gam1_hWW_loop(mW**2,qsq,mh**2,mbH,alpha,lam_ps,lam_s,mu_s))&                   !hWW Gam1 NLO cont.    
				+ckin_b/ckin_a*real(rGam2_hWW(mW**2,qsq,mh**2,mbH,alpha,lam_ps,lam_s,mu_s))/mW**2&   !hWW Gam2 NLO cont.
			)&
			-real(rPiWW(qsq,mbH,alpha,lam_ps,lam_s,mu_s))/(qsq-mW**2)&                              ! PiWW cont.    
			-sqrt(2.d0)/g*real(rGam_Wffp_loop_SM(qsq,mf))&                                          ! Wff NLO cont.    
		)

	end function
!------------------ dGamma( h-->Wffp )/dqsqdcos  at NLO ------------------
	double precision function dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mf,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,cos_the,mf,mbH,alpha,lam_ps,lam_s,mu_s
	double precision:: epsW,epsQ,x1,x2,ckin1,ckin2,ckin3,s24,s23,vf,vfp,Qf,Qfp,af,afp
	! Be careful, if fermion masses digenerate, the bellow if sentence does not work.

	if (mf == mc) then
		vf = vt ; af = at ; Qf = Qt
		vfp = vb ; afp = ab ; Qfp = Qb
	elseif (mf == msir) then
		vf = vb ; af = ab ; Qf = Qb
		vfp  = vt ; afp  = at ; Qfp  = Qt
	elseif (mf == mtau) then
		vf = ve ; af = ae ; Qf = Qe
		vfp = vnu ; afp = anu ; Qfp = 0.d0
	elseif (mf == mmu) then
		vf = ve ; af = ae ; Qf = Qe
		vfp = vnu ; afp = anu ; Qfp = 0.d0
	endif

	epsW=mW**2/mh**2
	epsQ=qsq/mh**2
	x1=1.d0+epsW-epsQ
	x2=1.d0/2.d0*(2.d0-x1+sqrt(x1**2-4.d0*mW**2/mh**2)*cos_the)
	s24=mh**2*(1.d0-x2)
	s23=mh**2+mW**2-qsq-s24
	ckin1=4.d0*qsq+2.d0/mW**2*(s24*s23-mh**2*mW**2)
	ckin2=1.d0/mW**2*(s24*s23-mh**2*mW**2)*(mh**2-mW**2-qsq)
	ckin3=2.d0*qsq*(s24-s23)

	dGam_dqsqdcos_hWW_NLO =&
		1.d0/(256.d0*pi**3*mh)&
		*cos(alpha)**2*2.d0*g**2*(mW**2/vev)**2&
		*(1.d0/2.d0)*sqrt(x1**2-4.d0*epsW)/(qsq-mW**2)**2*ckin1*(&
			1.d0/2.d0&                                                                            ! Tree cont.
			-(Del_r(mbH,alpha,lam_ps,lam_s,mu_s) )&                                               ! Delta_r 
			-1.d0/2.d0*real(rdPiWW(mW**2,mbH,alpha,lam_ps,lam_s,mu_s) )&                          ! rdPiWW 
			+1.d0/(cos(alpha)*2.d0*mW**2/vev)*(&
				+real(Gam1_hWW_loop(mW**2,qsq,mh**2,mbH,alpha,lam_ps,lam_s,mu_s))&                 ! hWW Gam1 NLO cont.
				+ckin2/ckin1*real(rGam2_hWW(mW**2,qsq,mh**2,mbH,alpha,lam_ps,lam_s,mu_s))/mW**2&   ! hWW Gam2 NLO cont. 
				+ckin3/ckin1*real(rGam3_hWW(mW**2,qsq,mh**2,mbH,alpha,lam_ps,lam_s,mu_s))/mW**2)&  ! hWW Gam3 NLO cont. 
				-real(rPiWW(qsq,mbH,alpha,lam_ps,lam_s,mu_s) )/(qsq-mW**2)&                        ! PiWW cont.  
				-sqrt(2.d0)/g*real(rGam_Wffp_loop_SM(qsq,mf))&
				+(qsq-mW**2)*Thff_W_SM(vf,af,qsq,cos_the)&                                         ! hff NLO cont. 
				+(qsq-mW**2)*B_W_box(qsq,cos_the,mf)/ckin1&                                        ! Box NLO cont.
				!----- soft photon contriburion -----
				+1.d0/2.d0*Del_soft_Wffp(qsq,cos_the,mf,0.1d0)&                                    ! final valuables in the argument is delE 
		)

	end function
!dqsq ------------------------------------------------------------------
	double precision function dGam_dqsq_hWmunu_NLOEW(qsq)
	double precision, intent(in):: qsq

	dGam_dqsq_hWmunu_NLOEW =&
		dGam_dqsq_hWW_NLO(qsq,mmu,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------------------------------
	double precision function dGam_dqsq_hWcs_NLOEW(qsq)
	double precision, intent(in):: qsq

	dGam_dqsq_hWcs_NLOEW= &
		3.d0*dGam_dqsq_hWW_NLO(qsq,mc,mbH,alpha,lam_ps,lam_s,mu_s) ! 3 is color factor

	end function
!dqsqdcos ------------------------------------------------------------------ 
	double precision function dGam_dqsqdcos_hWmunu_NLO(qsq,cos_the)
	double precision, intent(in):: qsq,cos_the

	dGam_dqsqdcos_hWmunu_NLO= &
		dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mmu,mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!------------------------------------------------------------------ 
	subroutine decay_hWWstar(vhWWstar,vhWcs_TBSH,vhWmunu_TBSH,OREW,ORQCD,alpha)
	double precision, intent(out):: vhWWstar
	double precision, intent(in):: vhWcs_TBSH,vhWmunu_TBSH,alpha
	integer, intent(in)::OREW,ORQCD
	double precision:: vhWcs,vhWmunu,dummy
	double precision,parameter::epsi=0.0001d0,epsics=0.1d0
	!comment:if epsics = epsi,the cancellation of div parameter doesn't happen for h->Wcs
	vhWWstar=0.d0
	vhWcs=0.d0;vhWmunu=0.d0;dummy=0.d0

	![EW=NLO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
	if (OREW == 1 .and. -1 <= ORQCD .and. ORQCD <= 2) then
		call romberg(vhWcs,dGam_dqsq_hWcs_NLOEW,(mc+msir)**2+epsics,(mh-mW)**2-epsics) ! h->W-cs~
		vhWcs = vhWcs+cos(alpha)**2*vhWcs_TBSH

		call romberg(vhWmunu,dGam_dqsq_hWmunu_NLOEW,(2.d0*mmu)**2+epsi,(mh-mW)**2-epsi)! h->W+mu-n
		vhWmunu = vhWmunu+cos(alpha)**2*vhWmunu_TBSH

		vhWWstar = 2.d0*(3.d0*vhWmunu+2.d0*vhWcs)
	![EW=NLO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
	else if (OREW == 0 .and. -1 <= ORQCD .and. ORQCD <= 2) then
		call decay_hWWstar_sm(vhWWstar,dummy,dummy,OREW,ORQCD)
		vhWWstar = cos(alpha)**2*vhWWstar
	else
		vhWWstar = 0.d0
	end if

	end subroutine
!#########################################################
!#
!#    Decay of additional CP even scalar: bH
!#
!#########################################################
!======================================================
!     Partial decay width (Fermionic decay)
!======================================================
	double precision function Gam_bHtt(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mt <= mbH) then
		Gam_bHtt = decay_bHtt(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	else if(mt+mW < mbH) then
		Gam_bHtt = decay_bHtts(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	else
		Gam_bHtt = 0.d0
	endif

	if (Gam_bHtt < 0.d0) then
		write(*,*) 'Gam_bHtt is negative'
	endif

	end function
!----- Gam(A -> q q~) except for q = t -----------------------------------------
	double precision function Gam_bHqq(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mf)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mf
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mf < mbH) then
		Gam_bHqq = decay_bHqq(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mf)
	else
		Gam_bHqq = 0.d0
	endif

	if (Gam_bHqq < 0.d0) then
		write(*,*) 'Gam_bHqq is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHll(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mf)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mf
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mf < mbH) then
		Gam_bHll = decay_bHll(mbH,alpha,lam_ps,lam_s,mu_s,OREW,mf)
	else
		Gam_bHll = 0.d0
	endif

	if (Gam_bHll < 0.d0) then
		write(*,*) 'Gam_bHll is negative'
	endif
	
	end function
!====================================================
!  Partial decay width (Bosonic decay)
!====================================================
	double precision function Gam_bHZZ(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mZ <= mbH) then
		Gam_bHZZ = decay_bHZZ(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	else if(mZ < mbH) then
		Gam_bHZZ = cos(alpha)**2*decay_hZZstar_tree(mbH)
	else
		Gam_bHZZ = 0.d0
	endif

	if (Gam_bHZZ < 0.d0) then
		write(*,*) 'Gam_bHZZ is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHWW(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mW <= mbH) then
		Gam_bHWW = decay_bHWW(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	else if(mW < mbH) then
		Gam_bHWW = cos(alpha)**2*decay_hWWstar_tree(mbH)
	else
		Gam_bHWW = 0.d0
	endif

	if (Gam_bHWW < 0.d0) then
		write(*,*) 'Gam_bHWW is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s,mu_r,OREW,ORQCD,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mu_r
	integer, intent(in):: OREW,ORQCD,SCHEME

	if(2.d0*mh <= mbH) then
		Gam_bHhh = decay_bHhh(mbH,alpha,lam_ps,lam_s,mu_s,mu_r,OREW,ORQCD,SCHEME)
	else
		Gam_bHhh = 0.d0
	endif

	if (Gam_bHhh < 0.d0) then
		write(*,*) 'Gam_bHhh is negative'
	endif

	end function
!====================================================
!  Partial decay width (loop-induced decay)
!====================================================
	double precision function Gam_bHgg(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD

	Gam_bHgg = decay_bHgg(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)

	if (Gam_bHgg < 0.d0) then
		write(*,*) 'Gam_bHgg is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHgamgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD

	Gam_bHgamgam = decay_bHgamgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)

	if (Gam_bHgamgam < 0.d0) then
		write(*,*) 'Gam_bHgamgam is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHZgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD

	if(mZ <= mbH) then
		Gam_bHZgam = decay_bHZgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	else
		Gam_bHZgam = 0.d0
	endif

	if (Gam_bHZgam < 0.d0) then
		write(*,*) 'Gam_bHZgam is negative'
	endif

	end function
!=====================================================
!  Two body functions (Fermionic decay)
!=====================================================
	double precision function decay_bHtt(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmf
	double precision:: R,mf,xf,If3,xif
	double precision:: Gam_S_LO_pole,Gam_S_LO_MSbar
	double precision:: decay_LO_pole,decay_LO_MSbar
	double precision:: decay_EWNLO_pole,decay_EWNLO_MSbar
	double precision:: QCD_pole,QCD_MSbar
	double precision:: decay_LO,decay_QCD,decay_EWNLO
	complex (kind(0d0)):: Gam_S_NLO
	double precision:: Delta_qq1,Delta_qq2
	mf = mt;	xf = mf/mbH
	p1sq=mf**2; p2sq=mf**2; qsq=mbH**2; mu=mbH
	R=2.d0*mf/mbH

	!--- mbH >= 2.d0*mt ---
	nf=6.d0; lam_QCD=lam_QCD6
	rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,nf),mt_MS)

	!===================
	!     LO
	!===================
	Gam_S_LO_pole = -mf/vev*sin(alpha)
	decay_LO_pole = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_pole**2

	if(OREW == 0 .and. ORQCD == -1) then
		decay_bHtt = decay_LO_pole
		return
	endif

	Gam_S_LO_MSbar = -rmf/vev*sin(alpha)
	decay_LO_MSbar = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_MSbar**2

	!----- Interpolation -----
	decay_LO = R**2*decay_LO_pole+(1.d0-R**2)*decay_LO_MSbar
	
	if(OREW == 0 .and. ORQCD == 0) then
		decay_bHtt = decay_LO
		return
	endif

	!=========================
	!     QCD corrections
	!=========================
	if(ORQCD > 0) then
		!----- on-shell -----
		QCD_pole  = decay_LO_pole*Delta_t_H(mu)
	
		!----- MSbar -----
		if(ORQCD == 1) then
			Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
			QCD_MSbar = decay_LO_MSbar*(Delta_qq1)
		else if(ORQCD == 2) then
			Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
			Delta_qq2 = (alphas(lam_QCD,mu,nf)/pi)**2*(&
								+10801.d0/144.d0-39.d0/2.d0*zeta3-(65.d0/24.d0-2.d0/3.d0*zeta3)*nf&
								-pi**2*(19.d0/12.d0-1.d0/18.d0*nf)&
							)
			QCD_MSbar = decay_LO_MSbar*(Delta_qq1+Delta_qq2)
		endif

		!----- Interpolation -----
		decay_QCD = R**2*QCD_pole+(1.d0-R**2)*QCD_MSbar

		if(OREW == 0) then
			decay_bHtt = decay_LO+decay_QCD
			return
		endif
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S_NLO = Gam_bHff_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			+mf*FbHff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			-mf*FbHff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			+(qsq-p1sq-p2sq+mf**2)*FbHff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)

		Gam_S_NLO =	Gam_S_NLO-Gam_S_LO_pole*Del_r(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0

		decay_EWNLO_pole =&
			Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_S_LO_pole*conjg(Gam_S_NLO))&
			)&
			!----- real photon emission -----
			+Nc*decay_bH_ffgam(mbH,alpha,lam_ps,lam_s,mu_s,mf)

		decay_EWNLO_MSbar = (rmf/mf)**2*decay_EWNLO_pole

		!----- Interpolation -----
		decay_EWNLO = R**2*decay_EWNLO_pole+(1.d0-R**2)*decay_EWNLO_MSbar
	
		if(ORQCD == -1) then
			decay_bHtt = decay_LO_pole+decay_EWNLO_pole
			return
		else if(ORQCD == 0) then
			decay_bHtt = decay_LO+decay_EWNLO
			return
		else if(1 <= ORQCD) then
			decay_bHtt = decay_LO+decay_EWNLO+decay_QCD
			return
		endif
	endif
	
	end function
!----- bH -> q q~ except for q = t -----------------------------------------
	double precision function decay_bHqq(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD,mf)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mf
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmf
	double precision:: xf
	double precision:: Gam_S_LO_pole,Gam_S_LO_MSbar
	double precision:: decay_LO_pole,decay_LO_MSbar
	double precision:: Delta_qq1,Delta_qq2,Delta_bH
	double precision:: decay_LO,decay_QCD,decay_EWNLO
	complex (kind(0d0)):: Gam_S_NLO
	p1sq=mf**2; p2sq=mf**2; qsq=mbH**2;
	xf = mf/mbH; mu=mbH

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if(mf == mb) then
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)
	else if(mf == mc) then
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD4,mc,4.d0),mc_MS)
	else if(mf == ms) then
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD3,ms,3.d0),ms_MS)
	endif

	!===================
	!     LO
	!===================
	Gam_S_LO_pole = -mf/vev*sin(alpha)
	decay_LO_pole = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_pole**2

	if(OREW==0 .and. ORQCD==-1) then
		decay_bHqq = decay_LO_pole
		return
	endif

	Gam_S_LO_MSbar = -rmf/vev*sin(alpha)
	decay_LO_MSbar = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_MSbar**2

	if(OREW==0 .and. ORQCD==0) then
		decay_bHqq = decay_LO_MSbar
		return
	endif

	!=========================
	!   QCD corrections
	!=========================
	decay_QCD = 0.d0
	Delta_qq1 = 0.d0; Delta_qq2 = 0.d0; Delta_bH = 0.d0

	if(ORQCD == 1) then
		Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
		decay_QCD = decay_LO_MSbar*Delta_qq1
	else if(ORQCD == 2) then
		Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
		Delta_qq2 = (alphas(lam_QCD,mu,nf)/pi)**2&
						*(10801.d0/144.d0-39.d0/2.d0*zeta3-(65.d0/24.d0-2.d0/3.d0*zeta3)*nf&
						  -pi**2*(19.d0/12.d0-1.d0/18.d0*nf))
		if (mbH < mt) then
			Delta_bH  = (alphas(lam_QCD,mu,nf)/pi)**2*(&
								+1.57d0-2.d0/3.d0*log(mbH**2/mt**2)&
								+1.d0/9.d0*(log(rmf**2/mbH**2))**2&
							)
		endif
		decay_QCD = decay_LO_MSbar*(Delta_qq1+Delta_qq2+Delta_bH)
	endif

	if(OREW == 0) then
		decay_bHqq = decay_LO_MSbar+decay_QCD
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S_NLO = Gam_bHff_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			+mf*FbHff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			-mf*FbHff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			+(qsq-p1sq-p2sq+mf**2)*FbHff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)

		Gam_S_NLO =	Gam_S_NLO-Gam_S_LO_pole*Del_r(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0

		decay_EWNLO =&
			Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_S_LO_pole*conjg(Gam_S_NLO))&
			)&
			!----- real photon emission -----
			+Nc*decay_bH_ffgam(mbH,alpha,lam_ps,lam_s,mu_s,mf)

		if(ORQCD == -1) then
			decay_bHqq = decay_LO_pole+decay_EWNLO
			return
		else if(ORQCD == 0) then
			decay_bHqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO
			return
		else if(ORQCD == 1) then
			decay_bHqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO+decay_QCD
			return
		else if(ORQCD == 2) then
			decay_bHqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO+decay_QCD
			return
		endif
	endif
	
	end function
!---------------------------------------------------------------------------
	double precision function decay_bHll(mbH,alpha,lam_ps,lam_s,mu_s,OREW,mf)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mf
	integer, intent(in):: OREW
	double precision:: p1sq,p2sq,qsq
	double precision:: xf
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_S_LO,Gam_S_NLO
	p1sq=mf**2; p2sq=mf**2; qsq=mbH**2;
	xf = mf/mbH

	!===================
	!     LO
	!===================
	Gam_S_LO = -mf/vev*sin(alpha)
	decay_LO = mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO**2

	if(OREW==0) then
		decay_bHll = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S_NLO = Gam_bHff_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			+mf*FbHff_V1(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			-mf*FbHff_V2(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)&
			+(qsq-p1sq-p2sq+mf**2)*FbHff_T(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mf)

		Gam_S_NLO =	Gam_S_NLO-Gam_S_LO*Del_r(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0

		decay_EWNLO =&
			mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_S_LO*conjg(Gam_S_NLO))&
			)&
			!----- real photon emission -----
			+decay_bH_ffgam(mbH,alpha,lam_ps,lam_s,mu_s,mf)

		decay_bHll = decay_LO+decay_EWNLO
		return
	endif
	
	end function
!--------------------------------------------------------------------------
	double precision function decay_bH_ffgam(mbH,alpha,lam_ps,lam_s,mu_s,mf)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mf
	double precision:: Qf

	if(mf == mt .or. mf == mc) then
		Qf = Qt
	else if(mf == mb .or. mf == ms) then
		Qf = Qb
	else if(mf == mtau .or. mf == mmu) then
		Qf = Qe
	endif

	decay_bH_ffgam =&
		2.d0*Qf**2*alpha_em/(16.d0*pi**2*mbH)&
		*(-mf/vev*sin(alpha))**2&
		*(&
			+OmegaLL_11(mbH,mf,mf)+OmegaLR_11(mbH,mf,mf)&
			+OmegaLL_22(mbH,mf,mf)+OmegaLR_22(mbH,mf,mf)&
			+OmegaLL_12(mbH,mf,mf)+OmegaLR_12(mbH,mf,mf)&
		)

	end function
!=====================================================
!   Three body functions (Fermionic decay)
!=====================================================
	double precision function dGam_dy1dy2_bHtts(mbH,alpha,lam_ps,lam_s,mu_s,yt,yb,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,yt,yb
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,kt,kw,gamt,KbHtts
	kt = mt**2/mbH**2
	kw = mW**2/mbH**2
	gamt = (1.42d0/mbH)**2
	KbHtts = 3*G_F**2*mt**2*sin(alpha)**2/32.d0/pi**3*mbH**3
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	dGam_dy1dy2_bHtts=&
		KbHtts/(yt**2+kt*gamt)&
		*(-yt**3+(1.d0-5.d0*kt+kw-yb)*yt**2&
		+((2.d0*kw-kt)*yb+2.d0*kt*(1.d0-2.d0*kw-4.d0*kt))*yt&
		+(1.d0-4.d0*kt)*(kt-kw)*(kt+2.d0*kw))*(&
			! LO
			+1.d0&
			! NLO Weak correction
			!	*S_NLOEW&
			! NLO  QED correction
			!	*S_NLOEW&
			! NLO  QCD correction
			!	*S_NLOQCD&
			! NNLO  QCD correction
			!	*S_NNLOQCD&
		)

	end function
!-------------------------------------------------------------------
	double precision function decay_bHtts(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	integer:: i,j,div_width
	double precision:: yt,yb,xt,xb,xw,ddecay_bHtts
	xt = mt/mbH
	xb = mb/mbH
	xw = mw/mbH

	div_width=200; decay_bHtts=0.d0

	do i = 0, div_width
		ddecay_bHtts=0.d0
		yt = (xb+xw)**2-xt**2+((1.d0-xt)**2-(xb+xw)**2)/dble(div_width)*dble(i)
		do j = 0, div_width
			yb =&
				xt**2+xw**2-xb**2&
				+(1.d0-2.d0*xt**2-yt)*(yt+xt**2+xw**2-xb**2)/(2.d0*(yt+xt**2))&
				-abs(lambda(yt+xt**2,xt**2)*lambda(xb**2/(yt+xt**2),xw**2/(yt+xt**2)))**(1.d0/2.d0)/2.d0&
				*(1.d0-2.d0*dble(j)/dble(div_width))
			if(j==0 .or. j==div_width) then
				ddecay_bHtts =&
					ddecay_bHtts&
					+dGam_dy1dy2_bHtts(mbH,alpha,lam_ps,lam_s,mu_s,yt,yb,OREW,ORQCD)
			else if(mod(j,2)==1) then
				ddecay_bHtts =&
					ddecay_bHtts&
					+4.d0*dGam_dy1dy2_bHtts(mbH,alpha,lam_ps,lam_s,mu_s,yt,yb,OREW,ORQCD)
			else if(mod(j,2)==0) then
				ddecay_bHtts =&
					ddecay_bHtts&
					+2.d0*dGam_dy1dy2_bHtts(mbH,alpha,lam_ps,lam_s,mu_s,yt,yb,OREW,ORQCD)
			endif
		enddo
		ddecay_bHtts =&
			ddecay_bHtts*sqrt(abs(lambda(yt+xt**2,xt**2)*lambda(xb**2/(yt+xt**2),xw**2/(yt+xt**2))))&
			/dble(div_width)/3.d0
		if(i==0 .or. i==div_width) then
			decay_bHtts = decay_bHtts+ddecay_bHtts
		else if(mod(i,2)==1) then
			decay_bHtts = decay_bHtts+4.d0*ddecay_bHtts
		else if(mod(i,2)==0) then
			decay_bHtts = decay_bHtts+2.d0*ddecay_bHtts
		endif
	enddo

	decay_bHtts = decay_bHtts*((1.d0-xt)**2-(xb+xw)**2)/dble(div_width)/3.d0

	end function
!=====================================================
!  Two body functions (Bosonic decay)
!=====================================================
	double precision function decay_bHWW(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq,mu,xV
	double precision:: Gam1_bHWW_tree
	double precision:: decay_LO,decay_EWNLO
	p1sq=mW**2; p2sq=mW**2; qsq=mbH**2; mu = mbH
	xV = mW/mbH

	Gam1_bHWW_tree = 2.d0*mW**2/vev*sin(alpha)

	!===================
	!     LO
	!===================
	decay_LO = mbH**3/(64.d0*pi*mW**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)&
					*(1.d0-4.d0*xV**2+12.d0*xV**4)*abs(Gam1_bHWW_tree)**2

	if(OREW == 0) then
		decay_bHWW = decay_LO
		return
	endif

	if(OREW == 1) then
		decay_EWNLO =&
			mbH**3/(64.d0*pi*mW**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)*(&
				+(1.d0-4.d0*xV**2+12.d0*xV**4)&
				*2.d0*Gam1_bHWW_tree*(&
					+dble(Gam1_bHWW_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s))&
					+Gam1_bHWW_tree*(&
						-dble(rdPiWW(mW**2,mbH,alpha,lam_ps,lam_s,mu_s))&
						-1.d0/2.d0*Del_r(mbH,alpha,lam_ps,lam_s,mu_s)&
					)&
				)&
				+(1.d0-6.d0*xV**2+8.d0*xV**4)/xV**2*Gam1_bHWW_tree*(&
					+dble(rGam2_bHWW(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s))&
				)&
			)

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_bH_WWgam(mbH,alpha,lam_ps,lam_s,mu_s)

		decay_bHWW = decay_LO+decay_EWNLO
		return
	endif
 
	end function
!--------------------------------------------------------------------------
	double precision function decay_bH_WWgam(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	decay_bH_WWgam =&
		alpha_em**2/(4.d0*pi*mbH*mW**2*sw**2)*sin(alpha)**2*(&
			+2.d0*mW**2*Ibrems22_11(mbH,mW,mW)&
			-mW**2*(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_11(mbH,mW,mW)&
			+2.d0*mW**2*Ibrems11_22(mbH,mW,mW)&
			-mW**2*(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_22(mbH,mW,mW)&
			+(mbH**6-6.d0*mbH**4*mW**2+20.d0*mbH**2*mW**4-24.d0*mW**6)*Ibrems_12(mbH,mW,mW)&
			+4.d0*mW**2*Ibrems2_1(mbH,mW,mW)&
			-(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_1(mbH,mW,mW)&
			+4.d0*mW**2*Ibrems1_2(mbH,mW,mW)&
			-(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_2(mbH,mW,mW)&
			+4.d0*mW**2*Ibrems(mbH,mW,mW)&
		)

	end function
!------------------------------------------------------------------
	double precision function decay_bHZZ(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD) 
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq,mu,xV
	double precision:: Gam1_bHZZ_tree
	double precision:: decay_LO,decay_EWNLO
	p1sq=mZ**2; p2sq=mZ**2; qsq=mbH**2; mu = mbH
	xV = mZ/mbH

	Gam1_bHZZ_tree = 2.d0*mZ**2/vev*sin(alpha)

	!===================
	!     LO
	!===================
	decay_LO  = mbH**3/(128.d0*pi*mZ**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)&
					*(1.d0-4.d0*xV**2+12.d0*xV**4)&
					*abs(Gam1_bHZZ_tree)**2

	if(OREW == 0) then
		decay_bHZZ = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		decay_EWNLO =&
			mbH**3/(128.d0*pi*mZ**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)*(&
				+(1.d0-4.d0*xV**2+12.d0*xV**4)&
				*2.d0*Gam1_bHZZ_tree*(&
					+real(Gam1_bHZZ_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s))&
					+Gam1_bHZZ_tree*(&
						-real(rdPiZZ(mZ**2,mbH,alpha,lam_ps,lam_s,mu_s))&
						-1.d0/2.d0*Del_r(mbH,alpha,lam_ps,lam_s,mu_s)&
					)&
				)&
				+(1.d0-6.d0*xV**2+8.d0*xV**4)/xV**2&
				*Gam1_bHZZ_tree*(&
					+real(rGam2_bHZZ(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s))&
				)&
			)

		decay_bHZZ = decay_LO+decay_EWNLO
		return
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHhh(mbH,alpha,lam_ps,lam_s,mu_s,mu_r,OREW,ORQCD,SCHEME)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s,mu_r
	integer, intent(in):: OREW,ORQCD,SCHEME
	double precision:: p1sq,p2sq,qsq,xphi
	double precision:: decay_LO,decay_EWNLO,decay_EWNNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mh**2; p2sq=mh**2; qsq=mbH**2
	xphi = mh/mbH

	!===================
	!     LO
	!===================
	Gam_LO = 2.d0*lam_bHhh(mbH,alpha,lam_ps,lam_s,mu_s)
	decay_LO = Gam_LO**2/(32.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)

	if(OREW==0) then
		decay_bHhh = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	Gam_NLO = Gam_bHhh_loop(p1sq,p2sq,qsq,mbH,alpha,lam_ps,lam_s,mu_s,mu_r,SCHEME)&
				 -Gam_LO*Del_r(mbH,alpha,lam_ps,lam_s,mu_s)/2.d0

	decay_EWNLO = 1.d0/(32.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)*(&
			+2.d0*dble(Gam_LO*conjg(Gam_NLO)))

	if(OREW == 1) then
		decay_bHhh = decay_LO+decay_EWNLO
		return
	endif

	end function
!=====================================================
!  Two body functions (Loop-induced decay)
!=====================================================
	double precision function decay_bHgamgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mbH**2; mu=mbH/2.d0

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	if (ORQCD == -1) then
		decay_bHgamgam=&
			alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
			*sin(alpha)**2&
			*abs(&
				Nc*Qt**2*I_f(mbH,mt)&
				+Nc*Qb**2*I_f(mbH,mb)&
				+Qe**2*I_f(mbH,mtau)&
				+I_W(mbH)&
			)**2
	endif

	if (ORQCD == 0) then
		decay_bHgamgam=&
			alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
			*sin(alpha)**2&
			*abs(&
				Nc*Qt**2*rmt/mt*I_f(mbH,mt)&
				+Nc*Qb**2*rmb/mb*I_f(mbH,mb)&
				+Qe**2*I_f(mbH,mtau)&
				+I_W(mbH)&
			)**2
	endif

	if (ORQCD == 1) then
		decay_bHgamgam=&
			alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
			*sin(alpha)**2&
			*abs(&
				Nc*Qt**2*rmt/mt*(&
					I_f(mbH,mt)&
					! NLO QCD
					-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mt,mu)&
				)&
				+Nc*Qb**2*rmb/mb*(&
					I_f(mbH,mb)&
					! NLO QCD
					-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mb,mu)&
				)&
				+Qe**2*I_f(mbH,mtau)&
				+I_W(mbH)&
			)**2
	endif

	if (ORQCD == 2) then
		if (mbH < mt) then
			decay_bHgamgam=&
				alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
				*sin(alpha)**2&
				*abs(&
					Nc*Qt**2*rmt/mt*(&
						I_f(mbH,mt)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mt,mu)&
						! NNLO QCD
	   				-I_f(mbH,mt)*(alphas(lam_QCD,mu,nf)/pi)**2*(&
	   					31.d0/24.d0+7.d0/4.d0*log(mu**2/mt**2)&
	   				)&
					)&
					+Nc*Qb**2*rmb/mb*(&
						I_f(mbH,mb)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mb,mu)&
					)&
					+Qe**2*I_f(mbH,mtau)&
					+I_W(mbH)&
				)**2
		else if (mt <= mbH) then
			decay_bHgamgam=&
				alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
				*sin(alpha)**2&
				*abs(&
					Nc*Qt**2*rmt/mt*(&
						I_f(mbH,mt)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mt,mu)&
					)&
					+Nc*Qb**2*rmb/mb*(&
						I_f(mbH,mb)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mb,mu)&
					)&
					+Qe**2*I_f(mbH,mtau)&
					+I_W(mbH)&
				)**2
		endif
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHZgam(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=mZ**2; p2sq=0.d0; qsq=mbH**2; mu=mbH/2.d0

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	if (ORQCD == -1) then
		decay_bHZgam=&
			sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
			*sin(alpha)**2&
			*abs(&
				Nc*Qt*vt*J_f(mbH,mt)&
				+Nc*Qb*vb*J_f(mbH,mb)&
				+Qe*ve*J_f(mbH,mtau)&
				+J_W(mbH)&
			)**2
	endif

	if (ORQCD == 0) then
		decay_bHZgam=&
			sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
			*sin(alpha)**2&
			*abs(&
				Nc*Qt*vt*rmt/mt*J_f(mbH,mt)&
				+Nc*Qb*vb*rmb/mb*J_f(mbH,mb)&
				+Qe*ve*J_f(mbH,mtau)&
				+J_W(mbH)&
			)**2
	endif

	if (1 <= ORQCD) then
		if (mbH < mt) then
			decay_bHZgam=&
				sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
				*sin(alpha)**2&
				*abs(&
					Nc*Qt*vt*rmt/mt*J_f(mbH,mt)*(&
						1.d0&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi&
					)&
					+Nc*Qb*vb*rmb/mb*J_f(mbH,mb)&
					+Qe*ve*J_f(mbH,mtau)&
					+J_W(mbH)&
				)**2
		else if (mt <= mbH) then
			decay_bHZgam=&
				sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
				*sin(alpha)**2&
				*abs(&
					Nc*Qt*vt*rmt/mt*J_f(mbH,mt)&
					+Nc*Qb*vb*rmb/mb*J_f(mbH,mb)&
					+Qe*ve*J_f(mbH,mtau)&
					+J_W(mbH)&
				)**2
		endif
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHgg(mbH,alpha,lam_ps,lam_s,mu_s,OREW,ORQCD)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: E_H1,dE_H1,E_H2,mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mbH**2; mu=mbH

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	E_H1 = 0.d0; dE_H1 = 0.d0; E_H2 = 0.d0
	if(1 <= ORQCD) then
		E_H1 = 95.d0/4.d0-7.d0/6.d0*nf+(33.d0-2.d0*nf)/6.d0*log(mu**2/mbH**2)
		dE_H1 =&
			dble(&
				(&
					B1_H(mbH**2/(4.d0*mt**2))+(2.d0*C2_H(mbH**2/(4.d0*mt**2)))*log(mu**2/mt**2)&
					+B1_H(mbH**2/(4.d0*mb**2))+(2.d0*C2_H(mbH**2/(4.d0*mb**2)))*log(mu**2/mb**2)&
				)&
				/(&
					F0_H(mbH**2/(4.d0*mt**2))&
					+F0_H(mbH**2/(4.d0*mb**2))&
				)&
			)&
			-11.d0/2.d0
	endif

	if(2 <= ORQCD .and. mbH < mt) then
		E_H2 =&
			+149533.d0/288.d0-363.d0/8.d0*zeta2-495.d0/8.d0*zeta3-19.d0/8.d0*log(mt**2/mbH**2)&
			+nf*(-4157.d0/72.d0+11.d0/2.d0*zeta2+5.d0/4.d0*zeta3-2.d0/3.d0*log(mt**2/mbH**2))&
			+nf**2*(127.d0/108.d0-1.d0/6.d0*zeta2)
	endif

	if (ORQCD == -1) then
		decay_bHgg=&
			sqrt(2.d0)*G_F*alphas(lam_QCD,mbH,nf)**2*mbH**3/(128.d0*pi**3)&
			*sin(alpha)**2&
			*abs(&
				I_f(mbH,mt)&
				+I_f(mbH,mb)&
			)**2
	else if (ORQCD == 0 .or. ORQCD == 1 .or. ORQCD == 2) then
		decay_bHgg=&
			sqrt(2.d0)*G_F*alphas(lam_QCD,mbH,nf)**2*mbH**3/(128.d0*pi**3)&
			*sin(alpha)**2&
			*abs(&
				rmt/mt*I_f(mbH,mt)&
				+rmb/mb*I_f(mbH,mb)&
			)**2&
			*(&
				!LO
				+1.d0&
				!NLO QCD
				+alphas(lam_QCD,mbH,nf)/pi*(E_H1+dE_H1)&
				!NNLO QCD
				+(alphas(lam_QCD,mbH,nf)/pi)**2*E_H2&
			)
	endif

	end function
!##########################################################
! 
!    SECTION VI OTHER QUANTITIES          
!                                     
!##########################################################       
	complex (kind(0d0)) function rPiWW(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	rPiWW =&
		PiWW_F(qsq)+PiWW_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)-PiWW_pinch(qsq)&
		-(del_mWsq_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_mWsq_B(mbH,alpha,lam_ps,lam_s,mu_s)) &
		+(qsq-mW**2)*(del_ZW_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZW_B(mbH,alpha,lam_ps,lam_s,mu_s))

	end function
!-------------------------------------------- 
	complex (kind(0d0)) function rdPiZZ(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	rdPiZZ =&
		dPiZZ_F(qsq)+dPiZZ_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)-dPiZZ_pinch(qsq)& 
		+ del_ZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZZ_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!--------------------------------------------
	complex (kind(0d0)) function rdPiWW(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rdPiWW =&
		dPiWW_F(qsq)+dPiWW_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)-dPiWW_pinch(qsq)&
		+del_ZW_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZW_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!--------------------------------------------  
	double precision function Del_r(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	Del_r =&
		rPiWW(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)/mW**2&
		+alpha_em/(4.d0*pi*sw**2)*(6.d0+(7.d0-4.d0*sw**2)/(2.d0*sw**2)*log(cw**2))

	end function
!-------------------------------------------- 
	complex (kind(0d0)) function rPiZZ(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rPiZZ =&
		PiZZ_F(qsq)+PiZZ_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)-PiZZ_pinch(qsq)&
		-del_mZsq_F(mbH,alpha,lam_ps,lam_s,mu_s)-del_mZsq_B(mbH,alpha,lam_ps,lam_s,mu_s)&
		+(qsq-mZ**2)*(del_ZZ_F(mbH,alpha,lam_ps,lam_s,mu_s)+del_ZZ_B(mbH,alpha,lam_ps,lam_s,mu_s))

	end function
!-------------------------------------------- 
	complex (kind(0d0)) function del_swsq_F()

	del_swsq_F = cw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_swsq_B(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_swsq_B =&
		cw**2*(PiZZ_B(mZ**2,mbH,alpha,lam_ps,lam_s,mu_s)/mz**2&
		-PiWW_B(mW**2,mbH,alpha,lam_ps,lam_s,mu_s)/mw**2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_swsq(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_swsq = del_swsq_F()+del_swsq_B(mbH,alpha,lam_ps,lam_s,mu_s)

	end function
!--------------------------------------------------------------                   
	complex (kind(0d0)) function del_ZZG(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: mbH,alpha,lam_ps,lam_s,mu_s

	del_ZZG =&
		-2.d0/mZ**2*(&
			-PiZG_F(0.d0)&
			-(PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(0.d0))&
		)&
		+del_swsq(mbH,alpha,lam_ps,lam_s,mu_s)/(sw*cw)

	end function
!--------------------------------------------------------------
	complex (kind(0d0)) function rPiZG(qsq,mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in):: qsq,mbH,alpha,lam_ps,lam_s,mu_s

	rPiZG =&
		PiZG_F(qsq)+PiZG_B(qsq,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(qsq)&
		-PiZG_F(0.d0)-(PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(0.d0))&
		+qsq*(&
			del_swsq(mbH,alpha,lam_ps,lam_s,mu_s)/(sw*cw)&
			+2.d0/mZ**2*(PiZG_F(0.d0)+PiZG_B(0.d0,mbH,alpha,lam_ps,lam_s,mu_s)-PiZG_pinch(0.d0))&
		)

	end function
!--------------------------------------------------------------
	double precision function rmW(mbH,alpha,lam_ps,lam_s,mu_s)
	double precision, intent(in)::mbH,alpha,lam_ps,lam_s,mu_s

	rmW =&
		sqrt(&
			mZ**2/2.d0*(&
			1.d0&
			+sqrt(1.d0-4.d0*pi*alpha_em&
				/(sqrt(2.d0)*G_f*mZ**2*(1.d0-Del_r(mbH,alpha,lam_ps,lam_s,mu_s)))&
			)&
			)&
		)

	end function

end subroutine HCOUP_HSM