subroutine HCOUP_IDM(OREW,ORQCD)

use SM_const
use pv
use Gauge_boson_2p
use SM_Hdecay
use real_photon_emission
use HCOUP_SM
use func_forQCDco
use int_romberg

	implicit none

	integer :: i,j,k
	integer :: OREW,ORQCD,constraint(6)
	character(4):: C_EW
	character(20):: C_QCD
	double precision:: rmc_mh,rmb_mh

	!========== Model parameters ==========
	double precision:: mhp,mhn,ma,mu2,lam2
	double precision:: cutoff,mu_r
	double precision:: para1(100)
	double precision:: mu2sq

	!========== Momentum inputs ==========
	complex (kind(0d0)):: vhZZ(3),vhWW(3),vhtt(8),vhbb(8),vhcc(8),vhll(8),vhmumu(8),vhhh
	complex (kind(0d0)):: vhZZ_sm(3),vhWW_sm(3),vhtt_sm(8),vhbb_sm(8),vhcc_sm(8),vhll_sm(8),vhmumu_sm(8),vhhh_sm
	complex (kind(0d0)):: vhgamgam(2),vhZgam(2)
	double precision:: p_hzz(3),p_hww(3),p_htt(3),p_hbb(3),p_hcc(3),p_hll(3),p_hmumu(3),p_hhh(3),p_hgamgam(3),p_hZgam(3)
	double precision:: para2(100)

	!========== Unitarity/Tribiality/RGE ==========
	double precision:: lqt = 1.d0/2.d0
	double precision:: nh = 2.d0,ng = 3.d0,gs,gp

	!========== SM Higgs decay ==========
	double precision:: hdecay_SM(-50:50,-50:50)=0.d0
	double precision:: BRh_SM(-50:50,-50:50)=0.d0
	double precision:: vGam_hhh_SM
	double precision:: Gam_h_total_SM
	!---------- h -> ZZ* and h-> WW* ----
	double precision:: vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
	double precision:: vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm

	!========== SM-like Higgs decay ==========
	double precision:: hdecay(-50:50,-50:50)=0.d0
	double precision:: BRh(-50:50,-50:50)=0.d0
	double precision:: vGam_hhh_2HDM
	double precision:: Gam_h_total

	!========== bH decay ==========
	double precision:: bHdecay(-50:50,-50:50)=0.d0
	double precision:: BRbH(-50:50,-50:50)=0.d0
	double precision:: Gam_bH_total

	!========== A decay ==========
	double precision:: Adecay(-50:50,-50:50)=0.d0
	double precision:: BRA(-50:50,-50:50)=0.d0
	double precision:: Gam_A_total

	!========== H± decay ==========
	double precision:: Hpmdecay(-50:50,-50:50)=0.d0
	double precision:: BRHpm(-50:50,-50:50)=0.d0
	double precision:: Gam_Hpm_total

	!========== LoopTools ==========
	double precision:: getlambda,getminmass,getmudim
	double precision:: p1sq,p2sq,qsq

	!========== files ==========
	integer:: flag, ios
	character:: writefile1*128,writefile2*128,writefile3*128,writefile4*128
	character:: readfile1*128
	logical:: hZZ_exist,hWW_exist

	!========== Misc. ==========
	complex (kind(0d0)),allocatable:: dummy(:)
	double precision:: rand(10)
	double precision:: test(100)=0.d0
	complex (kind(0d0)):: ctest(100)

	open(1, file='./inputs/in_idm.txt')
	do i = 1, 100
		if (i .le. 6) then 
			read (1,'()') 
		else 
			read (1,*,end=30) para1(i-6)
		endif
	enddo

30	mhp    = para1(1)
	ma     = para1(2)
	mhn    = para1(3)
	mu2sq  = para1(4)
	lam2   = para1(5)
	cutoff = para1(6)
	mu_r   = para1(7)

	mu2 = mu2sq

	open(2, file='./inputs/in_momentum.txt' )
	do i = 1, 100
		if (i <= 6) then
			read (2,'()')
		else
			read (2,*,end=40) para2(i-6)
		endif
	enddo 

40 p_hzz(1)   = para2(1)
	p_hzz(2)   = para2(2)
	p_hzz(3)   = para2(3)
	!--------------------------------------------------------------------------------------------------------
   p_hww(1)   = para2(4)
   p_hww(2)   = para2(5)
   p_hww(3)   = para2(6)
	!--------------------------------------------------------------------------------------------------------
   p_htt(1)   = para2(7)
   p_htt(2)   = para2(8)
   p_htt(3)   = para2(9)
	!--------------------------------------------------------------------------------------------------------
   p_hbb(1)   = para2(10)
   p_hbb(2)   = para2(11)
   p_hbb(3)   = para2(12)
	!--------------------------------------------------------------------------------------------------------
   p_hcc(1)   = para2(13)
   p_hcc(2)   = para2(14)
   p_hcc(3)   = para2(15)
	!--------------------------------------------------------------------------------------------------------
   p_hll(1)   = para2(16)
   p_hll(2)   = para2(17)
   p_hll(3)   = para2(18)
	!--------------------------------------------------------------------------------------------------------
   p_hmumu(1) = para2(19)
   p_hmumu(2) = para2(20)
   p_hmumu(3) = para2(21)
	!--------------------------------------------------------------------------------------------------------
   p_hhh(1)   = para2(22)
   p_hhh(2)   = para2(23)
   p_hhh(3)   = para2(24)

	call ltini

	if (OREW == 0) then
		C_EW = 'LO'
	else if(OREW == 1) then
		C_EW = 'NLO'
	end if

	if (ORQCD == -1) then
		C_QCD = 'LO(quark mass:OS)'
	elseif (ORQCD == 0) then
		C_QCD = 'LO(quark mass:MSbar)'
	else if(ORQCD == 1) then
		C_QCD = 'NLO'
	else if(ORQCD == 2) then
		C_QCD = 'NNLO'
	end if

	gs = sqrt(alpha_s*4.d0*pi)
	gp = g*sw/cw

	! !===== This is needed for calculations with mphoton=0.d0 ====== 
	! QED = 1.d0; mphoton = 0.d0
	! allocate (dummy(300))
	! call Cput(dummy,125.d0**2,80.d0**2,400.d0**2,400.d0**2,80.d0**2,0.d0)
	! call Dput(dummy,msir**2,mc**2,mW**2,mh**2,20.d0**2,10.d0**2,mW**2,mc**2,0.d0,mW**2)
	! !====================================================

	!========== calculate hVVstar_sm (take several minites) and make text file ==========
	if(OREW == 0) then
		call decay_hZZstar_sm(vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD)
		call decay_hWWstar_sm(vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD)
	else if(OREW == 1) then
		inquire (file="modules/dat/hVVstar_sm/hZZstar_sm.txt",exist=hZZ_exist)
		open(10,file="modules/dat/hVVstar_sm/hZZstar_sm.txt")
		if(hZZ_exist) then
			read(10,*) vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
		else
			call decay_hZZstar_sm(vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD)
			write(10,*) vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
		endif
		close(10)

		inquire (file="modules/dat/hVVstar_sm/hWWstar_sm.txt",exist=hWW_exist)
		open(20,file="modules/dat/hVVstar_sm/hWWstar_sm.txt")

		if(hWW_exist) then
			read(20,*) vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm
		else
			call decay_hWWstar_sm(vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD)
			write(20,*) vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm
		endif
		close(20)
	endif

	!###########################################################################
	! Main
	!###########################################################################
	if(main_prog) then
		!###################################   Constraints   ########################################
		constraint(1:6) = 0

		if (vs(mhp,mhn,ma,mu2,lam2) /= 0.d0) then
			write(*,*) 'Excluded by vacuum stability at tree level'
			constraint(1) = 1
		endif

		if (pu(mhp,mhn,ma,mu2,lam2) /= 0.d0) then
			write(*,*) 'Excluded by tree-level unitarity'
			constraint(2) = 1
		endif

		if (stu(mhp,mhn,ma,mu2,lam2) /= 0.d0) then
			write(*,*) 'Excluded by S and T parameters'
			constraint(3) = 1
		endif

		if (true_vacuum(mhp,mhn,ma,mu2,lam2) /= 0.d0) then 
			write(*,*) 'Excluded by true vacuum condition'
			constraint(4) = 1
		endif

		if (sqrt(mu2) >= 1.d3 .and. cutoff > sqrt(mu2)) then
			if (vs_rge_MSM(cutoff,mhp,mhn,ma,mu2,lam2) /= 0.d0) then
				write(*,*) 'Excluded by vacuum stability (RGE improved with the cutoff scale and SM matching)'
				constraint(5) = 1
			endif

			if (triviality_MSM(cutoff,mhp,mhn,ma,mu2,lam2) /= 0.d0) then
				write(*,*) 'Excluded by triviality (with the cutoff scale and SM matching)'
				constraint(6) = 1
			endif
		else
			if (vs_rge(cutoff,mhp,mhn,ma,mu2,lam2) /= 0.d0) then
				write(*,*) 'Excluded by vacuum stability (RGE improved with the cutoff scale)'
				constraint(5) = 1
			endif
	
			if (triviality(cutoff,mhp,mhn,ma,mu2,lam2) /= 0.d0) then
				write(*,*) 'Excluded by triviality (with the cutoff scale)'
				constraint(6) = 1
			endif
		end if

		!###################################   Effective vertices   ########################################
		open(10,file="outputs/out_sm.txt")
		open(11,file="outputs/out_idm.txt")

		!============================== SM ==============================
		vhZZ_sm(1)   = rGam1_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhZZ_sm(2)   = rGam2_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhZZ_sm(3)   = rGam3_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhWW_sm(1)   = rGam1_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhWW_sm(2)   = rGam2_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhWW_sm(3)   = rGam3_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhtt_sm(1)   = rGamS_htt_sm(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2)
		vhbb_sm(1)   = rGamS_hbb_sm(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2)
		vhcc_sm(1)   = rGamS_hcc_sm(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2)
		vhll_sm(1)   = rGamS_htautau_sm(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2)
		vhmumu_sm(1) = rGamS_hmumu_sm(p_hmumu(1)**2,p_hmumu(2)**2,p_hmumu(3)**2)
		vhhh_sm      = rGam_hhh_sm(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2)

		write(10,*) "============================== Higgs vertex functions =============================="
		write(10,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ_sm(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ_sm(1))
		write(10,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ_sm(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ_sm(2))
		write(10,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ_sm(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ_sm(3))
		write(10,100) 'Re[rGam_hWW(1)]:', dble(vhWW_sm(1)),'Im[rGam_hWW(1)]:', imag(vhWW_sm(1))
		write(10,100) 'Re[rGam_hWW(2)]:', dble(vhWW_sm(2)),'Im[rGam_hWW(2)]:', imag(vhWW_sm(2))
		write(10,100) 'Re[rGam_hWW(3)]:', dble(vhWW_sm(3)),'Im[rGam_hWW(3)]:', imag(vhWW_sm(3))
		write(10,100) 'Re[rGam_htt(S)]:', dble(vhtt_sm(1)),'Im[rGam_htt(S)]:', imag(vhtt_sm(1))
		write(10,100) 'Re[rGam_hbb(S)]:', dble(vhbb_sm(1)),'Im[rGam_hbb(S)]:', imag(vhbb_sm(1))
		write(10,100) 'Re[rGam_hcc(S)]:', dble(vhcc_sm(1)),'Im[rGam_hcc(S)]:', imag(vhcc_sm(1))
		write(10,100) 'Re[rGam_htautau(S)]:', dble(vhll_sm(1)),'Im[rGam_htautau(S)]:', imag(vhll_sm(1))
		write(10,100) 'Re[rGam_hmumu(S)]:', dble(vhmumu_sm(1)),'Im[rGam_hmumu(S)]:', imag(vhmumu_sm(1))
		write(10,100) 'Re[rGam_hhh]:'   , dble(vhhh_sm),'Im[rGam_hhh]:', imag(vhhh_sm)

		!============================== IDM ==============================
		vhZZ(1)   = rGam1_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mhp,mhn,ma,mu2,lam2)
		vhZZ(2)   = rGam2_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mhp,mhn,ma,mu2,lam2)
		vhZZ(3)   = rGam3_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mhp,mhn,ma,mu2,lam2)
		vhWW(1)   = rGam1_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mhp,mhn,ma,mu2,lam2)
		vhWW(2)   = rGam2_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mhp,mhn,ma,mu2,lam2)
		vhWW(3)   = rGam3_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mhp,mhn,ma,mu2,lam2)
		vhtt(1)   = rGamS_htt(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2,mhp,mhn,ma,mu2,lam2)
		vhbb(1)   = rGamS_hbb(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2,mhp,mhn,ma,mu2,lam2)
		vhcc(1)   = rGamS_hcc(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2,mhp,mhn,ma,mu2,lam2)
		vhll(1)   = rGamS_htautau(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2,mhp,mhn,ma,mu2,lam2)
		vhmumu(1) = rGamS_hmumu(p_hmumu(1)**2,p_hmumu(2)**2,p_hmumu(3)**2,mhp,mhn,ma,mu2,lam2)
		vhhh      = rGam_hhh(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2,mhp,mhn,ma,mu2,lam2)

		write(11,*) "============================== Higgs vertex functions =============================="
		write(11,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ(1))
		write(11,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ(2))
		write(11,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ(3))
		write(11,100) 'Re[rGam_hWW(1)]:', dble(vhWW(1)),'Im[rGam_hWW(1)]:', imag(vhWW(1))
		write(11,100) 'Re[rGam_hWW(2)]:', dble(vhWW(2)),'Im[rGam_hWW(2)]:', imag(vhWW(2))
		write(11,100) 'Re[rGam_hWW(3)]:', dble(vhWW(3)),'Im[rGam_hWW(3)]:', imag(vhWW(3))
		write(11,100) 'Re[rGam_htt(S)]:', dble(vhtt(1)),'Im[rGam_htt(S)]:', imag(vhtt(1))
		write(11,100) 'Re[rGam_hbb(S)]:', dble(vhbb(1)),'Im[rGam_hbb(S)]:', imag(vhbb(1))
		write(11,100) 'Re[rGam_hcc(S)]:', dble(vhcc(1)),'Im[rGam_hcc(S)]:', imag(vhcc(1))
		write(11,100) 'Re[rGam_htautau(S)]:', dble(vhll(1)),'Im[rGam_htautau(S)]:', imag(vhll(1))
		write(11,100) 'Re[rGam_hmumu(S)]:', dble(vhmumu(1)),'Im[rGam_hmumu(S)]:', imag(vhmumu(1))
		write(11,100) 'Re[rGam_hhh]:'   , dble(vhhh),'Im[rGam_hhh]:', imag(vhhh)

		!###################################   Decay branching ratios   ########################################
		100 Format(A24,1PE18.8,A24,1PE18.8)
		200 Format(A20,1PE18.8)

		98 format('# ',A)
		99 format('#')        
		101 format('BLOCK ',A,' #',A)
		102 format(3x,I3,4x,I3,'   # ',A)
		103 format(3x,I3,4x,1PE16.8,'   # ',A)
		104 format(3x,I3,4x,I3,13x,'   # ',A)

		201 format('#',10x,'PDG',10x,'Width')
		! 202 format('DECAY',I9,3x,E16.8,3x,'# ',A)
		202 format('DECAY',I9,3x,E16.8,3x,'# EW:',A,'QCD:',A)
		203 format('#',10x,'BR',9x,'NDA',7x,'ID1',6x,'ID2')
		213 format('#',10x,'Gamma',6x,'NDA',7x,'ID1',6x,'ID2')
		204 format(3x,1PE16.8,4x,I2,1x,I9,I9,4x'# ',A)

		!===================================   SM OUTPUTS   ========================================
		open(12,file="outputs/outBR_sm.txt")  
		call header_outputs(12)
		write(12,101) 'MODEL'
		write(12,102) 1,0,'SM'          
		
		write(12,101) 'SMINPUTS'
		write(12,103) 1,alpha_em,'alpha_em' 
		write(12,103) 2,G_F,'Fermi constant' 
		write(12,103) 3,alpha_s,'alpha_s' 
		write(12,103) 4,mc_MS,'mc(mc) MSbar'
		write(12,103) 5,mb_MS,'mb(mb) MSbar'
		write(12,103) 6,mc,'mc On-shell'
		write(12,103) 7,mb,'mb On-shell'
	  
		rmc_mh = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD4,mc_MS,4.d0),mc_MS) 
		rmb_mh = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD5,mb_MS,5.d0),mb_MS)
		
		write(12,101) 'MASS'        
		!write(12,103) 1,0.,'md'
		!write(12,103) 2,0.,'mu'
		!write(12,103) 3,0.,'ms'
		write(12,103) 4,rmc_mh,'mc(mh) MSbar'
		write(12,103) 5,rmb_mh,'mb(mh) MSbar'
		write(12,103) 6,mt,'mt'                
		write(12,103) 13,mmu,'mmu'        
		write(12,103) 15,mtau,'mtau'
		write(12,103) 23,mz,'mz'
		write(12,103) 24,mw,'mw (calculated,tree)' 
		write(12,103) 24,rmw_SM(),'mw (calculated,1-loop)' 
		write(12,103) 25,mh,'mh'

		!======================================================================
		!  SM Higgs boson'
		!======================================================================
		!========== initialization ==========
		hdecay_SM(:,:) = 0.d0; BRh_SM(:,:) = 0.d0; Gam_h_total_SM = 0.d0

		!========== quark decay ==========
		hdecay_SM(5,-5) = decay_hbb_sm(mh,OREW,ORQCD)
		hdecay_SM(4,-4) = decay_hcc_sm(mh,OREW,ORQCD)

		!========== leptonic decay ==========
		hdecay_SM(15,-15) = decay_htautau_sm(mh,OREW)
		hdecay_SM(13,-13) = decay_hmumu_sm(mh,OREW)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		hdecay_SM(23,23)  = vdecay_hZZstar_sm
		hdecay_SM(24,-24) = vdecay_hWWstar_sm

		!========== loop-induced decay ==========
		hdecay_SM(21,21) = decay_hgg_sm(mh,ORQCD)
		hdecay_SM(22,22) = decay_hgamgam_sm(mh,ORQCD)
		hdecay_SM(22,23) = decay_hZgam_sm(mh,ORQCD)

		!========== total decay width ==========
		Gam_h_total_SM = sum(hdecay_SM)

		!========== decay branching ratio ==========
		BRh_SM = hdecay_SM/Gam_h_total_SM

		write(12,99)
		write(12,98)'Decay branching ratios of the SM Higgs boson by H-COUP #'
		write(12,201)
		write(12,202) 25,Gam_h_total_SM,C_EW,C_QCD
		write(12,203)
		write(12,204) BRh_SM(4,-4),   2,  4,  -4, 'BR(h -> c c~)'
		write(12,204) BRh_SM(5,-5),   2,  5,  -5, 'BR(h -> b b~)'
		write(12,204) BRh_SM(13,-13), 2, 13, -13, 'BR(h -> mu- mu+)'
		write(12,204) BRh_SM(15,-15), 2, 15, -15, 'BR(h -> tau- tau+)'
		write(12,204) BRh_SM(21,21),  2, 21,  21, 'BR(h -> g g)'
		write(12,204) BRh_SM(22,22),  2, 22,  22, 'BR(h -> gam gam)'
		write(12,204) BRh_SM(22,23),  2, 22,  23, 'BR(h -> gam Z)'
		write(12,204) BRh_SM(23,23),  2, 23,  23, 'BR(h -> Z Z*)'
		write(12,204) BRh_SM(24,-24), 2, 24, -24, 'BR(h -> W+ W-*)'

		!===================================   IDM OUTPUTS   ========================================
		open(13,file="outputs/outBR_idm.txt") 
		call header_outputs(13) 
		write(13,101) 'MODEL'
		write(13,102) 1,3,'IDM'
		
		write(13,101) 'BSMINPUTS'
		write(13,103) 1,mu2sq,'mu_2^2 (GeV^2)' 
		write(13,103) 2,lam2,'lambda_2'    
		write(13,103) 3,mu_r,'mu_r (GeV)' 

		write(13,101) 'SMINPUTS'
		write(13,103) 1,alpha_em,'alpha_em' 
		write(13,103) 2,G_F,'Fermi constant' 
		write(13,103) 3,alpha_s,'alpha_s' 
		write(13,103) 4,mc_MS,'mc(mc) MSbar'
		write(13,103) 5,mb_MS,'mb(mb) MSbar'
		write(13,103) 6,mc,'mc On-shell'
		write(13,103) 7,mb,'mb On-shell'
				  
		write(13,101) 'MASS'        
		!write(13,103) 1,0.,'md'
		!write(13,103) 2,0.,'mu'
		!write(13,103) 3,0.,'ms'
		write(13,103) 4,rmc_mh,'mc(mh) MSbar'
		write(13,103) 5,rmb_mh,'mb(mh) MSbar'
		write(13,103) 6,mt,'mt'                
		write(13,103) 13,mmu,'mmu'
		write(13,103) 15,mtau,'mtau'
		write(13,103) 23,mz,'mz'
		write(13,103) 24,mw,'mw (calculated,tree)' 
		write(13,103) 24,rmW(mhp,mhn,ma,mu2,lam2),'mw (calculated,1-loop)' 
		write(13,103) 25,mh,'mh'
		write(13,103) 35,mhn,'mH' 
		write(13,103) 36,ma,'mA' 
		write(13,103) 37,mhp,'mH+' 

		write(13,101) 'CONSTRAINTS'
		write(13,103) 0,cutoff,'The cutoff scale (GeV)'
		write(13,102) 1,constraint(1),'Vacuum stability at tree level [0=OK, 1=No]'
		write(13,102) 2,constraint(2),'Tree-level unitarity [0=OK, 1=No]'
		write(13,102) 3,constraint(3),'S and T parameters [0=OK, 1=No]'
		write(13,102) 4,constraint(4),'True vacuum [0=OK, 1=No]'
		write(13,102) 5,constraint(5),'Vacuum stability (RGE improved with the cutoff scale) [0=OK, 1=No]'
		write(13,102) 6,constraint(6),'Triviality (with the cutoff scale) [0=OK, 1=No]'

		!======================================================================
		!  Lighter CP-even Higgs boson'
		!======================================================================
		!---------- initialization ----------
		hdecay(:,:) = 0.d0; BRh(:,:) = 0.d0; Gam_h_total = 0.d0

		!========== quark decay ==========
		hdecay(5,-5) = decay_hbb(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
		hdecay(4,-4) = decay_hcc(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)

		!========== leptonic decay ==========
		hdecay(15,-15) = decay_htautau(mhp,mhn,ma,mu2,lam2,OREW)
		hdecay(13,-13) = decay_hmumu(mhp,mhn,ma,mu2,lam2,OREW)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		call decay_hZZstar(hdecay(23,23),vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD)
		call decay_hWWstar(hdecay(24,-24),vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD)
		!---------- SS ----------
		hdecay(35,35)  = Gam_hbHbH(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
		hdecay(36,36)  = Gam_hAA(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
		hdecay(37,-37) = Gam_hHpHm(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)

		!========== loop-induced decay ==========
		hdecay(21,21) = decay_hgg_sm(mh,ORQCD)
		hdecay(22,22) = decay_hgamgam(mhp,mhn,ma,mu2,lam2,ORQCD)
		hdecay(22,23) = decay_hZgam(mhp,mhn,ma,mu2,lam2,ORQCD)
	
		!========== total decay width ==========
		Gam_h_total = sum(hdecay)

		!========== decay branching ratio ==========
		BRh = hdecay/Gam_h_total

		write(13,99)
		write(13,98)'Decay branching ratios of the SM-like Higgs boson by H-COUP #'
		write(13,201)
		write(13,202) 25,Gam_h_total,C_EW,C_QCD
		write(13,203)
		write(13,204) BRh(4,-4),   2,  4,  -4, 'BR(h -> c c~)'
		write(13,204) BRh(5,-5),   2,  5,  -5, 'BR(h -> b b~)'
		write(13,204) BRh(13,-13), 2, 13, -13, 'BR(h -> mu- mu+)'
		write(13,204) BRh(15,-15), 2, 15, -15, 'BR(h -> tau- tau+)'
		write(13,204) BRh(21,21),  2, 21,  21, 'BR(h -> g g)'
		write(13,204) BRh(22,22),  2, 22,  22, 'BR(h -> gam gam)'
		write(13,204) BRh(22,23),  2, 22,  23, 'BR(h -> gam Z)'
		write(13,204) BRh(23,23),  2, 23,  23, 'BR(h -> Z Z*)'
		write(13,204) BRh(24,-24), 2, 24, -24, 'BR(h -> W+ W-*)'
		write(13,204) BRh(35,35),  2, 35,  35, 'BR(h -> bH bH)'
		write(13,204) BRh(36,36),  2, 36,  36, 'BR(h -> A A)'
		write(13,204) BRh(37,-37), 2, 37, -37, 'BR(h -> H+ H-)'

		!======================================================================
		!  Heavier CP-even Higgs boson'
		!======================================================================
		!---------- initialization ----------
		bHdecay(:,:) = 0.d0; brbH(:,:) = 0.d0; Gam_bH_total = 0.d0

		!========== bosonic decay ==========
		!---------- SV ----------
		bHdecay(23,36) = Gam_bHAZ(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
		bHdecay(24,37) = Gam_bHchW(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)

		!========== total decay width ==========
		Gam_bH_total = sum(bHdecay)

		!========== decay branching ratio ==========
		if(Gam_bH_total == 0.d0) then
			write(13,99)
			write(13,98)'Decay branching ratios of the additional CP-even Higgs boson by H-COUP #'
			write(13,201)
			write(13,202) 35,Gam_bH_total,C_EW,C_QCD
			write(13,203)
			write(13,204) 0.d0, 2, 23,  36, 'BR(bH -> A Z)'
			write(13,204) 0.d0, 2, 24,  37, 'BR(bH -> H+W-/H-W+)'
		else if(Gam_bH_total /= 0.d0) then
			BRbH = bHdecay/Gam_bH_total
			write(13,99)
			write(13,98)'Decay branching ratios of the additional CP-even Higgs boson by H-COUP #'
			write(13,201)
			write(13,202) 35,Gam_bH_total,C_EW,C_QCD
			write(13,203)
			write(13,204) BRbH(23,36), 2, 23,  36, 'BR(bH -> A Z)'
			write(13,204) BRbH(24,37), 2, 24,  37, 'BR(bH -> H+W-/H-W+)'
		endif

		!======================================================================
		!  CP-odd Higgs boson'
		!======================================================================
		!---------- initialization ----------
		Adecay(:,:) = 0.d0; brA(:,:) = 0.d0; Gam_A_total = 0.d0

		!========== bosonic decay ==========
		!---------- SV ----------
		Adecay(23,35) = Gam_AZbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
		Adecay(24,37) = Gam_AWch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)

		!========== total decay width ==========
		Gam_A_total = sum(Adecay)

		!========== decay branching ratio ==========
		if(Gam_A_total == 0.d0) then
			write(13,99)
			write(13,98)'Decay branching ratios of the CP-odd Higgs boson by H-COUP #'
			write(13,201)
			write(13,202) 35,Gam_A_total,C_EW,C_QCD
			write(13,203)
			write(13,204) 0.d0, 2, 23,  35, 'BR(A -> Z bH)'
			write(13,204) 0.d0, 2, 24,  37, 'BR(A -> H+W-/H-W+)'	
		else if(Gam_A_total /= 0.d0) then
			BRA = Adecay/Gam_A_total
			write(13,99)
			write(13,98)'Decay branching ratios of the CP-odd Higgs boson by H-COUP #'
			write(13,201)
			write(13,202) 35,Gam_A_total,C_EW,C_QCD
			write(13,203)
			write(13,204) BRA(23,35), 2, 23,  35, 'BR(A -> Z bH)'
			write(13,204) BRA(24,37), 2, 24,  37, 'BR(A -> H+W-/H-W+)'
		endif

		!======================================================================
		!  Charged Higgs boson'
		!======================================================================
		!---------- initialization ----------
		Hpmdecay(:,:) = 0.d0; BRHpm(:,:) = 0.d0; Gam_Hpm_total = 0.d0

		!========== bosonic decay ==========
		Hpmdecay(24,35) = Gam_chWbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
		Hpmdecay(24,36) = Gam_chWA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)

		!========== total decay width ==========
		Gam_Hpm_total = sum(Hpmdecay)

		!========== decay branching ratio ==========
		if(Gam_Hpm_total == 0.d0) then
			write(13,99)
			write(13,98)'Decay branching ratios of the charged Higgs bosons by H-COUP #'
			write(13,201)
			write(13,202) 35,Gam_Hpm_total,C_EW,C_QCD
			write(13,203)
			write(13,204) 0.d0, 2, 24, 35, 'BR(H+ -> W+ bH)'
			write(13,204) 0.d0, 2, 24, 36, 'BR(H+ -> W+ A)'	
		else if(Gam_Hpm_total /= 0.d0) then
			BRHpm = Hpmdecay/Gam_Hpm_total
			write(13,99)
			write(13,98)'Decay branching ratios of the charged Higgs bosons by H-COUP #'
			write(13,201)
			write(13,202) 35,Gam_Hpm_total,C_EW,C_QCD
			write(13,203)
			write(13,204) BRHpm(24,35), 2, 24, 35, 'BR(H+ -> W+ bH)'
			write(13,204) BRHpm(24,36), 2, 24, 36, 'BR(H+ -> W+ A)'	
		endif



		!###################################   Partial decay width   ########################################
		!===================================   SM OUTPUTS   ========================================
		open(22,file="outputs/outGamma_sm.txt")  
		call header_outputs(22)
		write(22,101) 'MODEL'
		write(22,102) 1,0,'SM'          
		
		write(22,101) 'SMINPUTS'
		write(22,103) 1,alpha_em,'alpha_em' 
		write(22,103) 2,G_F,'Fermi constant' 
		write(22,103) 3,alpha_s,'alpha_s' 
		write(22,103) 4,mc_MS,'mc(mc) MSbar'
		write(22,103) 5,mb_MS,'mb(mb) MSbar'
		write(22,103) 6,mc,'mc On-shell'
		write(22,103) 7,mb,'mb On-shell'
		
		write(22,101) 'MASS'        
		!write(22,103) 1,0.,'md'
		!write(22,103) 2,0.,'mu'
		!write(22,103) 3,0.,'ms'
		write(22,103) 4,rmc_mh,'mc(mh) MSbar'
		write(22,103) 5,rmb_mh,'mb(mh) MSbar'
		write(22,103) 6,mt,'mt'                
		write(22,103) 13,mmu,'mmu'        
		write(22,103) 15,mtau,'mtau'
		write(22,103) 23,mz,'mz'
		write(22,103) 24,mw,'mw (calculated,tree)' 
		write(22,103) 24,rmw_SM(),'mw (calculated,1-loop)' 
		write(22,103) 25,mh,'mh'

		!======================================================================
		!  SM Higgs boson'
		!======================================================================
		write(22,99)
		write(22,98)'Partial decay widths of the SM Higgs boson by H-COUP #'
		write(22,201)
		write(22,202) 25,Gam_h_total_SM,C_EW,C_QCD
		write(22,213)
		write(22,204) hdecay_SM(4,-4),   2,  4,  -4, 'Gamma(h -> c c~)'
		write(22,204) hdecay_SM(5,-5),   2,  5,  -5, 'Gamma(h -> b b~)'
		write(22,204) hdecay_SM(13,-13), 2, 13, -13, 'Gamma(h -> mu- mu+)'
		write(22,204) hdecay_SM(15,-15), 2, 15, -15, 'Gamma(h -> tau- tau+)'
		write(22,204) hdecay_SM(21,21),  2, 21,  21, 'Gamma(h -> g g)'
		write(22,204) hdecay_SM(22,22),  2, 22,  22, 'Gamma(h -> gam gam)'
		write(22,204) hdecay_SM(22,23),  2, 22,  23, 'Gamma(h -> gam Z)'
		write(22,204) hdecay_SM(23,23),  2, 23,  23, 'Gamma(h -> Z Z*)'
		write(22,204) hdecay_SM(24,-24), 2, 24, -24, 'Gamma(h -> W+ W-*)'

		!===================================   IDM OUTPUTS   ========================================
		open(23,file="outputs/outGamma_idm.txt") 
		call header_outputs(23)
		write(23,101) 'MODEL'
		write(23,102) 1,3,'IDM'
		
		write(23,101) 'BSMINPUTS'
		write(23,103) 1,mu2sq,'mu_2^2 (GeV^2)' 
		write(23,103) 2,lam2,'lambda_2'    
		write(23,103) 3,mu_r,'mu_r (GeV)' 

		write(23,101) 'SMINPUTS'
		write(23,103) 1,alpha_em,'alpha_em' 
		write(23,103) 2,G_F,'Fermi constant' 
		write(23,103) 3,alpha_s,'alpha_s' 
		write(23,103) 4,mc_MS,'mc(mc) MSbar'
		write(23,103) 5,mb_MS,'mb(mb) MSbar'
		write(23,103) 6,mc,'mc On-shell'
		write(23,103) 7,mb,'mb On-shell'
				  
		write(23,101) 'MASS'        
		!write(23,103) 1,0.,'md'
		!write(23,103) 2,0.,'mu'
		!write(23,103) 3,0.,'ms'
		write(23,103) 4,rmc_mh,'mc(mh) MSbar'
		write(23,103) 5,rmb_mh,'mb(mh) MSbar'
		write(23,103) 6,mt,'mt'                
		write(23,103) 13,mmu,'mmu'
		write(23,103) 15,mtau,'mtau'
		write(23,103) 23,mz,'mz'
		write(23,103) 24,mw,'mw (calculated,tree)' 
		write(23,103) 24,rmW(mhp,mhn,ma,mu2,lam2),'mw (calculated,1-loop)' 
		write(23,103) 25,mh,'mh'
		write(23,103) 35,mhn,'mH' 
		write(23,103) 36,ma,'mA' 
		write(23,103) 37,mhp,'mH+' 

		write(23,101) 'CONSTRAINTS'
		write(23,103) 0,cutoff,'The cutoff scale (GeV)'
		write(23,102) 1,constraint(1),'Vacuum stability at tree level [0=OK, 1=No]'
		write(23,102) 2,constraint(2),'Tree-level unitarity [0=OK, 1=No]'
		write(23,102) 3,constraint(3),'S and T parameters [0=OK, 1=No]'
		write(23,102) 4,constraint(4),'True vacuum [0=OK, 1=No]'
		write(23,102) 5,constraint(5),'Vacuum stability (RGE improved with the cutoff scale) [0=OK, 1=No]'
		write(23,102) 6,constraint(6),'Triviality (with the cutoff scale) [0=OK, 1=No]'

		!======================================================================
		!  Lighter CP-even Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the SM-like Higgs boson by H-COUP #'
		write(23,201)
		write(23,202) 25,Gam_h_total,C_EW,C_QCD
		write(23,213)
		write(23,204) hdecay(4,-4),   2,  4,  -4, 'Gamma(h -> c c~)'
		write(23,204) hdecay(5,-5),   2,  5,  -5, 'Gamma(h -> b b~)'
		write(23,204) hdecay(13,-13), 2, 13, -13, 'Gamma(h -> mu- mu+)'
		write(23,204) hdecay(15,-15), 2, 15, -15, 'Gamma(h -> tau- tau+)'
		write(23,204) hdecay(21,21),  2, 21,  21, 'Gamma(h -> g g)'
		write(23,204) hdecay(22,22),  2, 22,  22, 'Gamma(h -> gam gam)'
		write(23,204) hdecay(22,23),  2, 22,  23, 'Gamma(h -> gam Z)'
		write(23,204) hdecay(23,23),  2, 23,  23, 'Gamma(h -> Z Z*)'
		write(23,204) hdecay(24,-24), 2, 24, -24, 'Gamma(h -> W+ W-*)'
		write(23,204) hdecay(35,35),  2, 35,  35, 'Gamma(h -> bH bH)'
		write(23,204) hdecay(36,36),  2, 36,  36, 'Gamma(h -> A A)'
		write(23,204) hdecay(37,-37), 2, 37, -37, 'Gamma(h -> H+ H-)'

		!======================================================================
		!  Heavier CP-even Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the additional CP-even Higgs boson by H-COUP #'
		write(23,201)
		write(23,202) 35,Gam_bH_total,C_EW,C_QCD
		write(23,213)
		write(23,204) bHdecay(23,36), 2, 23,  36, 'Gamma(bH -> A Z)'
		write(23,204) bHdecay(24,37), 2, 24,  37, 'Gamma(bH -> H+W-/H-W+)'

		!======================================================================
		!  CP-odd Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the CP-odd Higgs boson by H-COUP #'
		write(23,201)
		write(23,202) 35,Gam_A_total,C_EW,C_QCD
		write(23,213)
		write(23,204) Adecay(23,35), 2, 23,  35, 'Gamma(A -> Z bH)'
		write(23,204) Adecay(24,37), 2, 24,  37, 'Gamma(A -> H+W-/H-W+)'

		!======================================================================
		!  Charged Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the charged Higgs bosons by H-COUP #'
		write(23,201)
		write(23,202) 35,Gam_Hpm_total,C_EW,C_QCD
		write(23,213)
		write(23,204) Hpmdecay(24,35), 2, 24, 35, 'Gamma(H+ -> W+ bH)'
		write(23,204) Hpmdecay(24,36), 2, 24, 36, 'Gamma(H+ -> W+ A)'	
		
	endif

	contains
!#################################################
!
!    SECTION I Parameter translations
!
!#################################################
	double precision function mu1(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	mu1 = -mh**2/2.d0

	end function
!========= physical parameters -> lambda1-lambda5 =======
	double precision function lam1(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	lam1 = mh**2/vev**2

	end function
!------------------------------------
	double precision function lam3(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	lam3 = 2.d0/vev**2*(mhp**2-mu2)

	end function
!------------------------------------
	double precision function lam4(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	lam4 = 1.d0/vev**2*(mhn**2+ma**2-2.d0*mhp**2)

	end function
!------------------------------------
	double precision function lam5(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	lam5 = 1.d0/vev**2*(mhn**2-ma**2)

	end function
!#################################################
!
!    SECTION II Tree-level couplings
!
!#################################################
!========================================================   
! SSS Couplings
!========================================================
	double precision function g_h_h_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_h_h_h = -1.d0/(2.d0*vev)*mh**2

	end function
!-------------------------------------------------------
	double precision function g_g0_g0_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_g0_h = -1.d0/(2.d0*vev)*mh**2

	end function
!-------------------------------------------------------
	double precision function g_gp_gm_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_gp_gm_h = -1.d0/vev*mh**2

	end function
!-------------------------------------------------------
	double precision function g_hn_hn_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_hn_h = -1.d0/vev*(mhn**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_a_a_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_a_a_h = -1.d0/vev*(ma**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_hp_hm_h(mhp,mhn,ma,mu2,lam2)
	double precision  mhp,mhn,ma,mu2,lam2

	g_hp_hm_h = -2.d0/vev*(mhp**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_hn_a_g0(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_a_g0 = -1.d0/vev*(mhn**2-ma**2)

	end function
!-------------------------------------------------------
	double precision function g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_hp_gm = -1.d0/vev*(mhn**2-mhp**2)

	end function
!-------------------------------------------------------
	complex (kind(0d0)) function g_a_hp_gm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_a_hp_gm = ii/vev*(ma**2-mhp**2)

	end function
!========================================================   
! SSSS Couplings
!========================================================
	double precision function g_h_h_h_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_h_h_h_h = -mh**2/8.d0/vev**2

	end function
!-------------------------------------------------------
	double precision function g_g0_g0_h_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_g0_h_h = -mh**2/4.d0/vev**2

	end function
!-------------------------------------------------------
	double precision function g_g0_g0_g0_g0(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_g0_g0_g0 = -mh**2/8.d0/vev**2

	end function
!-------------------------------------------------------
	double precision function g_gp_gm_gp_gm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_gp_gm_gp_gm = -mh**2/2.d0/vev**2

	end function
!-------------------------------------------------------
	double precision function g_gp_gm_h_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_gp_gm_h_h = -mh**2/2.d0/vev**2

	end function
!-------------------------------------------------------
	double precision function g_g0_g0_gp_gm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_g0_gp_gm = -mh**2/8.d0/vev**2

	end function
!-------------------------------------------------------
	double precision function g_hn_hn_hn_hn(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_hn_hn_hn = -1.d0/8.d0*lam2

	end function
!-------------------------------------------------------
	double precision function g_hn_hn_a_a(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_hn_a_a = -1.d0/4.d0*lam2

	end function
!-------------------------------------------------------
	double precision function g_a_a_a_a(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_a_a_a_a = -1.d0/8.d0*lam2

	end function
!-------------------------------------------------------
	double precision function g_hp_hm_hp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hp_hm_hp_hm = -1.d0/2.d0*lam2

	end function
!-------------------------------------------------------
	double precision function g_hn_hn_hp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_hn_hp_hm = -1.d0/2.d0*lam2

	end function
!-------------------------------------------------------
	double precision function g_a_a_hp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_a_a_hp_hm = -1.d0/2.d0*lam2

	end function
!-------------------------------------------------------
	double precision function g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hp_hm_h_h = -1.d0/vev**2*(mhp**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_g0_g0_hp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_g0_hp_hm = -1.d0/vev**2*(mhp**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_hn_hn_gp_gm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_hn_gp_gm = -1.d0/vev**2*(mhp**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_a_a_gp_gm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_a_a_gp_gm = -1.d0/vev**2*(mhp**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_hn_h_h = -1.d0/2.d0/vev**2*(mhn**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_g0_g0_a_a(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_g0_a_a = -1.d0/2.d0/vev**2*(mhn**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_a_a_h_h(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_a_a_h_h = -1.d0/2.d0/vev**2*(ma**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_g0_g0_hn_hn(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_g0_hn_hn = -1.d0/2.d0/vev**2*(ma**2-mu2)

	end function
!-------------------------------------------------------
	double precision function g_h_hn_gp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_h_hn_gp_hm = -1.d0/vev**2*(mhn**2-mhp**2)

	end function
!-------------------------------------------------------
	double precision function g_g0_a_gp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_g0_a_gp_hm = -1.d0/vev**2*(mhn**2-mhp**2)

	end function
!-------------------------------------------------------
	complex (kind(0d0)) function g_h_a_gp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_h_a_gp_hm = -ii/vev**2*(ma**2-mhp**2)

	end function
!-------------------------------------------------------
	complex (kind(0d0)) function g_hn_g0_gp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_hn_g0_gp_hm = ii/vev**2*(ma**2-mhp**2)

	end function
!-------------------------------------------------------
	double precision function g_gp_gm_hp_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_gp_gm_hp_hm = -1.d0/vev**2*(mhn**2+ma**2-2.d0*mu2)

	end function
!-------------------------------------------------------
	double precision function g_gp_gp_hm_hm(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_gp_gp_hm_hm = -1.d0/(2.d0*vev**2)*(mhn**2-ma**2)

	end function
!-------------------------------------------------------
	double precision function g_h_hn_g0_a(mhp,mhn,ma,mu2,lam2)
	double precision mhp,mhn,ma,mu2,lam2

	g_h_hn_g0_a = -1.d0/vev**2*(mhn**2-ma**2)

	end function
!#################################################
!
!    SECTION III Constraints on parameter space
!
!#################################################
!============ Perturbative unitarity ===================
	double precision function a0ap(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0ap =&
	1.d0/(16.d0*pi)*(&
		+3.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)+lam2)&
		+dsqrt(&
			+9.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)-lam2)**2&
			+(2.d0*lam3(mhp,mhn,ma,mu2,lam2)+lam4(mhp,mhn,ma,mu2,lam2))**2&
		)&
	)

	end function 
!------------------------------------
	double precision function a0am(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0am=&
	(3.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)-&
	dsqrt(9.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+(2.d0*lam3(mhp,mhn,ma,mu2,lam2)&
	+lam4(mhp,mhn,ma,mu2,lam2))**2)&
	)/(16.d0*pi)

	end function
!------------------------------------
	double precision function a0bp(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0bp=(1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)+&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam4(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	end function
!------------------------------------
	double precision function a0bm(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0bm=(1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)-&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam4(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	end function 
!------------------------------------
	double precision function a0cp(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0cp=(1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)+&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam5(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	end function 
!------------------------------------
	double precision function a0cm(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0cm=&
       (1.d0/2.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	+lam2)-&
	dsqrt(1.d0/4.d0*(lam1(mhp,mhn,ma,mu2,lam2)&
	-lam2)**2&
	+lam5(mhp,mhn,ma,mu2,lam2)**2)&
	)/(16.d0*pi)

	end function 
!------------------------------------
	double precision function a0e1(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0e1=(lam3(mhp,mhn,ma,mu2,lam2)&
	+2.d0*lam4(mhp,mhn,ma,mu2,lam2)&
	-3.d0*lam5(mhp,mhn,ma,mu2,lam2)&
	)/(16.d0*pi)

	end function
!------------------------------------
	double precision function a0e2(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0e2=(lam3(mhp,mhn,ma,mu2,lam2)&
	-lam5(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	end function
!------------------------------------
	double precision function a0fp(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0fp=(lam3(mhp,mhn,ma,mu2,lam2)&
	 +2.d0*lam4(mhp,mhn,ma,mu2,lam2)&
	 +3.d0*lam5(mhp,mhn,ma,mu2,lam2)&
	)/(16.d0*pi)

	end function
!------------------------------------
	double precision function a0fm(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0fm=(lam3(mhp,mhn,ma,mu2,lam2)&
	+lam5(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	end function
!------------------------------------
	double precision function a0f1(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0f1=(lam3(mhp,mhn,ma,mu2,lam2)&
	+lam4(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	end function
!------------------------------------
	double precision function a0p(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	a0p=(lam3(mhp,mhn,ma,mu2,lam2)&
	-lam4(mhp,mhn,ma,mu2,lam2))/(16.d0*pi)

	end function
!------------------------------------
	double precision function pu(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	if (dabs(a0ap(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=1.d0
	else if (dabs(a0am(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=2.d0
	else if (dabs(a0bp(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=3.d0
	else if (dabs(a0bm(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=4.d0
	else if (dabs(a0cp(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=5.d0
	else if (dabs(a0cm(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=6.d0
	else if (dabs(a0e1(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=7.d0
	else if (dabs(a0e2(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=8.d0
	else if (dabs(a0fp(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=9.d0
	else if (dabs(a0fm(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=10.d0
	else if (dabs(a0f1(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=11.d0
	else if (dabs(a0p(mhp,mhn,ma,mu2,lam2)) .gt. lqt) then
		pu=12.d0
	else
		pu=0.d0
	end if

	end function
!------------------------------------
	double precision function vs(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: tmp1,tmp2,stab

	tmp1 = lam4(mhp,mhn,ma,mu2,lam2)+lam5(mhp,mhn,ma,mu2,lam2)
	tmp2 = lam4(mhp,mhn,ma,mu2,lam2)-lam5(mhp,mhn,ma,mu2,lam2)

	stab =&
		dsqrt(lam1(mhp,mhn,ma,mu2,lam2)*lam2)&
		+lam3(mhp,mhn,ma,mu2,lam2)+dmin1(0.d0,tmp1,tmp2)     

	if (lam1(mhp,mhn,ma,mu2,lam2) .le. 0.d0) then  ! KS: I modified .lt. to .le. for all if sentences 19/3/19
		vs=1.d0
	else if (lam2 .le. 0.d0) then
		vs=2.d0
	else if (stab .le. 0.d0) then
		vs=3.d0  
	else 
	 	vs=0.d0
	end if

	end function vs
!================= true vacuum conditions =======================================
	double precision function true_vacuum(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: vmu1,vmu2,vlam1,vlam2,vlam3,vlam4,vlam5
	double precision:: Rate

	vmu1 = mu1(mhp,mhn,ma,mu2,lam2)
	vmu2 = mu2
	vlam1 = lam1(mhp,mhn,ma,mu2,lam2)
	vlam2 = lam2
	vlam3 = lam3(mhp,mhn,ma,mu2,lam2)
	vlam4 = lam4(mhp,mhn,ma,mu2,lam2)
	vlam5 = lam5(mhp,mhn,ma,mu2,lam2)

	Rate = (vlam3+vlam4+vlam5)/sqrt(vlam1*vlam2)

	true_vacuum = 0.d0

	if(vmu1 > 0.d0 .and. vmu2 > 0.d0) then
		true_vacuum = 1.d0 !EW symmetric minima
	else if(vlam4-abs(vlam5) > 0.d0) then
		true_vacuum = 2.d0 !charge breaking minima
	endif

	if(Rate > 1.d0) then
		if(vmu1/sqrt(vlam1) > vmu2/sqrt(vlam2)) then
			true_vacuum = 3.d0
		endif
	else if(abs(Rate) < 1.d0) then
		if(Rate*vmu1/sqrt(vlam1) > vmu2/sqrt(vlam2)) then
			true_vacuum = 4.d0
		endif
	endif

	end function
!#################################################
!
!    SECTION IV 1PI diagrams
!
!#################################################
!========================================================              
!	Gauge boson's two point functions
!========================================================
	double complex function PiWW_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	PiWW_B = PiWW_B_SM(qsq)&
		+1.d0/(16.d0*pi**2)*g**2/4.d0*(b5f(qsq,mhn,mhp)+b5f(qsq,ma,mhp)) 

	end function
!-------------------------------------------------------
	double complex function PiZZ_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	PiZZ_B = PiZZ_B_SM(qsq)&
		+1.d0/16.d0/pi**2*mz**2*(1.d0-4.d0*sw**2*cw**2)/vev**2&
			*b5f(qsq,mhp,mhp)&
		+1.d0/16.d0/pi**2*mz**2/vev**2*b5f(qsq,mhn,ma)

	end function
!-------------------------------------------------------
	double complex function PiGG_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	PiGG_B = PiGG_B_WOH(qsq)&
		+1.d0/16.d0/pi**2*(g*sw)**2*b5f(qsq,mhp,mhp)

	end function
!-------------------------------------------------------
	double complex function PiZG_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	PiZG_B = PiZG_B_WOH(qsq) &
		+1.d0/16.d0/pi**2*(g*sw)*(g/cw)/2.d0*(cw**2-sw**2)*b5f(qsq,mhp,mhp)   

	end function
!-------------------------------------------------------
	double complex function dPiGG_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPiGG_B =dPiGG_B_WOH(qsq) &
			+1.d0/16.d0/pi**2*(g*sw)**2*db5f(qsq,mhp,mhp)  

	end function
!====== Fermion two-point functions ========
	double complex function Pitt_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitt_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mt,mphoton)-1.d0)&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mt,mZ)-1.d0)&
	+mt**2/vev**2*(b0f(qsq,mt,mz)-b0f(qsq,mt,mh)&
	+2.d0*mb**2/mt**2*b0f(qsq,mb,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function Picc_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	Picc_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mc,mphoton)-1.d0)&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mc,mZ)-1.d0)&
	+mc**2/vev**2*(b0f(qsq,mc,mz)-b0f(qsq,mc,mh)&
	+2.d0*ms**2/mc**2*b0f(qsq,ms,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function Pibb_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pibb_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qb**2*(2.d0*b0f(qsq,mb,mphoton)-1.d0)&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*b0f(qsq,mb,mZ)-1.d0)&
	+mb**2/vev**2*(b0f(qsq,mb,mz)-b0f(qsq,mb,mh)+2.d0*mt**2/mb**2*b0f(qsq,mt,mw))&
	)
	
	end function
!---------------------------------------------
	double complex function Pitautau_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitautau_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qe**2*(2.d0*b0f(qsq,mtau,mphoton)-1.d0)&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*b0f(qsq,mtau,mZ)-1.d0)&
	+mtau**2/vev**2*(b0f(qsq,mtau,mz)-b0f(qsq,mtau,mh)   )&
	)
	
	end function
!---------------------------------------------
	double complex function Pimumu_S(qsq,mh)
	double precision, intent(in):: mh,qsq


	Pimumu_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qe**2*(2.d0*b0f(qsq,mmu,mphoton)-1.d0)&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*b0f(qsq,mmu,mZ)-1.d0)&
	+mmu**2/vev**2*(b0f(qsq,mmu,mz)-b0f(qsq,mmu,mh)   )&
	)
	
	end function
!---------------------------------------------
	double complex function Pitt_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitt_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mt,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
	+mt**2/vev**2*(b1f(qsq,mt,mh)+b1f(qsq,mt,mz)&
	+(mb**2+mt**2)/mt**2*b1f(qsq,mb,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function Picc_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Picc_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mc,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
	+mc**2/vev**2*(b1f(qsq,mc,mh)+b1f(qsq,mc,mz)&
	+(ms**2+mc**2)/mc**2*b1f(qsq,ms,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function Pibb_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pibb_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qb**2*(2.d0*b1f(qsq,mb,mphoton)+1.d0)&
	+gz**2*(vb**2+ab**2)*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
	+mb**2/vev**2*( b1f(qsq,mb,mh)+b1f(qsq,mb,mz)+(mb**2+mt**2)/mb**2*b1f(qsq,mt,mw) )&	
	)
	
	end function
!---------------------------------------------
	double complex function Pitautau_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitautau_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qe**2*(2.d0*b1f(qsq,mtau,mphoton)+1.d0)&
	+gz**2*(ve**2+ae**2)*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mtau**2/vev**2*(b1f(qsq,mtau,mh)+b1f(qsq,mtau,mz)+b1f(qsq,m0,mw) )&	        
	)
	
	end function
!---------------------------------------------
	double complex function Pimumu_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pimumu_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qe**2*(2.d0*b1f(qsq,mmu,mphoton)+1.d0)&
	+gz**2*(ve**2+ae**2)*(2.d0*b1f(qsq,mmu,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mmu**2/vev**2*(b1f(qsq,mmu,mh)+b1f(qsq,mmu,mz)+b1f(qsq,m0,mw) )&	        
	)
	
	end function

!---------------------------------------------
	double complex function Pitt_A(qsq,mh)
	double precision, intent(in):: mh,qsq


	Pitt_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
	+(mt**2-mb**2)/vev**2*b1f(qsq,mb,mw)&	
	)
	
	end function
!---------------------------------------------
	double complex function Picc_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	Picc_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
	+(mc**2-ms**2)/vev**2*b1f(qsq,ms,mw)&	
	)
	
	end function
!---------------------------------------------
	double complex function Pibb_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pibb_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vb*ab*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
	+(mb**2-mt**2)/vev**2*b1f(qsq,mt,mw)&	
	)
	
	end function
!---------------------------------------------
	double complex function Pitautau_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pitautau_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mtau**2/vev**2*b1f(qsq,m0,mW)&	
	)
	
	end function
!---------------------------------------------
	double complex function Pimumu_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	Pimumu_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*b1f(qsq,mmu,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mmu**2/vev**2*b1f(qsq,m0,mW)&	
	)
	
	end function

!===================================================
	double complex function dPitt_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitt_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mt,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mt,mZ))&
	+mt**2/vev**2*(db0f(qsq,mt,mz)-db0f(qsq,mt,mh)&
	+2.d0*mb**2/mt**2*db0f(qsq,mb,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPicc_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPicc_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mc,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mc,mZ))&
	+mc**2/vev**2*(db0f(qsq,mc,mz)-db0f(qsq,mc,mh)&
	+2.d0*ms**2/mc**2*db0f(qsq,ms,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPibb_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPibb_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qb**2*(2.d0*db0f(qsq,mb,mphoton))&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*db0f(qsq,mb,mZ))&
	+mb**2/vev**2*(db0f(qsq,mb,mz)-db0f(qsq,mb,mh)&
	+2.d0*mt**2/mb**2*db0f(qsq,mt,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPitautau_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitautau_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qe**2*(&
        QED*2.d0*db0f(qsq,mtau,mphoton))&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*db0f(qsq,mtau,mZ))&
	+mtau**2/vev**2*(db0f(qsq,mtau,mz)-db0f(qsq,mtau,mh)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPimumu_S(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPimumu_S= -1.d0/(16.d0*pi**2)*(&
	2.d0*(g*sw)**2*Qe**2*(&
        QED*2.d0*db0f(qsq,mmu,mphoton))&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*db0f(qsq,mmu,mZ))&
	+mmu**2/vev**2*(db0f(qsq,mmu,mz)-db0f(qsq,mmu,mh)&	
	            )&
	)
	
	end function

!---------------------------------------------
	double complex function dPitt_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitt_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mt,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mt,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+mt**2/vev**2*(db1f(qsq,mt,mh)+db1f(qsq,mt,mz)&
	+(mb**2+mt**2)/mt**2*db1f(qsq,mb,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPicc_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPicc_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mc,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mc,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+mc**2/vev**2*(db1f(qsq,mc,mh)+db1f(qsq,mc,mz)&
	+(ms**2+mc**2)/mc**2*db1f(qsq,ms,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPibb_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPibb_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qb**2*(2.d0*db1f(qsq,mb,mphoton))&
	+gz**2*(vb**2+ab**2)*(2.d0*db1f(qsq,mb,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+mb**2/vev**2*(db1f(qsq,mb,mh)+db1f(qsq,mb,mz)&
	+(mb**2+mt**2)/mb**2*db1f(qsq,mt,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPitautau_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitautau_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qe**2*(2.d0*db1f(qsq,mtau,mphoton))&
	+gz**2*(ve**2+ae**2)*(2.d0*db1f(qsq,mtau,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*( db1f(qsq,mtau,mh)+db1f(qsq,mtau,mz)&
	+db1f(qsq,m0,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPimumu_V(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPimumu_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qe**2*(2.d0*db1f(qsq,mmu,mphoton))&
	+gz**2*(ve**2+ae**2)*(2.d0*db1f(qsq,mmu,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mmu**2/vev**2*( db1f(qsq,mmu,mh)+db1f(qsq,mmu,mz)&
	+db1f(qsq,m0,mw)&	
	            )&
	)
	
	end function
!---------------------------------------------
	double complex function dPitt_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitt_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mt,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+(mt**2-mb**2)/vev**2*db1f(qsq,mb,mw)&	
	)
	
	end function
!---------------------------------------------
	double complex function dPicc_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPicc_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mc,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+(mc**2-ms**2)/vev**2*db1f(qsq,ms,mw)&	
	)
	
	end function
!---------------------------------------------
	double complex function dPibb_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPibb_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vb*ab*(2.d0*db1f(qsq,mb,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+(mb**2-mt**2)/vev**2*db1f(qsq,mt,mw)&	
	)
	
	end function
!---------------------------------------------
	double complex function dPitautau_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPitautau_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*db1f(qsq,mtau,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*db1f(qsq,m0,mw)&	
	)
	
	end function
!---------------------------------------------
	double complex function dPimumu_A(qsq,mh)
	double precision, intent(in):: mh,qsq

	dPimumu_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*db1f(qsq,mmu,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mmu**2/vev**2*db1f(qsq,m0,mw)&	
	)
	
	end function
!=======================================================
!	SM-like Higgs boson's one and two point functions
!=======================================================
	double complex function Th_F(mh)
	double precision, intent(in):: mh

	Th_F = 1.d0/(16.d0*pi**2)*(&
		! up type quarks
		-Nc*4.d0*mt**2/vev*a0f(mt)&
		-Nc*4.d0*mc**2/vev*a0f(mc)&
		! down type quarks
		-Nc*4.d0*mb**2/vev*a0f(mb)&
		-Nc*4.d0*ms**2/vev*a0f(ms)&
		! leptons
		-4.d0*mtau**2/vev*a0f(mtau)&
		-4.d0*mmu**2/vev*a0f(mmu)&
	)

	end function
!---------------------------------------------
	double complex function Th_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Th_B = 1.d0/(16.d0*pi**2)*(&
		-3.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mh)&
		-g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*a0f(mw)&
		-g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*a0f(mz)&
		+3.d0*g*mw*a0f(mw)+3.d0/2.d0*gz*mz*a0f(mz)-2.d0*g*mw**3-gz*mz**3&
	)&
	! contributions of new particles
	+1.d0/(16.d0*pi**2)*(&
		-g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*a0f(mhp)&
		-g_a_a_h(mhp,mhn,ma,mu2,lam2)*a0f(ma)&
		-g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*a0f(mhn)&
	)

	end function
!---------------------------------------------
	double complex function Pihh_F(qsq,mh)
	double precision, intent(in):: qsq,mh

	Pihh_F =&
	-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*(&
		+a0f(mt)&
		+(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	)&
!
	-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*(&
		+a0f(mc)&
		+(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	)&
!
	-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*(&
	  	+a0f(mb)&
		+(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	)&
!
	-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*(&
	  	+a0f(ms)&
		+(2.d0*ms**2-qsq/2.d0)*b0f(qsq,ms,ms)&
	)&
!
	-4.d0*mtau**2/(16.d0*pi**2*vev**2)*(&
		+a0f(mtau)&
		+(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	)&
!
	-4.d0*mmu**2/(16.d0*pi**2*vev**2)*(&
		+a0f(mmu)&
		+(2.d0*mmu**2-qsq/2.d0)*b0f(qsq,mmu,mmu)&
	)

	end function
!---------------------------------------------
	double complex function Pihh_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	Pihh_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
	  g**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
	  +g**2/2.d0*(3.d0)*a0f(mW)&
	  +gz**2/2.d0*(3.d0*mz**2-qsq)*b0f(qsq,mZ,mZ)&
	  +gz**2/4.d0*(3.d0)*a0f(mZ)&
	  -(+3.d0/2.d0)*(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	( -12.d0*g_h_h_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mh)&
	  -2.d0*g_gp_gm_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mw)&
          -2.d0*g_g0_g0_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mz)&
	  +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mw,mw)&
	  +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mz,mz)&
          +18.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mh,mh)&
	 	) &
! ! ! contributions of new particles
        +1.d0/(16.d0*pi**2)*(&
          +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mhn,mhn)&
          +g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mhp,mhp)&
          +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,ma,ma)&
          -2.d0*g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mhn)&
          -2.d0*g_a_a_h_h(mhp,mhn,ma,mu2,lam2)*a0f(ma)&
          -2.d0*g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mhp)&
         )

	end function
!===========================================
	double complex function dPihh_F(qsq,mh)
	double precision, intent(in):: qsq,mh

	dPihh_F=&
	-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
		+(-1.d0/2.d0)*b0f(qsq,mt,mt)&
	)&	
!
	-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
		+(-1.d0/2.d0)*b0f(qsq,mc,mc)&
	)&	
!
	-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
 	(&
 		+(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
 		+(-1.d0/2.d0)*b0f(qsq,mb,mb)&
 	)&
!
	 -4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
 	(&
 		+(2.d0*ms**2-qsq/2.d0)*db0f(qsq,ms,ms)&
 		+(-1.d0/2.d0)*b0f(qsq,ms,ms)&
 	)&
!
	-4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
		+(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
	)&
!
	-4.d0*mmu**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mmu**2-qsq/2.d0)*db0f(qsq,mmu,mmu)&
		+(-1.d0/2.d0)*b0f(qsq,mmu,mmu)&
	)

	end function
!---------------------------------------------
	double complex function dPihh_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPihh_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
	  g**2*(3.d0*mw**2-qsq)*db0f(qsq,mW,mW)&
	  +g**2*(-1.d0)*b0f(qsq,mW,mW)&
	  +gz**2/2.d0*(3.d0*mz**2-qsq)*db0f(qsq,mZ,mZ)&
	  +gz**2/2.d0*(-1.d0)*b0f(qsq,mZ,mZ)&
	) &

	+1.d0/(16.d0*pi**2)*&
	(&
	 +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mw,mw)&
	 +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mz,mz)&
	 +18.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mh,mh)&
	) &
! ! additional Higgs boson loop
        +1.d0/16.d0/pi**2*(&
          +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mhn,mhn)&
          +g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mhp,mhp)&
          +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,ma,ma)&
         )
	
	end function
!=======================================================
!  Two point function of bH
!=======================================================
	double complex function Pihnhn_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	Pihnhn_B = 1.d0/(16.d0*pi**2)*(&
		!===== V =====
		+2.d0*g**2*(a0f(mW)-mW**2/2.d0)&
		+gz**2*(a0f(mZ)-mZ**2/2.d0)&
		!===== SV =====
		-g**2/2.d0*(2.d0*a0f(mW)-a0f(mhp)+(2.d0*mhp**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mhp))&
		-gz**2/4.d0*(2.d0*a0f(mZ)-a0f(ma)+(2.d0*ma**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,ma))&
		!===== S =====
		-2.d0*g_hn_hn_gp_gm(mhp,mhn,ma,mu2,lam2)*a0f(mw)&
		-2.d0*g_g0_g0_hn_hn(mhp,mhn,ma,mu2,lam2)*a0f(mz)&
		-2.d0*g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mh)&
		-2.d0*g_hn_hn_hp_hm(mhp,mhn,ma,mu2,lam2)*a0f(mhp)&
		-2.d0*g_hn_hn_a_a(mhp,mhn,ma,mu2,lam2)*a0f(ma)&
		-12.d0*g_hn_hn_hn_hn(mhp,mhn,ma,mu2,lam2)*a0f(mhn)&
		!===== SS =====
		+2.d0*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mhp,mw)&
		+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,ma,mz)&
		+4.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mhn,mh)&
	)

	end function
!---------------------------------------------
	double complex function dPihnhn_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPihnhn_B = 1.d0/(16.d0*pi**2)*(&
		!===== SV =====
		-g**2*b0f(qsq,mW,mhp)&
		-g**2/2.d0*(2.d0*mhp**2-mW**2+2.d0*qsq)*db0f(qsq,mW,mhp)&
		-gz**2/2.d0*b0f(qsq,mZ,ma)&
		-gz**2/4.d0*(2.d0*ma**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,ma)&
		!===== SS =====
		+2.d0*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mhp,mw)&
		+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,ma,mz)&
		+4.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mhn,mh)&
	)

	end function
!=======================================================
!  Two point function of A
!=======================================================
	double complex function Piaa_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	Piaa_B = 1.d0/(16.d0*pi**2)*(&
		!===== V =====
		+2.d0*g**2*(a0f(mW)-mW**2/2.d0)&
		+gz**2*(a0f(mZ)-mZ**2/2.d0)&
		!===== SV =====
		-g**2/2.d0*(2.d0*a0f(mW)-a0f(mhp)+(2.d0*mhp**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mhp))&
		-gz**2/4.d0*(2.d0*a0f(mZ)-a0f(mhn)+(2.d0*mhn**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mhn))&
		!===== S =====
		-2.d0*g_a_a_gp_gm(mhp,mhn,ma,mu2,lam2)*a0f(mw)&
		-2.d0*g_g0_g0_a_a(mhp,mhn,ma,mu2,lam2)*a0f(mz)&
		-2.d0*g_a_a_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mh)&
		-2.d0*g_a_a_hp_hm(mhp,mhn,ma,mu2,lam2)*a0f(mhp)&
		-2.d0*g_hn_hn_a_a(mhp,mhn,ma,mu2,lam2)*a0f(mhn)&
		-12.d0*g_a_a_a_a(mhp,mhn,ma,mu2,lam2)*a0f(ma)&
		!===== SS =====
		+2.d0*abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2*b0f(qsq,mhp,mw)&
		+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mhn,mz)&
		+4.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,ma,mh)&
	)

	end function
!---------------------------------------------
	double complex function dPiaa_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPiaa_B = 1.d0/(16.d0*pi**2)*(&
		!===== SV =====
		-g**2*b0f(qsq,mW,mhp)&
		-g**2/2.d0*(2.d0*mhp**2-mW**2+2.d0*qsq)*db0f(qsq,mW,mhp)&
		-gz**2/2.d0*b0f(qsq,mZ,mhn)&
		-gz**2/4.d0*(2.d0*mhn**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,mhn)&
		!===== SS =====
		+2.d0*abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2*db0f(qsq,mhp,mw)&
		+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mhn,mz)&
		+4.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,ma,mh)&
	)

	end function
!=======================================================
!  Two point function of H±
!=======================================================
	double complex function Pihphm_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	Pihphm_B = 1.d0/(16.d0*pi**2)*(&
		!===== V =====
		+2.d0*g**2*(a0f(mW)-mW**2/2.d0)&
		+gz**2*(cw**2-sw**2)**2*(a0f(mZ)-mZ**2/2.d0)&
		+4.d0*(g*sw)**2*(a0f(mphoton)-mphoton**2/2.d0)&
		!===== SV =====
		-g**2/4.d0*(2.d0*a0f(mW)-a0f(mhn)+(2.d0*mhn**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mhn))&
		-g**2/4.d0*(2.d0*a0f(mW)-a0f(ma)+(2.d0*ma**2-mW**2+2.d0*qsq)*b0f(qsq,mW,ma))&
		-gz**2/4.d0*(cw**2-sw**2)**2*(&
			2.d0*a0f(mZ)-a0f(mhp)+(2.d0*mhp**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mhp)&
		)&
		-(g*sw)**2*(&
			2.d0*a0f(mphoton)-a0f(mhp)+(2.d0*mhp**2-mphoton**2+2.d0*qsq)*b0f(qsq,mphoton,mhp)&
		)&
		!===== S =====
		-g_gp_gm_hp_hm(mhp,mhn,ma,mu2,lam2)*a0f(mw)&
		-g_g0_g0_hp_hm(mhp,mhn,ma,mu2,lam2)*a0f(mz)&
		-g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)*a0f(mh)&
		-4.d0*g_hp_hm_hp_hm(mhp,mhn,ma,mu2,lam2)*a0f(mhp)&
		-g_a_a_hp_hm(mhp,mhn,ma,mu2,lam2)*a0f(ma)&
		-g_hn_hn_hp_hm(mhp,mhn,ma,mu2,lam2)*a0f(mhn)&
		!===== SS =====
		+g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mw,mhn)&
		+abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2*b0f(qsq,mw,ma)&
		+g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**2*b0f(qsq,mh,mhp)&
	)

	end function
!---------------------------------------------
	double complex function dPihphm_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPihphm_B = 1.d0/(16.d0*pi**2)*(&
		!===== SV =====
		-g**2/2.d0*b0f(qsq,mW,mhn)&
		-g**2/4.d0*(2.d0*mhn**2-mW**2+2.d0*qsq)*db0f(qsq,mW,mhn)&
		-g**2/2.d0*b0f(qsq,mW,ma)&
		-g**2/4.d0*(2.d0*ma**2-mW**2+2.d0*qsq)*db0f(qsq,mW,ma)&
		-gz**2/2.d0*(cw**2-sw**2)**2*b0f(qsq,mZ,mhp)&
		-gz**2/4.d0*(cw**2-sw**2)**2*(2.d0*mhp**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,mhp)&
		-2.d0*(g*sw)**2*b0f(qsq,mphoton,mhp)&
		-(g*sw)**2*(2.d0*mhp**2-mphoton**2+2.d0*qsq)*db0f(qsq,mphoton,mhp)&
		!===== SS =====
		+g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mw,mhn)&
		+abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2*db0f(qsq,mw,ma)&
		+g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**2*db0f(qsq,mh,mhp)&
	)

	end function
!=======================================================
!  hZZ vertex
!=======================================================
	double complex function M1_hZZ_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M1_hZZ_F = Gam1_hZZ_F_SM(p1sq,p2sq,qsq)
	
	end function
!--------------------------------------------
	double complex function M2_hZZ_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M2_hZZ_F =  Gam2_hZZ_F_SM(p1sq,p2sq,qsq)
	
	end function
!--------------------------------------------
	double complex function M3_hZZ_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M3_hZZ_F = Gam3_hZZ_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	double complex function M1_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M1_hZZ_B = &
	 -gz**2*1.d0/(16.d0*pi**2)*&
	 (&
	 +2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mw,mw,mw)&
	 +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mz,mh,mz)&
	 +6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mh,mz,mh)&
	 )&

	 +gz**2*1.d0/(16.d0*pi**2)*&
	 (&
	 +1.d0/2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*b0f(qsq,mw,mw)&
	 +1.d0/2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mz,mz)&
	 +3.d0/2.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mh,mh)&
	 )&
!~~~~~~~~~~~ Gauge Boson Loops ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
 	+1.d0/(16.d0*pi**2)*(&
 	 +2.d0*g**3*mw*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&
 	 +g**3*mw*sw**2*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)& 
 	 +g**3*mw*sw**2*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&	 
 	 -2.d0*g**3*mw**3/cw**2*sw**4*c0f(p1sq,p2sq,qsq,mW,mw,mW)&
 	 -2.d0*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mw,mw)&
 	 -g*gz**2*mw*(cw**2-sw**2)*sw**2*&
 	 ( c24f(p1sq,p2sq,qsq,mW,mw,mw)+c24f(p1sq,p2sq,qsq,mw,mw,mW) )&
 	 +2.d0*gz**2*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*mw**2*sw**4*c0f(p1sq,p2sq,qsq,mw,mW,mw)&
 	 -6.d0*g**3*cw**2*mw*b0f(qsq,mW,mW)+4.d0*g**3*cw**2*mw&
 	 -g*gz**2*mw*sw**4*( b0f(p2sq,mW,mw)+b0f(p1sq,mw,mW) )&
! !
 	 +gz**3/2.d0*mz*( c24f(p1sq,p2sq,qsq,mZ,mh,mz)+c24f(p1sq,p2sq,qsq,mz,mh,mZ) )&
 	 -gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mh,mZ)&
 	 +6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*gz**2*mz**2*c0f(p1sq,p2sq,qsq,mh,mZ,mh)&
 	 -1.d0/2.d0*gz**3*mz*( b0f(p1sq,mh,mZ)+b0f(p2sq,mh,mZ))&
 	 ) &
! additional Higgs boson loop
        +1.d0/16.d0/pi**2*mz**2/vev**2*(&
           2.d0*(cw**2-sw**2)**2*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mhp,mhp)&
           +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,ma,ma)&
           +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mhn,mhn)&
           -8.d0*(cw**2-sw**2)**2*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mhp,mhp,mhp)&
           -8.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,ma,mhn,ma)&
           -8.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mhn,ma,mhn)&
         )
 
	end function
!--------------------------------------------
	double complex function M2_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M2_hZZ_B =  gz**2/(16.d0*pi**2)*mz**2*(&
                     +2.d0*g*mw*cw**4*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW) - C1223(p1sq,p2sq,qsq,mw,mw,mw)) &
!
                     +g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
                     +g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
!
                     -g*mw*(cw**2-sw**2)*sw**2*ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
                     -g*mw*(cw**2-sw**2)*sw**2*ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
                     +gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz)&
                     +gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)&
                ! 
                    -2.d0*g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&  
                    -2.d0*g_G0_G0_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
                    -2.d0*g_Hp_Hm_h(mhp,mhn,ma,mu2,lam2)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mhp,mhp,mhp)&
                    -2.d0*g_A_A_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mA,mhn,mA)&
                    -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
                    -2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhn,mA,mhn)&
                                     )

	end function
!=======================================================
!  hWW vertex
!=======================================================
	double complex function M1_hWW_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M1_hWW_F =&
	 4.d0*mw**2*mt**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mt,mb)+b0f(qsq,mt,mt)&
	 +1.d0/2.d0*b0f(p1sq,mt,mb)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mt,mb,mt)&
	 +(mt**2+mb**2-p1sq/2.d0-p2sq/2.d0)*c0f(p1sq,p2sq,qsq,mt,mb,mt)&
	 )&
!
	 +4.d0*mw**2*mb**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mb,mt)+b0f(qsq,mb,mb)&
	 +1.d0/2.d0*b0f(p1sq,mt,mb)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mb,mt,mb)&
	 +(mt**2+mb**2-p1sq/2.d0-p2sq/2.d0)*&
	  c0f(p1sq,p2sq,qsq,mb,mt,mb)&
	 )&
!
	 +4.d0*mw**2*mc**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mc,ms)+b0f(qsq,mc,mc)&
	 +1.d0/2.d0*b0f(p1sq,mc,ms)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mc,ms,mc)&
	 +(mc**2+ms**2-p1sq/2.d0-p2sq/2.d0)*c0f(p1sq,p2sq,qsq,mc,ms,mc)&
	 )&
!
	 +4.d0*mw**2*ms**2*3.d0/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,ms,mc)+b0f(qsq,ms,ms)&
	 +1.d0/2.d0*b0f(p1sq,mc,ms)&
	 -4.d0*c24f(p1sq,p2sq,qsq,ms,mc,ms)&
	 +(mc**2+ms**2-p1sq/2.d0-p2sq/2.d0)*&
	  c0f(p1sq,p2sq,qsq,ms,mc,ms)&
	 )&
!
	 +4.d0*mw**2*mtau**2/vev**3/&
	 (16.d0*pi**2)*&
	 (&
	 1.d0/2.d0*b0f(p2sq,mtau,m0)+b0f(qsq,mtau,mtau)&
	 +1.d0/2.d0*b0f(p1sq,m0,mtau)&
	 -4.d0*c24f(p1sq,p2sq,qsq,mtau,m0,mtau)&
	 +(m0**2+mtau**2-p1sq/2.d0-p2sq/2.d0)*&
	  c0f(p1sq,p2sq,qsq,mtau,m0,mtau)&
	 )

	end function
!--------------------------------------------
	double complex function M1_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M1_hWW_B =&
	  g**2*1.d0/(16.d0*pi**2)*&
	 (&
	 -2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
	 -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*(c24f(p1sq,p2sq,qsq,mh,mw,mh) )&
	 -g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*( c24f(p1sq,p2sq,qsq,mw,mz,mw)   )&
	 -g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*( c24f(p1sq,p2sq,qsq,mw,mh,mw)   )&
	 )&
!
	 +g**2/(16.d0*pi**2)*&
	 (&
	 +1.d0/2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mw,mw)&
	 +1.d0/2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mz,mz)&
	 +3.d0/2.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*b0f(qsq,mh,mh)&
	 )&
! !~~~~~~~~~~~ Gauge Boson Loops ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
 	  +1.d0/(16.d0*pi**2)*&
 	 (&
 	 +g**3*cw*mz*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
 	 +g**3*cw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
 	 +g**3*sw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
 	 -1.d0/2.d0*g**3*mw*sw**2*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))& 
 	 -1.d0/2.d0*g**3*mw*sw**2*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))& 
 	 -g**3/cw**3*mw**2*mZ*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
 	 -g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mh,mW)&
 	 +6.d0*g**2*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mw**2*c0f(p1sq,p2sq,qsq,mh,mW,mh)& 
 	 +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g**2*mw**2*sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
 	 +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g**2*sw**2*mw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
 	 +1.d0/2.d0*g**3*mw*( c24f(p1sq,p2sq,qsq,mW,mh,mw) + c24f(p1sq,p2sq,qsq,mw,mh,mW) )&
 	 +1.d0/2.d0*g**3*sw**2/cw**2*mw*( c24f(p1sq,p2sq,qsq,mz,mw,mZ) + c24f(p1sq,p2sq,qsq,mZ,mw,mz) )&
!
 	 -g**3*cw*mz*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
 	 -g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mz,mw)&
 	 -g**3*sw**2*mw*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)&
 	 -3.d0*g**3*mw*b0f(qsq,mW,mW)+2.d0*g**3*mw&
 	 -3.d0*g**3*cw*mz*b0f(qsq,mZ,mZ)+2.d0*g**3*cw*mz&
 !
 	 -1.d0/2.d0*g**3*mw*( b0f(p1sq,mW,mh) + b0f(p2sq,mW,mh) )&
 	 -1.d0/2.d0*g**3*mw*sw**4/cw**2*( b0f(p1sq,mZ,mw) + b0f(p2sq,mZ,mw) )&
 	 -1.d0/2.d0*g**3*sw**2*mw*( b0f(p1sq,mphoton,mw) + b0f(p2sq,mphoton,mw) )&
 	 )&     
! inert particles contributions                                                                                                                               
       +1.d0/16.d0/pi**2*g**2/4.d0*(&
        +2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
                             *b0f(qsq,mhp,mhp)&
        +2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)&
                             *b0f(qsq,ma,ma)&
        +2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
                             *b0f(qsq,mhn,mhn)&
        -g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,mhp,mhn,mhp)&
        -g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,mhp,ma,mhp)&
        -2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,ma,mhp,ma)&
        -2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
                      *4.d0*c24f(p1sq,p2sq,qsq,mhn,mhp,mhn)&
       )

	end function
!--------------------------------------------
	double complex function M2_hWW_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M2_hWW_F = Gam2_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	double complex function M3_hWW_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq

	M3_hWW_F = Gam3_hWW_F_SM(p1sq,p2sq,qsq)

	end function
!--------------------------------------------
	double complex function M2_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	M2_hWW_B = g**2/(16.d0*pi**2)*mw**2*(&
                    +g*cw*mz*(ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ) - c1223(p1sq,p2sq,qsq,mz,mw,mz)) &
                    +g*mw*cw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)-c1223(p1sq,p2sq,qsq,mw,mz,mw))& 
                    +g*mw*sw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)-c1223(p1sq,p2sq,qsq,mw,mphoton,mw)) &
!
          -g/2.d0*mw*(sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW) - sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
          -g/2.d0*mw*(sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw) - sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
!
                   +g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw)&
                   +g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)&
                   +g/2.d0*mw*sw**2/cw**2*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz)&
                   +g/2.d0*mw*sw**2/cw**2*ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)&
!
                   -2.d0*g_G0_G0_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
                   -1.d0*g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
                   -1.d0*g_Gp_Gm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
                   -2.d0*g_A_A_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mA,mhp,mA)&
                   -1.d0*g_Hp_Hm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhp,mhn,mhp)&
                   -1.d0*g_Hp_Hm_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhp,mA,mhp)&
                   -6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
                   -2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*c1223(p1sq,p2sq,qsq,mhn,mhp,mhn)&
                                       )

	end function
!=======================================================
!  hff vertex
!=======================================================
	double complex function Fhff_S(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

	Fhff_S = 1.d0/(16.d0*pi**2)*mf/vev*(&
	-4.d0*gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mz)&
	-QED*4.d0*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
	+mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
	-mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
	-2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
	-2.d0*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
	-6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
	+2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
	+2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
	-g**2/4.d0*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
	-g**2/4.d0*Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
	-gz**2/8.d0*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
	-gz**2/8.d0*Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
	)

	end function
!------------------------------------------------------------
	double complex function Fhff_P(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_P = -1.d0/(16.d0*pi**2)*mf/vev*(& 
           -g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW))&
           -2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ))&              
                                       )

	end function
!------------------------------------------------------------
	double complex function Fhff_V1(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_V1 = -1.d0/(16.d0*pi**2)*(& 
             2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +QED*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf))&
            +mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
            -gz**4*vev*(vf**2 + af**2)*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
                                      +c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
            -g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW)&
                           +c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
             +6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mh,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mh,mf,mh))&
             +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mz,mf,mz)&
                            +c11f(p1sq,p2sq,qsq,mz,mf,mz))&
             +1.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2+mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                            +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             -g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
                                       )

	end function
!------------------------------------------------------------
	double complex function Fhff_V2(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_V2 = -1.d0/(16.d0*pi**2)*(& 
             2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +QED*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf))&
            +mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf))&
            +mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
            -gz**4*vev*(vf**2 + af**2)*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
            -g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
            +6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mh,mf,mh))&
            +2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mz))&
            +1.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2+mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
            -g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       +c12f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                  -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                  +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                  )&
            -gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                  -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                  +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                  )&
                                       )

	end function
!------------------------------------------------------------
	double complex function Fhff_A1(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_A1 = -1.d0/(16.d0*pi**2)*(& 
             -4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                     +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
              +2.d0*gz**4*vf*af*vev*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
                                    +c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
              +g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW)&
                                    +c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
              +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2-mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                    +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      +c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                      )&
             +2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                      )&
         )

	end function
!------------------------------------------------------------
	double complex function Fhff_A2(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_A2 = -1.d0/(16.d0*pi**2)*(& 
             -4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
             +mfp**2*(mf**2- mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
             +2.d0*gz**4*vf*af*vev*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
             +g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
             +g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(mf**2-mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      +c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                      -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                      )&
             +2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                      -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                      )&
         )

	end function
!------------------------------------------------------------
	double complex function Fhff_T(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_T = -1.d0/(16.d0*pi**2)*(mf/vev)*(&
            mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf))&
           -mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf))&
           -2.d0*mfp**2/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +gz**2/8.d0*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )
 
	end function
!------------------------------------------------------------
	double complex function Fhff_PT(p1sq,p2sq,qsq,mh,mf)
	double precision, intent(in):: mh,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp

        if (mf .eq. mt) then 
        vf = vt
        af = at
        qf = qt
        mfp = mb
        elseif (mf .eq. mc) then 
        vf = vt
        af = at
        qf = qt
        mfp = ms
        elseif (mf .eq. mb) then 
        vf  = vb
        af  = ab
        qf  = qb
        mfp = mt
        elseif (mf .eq. mtau) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        elseif (mf .eq. mmu) then 
        vf = ve
        af = ae
        qf = qe
        mfp = 0.d0
        endif

    Fhff_PT = 1.d0/(16.d0*pi**2)*(mf/vev)*(&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +2.d0*gz**2*af*vf*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )
 
	end function
!=======================================================
!  hhh vertex
!=======================================================
	double complex function Gam_hhh_F(p1sq,p2sq,qsq)
	double precision, intent(in):: p1sq,p2sq,qsq
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Gam_hhh_F = &
      -8.d0*mt**4*3.d0/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
      +(&
         ( 4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mt,mt,mt)&
        )&
      )&
! 
      -8.d0*mc**4*3.d0/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
      +(&
         ( 4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mc,mc,mc)&
        )&
      )&
!
      -8.d0*mb**4*3.d0/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
      +(&
         ( 4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mb,mb,mb)&
      )&
      )&
! 
      -8.d0*mtau**4/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
      +(&
         ( 4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau)&
      )&
      )
	
	end function
!---------------------------------------------
	double complex function Gam_hhh_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_hhh_B =&
       1.d0/(16.d0*pi**2)*(&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       +8.d0*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mW,mW)&
       -1.d0/2.d0*g**3*mw**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
       +4.d0*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mZ,mZ)&
       -1.d0/4.d0*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      -1.d0/2.d0*g**3*mw*Chhh_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
      -1.d0/4.d0*gz**3*mz*Chhh_SVV(p1sq,p2sq,qsq,mz,mZ,mZ)&
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      +1.d0/2.d0*g**2*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*Chhh_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
      +1.d0/2.d0*gz**2*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*Chhh_VSS(p1sq,p2sq,qsq,mZ,mz,mz)&
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      -2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
      -8.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
      -216.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)**3*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
!~~~~~~~~~~~ B function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
      +2.d0*g**3*mw*(b0f(p1sq,mW,mW)+b0f(p2sq,mW,mW)+b0f(qsq,mW,mW))&        !! qsq can be separated into p1sq and p2sq and qsq
      +gz**3*mz*(b0f(p1sq,mZ,mZ)+b0f(p2sq,mZ,mZ)+b0f(qsq,mZ,mZ))&
      +2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g_gp_gm_h_h(mhp,mhn,ma,mu2,lam2)*&
        (b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw)+b0f(qsq,mw,mw))&
      +4.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*g_g0_g0_h_h(mhp,mhn,ma,mu2,lam2)*&
        (b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz)+b0f(qsq,mz,mz))&
      +72.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*g_h_h_h_h(mhp,mhn,ma,mu2,lam2)*&
        (b0f(p1sq,mh,mh)+b0f(p2sq,mh,mh)+b0f(qsq,mh,mh))&
     )&
	-1.d0/(16.d0*pi**2)*(3.d0*g**3*mW+3.d0/2.d0*gz**3*mZ)&
!New scalar loop contribution
!
        +1.d0/16.d0/pi**2*(&
          2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
           *g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)*(&
                b0f(p1sq,mhp,mhp)&
               +b0f(p2sq,mhp,mhp)&
               +b0f(qsq,mhp,mhp)          )&
          +4.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)&
           *g_a_a_h_h(mhp,mhn,ma,mu2,lam2)*(&
                b0f(p1sq,ma,ma)&
               +b0f(p2sq,ma,ma)&
               +b0f(qsq,ma,ma)          )&
          +4.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
           *g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2)*(&
                b0f(p1sq,mhn,mhn)&
               +b0f(p2sq,mhn,mhn)&
               +b0f(qsq,mhn,mhn)          )&
         -2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**3&
                    *c0f(p1sq,p2sq,qsq,mhp,mhp,mhp)&
          -8.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)**3&
                    *c0f(p1sq,p2sq,qsq,ma,ma,ma)&
          -8.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)**3&
                    *c0f(p1sq,p2sq,qsq,mhn,mhn,mhn)&
                         )
	end function
!=======================================================
!  H+W-H vertex
!=======================================================
	complex (kind(0d0)) function Gam_bHWHp_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_bHWHp_B = 1.d0/(16.d0*pi**2)*(&
		!SVV
		-g**3/8.d0*(&
			+CSVS_SVV(p1sq,p2sq,qsq,ma,mZ,mW)&
			+(cw**2-sw**2)*CSVS_SVV(p1sq,p2sq,qsq,mhp,mW,mZ)&
			+2.d0*sw**2*CSVS_SVV(p1sq,p2sq,qsq,mhp,mW,mphoton)&
		)&
   	!VSS
		-g**3/8.d0*(&
			+CSVS_VSS(p1sq,p2sq,qsq,mW,mhp,mhn)&
			-CSVS_VSS(p1sq,p2sq,qsq,mW,mhp,ma)&
			-(cw**2-sw**2)/cw**2*CSVS_VSS(p1sq,p2sq,qsq,mZ,ma,mhp)&
		)&
   	!SV_qsq
		+g**3/8.d0*(&
			+b0f(qsq,mhn,mW)-b1f(qsq,mhn,mW)&
			-sw**2/cw**2*(cw**2-sw**2)*(b0f(qsq,mhp,mZ)-b1f(qsq,mhp,mZ))&
			+2.d0*sw**2*(b0f(qsq,mhp,mphoton)-b1f(qsq,mhp,mphoton))&
		)&
   	!SV_p1sq
		+g**3/8.d0*(&
			+b0f(p1sq,mhp,mW)-b1f(p1sq,mhp,mW)&
			+sw**2/cw**2*(b0f(p1sq,ma,mZ)-b1f(p1sq,ma,mZ))&
		)&
		!SVS
		-g**2*mW/4.d0*(&
			+sw**2/cw**2*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*CSVS_SVS(p1sq,p2sq,qsq,ma,mZ,mw)&
			+g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*CSVS_SVS(p1sq,p2sq,qsq,mhp,mW,mh)&
		)&
		!SSV
		-g**2*mW/4.d0*(&
			+2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*CSVS_SSV(p1sq,p2sq,qsq,mhn,mh,mW)&
			-sw**2/cw**2*(cw**2-sw**2)*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*CSVS_SSV(p1sq,p2sq,qsq,mhp,mw,mZ)&
			+2.d0*sw**2*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*CSVS_SSV(p1sq,p2sq,qsq,mhp,mw,mphoton)&
		)&
		!SSS
		+g/2.d0*(&
			+2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*CSVS_SSS(p1sq,p2sq,qsq,mh,mhn,mhp)&
			+2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*CSVS_SSS(p1sq,p2sq,qsq,mhn,mh,mw)&
			-g_hn_a_g0(mhp,mhn,ma,mu2,lam2)*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*CSVS_SSS(p1sq,p2sq,qsq,ma,mz,mw)&
			-g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2*CSVS_SSS(p1sq,p2sq,qsq,mw,mhp,mhn)&
			+(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*CSVS_SSS(p1sq,p2sq,qsq,mw,mhp,ma)&
			-g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*CSVS_SSS(p1sq,p2sq,qsq,mhp,mw,mh)&
		)&
	)

	end function
!=======================================================
!  H+W-A vertex
!=======================================================
	complex (kind(0d0)) function Gam_AWHp_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_AWHp_B = ii/(16.d0*pi**2)*(&
		!SVV
		+g**3/8.d0*(&
			+CSVS_SVV(p1sq,p2sq,qsq,mhn,mZ,mW)&
			+(cw**2-sw**2)*CSVS_SVV(p1sq,p2sq,qsq,mhp,mW,mZ)&
			+2.d0*sw**2*CSVS_SVV(p1sq,p2sq,qsq,mhp,mW,mphoton)&
		)&
		!VSS
		+g**3/8.d0*(&
			+CSVS_VSS(p1sq,p2sq,qsq,mW,mhp,ma)&
			-CSVS_VSS(p1sq,p2sq,qsq,mW,mhp,mhn)&
			-(cw**2-sw**2)/cw**2*CSVS_VSS(p1sq,p2sq,qsq,mZ,mhn,mhp)&
		)&
		!SV_qsq
		-g**3/8.d0*(&
			+b0f(qsq,ma,mW)-b1f(qsq,ma,mW)&
			-sw**2/cw**2*(cw**2-sw**2)*(b0f(qsq,mhp,mZ)-b1f(qsq,mhp,mZ))&
			+2.d0*sw**2*(b0f(qsq,mhp,mphoton)-b1f(qsq,mhp,mphoton))&
		)&
		!SV_p1sq
		-g**3/8.d0*(&
			+b0f(p1sq,mhp,mW)-b1f(p1sq,mhp,mW)&
			+sw**2/cw**2*(b0f(p1sq,mhn,mZ)-b1f(p1sq,mhn,mZ))&
		)&
		!SVS
		+g**2*mW/4.d0*(&
			+sw**2/cw**2*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*CSVS_SVS(p1sq,p2sq,qsq,mhn,mZ,mw)&
			+g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*CSVS_SVS(p1sq,p2sq,qsq,mhp,mW,mh)&
		)&
		!SSV
		+g**2*mW/4.d0*(&
			+2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*CSVS_SSV(p1sq,p2sq,qsq,ma,mh,mW)&
			-sw**2/cw**2*(cw**2-sw**2)*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*CSVS_SSV(p1sq,p2sq,qsq,mhp,mw,mZ)&
			+2.d0*sw**2*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*CSVS_SSV(p1sq,p2sq,qsq,mhp,mw,mphoton)&
		)&
		!SSS
		-g/2.d0*(&
			+2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,mh,ma,mhp)&
			+2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))&
				*CSVS_SSS(p1sq,p2sq,qsq,ma,mh,mw)&
			+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,mhn,mz,mw)&
			-g_a_hp_gm(mhp,mhn,ma,mu2,lam2)*conjg(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))&
				*CSVS_SSS(p1sq,p2sq,qsq,mw,mhp,ma)&
			-g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*(ii*conjg(g_a_hp_gm(mhp,mhn,ma,mu2,lam2)))&
				*CSVS_SSS(p1sq,p2sq,qsq,mw,mhp,mhn)&
			-(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,mhp,mw,mh)&
		)&
	)

	end function
!=======================================================
!  AZbH vertex
!=======================================================
	complex (kind(0d0)) function Gam_AZbH_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_AZbH_B = ii/(16.d0*pi**2)*(&
		!SVV
		+g**3*cw/4.d0*CSVS_SVV(p1sq,p2sq,qsq,mhp,mW,mW)&
		!VSS
		+gz**3/8.d0*(&
			+CSVS_VSS(p1sq,p2sq,qsq,mZ,ma,mhn)&
			-2.d0*cw**2*(cw**2-sw**2)*CSVS_VSS(p1sq,p2sq,qsq,mW,mhp,mhp)&
		)&
		!SV_qsq
		-gz**3/8.d0*(&
			+b0f(qsq,mhn,mZ)-b1f(qsq,mhn,mZ)&
			+2.d0*sw**2*cw**2*(b0f(qsq,mhp,mW)-b1f(qsq,mhp,mW))&
		)&
		!SV_p1sq
		-gz**3/8.d0*(&
			+b0f(p1sq,ma,mZ)-b1f(p1sq,ma,mZ)&
			+2.d0*sw**2*cw**2*(b0f(p1sq,mhp,mW)-b1f(p1sq,mhp,mW))&
		)&
		!SSV
		+gz**2*mZ/4.d0*(&
			+2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*CSVS_SSV(p1sq,p2sq,qsq,mhn,mh,mZ)&
			+2.d0*sw**2*cw**2*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*CSVS_SSV(p1sq,p2sq,qsq,mhp,mw,mW)&
		)&
		!SVS
		+gz**2*mZ/4.d0*(&
			+2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*CSVS_SVS(p1sq,p2sq,qsq,ma,mZ,mh)&
			+2.d0*sw**2*cw**2*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*CSVS_SSV(p1sq,p2sq,qsq,mhp,mW,mw)&
		)&
		!SSS
		+gz/2.d0*(&
			-4.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,mh,mhn,ma)&
			-2.d0*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,mhn,mh,mz)&
			+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2*CSVS_SSS(p1sq,p2sq,qsq,mz,ma,mhn)&
			+2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,ma,mz,mh)&
			+2.d0*(cw**2-sw**2)*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,mw,mhp,mhp)&
			-2.d0*(cw**2-sw**2)*(ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)&
				*CSVS_SSS(p1sq,p2sq,qsq,mhp,mw,mw)&
		)&
	)

	end function
!=======================================================
!	hHH vertex
!=======================================================
	complex (kind(0d0)) function Gam_hbHbH_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_hbHbH_B = 1.d0/(16.d0*pi**2)*(&
		!SS_qsq
		+(6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,mh,mh)&
		+(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))*(24.d0*g_hn_hn_hn_hn(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,mhn,mhn)&
		+g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(2.d0*g_hn_hn_gp_gm(mhp,mhn,ma,mu2,lam2))&
			*b0f(qsq,mw,mw)&
		+(2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_g0_g0_hn_hn(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,mz,mz)&
		+g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*(2.d0*g_hn_hn_hp_hm(mhp,mhn,ma,mu2,lam2))&
			*b0f(qsq,mhp,mhp)&
		+(2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_hn_hn_a_a(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,ma,ma)&
		!VV_qsq
		+g**4*vev*(b0f(qsq,mW,mW)-1.d0/2.d0)&
		+gZ**4*vev/2.d0*(b0f(qsq,mZ,mZ)-1.d0/2.d0)&
		!SS_p1sq
		+(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2))&
			*b0f(p1sq,mh,mhn)&
		+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)*g_h_hn_g0_a(mhp,mhn,ma,mu2,lam2)&
			*b0f(p1sq,mz,mA)&
		+2.d0*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*g_h_hn_gp_hm(mhp,mhn,ma,mu2,lam2)&
			*b0f(p1sq,mw,mhp)&
		!SS_p2sq
		+(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_hn_hn_h_h(mhp,mhn,ma,mu2,lam2))&
			*b0f(p2sq,mh,mhn)&
		+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)*g_h_hn_g0_a(mhp,mhn,ma,mu2,lam2)&
			*b0f(p2sq,mz,mA)&
		+2.d0*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*g_h_hn_gp_hm(mhp,mhn,ma,mu2,lam2)&
			*b0f(p2sq,mw,mhp)&
		!SVS
		+gz**2/4.d0*(2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2))&
			*CSSS_SVS(p1sq,p2sq,qsq,mA,mZ,mA)&
		+g**2/2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SVS(p1sq,p2sq,qsq,mhp,mW,mhp)&
		!VSS
		+gz**2/4.d0*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)&
			*CSSS_VSS(p1sq,p2sq,qsq,mZ,mA,mz)&
		+g**2/2.d0*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)&
			*CSSS_VSS(p1sq,p2sq,qsq,mW,mhp,mw)&
		!SSV
		+gz**2/4.d0*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SSV(p1sq,p2sq,qsq,mz,mA,mZ)&
		+g**2/2.d0*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SSV(p1sq,p2sq,qsq,mw,mhp,mW)&
		!VSV
		-gz**4/8.d0*vev&
			*CSSS_VSV(p1sq,p2sq,qsq,mZ,mA,mZ)&
		-g**4/4.d0*vev&
			*CSSS_VSV(p1sq,p2sq,qsq,mW,mhp,mW)&
		!SSS
		-(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))**3&
			*c0f(p1sq,p2sq,qsq,mhn,mh,mhn)&
		-(6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2))*(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))**2&
			*c0f(p1sq,p2sq,qsq,mh,mhn,mh)&
		-(2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2))*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mz,mA,mz)&
		-(2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2))*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mA,mz,mA)&
		-(2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2))*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mw,mhp,mw)&
		-(2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2))*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mhp,mw,mhp)&	
	)

	end function
!=======================================================
!	hAA vertex
!=======================================================
	complex (kind(0d0)) function Gam_hAA_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_hAA_B = 1.d0/(16.d0*pi**2)*(&
		!SS_qsq
		+(6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_a_a_h_h(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,mh,mh)&
		+(2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2))*(24.d0*g_a_a_a_a(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,ma,ma)&
		+g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*(2.d0*g_a_a_gp_gm(mhp,mhn,ma,mu2,lam2))&
			*b0f(qsq,mw,mw)&
		+(2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_g0_g0_a_a(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,mz,mz)&
		+g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*(2.d0*g_a_a_hp_hm(mhp,mhn,ma,mu2,lam2))&
			*b0f(qsq,mhp,mhp)&
		+(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_hn_hn_a_a(mhp,mhn,ma,mu2,lam2))/2.d0&
			*b0f(qsq,mhn,mhn)&
		!VV_qsq
		+g**4*vev*(b0f(qsq,mW,mW)-1.d0/2.d0)&
		+gZ**4*vev/2.d0*(b0f(qsq,mZ,mZ)-1.d0/2.d0)&
		!SS_p1sq and SS_p2sq
		+(2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2))*(4.d0*g_a_a_h_h(mhp,mhn,ma,mu2,lam2))&
			*(b0f(p1sq,ma,mh)+b0f(p2sq,ma,mh))&
		+g_hn_a_g0(mhp,mhn,ma,mu2,lam2)*g_h_hn_g0_a(mhp,mhn,ma,mu2,lam2)&
			*(b0f(p1sq,mz,mhn)+b0f(p2sq,mz,mhn))&
		+2.d0*g_a_hp_gm(mhp,mhn,ma,mu2,lam2)*g_h_a_gp_hm(mhp,mhn,ma,mu2,lam2)&
			*(b0f(p1sq,mw,mhp)+b0f(p2sq,mw,mhp))&
		!SVS
		+gz**2/4.d0*(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))&
			*CSSS_SVS(p1sq,p2sq,qsq,mhn,mZ,mhn)&
		+g**2/2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SVS(p1sq,p2sq,qsq,mhp,mW,mhp)&
		!VSS
		-gz**2/4.d0*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)&
			*CSSS_VSS(p1sq,p2sq,qsq,mZ,mhn,mz)&
		+ii*g**2/2.d0*g_a_hp_gm(mhp,mhn,ma,mu2,lam2)&
			*CSSS_VSS(p1sq,p2sq,qsq,mW,mhp,mw)&
		!SSV
		-gz**2/4.d0*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SSV(p1sq,p2sq,qsq,mz,mhn,mZ)&
		+ii*g**2/2.d0*g_a_hp_gm(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SSV(p1sq,p2sq,qsq,mw,mhp,mW)&
		!VSV
		-gz**4/8.d0*vev&
			*CSSS_VSV(p1sq,p2sq,qsq,mZ,mhn,mZ)&
		-g**4/4.d0*vev&
			*CSSS_VSV(p1sq,p2sq,qsq,mW,mhp,mW)&
		!SSS
		-(2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2))**3&
			*c0f(p1sq,p2sq,qsq,ma,mh,ma)&
		-(6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2))*(2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2))**2&
			*c0f(p1sq,p2sq,qsq,mh,ma,mh)&
		-(2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2))*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mz,mhn,mz)&
		-(2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2))*g_hn_a_g0(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mhn,mz,mhn)&
		-(2.d0*g_gp_gm_h(mhp,mhn,ma,mu2,lam2))*abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2&
			*c0f(p1sq,p2sq,qsq,mw,mhp,mw)&
		-(2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2))*abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2&
			*c0f(p1sq,p2sq,qsq,mhp,mw,mhp)&	
	)

	end function
!=======================================================
!	hH+H- vertex
!=======================================================
	complex (kind(0d0)) function Gam_hHpHm_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_hHpHm_B = 1.d0/(16.d0*pi**2)*(& 
		!SVS
		+(g*sw)**2*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SVS(p1sq,p2sq,qsq,mhp,mphoton,mhp)&
		+gZ**2*(cw**2-sw**2)**2/4.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SVS(p1sq,p2sq,qsq,mhp,mZ,mhp)&
		+g**2/2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SVS(p1sq,p2sq,qsq,mhn,mW,mhn)&
		+g**2/2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)&
			*CSSS_SVS(p1sq,p2sq,qsq,ma,mW,ma)&
   	!SSV+VSS
		-g**2/4.d0*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mw,mhn,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,mhn,mw))&
		+g**2/4.d0*(-ii*g_a_hp_gm(mhp,mhn,ma,mu2,lam2))&
			*(CSSS_SSV(p1sq,p2sq,qsq,mw,ma,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,ma,mw))&
		!VSV
		-g**4*vev/8.d0*(&
			+CSSS_VSV(p1sq,p2sq,qsq,mW,mhn,mW)&
			+CSSS_VSV(p1sq,p2sq,qsq,mW,ma,mW)&
		)&
		-gZ**4*(cw**2-sw**2)**2*vev/8.d0&
			*CSSS_VSV(p1sq,p2sq,qsq,mZ,mhp,mZ)&
		!VV
		+gZ**4*(cw**2-sw**2)**2*vev/8.d0&
			*(4.d0*b0f(qsq,mZ,mZ)-2.d0)&
		+g**4*vev/4.d0&
			*(4.d0*b0f(qsq,mW,mW)-2.d0)&
		!SS_qsq
		+6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)&
			*b0f(qsq,mh,mh)&
		+2.d0*g_g0_g0_h(mhp,mhn,ma,mu2,lam2)*g_g0_g0_hp_hm(mhp,mhn,ma,mu2,lam2)&
			*b0f(qsq,mz,mz)&
		+g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g_gp_gm_hp_hm(mhp,mhn,ma,mu2,lam2)&
			*b0f(qsq,mw,mw)&
		+2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*g_hn_hn_hp_hm(mhp,mhn,ma,mu2,lam2)&
			*b0f(qsq,mhn,mhn)&
		+2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*g_a_a_hp_hm(mhp,mhn,ma,mu2,lam2)&
			*b0f(qsq,ma,ma)&
		+4.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*g_hp_hm_hp_hm(mhp,mhn,ma,mu2,lam2)&
			*b0f(qsq,mhp,mhp)&
		!SS_p1sq and SS_p2sq
		+2.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*g_hp_hm_h_h(mhp,mhn,ma,mu2,lam2)&
			*(b0f(p1sq,mhp,mh)+b0f(p2sq,mhp,mh))&
		+g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)*g_h_hn_gp_hm(mhp,mhn,ma,mu2,lam2)&
			*(b0f(p1sq,mw,mhn)+b0f(p2sq,mw,mhn))&
		+g_a_hp_gm(mhp,mhn,ma,mu2,lam2)*g_h_a_gp_hm(mhp,mhn,ma,mu2,lam2)&
			*(b0f(p1sq,mw,mA)+b0f(p2sq,mw,mA))&
		!SSS
		-6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mh,mhp,mh)&
		-g_hp_hm_h(mhp,mhn,ma,mu2,lam2)**3&
			*c0f(p1sq,p2sq,qsq,mhp,mh,mhp)&
		-2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mhn,mw,mhn)&
		-g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*g_hn_hp_gm(mhp,mhn,ma,mu2,lam2)**2&
			*c0f(p1sq,p2sq,qsq,mw,mhn,mw)&
		-2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)*abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2&
			*c0f(p1sq,p2sq,qsq,ma,mw,ma)&
		-g_gp_gm_h(mhp,mhn,ma,mu2,lam2)*abs(g_a_hp_gm(mhp,mhn,ma,mu2,lam2))**2&
			*c0f(p1sq,p2sq,qsq,mw,ma,mw)&
	 	)

	end function
!#################################################
!
!    SECTION IV COUNTER TERMS
!
!#################################################
!=======================================================
!  Fermion sector
!=======================================================
	double complex function del_mt(mh)
	double precision, intent(in):: mh

	del_mt =&
		dble(mt*(Pitt_V(mt**2,mh)+Pitt_S(mt**2,mh)))

	end function
!---------------------------------------------
	double complex function del_mc(mh)
	double precision, intent(in):: mh

	del_mc =&
		dble(mc*(Picc_V(mc**2,mh)+Picc_S(mc**2,mh)))

	end function
!---------------------------------------------
	double complex function del_mb(mh)
	double precision, intent(in):: mh

	del_mb =&
		dble(mb*(Pibb_V(mb**2,mh)+Pibb_S(mb**2,mh)))

	end function
!---------------------------------------------
	double complex function del_mtau(mh)
	double precision, intent(in):: mh

	del_mtau =&
		dble(mtau*(Pitautau_V(mtau**2,mh)+Pitautau_S(mtau**2,mh)))

	end function
!---------------------------------------------
	double complex function del_mmu(mh)
	double precision, intent(in):: mh

	del_mmu =&
		dble(mmu*(Pimumu_V(mmu**2,mh)+Pimumu_S(mmu**2,mh)))

	end function
!---------------------------------------------
	double complex function del_ZVt(mh)
	double precision, intent(in):: mh

	del_ZVt =&
		dble(-Pitt_V(mt**2,mh)&
		-2.d0*mt**2*(dPitt_V(mt**2,mh)+dPitt_S(mt**2,mh)))

	end function
!---------------------------------------------
	double complex function del_ZVc(mh)
	double precision, intent(in):: mh

	del_ZVc =&
		dble(-Picc_V(mc**2,mh)&
		-2.d0*mc**2*(dPicc_V(mc**2,mh)+dPicc_S(mc**2,mh)))

	end function
!---------------------------------------------
	double complex function del_ZVb(mh)
	double precision, intent(in):: mh

	del_ZVb =&
		dble(-Pibb_V(mb**2,mh)&
		-2.d0*mb**2*(dPibb_V(mb**2,mh)+dPibb_S(mb**2,mh)))

	end function
!---------------------------------------------
	double complex function del_ZVtau(mh)
	double precision, intent(in):: mh

	del_ZVtau =&
		dble(-Pitautau_V(mtau**2,mh)&
		-2.d0*mtau**2*(dPitautau_V(mtau**2,mh)+dPitautau_S(mtau**2,mh)))

	end function
!---------------------------------------------
	double complex function del_ZVmu(mh)
	double precision, intent(in):: mh

	del_ZVmu =&
		dble(-Pimumu_V(mmu**2,mh)&
		-2.d0*mmu**2*(dPimumu_V(mmu**2,mh)+dPimumu_S(mmu**2,mh)))

	end function
!=======================================================
!  Gauge sector
!=======================================================
	double precision function del_swsq_F(mh)
	double precision, intent(in):: mh

	del_swsq_F = cw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2)

	end function
!---------------------------------------------
	double precision function del_swsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_swsq_B = cw**2*(PiZZ_B(mZ**2,mhp,mhn,ma,mu2,lam2)/mz**2&
                   -PiWW_B(mW**2,mhp,mhn,ma,mu2,lam2)/mw**2)

	end function
!---------------------------------------------
 	double precision function del_swsq_pinch(mh)
 	double precision, intent(in):: mh

 	del_swsq_pinch = cw**2*(PiZZ_pinch(mz**2)/mz**2-PiWW_pinch(mw**2)/mw**2)

	end function
!---------------------------------------------
	double precision function del_swsq(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_swsq = del_swsq_F(mh)+del_swsq_B(mhp,mhn,ma,mu2,lam2)

	end function
!---------------------------------------------
	double complex function del_v_F(mh)
	double precision, intent(in):: mh

	del_v_F = dble(vev/2.d0*(&
		+PiWW_F(mw**2)/mw**2&
		+del_swsq_F(mh)/sw**2&
		-delta_alpha&
		-(PiGG_F(mz**2)/mZ**2+dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
		-2.d0*sw/cw*PiZG_F(0.d0)/mz**2))

! KOSY scheme
!	del_v_F = vev/2.d0*(PiWW_F(0.d0)/mw**2)

	end function
!---------------------------------------------
	double complex function del_v_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_v_B = dble(vev/2.d0*(&
		+PiWW_B(mW**2,mhp,mhn,ma,mu2,lam2)/mw**2&
		+del_swsq_B(mhp,mhn,ma,mu2,lam2)/sw**2&
		-dPiGG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
		-2.d0*sw/cw*PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2))

! KOSY scheme
!!	del_v_B = vev/2.d0*(PiWW_B(0.d0,mhp,mhn,ma,mu2,lam2)/mw**2)

	end function
!---------------------------------------------
	double complex function del_v(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_v = del_v_F(mh)+del_v_B(mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------
  	double precision function del_mZsq_F(mh)
	double precision, intent(in):: mh
	
	del_mZsq_F = dble(PiZZ_F(mZ**2))

	end function
!--------------------------------------------
  	double precision function del_mZsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mZsq_B = dble(PiZZ_B(mZ**2,mhp,mhn,ma,mu2,lam2))

	end function
!--------------------------------------------
 	double complex function del_mWsq_F(mh)
	double precision, intent(in):: mh

	del_mWsq_F = dble(PiWW_F(mW**2))

	end function
!--------------------------------------------
  	double complex function del_mWsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mWsq_B = dble(PiWW_B(mW**2,mhp,mhn,ma,mu2,lam2))

	end function
!===============================================
  	double complex function del_ZZ_F(mh)
	double precision, intent(in):: mh

	del_ZZ_F =&
		dble(-delta_alpha&
      -(PiGG_F(mz**2)/mZ**2+dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
	   -2.d0*(cw**2-sw**2)/(cw*sw)*PiZG_F(0.d0)/mz**2&
		+(cw**2-sw**2)/cw**2*&
		del_swsq_F(mh)/sw**2)

! KOSY scheme
!!        del_ZZ_F=-dPiZZ_F(mZ**2)
	end function
!--------------------------------------------
  	double complex function del_ZZ_B(mhp,mhn,ma,mu2,lam2)
  	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
    del_ZZ_B =&
		dble(-(&
			dPiGG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
			-dPiGG_pinch(0.d0)&
		)&
		+2.d0*(cw**2-sw**2)/(cw*sw)*(&
			PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
			-PiZG_pinch(0.d0))/mz**2&
		+(cw**2-sw**2)/cw**2*(del_swsq_B(mhp,mhn,ma,mu2,lam2))/sw**2)

! KOSY scheme
!!        del_ZZ_B=-dPiZZ_B(mz**2,mhp,mhn,ma,mu2,lam2)
	end function

!--------------------------------------------
  	double complex function del_ZW_F(mh)
	double precision, intent(in):: mh

	del_ZW_F =&
	dble(-delta_alpha-(PiGG_F(mz**2)/mZ**2+dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
	+2.d0*cw/sw*PiZG_F(0.d0)/mz**2&
	+del_swsq_F(mh)/sw**2)

! KOSY scheme
!!        del_ZW_F=-dPiWW_F(mW**2)

	end function
!--------------------------------------------
  	double complex function del_ZW_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
!!!	del_ZW_B =&
!!!	   -dPiGG_B(0.d0,mh)&
!!!	   -2.d0*cw/sw*&
!!!	 PiZG_B(0.d0,mh)/mz**2&
!!!	 +del_swsq_B(mh)/sw**2

	del_ZW_B =&
	dble(-(dPiGG_B(0.d0,mhp,mhn,ma,mu2,lam2)-dPiGG_pinch(0.d0))&
	+2.d0*cw/sw*(PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)-PiZG_pinch(0.d0))/mz**2&
	+del_swsq_B(mhp,mhn,ma,mu2,lam2)/sw**2)

! ! KOSY scheme
!!         del_ZW_B=-dPiWW_B(mW**2+0.01d0,mhp,mhn,ma,mu2,lam2)
! We deviate from  mW**2 because B2(mW**2,mW,mphoton) has divergence

	end function
!=======================================================
!  Higgs sector
!=======================================================
!----- SM-like Higgs boson ------------------
	double complex function del_mhsq_F(mh)
	double precision, intent(in):: mh
	
	del_mhsq_F =&
		-(1.d0/vev)*Th_F(mh)&
		+Pihh_F(mh**2,mh)

	end function
!--------------------------------------------
	double complex function del_mhsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mhsq_B = &
	  -(1.d0/vev)*Th_B(mhp,mhn,ma,mu2,lam2)&
	 +Pihh_B(mh**2,mhp,mhn,ma,mu2,lam2)
	
	end function
!-------------------------------------------
	double complex function del_Zh_F(mh)
	double precision, intent(in):: mh

	del_Zh_F = -dPihh_F(mh**2,mh)

	end function
!---------------------------------------------
	double complex function del_Zh_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Zh_B = -dPihh_B(mh**2,mhp,mhn,ma,mu2,lam2)

	end function
!---------------------------------------------
	double complex function del_Zh(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Zh = del_Zh_F(mh)+del_Zh_B(mhp,mhn,ma,mu2,lam2)

	end function
!----- additional Higgs boson: bH ------------------
	double complex function del_mhnsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mhnsq_B = Pihnhn_B(mhn**2,mhp,mhn,ma,mu2,lam2)
	
	end function
!-------------------------------------------
	double complex function del_Zhn_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Zhn_B = -dPihnhn_B(mhn**2,mhp,mhn,ma,mu2,lam2)

	end function
!----- additional Higgs boson: A ------------------
	double complex function del_masq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_masq_B = Piaa_B(ma**2,mhp,mhn,ma,mu2,lam2)
	
	end function
!-------------------------------------------
	double complex function del_Za_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Za_B = -dPiaa_B(ma**2,mhp,mhn,ma,mu2,lam2)

	end function
!----- additional charged Higgs boson: H± ------------------
	double complex function del_mhpsq_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	del_mhpsq_B = Pihphm_B(mhp**2,mhp,mhn,ma,mu2,lam2)
	
	end function
!-------------------------------------------
	double complex function del_Zhp_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Zhp_B = -dPihphm_B(mhp**2,mhp,mhn,ma,mu2,lam2)

	end function
!-------------------------------------------
	double complex function del_mu2sq_B(mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r

	del_mu2sq_B = 1.d0/(16.d0*pi**2)*(&
		-mh**2/(2.d0*vev**2)*(mhn**2+ma**2+2.d0*mhp**2)&
		+mu2/vev**2*(2.d0*mh**2-6.d0*mW**2-3.d0*mZ**2+3.d0*lam2*vev**2)&
	)*(div-log(mu_r**2))

	end function
!=======================================================
!  hff vertex
!=======================================================
	double complex function rGamS_hbb(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_hbb =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mb)&
	-mb/vev*(1.d0+&
	del_mb(mh)/mb&
        -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	+del_ZVb(mh)&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!---------------------------------------------
	double complex function rGamS_htt(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_htt =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mt)&
	-mt/vev*(1.d0+&
	del_mt(mh)/mt&
        -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	+del_ZVt(mh)&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!---------------------------------------------
	double complex function rGamS_hcc(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_hcc =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mc)&
	-mc/vev*(1.d0+&
	del_mc(mh)/mc&
        +del_ZVc(mh)&
        -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!---------------------------------------------
	double complex function rGamS_htautau(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_htautau =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mtau)&
	-mtau/vev*(1.d0+&
	del_mtau(mh)/mtau&
	+del_ZVtau(mh)&
       -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!---------------------------------------------
	double complex function rGamS_hmumu(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGamS_hmumu =&
	+Fhff_S(p1sq,p2sq,qsq,mh,mmu)&
	-mmu/vev*(1.d0+&
	del_mmu(mh)/mmu&
	+del_ZVmu(mh)&
       -del_v_F(mh)/vev&
	-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
        +1.d0/2.d0*del_Zh_F(mh)&
        +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!=======================================================
!  hZZ vertex
!=======================================================
  	double complex function del_M1_hZZ_F(mh)
	double precision, intent(in):: mh

	del_M1_hZZ_F = 2.d0*mz**2/vev*&
	 (&
	 +del_mzsq_F(mh)/mz**2&
	 +1.d0/2.d0*del_Zh_F(mh)&
         +del_ZZ_F(mh) &
	 -del_v_F(mh)/vev&
	 )

	end function
!--------------------------------------------
  	double complex function del_M1_hZZ_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_M1_hZZ_B = 2.d0*mz**2/vev*&
	 (&
	 +del_mZsq_B(mhp,mhn,ma,mu2,lam2)/mz**2&
	 +1.d0/2.d0*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
         +del_ZZ_B(mhp,mhn,ma,mu2,lam2) &
	 -del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	 )

	end function
!--------------------------------------------
	double complex function Gamma_hZZ_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
  	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	Gamma_hZZ_loop = &
	 +M1_hZZ_F(p1sq,p2sq,qsq)&
	 +del_M1_hZZ_F(mh)&
	 +M1_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)  &
	 +del_M1_hZZ_B(mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------
  	double complex function rGam1_hZZ(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam1_hZZ = 2.d0*mz**2/vev + Gamma_hZZ_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------
	double complex function rGam2_hZZ(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam2_hZZ = M2_hZZ_F(p1sq,p2sq,qsq) + M2_hZZ_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------
  	double complex function rGam3_hZZ(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam3_hZZ = M3_hZZ_F(p1sq,p2sq,qsq)

	end function
!=======================================================
!  hhh vertex
!=======================================================
  	double complex function del_hhh_F(mh)
	double precision, intent(in):: mh

	del_hhh_F =&
	-6.d0*(&
		(1.d0/vev)*del_mhsq_F(mh)/2.d0&
		+3.d0/4.d0*(mh**2/vev)*del_Zh_F(mh)&
		+mh**2/(2.d0*vev**3)*(-vev*del_v_F(mh))&
	)

	end function
!--------------------------------------------
  	double complex function del_hhh_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_hhh_B =&
	-6.d0*(&
		(1.d0/vev)*del_mhsq_B(mhp,mhn,ma,mu2,lam2)/2.d0&
		+3.d0/4.d0*(mh**2/vev)*del_Zh_B(mhp,mhn,ma,mu2,lam2)&
		+mh**2/(2.d0*vev**3)*(-vev*del_v_B(mhp,mhn,ma,mu2,lam2))&
	)

	end function
!----------------------------------------------
  	double complex function rGam_hhh(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGam_hhh = & 
		6.d0*g_h_h_h(mhp,mhn,ma,mu2,lam2)&
		+Gam_hhh_F(p1sq,p2sq,qsq)&
		+del_hhh_F(mh)&
		+Gam_hhh_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
		+del_hhh_B(mhp,mhn,ma,mu2,lam2)

	end function
!=======================================================
!  hWW vertex
!=======================================================
  	double complex function del_M1_hWW_F(mh)
	double precision, intent(in):: mh

	del_M1_hWW_F = 2.d0*mw**2/vev*(&
	 +del_mWsq_F(mh)/mw**2&
	 +del_ZW_F(mh)&
	 +1.d0/2.d0*del_Zh_F(mh)&
	 -del_v_F(mh)/vev&
	 )

	end function
!--------------------------------------------
  	double complex function del_M1_hWW_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_M1_hWW_B = mw**2/vev*(&
	 2.d0*del_mWsq_B(mhp,mhn,ma,mu2,lam2)/mw**2&
	 +2.d0*del_ZW_B(mhp,mhn,ma,mu2,lam2)&
	 +del_Zh_B(mhp,mhn,ma,mu2,lam2)&
	 -2.d0*del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
	 )

	end function
!--------------------------------------------
  	double complex function Gamma_hWW_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	Gamma_hWW_loop = &
	 +M1_hWW_F(p1sq,p2sq,qsq)&
	 +del_M1_hWW_F(mh)&
	 +M1_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
	 +del_M1_hWW_B(mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------
  	double complex function rGam1_hWW(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam1_hWW = 2.d0*mw**2/vev + Gamma_hWW_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------
  	double complex function rGam2_hWW(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam2_hWW = M2_hWW_F(p1sq,p2sq,qsq) + M2_hWW_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------
  	double complex function rGam3_hWW(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2
	
	rGam3_hWW = M3_hWW_F(p1sq,p2sq,qsq)

	end function
!===========  h-> 2*gamma/Zgamma ==========================
	double precision function decay_hgamgam(mhp,mhn,ma,mu2,lam2,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: ORQCD
	doubleprecision:: S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mh**2; mu=mh/2.d0

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	! call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	! decay_hgamgam=alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3*&
	! ABS(&
   !       Nc*Qt**2*I_f(mh,mt)*(&
   !        +1.d0&
   !        -1.d0*alphas(lam_QCD5,mh/2.d0,5.d0)/pi*S_NLOQCD&
   !        -(alphas(lam_QCD5,mh/2.d0,5.d0)/pi)**2&
   !       *(31.d0/24.d0+7.d0/4.d0*log((mh/2.d0)**2/mt**2) )*S_NNLOQCD )& 
	! +Nc*Qb**2*I_f(mh,mb)&
	! +Qe**2*I_f(mh,mtau)&
	! +I_W(mh)&
	! -I_S(mh,mhp)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev&
	! )**2

	if (ORQCD == -1) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				Nc*Qt**2*I_f(mh,mt)&
            +Nc*Qb**2*I_f(mh,mb)&
   			+Qe**2*I_f(mh,mtau)&
   			+I_W(mh)&
				-I_S(mh,mhp)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev&
   		)**2
	else if (ORQCD == 0) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				Nc*Qt**2*rmt/mt*I_f(mh,mt)&
            +Nc*Qb**2*rmb/mb*I_f(mh,mb)&
   			+Qe**2*I_f(mh,mtau)&
   			+I_W(mh)&
				-I_S(mh,mhp)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev&
   		)**2
	else if (ORQCD == 1) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				Nc*Qt**2*rmt/mt*(&
					I_f(mh,mt)&
   				! NLO QCD
               -alphas(lam_QCD,mu,nf)/pi*C_H(mh,mt,mu)&
				)&
            +Nc*Qb**2*rmb/mb*I_f(mh,mb)*(&
					I_f(mh,mb)&
					! NLO QCD
					-alphas(lam_QCD,mu,nf)/pi*C_H(mh,mb,mu)&
				)&
   			+Qe**2*I_f(mh,mtau)&
   			+I_W(mh)&
				-I_S(mh,mhp)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev&
   		)**2
   else if (ORQCD == 2) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				Nc*Qt**2*rmt/mt*(&
					I_f(mh,mt)&
   				! NLO QCD
               -alphas(lam_QCD,mu,nf)/pi*C_H(mh,mt,mu)&
   				! NNLO QCD
   				-I_f(mh,mt)*(alphas(lam_QCD5,mh/2.d0,5.d0)/pi)**2*(&
   					31.d0/24.d0+7.d0/4.d0*log((mh/2.d0)**2/mt**2)&
					)&
				)&
            +Nc*Qb**2*rmb/mb*I_f(mh,mb)*(&
					I_f(mh,mb)&
					! NLO QCD
					-alphas(lam_QCD,mu,nf)/pi*C_H(mh,mb,mu)&
				)&
   			+Qe**2*I_f(mh,mtau)&
   			+I_W(mh)&
				-I_S(mh,mhp)*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev&
   		)**2
   endif

	end function
!----------------------------------------
	double precision function decay_hZgam(mhp,mhn,ma,mu2,lam2,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: ORQCD
	doubleprecision:: S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: g_HpHmZ
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mh**2; mu=mh/2.d0
	g_HpHmZ=gz/2.d0*(cw**2-sw**2)

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	! call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)
	! decay_hZgam=dsqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)*&
	! (1.d0-mz**2/mh**2)**3*&
	! abs(&
	! -g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev*g_HpHmZ*J_S(mh,mhp)&
	! +Nc*Qt*vt*J_f(mh,mt)*(&
   !        +1.d0&
   !        -1.d0*alphas(lam_QCD5,mh/2.d0,5.d0)/pi*S_NLOQCD&
   !        +0.d0*S_NNLOQCD )& 
	! +Nc*Qb*vb*J_f(mh,mb)&
	! +Qe*ve*J_f(mh,mtau)&
	! +J_W(mh)&
	! )**2

	if (ORQCD == -1) then
		decay_hZgam =&
   		sqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)&
   		*(1.d0-mz**2/mh**2)**3&
   		*abs(&
				Nc*Qt*vt*J_f(mh,mt)&
   			+Nc*Qb*vb*J_f(mh,mb)&
   			+Qe*ve*J_f(mh,mtau)&
   			+J_W(mh)&
				-g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev*g_HpHmZ*J_S(mh,mhp)&
   		)**2
   else if (ORQCD == 0) then
		decay_hZgam =&
   		sqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)&
   		*(1.d0-mz**2/mh**2)**3&
   		*abs(&
				Nc*Qt*vt*rmt/mt*J_f(mh,mt)&
   			+Nc*Qb*vb*rmb/mb*J_f(mh,mb)&
   			+Qe*ve*J_f(mh,mtau)&
   			+J_W(mh)&
				-g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev*g_HpHmZ*J_S(mh,mhp)&
   		)**2
	else if (1 <= ORQCD) then
		decay_hZgam =&
   		sqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)&
   		*(1.d0-mz**2/mh**2)**3&
   		*abs(&
				Nc*Qt*vt*rmt/mt*J_f(mh,mt)*(&
					1&
					! NLO QCD
					-alphas(lam_QCD,mu,nf)/pi&
				)&
   			+Nc*Qb*vb*rmb/mb*J_f(mh,mb)&
   			+Qe*ve*J_f(mh,mtau)&
   			+J_W(mh)&
				-g_hp_hm_h(mhp,mhn,ma,mu2,lam2)/vev*g_HpHmZ*J_S(mh,mhp)&
   		)**2
   endif

	end function 
!=======================================================
!  H+W-H vertex
!=======================================================
	double precision function Gam_bHWHp_tree(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_bHWHp_tree = -mW/vev

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_bHWHp_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_bHWHp_F =&
	Gam_bHWHp_tree(mhp,mhn,ma,mu2,lam2)*(&
		+del_mWsq_F(mh)/(2.d0*mw**2)&
		-del_v_F(mh)/vev&
		+del_ZW_F(mh)/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_bHWHp_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_bHWHp_B =&
	Gam_bHWHp_tree(mhp,mhn,ma,mu2,lam2)*(&
		+del_mWsq_B(mhp,mhn,ma,mu2,lam2)/(2.d0*mw**2)&
		-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
		+(del_ZW_B(mhp,mhn,ma,mu2,lam2)+del_Zhp_B(mhp,mhn,ma,mu2,lam2)+del_Zhn_B(mhp,mhn,ma,mu2,lam2))/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHWHp_loop_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_bHWHp_loop_F = del_Gam_bHWHp_F(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHWHp_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_bHWHp_loop_B =&
		+Gam_bHWHp_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
		+del_Gam_bHWHp_B(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHWHp_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_bHWHp_loop =&
		+Gam_bHWHp_loop_F(mhp,mhn,ma,mu2,lam2)&
		+Gam_bHWHp_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_bHWHp(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGam_bHWHp =&
		+Gam_bHWHp_tree(mhp,mhn,ma,mu2,lam2)&
		+Gam_bHWHp_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!=======================================================
!  H+W-A vertex
!=======================================================
	complex (kind(0d0)) function Gam_AWHp_tree(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_AWHp_tree = ii*mw/vev

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_AWHp_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_AWHp_F =&
	Gam_AWHp_tree(mhp,mhn,ma,mu2,lam2)*(&
		+del_mWsq_F(mh)/(2.d0*mw**2)&
		-del_v_F(mh)/vev&
		+del_ZW_F(mh)/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_AWHp_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_AWHp_B =&
	Gam_AWHp_tree(mhp,mhn,ma,mu2,lam2)*(&
		+del_mWsq_B(mhp,mhn,ma,mu2,lam2)/(2.d0*mw**2)&
		-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
		+(del_ZW_B(mhp,mhn,ma,mu2,lam2)+del_Zhp_B(mhp,mhn,ma,mu2,lam2)+del_Za_B(mhp,mhn,ma,mu2,lam2))/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AWHp_loop_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_AWHp_loop_F = del_Gam_AWHp_F(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AWHp_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_AWHp_loop_B =&
		+Gam_AWHp_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
		+del_Gam_AWHp_B(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AWHp_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_AWHp_loop =&
		+Gam_AWHp_loop_F(mhp,mhn,ma,mu2,lam2)&
		+Gam_AWHp_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_AWHp(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGam_AWHp =&
		+Gam_AWHp_tree(mhp,mhn,ma,mu2,lam2)&
		+Gam_AWHp_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!=======================================================
!  AZbH vertex
!=======================================================
	complex (kind(0d0)) function Gam_AZbH_tree(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_AZbH_tree = ii*mZ/vev

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_AZbH_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_AZbH_F =&
	Gam_AZbH_tree(mhp,mhn,ma,mu2,lam2)*(&
		+del_mZsq_F(mh)/(2.d0*mZ**2)&
		-del_v_F(mh)/vev&
		+del_ZZ_F(mh)/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_AZbH_B(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_AZbH_B =&
	Gam_AZbH_tree(mhp,mhn,ma,mu2,lam2)*(&
		+del_mZsq_B(mhp,mhn,ma,mu2,lam2)/(2.d0*mZ**2)&
		-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
		+(del_ZZ_B(mhp,mhn,ma,mu2,lam2)+del_Za_B(mhp,mhn,ma,mu2,lam2)+del_Zhn_B(mhp,mhn,ma,mu2,lam2))/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZbH_loop_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_AZbH_loop_F = del_Gam_AZbH_F(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZbH_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_AZbH_loop_B =&
		+Gam_AZbH_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
		+del_Gam_AZbH_B(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZbH_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	Gam_AZbH_loop =&
		+Gam_AZbH_loop_F(mhp,mhn,ma,mu2,lam2)&
		+Gam_AZbH_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_AZbH(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

	rGam_AZbH =&
		+Gam_AZbH_tree(mhp,mhn,ma,mu2,lam2)&
		+Gam_AZbH_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

	end function
!=======================================================
!  hHH vertex
!=======================================================
	complex (kind(0d0)) function Gam_hbHbH_tree(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_hbHbH_tree = 2.d0*g_hn_hn_h(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_hbHbH_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_hbHbH_F =&
	Gam_hbHbH_tree(mhp,mhn,ma,mu2,lam2)*(&
		-del_v_F(mh)/vev&
		+del_Zh_F(mh)/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_hbHbH_B(mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r

	del_Gam_hbHbH_B =&
	-2.d0/vev*(&
		+del_mhnsq_B(mhp,mhn,ma,mu2,lam2)&
		-del_mu2sq_B(mhp,mhn,ma,mu2,lam2,mu_r)&
	)&
	+Gam_hbHbH_tree(mhp,mhn,ma,mu2,lam2)*(&
		-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
		+del_Zh_B(mhp,mhn,ma,mu2,lam2)/2.d0&
		+del_Zhn_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hbHbH_loop_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_hbHbH_loop_F = del_Gam_hbHbH_F(mhp,mhn,ma,mu2,lam2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hbHbH_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	Gam_hbHbH_loop_B =&
		+Gam_hbHbH_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
		+del_Gam_hbHbH_B(mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hbHbH_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	Gam_hbHbH_loop =&
		+Gam_hbHbH_loop_F(mhp,mhn,ma,mu2,lam2)&
		+Gam_hbHbH_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_hbHbH(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	rGam_hbHbH =&
		+Gam_hbHbH_tree(mhp,mhn,ma,mu2,lam2)&
		+Gam_hbHbH_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!=======================================================
!  hAA vertex
!=======================================================
	complex (kind(0d0)) function Gam_hAA_tree(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_hAA_tree = 2.d0*g_a_a_h(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_hAA_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_hAA_F =&
	Gam_hAA_tree(mhp,mhn,ma,mu2,lam2)*(&
		-del_v_F(mh)/vev&
		+del_Zh_F(mh)/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_hAA_B(mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r

	del_Gam_hAA_B =&
	-2.d0/vev*(&
		+del_masq_B(mhp,mhn,ma,mu2,lam2)&
		-del_mu2sq_B(mhp,mhn,ma,mu2,lam2,mu_r)&
	)&
	+Gam_hAA_tree(mhp,mhn,ma,mu2,lam2)*(&
		-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
		+del_Zh_B(mhp,mhn,ma,mu2,lam2)/2.d0&
		+del_Za_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hAA_loop_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_hAA_loop_F = del_Gam_hAA_F(mhp,mhn,ma,mu2,lam2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hAA_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	Gam_hAA_loop_B =&
		+Gam_hAA_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
		+del_Gam_hAA_B(mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hAA_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	Gam_hAA_loop =&
		+Gam_hAA_loop_F(mhp,mhn,ma,mu2,lam2)&
		+Gam_hAA_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_hAA(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	rGam_hAA =&
		+Gam_hAA_tree(mhp,mhn,ma,mu2,lam2)&
		+Gam_hAA_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!=======================================================
!  hH+H- vertex
!=======================================================
	complex (kind(0d0)) function Gam_hHpHm_tree(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_hHpHm_tree = g_hp_hm_h(mhp,mhn,ma,mu2,lam2)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_hHpHm_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_Gam_hHpHm_F =&
	Gam_hHpHm_tree(mhp,mhn,ma,mu2,lam2)*(&
		-del_v_F(mh)/vev&
		+del_Zh_F(mh)/2.d0&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function del_Gam_hHpHm_B(mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r

	del_Gam_hHpHm_B =&
	-2.d0/vev*(&
		+del_mhpsq_B(mhp,mhn,ma,mu2,lam2)&
		-del_mu2sq_B(mhp,mhn,ma,mu2,lam2,mu_r)&
	)&
	+Gam_hHpHm_tree(mhp,mhn,ma,mu2,lam2)*(&
		-del_v_B(mhp,mhn,ma,mu2,lam2)/vev&
		+del_Zh_B(mhp,mhn,ma,mu2,lam2)/2.d0&
		+del_Zhp_B(mhp,mhn,ma,mu2,lam2)&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hHpHm_loop_F(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Gam_hHpHm_loop_F = del_Gam_hHpHm_F(mhp,mhn,ma,mu2,lam2)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hHpHm_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	Gam_hHpHm_loop_B =&
		+Gam_hHpHm_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)&
		+del_Gam_hHpHm_B(mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hHpHm_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	Gam_hHpHm_loop =&
		+Gam_hHpHm_loop_F(mhp,mhn,ma,mu2,lam2)&
		+Gam_hHpHm_loop_B(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_hHpHm(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r

	rGam_hHpHm =&
		+Gam_hHpHm_tree(mhp,mhn,ma,mu2,lam2)&
		+Gam_hHpHm_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)

	end function
!================================================
!    SECTION VI RGE                             !
!================================================
!--------- g1 ------------------
	double precision function g1(t0,t)
	double precision, intent(in)::  t0,t
	double precision c1

	c1= 20.d0/9.d0*ng+1.d0/6.d0*nh
	g1= gp/sqrt(1.d0-2.d0*c1*gp**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g2 ------------------
	double precision function g2(t0,t)
	double precision, intent(in)::  t0,t
	double precision c2

	c2=(-22.d0/3.d0+4.d0/3.d0*ng+1.d0/6.d0*nh)
	g2=g/sqrt(1.d0-2.d0*c2*g**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g3 ------------------
	double precision function g3(t0,t)
	double precision, intent(in)::  t0,t
	double precision c3

	c3=(-11.d0+4.d0/3.d0*ng)
	g3=gs/sqrt(1.d0-2.d0*c3*gs**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- beta(lam1) ------------------
	double precision function beta_lam1(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam1 =&
		1.d0/(16.d0*pi**2)*(&
			12.d0*vlam1**2&
			+4.d0*vlam3**2&
			+2.d0*vlam4**2&
			+4.d0*vlam3*vlam4&
			+2.d0*vlam5**2&
			-12.d0*vyt**4&
			+9.d0/4.d0*g2(t0,t)**4&
			+3.d0/4.d0*g1(t0,t)**4&
			+3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
			-3.d0*vlam1*(3.d0*g2(t0,t)**2+g1(t0,t)**2-4.d0*vyt**2)&
		)

	end function
!--------- beta(lam2) ------------------
	double precision function beta_lam2(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam2 =&
		1.d0/(16.d0*pi**2)*(&
			12.d0*vlam2**2&
			+4.d0*vlam3**2&
			+2.d0*vlam4**2&
			+4.d0*vlam3*vlam4&
			+2.d0*vlam5**2&
			+9.d0/4.d0*g2(t0,t)**4&
			+3.d0/4.d0*g1(t0,t)**4&
			+3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
			-3.d0*vlam2*(3.d0*g2(t0,t)**2+g1(t0,t)**2)&
		)

	end function
!--------- beta(lam3) ------------------
	double precision function beta_lam3(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam3 =&
		1.d0/(16.d0*pi**2)*(&
			2.d0*(vlam1+vlam2)*(3.d0*vlam3+vlam4)&
			+4.d0*vlam3**2+2.d0*vlam4**2+2.d0*vlam5**2&
			+9.d0/4.d0*g2(t0,t)**4&
			+3.d0/4.d0*g1(t0,t)**4&
			-3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&       
			-3.d0*vlam3*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
		)

	end function
!--------- beta(lam4) ------------------
	double precision function beta_lam4(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam4 =&
		1.d0/(16.d0*pi**2)*(&
			2.d0*vlam4*(vlam1+vlam2+4.d0*vlam3+2.d0*vlam4)&
			+8.d0*vlam5**2&
			+3.d0*g1(t0,t)**2*g2(t0,t)**2&
			-3.d0*vlam4*(3.d0*g2(t0,t)**2+g1(t0,t)**2-2.d0*vyt**2)&
		)

	end function
!--------- beta(lam5) ------------------
	double precision function beta_lam5(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam5 =&
		1.d0/(16.d0*pi**2)*(&
			2.d0*vlam5*(vlam1+vlam2+4.d0*vlam3+6.d0*vlam4)&
			-3.d0*vlam5*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
		)

	end function
!--------- beta(yt) ------------------
	double precision function beta_yt(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_yt =&
		1.d0/(16.d0*pi**2)*(&
			+9.d0/2.d0*vyt**3&
			-vyt*(8.d0*g3(t0,t)**2+9.d0/4.d0*g2(t0,t)**2+17.d0/12.d0*g1(t0,t)**2)&
		)

	end function
!================================================
!    SECTION VII SUBROUTINES                    !
!================================================
	subroutine RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision:: rk_lam1(4),rk_lam2(4), rk_lam3(4), rk_lam4(4), rk_lam5(4),rk_yt(4) 
	double precision, intent(in):: t0,tfin,t,h
	double precision :: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	integer, intent(in):: no
! ----------------------------------------------------------------------------------
           rk_lam1(1)   = beta_lam1  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam2(1)   = beta_lam2  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam3(1)   = beta_lam3  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam4(1)   = beta_lam4  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam5(1)   = beta_lam5  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_yt(1)     = beta_yt    (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
!--------------- STEP 2 ----------------------------------------------------------------------------------
           rk_lam1(2)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam2(2)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam3(2)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam4(2)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam5(2)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_yt  (2)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
!--------------- STEP 3 ----------------------------------------------------------------------------------
           rk_lam1(3)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam2(3)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam3(3)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam4(3)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam5(3)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_yt  (3)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
!--------------- STEP 4 ----------------------------------------------------------------------------------
           rk_lam1(4)   = beta_lam1  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam2(4)   = beta_lam2  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam3(4)   = beta_lam3  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam4(4)   = beta_lam4  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam5(4)   = beta_lam5  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_yt(4)     = beta_yt    &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
!--------------- SUM ----------------------------------------------------------------------------------
           vlam1   = vlam1   + h/6.d0*(rk_lam1(1)   +2.d0*rk_lam1(2)   +2.d0*rk_lam1(3)   + rk_lam1(4))
           vlam2   = vlam2   + h/6.d0*(rk_lam2(1)   +2.d0*rk_lam2(2)   +2.d0*rk_lam2(3)   + rk_lam2(4))
           vlam3   = vlam3   + h/6.d0*(rk_lam3(1)   +2.d0*rk_lam3(2)   +2.d0*rk_lam3(3)   + rk_lam3(4))
           vlam4   = vlam4   + h/6.d0*(rk_lam4(1)   +2.d0*rk_lam4(2)   +2.d0*rk_lam4(3)   + rk_lam4(4))
           vlam5   = vlam5   + h/6.d0*(rk_lam5(1)   +2.d0*rk_lam5(2)   +2.d0*rk_lam5(3)   + rk_lam5(4))
           vyt     = vyt     + h/6.d0*(rk_yt  (1)   +2.d0*rk_yt  (2)   +2.d0*rk_yt  (3)   + rk_yt  (4))
	end subroutine 
!---------------------------------------------------------------
	subroutine RGE_sm(t0,tfin,h,t,no,vlam1,vyt)
	double precision:: rk_lam1(4),rk_lam2(4), rk_lam3(4), rk_lam4(4), rk_lam5(4),rk_yt(4) 
	double precision, intent(in):: t0,tfin,t,h
	double precision :: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	integer, intent(in):: no
! ----------------------------------------------------------------------------------
           rk_lam1(1)   = beta_lam1  (t0,t,vlam1,0.d0,0.d0,0.d0,0.d0,vyt)
           rk_yt(1)     = beta_yt    (t0,t,vlam1,0.d0,0.d0,0.d0,0.d0,vyt)
!--------------- STEP 2 ----------------------------------------------------------------------------------
           rk_lam1(2)   = beta_lam1  (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,0.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(1)/2.d0)
           rk_yt  (2)   = beta_yt    (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,0.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(1)/2.d0)
!--------------- STEP 3 ----------------------------------------------------------------------------------
           rk_lam1(3)   = beta_lam1  (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,0.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(2)/2.d0)
           rk_yt  (3)   = beta_yt    (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,0.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(2)/2.d0)
!--------------- STEP 4 ----------------------------------------------------------------------------------
           rk_lam1(4)   = beta_lam1  (t0,t+h,vlam1+h*rk_lam1(3),0.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(3))
           rk_yt(4)     = beta_yt    (t0,t+h,vlam1+h*rk_lam1(3),0.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(3))
!--------------- SUM ----------------------------------------------------------------------------------
           vlam1   = vlam1   + h/6.d0*(rk_lam1(1)   +2.d0*rk_lam1(2)   +2.d0*rk_lam1(3)   + rk_lam1(4))
           vyt     = vyt     + h/6.d0*(rk_yt  (1)   +2.d0*rk_yt  (2)   +2.d0*rk_yt  (3)   + rk_yt  (4))
	end subroutine 
!-----------------------------------------------------------------------------------------
	double precision function triviality(cutoff,mhp,mhn,ma,mu2,lam2)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	double precision, intent(in):: cutoff,mhp,mhn,ma,mu2,lam2

           vlam1 = lam1(mhp,mhn,ma,mu2,lam2)
           vlam2 = lam2
           vlam3 = lam3(mhp,mhn,ma,mu2,lam2)
           vlam4 = lam4(mhp,mhn,ma,mu2,lam2)
           vlam5 = lam5(mhp,mhn,ma,mu2,lam2)
           vyt   =  sqrt(2.d0)*mt/vev*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))

	   no=100
           t0= Log(mh)
	   tfin=Log(1.d10)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           max_coup = max(abs(vlam1),abs(vlam2),abs(vlam3),abs(vlam4),abs(vlam5),abs(vyt))
           if (exp(t) .lt. cutoff .and. max_coup .gt. 4.d0*pi) then 
           triviality = 1.d0
           exit
           else if  (exp(t) .gt. cutoff .and. max_coup .le. 4.d0*pi) then 
           triviality = 0.d0
           exit
           endif
           enddo

	end function
!-----------------------------------------------------------------------------------------
	double precision function triviality_MSM(cutoff,mhp,mhn,ma,mu2,lam2)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,cr
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	double precision, intent(in):: cutoff,mhp,mhn,ma,mu2,lam2
        cr=4.d0*pi
!--------------------------- sm RGE----------------------------------------
           vlam1 = lam1(mhp,mhn,ma,mu2,lam2)
           vyt   =  sqrt(2.d0)*mt/vev*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))
           triviality_MSM = 0.d0
           no=100

           t0= Log(mh)
           tfin= Log(dsqrt(mu2))
           h=(tfin-t0)/dble(no)
           do  i = 0,no
           t=t0+h*dble(i)
           call RGE_sm(t0,tfin,h,t,no,vlam1,vyt)
           max_coup = max(abs(vlam1),abs(vyt))
              if (max_coup .gt. cr) then
           triviality_MSM = 2.d0
           go to 30
           end if
           end do
           t0= 0.d0; tfin= 0.d0; h=0.d0; t=0.d0
!--------------------------- IDM RGE----------------------------------------
           vlam2 = lam2
           vlam3 = lam3(mhp,mhn,ma,mu2,lam2)
           vlam4 = lam4(mhp,mhn,ma,mu2,lam2)
           vlam5 = lam5(mhp,mhn,ma,mu2,lam2)
	   no=100
           t0= Log(dsqrt(mu2))
	   tfin=Log(1.d10)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           max_coup = max(abs(vlam1),abs(vlam2),abs(vlam3),abs(vlam4),abs(vlam5),abs(vyt))
           if (exp(t) .lt. cutoff .and. max_coup .gt. cr) then 
           triviality_MSM = 1.d0
           exit
           else if  (exp(t) .gt. cutoff .and. max_coup .le. cr) then 
           triviality_MSM = 0.d0
           exit
           endif
           enddo
30         continue 
	end function
!-----------------------------------------------------------------------------------------
	double precision function vs_rge(cutoff,mhp,mhn,ma,mu2,lam2)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt,stab
	double precision, intent(in):: cutoff,mhp,mhn,ma,mu2,lam2

           vlam1 = lam1(mhp,mhn,ma,mu2,lam2)
           vlam2 = lam2
           vlam3 = lam3(mhp,mhn,ma,mu2,lam2)
           vlam4 = lam4(mhp,mhn,ma,mu2,lam2)
           vlam5 = lam5(mhp,mhn,ma,mu2,lam2)
           vyt   =  sqrt(2.d0)*mt/vev*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))
           vs_rge=0.d0

	   no=100
           t0= Log(mh)
	   tfin=Log(cutoff)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
         stab = sqrt(vlam1*vlam2)+vlam3 + min1(0.d0,vlam4+vlam5,vlam4-vlam5)     
         if (vlam1 .le. 0.d0) then  ! KS: I modified .lt. to .le. for all if sentences 19/3/19
            vs_rge=1.d0  
         else if (vlam2 .le. 0.d0) then
            vs_rge=2.d0 
         else if (stab .le. 0.d0) then 
            vs_rge=3.d0  
         end if
         enddo
	end function
!-----------------------------------------------------------------------------------------
	double precision function vs_rge_MSM(cutoff,mhp,mhn,ma,mu2,lam2)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt,stab
	double precision, intent(in):: cutoff,mhp,mhn,ma,mu2,lam2
           !--------------------------- SM RGE ----------------------------
           vlam1 = lam1(mhp,mhn,ma,mu2,lam2)
           vyt   =  sqrt(2.d0)*mt/vev*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))
           vs_rge_MSM = 0.d0
           no=100
           t0= Log(mh)
           tfin= Log(dsqrt(mu2))
           h=(tfin-t0)/dble(no)
           do  i = 0,no
           t=t0+h*dble(i)
           call RGE_sm(t0,tfin,h,t,no,vlam1,vyt)
           if (vlam1 .le. 0.d0) then
           vs_rge_MSM = 4.d0
           end if
           end do
           t0=0.d0;tfin=0.d0;h=0.d0;t=0.d0
           !-------------------------- IDM RGE -------------------------------
           vlam2 = lam2
           vlam3 = lam3(mhp,mhn,ma,mu2,lam2)
           vlam4 = lam4(mhp,mhn,ma,mu2,lam2)
           vlam5 = lam5(mhp,mhn,ma,mu2,lam2)

	   no=100
           t0= Log(dsqrt(mu2))
	   tfin=Log(cutoff)
           h=(tfin-t0)/dble(no)
           do  i = 0,no
	   t=t0+h*dble(i)
     	   call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
         stab = sqrt(vlam1*vlam2)+vlam3 + min1(0.d0,vlam4+vlam5,vlam4-vlam5)     
         if (vlam1 .le. 0.d0) then  ! KS: I modified .lt. to .le. for all if sentences 19/3/19
            vs_rge_MSM=1.d0  
         else if (vlam2 .le. 0.d0) then
            vs_rge_MSM=2.d0 
         else if (stab .le. 0.d0) then 
            vs_rge_MSM=3.d0  
         end if
         enddo
	end function

!============S,T parameters==================================

	! double complex function del_S_IDM(mhp,mhn,ma,mu2,lam2)
	! double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        ! del_S_IDM = 1.d0/4.d0/pi*(db5f(0.d0,mhp,mhp)-db5f(0.d0,mh,ma))
        ! end function

        ! double complex function del_T_IDM(mhp,mhn,ma,mu2,lam2)
	! double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        ! del_T_IDM =-dsqrt(2.d0)*G_F/16.d0/pi**2/alpha_em*(b5f(0.d0,mhp,mhp)-b5f(0.d0,mhn,mhp)&
        ! +b5f(0.d0,mhn,ma)-b5f(0.d0,ma,mhp))
        ! end function

!====== Gauge boson two point functions ========
	double complex function PiWW_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiWW_SM_B=PiWW_B_WOH(qsq)+g**2/(16.d0*pi**2)*( mw**2*b0f(qsq,mh,mW)+1.d0/4.d0*b5f(qsq,mh,mw) )

 	end function
!---------------------------------------------
	double complex function PiZZ_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiZZ_SM_B=PiZZ_B_WOH(qsq)+ g**2/cw**2/(16.d0*pi**2)*( mZ**2*b0f(qsq,mh,mZ)+1.d0/4.d0*b5f(qsq,mh,mZ) )

 	end function
!---------------------------------------------
	double complex function PiGG_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiGG_SM_B=PiGG_B_WOH(qsq)

 	end function
!---------------------------------------------
	double complex function PiZG_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	PiZG_SM_B=PiZG_B_WOH(qsq)

 	end function
!---------------------------------------------
	double complex function dPiGG_SM_B(qsq,mh)
	double precision, intent(in):: qsq,mh
	
	dPiGG_SM_B=dPiGG_B_WOH(qsq)

 	end function
!============== S-T parameters in the SM, THDM  ======================
	double complex function S_SM(mh)
	double precision, intent(in):: mh

	S_SM =& 
	4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_F(mz**2)-PiGG_F(0.d0)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_F(mz**2)-PiZG_F(0.d0))&
	-(PiZZ_F(mz**2)-PiZZ_F(0.d0))&
	)&
!
	+4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_SM_B(mz**2,mh)-PiGG_SM_B(0.d0,mh)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_SM_B(mz**2,mh)-PiZG_SM_B(0.d0,mh))&
	-(PiZZ_SM_B(mz**2,mh)-PiZZ_SM_B(0.d0,mh))&
	)
 
	end function
!---------------------------------------------
	double complex function S_IDM(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in)::mhp,mhn,ma,mu2,lam2

	S_IDM =& 
	4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_F(mz**2)-PiGG_F(0.d0)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_F(mz**2)-PiZG_F(0.d0))&
	-(PiZZ_F(mz**2)-PiZZ_F(0.d0))&
	)&
!
	+4.d0*sw**2*cw**2/(alpha_em*mz**2)*(&
	  PiGG_B(mz**2,mhp,mhn,ma,mu2,lam2)-PiGG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
	+(cw**2-sw**2)/(cw*sw)*(PiZG_B(mz**2,mhp,mhn,ma,mu2,lam2)-PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2))&
	-(PiZZ_B(mz**2,mhp,mhn,ma,mu2,lam2)-PiZZ_B(0.d0,mhp,mhn,ma,mu2,lam2))&
	)

	end function
!---------------------------------------------
	double complex function T_SM(mh)
	double precision, intent(in):: mh
	
	T_SM =&
	1.d0/alpha_em*(&
	PiZZ_F(0.d0)/mz**2-PiWW_F(0.d0)/mw**2&
	+2.d0*sw/cw*PiZG_F(0.d0)/mz**2+sw**2/cw**2*PiGG_F(0.d0)/mz**2&
	)&
!
	+1.d0/alpha_em*(&
	PiZZ_SM_B(0.d0,mh)/mz**2-PiWW_SM_B(0.d0,mh)/mw**2&
	+2.d0*sw/cw*PiZG_SM_B(0.d0,mh)/mz**2+sw**2/cw**2*PiGG_SM_B(0.d0,mh)/mz**2&
	)
 
	end function

!---------------------------------------------
        double complex function T_IDM(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	
	T_IDM =&
	1.d0/alpha_em*(&
	PiZZ_F(0.d0)/mz**2-PiWW_F(0.d0)/mw**2&
	+2.d0*sw/cw*PiZG_F(0.d0)/mz**2+sw**2/cw**2*PiGG_F(0.d0)/mz**2&
	)&
!
	+1.d0/alpha_em*(&
	PiZZ_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2-PiWW_B(0.d0,mhp,mhn,ma,mu2,lam2)/mw**2&
	+2.d0*sw/cw*PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2&
        +sw**2/cw**2*PiGG_B(0.d0,mhp,mhn,ma,mu2,lam2)/mz**2&
	)
 
	end function
!---------------------------------------------
	double complex function del_S(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        del_S = S_IDM(mhp,mhn,ma,mu2,lam2)-S_SM(mh)
	end function
!---------------------------------------------
	double complex function del_T(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        del_T = T_IDM(mhp,mhn,ma,mu2,lam2)-T_SM(mh)
	end function
!---------------------------------------------
	double complex function stu(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        double precision:: vdel_S,vdel_T,muS,muT,sigmaS,sigmaT,rhoST,tmp

        vdel_S = del_S(mhp,mhn,ma,mu2,lam2)
        vdel_T = del_T(mhp,mhn,ma,mu2,lam2)

        muS = 0.05d0
        sigmaS = 0.09d0
        muT = 0.08d0
        sigmaT = 0.07d0
        rhoST = +0.91d0

        tmp = (vdel_S-muS)*(&
        sigmaT**2*(vdel_S-muS)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        -rhoST*sigmaS*sigmaT*(vdel_T-muT)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        )&
        +(vdel_T-muT)*(&
        sigmaS**2*(vdel_T-muT)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        -rhoST*sigmaS*sigmaT*(vdel_S-muS)/(sigmaS**2*sigmaT**2-rhoST**2*sigmaS**2*sigmaT**2)&
        )

        if (tmp  .le. 5.99d0) then 
        stu = 0.d0
        else if (tmp .gt. 5.99d0) then 
        stu = 1.d0
        endif

      end function stu

!-------- hZgam hgamgam vertex function at the 1-loop level --------------

       complex (kind(0d0)) function rGam1_hZgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2


       rGam1_hZgam_S=&
            -4.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*(g*sw)*gz*(cw**2-sw**2)*1.d0/16.d0/pi**2*&
            ( c24f(p1sq,p2sq,qsq,mhp,mhp,mhp)-1.d0/4.d0*b0f(qsq,mhp,mhp))
        end function
!-----------------------------------------------------------------           
       complex (kind(0d0)) function rGam2_hZgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

       rGam2_hZgam_S=&
            -4.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*(g*sw)*gz*(cw**2-sw**2)*1.d0/16.d0/pi**2*&
            ( c23f(p1sq,p2sq,qsq,mhp,mhp,mhp)+c12f(p1sq,p2sq,qsq,mhp,mhp,mhp))
        end function
!-----------------------------------------------------------------  
       complex (kind(0d0)) function rGam1_hZgam(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

       rGam1_hZgam=&
            rGam1_hZgam_F_SM(p1sq,p2sq,qsq)&
           +rGam1_hZgam_W_SM(p1sq,p2sq,qsq)&
           +rGam1_hZgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

       end function
!-----------------------------------------------------------------  
       complex (kind(0d0)) function rGam2_hZgam(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

       rGam2_hZgam=&
            rGam2_hZgam_F_SM(p1sq,p2sq,qsq)&
           +rGam2_hZgam_W_SM(p1sq,p2sq,qsq)&
           +rGam2_hZgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       end function

!----------------------------------------------------------------
       complex (kind(0d0)) function rGam1_hgamgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

       rGam1_hgamgam_S=&
            -8.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*(g*sw)**2*1.d0/16.d0/pi**2*&
            ( c24f(p1sq,p2sq,qsq,mhp,mhp,mhp)-1.d0/4.d0*b0f(qsq,mhp,mhp))
        end function
!-----------------------------------------------------------------   
       complex (kind(0d0)) function rGam2_hgamgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2


       rGam2_hgamgam_S=&
            -8.d0*g_hp_hm_h(mhp,mhn,ma,mu2,lam2)*(g*sw)**2*1.d0/16.d0/pi**2*&
            ( c23f(p1sq,p2sq,qsq,mhp,mhp,mhp)+c12f(p1sq,p2sq,qsq,mhp,mhp,mhp))
        end function
!-----------------------------------------------------------------         
       complex (kind(0d0)) function rGam1_hgamgam(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

       rGam1_hgamgam=&
            rGam1_hgamgam_F_SM(p1sq,p2sq,qsq)&
           +rGam1_hgamgam_W_SM(p1sq,p2sq,qsq)&
           +rGam1_hgamgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

       end function
!-----------------------------------------------------------------    
       complex (kind(0d0)) function rGam2_hgamgam(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2

       rGam2_hgamgam=&
            rGam2_hgamgam_F_SM(p1sq,p2sq,qsq)&
           +rGam2_hgamgam_W_SM(p1sq,p2sq,qsq)&
           +rGam2_hgamgam_S(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)
       end function
!#########################################################
!#
!#     Decay of h
!#
!#########################################################
        double precision function decay_hbb(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        integer, intent(in):: OREW,ORQCD
        doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
        double precision:: p1sq,p2sq,qsq,CF,mu,y_hbb,rmb
        p1sq=mb**2; p2sq=mb**2; qsq=mh**2
        CF = 4.d0/3.d0; mu = mh
        y_hbb = (-mb/vev)
        rmb = mq_bar(mu,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD5,mb_MS,5.d0),mb_MS) 
        call Switch_HOEW(OREW,S_NLOEW)
        call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)


        decay_hbb=&
           3.d0*mh/8.d0/pi*(1.d0-4.d0*mb**2/mh**2)**(3.d0/2.d0)*&
            (mb/vev+S_RMSM*(rmb-mb)/vev)**2*(&
! LO
            1.d0&
! NLO Weak correction
             +(-Del_r(mhp,mhn,ma,mu2,lam2)&
             +(1.d0/y_hbb)*2.d0*real(&
             rGamS_hbb(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)-y_hbb&   !y_hff is added to subtract cont. of tree in rGamS_hff
             +mb*( Fhff_V1(p1sq,p2sq,qsq,mh,mb)-Fhff_V2(p1sq,p2sq,qsq,mh,mb) )&
             +mh**2*(1.d0-mb**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mh,mb)&
                  ) )*S_NLOEW&
! NLO QED correction
        !       +alpha_em/pi*Qb**2*(17.d0/4.d0&
        !             +3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
        !             +9.d0/4.d0*log(mu**2/mh**2)**2 )*S_NLOEW&
! NLO QCD correction
              +alphas(lam_QCD5,mh,5.d0)/pi*CF*(17.d0/4.d0&
                    +3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
                    +9.d0/4.d0*log(mu**2/mh**2)**2 )*S_NLOQCD&
! NNLOQCD correction                                          
           +(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
           +(alphas(lam_QCD5,mh,5.d0)/pi)**2*(1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
            +1.d0/9.d0*(log(rmb**2/mh**2) )**2 )*S_NNLOQCD&
                  ) &
         +3.d0*((mb+S_RMSM*(rmb-mb))**2/mb**2)*decay_h_ffgam_sm(mb)*S_NLOEW
        end function decay_hbb
!----------------------------------------------------------------- 
        double precision function decay_hcc(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        integer, intent(in):: OREW,ORQCD
        doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
        double precision:: p1sq,p2sq,qsq,CF,mu,y_hcc,rmc
        p1sq=mc**2; p2sq=mc**2; qsq=mh**2
        CF = 4.d0/3.d0
        mu = mh
        y_hcc = (-mc/vev)
        rmc = mq_bar(mu,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD4,mc_MS,4.d0),mc_MS) 
        call Switch_HOEW(OREW,S_NLOEW)
        call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)
 

        decay_hcc=&
            3.d0*mh/8.d0/pi*(1.d0-4.d0*mc**2/mh**2)**(3.d0/2.d0)*&
            (mc/vev+S_RMSM*(rmc-mc)/vev)**2*(&
! LO
            1.d0&
! NLO Weak correction
            +(-Del_r(mhp,mhn,ma,mu2,lam2)&
            +2.d0*(1.d0/y_hcc)*real(&
            rGamS_hcc(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)-y_hcc& !y_hff is added to subtract cont. of tree in rGamS_hff
            +mc*( Fhff_V1(p1sq,p2sq,qsq,mh,mc)-Fhff_V2(p1sq,p2sq,qsq,mh,mc) )&
             +mh**2*(1.d0-mc**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mh,mc)&
                 ) )*S_NLOEW&
! NLO QED correction
        !       +alpha_em/pi*Qt**2*(17.d0/4.d0&
        !             +3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
        !             +9.d0/4.d0*log(mu**2/mh**2)**2 )*S_NLOEW&
! NLO QCD correction
              +alphas(lam_QCD5,mh,5.d0)/pi*CF*(17.d0/4.d0&
                    +3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
                    +9.d0/4.d0*log(mu**2/mh**2)**2 )*S_NLOQCD&
! NNLO QCD correction                          
             +(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
             +(alphas(lam_QCD5,mh,5.d0)/pi)**2*(1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
             +1.d0/9.d0*(log(rmc**2/mh**2) )**2 )*S_NNLOQCD&
                  ) &
           +3.d0*((mc+S_RMSM*(rmc-mc))**2/mc**2)*decay_h_ffgam_sm(mc)*S_NLOEW
      end function decay_hcc
!-----------------------------------------------
        double precision function decay_htautau(mhp,mhn,ma,mu2,lam2,OREW)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        integer, intent(in):: OREW
        doubleprecision:: S_NLOEW
        double precision:: p1sq,p2sq,qsq,y_htautau
        p1sq=mtau**2; p2sq=mtau**2; qsq=mh**2
        y_htautau = (-mtau/vev)
        call Switch_HOEW(OREW,S_NLOEW) 

        decay_htautau =&
           mh/8.d0/pi*(1.d0-4.d0*mtau**2/mh**2)**(3.d0/2.d0)*&
           y_htautau**2*(&
! LO
          1.d0&
! NLO Weak correction
          +(-Del_r(mhp,mhn,ma,mu2,lam2)&
          +2.d0*(1.d0/y_htautau)*real(&
          rGamS_htautau(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)-y_htautau& !y_hff is added to subtract cont. of tree in rGamS_hff
          +mtau*( Fhff_V1(p1sq,p2sq,qsq,mh,mtau)-Fhff_V2(p1sq,p2sq,qsq,mh,mtau) )&
          +mh**2*(1.d0-mtau**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mh,mtau)&
                 ) )*S_NLOEW&
! NLO QED correction
                !  +Del_QED_hff(mtau)*S_NLOEW&  ! NLO QED correction (exaxt formula)
                 )&
         +decay_h_ffgam_sm(mtau)*S_NLOEW
        
      end function decay_htautau
!-----------------------------------------------
        double precision function decay_hmumu(mhp,mhn,ma,mu2,lam2,OREW)
        double precision, intent(in):: mhp,mhn,ma,mu2,lam2
        integer, intent(in):: OREW
        doubleprecision:: S_NLOEW
        double precision:: p1sq,p2sq,qsq,y_hmumu
        p1sq=mmu**2; p2sq=mmu**2; qsq=mh**2
        y_hmumu = (-mmu/vev)
        call Switch_HOEW(OREW,S_NLOEW) 

        decay_hmumu =&
           mh/8.d0/pi*(1.d0-4.d0*mmu**2/mh**2)**(3.d0/2.d0)*&
           y_hmumu**2*(&
! LO
          1.d0&
! NLO Weak correction
          +(-Del_r(mhp,mhn,ma,mu2,lam2)&
          +2.d0*(1.d0/y_hmumu)*real(&
          rGamS_hmumu(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)-y_hmumu& !y_hff is added to subtract cont. of tree in rGamS_hff
          +mmu*( Fhff_V1(p1sq,p2sq,qsq,mh,mmu)-Fhff_V2(p1sq,p2sq,qsq,mh,mmu) )&
          +mh**2*(1.d0-mmu**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mh,mmu)&
                 ) )*S_NLOEW&
! NLO QED correction
!                 +Del_QED_hff(mmu)*S_NLOEW&  ! NLO QED correction (exaxt formula)
                 ) &
        +decay_h_ffgam_sm(mmu)*S_NLOEW
      end function 

!------------------ dGamma( h-->Zff )/dqsq  at NLO ------------------    
       double precision function dGam_dqsq_hZZ_NLO(qsq,vf,af,Iff,Qf,mhp,mhn,ma,mu2,lam2)
       double precision, intent(in):: qsq,vf,af,Iff,Qf
       double precision, intent(in):: mhp,mhn,ma,mu2,lam2
       double precision:: epsZ,epsQ,x1,x2,ckin_a,ckin_b,s24,s23
       epsZ=mZ**2/mh**2
       epsQ=qsq/mh**2
       x1=1.d0+epsZ-epsQ
       ckin_a=sqrt(x1**2-4.d0*epsZ)*((x1-6.d0*epsZ)**2+8.d0*epsZ*(1.d0-3.d0*epsZ))
       ckin_b=(x1**2-4.d0*epsZ)**(3.d0/2.d0)*(x1-2.d0*epsZ)*mh**2/2.d0
! note: this calcration is not included contributuion from hff vertex corrections and box diagrams  

       dGam_dqsq_hZZ_NLO=&
            mh**3*gz**4/384.d0/pi**3*(vf**2+af**2)/(qsq-mz**2)**2*ckin_a*(&
            1.d0/2.d0&                                                                           ! Tree cont.
                  -(Del_r(mhp,mhn,ma,mu2,lam2))&                                             ! Delta_r
                   -1.d0/2.d0*real(rdPiZZ(mZ**2,mhp,mhn,ma,mu2,lam2))&                           ! dPiZZ 
                    +1.d0/(2.d0*mZ**2/vev)*(&
                    +real(Gamma_hZZ_loop(mZ**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2))&                  ! hZZ Gam1 NLO cont.
                    +ckin_b/ckin_a*real(rGam2_hZZ(mZ**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2))/mZ**2)&  ! hZZ Gam2 NLO cont.
                    -real(rPiZZ(qsq,mhp,mhn,ma,mu2,lam2) )/(qsq-mZ**2)&                          ! PiZZ cont. 
                    +1.d0/(vf**2+af**2)*(&
                      (qsq-mZ**2)/(qsq)*vf*Qf*cw*sw*(&
                      1.d0/(2.d0*mZ**2/vev)*(&
                      +real(rGam1_hZgam(mZ**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2) )&                  ! hZGam Gam1 
                      +ckin_b/ckin_a*real(rGam2_hZgam(mZ**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2)) )&   ! hZGam Gam2 
                      -real(rPiZG(qsq,mhp,mhn,ma,mu2,lam2) )/(qsq-mZ**2)&                        ! PiZG cont.
                    )&
                     -1.d0/(gz)*(&
                            +vf*real(rGamV_Zff_loop_SM(qsq,vf,af,Iff))&                          ! ZffV NLO cont. 
                           -af*real(rGamA_Zff_loop_SM(qsq,vf,af,Iff))&                           ! ZffA NLO cont.
                                             )&
                      )&
                )

       end function
!------------------------------------------------------------------    
       double precision function dGam_dqsq_hZnunu_NLO(qsq)
       double precision, intent(in):: qsq
       dGam_dqsq_hZnunu_NLO= &
              dGam_dqsq_hZZ_NLO(qsq,vnu,anu,It,0.d0,mhp,mhn,ma,mu2,lam2)

       end function
!------------------------------------------------------------------
       double precision function dGam_dqsq_hZee_NLO(qsq)
       double precision, intent(in):: qsq
       dGam_dqsq_hZee_NLO= dGam_dqsq_hZZ_NLO(qsq,ve,ae,Ie,qe,mhp,mhn,ma,mu2,lam2)
       end function
!------------------------------------------------------------------
       double precision function dGam_dqsq_hZuu_NLO(qsq)
       double precision, intent(in):: qsq
       dGam_dqsq_hZuu_NLO= dGam_dqsq_hZZ_NLO(qsq,vt,at,It,qt,mhp,mhn,ma,mu2,lam2)
       end function
!------------------------------------------------------------------
       double precision function dGam_dqsq_hZdd_NLO(qsq)
       double precision, intent(in):: qsq
       dGam_dqsq_hZdd_NLO= dGam_dqsq_hZZ_NLO(qsq,vb,ab,Ib,qb,mhp,mhn,ma,mu2,lam2)
       end function

! !------------------ dGamma( h-->Wffp )/dqsq  at NLO ------------------
        double precision function dGam_dqsq_hWW_NLO(qsq,mf,mhp,mhn,ma,mu2,lam2)
        double precision, intent(in):: qsq,mf,mhp,mhn,ma,mu2,lam2
        double precision:: epsW,epsQ,x1,ckin_a,ckin_b
        epsW=mW**2/mh**2
        epsQ=qsq/mh**2
        x1=1.d0+epsW-epsQ
        ckin_a=sqrt(x1**2-4.d0*epsW)*((x1-6.d0*epsW)**2+8.d0*epsW*(1.d0-3.d0*epsW))
        ckin_b=(x1**2-4.d0*epsW)**(3.d0/2.d0)*(x1-2.d0*epsW)*mh**2/2.d0
! ! note: this calcration is not included contributuion from hff vertex corrections and box diagrams 
        dGam_dqsq_hWW_NLO= &
            mh**3*(2.d0*mW**2/vev)**2/384.d0/pi**3/vev**2/(qsq-mW**2)**2*ckin_a*(&
            1.d0/2.d0&                                                                                ! Tree cont. 
                -(Del_r(mhp,mhn,ma,mu2,lam2) )&                                                   ! Delta_r  
                -1.d0/2.d0*real(rdPiWW(mW**2,mhp,mhn,ma,mu2,lam2) )&                                  ! rdPiWW 
                +1.d0/(2.d0*mW**2/vev)*(&
                         +real(Gamma_hWW_loop(mW**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2) )&                 ! hWW Gam1 NLO cont.    
                         +ckin_b/ckin_a*real(rGam2_hWW(mW**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2))/mW**2)&  ! hWW Gam2 NLO cont. 
                -real(rPiWW(qsq,mhp,mhn,ma,mu2,lam2))/(qsq-mW**2)&                                    ! PiWW cont.    
                -sqrt(2.d0)/g*real(rGam_Wffp_loop_SM(qsq,mf)) &                                       ! Wff NLO cont.    
             )

        end function
!------------------------------------------------------------------
       double precision function dGam_dqsq_hWmunu_NLO(qsq)
       double precision, intent(in):: qsq
       dGam_dqsq_hWmunu_NLO= &
            dGam_dqsq_hWW_NLO(qsq,mmu,mhp,mhn,ma,mu2,lam2)
       end function

! ------------------------------------------------------------------
       double precision function dGam_dqsq_hWcs_NLO(qsq)
       double precision, intent(in):: qsq
       dGam_dqsq_hWcs_NLO= &
            3.d0*dGam_dqsq_hWW_NLO(qsq,mc,mhp,mhn,ma,mu2,lam2) ! 3 is color factor
       end function

!------------------------------------------------------------------ 
       subroutine decay_hZZstar(vhZZstar,vhZnunu_TB,vhZee_TB,vhZuu_TB,vhZdd_TB,OREW,ORQCD)
       double precision, intent(out):: vhZZstar
       double precision, intent(in):: vhZnunu_TB,vhZee_TB,vhZuu_TB,vhZdd_TB
       integer, intent(in)::OREW,ORQCD
       double precision:: vhZnunu,vhZee,vhZuu,vhZdd,dummy
       double precision,parameter:: epsi=0.0001d0,mm =0.1d0
       vhZZstar = 0.d0
       vhZnunu=0.d0;vhZee=0.d0;vhZuu=0.d0;vhZdd=0.d0;dummy=0.d0
![EW=NLO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~
        if (OREW .eq. 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 ) then 
        call romberg(vhZnunu,dGam_dqsq_hZnunu_NLO,0.d0+epsi,(mh-mZ)**2-epsi) ! h->Znunu 
        vhZnunu=vhZnunu + vhZnunu_TB

        call romberg(vhZee,dGam_dqsq_hZee_NLO,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)  !h->Zee 
        vhZee = vhZee+vhZee_TB

        call romberg(vhZuu,dGam_dqsq_hZuu_NLO,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi) ! h->Zuu
        vhZuu=vhZuu+vhZuu_TB

        call romberg(vhZdd,dGam_dqsq_hZdd_NLO,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)! h->Zdd
        vhZdd = vhZdd+ vhZdd_TB

        vhZZstar=3.d0*vhZnunu+3.d0*vhZee +6.d0*vhZuu+9.d0*vhZdd

![EW=LO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~
         else if (OREW .eq. 0 .and. ORQCD .ge.-1 .and. ORQCD .le.2 ) then 
         call decay_hZZstar_sm(vhZZstar,dummy,dummy,dummy,dummy,OREW,ORQCD)

        else
        vhZZstar = 0.d0

        end if
        end subroutine

!------------------------------------------------------------------ 
       subroutine decay_hWWstar(vhWWstar,vhWcs_TBSH,vhWmunu_TBSH,OREW,ORQCD)
       double precision, intent(out):: vhWWstar
       double precision, intent(in):: vhWcs_TBSH,vhWmunu_TBSH
       integer, intent(in)::OREW,ORQCD
       double precision:: vhWcs,vhWmunu,dummy
       double precision,parameter:: epsi=0.0001d0,epsics=0.1d0 !comment:if epsics = epsi,the cancellation of div parameter doesn't happen for h->Wcs
       vhWWstar=0.d0
       vhWcs=0.d0;vhWmunu=0.d0;dummy=0.d0
![EW=NLO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~ 
        if (OREW .eq. 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 ) then
        call romberg(vhWcs,dGam_dqsq_hWcs_NLO,(mc+msir)**2+epsics,(mh-mW)**2-epsi) ! h->W-cs~ 
        vhWcs= vhWcs+vhWcs_TBSH
        
        call romberg(vhWmunu,dGam_dqsq_hWmunu_NLO,(2.d0*mmu)**2+epsi,(mh-mW)**2-epsi)! h->W+mu-n
        vhWmunu=vhWmunu+vhWmunu_TBSH

        vhWWstar =  2.d0*(3.d0*vhWmunu+2.d0*vhWcs)

    

![EW=LO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~
        else if (OREW .eq. 0 .and. ORQCD .ge.-1 .and. ORQCD .le.2 ) then 
        call decay_hWWstar_sm(vhWWstar,dummy,dummy,OREW,ORQCD)
        else
        vhWWstar = 0.d0
        end if
        end subroutine
!--------------------------------------------------------------------------
	double precision function Gam_hbHbH(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mhn <= mh) then
		Gam_hbHbH = decay_hbHbH(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	else
		Gam_hbHbH = 0.d0
	endif

	if(Gam_hbHbH < 0.d0) then
		write(*,*) 'Gam_hbHbH is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_hAA(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r
	integer, intent(in):: OREW,ORQCD

	if(2.d0*ma <= mh) then
		Gam_hAA = decay_hAA(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	else
		Gam_hAA = 0.d0
	endif

	if(Gam_hAA < 0.d0) then
		write(*,*) 'Gam_hAA is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_hHpHm(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mhp <= mh) then
		Gam_hHpHm = decay_hHpHm(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	else
		Gam_hHpHm = 0.d0
	endif

	if(Gam_hHpHm < 0.d0) then
		write(*,*) 'Gam_hHpHm is negative'
	endif

	end function
!=====================================================
!	Two body decay functions
!=====================================================
	double precision function decay_hbHbH(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mhn**2; p2sq=mhn**2; qsq=mh**2
	xphi = mhn/mh

	!===================
	!     LO
	!===================
	Gam_LO = Gam_hbHbH_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = Gam_LO**2/(32.d0*pi*mh)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)

	if(OREW == 0) then
		decay_hbHbH = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	Gam_NLO = Gam_hbHbH_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	decay_EWNLO = 1.d0/(32.d0*pi*mh)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)*(&
			+2.d0*dble(Gam_LO*conjg(Gam_NLO)))
	decay_EWNLO = decay_EWNLO&
			+decay_LO*(&
				-Del_r(mhp,mhn,ma,mu2,lam2)&
			)

	if(OREW == 1) then
		decay_hbHbH = decay_LO+decay_EWNLO
		return
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_hAA(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=ma**2; p2sq=ma**2; qsq=mh**2
	xphi = ma/mh

	!===================
	!     LO
	!===================
	Gam_LO = Gam_hAA_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = Gam_LO**2/(32.d0*pi*mh)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)

	if(OREW == 0) then
		decay_hAA = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	Gam_NLO = Gam_hAA_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
	decay_EWNLO = 1.d0/(32.d0*pi*mh)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)*(&
			+2.d0*dble(Gam_LO*conjg(Gam_NLO)))
	decay_EWNLO = decay_EWNLO&
			+decay_LO*(&
				-Del_r(mhp,mhn,ma,mu2,lam2)&
			)

	if(OREW == 1) then
		decay_hAA = decay_LO+decay_EWNLO
		return
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_hHpHm(mhp,mhn,ma,mu2,lam2,mu_r,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2,mu_r
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mhp**2; p2sq=mhp**2; qsq=mh**2
	xphi = mhp/mh

	!===================
	!     LO
	!===================
	Gam_LO = Gam_hHpHm_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = Gam_LO**2/(16.d0*pi*mh)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)

	if(OREW == 0) then
		decay_hHpHm = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_NLO = Gam_hHpHm_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2,mu_r)
		decay_EWNLO = 1.d0/(16.d0*pi*mh)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)*(&
				+2.d0*dble(Gam_LO*conjg(Gam_NLO)))
		decay_EWNLO = decay_EWNLO&
				+decay_LO*(&
					-Del_r(mhp,mhn,ma,mu2,lam2)&
				)
		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_h_chchgam(mhp,mhn,ma,mu2,lam2)
		decay_hHpHm = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_h_chchgam(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: xch
	xch = mhp/mh

	decay_h_chchgam =&
		-alpha_em*(g_hp_hm_h(mhp,mhn,ma,mu2,lam2))**2/(4.d0*pi**2)/mh*(&
			+mhp**2*(Ibrems_11(mh,mhp,mhp)+Ibrems_22(mh,mhp,mhp))&
			-(mh**2-2.d0*mhp**2)*Ibrems_12(mh,mhp,mhp)&
			+Ibrems_1(mh,mhp,mhp)+Ibrems_2(mh,mhp,mhp)&		
		)

	end function
!#########################################################
!#
!#     Decay of bH
!#
!#########################################################
	double precision function Gam_bHAZ(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD

	if(mZ+ma <= mhn) then
		Gam_bHAZ = decay_bHAZ(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else if(ma < mhn) then
		Gam_bHAZ = decay_bHZstarA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else
		Gam_bHAZ = 0.d0
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHchW(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD

	if(mW+mhp <= mhn) then
		Gam_bHchW = decay_bHchW(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else if(mhp < mhn) then
		Gam_bHchW = decay_bHWstarch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else
		Gam_bHchW = 0.d0
	endif

	end function
!=====================================================
!	Two body decay functions
!=====================================================
	double precision function decay_bHAZ(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=ma**2; p2sq=mZ**2; qsq=mhn**2
	xphi = ma/mhn; xV = mZ/mhn

	!===================
	!     LO
	!===================
	Gam_LO = -Gam_AZbH_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = mhn**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*abs(Gam_LO)**2

	if(OREW == 0) then
		decay_bHAZ = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_NLO = -Gam_AZbH_loop(qsq,p2sq,p1sq,mhp,mhn,ma,mu2,lam2)
		!pbH = p1, pZ = p2, pA = q by definition

		decay_EWNLO = mhn**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
							+2.d0*dble(Gam_LO*conjg(Gam_NLO))&
						  )
		decay_EWNLO = decay_EWNLO&
						  +decay_LO*(&
							  -dble(rdPiZZ(mZ**2,mhp,mhn,ma,mu2,lam2))&
							  -Del_r(mhp,mhn,ma,mu2,lam2)&
						  )

		decay_bHAZ = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHchW(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mhp**2; p2sq=mW**2; qsq=mhn**2
	xphi = mhp/mhn; xV = mw/mhn

	!===================
	!     LO
	!===================
	Gam_LO = -Gam_bHWHp_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = 2.d0*mhn**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*abs(Gam_LO)**2

	if(OREW==0) then
		decay_bHchW = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_NLO = -Gam_bHWHp_loop(qsq,p2sq,p1sq,mhp,mhn,ma,mu2,lam2)
		!pbH = p1, pW = p2, pcH = q by definition

		decay_EWNLO = 2.d0*mhn**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
								+2.d0*dble(Gam_LO*conjg(Gam_NLO))&
						  )
		decay_EWNLO = +decay_EWNLO&
						  +decay_LO*(&
						  		-dble(rdPiWW(mW**2,mhp,mhn,ma,mu2,lam2))&
						  		-Del_r(mhp,mhn,ma,mu2,lam2)&
						  )

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_bH_chWgam(mhp,mhn,ma,mu2,lam2)

		decay_bHchW = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bH_chWgam(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: xch,xw
	xch = mhp/mhn; xW = mW/mhn

	decay_bH_chWgam =&
		-sqrt(2.d0)*G_F*mW**2*alpha_em/(2.d0*pi**2)*mhn**3*(&
			+lambda(xch**2,xW**2)*(&
				+Ibrems_22(mhn,mhp,mW)&
				+mhp**2/mW**2*Ibrems_11(mhn,mhp,mW)&
				+(1.d0+(mhp**2-mhn**2)/mW**2)*Ibrems_12(mhn,mhp,mW)&
				+1.d0/mW**2*(Ibrems_1(mhn,mhp,mW)+Ibrems_2(mhn,mhp,mW)))&
			-2.d0/mhn**4*(&
				+Ibrems(mhn,mhp,mW)+2.d0*Ibrems1_2(mhn,mhp,mW)+Ibrems11_22(mhn,mhp,mW))&
		)

	end function
!=====================================================
!	Three body decay functions
!=====================================================
	double precision function decay_bHZstarA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: KbHZA
	double precision:: mu,nf,lam_QCD

	KbHZA = 9.d0*G_F**2*mZ**4*mhn/16.d0/pi**3&
		*(7.d0/12.d0-10.d0/9.d0*sw**2+40.d0/27.d0*sw**4)

	if(ORQCD <= 0) then
		decay_bHZstarA = KbHZA*SSpV3body(mhn,ma,mZ)
	elseif (0 < ORQCD) then
		mu = mZ; nf=5.d0; lam_QCD=lam_QCD5
		decay_bHZstarA = KbHZA*SSpV3body(mhn,ma,mZ)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)&
			! NNLO  QCD correction
		)
	endif

	end function
!-------------------------------------------------------------------
	double precision function decay_bHWstarch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD) !Sum up W+H- and W-H+
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: KbHWch
	double precision:: mu,nf,lam_QCD

	KbHWch = 2.d0*9.d0*G_F**2*mW**4*mhn/16.d0/pi**3

	if(ORQCD <= 0) then
		decay_bHWstarch = KbHWch*SSpV3body(mhn,mhp,mW)
	elseif (0 < ORQCD) then
		mu = mW; nf=5.d0; lam_QCD=lam_QCD5
		decay_bHWstarch = KbHWch*SSpV3body(mhn,mhp,mW)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)&
			! NNLO  QCD correction
		)
	endif

	end function
!#########################################################
!#
!#     Decay of A
!#
!#########################################################
	double precision function Gam_AZbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD

	if(mZ+mhn < ma) then
		Gam_AZbH = decay_AZbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else if(mhn < ma .and. ma <= mZ+mhn) then
		Gam_AZbH = decay_AZstarbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else
		Gam_AZbH = 0.d0
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_AWch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD

	if(mW+mhn < ma) then
		Gam_AWch = decay_AWch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else if(mhp < ma .and. ma <= mW+mhp) then
		Gam_AWch = decay_AWstarch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else
		Gam_AWch = 0.d0
	endif

	end function
!=====================================================
!	Two body decay functions
!=====================================================
	double precision function decay_AZbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO,decay_EWNNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mhn**2; p2sq=mZ**2; qsq=ma**2
	xphi = mhn/ma; xV = mZ/ma

	!===================
	!     LO
	!===================
	Gam_LO   = Gam_AZbH_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = ma**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*abs(Gam_LO)**2

	if(OREW == 0) then
		decay_AZbH = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_NLO = Gam_AZbH_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

		decay_EWNLO = ma**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
							+2.d0*dble(Gam_LO*conjg(Gam_NLO))&
						  )
		decay_EWNLO = decay_EWNLO&
						  +decay_LO*(&
							  -dble(rdPiZZ(mZ**2,mhp,mhn,ma,mu2,lam2))&
							  -Del_r(mhp,mhn,ma,mu2,lam2)&
						  )

		decay_AZbH = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_AWch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mhp**2; p2sq=mW**2; qsq=ma**2
	xphi = mhp/ma; xV = mW/ma

	!===================
	!     LO
	!===================
	Gam_LO   = -Gam_AWHp_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = 2.d0*ma**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*abs(Gam_LO)**2

	if(OREW==0) then
		decay_AWch = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_NLO = -Gam_AWHp_loop(qsq,p2sq,p1sq,mhp,mhn,ma,mu2,lam2)
		!pA = p1, pW = p2, pcH = q by definition

		decay_EWNLO = 2.d0*ma**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
							+2.d0*dble(Gam_LO*conjg(Gam_NLO))&
						  )
		decay_EWNLO = decay_EWNLO&
						  +decay_LO*(&
							  -dble(rdPiWW(mW**2,mhp,mhn,ma,mu2,lam2))&
							  -Del_r(mhp,mhn,ma,mu2,lam2)&
						  )

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_A_chWgam(mhp,mhn,ma,mu2,lam2)

		decay_AWch = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_A_chWgam(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: xch,xW
	xch = mhp/ma; xW = mW/ma

	decay_A_chWgam =&
		-sqrt(2.d0)*G_F*mW**2*alpha_em/(2.d0*pi**2)*ma**3*(&
			+lambda(xch**2,xW**2)*(&
				+Ibrems_22(ma,mhp,mW)&
				+mhp**2/mW**2*Ibrems_11(ma,mhp,mW)&
				+(1.d0+(mhp**2-ma**2)/mW**2)*Ibrems_12(ma,mhp,mW)&
				+1.d0/mW**2*(Ibrems_1(ma,mhp,mW)+Ibrems_2(ma,mhp,mW)))&
			-2.d0/ma**4*(&
				+Ibrems(ma,mhp,mW)+2.d0*Ibrems1_2(ma,mhp,mW)+Ibrems11_22(ma,mhp,mW))&
		)

	end function
!=====================================================
!	Three body decay functions
!=====================================================
	double precision function decay_AZstarbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: KAZbH
	double precision:: mu,nf,lam_QCD

	KAZbH = 9.d0*G_F**2*mZ**4*ma/16.d0/pi**3&
		*(7.d0/12.d0-10.d0/9.d0*sw**2+40.d0/27.d0*sw**4)

	if(ORQCD <= 0) then
		decay_AZstarbH = KAZbH*SSpV3body(ma,mhn,mZ)
	elseif (0 < ORQCD) then
		mu = mZ; nf=5.d0; lam_QCD=lam_QCD5
		decay_AZstarbH = KAZbH*SSpV3body(ma,mhn,mZ)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)&
			! NNLO  QCD correction
		)
	endif

	end function
!-------------------------------------------------------------------
	double precision function decay_AWstarch(mhp,mhn,ma,mu2,lam2,OREW,ORQCD) !Sum up W+H- and W-H+
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: KAWch
	double precision:: mu,nf,lam_QCD

	KAWch = 2.d0*9.d0*G_F**2*mW**4*mA/16.d0/pi**3

	if(ORQCD <= 0) then
		decay_AWstarch = KAWch*SSpV3body(ma,mhp,mW)
	elseif (0 < ORQCD) then
		mu = mW; nf=5.d0; lam_QCD=lam_QCD5
		decay_AWstarch = KAWch*SSpV3body(ma,mhp,mW)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)&
			! NNLO  QCD correction
		)
	endif

	end function
!#########################################################
!#
!#     Decay of charged scalar : H±
!#
!#########################################################
	double precision function Gam_chWbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD

	if(mW+mhn <= mhp) then
		Gam_chWbH = decay_chWbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else if(mhn < mhp) then
		Gam_chWbH = decay_chWstarbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else
		Gam_chWbH = 0.d0
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chWA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD

	if(mW+ma <= mhp) then
		Gam_chWA = decay_chWA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else if(ma < mhp) then
		Gam_chWA = decay_chWstarA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	else
		Gam_chWA = 0.d0
	endif

	end function
!=====================================================
!	Two body decay functions
!=====================================================
	double precision function decay_chWbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mhn**2; p2sq=mW**2; qsq=mhp**2
	xphi = mhn/mhp; xV = mW/mhp

	!===================
	!     LO
	!===================
	Gam_LO = Gam_bHWHp_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = mhp**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*abs(Gam_LO)**2

	if(OREW==0) then
		decay_chWbH = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_NLO = Gam_bHWHp_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

		decay_EWNLO = mhp**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
								+2.d0*dble(Gam_LO*conjg(Gam_NLO))&
						  )
		decay_EWNLO = +decay_EWNLO&
						  +decay_LO*(&
						  		-dble(rdPiWW(mW**2,mhp,mhn,ma,mu2,lam2))&
						  		-Del_r(mhp,mhn,ma,mu2,lam2)&
						  )

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_ch_WbHgam(mhp,mhn,ma,mu2,lam2)

		decay_chWbH = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_ch_WbHgam(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: xphi,xW
	xphi = mhn/mhp; xW = mW/mhp

	decay_ch_WbHgam =&
		-sqrt(2.d0)*G_F*mW**2*alpha_em/(4.d0*pi**2)*mhp**3*(&
	 		+lambda(xphi**2,xW**2)*(&
				+Ibrems_22(mhp,mhn,mW)&
				+mhp**2/mW**2*Ibrems_00(mhp,mhn,mW)&
				+(1.d0+(mhp**2-mhn**2)/mW**2)*Ibrems_02(mhp,mhn,mW)&
				+1.d0/mW**2*(Ibrems_2(mhp,mhn,mW)+Ibrems_0(mhp,mhn,mW))&
			)&
			-2.d0/mhp**4*Ibrems11_22(mhp,mhn,mW)&
		)

	end function
!--------------------------------------------------------------------------
	double precision function decay_chWA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=ma**2; p2sq=mW**2; qsq=mhp**2
	xphi = ma/mhp; xV = mW/mhp

	!===================
	!     LO
	!===================
	Gam_LO   = Gam_AWHp_tree(mhp,mhn,ma,mu2,lam2)
	decay_LO = mhp**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*abs(Gam_LO)**2

	if(OREW==0) then
		decay_chWA = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_NLO = Gam_AWHp_loop(p1sq,p2sq,qsq,mhp,mhn,ma,mu2,lam2)

		decay_EWNLO = mhp**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
							+2.d0*dble(Gam_LO*conjg(Gam_NLO))&
						  )
		decay_EWNLO = decay_EWNLO&
						  +decay_LO*(&
							  -dble(rdPiWW(mW**2,mhp,mhn,ma,mu2,lam2))&
							  -Del_r(mhp,mhn,ma,mu2,lam2)&
						  )

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_ch_WAgam(mhp,mhn,ma,mu2,lam2)

		decay_chWA = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_ch_WAgam(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	double precision:: xphi,xW
	xphi = ma/mhp; xW = mW/mhp

	decay_ch_WAgam =&
		-sqrt(2.d0)*G_F*mW**2*alpha_em/(4.d0*pi**2)*mhp**3*(&
	 		+lambda(xphi**2,xW**2)*(&
				+Ibrems_22(mhp,ma,mW)&
				+mhp**2/mW**2*Ibrems_00(mhp,ma,mW)&
				+(1.d0+(mhp**2-ma**2)/mW**2)*Ibrems_02(mhp,ma,mW)&
				+1.d0/mW**2*(Ibrems_2(mhp,ma,mW)+Ibrems_0(mhp,ma,mW))&
			)&
			-2.d0/mhp**4*Ibrems11_22(mhp,ma,mW)&
		)

	end function
!=====================================================
!	Three body decay functions
!=====================================================
	double precision function decay_chWstarbH(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: KchWbH
	double precision:: mu,nf,lam_QCD

	KchWbH = 9.d0*G_F**2*mW**4*mhp/16.d0/pi**3

	if(ORQCD <= 0) then
		decay_chWstarbH = KchWbH*SSpV3body(mhp,mhn,mW)
	elseif (0 < ORQCD) then
		mu = mW; nf=5.d0; lam_QCD=lam_QCD5
		decay_chWstarbH = KchWbH*SSpV3body(mhp,mhn,mW)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)&
			! NNLO  QCD correction
		)
	endif

	end function
!-------------------------------------------------------------------
	double precision function decay_chWstarA(mhp,mhn,ma,mu2,lam2,OREW,ORQCD)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2
	integer, intent(in):: OREW,ORQCD
	double precision:: KchWA
	double precision:: mu,nf,lam_QCD

	KchWA = 9.d0*G_F**2*mW**4*mhp/16.d0/pi**3

	if(ORQCD <= 0) then
		decay_chWstarA = KchWA*SSpV3body(mhp,ma,mW)
	elseif (0 < ORQCD) then
		mu = mW; nf=5.d0; lam_QCD=lam_QCD5
		decay_chWstarA = KchWA*SSpV3body(mhp,ma,mW)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)&
			! NNLO  QCD correction
		)
	endif

	end function
!##########################################################
! 
!    SECTION VI OTHER QUANTITIES          
!                                     
!##########################################################       
!--------------------------------------------- added from v2
	complex (kind(0d0)) function dPiZZ_S(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPiZZ_S =&
		g**2/cw**2/(16.d0*pi**2)*(&
			mZ**2*db0f(qsq,mh,mZ)+1.d0/4.d0*db5f(qsq,mh,mZ)&
			+1.d0/4.d0*(1.d0-4.d0*sw**2*cw**2)*db5f(qsq,mhp,mhp)+1.d0/4.d0*db5f(qsq,mhn,ma)& 
		)

	end function dPiZZ_S

	complex (kind(0d0)) function dPiWW_S(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPiWW_S =&
		g**2/(16.d0*pi**2)*(&
			+mW**2*db0f(qsq,mh,mW)+1.d0/4.d0*db5f(qsq,mh,mw)&
			+1.d0/4.d0*db5f(qsq,mhn,mhp)+1.d0/4.d0*db5f(qsq,ma,mhp)&
		)           

	end function dPiWW_S
!--------------------------------------------- 
	complex (kind(0d0)) function dPiZZ_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2
    
	dPiZZ_B = dPiZZ_B_WOH(qsq)+dPiZZ_S(qsq,mhp,mhn,ma,mu2,lam2)

	end function dPiZZ_B
!--------------------------------------------- 
	complex (kind(0d0)) function dPiWW_B(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	dPiWW_B = dPiWW_B_WOH(qsq)+dPiWW_S(qsq,mhp,mhn,ma,mu2,lam2)

	end function dPiWW_B
!--------------------------------------------
	complex (kind(0d0)) function rPiWW(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	rPiWW = PiWW_F(qsq) + PiWW_B(qsq,mhp,mhn,ma,mu2,lam2) - PiWW_pinch(qsq) &
		- (del_mWsq_F(mh)+del_mWsq_B(mhp,mhn,ma,mu2,lam2) ) &
		+ (qsq-mW**2)*(del_ZW_F(mh)+del_ZW_B(mhp,mhn,ma,mu2,lam2) )

	end function
!-------------------------------------------- 
	complex (kind(0d0)) function rdPiZZ(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	rdPiZZ = &
		dPiZZ_F(qsq)+dPiZZ_B(qsq,mhp,mhn,ma,mu2,lam2)-dPiZZ_pinch(qsq)& 
		+ del_ZZ_F(mh) +del_ZZ_B(mhp,mhn,ma,mu2,lam2)
                
	end function
 !--------------------------------------------
	complex (kind(0d0)) function rdPiWW(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	rdPiWW = dPiWW_F(qsq)+dPiWW_B(qsq,mhp,mhn,ma,mu2,lam2)-dPiWW_pinch(qsq) &
					+del_ZW_F(mh)+del_ZW_B(mhp,mhn,ma,mu2,lam2)

	end function
!--------------------------------------------  
	double precision function Del_r(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	Del_r = rPiWW(0.d0,mhp,mhn,ma,mu2,lam2)/mW**2 &
		+ alpha_em/(4.d0*pi*sw**2)*(6.d0 + (7.d0-4.d0*sw**2)/(2.d0*sw**2)*log(cw**2))

	end function
!-------------------------------------------- 
	complex (kind(0d0)) function rPiZZ(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	rPiZZ= PiZZ_F(qsq)+PiZZ_B(qsq,mhp,mhn,ma,mu2,lam2)-PiZZ_pinch(qsq)&
		-del_mZsq_F(mh)-del_mZsq_B(mhp,mhn,ma,mu2,lam2)&
		+(del_ZZ_F(mh)+del_ZZ_B(mhp,mhn,ma,mu2,lam2) )*(qsq-mZ**2)

	end function
!--------------------------------------------------------------                   
	complex (kind(0d0)) function del_ZZG(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: mhp,mhn,ma,mu2,lam2

	del_ZZG =&
		-2.d0/mZ**2*(-PiZG_F(0.d0)-PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)&
		+PiZG_pinch(0.d0))&
		+del_swsq(mhp,mhn,ma,mu2,lam2)/(sw*cw)

	end function
!--------------------------------------------------------------
	complex (kind(0d0)) function rPiZG(qsq,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,mhp,mhn,ma,mu2,lam2

	rPiZG= PiZG_F(qsq)+PiZG_B(qsq,mhp,mhn,ma,mu2,lam2)-PiZG_pinch(qsq)&
		-PiZG_F(0.d0)-PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)+PiZG_pinch(0.d0)&
		+qsq*(del_swsq(mhp,mhn,ma,mu2,lam2)/(sw*cw)&
		+2.d0/mZ**2*(PiZG_F(0.d0)+PiZG_B(0.d0,mhp,mhn,ma,mu2,lam2)-PiZG_pinch(0.d0)) )

	end function rPiZG
!--------------------------------------------------------------
	double precision function rmW(mhp,mhn,ma,mu2,lam2)
	double precision, intent(in)::mhp,mhn,ma,mu2,lam2

	rmW = sqrt(&
		mZ**2/2.d0*(1.d0&
			+sqrt(1.d0-4.d0*pi*alpha_em/&
			(sqrt(2.d0)*G_f*mZ**2*(1.d0-Del_r(mhp,mhn,ma,mu2,lam2))&
				))&
			)&
		)

	end function
!------------------ dGamma( h-->Wffp )/dqsqdcos  at NLO ------------------
	double precision function dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mf,mhp,mhn,ma,mu2,lam2)
	double precision, intent(in):: qsq,cos_the,mf,mhp,mhn,ma,mu2,lam2
	double precision:: epsW,epsQ,x1,x2,ckin1,ckin2,ckin3,s24,s23,vf,vfp,Qf,Qfp,af,afp
	! Be careful, if fermion masses digenerate, the bellow if sentence does not work. 

	if (mf .eq. mc) then
		vf = vt ; af = at ; Qf = Qt
		vfp = vb ; afp = ab ; Qfp = Qb
	elseif (mf .eq. msir) then 
		vf = vb ; af = ab ; Qf = Qb
		vfp  = vt ; afp  = at ; Qfp  = Qt
	elseif (mf .eq. mtau) then 
		vf = ve ; af = ae ; Qf = Qe
		vfp = vnu ; afp = anu ; Qfp = 0.d0
	elseif (mf .eq. mmu) then 
		vf = ve ; af = ae ; Qf = Qe 
		vfp = vnu ; afp = anu ; Qfp = 0.d0
	endif

	epsW=mW**2/mh**2
	epsQ=qsq/mh**2
	x1=1.d0+epsW-epsQ
	x2=1.d0/2.d0*(2.d0-x1+sqrt(x1**2-4.d0*mW**2/mh**2)*cos_the)
	s24=mh**2*(1.d0-x2)
	s23=mh**2+mW**2-qsq-s24
	ckin1=4.d0*qsq+2.d0/mW**2*(s24*s23-mh**2*mW**2)
	ckin2=1.d0/mW**2*(s24*s23-mh**2*mW**2)*(mh**2-mW**2-qsq)
	ckin3=2.d0*qsq*(s24-s23)

! Full expressions
	dGam_dqsqdcos_hWW_NLO= 1.d0/(256.d0*pi**3*mh)*&
		2.d0*g**2*(mW**2/vev)**2&
		*(1.d0/2.d0)*sqrt(x1**2-4.d0*epsW)/(qsq-mW**2)**2*ckin1*(&
				1.d0/2.d0&                                                  !Tree cont.
						-real(Del_r(mhp,mhn,ma,mu2,lam2))&                   !Delta_r
						-1.d0/2.d0*real(rdPiWW(mW**2,mhp,mhn,ma,mu2,lam2))&                         !rdPiWW
						+1.d0/(2.d0*mW**2/vev)*(&
							+real(Gamma_hWW_loop(mW**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2))&                !hWW Gam1 NLO cont.
							+ckin2/ckin1*real(rGam2_hWW(mW**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2))/mW**2&  !hWW Gam2 NLO cont.
							+ckin3/ckin1*real(rGam3_hWW(mW**2,qsq,mh**2,mhp,mhn,ma,mu2,lam2))/mW**2)& !hWW Gam3 NLO cont.
							-real(rPiWW(qsq,mhp,mhn,ma,mu2,lam2))/(qsq-mW**2)&                        ! PiWW cont.
							-sqrt(2.d0)/g*real(rGam_Wffp_loop_SM(qsq,mf))&
						+(qsq-mW**2)*Thff_W_SM(vf,af,qsq,cos_the)&             ! hff NLO cont.  
					+(qsq-mW**2)*B_W_box(qsq,cos_the,mf)/ckin1&         ! Box NLO cont.  
						! soft photon contriburion
						+1.d0/2.d0*Del_soft_Wffp(qsq,cos_the,mf,0.1d0)& ! final valuables in the argument is delE 
                )

	end function
!dqsq ------------------------------------------------------------------
	subroutine Debug_hdecays_QED()
	double precision :: vGamhbb_noRE_QED0,vGamhcc_noRE_QED0
	double precision :: vGamhtautau_noRE_QED0,vGamhmumu_noRE_QED0
	double precision :: vhWW,dummy,vhWcs_TBSH_sm,vhWmunu_TBSH_sm
	double precision :: getlambda
	complex (kind(0d0)),allocatable:: vltput(:)

	!===== This is needed for calculations with mphoton=0.d0 ======
	QED = 1.d0; mphoton = 0.d0
	allocate (vltput(300))
	call Cput(vltput,125.d0**2,80.d0**2,400.d0**2,400.d0**2,80.d0**2,0.d0)
	call Dput(vltput,msir**2,mc**2,mW**2,mh**2,20.d0**2,10.d0**2,mW**2,mc**2,0.d0,mW**2)
	!====================================================   

	write(*,*) '#----------------------------------------------------------------------'
	write(*,*) '# IR divergences in the h decays'
	write(*,*) '#----------------------------------------------------------------------'

	print*, "---------------IDM case ---------------------"
	!===== h -> bb =====
	QED = 0.d0; mphoton =  1.d-7
	vGamhbb_noRE_QED0=decay_hbb(mhp,mhn,ma,mu2,lam2,1,-1)&
	-3.d0*decay_h_ffgam_sm(mb)

	QED = 1.d0; mphoton = 0.d0

	print*,"Gam(h-->bb)[LO]", decay_hbb(mhp,mhn,ma,mu2,lam2,0,0)
	print*,"Del_QED_hff",Del_QED_hff(mb)
	write(*,*)

	call setlambda(1.d4)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->bb)[NLO EW, QCD=-1]", decay_hbb(mhp,mhn,ma,mu2,lam2,1,-1)
	print*,"Gam(h-->bb)[NLO EW, QCD=0]", decay_hbb(mhp,mhn,ma,mu2,lam2,1,0)

	print*,"Del_QED_hff(new)",(decay_hbb(mhp,mhn,ma,mu2,lam2,1,-1)-vGamhbb_noRE_QED0)&
	/decay_hbb(mhp,mhn,ma,mu2,lam2,0,-1)
	write(*,*)
	call setlambda(1.d8)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->bb)[NLO EW, QCD=-1]", decay_hbb(mhp,mhn,ma,mu2,lam2,1,-1)
	print*,"Gam(h-->bb)[NLO, QCD=0]", decay_hbb(mhp,mhn,ma,mu2,lam2,1,0)
	print*,"Del_QED_hff(new)",(decay_hbb(mhp,mhn,ma,mu2,lam2,1,-1)-vGamhbb_noRE_QED0)&
	/decay_hbb(mhp,mhn,ma,mu2,lam2,0,-1)
	write(*,*)


	!===== h -> cc =====
	QED = 0.d0; mphoton =  1.d-7
	vGamhcc_noRE_QED0=decay_hcc(mhp,mhn,ma,mu2,lam2,1,-1)&
	-3.d0*decay_h_ffgam_sm(mc)

	QED = 1.d0; mphoton = 0.d0

	print*,"Gam(h-->cc)[LO]", decay_hcc(mhp,mhn,ma,mu2,lam2,0,0)
	print*,"Del_QED_hff",Del_QED_hff(mc)
	write(*,*)

	call setlambda(1.d4)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->cc)[NLO EW, QCD=-1]", decay_hcc(mhp,mhn,ma,mu2,lam2,1,-1)
	print*,"Gam(h-->cc)[NLO EW, QCD=0]", decay_hcc(mhp,mhn,ma,mu2,lam2,1,0)

	print*,"Del_QED_hff(new)",(decay_hcc(mhp,mhn,ma,mu2,lam2,1,-1)-vGamhcc_noRE_QED0)&
	/decay_hcc(mhp,mhn,ma,mu2,lam2,0,-1)
	write(*,*)
	call setlambda(1.d8)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->cc)[NLO EW, QCD=-1]", decay_hcc(mhp,mhn,ma,mu2,lam2,1,-1)
	print*,"Gam(h-->cc)[NLO, QCD=0]", decay_hcc(mhp,mhn,ma,mu2,lam2,1,0)
	print*,"Del_QED_hff(new)",(decay_hcc(mhp,mhn,ma,mu2,lam2,1,-1)-vGamhcc_noRE_QED0)&
	/decay_hcc(mhp,mhn,ma,mu2,lam2,0,-1)
	write(*,*)

	!===== h -> tautau =====
	QED = 0.d0; mphoton =  1.d-7
	vGamhtautau_noRE_QED0=decay_htautau(mhp,mhn,ma,mu2,lam2,1)&
								-decay_h_ffgam_sm(mtau)

	QED = 1.d0; mphoton = 0.d0

	print*,"Gam(h-->tautau)[LO]", decay_htautau(mhp,mhn,ma,mu2,lam2,0)
	print*,"Del_QED_hff",Del_QED_hff(mtau)
	write(*,*)

	call setlambda(1.d4)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->tautau)[NLO]", decay_htautau(mhp,mhn,ma,mu2,lam2,1)
	print*,"Del_QED_hff(new)",(decay_htautau(mhp,mhn,ma,mu2,lam2,1)-vGamhtautau_noRE_QED0)&
	/decay_htautau(mhp,mhn,ma,mu2,lam2,0)
	write(*,*)
	call setlambda(1.d8)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->tautau)[NLO]", decay_htautau(mhp,mhn,ma,mu2,lam2,1)
	print*,"Del_QED_hff(new)",(decay_htautau(mhp,mhn,ma,mu2,lam2,1)-vGamhtautau_noRE_QED0)&
	/decay_htautau(mhp,mhn,ma,mu2,lam2,0)
	write(*,*)

	!===== h -> mumu =====
	QED = 0.d0; mphoton =  1.d-7
	vGamhmumu_noRE_QED0=decay_hmumu(mhp,mhn,ma,mu2,lam2,1)&
								-decay_h_ffgam_sm(mmu)
	QED = 1.d0; mphoton = 0.d0
	print*,"Gam(h-->mumu)[LO]", decay_hmumu(mhp,mhn,ma,mu2,lam2,0)
	print*,"Del_QED_hff",Del_QED_hff(mmu)
	write(*,*)

	call setlambda(1.d4)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->mumu)[NLO]", decay_hmumu(mhp,mhn,ma,mu2,lam2,1)
	print*,"Del_QED_hff(new)",(decay_hmumu(mhp,mhn,ma,mu2,lam2,1)-vGamhmumu_noRE_QED0)&
	/decay_hmumu(mhp,mhn,ma,mu2,lam2,0)
	print*,"decay_h_mumugam",decay_h_ffgam_sm(mmu)
	write(*,*)
	call setlambda(1.d8)
	write(*,*) 'mphoton =', sqrt(getlambda())
	print*,"Gam(h-->mumu)[NLO]", decay_hmumu(mhp,mhn,ma,mu2,lam2,1)
	print*,"Del_QED_hff(new)",(decay_hmumu(mhp,mhn,ma,mu2,lam2,1)-vGamhmumu_noRE_QED0)&
	/decay_hmumu(mhp,mhn,ma,mu2,lam2,0)
	print*,"decay_h_mumugam",decay_h_ffgam_sm(mmu)
	write(*,*)

	call setlambda(1.d4)
	! mphoton =  1.d-7
	write(*,*) 'mphoton =', sqrt(getlambda())


	call decay_hWWstar_sm(vhWW,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,1,2)
	! print*,"Gam_hWWstar_SM", vhWW
	print*,"dGam_dqsqdcos_hWcs", dGam_dqsqdcos_hWW_NLO(20.d0**2,0.5d0,mc,mhp,mhn,ma,mu2,lam2)
	print*,"dGam_dqsqdcos_hWmunu", dGam_dqsqdcos_hWW_NLO(20.d0**2,0.5d0,mmu,mhp,mhn,ma,mu2,lam2)
	call decay_hWWstar(vhWW,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,1,2)
	print*,"Gam_hWWstar", vhWW

	call setlambda(1.d8)
	write(*,*) 'mphoton =', sqrt(getlambda())

	call decay_hWWstar_sm(vhWW,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,1,2)
	! print*,"Gam_hWWstar_SM", vhWW
	print*,"dGam_dqsqdcos_hWcs", dGam_dqsqdcos_hWW_NLO(20.d0**2,0.5d0,mc,mhp,mhn,ma,mu2,lam2)
	print*,"dGam_dqsqdcos_hWmunu", dGam_dqsqdcos_hWW_NLO(20.d0**2,0.5d0,mmu,mhp,mhn,ma,mu2,lam2)
	call decay_hWWstar(vhWW,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,1,2)
	print*,"Gam_hWWstar", vhWW
	write(*,*)

	end subroutine

end subroutine HCOUP_IDM
