subroutine HCOUP_THDM(OREW,ORQCD,n)

use SM_const
use pv
use Gauge_boson_2p
use SM_Hdecay
use real_photon_emission
use HCOUP_SM
use func_forQCDco
use int_romberg

	implicit none

	integer:: i,j,k
	integer:: OREW,ORQCD,constraint(6)
	character(4):: C_EW
	character(20):: C_QCD
	double precision:: rmc_mh,rmb_mh

	!========== Model parameters ==========
	integer:: n
	integer:: sig
	double precision:: mch,ma,mbH,bmsq,tanb,sin_ba
	double precision:: beta,alpha
	double precision:: cutoff,mu_r
	double precision:: para1(100)
	integer:: SCHEME
	!---------- scheme difference ----------
	! 0: Pinched tadpole, del_bM^2
	! 1: KOSY with PT, del_bM^2
	! 2: KOSY with PT, del_m_12^2 (= Pinched tadpole, del_m_12^2 )

	!========== Momentum inputs ==========
	complex (kind(0d0)):: vhZZ(3),vhWW(3),vhtt(8),vhbb(8),vhcc(8),vhll(8),vhmumu(8),vhhh
	complex (kind(0d0)):: vhZZ_sm(3),vhWW_sm(3),vhtt_sm(8),vhbb_sm(8),vhcc_sm(8),vhll_sm(8),vhmumu_sm(8),vhhh_sm
	double precision:: p_hzz(3),p_hww(3),p_htt(3),p_hbb(3),p_hcc(3),p_hll(3),p_hmumu(3),p_hhh(3)
	double precision:: para2(100)

	!========== Unitarity/Tribiality/RGE ==========
	double precision:: lqt = 1.d0/2.d0
	double precision:: nh = 2.d0,ng = 3.d0,gs,gp
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5

	!========== SM Higgs decay ==========
	double precision:: hdecay_SM(-50:50,-50:50)=0.d0
	double precision:: BRh_SM(-50:50,-50:50)=0.d0
	double precision:: vGam_hhh_SM
	double precision:: Gam_h_total_SM
	!---------- h -> ZZ* and h-> WW* ----
	double precision:: vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
	double precision:: vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm

	!========== SM-like Higgs decay ==========
	double precision:: hdecay(-50:50,-50:50)=0.d0
	double precision:: BRh(-50:50,-50:50)=0.d0
	double precision:: vGam_hhh_2HDM
	double precision:: Gam_h_total

	!========== bH decay ==========
	double precision:: bHdecay(-50:50,-50:50)=0.d0
	double precision:: BRbH(-50:50,-50:50)=0.d0
	double precision:: Gam_bH_total

	!========== A decay ==========
	double precision:: Adecay(-50:50,-50:50)=0.d0
	double precision:: BRA(-50:50,-50:50)=0.d0
	double precision:: Gam_A_total

	!========== H± decay ==========
	double precision:: Hpmdecay(-50:50,-50:50)=0.d0
	double precision:: BRHpm(-50:50,-50:50)=0.d0
	double precision:: Gam_Hpm_total

	!========== LoopTools ==========
	double precision:: getlambda,getminmass,getmudim
	double precision:: p1sq,p2sq,qsq

	!========== files ==========
	integer:: flag, ios
	character:: writefile1*128,writefile2*128,writefile3*128,writefile4*128
	character:: readfile1*128
	logical:: hZZ_exist,hWW_exist

	!========== Misc. ==========
	complex (kind(0d0)),allocatable:: dummy(:)
	double precision:: rand(10)
	double precision:: test(100)=0.d0
	complex (kind(0d0)):: ctest(100)

	open(1, file='./inputs/in_thdm.txt')
	do i = 1, 100
		if (i .le. 6) then 
			read (1,'()') 
		else
			read (1,*,end=30) para1(i-6)
		endif
	enddo

30	sig    = para1(1)
	mch    = para1(2)
	ma     = para1(3)
	mbH    = para1(4)
	bmsq   = para1(5)
	tanb   = para1(6)
	sin_ba = para1(7)
	cutoff = para1(8)
	mu_r   = para1(9)
	SCHEME = para1(10)

	beta = atan(tanb)
	alpha = alpha_f(beta,1.d0-sin_ba,sig)

	open(2, file='./inputs/in_momentum.txt')
	do i = 1, 100
		if (i <= 6) then
			read (2,'()')
		else
			read (2,*,end=40) para2(i-6)
		endif
	enddo 

40 p_hzz(1)   = para2(1)
	p_hzz(2)   = para2(2)
	p_hzz(3)   = para2(3)
	!--------------------------------------------------------------------------------------------------------
   p_hww(1)   = para2(4)
   p_hww(2)   = para2(5)
   p_hww(3)   = para2(6)
	!--------------------------------------------------------------------------------------------------------
   p_htt(1)   = para2(7)
   p_htt(2)   = para2(8)
   p_htt(3)   = para2(9)
	!--------------------------------------------------------------------------------------------------------
   p_hbb(1)   = para2(10)
   p_hbb(2)   = para2(11)
   p_hbb(3)   = para2(12)
	!--------------------------------------------------------------------------------------------------------
   p_hcc(1)   = para2(13)
   p_hcc(2)   = para2(14)
   p_hcc(3)   = para2(15)
	!--------------------------------------------------------------------------------------------------------
   p_hll(1)   = para2(16)
   p_hll(2)   = para2(17)
   p_hll(3)   = para2(18)
	!--------------------------------------------------------------------------------------------------------
   p_hmumu(1) = para2(19)
   p_hmumu(2) = para2(20)
   p_hmumu(3) = para2(21)
	!--------------------------------------------------------------------------------------------------------
   p_hhh(1)   = para2(22)
   p_hhh(2)   = para2(23)
   p_hhh(3)   = para2(24)

	call ltini

	if (OREW == 0) then
		C_EW = 'LO'
	else if(OREW == 1) then
		C_EW = 'NLO'
	end if
	if (ORQCD == -1) then
		C_QCD = 'LO(quark mass:OS)'
	else if (ORQCD == 0) then
		C_QCD = 'LO(quark mass:MSbar)'
	else if(ORQCD == 1) then
		C_QCD = 'NLO'
	else if(ORQCD == 2) then
		C_QCD = 'NNLO'
	end if

	gs = sqrt(alpha_s*4.d0*pi)
	gp = g*sw/cw

	! !===== This is needed for calculations with mphoton=0.d0 ====== 
	! QED = 1.d0; mphoton = 0.d0
	! allocate (dummy(300))
	! call Cput(dummy,125.d0**2,80.d0**2,400.d0**2,400.d0**2,80.d0**2,0.d0)
	! call Dput(dummy,msir**2,mc**2,mW**2,mh**2,20.d0**2,10.d0**2,mW**2,mc**2,0.d0,mW**2)
	! !====================================================

	!========== calculate hVVstar_sm (take several minites) and make text file ==========
	if(OREW == 0) then
		call decay_hZZstar_sm(vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD)
		call decay_hWWstar_sm(vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD)
	else if(OREW == 1) then
		inquire (file="modules/dat/hVVstar_sm/hZZstar_sm.txt",exist=hZZ_exist)	
		open(10,file="modules/dat/hVVstar_sm/hZZstar_sm.txt")
		if(hZZ_exist) then
			read(10,*) vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
		else
			call decay_hZZstar_sm(vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD)
			write(10,*) vdecay_hZZstar_sm,vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm
		endif

		inquire (file="modules/dat/hVVstar_sm/hWWstar_sm.txt",exist=hWW_exist)
		open(20,file="modules/dat/hVVstar_sm/hWWstar_sm.txt")
		close(10)

		if(hWW_exist) then
			read(20,*) vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm
		else
			call decay_hWWstar_sm(vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD)
			write(20,*) vdecay_hWWstar_sm,vhWcs_TBSH_sm,vhWmunu_TBSH_sm
		endif
		close(20)
	endif

	!###########################################################################
	! Main
	!###########################################################################
	if(main_prog) then
		!###################################   Constraints   ########################################
		constraint(1:6) = 0

		if (vs(mch,mA,mbh,bmsq,alpha,beta) /= 0.d0) then
			write(*,*) 'Excluded by vacuum stability at tree level'
			constraint(1) = 1
		endif

		if (pu(mch,mA,mbh,bmsq,alpha,beta) /= 0.d0) then
			write(*,*) 'Excluded by tree-level unitarity'
			constraint(2) = 1
		endif

		if (stu(mch,ma,mbh,alpha,beta) /= 0.d0) then
			write(*,*) 'Excluded by S and T parameters'
			constraint(3) = 1
		endif

		if (true_vacuum(mch,ma,mbh,bmsq,alpha,beta) /= 0.d0) then 
			write(*,*) 'Excluded by true vacuum condition'
			constraint(4) = 1
		endif

		if (sqrt(bmsq) >= 1.d3 .and. cutoff > sqrt(bmsq)) then
			if (vs_rge_MSM(cutoff,mch,mA,mbh,bmsq,alpha,beta) /= 0.d0) then
				write(*,*) 'Excluded by vacuum stability (RGE improved with the cutoff scale and SM matching)'
				constraint(5) = 1
			endif

			if (triviality_MSM(cutoff,mch,mA,mbh,bmsq,alpha,beta) /= 0.d0) then
				write(*,*) 'Excluded by triviality (with the cutoff scale and SM matching)'
				constraint(6) = 1
			endif
		else
			if (vs_rge(cutoff,mch,mA,mbh,bmsq,alpha,beta) /= 0.d0) then
				write(*,*) 'Excluded by vacuum stability (RGE improved with the cutoff scale)'
				constraint(5)=1
			endif

			if (triviality(cutoff,mch,mA,mbh,bmsq,alpha,beta) .ne. 0.d0) then
				write(*,*) 'Excluded by triviality (with the cutoff scale)'
				constraint(6)=1
			endif
		endif

		!###################################   Effective vertices   ########################################
		open(10,file="outputs/out_sm.txt")
		if (n == 1) then
			open(11,file="outputs/out_thdmI.txt")
		else if (n == 2) then
			open(11,file="outputs/out_thdmII.txt")
		else if (n == 3) then
			open(11,file="outputs/out_thdmX.txt")
		else if (n == 4) then
			open(11,file="outputs/out_thdmY.txt")
		endif

		!============================== SM ==============================
		vhZZ_sm(1)   = rGam1_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhZZ_sm(2)   = rGam2_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhZZ_sm(3)   = rGam3_hZZ_sm(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2)
		vhWW_sm(1)   = rGam1_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhWW_sm(2)   = rGam2_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhWW_sm(3)   = rGam3_hWW_sm(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2)
		vhtt_sm(1)   = rGamS_htt_sm(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2)
		vhbb_sm(1)   = rGamS_hbb_sm(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2)
		vhcc_sm(1)   = rGamS_hcc_sm(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2)
		vhll_sm(1)   = rGamS_htautau_sm(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2)
		vhmumu_sm(1) = rGamS_hmumu_sm(p_hmumu(1)**2,p_hmumu(2)**2,p_hmumu(3)**2)
		vhhh_sm      = rGam_hhh_sm(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2)

		write(10,*) "============================== Higgs vertex functions =============================="
		write(10,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ_sm(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ_sm(1))
		write(10,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ_sm(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ_sm(2))
		write(10,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ_sm(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ_sm(3))
		write(10,100) 'Re[rGam_hWW(1)]:', dble(vhWW_sm(1)),'Im[rGam_hWW(1)]:', imag(vhWW_sm(1))
		write(10,100) 'Re[rGam_hWW(2)]:', dble(vhWW_sm(2)),'Im[rGam_hWW(2)]:', imag(vhWW_sm(2))
		write(10,100) 'Re[rGam_hWW(3)]:', dble(vhWW_sm(3)),'Im[rGam_hWW(3)]:', imag(vhWW_sm(3))
		write(10,100) 'Re[rGam_htt(S)]:', dble(vhtt_sm(1)),'Im[rGam_htt(S)]:', imag(vhtt_sm(1))
		write(10,100) 'Re[rGam_hbb(S)]:', dble(vhbb_sm(1)),'Im[rGam_hbb(S)]:', imag(vhbb_sm(1))
		write(10,100) 'Re[rGam_hcc(S)]:', dble(vhcc_sm(1)),'Im[rGam_hcc(S)]:', imag(vhcc_sm(1))
		write(10,100) 'Re[rGam_htautau(S)]:', dble(vhll_sm(1)),'Im[rGam_htautau(S)]:', imag(vhll_sm(1))
		write(10,100) 'Re[rGam_hmumu(S)]:', dble(vhmumu_sm(1)),'Im[rGam_hmumu(S)]:', imag(vhmumu_sm(1))
		write(10,100) 'Re[rGam_hhh]:'   , dble(vhhh_sm),'Im[rGam_hhh]:', imag(vhhh_sm)

		!============================== 2HDM ==============================
		vhZZ(1)   = rGam1_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhZZ(2)   = rGam2_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhZZ(3)   = rGam3_hZZ(p_hzz(1)**2,p_hzz(2)**2,p_hzz(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhWW(1)   = rGam1_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhWW(2)   = rGam2_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhWW(3)   = rGam3_hWW(p_hww(1)**2,p_hww(2)**2,p_hww(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhtt(1)   = rGamS_htt(p_htt(1)**2,p_htt(2)**2,p_htt(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhbb(1)   = rGamS_hbb(p_hbb(1)**2,p_hbb(2)**2,p_hbb(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhcc(1)   = rGamS_hcc(p_hcc(1)**2,p_hcc(2)**2,p_hcc(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhll(1)   = rGamS_htautau(p_hll(1)**2,p_hll(2)**2,p_hll(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhmumu(1) = rGamS_hmumu(p_hmumu(1)**2,p_hmumu(2)**2,p_hmumu(3)**2,mch,mA,mbh,bmsq,alpha,beta,n)
		vhhh      = rGam_hhh(p_hhh(1)**2,p_hhh(2)**2,p_hhh(3)**2,mch,mA,mbh,bmsq,alpha,beta,mu_r,n)

		write(11,*) "============================== Higgs vertex functions =============================="
		write(11,100) 'Re[rGam_hZZ(1)]:', dble(vhZZ(1)),'Im[rGam_hZZ(1)]:', imag(vhZZ(1))
		write(11,100) 'Re[rGam_hZZ(2)]:', dble(vhZZ(2)),'Im[rGam_hZZ(2)]:', imag(vhZZ(2))
		write(11,100) 'Re[rGam_hZZ(3)]:', dble(vhZZ(3)),'Im[rGam_hZZ(3)]:', imag(vhZZ(3))
		write(11,100) 'Re[rGam_hWW(1)]:', dble(vhWW(1)),'Im[rGam_hWW(1)]:', imag(vhWW(1))
		write(11,100) 'Re[rGam_hWW(2)]:', dble(vhWW(2)),'Im[rGam_hWW(2)]:', imag(vhWW(2))
		write(11,100) 'Re[rGam_hWW(3)]:', dble(vhWW(3)),'Im[rGam_hWW(3)]:', imag(vhWW(3))
		write(11,100) 'Re[rGam_htt(S)]:', dble(vhtt(1)),'Im[rGam_htt(S)]:', imag(vhtt(1))
		write(11,100) 'Re[rGam_hbb(S)]:', dble(vhbb(1)),'Im[rGam_hbb(S)]:', imag(vhbb(1))
		write(11,100) 'Re[rGam_hcc(S)]:', dble(vhcc(1)),'Im[rGam_hcc(S)]:', imag(vhcc(1))
		write(11,100) 'Re[rGam_htautau(S)]:', dble(vhll(1)),'Im[rGam_htautau(S)]:', imag(vhll(1))
		write(11,100) 'Re[rGam_hmumu(S)]:', dble(vhmumu(1)),'Im[rGam_hmumu(S)]:', imag(vhmumu(1))
		write(11,100) 'Re[rGam_hhh]:'   , dble(vhhh),'Im[rGam_hhh]:', imag(vhhh)

		!###################################   Decay branching ratios   ########################################
		100 Format(A24,1PE18.8,A24,1PE18.8)
		200 Format(A20,1PE18.8)

		98 format('# ',A)
		99 format('#')        
		101 format('BLOCK ',A,' #',A)
		102 format(3x,I3,4x,I3,'   # ',A)
		103 format(3x,I3,4x,1PE16.8,'   # ',A)
		104 format(3x,I3,4x,I3,13x,'   # ',A)
		
		201 format('#',10x,'PDG',10x,'Width')
		! 202 format('DECAY',I9,3x,E16.8,3x,'# ',A)
		202 format('DECAY',I9,3x,E16.8,3x,'# EW:',A,'QCD:',A)
		203 format('#',10x,'BR',9x,'NDA',7x,'ID1',6x,'ID2')
		213 format('#',10x,'Gamma',6x,'NDA',7x,'ID1',6x,'ID2')
		204 format(3x,1PE16.8,4x,I2,1x,I9,I9,4x'# ',A)

		!===================================   SM OUTPUTS   ========================================
		open(12,file="outputs/outBR_sm.txt")
		call header_outputs(12)  
		write(12,101) 'MODEL'
		write(12,102) 1,0,'SM'          
		
		write(12,101) 'SMINPUTS'
		write(12,103) 1,alpha_em,'alpha_em' 
		write(12,103) 2,G_F,'Fermi constant' 
		write(12,103) 3,alpha_s,'alpha_s' 
		write(12,103) 4,mc_MS,'mc(mc) MSbar'
		write(12,103) 5,mb_MS,'mb(mb) MSbar'
		write(12,103) 6,mc,'mc On-shell'
		write(12,103) 7,mb,'mb On-shell'
	  
		rmc_mh = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD4,mc_MS,4.d0),mc_MS) 
		rmb_mh = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD5,mb_MS,5.d0),mb_MS)
		
		write(12,101) 'MASS'        
		!write(12,103) 1,0.,'md'
		!write(12,103) 2,0.,'mu'
		!write(12,103) 3,0.,'ms'
		write(12,103) 4,rmc_mh,'mc(mh) MSbar'
		write(12,103) 5,rmb_mh,'mb(mh) MSbar'
		write(12,103) 6,mt,'mt'                
		write(12,103) 13,mmu,'mmu'
		write(12,103) 15,mtau,'mtau'
		write(12,103) 23,mz,'mz'
		write(12,103) 24,mw,'mw (calculated,tree)' 
		write(12,103) 24,rmw_SM(),'mw (calculated,1-loop)' 
		write(12,103) 25,mh,'mh'
		
		!======================================================================
		!  SM Higgs boson'
		!======================================================================
		!========== initialization ==========
		hdecay_SM(:,:) = 0.d0; BRh_SM(:,:) = 0.d0; Gam_h_total_SM = 0.d0

		!========== quark decay ==========
		hdecay_SM(5,-5) = decay_hbb_sm(mh,OREW,ORQCD)
		hdecay_SM(4,-4) = decay_hcc_sm(mh,OREW,ORQCD)

		!========== leptonic decay ==========
		hdecay_SM(15,-15) = decay_htautau_sm(mh,OREW)
		hdecay_SM(13,-13) = decay_hmumu_sm(mh,OREW)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		hdecay_SM(23,23)  = vdecay_hZZstar_sm
		hdecay_SM(24,-24) = vdecay_hWWstar_sm

		!========== loop-induced decay ==========
		hdecay_SM(21,21) = decay_hgg_sm(mh,ORQCD)
		hdecay_SM(22,22) = decay_hgamgam_sm(mh,ORQCD)
		hdecay_SM(22,23) = decay_hZgam_sm(mh,ORQCD)

		!========== total decay width ==========
		Gam_h_total_SM = sum(hdecay_SM)

		!========== decay branching ratio ==========
		BRh_SM = hdecay_SM/Gam_h_total_SM

		write(12,99)
		write(12,98)'Decay branching ratios of the SM Higgs boson by H-COUP #'
		write(12,201)
		write(12,202) 25,Gam_h_total_SM,C_EW,C_QCD
		write(12,203)
		write(12,204) BRh_SM(4,-4),   2,  4,  -4, 'BR(h -> c c~)'
		write(12,204) BRh_SM(5,-5),   2,  5,  -5, 'BR(h -> b b~)'
		write(12,204) BRh_SM(13,-13), 2, 13, -13, 'BR(h -> mu- mu+)'
		write(12,204) BRh_SM(15,-15), 2, 15, -15, 'BR(h -> tau- tau+)'
		write(12,204) BRh_SM(21,21),  2, 21,  21, 'BR(h -> g g)'
		write(12,204) BRh_SM(22,22),  2, 22,  22, 'BR(h -> gam gam)'
		write(12,204) BRh_SM(22,23),  2, 22,  23, 'BR(h -> gam Z)'
		write(12,204) BRh_SM(23,23),  2, 23,  23, 'BR(h -> Z Z*)'
		write(12,204) BRh_SM(24,-24), 2, 24, -24, 'BR(h -> W+ W-*)'

		!===================================   2HDM OUTPUTS   ========================================
		if (n == 1) then
			open(13,file="outputs/outBR_thdmI.txt") 
		else if (n == 2) then
			open(13,file="outputs/outBR_thdmII.txt") 
		else if (n == 3) then
			open(13,file="outputs/outBR_thdmX.txt") 
		else if (n == 4) then
			open(13,file="outputs/outBR_thdmY.txt") 
		endif
		call header_outputs(13)
		write(13,101) 'MODEL'
		write(13,102) 1,2,'THDM'
		write(13,102) 2,n,'(1,2,3,4) = Type-(I,II,X,Y)' 
		write(13,102) 3,SCHEME,'MSbar renormalization scheme'
		
		write(13,101) 'BSMINPUTS'
		write(13,103) 1,bmsq,'M^2 (GeV^2)' 
		write(13,103) 2,tanb,'tan(beta)' 
		write(13,103) 3,sin_ba,'sin(beta-alpha)' 
		write(13,104) 4,sig,'sign of cos(beta-alpha)'
		write(13,103) 5,mu_r,'mu_r (GeV)'

		write(13,101) 'SMINPUTS'
		write(13,103) 1,alpha_em,'alpha_em' 
		write(13,103) 2,G_F,'Fermi constant' 
		write(13,103) 3,alpha_s,'alpha_s' 
		write(13,103) 4,mc_MS,'mc(mc) MSbar'
		write(13,103) 5,mb_MS,'mb(mb) MSbar'
		write(13,103) 6,mc,'mc On-shell'
		write(13,103) 7,mb,'mb On-shell'
				  
		write(13,101) 'MASS'        
		!write(13,103) 1,0.,'md'
		!write(13,103) 2,0.,'mu'
		!write(13,103) 3,0.,'ms'
		write(13,103) 4,rmc_mh,'mc(mh) MSbar'
		write(13,103) 5,rmb_mh,'mb(mh) MSbar'
		write(13,103) 6,mt,'mt'                
		write(13,103) 13,mmu,'mmu'
		write(13,103) 15,mtau,'mtau'
		write(13,103) 23,mz,'mz'
		write(13,103) 24,mw,'mw (calculated,tree)' 
		write(13,103) 24,rmW(mch,mA,mbh,bmsq,alpha,beta,n),'mw (calculated,1-loop)' 
		write(13,103) 25,mh,'mh'
		write(13,103) 35,mbh,'mH' 
		write(13,103) 36,ma,'mA' 
		write(13,103) 37,mch,'mH+' 

		write(13,101) 'CONSTRAINTS'
		write(13,103) 0,cutoff,'The cutoff scale (GeV)'
		write(13,102) 1,constraint(1),'Vacuum stability at tree level [0=OK, 1=No]'
		write(13,102) 2,constraint(2),'Tree-level unitarity [0=OK, 1=No]'
		write(13,102) 3,constraint(3),'S and T parameters [0=OK, 1=No]'
		write(13,102) 4,constraint(4),'True vacuum [0=OK, 1=No]'
		write(13,102) 5,constraint(5),'Vacuum stability (RGE improved with the cutoff scale) [0=OK, 1=No]'
		write(13,102) 6,constraint(6),'Triviality (with the cutoff scale) [0=OK, 1=No]'
		
		!======================================================================
		!  Lighter CP-even Higgs boson'
		!======================================================================
		!---------- initialization ----------
		hdecay(:,:) = 0.d0; BRh(:,:) = 0.d0; Gam_h_total = 0.d0

		!========== quark decay ==========
		hdecay(5,-5) = decay_hbb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		hdecay(4,-4) = decay_hcc(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

		!========== leptonic decay ==========
		hdecay(15,-15) = decay_htautau(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
		hdecay(13,-13) = decay_hmumu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		call decay_hZZstar(hdecay(23,23),vhZnunu_TB_sm,vhZee_TB_sm,vhZuu_TB_sm,vhZdd_TB_sm,OREW,ORQCD,alpha,beta,n)
		call decay_hWWstar(hdecay(24,-24),vhWcs_TBSH_sm,vhWmunu_TBSH_sm,OREW,ORQCD,alpha,beta,n)

		!========== loop-induced decay ==========
		hdecay(21,21) = decay_hgg(mch,mA,mbH,bmsq,alpha,beta,n,ORQCD)
		hdecay(22,22) = decay_hgamgam(mch,mA,mbH,bmsq,alpha,beta,n,ORQCD)
		hdecay(22,23) = decay_hZgam(mch,mA,mbH,bmsq,alpha,beta,n,ORQCD)
	
		!========== total decay width ==========
		Gam_h_total = sum(hdecay)

		!========== decay branching ratio ==========
		BRh = hdecay/Gam_h_total

		write(13,99)
		write(13,98)'Decay branching ratios of the SM-like Higgs boson by H-COUP #'
		write(13,201)
		write(13,202) 25,Gam_h_total,C_EW,C_QCD
		write(13,203)
		write(13,204) BRh(4,-4),   2,  4,  -4, 'BR(h -> c c~)'
		write(13,204) BRh(5,-5),   2,  5,  -5, 'BR(h -> b b~)'
		write(13,204) BRh(13,-13), 2, 13, -13, 'BR(h -> mu- mu+)'
		write(13,204) BRh(15,-15), 2, 15, -15, 'BR(h -> tau- tau+)'
		write(13,204) BRh(21,21),  2, 21,  21, 'BR(h -> g g)'
		write(13,204) BRh(22,22),  2, 22,  22, 'BR(h -> gam gam)'
		write(13,204) BRh(22,23),  2, 22,  23, 'BR(h -> gam Z)'
		write(13,204) BRh(23,23),  2, 23,  23, 'BR(h -> Z Z*)'
		write(13,204) BRh(24,-24), 2, 24, -24, 'BR(h -> W+ W-*)'

		!======================================================================
		!  Heavier CP-even Higgs boson'
		!======================================================================
		!---------- initialization ----------
		bHdecay(:,:) = 0.d0; brbH(:,:) = 0.d0; Gam_bH_total = 0.d0

		!========== quark decay ==========
		bHdecay(6,-6) = Gam_bHtt(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		bHdecay(5,-5) = Gam_bHqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mb)
		bHdecay(4,-4) = Gam_bHqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mc)

		!========== leptonic decay ==========
		bHdecay(15,-15) = Gam_bHll(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mtau)
		bHdecay(13,-13) = Gam_bHll(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mmu)

		!========== bosonic decay ==========
		!---------- ZZ/WW ----------
		bHdecay(23,23)  = Gam_bHZZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		bHdecay(24,-24) = Gam_bHWW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		!---------- SV ----------
		bHdecay(23,36) = Gam_bHAZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		bHdecay(24,37) = Gam_bHchW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		!---------- SS ----------
		bHdecay(25,25)  = Gam_bHhh(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
		bHdecay(36,36)  = Gam_bHAA(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
		bHdecay(37,-37) = Gam_bHchch(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)

		!========== loop-induced decay ==========
		bHdecay(21,21) = Gam_bHgg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		bHdecay(22,22) = Gam_bHgamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		bHdecay(22,23) = Gam_bHZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

		!========== total decay width ==========
		Gam_bH_total = sum(bHdecay)

		!========== decay branching ratio ==========
		BRbH = bHdecay/Gam_bH_total

		write(13,99)
		write(13,98)'Decay branching ratios of the additional CP-even Higgs boson by H-COUP #'
		write(13,201)
		write(13,202) 35,Gam_bH_total,C_EW,C_QCD
		write(13,203)
		write(13,204) BRbH(6,-6),   2,  6, -6,  'BR(bH -> t t~)'
		write(13,204) BRbH(5,-5),   2,  5, -5,  'BR(bH -> b b~)'
		write(13,204) BRbH(4,-4),   2,  4, -4,  'BR(bH -> c c~)'
		write(13,204) BRbH(13,-13), 2, 13, -13, 'BR(bH -> mu- mu+)'
		write(13,204) BRbH(15,-15), 2, 15, -15, 'BR(bH -> tau- tau+)'
		write(13,204) BRbH(23,23),  2, 23,  23, 'BR(bH -> Z Z)'
		write(13,204) BRbH(24,-24), 2, 24, -24, 'BR(bH -> W+ W-)'
		write(13,204) BRbH(23,36),  2, 23,  36, 'BR(bH -> A Z)'
		write(13,204) BRbH(24,37),  2, 24,  37, 'BR(bH -> H+W-/H-W+)'
		write(13,204) BRbH(25,25),  2, 25,  25, 'BR(bH -> h h)'
		write(13,204) BRbH(36,36),  2, 36,  36, 'BR(bH -> A A)'
		write(13,204) BRbH(37,-37), 2, 37, -37, 'BR(bH -> H+ H-)'
		write(13,204) BRbH(21,21),  2, 21,  21, 'BR(bH -> g g)'
		write(13,204) BRbH(22,22),  2, 22,  22, 'BR(bH -> gam gam)'
		write(13,204) BRbH(22,23),  2, 22,  23, 'BR(bH -> gam Z)'

		!======================================================================
		!  CP-odd Higgs boson'
		!======================================================================
		!---------- initialization ----------
		Adecay(:,:) = 0.d0; brA(:,:) = 0.d0; Gam_A_total = 0.d0

		!========== quark decay ==========
		Adecay(6,-6) = Gam_Att(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Adecay(5,-5) = Gam_Aqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mb)
		Adecay(4,-4) = Gam_Aqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mc)

		!========== leptonic decay ==========
		Adecay(15,-15) = Gam_All(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mtau)
		Adecay(13,-13) = Gam_All(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mmu)

		!========== bosonic decay ==========
		!---------- SV ----------
		Adecay(23,25) = Gam_AZh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Adecay(23,35) = Gam_AZbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Adecay(24,37) = Gam_AWch(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

		!========== loop-induced decay ==========
		Adecay(21,21) = Gam_Agg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Adecay(22,22) = Gam_Agamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Adecay(22,23) = Gam_AZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Adecay(23,23) = Gam_AZZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Adecay(24,24) = Gam_AWW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

		!========== total decay width ==========
		Gam_A_total = sum(Adecay)

		!========== decay branching ratio ==========
		BRA = Adecay/Gam_A_total

		write(13,99)
		write(13,98)'Decay branching ratios of the CP-odd Higgs boson by H-COUP #'
		write(13,201)
		write(13,202) 35,Gam_A_total,C_EW,C_QCD
		write(13,203)
		write(13,204) BRA(6,-6),   2,  6, -6,  'BR(A -> t t~)'
		write(13,204) BRA(5,-5),   2,  5, -5,  'BR(A -> b b~)'
		write(13,204) BRA(4,-4),   2,  4, -4,  'BR(A -> c c~)'
		write(13,204) BRA(13,-13), 2, 13, -13, 'BR(A -> mu- mu+)'
		write(13,204) BRA(15,-15), 2, 15, -15, 'BR(A -> tau- tau+)'
		write(13,204) BRA(23,25),  2, 23,  25, 'BR(A -> Z h)'
		write(13,204) BRA(23,35),  2, 23,  35, 'BR(A -> Z bH)'
		write(13,204) BRA(24,37),  2, 24,  37, 'BR(A -> H+W-/H-W+)'
		write(13,204) BRA(21,21),  2, 21,  21, 'BR(A -> g g)'
		write(13,204) BRA(22,22),  2, 22,  22, 'BR(A -> gam gam)'
		write(13,204) BRA(22,23),  2, 22,  23, 'BR(A -> gam Z)'
		write(13,204) BRA(23,23),  2, 23,  23, 'BR(A -> Z Z)'
		write(13,204) BRA(24,-24), 2, 24, -24, 'BR(A -> W+ W-)'

		!======================================================================
		!  Charged Higgs boson'
		!======================================================================
		!---------- initialization ----------
		Hpmdecay(:,:) = 0.d0; BRHpm(:,:) = 0.d0; Gam_Hpm_total = 0.d0

		!========== quark decay ==========
		Hpmdecay(6,-5) = Gam_chtb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(6,-3) = Gam_chts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(6,-1) = Gam_chtd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(4,-5) = Gam_chcb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(4,-3) = Gam_chcs(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(4,-1) = Gam_chcd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(2,-5) = Gam_chub(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(2,-3) = Gam_chus(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

		!========== leptonic decay ==========
		Hpmdecay(16,-15) = Gam_chlnu(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mtau)
		Hpmdecay(14,-13) = Gam_chlnu(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mmu)
		Hpmdecay(12,-11) = Gam_chlnu(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,me)

		!========== bosonic decay ==========
		Hpmdecay(24,25) = Gam_chwh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(24,35) = Gam_chwbh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(24,36) = Gam_chwA(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

		!========== loop-induced decay ==========
		Hpmdecay(24,23) = Gam_chWZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
		Hpmdecay(24,22) = Gam_chWgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

		!========== total decay width ==========
		Gam_Hpm_total = sum(Hpmdecay)

		!========== decay branching ratio ==========
		BRHpm = Hpmdecay/Gam_Hpm_total

		write(13,99)
		write(13,98)'Decay branching ratios of the charged Higgs bosons by H-COUP #'
		write(13,201)
		write(13,202) 35,Gam_Hpm_total,C_EW,C_QCD
		write(13,203)
		write(13,204) BRHpm(6,-5),   2,  6, -5,  'BR(H+ -> t b~)'
		write(13,204) BRHpm(6,-3),   2,  6, -3,  'BR(H+ -> t s~)'
		write(13,204) BRHpm(6,-1),   2,  6, -1,  'BR(H+ -> t d~)'
		write(13,204) BRHpm(4,-5),   2,  4, -5,  'BR(H+ -> c b~)'
		write(13,204) BRHpm(4,-3),   2,  4, -3,  'BR(H+ -> c s~)'
		write(13,204) BRHpm(4,-1),   2,  4, -1,  'BR(H+ -> c d~)'
		write(13,204) BRHpm(2,-5),   2,  2, -5,  'BR(H+ -> u b~)'
		write(13,204) BRHpm(2,-3),   2,  2, -3,  'BR(H+ -> u s~)'
		write(13,204) BRHpm(16,-15), 2, 16, -15, 'BR(H+ -> nu tau+)'
		write(13,204) BRHpm(14,-13), 2, 14, -13, 'BR(H+ -> nu mu+)'
		write(13,204) BRHpm(12,-11), 2, 12, -11, 'BR(H+ -> nu e+)'
		write(13,204) BRHpm(24,25),  2, 24,  25, 'BR(H+ -> W+ h)'
		write(13,204) BRHpm(24,35),  2, 24,  35, 'BR(H+ -> W+ bH)'
		write(13,204) BRHpm(24,36),  2, 24,  36, 'BR(H+ -> W+ A)'
		write(13,204) BRHpm(24,23),  2, 24,  23, 'BR(H+ -> W+ Z)'
		write(13,204) BRHpm(24,22),  2, 24,  22, 'BR(H+ -> W+ gam)'



		!###################################   Partial decay width   ########################################
		!===================================   SM OUTPUTS   ========================================
		open(22,file="outputs/outGamma_sm.txt")
		call header_outputs(22)
		write(22,101) 'MODEL'
		write(22,102) 1,0,'SM'          

		write(22,101) 'SMINPUTS'
		write(22,103) 1,alpha_em,'alpha_em' 
		write(22,103) 2,G_F,'Fermi constant' 
		write(22,103) 3,alpha_s,'alpha_s' 
		write(22,103) 4,mc_MS,'mc(mc) MSbar'
		write(22,103) 5,mb_MS,'mb(mb) MSbar'
		write(22,103) 6,mc,'mc On-shell'
		write(22,103) 7,mb,'mb On-shell'

		write(22,101) 'MASS'        
		!write(22,103) 1,0.,'md'
		!write(22,103) 2,0.,'mu'
		!write(22,103) 3,0.,'ms'
		write(22,103) 4,rmc_mh,'mc(mh) MSbar'
		write(22,103) 5,rmb_mh,'mb(mh) MSbar'
		write(22,103) 6,mt,'mt'                
		write(22,103) 13,mmu,'mmu'
		write(22,103) 15,mtau,'mtau'
		write(22,103) 23,mz,'mz'
		write(22,103) 24,mw,'mw (calculated,tree)' 
		write(22,103) 24,rmw_SM(),'mw (calculated,1-loop)' 
		write(22,103) 25,mh,'mh'

		!======================================================================
		!  SM Higgs boson'
		!======================================================================
		write(22,99)
		write(22,98)'Partial decay widths of the SM Higgs boson by H-COUP #'
		write(22,201)
		write(22,202) 25,Gam_h_total_SM,C_EW,C_QCD
		write(22,213)
		write(22,204) hdecay_SM(4,-4),   2,  4,  -4, 'Gamma(h -> c c~)'
		write(22,204) hdecay_SM(5,-5),   2,  5,  -5, 'Gamma(h -> b b~)'
		write(22,204) hdecay_SM(13,-13), 2, 13, -13, 'Gamma(h -> mu- mu+)'
		write(22,204) hdecay_SM(15,-15), 2, 15, -15, 'Gamma(h -> tau- tau+)'
		write(22,204) hdecay_SM(21,21),  2, 21,  21, 'Gamma(h -> g g)'
		write(22,204) hdecay_SM(22,22),  2, 22,  22, 'Gamma(h -> gam gam)'
		write(22,204) hdecay_SM(22,23),  2, 22,  23, 'Gamma(h -> gam Z)'
		write(22,204) hdecay_SM(23,23),  2, 23,  23, 'Gamma(h -> Z Z*)'
		write(22,204) hdecay_SM(24,-24), 2, 24, -24, 'Gamma(h -> W+ W-*)'

		!===================================   2HDM OUTPUTS   ========================================
		if (n == 1) then
			open(23,file="outputs/outGamma_thdmI.txt") 
		else if (n == 2) then
			open(23,file="outputs/outGamma_thdmII.txt") 
		else if (n == 3) then
			open(23,file="outputs/outGamma_thdmX.txt") 
		else if (n == 4) then
			open(23,file="outputs/outGamma_thdmY.txt") 
		endif
		call header_outputs(23)
		write(23,101) 'MODEL'
		write(23,102) 1,2,'THDM'
		write(23,102) 2,n,'(1,2,3,4) = Type-(I,II,X,Y)' 
		write(23,102) 3,SCHEME,'MSbar renormalization scheme'
		
		write(23,101) 'BSMINPUTS'
		write(23,103) 1,bmsq,'M^2 (GeV^2)' 
		write(23,103) 2,tanb,'tan(beta)' 
		write(23,103) 3,sin_ba,'sin(beta-alpha)' 
		write(23,104) 4,sig,'sign of cos(beta-alpha)'
		write(23,103) 5,mu_r,'mu_r (GeV)'

		write(23,101) 'SMINPUTS'
		write(23,103) 1,alpha_em,'alpha_em' 
		write(23,103) 2,G_F,'Fermi constant' 
		write(23,103) 3,alpha_s,'alpha_s' 
		write(23,103) 4,mc_MS,'mc(mc) MSbar'
		write(23,103) 5,mb_MS,'mb(mb) MSbar'
		write(23,103) 6,mc,'mc On-shell'
		write(23,103) 7,mb,'mb On-shell'
				  
		write(23,101) 'MASS'        
		!write(23,103) 1,0.,'md'
		!write(23,103) 2,0.,'mu'
		!write(23,103) 3,0.,'ms'
		write(23,103) 4,rmc_mh,'mc(mh) MSbar'
		write(23,103) 5,rmb_mh,'mb(mh) MSbar'
		write(23,103) 6,mt,'mt'                
		write(23,103) 13,mmu,'mmu'
		write(23,103) 15,mtau,'mtau'
		write(23,103) 23,mz,'mz'
		write(23,103) 24,mw,'mw (calculated,tree)' 
		write(23,103) 24,rmW(mch,mA,mbh,bmsq,alpha,beta,n),'mw (calculated,1-loop)' 
		write(23,103) 25,mh,'mh'
		write(23,103) 35,mbh,'mH' 
		write(23,103) 36,ma,'mA' 
		write(23,103) 37,mch,'mH+' 

		write(23,101) 'CONSTRAINTS'
		write(23,103) 0,cutoff,'The cutoff scale (GeV)'
		write(23,102) 1,constraint(1),'Vacuum stability at tree level [0=OK, 1=No]'
		write(23,102) 2,constraint(2),'Tree-level unitarity [0=OK, 1=No]'
		write(23,102) 3,constraint(3),'S and T parameters [0=OK, 1=No]'
		write(23,102) 4,constraint(4),'True vacuum [0=OK, 1=No]'
		write(23,102) 5,constraint(5),'Vacuum stability (RGE improved with the cutoff scale) [0=OK, 1=No]'
		write(23,102) 6,constraint(6),'Triviality (with the cutoff scale) [0=OK, 1=No]'

		!======================================================================
		!  Lighter CP-even Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the SM-like Higgs boson by H-COUP #'
		write(23,201)
		write(23,202) 25,Gam_h_total,C_EW,C_QCD
		write(23,213)
		write(23,204) hdecay(4,-4),   2,  4,  -4, 'Gamma(h -> c c~)'
		write(23,204) hdecay(5,-5),   2,  5,  -5, 'Gamma(h -> b b~)'
		write(23,204) hdecay(13,-13), 2, 13, -13, 'Gamma(h -> mu- mu+)'
		write(23,204) hdecay(15,-15), 2, 15, -15, 'Gamma(h -> tau- tau+)'
		write(23,204) hdecay(21,21),  2, 21,  21, 'Gamma(h -> g g)'
		write(23,204) hdecay(22,22),  2, 22,  22, 'Gamma(h -> gam gam)'
		write(23,204) hdecay(22,23),  2, 22,  23, 'Gamma(h -> gam Z)'
		write(23,204) hdecay(23,23),  2, 23,  23, 'Gamma(h -> Z Z*)'
		write(23,204) hdecay(24,-24), 2, 24, -24, 'Gamma(h -> W+ W-*)'

		!======================================================================
		!  Heavier CP-even Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the additional CP-even Higgs boson by H-COUP #'
		write(23,201)
		write(23,202) 35,Gam_bH_total,C_EW,C_QCD
		write(23,213)
		write(23,204) bHdecay(6,-6),   2,  6, -6,  'Gamma(bH -> t t~)'
		write(23,204) bHdecay(5,-5),   2,  5, -5,  'Gamma(bH -> b b~)'
		write(23,204) bHdecay(4,-4),   2,  4, -4,  'Gamma(bH -> c c~)'
		write(23,204) bHdecay(13,-13), 2, 13, -13, 'Gamma(bH -> mu- mu+)'
		write(23,204) bHdecay(15,-15), 2, 15, -15, 'Gamma(bH -> tau- tau+)'
		write(23,204) bHdecay(23,23),  2, 23,  23, 'Gamma(bH -> Z Z)'
		write(23,204) bHdecay(24,-24), 2, 24, -24, 'Gamma(bH -> W+ W-)'
		write(23,204) bHdecay(23,36),  2, 23,  36, 'Gamma(bH -> A Z)'
		write(23,204) bHdecay(24,37),  2, 24,  37, 'Gamma(bH -> H+W-/H-W+)'
		write(23,204) bHdecay(25,25),  2, 25,  25, 'Gamma(bH -> h h)'
		write(23,204) bHdecay(36,36),  2, 36,  36, 'Gamma(bH -> A A)'
		write(23,204) bHdecay(37,-37), 2, 37, -37, 'Gamma(bH -> H+ H-)'
		write(23,204) bHdecay(21,21),  2, 21,  21, 'Gamma(bH -> g g)'
		write(23,204) bHdecay(22,22),  2, 22,  22, 'Gamma(bH -> gam gam)'
		write(23,204) bHdecay(22,23),  2, 22,  23, 'Gamma(bH -> gam Z)'

		!======================================================================
		!  CP-odd Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the CP-odd Higgs boson by H-COUP #'
		write(23,201)
		write(23,202) 35,Gam_A_total,C_EW,C_QCD
		write(23,213)
		write(23,204) Adecay(6,-6),   2,  6, -6,  'Gamma(A -> t t~)'
		write(23,204) Adecay(5,-5),   2,  5, -5,  'Gamma(A -> b b~)'
		write(23,204) Adecay(4,-4),   2,  4, -4,  'Gamma(A -> c c~)'
		write(23,204) Adecay(13,-13), 2, 13, -13, 'Gamma(A -> mu- mu+)'
		write(23,204) Adecay(15,-15), 2, 15, -15, 'Gamma(A -> tau- tau+)'
		write(23,204) Adecay(23,25),  2, 23,  25, 'Gamma(A -> Z h)'
		write(23,204) Adecay(23,35),  2, 23,  35, 'Gamma(A -> Z bH)'
		write(23,204) Adecay(24,37),  2, 24,  37, 'Gamma(A -> H+W-/H-W+)'
		write(23,204) Adecay(21,21),  2, 21,  21, 'Gamma(A -> g g)'
		write(23,204) Adecay(22,22),  2, 22,  22, 'Gamma(A -> gam gam)'
		write(23,204) Adecay(22,23),  2, 22,  23, 'Gamma(A -> gam Z)'
		write(23,204) Adecay(23,23),  2, 23,  23, 'Gamma(A -> Z Z)'
		write(23,204) Adecay(24,-24), 2, 24, -24, 'Gamma(A -> W+ W-)'

		!======================================================================
		!  Charged Higgs boson'
		!======================================================================
		write(23,99)
		write(23,98)'Partial decay widths of the charged Higgs bosons by H-COUP #'
		write(23,201)
		write(23,202) 35,Gam_Hpm_total,C_EW,C_QCD
		write(23,213)
		write(23,204) Hpmdecay(6,-5),   2,  6, -5,  'Gamma(H+ -> t b~)'
		write(23,204) Hpmdecay(6,-3),   2,  6, -3,  'Gamma(H+ -> t s~)'
		write(23,204) Hpmdecay(6,-1),   2,  6, -1,  'Gamma(H+ -> t d~)'
		write(23,204) Hpmdecay(4,-5),   2,  4, -5,  'Gamma(H+ -> c b~)'
		write(23,204) Hpmdecay(4,-3),   2,  4, -3,  'Gamma(H+ -> c s~)'
		write(23,204) Hpmdecay(4,-1),   2,  4, -1,  'Gamma(H+ -> c d~)'
		write(23,204) Hpmdecay(2,-5),   2,  2, -5,  'Gamma(H+ -> u b~)'
		write(23,204) Hpmdecay(2,-3),   2,  2, -3,  'Gamma(H+ -> u s~)'
		write(23,204) Hpmdecay(16,-15), 2, 16, -15, 'Gamma(H+ -> nu tau+)'
		write(23,204) Hpmdecay(14,-13), 2, 14, -13, 'Gamma(H+ -> nu mu+)'
		write(23,204) Hpmdecay(12,-11), 2, 12, -11, 'Gamma(H+ -> nu e+)'
		write(23,204) Hpmdecay(24,25),  2, 24,  25, 'Gamma(H+ -> W+ h)'
		write(23,204) Hpmdecay(24,35),  2, 24,  35, 'Gamma(H+ -> W+ bH)'
		write(23,204) Hpmdecay(24,36),  2, 24,  36, 'Gamma(H+ -> W+ A)'
		write(23,204) Hpmdecay(24,23),  2, 24,  23, 'Gamma(H+ -> W+ Z)'
		write(23,204) Hpmdecay(24,22),  2, 24,  22, 'Gamma(H+ -> W+ gam)'
		
	endif

contains

!#################################################
!
!    SECTION I Parameter translations
!
!#################################################
!================= Mixing Angle ==================
	double precision function alpha_f(beta,delta,sig)
	double precision, intent(in):: beta,delta
	integer, intent(in):: sig
	! delta is defined by sin(beta-alpha) = 1-delta

	if (sig == 1) then 
		alpha_f = beta-asin(1.d0-delta)
	else if (sig == -1) then
		alpha_f = beta+asin(1.d0-delta)-pi
	else
		alpha_f=0.d0
	end if 

	end function
!------------------------------------
	double precision function m11sq(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	m11sq =&
		bmsq*sin(beta)**2&
		-vev**2/2.d0*(&
			lam1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta)**2&
			+(&
				lam3(mch,mA,mbH,bmsq,alpha,beta)&
				+lam4(mch,mA,mbH,bmsq,alpha,beta)&
				+lam5(mch,mA,mbH,bmsq,alpha,beta)&
			)*sin(beta)**2&
		)

	end function
!------------------------------------
	double precision function m22sq(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	m22sq =&
		bmsq*cos(beta)**2&
		-vev**2/2.d0*(&
			lam2(mch,mA,mbH,bmsq,alpha,beta)*sin(beta)**2&
			+(&
				lam3(mch,mA,mbH,bmsq,alpha,beta)&
				+lam4(mch,mA,mbH,bmsq,alpha,beta)&
				+lam5(mch,mA,mbH,bmsq,alpha,beta)&
			)*cos(beta)**2&
		)

	end function
!------------------------------------
	double precision function m12sq(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	m12sq = bmsq*sin(beta)*cos(beta)

	end function
!========= physical parameters -> lambda1-lambda5 =======
	double precision function lam1(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam1 =&
	(&
		(-sin(beta)**2*bmsq+sin(alpha)**2*mh**2+cos(alpha)**2*mbH**2)/dcos(beta)**2&
	)/vev**2

	end function
!------------------------------------
	double precision function lam2(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam2 =&
	(&
		(-cos(beta)**2*bmsq+cos(alpha)**2*mh**2+sin(alpha)**2*mbH**2)/sin(beta)**2&
	)/vev**2

	end function 
!------------------------------------
	double precision function lam3(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam3 =&
	(&
		-bmsq+2.d0*mch**2+sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2)&
	)/vev**2

	end function 
!------------------------------------
	double precision function lam4(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam4 = (bmsq+mA**2-2.d0*mch**2)/vev**2

	end function 
!------------------------------------
	double precision function lam5(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam5 = (bmsq-mA**2)/vev**2

	end function
!#################################################
!
!    SECTION II Tree-level couplings
!
!#################################################
!---------------  Type up -------------------
	double precision function xiu(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xiu = cos(alpha)/sin(beta)
	else if (n == 2) then
		xiu = cos(alpha)/sin(beta)
	else if (n == 3) then
		xiu = cos(alpha)/sin(beta)
	else if (n == 4) then
		xiu = cos(alpha)/sin(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type down -------------------
	double precision function xid(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xid = cos(alpha)/sin(beta)
	else if (n == 2) then
		xid = -sin(alpha)/cos(beta)
	else if (n == 3) then
		xid = cos(alpha)/sin(beta)
	else if (n == 4) then
		xid = -sin(alpha)/cos(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type lepton -------------------
	double precision function xil(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xil = cos(alpha)/sin(beta)
	else if (n == 2) then
		xil = -sin(alpha)/cos(beta)
	else if (n == 3) then
		xil = -sin(alpha)/cos(beta)
	else if (n == 4) then
		xil = cos(alpha)/sin(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type up -------------------
	double precision function xiu_H(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xiu_H = sin(alpha)/sin(beta)
	else if (n == 2) then
		xiu_H = sin(alpha)/sin(beta)
	else if (n == 3) then
		xiu_H = sin(alpha)/sin(beta)
	else if (n == 4) then
		xiu_H = sin(alpha)/sin(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type down -------------------
	double precision function xid_H(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xid_H = sin(alpha)/sin(beta)
	else if (n == 2) then
		xid_H = cos(alpha)/cos(beta)
	else if (n == 3) then
		xid_H = sin(alpha)/sin(beta)
	else if (n == 4) then
		xid_H = cos(alpha)/cos(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type lepton -------------------
	double precision function xil_H(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xil_H = sin(alpha)/sin(beta)
	else if (n == 2) then
		xil_H = cos(alpha)/cos(beta)
	else if (n == 3) then
		xil_H = cos(alpha)/cos(beta)
	else if (n == 4) then
		xil_H = sin(alpha)/sin(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type up -------------------
	double precision function xiu_A(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xiu_A = 1.d0/tan(beta)
	else if (n == 2) then
		xiu_A = 1.d0/tan(beta)
	else if (n == 3) then
		xiu_A = 1.d0/tan(beta)
	else if (n == 4) then
		xiu_A = 1.d0/tan(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type down -------------------
	double precision function xid_A(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xid_A = 1.d0/tan(beta)
	else if (n == 2) then
		xid_A = -tan(beta)
	else if (n == 3) then
		xid_A = 1.d0/tan(beta)
	else if (n == 4) then
		xid_A = -tan(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!---------------  Type lepton -------------------
	double precision function xil_A(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	if (n == 1) then
		xil_A = 1.d0/tan(beta)
	else if (n == 2) then
		xil_A = -tan(beta)
	else if (n == 3) then
		xil_A = -tan(beta)
	else if (n == 4) then
		xil_A = 1.d0/tan(beta)
	else
		write(*,*) 'Model is undefined.'
		stop
	end if

	end function
!============================================
!  Higgs couplings in the Higgs basis
!============================================
	double precision function Z1(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z1 = (mbH**2*cos(beta-alpha)**2+mh**2*sin(beta-alpha)**2)/vev**2

	end function
!----------------------------------------------------
	double precision function Z2(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z2 =&
	(&
		mbH**2*cos(beta-alpha)**2+mh**2*sin(beta-alpha)**2&
		+4.d0*(mh**2-mbH**2)*cos(beta-alpha)*sin(beta-alpha)/tan(2.d0*beta)&
		+4.d0*(&
			+(mbH**2-bmsq)*sin(beta-alpha)**2&
			+(mh**2-bmsq)*cos(beta-alpha)**2&
		)/tan(2.d0*beta)**2&
	)/vev**2

	end function
!----------------------------------------------------
	double precision function Z3(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z3 =&
	(&
		mbH**2*cos(beta-alpha)**2+mh**2*sin(beta-alpha)**2&
		+2.d0*(mh**2-mbH**2)*cos(beta-alpha)*sin(beta-alpha)/tan(2.d0*beta)&
		+2.d0*(mch**2-bmsq)&
	)/vev**2

	end function
!----------------------------------------------------
	double precision function Z4(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z4 =&
	(&
		mbH**2*sin(beta-alpha)**2+mh**2*cos(beta-alpha)**2+mA**2-2.d0*mch**2&
	)/vev**2

	end function
!----------------------------------------------------
	double precision function Z5(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z5 =&
	(&
		mbH**2*sin(beta-alpha)**2+mh**2*cos(beta-alpha)**2-mA**2&
	)/vev**2

	end function
!----------------------------------------------------
	double precision function Z6(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z6 = (mh**2-mbH**2)*cos(beta-alpha)*sin(beta-alpha)/vev**2

	end function
!----------------------------------------------------
	double precision function Z7(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z7 =&
	(&
		2.d0*((mbH**2-bmsq)*sin(beta-alpha)**2&
		+(mh**2-bmsq)*cos(beta-alpha)**2)/tan(2.d0*beta)&
		+(mh**2-mbH**2)*cos(beta-alpha)*sin(beta-alpha)&
	)/vev**2

	end function
!----------------------------------------------------
	double precision function Z345(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Z345 =&
		Z3(mch,mA,mbH,bmsq,alpha,beta)&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)

	end function
!=========================================
!  Higgs triple couplings
!=========================================
	double precision function lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GpGmh = -1.d0/vev*sin(beta-alpha)*mh**2
	
	lam_GpGmh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
	)*vev

	end function
!----------------------------------------------------
	double precision function lam_GGh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GGh = -1.d0/(2.d0*vev)*sin(beta-alpha)*mh**2

	lam_GGh = lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GpGmbH = -1.d0/vev*cos(beta-alpha)*mbH**2

	lam_GpGmbH =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		-Z6(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
	)*vev

	end function
!----------------------------------------------------
	double precision function lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GGbH = -1.d0/(2.d0*vev)*cos(beta-alpha)*mbH**2

	lam_GGbH = lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpHmh=-1.d0/(vev*dsin(2.d0*beta))*(&
	! 	2.d0*cos(alpha+beta)*(mh**2-bmsq)+dsin(beta-alpha)*dsin(2.d0*beta)*(2.d0*mch**2-mh**2))

	! lam_HpHmh = -1.d0/vev*(&
	! 	+(2.d0*mch**2-2.d0*bmsq+mh**2)*sin(beta-alpha)&
	! 	+2.d0*(mh**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta)&
	! )

	lam_HpHmh =&
	-(&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
	)*vev

	end function
!----------------------------------------------------
	double precision function lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpHmbH=&
	! 1.d0/(2.d0*vev*sin(2.d0*beta))*&
	! ( 4.d0*bmsq*sin(alpha+beta)&
	! 	-(&
	! 	 sin(alpha-3.d0*beta)+3.d0*sin(alpha+beta)&
	! 	 )*mbH**2&
	! -4.d0*cos(alpha-beta)*sin(2.d0*beta)*mch**2)

	lam_HpHmbH =&
	-(&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		-Z7(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
	)*vev
	
	end function
!----------------------------------------------------
	double precision function lam_AAh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AAh=-(1.d0/(2.d0*vev))*(&
	! 	(dcos(alpha)*dcos(beta)**2.d0/dsin(beta)&
	! 	-dsin(alpha)*dsin(beta)**2.d0/dcos(beta))*mh**2.d0&
	! 	-2.d0*dsin(alpha-beta)*mA**2.d0&
	! 	-bmsq*dcos(alpha+beta)/(dsin(beta)*dcos(beta)))

	lam_AAh =&
	-(&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
	)*vev/2.d0

	end function
!----------------------------------------------------
	double precision function lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AAbH=-(1.d0/(8.d0*vev))*(-4.d0*bmsq*sin(alpha+beta)&
	! +4.d0*cos(alpha-beta)*sin(2.d0*beta)*mA**2&
	!  +(sin(alpha-3.d0*beta)+3.d0*sin(alpha+beta))&
	! *mbH**2)/(sin(beta)*cos(beta))

	lam_AAbH =&
	-(&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		-Z7(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
	)*vev/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpGmh=-1.d0/vev*cos(beta-alpha)*(mh**2-mch**2)

	lam_HpGmh =&
	-(&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)/2.d0&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)/2.d0&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
	)*vev

	end function 
!----------------------------------------------------
	double precision function lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpGmbH= -1.d0/vev*sin(beta-alpha)*(mch**2-mbH**2)

	lam_HpGmbH =&
	-(&
		-Z4(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)/2.d0&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)/2.d0&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
	)*vev

	end function
!----------------------------------------------------
	double precision function lam_AGh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AGh= -1.d0/vev*cos(beta-alpha)*(mh**2-mA**2)

	lam_AGh =&
	-(&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
	)*vev

	end function 
!----------------------------------------------------
	double precision function lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AGbH=-1.d0/vev*sin(beta-alpha)*(mA**2-mbH**2)

	lam_AGbH =&
	-(&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
	)*vev

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpGmA = +ii*(mA**2-mch**2)/vev

	lam_HpGmA =&
	-ii*(&
		-Z4(mch,mA,mbH,bmsq,alpha,beta)&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)&
	)*vev/2.d0

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HmGpA = conjg(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))

	end function
!----------------------------------------------------
	double precision function lam_hhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_hhh = &
	! -mh**2/(2.d0*vev)*sin(beta-alpha)-1.d0/(vev*sin(2.d0*beta))*cos(beta-alpha)**2*cos(beta+alpha)*(mh**2-bmsq)

	lam_hhh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**3&
		+Z345(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*sin(beta-alpha)&
		+3.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)**2&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**3&
	)*vev/2.d0

	end function
!----------------------------------------------------
	double precision function lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_bHhh= -(1.d0/(4.d0*vev))*cos(alpha-beta)*&
	! 	(bmsq*(-3.d0*sin(2.d0*alpha)+sin(2.d0*beta))&
	! 	+2.d0*sin(2.d0*alpha)*mh**2+sin(2.d0*alpha)*mbH**2)/&
	! 	(sin(beta)*cos(beta))

	lam_bHhh =&
	-(&
		+3.d0*Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*cos(beta-alpha)&
		+Z345(mch,mA,mbH,bmsq,alpha,beta)*(&
			+cos(beta-alpha)**3-2.d0*sin(beta-alpha)**2*cos(beta-alpha)&
		)&
		+3.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*(&
			+2.d0*cos(beta-alpha)**2*sin(beta-alpha)-sin(beta-alpha)**3&
		)&
		-3.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*sin(beta-alpha)&
	)*vev/2.d0

	end function
!----------------------------------------------------
	double precision function lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_bHbHh=-(-1.d0/(4.d0*vev))*dsin(alpha-beta)*&
	! 	(bmsq*(3.d0*dsin(2.d0*alpha)+dsin(2.d0*beta))&
	! 	-dsin(2.d0*alpha)*mh**2-2.d0*dsin(2.d0*alpha)*mbH**2)/(dsin(beta)*dcos(beta))

	lam_bHbHh =&
	-(&
		+3.d0*Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*sin(beta-alpha)&
		+Z345(mch,mA,mbH,bmsq,alpha,beta)*(&
			+sin(beta-alpha)**3-2.d0*cos(beta-alpha)**2*sin(beta-alpha)&
		)&
		+3.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*(&
			-2.d0*sin(beta-alpha)**2*cos(beta-alpha)+cos(beta-alpha)**3&
		)&
		+3.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*cos(beta-alpha)&
	)*vev/2.d0

	end function
!----------------------------------------------------
	double precision function lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_bHbHbH = 1.d0/(4.d0*sin(2.d0*beta)*vev)*(&
	! 	sin(3.d0*alpha-beta)*mbH**2+sin(alpha+beta)*(4.d0*sin(beta-alpha)**2*bmsq-3.d0*mbH**2)&
	! )

	lam_bHbHbH =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**3&
		+Z345(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*cos(beta-alpha)&
		-3.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)**2&
		-Z7(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**3&
	)*vev/2.d0

	end function
!=========================================
!  Higgs quartic couplings
!=========================================
	double precision function lam_GpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_GpGmGpGm = -Z1(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_GpGmGG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_GpGmGG = lam_GpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)

	end function
!----------------------------------------------------
	double precision function lam_GGGG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_GGGG = lam_GpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmHpHm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpHmHpHm = -Z2(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmAA(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpHmAA = lam_HpHmHpHm(mch,mA,mbH,bmsq,alpha,beta)

	end function
!----------------------------------------------------
	double precision function lam_AAAA(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_AAAA = lam_HpHmHpHm(mch,mA,mbH,bmsq,alpha,beta)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmGpGm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpHmGpGm =&
		-Z3(mch,mA,mbH,bmsq,alpha,beta)&
		-Z4(mch,mA,mbH,bmsq,alpha,beta)

	end function
!----------------------------------------------------
	double precision function lam_GpGmAA(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_GpGmAA = -Z3(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmGG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpHmGG = lam_GpGmAA(mch,mA,mbH,bmsq,alpha,beta)

	end function
!----------------------------------------------------
	double precision function lam_HpGmAG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmAG =&
	-(&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)&
	)/2.d0
	
	end function
!----------------------------------------------------
	double precision function lam_GGAA(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_GGAA = -Z345(mch,mA,mbH,bmsq,alpha,beta)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_HpGmHpGm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmHpGm = -Z5(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmGpGm = -Z6(mch,mA,mbH,bmsq,alpha,beta)
	
	end function
!----------------------------------------------------
	double precision function lam_HpGmGG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmGG = lam_HpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_GpGmAG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GpGmAG = -1.d0/(2.d0*vev**2)*sin(2.d0*alpha-2.d0*beta)*(mbH**2-mh**2)

	lam_GpGmAG = lam_HpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)

	end function
!----------------------------------------------------
	double precision function lam_AGGG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AGGG = -1.d0/(4.d0*vev**2)*sin(2.d0*alpha-2.d0*beta)*(mbH**2-mh**2)

	lam_AGGG = lam_HpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpGmHpHm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmHpHm = -Z7(mch,mA,mbH,bmsq,alpha,beta)

	end function
!----------------------------------------------------
	double precision function lam_HpGmAA(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmAA = lam_HpGmHpHm(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmAG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpHmAG = -1.d0/(4.d0*vev**2)*(&
	! 	+cos(2.d0*alpha)*(3.d0+cos(4.d0*beta))/sin(2.d0*beta)*(mh**2-mbH**2)&
	! 	+2.d0*cos(2.d0*beta)*sin(2.d0*alpha)*(mh**2-mbH**2)&
	! 	+4.d0*(-2.d0*bmsq+mh**2+mbH**2)/tan(2.d0*beta)&
	! )

	lam_HpHmAG = lam_HpGmHpHm(mch,mA,mbH,bmsq,alpha,beta)

	end function
!----------------------------------------------------
	double precision function lam_AAAG(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AAAG = -1.d0/(24.d0*vev**2)*(&
	! 	+3.d0*cos(2.d0*alpha)/sin(2.d0*beta)*(3.d0+cos(4.d0*beta))*(mh**2-mbH**2)&
	! 	+6.d0*cos(2.d0*beta)*sin(2.d0*alpha)*(mh**2-mbH**2)&
	! 	+12.d0/tan(2.d0*beta)*(-2.d0*bmsq+mh**2+mbH**2)&
	! )

	lam_AAAG = lam_HpGmHpHm(mch,mA,mbH,bmsq,alpha,beta)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_GpGmbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GpGmbHbH = -1.d0/(8.d0*vev**2)*(&
	! 	+(-4.d0*sin(alpha-beta)**2)*(&
	! 		+2.d0*bmsq-2.d0*mch**2+sin(2.d0*alpha)/sin(2.d0*beta)*mh**2&
	! 	)&
	! 	+(3.d0+cos(4.d0*alpha)+2.d0*sin(2.d0*alpha)/sin(2.d0*beta)-sin(4.d0*alpha)/tan(2.d0*beta))*mbH**2&
	! )

	lam_GpGmbHbH =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		-2.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_GpGmbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GpGmbHh = -1.d0/(2.d0*vev**2)*(&
	! 	sin(2.d0*alpha-2.d0*beta)*(-2.d0*bmsq+2.d0*mch**2+sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2))&
	! )

	lam_GpGmbHh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		-Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)&
	)

	end function
!----------------------------------------------------
	double precision function lam_GpGmhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GpGmhh = -1.d0/(8.d0*vev**2)*(&
	! 	-(-3.d0+(2.d0*sin(2.d0*alpha)+sin(4.d0*alpha-2.d0*beta))/sin(2.d0*beta))*mh**2&
	! 	+4.d0*cos(alpha-beta)**2*(-2.d0*bmsq+2.d0*mch**2+sin(2.d0*alpha)/sin(2.d0*beta)*mbH**2)&
	! )

	lam_GpGmhh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+2.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_GGbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GGbHbH = -1.d0/(16.d0*vev**2)*(&
	! 	(-4.d0*sin(alpha-beta)**2)*(&
	! 		+2.d0*bmsq-2.d0*mA**2+sin(2.d0*alpha)/sin(2.d0*beta)*mh**2&
	! 	)&
	! 	+(3.d0+cos(4.d0*alpha)+2.d0*sin(2.d0*alpha)/sin(2.d0*beta)-sin(4.d0*alpha)/tan(2.d0*beta))*mbH**2&
	! )

	lam_GGbHbH =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		-2.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_GGbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GGbHh = -1.d0/(4.d0*vev**2)*sin(2.d0*alpha-2.d0*beta)*(&
	! -2.d0*bmsq+2.d0*mA**2+sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2)&
	! )

	lam_GGbHh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		-Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		-Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_GGhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_GGhh = -1.d0/(16.d0*vev**2)*(&
	! -(-3.d0+(2.d0*sin(2.d0*alpha)+sin(4.d0*alpha-2.d0*beta))/sin(2.d0*beta))*mh**2&
	! +4.d0*cos(alpha-beta)**2*(-2.d0*bmsq+2.d0*mA**2+sin(2.d0*alpha)/sin(2.d0*beta)*mbH**2)&
	! )

	lam_GGhh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+2.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpHmbHbH = -1.d0/(16.d0*vev**2)*(&
	! 	+16.d0*cos(alpha-beta)**2*mch**2&
	! 	+4.d0*cos(2.d0*alpha)/tan(2.d0*beta)/sin(2.d0*beta)*( (3.d0+cos(4.d0*beta))*bmsq-4.d0*mbH**2 )&
	! 	-(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(4.d0*bmsq-mh**2-3.d0*mbH**2)&
	! 	-cos(4.d0*alpha)*(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(mh**2-mbH**2)&
	! 	+2.d0/tan(2.d0*beta)*sin(4.d0*alpha)*(mbH**2-mh**2)&
	! 	+4.d0/sin(2.d0*beta)*sin(2.d0*alpha)*((-1.d0+cos(4.d0*beta))*bmsq-mh**2+mbH**2)&
	! )
	
	lam_HpHmbHbH =&
	-(&
		+Z2(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		-2.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpHmbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpHmbHh = -1.d0/(8.d0*vev**2)*(&
	! 	+8.d0*cos(2.d0*alpha)*sin(2.d0*beta)*(mch**2-bmsq)+2.d0/tan(2.d0*beta)*(mh**2-mbH**2)&
	! 	+(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*sin(4.d0*alpha)*(mh**2-mbH**2)&
	! 	+2.d0*cos(4.d0*alpha)/tan(2.d0*beta)*(mbH**2-mh**2)&
	! 	-4.d0/tan(2.d0*beta)/sin(2.d0*beta)*sin(2.d0*alpha)*(&
	! 		(3.d0+cos(4.d0*beta))*bmsq+2.d0*sin(2.d0*beta)**2*mch**2-2.d0*(mh**2+mbH**2)&
	! 	)&
	! )

	lam_HpHmbHh =&
	-(&
		-Z2(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)&
	)

	end function
!----------------------------------------------------
	double precision function lam_HpHmhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpHmhh = -1.d0/(16.d0*sin(2.d0*beta)**2*vev**2)*(&
	! 	-2.d0*(cos(2.d0*alpha-6.d0*beta) + 2.d0*(3.d0+cos(2.d0*alpha-2.d0*beta)+cos(4.d0*beta) )&
	! 		+5.d0*(cos(2.d0*alpha+2.d0*beta)))*bmsq&
	! 	+16.d0*sin(beta-alpha)**2*sin(2.d0*beta)**2*mch**2&
	! 	+(9.d0+3.d0*cos(4.d0*alpha)+6.d0*cos(2.d0*alpha-2.d0*beta)&
	! 	+cos(4.d0*alpha-4.d0*beta)+3.d0*cos(4.d0*beta)+10.d0*cos(2.d0*alpha+2.d0*beta))*mh**2&
	! 	+2.d0*sin(2.d0*alpha)*(3.d0*sin(2.d0*alpha)+sin(2.d0*alpha-4.d0*beta)+2.d0*sin(2.d0*beta))*mbH**2&
	! )

	lam_HpHmhh =&
	-(&
		+Z2(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+2.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_AAbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AAbHbH = -1.d0/(32.d0*vev**2)*(&
	! 	16.d0*cos(alpha-beta)**2*mA**2+4.d0*cos(2.d0*alpha)/tan(2.d0*beta)/sin(2.d0*beta)*(&
	! 	(3.d0+cos(4.d0*beta))*bmsq-4.d0*mbH**2)&
	! 	-(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(4.d0*bmsq-mh**2-3.d0*mbH**2)&
	! 	-cos(4.d0*alpha)*(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*(mh**2-mbH**2)&
	! 	+2.d0/tan(2.d0*beta)*sin(4.d0*alpha)*(mbH**2-mh**2)&
	! 	+4.d0/sin(2.d0*beta)*sin(2.d0*alpha)*((-1.d0+cos(4.d0*beta))*bmsq-mh**2+mbH**2)&
	! )

	lam_AAbHbH =&
	-(&
		+Z2(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		-2.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_AAbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AAbHh = -1.d0/(16.d0*vev**2)*(&
	! 	8.d0*cos(2.d0*alpha)*sin(2.d0*beta)*(-bmsq+mA**2)+2.d0/tan(2.d0*beta)*(mh**2-mbH**2)&
	! 	+(3.d0+cos(4.d0*beta))/sin(2.d0*beta)**2*sin(4.d0*alpha)*(mh**2-mbH**2)&
	! 	+2.d0*cos(4.d0*alpha)/tan(2.d0*beta)*(mbH**2-mh**2)&
	! 	-4.d0/tan(2.d0*beta)/sin(2.d0*beta)*sin(2.d0*alpha)*((3.d0+cos(4.d0*beta))*bmsq&
	! 	+2.d0*sin(2.d0*beta)**2*mA**2-2.d0*(mh**2+mbH**2))&
	! )

	lam_AAbHh =&
	-(&
		-Z2(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_AAhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AAhh = -1.d0/(32.d0*sin(2.d0*beta)**2*vev**2)*(&
	! -2.d0*( cos(2.d0*alpha-6.d0*beta) + 2.d0*(3.d0+cos(2.d0*alpha-2.d0*beta)+cos(4.d0*beta) )&
   !             +5.d0*(cos(2.d0*alpha+2.d0*beta))  )*bmsq&
	! +16.d0*sin(beta-alpha)**2*sin(2.d0*beta)**2*mA**2&
	! +(9.d0+3.d0*cos(4.d0*alpha)+6.d0*cos(2.d0*alpha-2.d0*beta)&
	! +cos(4.d0*alpha-4.d0*beta)+3.d0*cos(4.d0*beta)+10.d0*cos(2.d0*alpha+2.d0*beta))*mh**2&
	! +2.d0*sin(2.d0*alpha)*(3.d0*sin(2.d0*alpha)+sin(2.d0*alpha-4.d0*beta)+2.d0*sin(2.d0*beta))*mbH**2&
	! )

	lam_AAhh =&
	-(&
		+Z2(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z3(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+2.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_HpGmbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpGmbHbH =&
	! -((mh**2*(1.d0-2.d0*cos(beta-alpha)**2)-mbH**2*(1.d0+2.d0*sin(beta-alpha)**2)&
	! 	+2.d0*mch**2)*cos(beta-alpha)*sin(beta-alpha)&
	! +2.d0*(mbH**2*sin(beta-alpha)**2+mh**2*cos(beta-alpha)**2-bmsq)&
	! *sin(beta-alpha)**2/tan(2.d0*beta))/(2.d0*vev**2)

	lam_HpGmbHbH =&
	-(&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		-Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpGmbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmbHh =&
	-(&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)&
		+2.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		-2.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_HpGmhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_HpGmhh = cos(beta-alpha)/vev**2*(&
	! -1.d0/(4.d0*sin(2.d0*beta))*( cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*mh**2&
	! +1.d0/(2.d0*sin(2.d0*beta))*sin(2.d0*alpha)*sin(beta-alpha)*mbH**2&
	! +cos(beta-alpha)/tan(2.d0*beta)*bmsq&
	! +sin(beta-alpha)*mch**2&
	! )

	lam_HpGmhh =&
	-(&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0
	
	end function
!----------------------------------------------------
	double precision function lam_AGbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AGbHbH = 1.d0/(4.d0*vev**2)*(&
	! 	sin(alpha-beta)/sin(2.d0*beta)*(&
	! 		+4.d0*cos(2.d0*beta)*sin(alpha-beta)*bmsq+2.d0*cos(alpha-beta)*(2.d0*sin(2.d0*beta)*mA**2-sin(2.d0*alpha)*mh**2)&
	! 		+(sin(3.d0*alpha-beta)-3.d0*sin(alpha+beta))*mbH**2&
	! 	)&
	! )

	lam_AGbHbH =&
	-(&	
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		-2.d0*Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_AGbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_AGbHh =&
	-(&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		-Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
		+Z5(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)&
	)

	end function
!----------------------------------------------------
	double precision function lam_AGhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_AGhh = -1.d0/(8.d0*vev**2)*(&
	! 	cos(alpha-beta)/sin(beta)/cos(beta)*(&
	! 		-4.d0*cos(alpha-beta)*cos(2.d0*beta)*bmsq+2.d0*sin(alpha-beta)*(2.d0*sin(2.d0*beta)*mA**2+sin(2.d0*alpha)*mbH**2)&
	! 		+(cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*mh**2&
	! 	)&
	! )

	lam_AGhh =&
	-(&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2&
		+2.d0*Z5(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)&
	)/2.d0

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HpGmAbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmAbH =&
	ii*(&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)&
	)*cos(beta-alpha)/2.d0

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HmGpAbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HmGpAbH = conjg(lam_HpGmAbH(mch,mA,mbH,bmsq,alpha,beta))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HpGmAh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmAh =&
	ii*(&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)&
	)*sin(beta-alpha)/2.d0

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HmGpAh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HmGpAh = conjg(lam_HpGmAh(mch,mA,mbH,bmsq,alpha,beta))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HpGmGbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmGbH =&
	ii*(&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)&
	)*sin(beta-alpha)/2.d0

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HmGpGbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HmGpGbH = conjg(lam_HpGmGbH(mch,mA,mbH,bmsq,alpha,beta))

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HpGmGh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HpGmGh =&
	-ii*(&
		+Z4(mch,mA,mbH,bmsq,alpha,beta)&
		-Z5(mch,mA,mbH,bmsq,alpha,beta)&
	)*cos(beta-alpha)/2.d0

	end function
!----------------------------------------------------
	complex (kind(0d0)) function lam_HmGpGh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	lam_HmGpGh = conjg(lam_HpGmGh(mch,mA,mbH,bmsq,alpha,beta))

	end function
!----------------------------------------------------
	double precision function lam_hhhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_hhhh = -1.d0/(32.d0*sin(2.d0*beta)**2*vev**2)*(&
	! -4.d0*(cos(2.d0*alpha)+cos(2.d0*beta))**2*bmsq&
	! +(cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))**2*mh**2&
	! +4.d0*cos(alpha-beta)**2*sin(2.d0*alpha)**2*mbH**2&
	! )

	lam_hhhh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**4&
		+Z2(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**4&
		+2.d0*Z345(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*sin(beta-alpha)**2&
		+4.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)**3&
		+4.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**3*sin(beta-alpha)&
	)/8.d0

	end function
!----------------------------------------------------
	double precision function lam_bHhhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_bHhhh = -1.d0/(4.d0*vev**2)*cos(alpha-beta)/sin(2.d0*beta)**2*sin(2.d0*alpha)*(&
	! cos(3.d0*alpha-beta)*mh**2+cos(alpha+beta)*(-4.d0*bmsq+3.d0*mh**2)&
	! +2.d0*sin(2.d0*alpha)*sin(alpha-beta)*mbH**2&
	! )

	lam_bHhhh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**3*cos(beta-alpha)&
		-Z2(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)**3&
		+Z345(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)*cos(beta-alpha)*sin(beta-alpha)&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*(&
			3.d0*cos(beta-alpha)**2-sin(beta-alpha)**2&
		)*sin(beta-alpha)**2&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-3.d0*sin(beta-alpha)**2&
		)*cos(beta-alpha)**2&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_bHbHhh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_bHbHhh = -1.d0/(16.d0*sin(2.d0*beta)**2*vev**2)*(&
	! +( 6.d0*cos(4.d0*alpha)-2.d0*(2.d0+cos(4.d0*beta)) )*bmsq&
	! +sin(2.d0*alpha)*(&
	!    3.d0*cos(2.d0*beta)*sin(4.d0*alpha)*(mh**2-mbH**2)&
	!    -(1.d0+3.d0*cos(4.d0*alpha))*sin(2.d0*beta)*(mh**2-mbH**2)&
	!    +6.d0*sin(2.d0*alpha)*(mh**2+mbH**2)&
	! 		 )&
	! )

	lam_bHbHhh =&
	-(&
		+3.d0*Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*cos(beta-alpha)**2&
		+3.d0*Z2(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*cos(beta-alpha)**2&
		+Z345(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**4+sin(beta-alpha)**4-4.d0*cos(beta-alpha)**2*sin(beta-alpha)**2&
		)&
		+6.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)*cos(beta-alpha)*sin(beta-alpha)&
		-6.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)*cos(beta-alpha)*sin(beta-alpha)&
	)/4.d0

	end function
!----------------------------------------------------
	double precision function lam_bHbHbHh(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_bHbHbHh = -1.d0/(2.d0*vev**2)/sin(2.d0*beta)**2*sin(2.d0*alpha)*sin(alpha-beta)*(&
	! -2.d0*sin(alpha+beta)*bmsq+cos(alpha-beta)*sin(2.d0*alpha)*mh**2&
	! +2.d0*(cos(beta)*sin(alpha)**3+cos(alpha)**3*sin(beta))*mbH**2&
	! )

	lam_bHbHbHh =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)**3&
		-Z2(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**3*cos(beta-alpha)&
		-Z345(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-sin(beta-alpha)**2&
		)*cos(beta-alpha)*sin(beta-alpha)&
		+Z6(mch,mA,mbH,bmsq,alpha,beta)*(&
			cos(beta-alpha)**2-3.d0*sin(beta-alpha)**2&
		)*cos(beta-alpha)**2&
		+Z7(mch,mA,mbH,bmsq,alpha,beta)*(&
			3.d0*cos(beta-alpha)**2-sin(beta-alpha)**2&
		)*sin(beta-alpha)**2&
	)/2.d0

	end function
!----------------------------------------------------
	double precision function lam_bHbHbHbH(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! lam_bHbHbHbH = -1.d0/(32.d0*vev**2)/sin(2.d0*beta)**2*(&
	! 	4.d0*sin(alpha-beta)**2*( -4.d0*sin(alpha+beta)**2*bmsq+sin(2.d0*alpha)**2*mh**2 )&
	! 	+(sin(3.d0*alpha-beta)-3.d0*sin(alpha+beta))**2*mbH**2&
	! )

	lam_bHbHbHbH =&
	-(&
		+Z1(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**4&
		+Z2(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**4&
		+2.d0*Z345(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*sin(beta-alpha)**2&
		-4.d0*Z6(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**3*sin(beta-alpha)&
		-4.d0*Z7(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)**3&
	)/8.d0

	end function
!#################################################
!
!    SECTION III Constraints on parameter space
!
!#################################################
!============ Perturbative unitarity ===================
	double precision function a0ap(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0ap =&
	1.d0/(16.d0*pi)*(&
		+3.d0/2.d0*(&
			+lam1(mch,mA,mbH,bmsq,alpha,beta)&
			+lam2(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+sqrt(&
			+9.d0/4.d0*(&
				+lam1(mch,mA,mbH,bmsq,alpha,beta)&
				-lam2(mch,mA,mbH,bmsq,alpha,beta)&
			)**2&
			+(&
				+2.d0*lam3(mch,mA,mbH,bmsq,alpha,beta)&
				+lam4(mch,mA,mbH,bmsq,alpha,beta)&
			)**2&
		)&
	)

	end function 
!------------------------------------
	double precision function a0am(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0am=&
	1.d0/(16.d0*pi)*(&
		+3.d0/2.d0*(&
			+lam1(mch,mA,mbH,bmsq,alpha,beta)&
			+lam2(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		-sqrt(&
			+9.d0/4.d0*(&
				+lam1(mch,mA,mbH,bmsq,alpha,beta)&
				-lam2(mch,mA,mbH,bmsq,alpha,beta)&
			)**2&
			+(&
				+2.d0*lam3(mch,mA,mbH,bmsq,alpha,beta)&
				+lam4(mch,mA,mbH,bmsq,alpha,beta)&
			)**2&
		)&
	)

	end function
!------------------------------------
	double precision function a0bp(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0bp =&
	1.d0/(16.d0*pi)*(&
		+1.d0/2.d0*(&
			+lam1(mch,mA,mbH,bmsq,alpha,beta)&
			+lam2(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+sqrt(&
			+1.d0/4.d0*(&
				+lam1(mch,mA,mbH,bmsq,alpha,beta)&
				-lam2(mch,mA,mbH,bmsq,alpha,beta)&
			)**2&
			+lam4(mch,mA,mbH,bmsq,alpha,beta)**2&
		)&
	)

	end function 
!------------------------------------
	double precision function a0bm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0bm =&
	1.d0/(16.d0*pi)*(&
		+1.d0/2.d0*(&
			+lam1(mch,mA,mbH,bmsq,alpha,beta)&
			+lam2(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		-sqrt(&
			+1.d0/4.d0*(&
				+lam1(mch,mA,mbH,bmsq,alpha,beta)&
				-lam2(mch,mA,mbH,bmsq,alpha,beta)&
			)**2&
			+lam4(mch,mA,mbH,bmsq,alpha,beta)**2&
		)&
	)

	end function 
!------------------------------------
	double precision function a0cp(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0cp =&
	1.d0/(16.d0*pi)*(&
		+1.d0/2.d0*(&
			+lam1(mch,mA,mbH,bmsq,alpha,beta)&
			+lam2(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+sqrt(&
			+1.d0/4.d0*(&
				+lam1(mch,mA,mbH,bmsq,alpha,beta)&
				-lam2(mch,mA,mbH,bmsq,alpha,beta)&
			)**2&
			+lam5(mch,mA,mbH,bmsq,alpha,beta)**2&
		)&
	)

	end function 
!------------------------------------
	double precision function a0cm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0cm =&
	1.d0/(16.d0*pi)*(&
		+1.d0/2.d0*(&
			+lam1(mch,mA,mbH,bmsq,alpha,beta)&
			+lam2(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		-sqrt(&
			+1.d0/4.d0*(&
				+lam1(mch,mA,mbH,bmsq,alpha,beta)&
				-lam2(mch,mA,mbH,bmsq,alpha,beta))**2&
				+lam5(mch,mA,mbH,bmsq,alpha,beta)**2&
		)&
	)

	end function 
!------------------------------------
	double precision function a0e1(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

   a0e1 =&
	1.d0/(16.d0*pi)*(&
		+lam3(mch,mA,mbH,bmsq,alpha,beta)&
		+2.d0*lam4(mch,mA,mbH,bmsq,alpha,beta)&
		-3.d0*lam5(mch,mA,mbH,bmsq,alpha,beta)&
	)

	end function
!------------------------------------
	double precision function a0e2(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0e2 =&
	1.d0/(16.d0*pi)*(&
		+lam3(mch,mA,mbH,bmsq,alpha,beta)&
		-lam5(mch,mA,mbH,bmsq,alpha,beta)&
	)

	end function
!------------------------------------
	double precision function a0fp(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0fp =&
	1.d0/(16.d0*pi)*(&
		+lam3(mch,mA,mbH,bmsq,alpha,beta)&
		+2.d0*lam4(mch,mA,mbH,bmsq,alpha,beta)&
		+3.d0*lam5(mch,mA,mbH,bmsq,alpha,beta)&
	)

	end function
!------------------------------------
	double precision function a0fm(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0fm =&
	1.d0/(16.d0*pi)*(&
		+lam3(mch,mA,mbH,bmsq,alpha,beta)&
		+lam5(mch,mA,mbH,bmsq,alpha,beta)&
	)

	end function
!------------------------------------
	double precision function a0f1(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	a0f1 =&
	1.d0/(16.d0*pi)*(&
		+lam3(mch,mA,mbH,bmsq,alpha,beta)&
		+lam4(mch,mA,mbH,bmsq,alpha,beta)&
	)

	end function
!------------------------------------
	double precision function a0p(mch,ma,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,ma,mbH,bmsq,alpha,beta

	a0p =&
	1.d0/(16.d0*pi)*(&
		lam3(mch,ma,mbH,bmsq,alpha,beta)&
		-lam4(mch,ma,mbH,bmsq,alpha,beta)&
	)

	end function
!------------------------------------
	double precision function pu(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	if (abs(a0ap(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=1.d0
	else if (abs(a0am(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=2.d0 
	else if (abs(a0bp(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=3.d0
	else if (abs(a0bm(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=4.d0 
	else if (abs(a0cp(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=5.d0 
	else if (abs(a0cm(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=6.d0 
	else if (abs(a0e1(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=7.d0 
	else if (abs(a0e2(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=8.d0 
	else if (abs(a0fp(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=9.d0 
   else if (abs(a0fm(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=10.d0 
   else if (abs(a0f1(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=11.d0 
   else if (abs(a0p(mch,mA,mbH,bmsq,alpha,beta)) > lqt) then
		pu=12.d0 
	else
		pu=0.d0
	end if

	end function
!============= Vacuum stability ===============================
	double precision function vs(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	double precision:: tmp1,tmp2,stab

	tmp1 = lam4(mch,mA,mbH,bmsq,alpha,beta)+lam5(mch,mA,mbH,bmsq,alpha,beta)
   tmp2 = lam4(mch,mA,mbH,bmsq,alpha,beta)-lam5(mch,mA,mbH,bmsq,alpha,beta)

	stab =&
		+sqrt(lam1(mch,mA,mbH,bmsq,alpha,beta)*lam2(mch,mA,mbH,bmsq,alpha,beta))&
      +lam3(mch,mA,mbH,bmsq,alpha,beta)&
      +dmin1(0.d0,tmp1,tmp2)

	if (lam1(mch,mA,mbH,bmsq,alpha,beta) <= 0.d0) then
		vs=1.d0  
	else if (lam2(mch,mA,mbH,bmsq,alpha,beta) <= 0.d0) then
		vs=2.d0  
	else if (stab <= 0.d0) then 
		vs=3.d0  
	else 
 		vs=0.d0
   end if
	!KS: modified all above logic operators from .lt. to .le. 

	end function
!=============== true vacuum conditions ========================================
	double precision function true_vacuum(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	double precision:: vm11sq,vm22sq,vm12sq,vlam1,vlam2,vlam3,vlam4,vlam5
	double precision:: vev1,vev2,vk
	double precision:: Discriminant

	vm11sq = m11sq(mch,mA,mbH,bmsq,alpha,beta)
	vm22sq = m22sq(mch,mA,mbH,bmsq,alpha,beta)
	vm12sq = m12sq(mch,mA,mbH,bmsq,alpha,beta)
	vlam1 = lam1(mch,mA,mbH,bmsq,alpha,beta)
	vlam2 = lam2(mch,mA,mbH,bmsq,alpha,beta)
	vlam3 = lam3(mch,mA,mbH,bmsq,alpha,beta)
	vlam4 = lam4(mch,mA,mbH,bmsq,alpha,beta)
	vlam5 = lam5(mch,mA,mbH,bmsq,alpha,beta)

	vev1 = vev*cos(beta)
	vev2 = vev*sin(beta)
	vk = (vlam1/vlam2)**(1.d0/4.d0)

	Discriminant = vm12sq*(vm11sq-vk**2*vm22sq)*(vev2/vev1-vk)

	true_vacuum = 0.d0

	if(Discriminant < 0.d0) then
		true_vacuum = 1.d0
	endif

	end function
!=============== Triviality bound ==============================================
	double precision function triviality(cutoff,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: cutoff,mch,mA,mbH,bmsq,alpha,beta
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	vlam1 = lam1(mch,mA,mbH,bmsq,alpha,beta)
	vlam2 = lam2(mch,mA,mbH,bmsq,alpha,beta)
	vlam3 = lam3(mch,mA,mbH,bmsq,alpha,beta)
	vlam4 = lam4(mch,mA,mbH,bmsq,alpha,beta)
	vlam5 = lam5(mch,mA,mbH,bmsq,alpha,beta)
	vyt   = sqrt(2.d0)*mt/vev/sin(beta)*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))

	no=100
   t0= log(mh); tfin=log(1.d10); h=(tfin-t0)/dble(no)

	do  i = 0,no
		t = t0+h*dble(i)
		call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
		max_coup = max(abs(vlam1),abs(vlam2),abs(vlam3),abs(vlam4),abs(vlam5),abs(vyt))

		if (exp(t) < cutoff .and. 4.d0*pi < max_coup) then 
			triviality = 1.d0
			exit
		else if  (cutoff < exp(t) .and. max_coup <= 4.d0*pi) then 
			triviality = 0.d0
			exit
		endif
	enddo

	end function
!-------------------------------------------------------------------------------
	double precision function triviality_MSM(cutoff,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: cutoff,mch,mA,mbH,bmsq,alpha,beta
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h,cr
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	cr=4.d0*pi
	! cr=8.d0*pi ! for numerical check

	!-------------------------------- sm RGE ----------------------------------------
	vlam2 = lam2(mch,mA,mbH,bmsq,alpha,beta)
	vyt   =  sqrt(2.d0)*mt/vev/sin(beta)*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))
	triviality_MSM = 0.d0
	no=100

	t0= log(mh); tfin = log(sqrt(bmsq)); h=(tfin-t0)/dble(no)
	do  i = 0,no
		t=t0+h*dble(i)
		call RGE_sm(t0,tfin,h,t,no,vlam2,vyt)
		max_coup = max(vlam2,vyt)
		! max_coup = max(vlam2,vyt**2*2.d0)

		if (cr < max_coup) then
			triviality_MSM = 2.d0
			go to 30
		end if
	end do

	!-------------------------------- THDM RGE ----------------------------------------
	t0= 0.d0; tfin= 0.d0; h=0.d0; t=0.d0
	vlam1 = lam1(mch,mA,mbH,bmsq,alpha,beta)
	vlam3 = lam3(mch,mA,mbH,bmsq,alpha,beta)
	vlam4 = lam4(mch,mA,mbH,bmsq,alpha,beta)
	vlam5 = lam5(mch,mA,mbH,bmsq,alpha,beta)

	no = 100
	t0 = log(sqrt(bmsq)); tfin=log(1.d10); h=(tfin-t0)/dble(no)
	do  i = 0,no
		t = t0+h*dble(i)
		call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
		max_coup = max(abs(vlam1),abs(vlam2),abs(vlam3),abs(vlam4),abs(vlam5),abs(vyt))
		! max_coup = max(vlam1,vlam2,vlam3,vlam4,vlam5,vyt**2*2.d0)
		if (exp(t) < cutoff .and. cr < max_coup) then 
			triviality_MSM = 1.d0
			exit
		else if (cutoff < exp(t) .and. max_coup <= cr) then 
			triviality_MSM = 0.d0
			exit
		endif
	enddo

30	continue

	end function
!============= RGE improved vacuum stability ====================
	double precision function vs_rge(cutoff,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: cutoff,mch,mA,mbH,bmsq,alpha,beta
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt,stab

	vlam1 = lam1(mch,mA,mbH,bmsq,alpha,beta)
	vlam2 = lam2(mch,mA,mbH,bmsq,alpha,beta)
	vlam3 = lam3(mch,mA,mbH,bmsq,alpha,beta)
	vlam4 = lam4(mch,mA,mbH,bmsq,alpha,beta)
	vlam5 = lam5(mch,mA,mbH,bmsq,alpha,beta)
	vyt   = sqrt(2.d0)*mt/vev/sin(beta)*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))

	vs_rge = 0.d0

	no = 100
	t0 = log(mh); tfin = log(cutoff); h=(tfin-t0)/dble(no)
	do  i = 0,no
		t=t0+h*dble(i)
		call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
		stab = sqrt(vlam1*vlam2)+vlam3+min1(0.d0,vlam4+vlam5,vlam4-vlam5)
		if (vlam1 <= 0.d0) then
			vs_rge = 1.d0  
		else if (vlam2 <= 0.d0) then
			vs_rge = 2.d0 
		else if (stab <= 0.d0) then 
			vs_rge = 3.d0  
		end if
	enddo

	end function
!---------------------------------------------------
	double precision function vs_rge_MSM(cutoff,mch,mA,mbH,bmsq,alpha,beta)
	integer:: i,no
	double precision:: t0,tfin,max_coup,t,h
	double precision:: vlam1,vlam2,vlam3,vlam4,vlam5,vyt,stab
	double precision, intent(in):: cutoff,mch,mA,mbH,bmsq,alpha,beta

	!--------------------- SM RGE ------------------------------
	vlam2 = lam2(mch,mA,mbH,bmsq,alpha,beta)
	vyt   =  sqrt(2.d0)*mt/vev/sin(beta)*(1.d0-4.d0/3.d0/pi*alphas(lam_QCD5,mh,5.d0))

	vs_rge_MSM = 0.d0

	no=100
	t0 = log(mh); tfin = log(sqrt(bmsq)); h = (tfin-t0)/dble(no)
	do  i = 0,no
		t = t0+h*dble(i)
		call RGE_sm(t0,tfin,h,t,no,vlam2,vyt)
		if (vlam2 <= 0.d0) then
			vs_rge_MSM = 4.d0
		end if
	end do

	!--------------------- THDM RGE ------------------------------
	t0=0.d0;tfin=0.d0;h=0.d0;t=0.d0
	vlam1 = lam1(mch,mA,mbH,bmsq,alpha,beta)
	vlam3 = lam3(mch,mA,mbH,bmsq,alpha,beta)
	vlam4 = lam4(mch,mA,mbH,bmsq,alpha,beta)
	vlam5 = lam5(mch,mA,mbH,bmsq,alpha,beta)

	no=100
	t0= log(sqrt(bmsq)); tfin=log(cutoff); h=(tfin-t0)/dble(no)
	do  i = 0,no
	   t=t0+h*dble(i)
		call RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
		stab = sqrt(vlam1*vlam2)+vlam3+min1(0.d0,vlam4+vlam5,vlam4-vlam5)
		if (vlam1 <= 0.d0) then
			vs_rge_MSM = 1.d0
		else if (vlam2 <= 0.d0) then
			vs_rge_MSM = 2.d0
		else if (stab <= 0.d0) then
			vs_rge_MSM = 3.d0
		! ! KS modefyed 
		! ! bellow conditions comes from the positibity of masses of scalar bosons. 
		! ! From these conditions, minima that breaks CP and electric charge can be avoid. 
		! ! the last condition is only valid for sin(b-a)=1.
		!           else if (vlam4+vlam5-2.d0*bmsq/vev**2 .ge. 0.d0) then
		!              vs_rge_MSM = 5.d0
		!           else if (vlam5-bmsq/vev**2 .ge. 0.d0) then
		!              vs_rge_MSM = 6.d0
		!           else if (vlam1+vlam2*tan(beta)**4+(vlam3+vlam4+vlam5)*tan(beta)**2 .lt. 0.d0) then
		!              vs_rge_MSM = 7.d0
		!           else if ( bmsq/vev**2*(tan(beta)+1.d0)**2+tan(beta)**2*(vlam1+vlam2-2.d0*(vlam3+vlam4+vlam5)).lt.0.d0) then
		!              vs_rge_MSM = 8.d0
		! ! ! end modefied  
		end if
	enddo

	end function
!=============== ST parameters===================
	complex (kind(0d0)) function  F_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	F_stu = -B5f(psq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  G_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	G_stu = -4.d0*m2**2*B0f(psq,m1,m2)-B5f(psq,m1,m2)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Fp_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	Fp_stu = (F_stu(psq,m1,m2)-F_stu(0.d0,m1,m2))/psq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Gp_stu(psq,m1,m2)
	double precision, intent(in):: psq,m1,m2

	Gp_stu = (G_stu(psq,m1,m2)-G_stu(0.d0,m1,m2))/psq

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Del_S_2HDM(mch,ma,mbH,alpha,beta)
	double precision, intent(in):: mch,ma,mbH,alpha,beta

	Del_S_2HDM =&
	1.d0/(4.d0*pi)*(&
		-Fp_stu(mz**2,mch,mch)&
		+sin(beta-alpha)**2*(Fp_stu(mz**2,mbH,ma)+Gp_stu(mz**2,mh,mz))&
		+cos(beta-alpha)**2*(Fp_stu(mz**2,mh,ma)+Gp_stu(mz**2,mbH,mz))&
		-Gp_stu(mz**2,mh,mz)&
	)

	end function
!---------------------------------------------------
	complex (kind(0d0)) function  Del_T_2HDM(mch,ma,mbH,alpha,beta)
	double precision, intent(in):: mch,ma,mbH,alpha,beta

	Del_T_2HDM =&
	1.d0/(16.d0*pi**2*alpha_em*vev**2)*(&
		F_stu(0.d0,mch,ma)&
		+sin(beta-alpha)**2*(F_stu(0.d0,mch,mbH)-F_stu(0.d0,mbH,ma))& 
		+cos(beta-alpha)**2*(&
			+F_stu(0.d0,mch,mh)-F_stu(0.d0,ma,mh)&
			-G_stu(0.d0,mh,mw)+G_stu(0.d0,mbH,mw)&
			+G_stu(0.d0,mh,mz)-G_stu(0.d0,mbH,mz)&
		)&
	)

	end function
!--------------------------------------------------------
	double precision function stu(mch,ma,mbH,alpha,beta)
	double precision:: V_inv(2,2),del_chisq,dels,delt
	double precision, intent(in):: mch,ma,mbH,alpha,beta

	dels = Del_S_2HDM(mch,ma,mbH,alpha,beta)
	delt = Del_T_2HDM(mch,ma,mbH,alpha,beta)

	V_inv(1,1) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_t**2
	V_inv(2,2) = 1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s**2
	V_inv(1,2) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
	V_inv(2,1) = -1.d0/(sigma_s**2*sigma_t**2)*1.d0/(1.d0-rho_st**2)*sigma_s*sigma_t*rho_st
  
	del_chisq = (dels-s_cent)**2*V_inv(1,1)+(delt-t_cent)**2*V_inv(2,2)+2.d0*(dels-s_cent)*(delt-t_cent)*V_inv(1,2)
	if (del_chisq  <= 5.99d0) then 
		stu = 0.d0
	else if (5.99d0 < del_chisq) then 
		stu = 1.d0
	endif

	end function
!#################################################
!
!    SECTION IV 1PI diagrams
!
!#################################################
!====== Gauge boson two point functions ========
	complex (kind(0d0)) function PiWW_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	PiWW_S =&
	g**2/(16.d0*pi**2)*(&
		+1.d0/4.d0*(&
			+sin(beta-alpha)**2*b5f(qsq,mbH,mch)&
			+cos(beta-alpha)**2*b5f(qsq,mh,mch)&
			+b5f(qsq,mA,mch)&
		)&
		+sin(beta-alpha)**2*(mw**2*b0f(qsq,mh,mW)+1.d0/4.d0*b5f(qsq,mh,mw))&
		+cos(beta-alpha)**2*(mw**2*b0f(qsq,mbH,mW)+1.d0/4.d0*b5f(qsq,mbH,mw))&	
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	PiGG_S =&
	g**2*sw**2/(16.d0*pi**2)*(&
		b5f(qsq,mch,mch)&
	)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	PiZG_S =&
	g**2*sw/cw/(16.d0*pi**2)*(&
		1.d0/2.d0*b5f(qsq,mch,mch)&
	)&
	-sw/cw*PiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	PiZZ_S =&
	g**2/cw**2/(16.d0*pi**2)*(&
		1.d0/4.d0*(&
			+sin(beta-alpha)**2*b5f(qsq,mbH,mA)&
			+cos(beta-alpha)**2*b5f(qsq,mh,mA)&
			+b5f(qsq,mch,mch)&
		)&
		+sin(beta-alpha)**2*(mZ**2*b0f(qsq,mh,mZ)+1.d0/4.d0*b5f(qsq,mh,mZ))&
		+cos(beta-alpha)**2*(mZ**2*b0f(qsq,mbH,mZ)+1.d0/4.d0*b5f(qsq,mbH,mZ))&
	)&
	-2.d0*sw/cw*PiZG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)&
	-sw**2/cw**2*PiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
 
	end function
!==================================================
	complex (kind(0d0)) function dPiWW_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	dPiWW_S =&
	g**2/(16.d0*pi**2)*(&
		1.d0/4.d0*(&
			+sin(beta-alpha)**2*db5f(qsq,mbH,mch)&
			+cos(beta-alpha)**2*db5f(qsq,mh,mch)&
			+db5f(qsq,mA,mch)&
		)&
		+sin(beta-alpha)**2*(mw**2*db0f(qsq,mh,mW)+1.d0/4.d0*db5f(qsq,mh,mw))&
		+cos(beta-alpha)**2*(mw**2*db0f(qsq,mbH,mW)+1.d0/4.d0*db5f(qsq,mbH,mw))&	
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	dPiGG_S =&
	g**2*sw**2/(16.d0*pi**2)*(&
		db5f(qsq,mch,mch)&
	)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	dPiZG_S =&
	g**2*sw/cw/(16.d0*pi**2)*(&
		1.d0/2.d0*db5f(qsq,mch,mch)&
	)&
	-sw/cw*dPiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZZ_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	dPiZZ_S =&
	g**2/cw**2/(16.d0*pi**2)*(&
		1.d0/4.d0*(&
			+sin(beta-alpha)**2*db5f(qsq,mbH,mA)&
			+cos(beta-alpha)**2*db5f(qsq,mh,mA)&
			+db5f(qsq,mch,mch)&
		)&
		+sin(beta-alpha)**2*(mZ**2*db0f(qsq,mh,mZ)+1.d0/4.d0*db5f(qsq,mh,mZ))&
		+cos(beta-alpha)**2*(mZ**2*db0f(qsq,mbH,mZ)+1.d0/4.d0*db5f(qsq,mbH,mZ))&
	)&
	-2.d0*sw/cw*dPiZG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)&
	-sw**2/cw**2*dPiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)
 
	end function
!==================================================
	complex (kind(0d0)) function PiWW_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	PiWW_B = PiWW_B_WOH(qsq)+PiWW_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiGG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	PiGG_B = PiGG_B_WOH(qsq)+PiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	PiZG_B = PiZG_B_WOH(qsq)+PiZG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function PiZZ_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	PiZZ_B = PiZZ_B_WOH(qsq)+PiZZ_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiWW_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	dPiWW_B = dPiWW_B_WOH(qsq)+dPiWW_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiGG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	dPiGG_B = dPiGG_B_WOH(qsq)+dPiGG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	dPiZG_B = dPiZG_B_WOH(qsq)+dPiZG_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiZZ_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	
	dPiZZ_B = dPiZZ_B_WOH(qsq)+dPiZZ_S(qsq,mch,mA,mbH,bmsq,alpha,beta)

 	end function
!=======================================================
!  CP-even Higgs boson one and two point functions
!=======================================================
	complex (kind(0d0)) function Th_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	Th_F =&
	1.d0/(16.d0*pi**2)*(&
		! up type quarks
		-Nc*4.d0*mt**2*xiu(alpha,beta,n)/vev*a0f(mt)&
		-Nc*4.d0*mc**2*xiu(alpha,beta,n)/vev*a0f(mc)&
		! down type quarks
		-Nc*4.d0*mb**2*xid(alpha,beta,n)/vev*a0f(mb)&
		-Nc*4.d0*ms**2*xid(alpha,beta,n)/vev*a0f(ms)&
		! leptons
		-4.d0*mtau**2*xil(alpha,beta,n)/vev*a0f(mtau)&
		-4.d0*mmu**2*xil(alpha,beta,n)/vev*a0f(mmu)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Th_F_div(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	Th_F_div =&
	1.d0/(16.d0*pi**2)*(&
		! up type quarks
		-Nc*4.d0*mt**2*xiu(alpha,beta,n)/vev*a0f_div(mt)&
		-Nc*4.d0*mc**2*xiu(alpha,beta,n)/vev*a0f_div(mc)&
		! down type quarks
		-Nc*4.d0*mb**2*xid(alpha,beta,n)/vev*a0f_div(mb)&
		-Nc*4.d0*ms**2*xid(alpha,beta,n)/vev*a0f_div(ms)&
		! leptons
		-4.d0*mtau**2*xil(alpha,beta,n)/vev*a0f_div(mtau)&
		-4.d0*mmu**2*xil(alpha,beta,n)/vev*a0f_div(mmu)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Th_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Th_B =&
	1.d0/(16.d0*pi**2)*(&
		!--- S ---
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
		-lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)& 	
		-lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-3.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)& 
		-lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		!--- V ---
		+sin(beta-alpha)*(&
			3.d0*g*mW*a0f(mW)-2.d0*g*mW**3&
			+3.d0/2.d0*gz*mZ*a0f(mZ)-gz*mZ**3&
		)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Th_B_div(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	Th_B_div =&
	1.d0/(16.d0*pi**2)*(&
		!--- S ---
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mch)&
		-lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mA)&
		-lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mbH)&
		-3.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mh)&
		-lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mw)&
		-lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mz)&
		!--- V ---
		+sin(beta-alpha)*(&
			3.d0*g*mW*a0f_div(mW)&
			+3.d0/2.d0*gz*mZ*a0f_div(mZ)&
		)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function TbH_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	TbH_F =&
	1.d0/(16.d0*pi**2)*(&
		! up type quarks
		-Nc*4.d0*mt**2*xiu_H(alpha,beta,n)/vev*a0f(mt)&
		-Nc*4.d0*mc**2*xiu_H(alpha,beta,n)/vev*a0f(mc)&
		! down type quarks
		-Nc*4.d0*mb**2*xid_H(alpha,beta,n)/vev*a0f(mb)&
		-Nc*4.d0*ms**2*xid_H(alpha,beta,n)/vev*a0f(ms)&
		! leptons
		-4.d0*mtau**2*xil_H(alpha,beta,n)/vev*a0f(mtau)&
		-4.d0*mmu**2*xil_H(alpha,beta,n)/vev*a0f(mmu)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function TbH_F_div(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	TbH_F_div =&
	1.d0/(16.d0*pi**2)*(&
		! up type quarks
		-Nc*4.d0*mt**2*xiu_H(alpha,beta,n)/vev*a0f_div(mt)&
		-Nc*4.d0*mc**2*xiu_H(alpha,beta,n)/vev*a0f_div(mc)&
		! down type quarks
		-Nc*4.d0*mb**2*xid_H(alpha,beta,n)/vev*a0f_div(mb)&
		-Nc*4.d0*ms**2*xid_H(alpha,beta,n)/vev*a0f_div(ms)&
		! leptons
		-4.d0*mtau**2*xil_H(alpha,beta,n)/vev*a0f_div(mtau)&
		-4.d0*mmu**2*xil_H(alpha,beta,n)/vev*a0f_div(mmu)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function TbH_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	TbH_B =&
	1.d0/(16.d0*pi**2)*(&
		!--- S ---
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
		-lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-3.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)& 
		-lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		!--- V ---
		+cos(beta-alpha)*(&
			3.d0*g*mW*a0f(mW)-2.d0*g*mW**3&
			+3.d0/2.d0*gz*mZ*a0f(mZ)-gz*mZ**3&
		)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function TbH_B_div(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	TbH_B_div =&
	1.d0/(16.d0*pi**2)*(&
		!--- S ---
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mch)&
		-lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mA)&
		-3.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mbH)&
		-lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mh)&
		-lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mw)&
		-lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mz)&
		!--- V ---
		+cos(beta-alpha)*(&
			3.d0*g*mW*a0f_div(mW)&
			+3.d0/2.d0*gz*mZ*a0f_div(mZ)&
		)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function T1_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	T1_F = cos(alpha)*TbH_F(alpha,beta,n)-sin(alpha)*Th_F(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function T2_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	T2_F = sin(alpha)*TbH_F(alpha,beta,n)+cos(alpha)*Th_F(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function T1_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	T1_B = cos(alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)-sin(alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	complex (kind(0d0)) function T2_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	T2_B = sin(alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)+cos(alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pihh_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	Pihh_F=&
	-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mt)&
		+(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	)*&
	xiu(alpha,beta,n)**2&
!
	-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mc)&
		+(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	)*&
	xiu(alpha,beta,n)**2&	
!
	-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mb)&
		+(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	)*&
	xid(alpha,beta,n)**2&
!
	-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(ms)&
		+(2.d0*ms**2-qsq/2.d0)*b0f(qsq,ms,ms)&
	)*&
	xid(alpha,beta,n)**2&
!
	-4.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mtau)&
		+(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	)*&
	xil(alpha,beta,n)**2&
!
	-4.d0*mmu**2/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mmu)&
		+(2.d0*mmu**2-qsq/2.d0)*b0f(qsq,mmu,mmu)&
	)*&
	xil(alpha,beta,n)**2

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pihh_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	Pihh_B=&
	+1.d0/(16.d0*pi**2)*&
	(&
		!----- V and VV and VS -----
		+g**2*sin(beta-alpha)**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
		+g**2/2.d0*(4.d0-sin(beta-alpha)**2)*a0f(mW)&
		+gz**2/2.d0*sin(beta-alpha)**2*(3.d0*mz**2-qsq)*b0f(qsq,mZ,mZ)&
		+gz**2/4.d0*(4.d0-sin(beta-alpha)**2)*a0f(mZ)&
		-g**2/2.d0*cos(beta-alpha)**2*(2.d0*a0f(mW)-a0f(mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mch))&
		-gz**2/4.d0*cos(beta-alpha)**2*(2.d0*a0f(mZ)-a0f(mA)+(2.d0*mA**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mA))&
		-(sin(beta-alpha)**2+1.d0/2.d0)*(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
	!----- S and SS -----
	+1.d0/(16.d0*pi**2)*&
	(&
		-12.d0*lam_hhhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)&
		-2.d0*lam_bHbHhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-2.d0*lam_GGhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		-2.d0*lam_AAhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-2.d0*lam_GpGmhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-2.d0*lam_HpHmhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
		+lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mw,mw)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mch,mch)&
		+2.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mch,mw)&
		+2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mz,mz)&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mA,mA)&
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mA,mz)&
		+18.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mh,mh)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mbH,mbH)&
		+4.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mbH,mh)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function PibHbH_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PibHbH_F=&
	-Nc*4.d0*mt**2/(16.d0*pi**2*vev**2)*&
	(&
	 +a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*xiu_H(alpha,beta,n)**2&
!
	-Nc*4.d0*mb**2/(16.d0*pi**2*vev**2)*&
	(&
	 +a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*xid_H(alpha,beta,n)**2&
!
	-Nc*4.d0*mc**2/(16.d0*pi**2*vev**2)*&
	(&
	 +a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*xiu_H(alpha,beta,n)**2&
!
	-Nc*4.d0*ms**2/(16.d0*pi**2*vev**2)*&
	(&
	+a0f(ms)&
	+(2.d0*ms**2-qsq/2.d0)*b0f(qsq,ms,ms)&
	)*xid_H(alpha,beta,n)**2&
!
	-4.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
	 +a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )*xil_H(alpha,beta,n)**2&
!
	-4.d0*mmu**2/(16.d0*pi**2*vev**2)*&
	(&
	 +a0f(mmu)&
	 +(2.d0*mmu**2-qsq/2.d0)*b0f(qsq,mmu,mmu)&
	 )*xil_H(alpha,beta,n)**2
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function PibHbH_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	PibHbH_B=&
	+1.d0/(16.d0*pi**2)*&
	(&
		+g**2*cos(beta-alpha)**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
		+g**2/2.d0*(4.d0-cos(beta-alpha)**2)*a0f(mW)&
		+gz**2/2.d0*cos(beta-alpha)**2*(3.d0*mz**2-qsq)*b0f(qsq,mZ,mZ)&
		+gz**2/4.d0*(4.d0-cos(beta-alpha)**2)*a0f(mZ)&
		-g**2/2.d0*sin(beta-alpha)**2*(2.d0*a0f(mW)-a0f(mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mch))&
		-gz**2/4.d0*sin(beta-alpha)**2*(2.d0*a0f(mZ)-a0f(mA)+(2.d0*mA**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mA))&
		-(cos(beta-alpha)**2+1.d0/2.d0)*(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	(&
		-2.d0*lam_bHbHhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)&
		-12.d0*lam_bHbHbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-2.d0*lam_GGbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		-2.d0*lam_AAbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-2.d0*lam_GpGmbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-2.d0*lam_HpHmbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mw,mw)&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mch,mch)&
 		+2.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mch,mw)&
		+2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mz,mz)&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mA,mA)&
		+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mA,mz)&
		+18.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mbH,mbH)&
		+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mh,mh)&
		+4.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mbH,mh)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function PibHh_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PibHh_F=&
	 -4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mt)&
	 +(2.d0*mt**2-qsq/2.d0)*b0f(qsq,mt,mt)&
	 )*&
	xiu(alpha,beta,n)*xiu_H(alpha,beta,n)&	
!
	 -4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mc)&
	 +(2.d0*mc**2-qsq/2.d0)*b0f(qsq,mc,mc)&
	 )*&
	xiu(alpha,beta,n)*xiu_H(alpha,beta,n)&
!
	 -4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mb)&
	 +(2.d0*mb**2-qsq/2.d0)*b0f(qsq,mb,mb)&
	 )*&
	xid(alpha,beta,n)*xid_H(alpha,beta,n)&
!
	 -4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(ms)&
	 +(2.d0*ms**2-qsq/2.d0)*b0f(qsq,ms,ms)&
	 )*&
	xid(alpha,beta,n)*xid_H(alpha,beta,n)&
!
	 -4.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mtau)&
	 +(2.d0*mtau**2-qsq/2.d0)*b0f(qsq,mtau,mtau)&
	 )*&
	xil(alpha,beta,n)*xil_H(alpha,beta,n)&
!
	 -4.d0*mmu**2/(16.d0*pi**2*vev**2)*&
	(&
	  a0f(mmu)&
	 +(2.d0*mmu**2-qsq/2.d0)*b0f(qsq,mmu,mmu)&
	 )*&
	xil(alpha,beta,n)*xil_H(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PibHh_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	PibHh_B=&
	+1.d0/(16.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)*(&
		+g**2*(3.d0*mw**2-qsq)*b0f(qsq,mW,mW)&
		-g**2/2.d0*a0f(mW)&
		+gz**2/2.d0*(3.d0*mZ**2-qsq)*b0f(qsq,mZ,mZ)&
		-gz**2/4.d0*a0f(mZ)&
		+g**2/2.d0*(2.d0*a0f(mW)-a0f(mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mch))&
		+gz**2/4.d0*(2.d0*a0f(mZ)-a0f(mA)+(2.d0*mA**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mA))&
		-(2.d0*g**2*mW**2+gz**2*mZ**2)&
	)&
	!
	+1.d0/(16.d0*pi**2)*(&
		-3.d0*lam_bHhhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)&
		-3.d0*lam_bHbHbHh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-lam_GGbHh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		-lam_AAbHh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-lam_GpGmbHh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-lam_HpHmbHh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mw,mw)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mch,mch)&
		+2.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mch,mw)&
		+2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mz,mz)&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mA,mA)&
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mA,mz)&
		+6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mbH,mbH)&
		+6.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mh,mh)&
		+4.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mbH,mh)&
	)
	
	end function
!===========================================
	complex (kind(0d0)) function dPihh_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta
 
	dPihh_F=&
	-4.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
		+(-1.d0/2.d0)*b0f(qsq,mt,mt)&
	)*xiu(alpha,beta,n)**2&
 !
	-4.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
		+(-1.d0/2.d0)*b0f(qsq,mc,mc)&
	)*xiu(alpha,beta,n)**2&	
!
	-4.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
		+(-1.d0/2.d0)*b0f(qsq,mb,mb)&
	)*xid(alpha,beta,n)**2&
!
	-4.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*ms**2-qsq/2.d0)*db0f(qsq,ms,ms)&
		+(-1.d0/2.d0)*b0f(qsq,ms,ms)&
	)*xid(alpha,beta,n)**2&
!
	-4.d0*mtau**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
		+(-1.d0/2.d0)*b0f(qsq,mtau,mtau)&
	)*xil(alpha,beta,n)**2&
!
	-4.d0*mmu**2*1.d0/(16.d0*pi**2*vev**2)*&
	(&
		+(2.d0*mmu**2-qsq/2.d0)*db0f(qsq,mmu,mmu)&
		+(-1.d0/2.d0)*b0f(qsq,mmu,mmu)&
	)*xil(alpha,beta,n)**2

	end function
 !---------------------------------------------
	complex (kind(0d0)) function dPihh_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
 
	dPihh_B=&
	1.d0/(16.d0*pi**2)*(&
		g**2*sin(beta-alpha)**2*(3.d0*mw**2-qsq)*db0f(qsq,mW,mW)&
		+g**2*sin(beta-alpha)**2*(-1.d0)*b0f(qsq,mW,mW)&
		+gz**2/2.d0*sin(beta-alpha)**2*(3.d0*mz**2-qsq)*db0f(qsq,mZ,mZ)&
		+gz**2/2.d0*sin(beta-alpha)**2*(-1.d0)*b0f(qsq,mZ,mZ)&
		-g**2/2.d0*cos(beta-alpha)**2*(2.d0*mch**2-mW**2+2.d0*qsq)*db0f(qsq,mW,mch)&
		-g**2/2.d0*cos(beta-alpha)**2*2.d0*b0f(qsq,mW,mch)&
		-gz**2/4.d0*cos(beta-alpha)**2*(2.d0*mA**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,mA)&
		-gz**2/4.d0*cos(beta-alpha)**2*2.d0*b0f(qsq,mZ,mA)&
	)&
	!
	+1.d0/(16.d0*pi**2)*(&
	  +lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mch,mch)&
	  +lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mw,mw)&
	  +2.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mch,mw)&
	  +2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mA,mA)&
	  +2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mz,mz)&
	  +lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mA,mz)&
	  +2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mbH,mbH)&
		+18.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mh,mh)&
	  +4.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mbH,mh)&
	)
	 
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPibHbH_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	dPibHbH_F=&
	-Nc*4.d0*mt**2/(16.d0*pi**2*vev**2)*&
	(&
	-1.d0/2.d0*b0f(qsq,mt,mt)&
	+(2.d0*mt**2-qsq/2.d0)*db0f(qsq,mt,mt)&
	)*xiu_H(alpha,beta,n)**2&	
!
	 -Nc*4.d0*mc**2/(16.d0*pi**2*vev**2)*&
	(&
	-1.d0/2.d0*b0f(qsq,mc,mc)&
	+(2.d0*mc**2-qsq/2.d0)*db0f(qsq,mc,mc)&
	)*xiu_H(alpha,beta,n)**2&
!
	 -Nc*4.d0*mb**2/(16.d0*pi**2*vev**2)*&
	(&
	-1.d0/2.d0*b0f(qsq,mb,mb)&
	+(2.d0*mb**2-qsq/2.d0)*db0f(qsq,mb,mb)&
	)*xid_H(alpha,beta,n)**2&
!
	 -Nc*4.d0*ms**2/(16.d0*pi**2*vev**2)*&
	(&
	-1.d0/2.d0*b0f(qsq,ms,ms)&
	+(2.d0*ms**2-qsq/2.d0)*db0f(qsq,ms,ms)&
	)*xid_H(alpha,beta,n)**2&
!
	-4.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
	-1.d0/2.d0*b0f(qsq,mtau,mtau)&
	+(2.d0*mtau**2-qsq/2.d0)*db0f(qsq,mtau,mtau)&
	)*xil_H(alpha,beta,n)**2&
!
	-4.d0*mmu**2/(16.d0*pi**2*vev**2)*&
	(&
	-1.d0/2.d0*b0f(qsq,mmu,mmu)&
	+(2.d0*mmu**2-qsq/2.d0)*db0f(qsq,mmu,mmu)&
	)*xil_H(alpha,beta,n)**2

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPibHbH_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	dPibHbH_B=&
	1.d0/(16.d0*pi**2)*&
	(&
	  +g**2*cos(beta-alpha)**2*(-b0f(qsq,mW,mW)+(3.d0*mw**2-qsq)*db0f(qsq,mW,mW))&
	  +gz**2/2.d0*cos(beta-alpha)**2*(-b0f(qsq,mZ,mZ)+(3.d0*mz**2-qsq)*db0f(qsq,mZ,mZ))&
	  -g**2/2.d0*sin(beta-alpha)**2*(2.d0*b0f(qsq,mW,mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*db0f(qsq,mW,mch))&
	  -gz**2/4.d0*sin(beta-alpha)**2*(2.d0*b0f(qsq,mZ,mA)+(2.d0*mA**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,mA))&
	)&
!
	+1.d0/(16.d0*pi**2)*&
	(&
	 +lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mch,mch)&
	 +lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mw,mw)&
	 +2.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mch,mw)&
	 +2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mA,mA)&
	 +2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mz,mz)&
	 +lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mA,mz)&
	 +18.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mbH,mbH)&
	 +2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mh,mh)&
	 +4.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mbH,mh)&
	)
	
	end function
!=======================================================
!     CP-odd Higgs/NG boson two point functions
!=======================================================
	complex (kind(0d0)) function PiAA_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PiAA_F=&
	-Nc*4.d0*mt**2/(16.d0*pi**2*vev**2)&
	*(&
	 +a0f(mt)-qsq/2.d0*b0f(qsq,mt,mt)&
	)*xiu_A(alpha,beta,n)**2&
! 
	-Nc*4.d0*mb**2/(16.d0*pi**2*vev**2)&
	*(&
	 +a0f(mb)-qsq/2.d0*b0f(qsq,mb,mb)&
	)*xid_A(alpha,beta,n)**2&
!
	-Nc*4.d0*mc**2/(16.d0*pi**2*vev**2)&
	*(&
		+a0f(mc)-qsq/2.d0*b0f(qsq,mc,mc)&
	)*xiu_A(alpha,beta,n)**2&
! 
	-Nc*4.d0*ms**2/(16.d0*pi**2*vev**2)&
	*(&
	 +a0f(ms)-qsq/2.d0*b0f(qsq,ms,ms)&
	)*xid_A(alpha,beta,n)**2&
!
	-4.d0*mtau**2/(16.d0*pi**2*vev**2)&
	*(&
	 +a0f(mtau)-qsq/2.d0*b0f(qsq,mtau,mtau)&
	)*xil_A(alpha,beta,n)**2&
!
	-4.d0*mmu**2/(16.d0*pi**2*vev**2)&
	*(&
	 +a0f(mmu)-qsq/2.d0*b0f(qsq,mmu,mmu)&
	)*xil_A(alpha,beta,n)**2

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiAA_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	PiAA_B=&
	+1.d0/(16.d0*pi**2)*&
	(&
		+2.d0*g**2*a0f(mW)+gz**2*a0f(mZ)-(2.d0*g**2*mW**2+gz**2*mZ**2)/2.d0&
		-g**2/2.d0*(2.d0*a0f(mW)-a0f(mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*b0f(qsq,mW,mch))&
		-gz**2/4.d0*cos(beta-alpha)**2*(2.d0*a0f(mZ)-a0f(mh)+(2.d0*mh**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mh))&
		-gz**2/4.d0*sin(beta-alpha)**2*(2.d0*a0f(mZ)-a0f(mbH)+(2.d0*mbH**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mbH))&
	)&
! 
	+1.d0/(16.d0*pi**2)*&
	(&
		-2.d0*lam_HpHmAA(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
		-12.d0*lam_AAAA(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-2.d0*lam_AAbhbh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-2.d0*lam_AAhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)&
		-2.d0*lam_GpGmAA(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-2.d0*lam_GGAA(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		+2.d0*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*conjg(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))*b0f(qsq,mch,mw)&
		+4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mA,mh)&
		+4.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mA,mbH)&
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mh,mz)&
		+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mbH,mz)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiAG_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PiAG_F=&
	-8.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mt)&
		-qsq/2.d0*b0f(qsq,mt,mt)&
	)*&
	xiu_A(alpha,beta,n)*It&
	!
	-8.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mc)&
		-qsq/2.d0*b0f(qsq,mc,mc)&
	)*&
	xiu_A(alpha,beta,n)*It&	
	!
	-8.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mb)&
		-qsq/2.d0*b0f(qsq,mb,mb)&
	)*&
	(-xid_A(alpha,beta,n))*Ib&
	!
	-8.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f(ms)&
		-qsq/2.d0*b0f(qsq,ms,ms)&
	)*&
	(-xid_A(alpha,beta,n))*Ib&
	!
	-8.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mtau)&
		-qsq/2.d0*b0f(qsq,mtau,mtau)&
	)*&
	(-xil_A(alpha,beta,n))*Ie&
	!
	-8.d0*mmu**2/(16.d0*pi**2*vev**2)*&
	(&
		a0f(mmu)&
		-qsq/2.d0*b0f(qsq,mmu,mmu)&
	)*&
	(-xil_A(alpha,beta,n))*Ie

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiAG_F_div(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PiAG_F_div =&
	-8.d0*mt**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f_div(mt)&
		-qsq/2.d0*div&
	)*&
	xiu_A(alpha,beta,n)*It&
	!
	-8.d0*mc**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f_div(mc)&
		-qsq/2.d0*div&
	)*&
	xiu_A(alpha,beta,n)*It&	
	!
	-8.d0*mb**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f_div(mb)&
		-qsq/2.d0*div&
	)*&
	(-xid_A(alpha,beta,n))*Ib&
	!
	-8.d0*ms**2*3.d0/(16.d0*pi**2*vev**2)*&
	(&
		a0f_div(ms)&
		-qsq/2.d0*div&
	)*&
	(-xid_A(alpha,beta,n))*Ib&
	!
	-8.d0*mtau**2/(16.d0*pi**2*vev**2)*&
	(&
		a0f_div(mtau)&
		-qsq/2.d0*div&
	)*&
	(-xil_A(alpha,beta,n))*Ie&
	!
	-8.d0*mmu**2/(16.d0*pi**2*vev**2)*&
	(&
		a0f_div(mmu)&
		-qsq/2.d0*div&
	)*&
	(-xil_A(alpha,beta,n))*Ie

	end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiAG_F(qsq,alpha,beta,n)
	double precision, intent(in):: qsq,alpha,beta
	integer, intent(in):: n

	tildePiAG_F =&
		PiAG_F(qsq,alpha,beta,n)&
		+sin(beta-alpha)*TbH_F(alpha,beta,n)/vev&
		-cos(beta-alpha)*Th_F(alpha,beta,n)/vev

	end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiAG_F_div(qsq,alpha,beta,n)
	double precision, intent(in):: qsq,alpha,beta
	integer, intent(in):: n

	tildePiAG_F_div =&
		PiAG_F_div(qsq,alpha,beta,n)&
		+sin(beta-alpha)*TbH_F_div(alpha,beta,n)/vev&
		-cos(beta-alpha)*Th_F_div(alpha,beta,n)/vev

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiAG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	PiAG_B=&
	+1.d0/(16.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)&
	*(&
		-gz**2/4.d0*(2.d0*a0f(mZ)-a0f(mh)+(2.d0*mh**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mh))&
		+gz**2/4.d0*(2.d0*a0f(mZ)-a0f(mbH)+(2.d0*mbH**2-mZ**2+2.d0*qsq)*b0f(qsq,mZ,mbH))&
	)&
	!
	+1.d0/(16.d0*pi**2)&
	*(&
		-lam_GpGmAG(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-3.d0*lam_AGGG(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		-lam_HpHmAG(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
		-3.d0*lam_AAAG(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-lam_AGbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
      -lam_AGhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mA,mh)&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mA,mbH)&
		+2.d0*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mz,mh)&
		+2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mz,mbH)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiAG_B_div(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	
	PiAG_B_div =&
	+1.d0/(16.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)&
	*(&
		-gz**2/4.d0*(2.d0*a0f_div(mZ)-a0f_div(mh)+(2.d0*mh**2-mZ**2+2.d0*qsq)*div)&
		+gz**2/4.d0*(2.d0*a0f_div(mZ)-a0f_div(mbH)+(2.d0*mbH**2-mZ**2+2.d0*qsq)*div)&
	)&
	!
	+1.d0/(16.d0*pi**2)&
	*(&
		-lam_GpGmAG(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mw)&
		-3.d0*lam_AGGG(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mz)&
		-lam_HpHmAG(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mch)&
		-3.d0*lam_AAAG(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mA)&
		-lam_AGbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mbH)&
		-lam_AGhh(mch,mA,mbH,bmsq,alpha,beta)*a0f_div(mh)&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*div&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*div&
		+2.d0*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*div&
		+2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*div&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiAG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	tildePiAG_B =&
		PiAG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+sin(beta-alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		-cos(beta-alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)/vev
	 	
	end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiAG_B_div(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	
	tildePiAG_B_div =&
		PiAG_B_div(qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+sin(beta-alpha)*TbH_B_div(mch,mA,mbH,bmsq,alpha,beta)/vev&
		-cos(beta-alpha)*Th_B_div(mch,mA,mbH,bmsq,alpha,beta)/vev
		
	end function
!---------------------------------------------
	complex (kind(0d0)) function Del_PiAG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	! The expression for (Landau Gauge - Feynman Gauge)
	! Del_PiAG_B + PiAG_B gives the AG mixing in the Ladau-Gauge, and if we take qsq = 0, it becomes 0. 
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	Del_PiAG_B =&
	gz**2/(64.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)/mz**2&
	*(&
		+ (qsq*(qsq-2.d0*mh**2 )  + mh**2* mA**2)*(B0f(qsq,mz,mh)  - B0f(qsq,0.d0,mh )) &
		- (qsq*(qsq-2.d0*mbH**2)  + mbH**2*mA**2)*(B0f(qsq,mz,mbH) - B0f(qsq,0.d0,mbH)) &
	) 

	end function
!---------------------------------------------
	complex (kind(0d0)) function GamAZ_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	GamAZ_B= 1.d0/(16.d0*pi**2)*(& 
        +2.d0/vev*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(2.d0*b1f(qsq,mA,mbH)+b0f(qsq,mA,mbH)) &
        -2.d0/vev*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(2.d0*b1f(qsq,mA,mh)+b0f(qsq,mA,mh)) &
        -1.d0/vev*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(2.d0*b1f(qsq,mz,mbH)+b0f(qsq,mz,mbH)) &
        -1.d0/vev*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(2.d0*b1f(qsq,mz,mh)+b0f(qsq,mz,mh)) &
       +gz**2/2.d0*sin(beta-alpha)*cos(beta-alpha)*&
         ( b1f(qsq,mz,mbH)+2.d0*b0f(qsq,mz,mbH)-( b1f(qsq,mz,mh)+2.d0*b0f(qsq,mz,mh) ) )&
        )
	 	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiAA_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta
 
	dPiAA_F=&
	-Nc*4.d0*mt**2/(16.d0*pi**2*vev**2)&
	*(&
	 -1.d0/2.d0*b0f(qsq,mt,mt)-qsq/2.d0*db0f(qsq,mt,mt)&
	)*xiu_A(alpha,beta,n)**2&
! 
	-Nc*4.d0*mb**2/(16.d0*pi**2*vev**2)&
	*(&
	-1.d0/2.d0*b0f(qsq,mb,mb)-qsq/2.d0*db0f(qsq,mb,mb)&
	)*xid_A(alpha,beta,n)**2&
! 
	-Nc*4.d0*mc**2/(16.d0*pi**2*vev**2)&
	*(&
	-1.d0/2.d0*b0f(qsq,mc,mc)-qsq/2.d0*db0f(qsq,mc,mc)&
	)*xiu_A(alpha,beta,n)**2&
! 
	-Nc*4.d0*ms**2/(16.d0*pi**2*vev**2)&
	*(&
	-1.d0/2.d0*b0f(qsq,ms,ms)-qsq/2.d0*db0f(qsq,ms,ms)&
	)*xid_A(alpha,beta,n)**2&
! 
	-4.d0*mtau**2/(16.d0*pi**2*vev**2)&
	*(&
	-1.d0/2.d0*b0f(qsq,mtau,mtau)-qsq/2.d0*db0f(qsq,mtau,mtau)&
	)*xil_A(alpha,beta,n)**2&
! 
	-4.d0*mmu**2/(16.d0*pi**2*vev**2)&
	*(&
	-1.d0/2.d0*b0f(qsq,mmu,mmu)-qsq/2.d0*db0f(qsq,mmu,mmu)&
	)*xil_A(alpha,beta,n)**2

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiAA_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
 
	dPiAA_B=&
	 1.d0/(16.d0*pi**2)*&
	(&
		-g**2/2.d0*(2.d0*b0f(qsq,mW,mch)+(2.d0*mch**2-mW**2+2.d0*qsq)*db0f(qsq,mW,mch))&
		-gz**2/4.d0*cos(beta-alpha)**2*(2.d0*b0f(qsq,mZ,mh)+(2.d0*mh**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,mh))&
		-gz**2/4.d0*sin(beta-alpha)**2*(2.d0*b0f(qsq,mZ,mbH)+(2.d0*mbH**2-mZ**2+2.d0*qsq)*db0f(qsq,mZ,mbH))&
	)&
! 
	+1.d0/(16.d0*pi**2)*&
	(&
	+2.d0*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*conjg(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))*db0f(qsq,mch,mw)&
	+4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mA,mh)&
	+4.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mA,mbH)&
	+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mh,mz)&
	+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mbH,mz)&
	)
	 
	end function
!=======================================================
!     Charged Higgs/NG bosons two point functions
!=======================================================
	complex (kind(0d0)) function PiHpHm_fermion(qsq,alpha,beta,n,mfp,mfm)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta,mfp,mfm

	double precision:: gHp_L,gHp_R

	if (mfp == mt .or. mfp == mc) then
		gHp_L = -sqrt(2.d0)*mfp*xiu_A(alpha,beta,n)/vev
	elseif (mfp == m0) then
		gHp_L = 0.d0
	endif

	if (mfm == mb .or. mfm == ms) then
		gHp_R = sqrt(2.d0)*mfm*xid_A(alpha,beta,n)/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		gHp_R = sqrt(2.d0)*mfm*xil_A(alpha,beta,n)/vev
	endif

	PiHpHm_fermion=&
	-1.d0/(16.d0*pi**2)*(&
		(gHp_L**2+gHp_R**2)*(a0f(mfp)+a0f(mfm)+(mfp**2+mfm**2-qsq)*b0f(qsq,mfp,mfm))&
		+4.d0*mfp*mfm*gHp_L*gHp_R*b0f(qsq,mfp,mfm)&
	)
 
	end function
!---------------------------------------------
	complex (kind(0d0)) function PiHpHm_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PiHpHm_F =&
		+Nc*PiHpHm_fermion(qsq,alpha,beta,n,mt,mb)&
		+Nc*PiHpHm_fermion(qsq,alpha,beta,n,mc,ms)&
		+PiHpHm_fermion(qsq,alpha,beta,n,m0,mtau)&
		+PiHpHm_fermion(qsq,alpha,beta,n,m0,mmu)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiHpHm_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	PiHpHm_B=&
	+1.d0/(16.d0*pi**2)*(&
		-g**2/4.d0*cos(beta-alpha)**2&
			*(2.d0*a0f(mW)-a0f(mh)+(2.d0*qsq+2.d0*mh**2-mw**2)*b0f(qsq,mW,mh))&
		-g**2/4.d0*sin(beta-alpha)**2&
			*(2.d0*a0f(mW)-a0f(mbH)+(2.d0*qsq+2.d0*mbH**2-mw**2)*b0f(qsq,mW,mbH))&
		-g**2/4.d0&
			*(2.d0*a0f(mW)-a0f(mA)+(2.d0*qsq+2.d0*mA**2-mw**2)*b0f(qsq,mW,mA))&
		-gz**2/4.d0*(cw**2-sw**2)**2&
			*(2.d0*a0f(mZ)-a0f(mch)+(2.d0*qsq+2.d0*mch**2-mZ**2)*b0f(qsq,mZ,mch))&
		-(g*sw)**2&
			*(2.d0*a0f(mphoton)-a0f(mch)+(2.d0*qsq+2.d0*mch**2-mphoton**2)*b0f(qsq,mphoton,mch))*QED&
		!
		+2.d0*g**2*(a0f(mW)-mW**2/2.d0)&
		+gz**2*(cw**2-sw**2)**2*(a0f(mZ)-mZ**2/2.d0)&
		+4.d0*(g*sw)**2*(a0f(mphoton)-mphoton**2/2.d0)*QED&
		!
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mch,mh)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mw,mh)&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mch,mbH)&
		+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*b0f(qsq,mw,mbH)&
		+abs(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))**2*b0f(qsq,mw,mA)&
		-lam_HpHmhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)&
		-lam_HpHmGG(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		-lam_HpHmGpGm(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-lam_HpHmbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-lam_HpHmAA(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-4.d0*lam_HpHmHpHm(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiHpHm_fermion(qsq,alpha,beta,n,mfp,mfm)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta,mfp,mfm
	double precision:: gHp_L,gHp_R

	if (mfp == mt .or. mfp == mc) then
		gHp_L = -sqrt(2.d0)*mfp*xiu_A(alpha,beta,n)/vev
	elseif (mfp == m0) then
		gHp_L = 0.d0
	endif

	if (mfm == mb .or. mfm == ms) then
		gHp_R = sqrt(2.d0)*mfm*xid_A(alpha,beta,n)/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		gHp_R = sqrt(2.d0)*mfm*xil_A(alpha,beta,n)/vev
	endif

	dPiHpHm_fermion=&
	-1.d0/(16.d0*pi**2)*(&
		-(gHp_L**2+gHp_R**2)*b0f(qsq,mfp,mfm)&
		+(gHp_L**2+gHp_R**2)*(mfp**2+mfm**2-qsq)*db0f(qsq,mfp,mfm)&
		+4.d0*mfp*mfm*gHp_L*gHp_R*db0f(qsq,mfp,mfm)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiHpHm_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta
 
	dPiHpHm_F=&
		+Nc*dPiHpHm_fermion(qsq,alpha,beta,n,mt,mb)&
		+Nc*dPiHpHm_fermion(qsq,alpha,beta,n,mc,ms)&
		+dPiHpHm_fermion(qsq,alpha,beta,n,m0,mtau)&
		+dPiHpHm_fermion(qsq,alpha,beta,n,m0,mmu)

	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiHpHm_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	dPiHpHm_B=&
	1.d0/(16.d0*pi**2)*(&
		-g**2/4.d0*cos(beta-alpha)**2*(2.d0*b0f(qsq,mW,mh)+(2.d0*qsq+2.d0*mh**2-mw**2)*db0f(qsq,mW,mh))&
		-g**2/4.d0*sin(beta-alpha)**2*(2.d0*b0f(qsq,mW,mbH)+(2.d0*qsq+2.d0*mbH**2-mw**2)*db0f(qsq,mW,mbH))&
		-g**2/4.d0*(2.d0*b0f(qsq,mW,mA)+(2.d0*qsq+2.d0*mA**2-mw**2)*db0f(qsq,mW,mA))&
		-gz**2/4.d0*(cw**2-sw**2)**2*(2.d0*b0f(qsq,mZ,mch)+(2.d0*qsq+2.d0*mch**2-mZ**2)*db0f(qsq,mZ,mch))&
		-(g*sw)**2*(2.d0*b0f(qsq,mphoton,mch)+(2.d0*qsq+2.d0*mch**2-mphoton**2)*db0f(qsq,mphoton,mch))*QED&
		!
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mch,mh)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mw,mh)&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mch,mbH)&
		+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*db0f(qsq,mw,mbH)&
		+lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*conjg(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))*db0f(qsq,mw,mA)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiHpGm_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PiHpGm_F=&
	-Nc*2.d0/(16.d0*pi**2*vev**2)&
	*(&
		(mt**2*xiu_A(alpha,beta,n)+mb**2*xid_A(alpha,beta,n))&
			*(a0f(mt)+a0f(mb)+(mt**2+mb**2-qsq)*b0f(qsq,mt,mb))&
		-2.d0*mt**2*mb**2*(xiu_A(alpha,beta,n)+xid_A(alpha,beta,n))*b0f(qsq,mt,mb)&
		!
		+(mc**2*xiu_A(alpha,beta,n)+ms**2*xid_A(alpha,beta,n))&
			*(a0f(mc)+a0f(ms)+(mc**2+ms**2-qsq)*b0f(qsq,mc,ms))&
		-2.d0*mc**2*ms**2*(xiu_A(alpha,beta,n)+xid_A(alpha,beta,n))*b0f(qsq,mc,ms)&
	)&
	!
	-2.d0/(16.d0*pi**2*vev**2)*&
	mtau**2*xil_A(alpha,beta,n)*(a0f(mtau)+(mtau**2-qsq)*b0f(qsq,m0,mtau))&
	!
	-2.d0/(16.d0*pi**2*vev**2)*&
	mmu**2*xil_A(alpha,beta,n)*(a0f(mmu)+(mmu**2-qsq)*b0f(qsq,m0,mmu))

	end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiHpGm_F(qsq,alpha,beta,n)
	double precision, intent(in):: qsq,alpha,beta
	integer, intent(in):: n

	tildePiHpGm_F =&
		+PiHpGm_F(qsq,alpha,beta,n)&
		+sin(beta-alpha)*TbH_F(alpha,beta,n)/vev&
		-cos(beta-alpha)*Th_F(alpha,beta,n)/vev

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiHpGm_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	PiHpGm_B=&
	1.d0/(16.d0*pi**2)*(&
		-g**2/4.d0*sin(beta-alpha)*cos(beta-alpha)&
			*(2.d0*a0f(mW)-a0f(mh)+(2.d0*qsq+2.d0*mh**2-mW**2)*b0f(qsq,mW,mh))&
		+g**2/4.d0*sin(beta-alpha)*cos(beta-alpha)&
			*(2.d0*a0f(mW)-a0f(mbH)+(2.d0*qsq+2.d0*mbH**2-mW**2)*b0f(qsq,mW,mbH))&
		!
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mch,mh)&
		+lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mw,mh)&
		+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mch,mbH)&
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*b0f(qsq,mw,mbH)&
		!
		-lam_HpGmhh(mch,mA,mbH,bmsq,alpha,beta)*a0f(mh)&
		-lam_HpGmGG(mch,mA,mbH,bmsq,alpha,beta)*a0f(mz)&
		-2.d0*lam_HpGmGpGm(mch,mA,mbH,bmsq,alpha,beta)*a0f(mw)&
		-lam_HpGmbHbH(mch,mA,mbH,bmsq,alpha,beta)*a0f(mbH)&
		-lam_HpGmAA(mch,mA,mbH,bmsq,alpha,beta)*a0f(mA)&
		-2.d0*lam_HpGmHpHm(mch,mA,mbH,bmsq,alpha,beta)*a0f(mch)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function tildePiHpGm_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	tildePiHpGm_B =&
		+PiHpGm_B(qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+sin(beta-alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		-cos(beta-alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)/vev

	end function
!---------------------------------------------
	complex (kind(0d0)) function rPiHpGm(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n

	rPiHpGm=&
		+tildePiHpGm_F(qsq,alpha,beta,n)&
		+tildePiHpGm_B(qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+2.d0*qsq*del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)&
		+mch**2*(&
			+del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
			-del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiHpW_F(qsq,alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: qsq,alpha,beta

	PiHpW_F =&
	-Nc*4.d0*mW/(16.d0*pi**2*vev**2)*(&
		+mt**2*xiu_A(alpha,beta,n)*(b1f(qsq,mt,mb)+b0f(qsq,mt,mb))&
		-mb**2*xid_A(alpha,beta,n)*b1f(qsq,mt,mb)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function PiHpW_B(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta

	PiHpW_B =&
	g**3*vev/4.d0/(16.d0*pi**2)*sin(beta-alpha)*cos(beta-alpha)*(&
		(b0f(qsq,mh,mW)-b1f(qsq,mh,mW))-(b0f(qsq,mbH,mW)-b1f(qsq,mbH,mW))&
	)&
	!
	+g/(16.d0*pi**2)/2.d0*(&
	-lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*&
		(b0f(qsq,mh,mw)+2.d0*b1f(qsq,mh,mw))&
	-lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*&
		(b0f(qsq,mbH,mw)+2.d0*b1f(qsq,mbH,mw))&
	-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*&
		(b0f(qsq,mh,mch)+2.d0*b1f(qsq,mh,mch))&
	+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*&
		(b0f(qsq,mbH,mch)+2.d0*b1f(qsq,mbH,mch))&
	)

	end function
!====== Fermion two-point functions ========
	complex (kind(0d0)) function Pitt_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitt_S =&
	-1.d0/(16.d0*pi**2)*(&
		QED*2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mt,mphoton)-1.d0)&
		+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mt,mZ)-1.d0)&
		+mt**2/vev**2*(&
			b0f(qsq,mt,mz)&
			+xiu_A(alpha,beta,n)**2*b0f(qsq,mt,mA)&
			-xiu(alpha,beta,n)**2*b0f(qsq,mt,mh)&
			-xiu_H(alpha,beta,n)**2*b0f(qsq,mt,mbH)&
			+2.d0*mb**2/mt**2*b0f(qsq,mb,mw)&
			-2.d0*mb**2/mt**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*b0f(qsq,mb,mch)&
		)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Picc_S =&
	-1.d0/(16.d0*pi**2)*(&
		QED*2.d0*(g*sw)**2*Qt**2*(2.d0*b0f(qsq,mc,mphoton)-1.d0)&
		+2.d0*gz**2*(vt**2-at**2)*(2.d0*b0f(qsq,mc,mZ)-1.d0)&
		+mc**2/vev**2*(&
			b0f(qsq,mc,mz)&
			+xiu_A(alpha,beta,n)**2*b0f(qsq,mc,mA)&
			-xiu(alpha,beta,n)**2*b0f(qsq,mc,mh)&
			-xiu_H(alpha,beta,n)**2*b0f(qsq,mc,mbH)&
			+2.d0*ms**2/mc**2*b0f(qsq,ms,mw)&
			-2.d0*ms**2/mc**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*b0f(qsq,ms,mch)&	
		)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pibb_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qb**2*(2.d0*b0f(qsq,mb,mphoton)-1.d0)&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*b0f(qsq,mb,mZ)-1.d0)&
	+mb**2/vev**2*(b0f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*b0f(qsq,mb,mA)&
	-xid(alpha,beta,n)**2*b0f(qsq,mb,mh)-xid_H(alpha,beta,n)**2*b0f(qsq,mb,mbH)&
	+2.d0*mt**2/mb**2*b0f(qsq,mt,mw)-2.d0*mt**2/mb**2*(-xid_A(alpha,beta,n))*xiu_A(alpha,beta,n)*b0f(qsq,mt,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Piss_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Piss_S= -1.d0/(16.d0*pi**2)*(&
		+QED*2.d0*(g*sw)**2*Qb**2*(2.d0*b0f(qsq,ms,mphoton)-1.d0)&
		+2.d0*gz**2*(vb**2-ab**2)*(2.d0*b0f(qsq,ms,mZ)-1.d0)&
		+ms**2/vev**2*(b0f(qsq,ms,mz)+(-xid_A(alpha,beta,n))**2*b0f(qsq,ms,mA)&
			-xid(alpha,beta,n)**2*b0f(qsq,ms,mh)-xid_H(alpha,beta,n)**2*b0f(qsq,ms,mbH))&
		+2.d0*mc**2/vev**2*b0f(qsq,mc,mw)&
		-2.d0*mc**2/vev**2*(-xid_A(alpha,beta,n))*xiu_A(alpha,beta,n)*b0f(qsq,mc,mch)&	
	  )
	
	end function
!--------------------------------------------- 
	complex (kind(0d0)) function Pitautau_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitautau_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qe**2*(2.d0*b0f(qsq,mtau,mphoton)-1.d0)&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*b0f(qsq,mtau,mZ)-1.d0)&
	+mtau**2/vev**2*(b0f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*b0f(qsq,mtau,mA)&
	-xil(alpha,beta,n)**2*b0f(qsq,mtau,mh)-xil_H(alpha,beta,n)**2*b0f(qsq,mtau,mbH)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pimumu_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pimumu_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qe**2*(2.d0*b0f(qsq,mmu,mphoton)-1.d0)&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*b0f(qsq,mmu,mZ)-1.d0)&
	+mmu**2/vev**2*(b0f(qsq,mmu,mz)+(-xil_A(alpha,beta,n))**2*b0f(qsq,mmu,mA)&
	-xil(alpha,beta,n)**2*b0f(qsq,mmu,mh)-xil_H(alpha,beta,n)**2*b0f(qsq,mmu,mbH)&	
	            )&
	)
	
	end function

!---------------------------------------------
	complex (kind(0d0)) function Pitt_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitt_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mt,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
	+mt**2/vev**2*(xiu(alpha,beta,n)**2*b1f(qsq,mt,mh)+xiu_H(alpha,beta,n)**2*b1f(qsq,mt,mbH)&
	+b1f(qsq,mt,mz)+xiu_A(alpha,beta,n)**2*b1f(qsq,mt,mA)&
	+(mb**2+mt**2)/mt**2*b1f(qsq,mb,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mt**2*b1f(qsq,mb,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Picc_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*b1f(qsq,mc,mphoton)+1.d0)&
	+gz**2*(vt**2+at**2)*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
	+g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
	+mc**2/vev**2*(xiu(alpha,beta,n)**2*b1f(qsq,mc,mh)+xiu_H(alpha,beta,n)**2*b1f(qsq,mc,mbH)&
	+b1f(qsq,mc,mz)+xiu_A(alpha,beta,n)**2*b1f(qsq,mc,mA)&
	+(ms**2+mc**2)/mc**2*b1f(qsq,ms,mw)+(mc**2*xiu_A(alpha,beta,n)**2+ms**2*(-xid_A(alpha,beta,n))**2)/mc**2*b1f(qsq,ms,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pibb_V= -1.d0/(16.d0*pi**2)*(&
		QED*(g*sw)**2*Qb**2*(2.d0*b1f(qsq,mb,mphoton)+1.d0)&
		+gz**2*(vb**2+ab**2)*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
		+g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
		+mb**2/vev**2*(xid(alpha,beta,n)**2*b1f(qsq,mb,mh)+xid_H(alpha,beta,n)**2*b1f(qsq,mb,mbH)&
		+b1f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*b1f(qsq,mb,mA)&
		+(mb**2+mt**2)/mb**2*b1f(qsq,mt,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mb**2*b1f(qsq,mt,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Piss_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Piss_V= -1.d0/(16.d0*pi**2)*(&
		+QED*(g*sw)**2*Qb**2*(2.d0*b1f(qsq,ms,mphoton)+1.d0)&
		+gz**2*(vb**2+ab**2)*(2.d0*b1f(qsq,ms,mZ)+1.d0)&
		+g**2/4.d0*(2.d0*b1f(qsq,mc,mW)+1.d0)&
		+ms**2/vev**2*(xid(alpha,beta,n)**2*b1f(qsq,ms,mh)+xid_H(alpha,beta,n)**2*b1f(qsq,ms,mbH)&
		+b1f(qsq,ms,mz)+(-xid_A(alpha,beta,n))**2*b1f(qsq,ms,mA))&
		+(ms**2+mc**2)/vev**2*b1f(qsq,mc,mw)&
		+(mc**2*xiu_A(alpha,beta,n)**2+ms**2*(-xid_A(alpha,beta,n))**2)/vev**2*b1f(qsq,mc,mch)&
		)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pintnt_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pintnt_V= -1.d0/(16.d0*pi**2)*(&
		+gz**2*(vnu**2+anu**2)*(2.d0*b1f(qsq,m0,mZ)+1.d0)&
		+g**2/4.d0*(2.d0*b1f(qsq,mtau,mW)+1.d0)&
		+mtau**2/vev**2*b1f(qsq,mtau,mw)&
		+(mtau*xil_A(alpha,beta,n))**2/vev**2*b1f(qsq,mtau,mch))

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitautau_V= -1.d0/(16.d0*pi**2)*(&
		QED*(g*sw)**2*Qe**2*(2.d0*b1f(qsq,mtau,mphoton)+1.d0)&
		+gz**2*(ve**2+ae**2)*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
		+g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
		+mtau**2/vev**2*(xil(alpha,beta,n)**2*b1f(qsq,mtau,mh)+xil_H(alpha,beta,n)**2*b1f(qsq,mtau,mbH)&
		+b1f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*b1f(qsq,mtau,mA)&
		+b1f(qsq,m0,mw)+mtau**2*(-xil_A(alpha,beta,n))**2/mtau**2*b1f(qsq,m0,mch)&	        
	)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pinmnm_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pinmnm_V= -1.d0/(16.d0*pi**2)*(&
		+gz**2*(vnu**2+anu**2)*(2.d0*b1f(qsq,m0,mZ)+1.d0)&
		+g**2/4.d0*(2.d0*b1f(qsq,mmu,mW)+1.d0)&
		+mmu**2/vev**2*b1f(qsq,mmu,mw)&
		+(mmu*xil_A(alpha,beta,n))**2/vev**2*b1f(qsq,mmu,mch))

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pimumu_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pimumu_V= -1.d0/(16.d0*pi**2)*(&
		QED*(g*sw)**2*Qe**2*(2.d0*b1f(qsq,mmu,mphoton)+1.d0)&
		+gz**2*(ve**2+ae**2)*(2.d0*b1f(qsq,mmu,mZ)+1.d0)&
		+g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
		+mmu**2/vev**2*(xil(alpha,beta,n)**2*b1f(qsq,mmu,mh)+xil_H(alpha,beta,n)**2*b1f(qsq,mmu,mbH)&
		+b1f(qsq,mmu,mz)+(-xil_A(alpha,beta,n))**2*b1f(qsq,mmu,mA)&
		+b1f(qsq,m0,mw)+mmu**2*(-xil_A(alpha,beta,n))**2/mmu**2*b1f(qsq,m0,mch)&	        
	)&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pitt_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitt_A= 1.d0/(16.d0*pi**2)*(&
		-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mt,mZ)+1.d0)&
		-g**2/4.d0*(2.d0*b1f(qsq,mb,mW)+1.d0)&
		+(mt**2-mb**2)/vev**2*b1f(qsq,mb,mw)&
		+(mt**2*xiu_A(alpha,beta,n)**2-mb**2*(-xid_A(alpha,beta,n))**2)/vev**2*b1f(qsq,mb,mch)&	
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Picc_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Picc_A= 1.d0/(16.d0*pi**2)*(&
		-2.d0*gz**2*vt*at*(2.d0*b1f(qsq,mc,mZ)+1.d0)&
		-g**2/4.d0*(2.d0*b1f(qsq,ms,mW)+1.d0)&
		+(mc**2-ms**2)/vev**2*b1f(qsq,ms,mw)&
		+(mc**2*xiu_A(alpha,beta,n)**2-ms**2*(-xid_A(alpha,beta,n))**2)/vev**2*b1f(qsq,ms,mch)&	
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Pibb_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pibb_A= 1.d0/(16.d0*pi**2)*(&
		-2.d0*gz**2*vb*ab*(2.d0*b1f(qsq,mb,mZ)+1.d0)&
		-g**2/4.d0*(2.d0*b1f(qsq,mt,mW)+1.d0)&
		+(mb**2-mt**2)/vev**2*b1f(qsq,mt,mw)&
		+(mb**2*(-xid_A(alpha,beta,n))**2-mt**2*xiu_A(alpha,beta,n)**2)/vev**2*b1f(qsq,mt,mch)&	
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Piss_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Piss_A= 1.d0/(16.d0*pi**2)*(&
		-2.d0*gz**2*vb*ab*(2.d0*b1f(qsq,ms,mZ)+1.d0)&
		-g**2/4.d0*(2.d0*b1f(qsq,mc,mW)+1.d0)&
		+(ms**2-mc**2)/vev**2*b1f(qsq,mc,mw)&
		+(ms**2*(-xid_A(alpha,beta,n))**2-mc**2*xiu_A(alpha,beta,n)**2)/vev**2*b1f(qsq,mc,mch)&	
		)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pintnt_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pintnt_A = 1.d0/(16.d0*pi**2)*(&
		-2.d0*gz**2*vnu*anu*(2.d0*b1f(qsq,m0,mZ)+1.d0)&
		-g**2/4.d0*(2.d0*b1f(qsq,mtau,mW)+1.d0)&
		-mtau**2/vev**2*b1f(qsq,mtau,mw)&
		-(mtau*xil_A(alpha,beta,n))**2/vev**2*b1f(qsq,mtau,mch))
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pitautau_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pitautau_A = 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*b1f(qsq,mtau,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mtau**2/vev**2*b1f(qsq,m0,mw)+(mtau**2*(-xil_A(alpha,beta,n))**2)/vev**2*b1f(qsq,m0,mch)&	
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pinmnm_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pinmnm_A = 1.d0/(16.d0*pi**2)*(&
		-2.d0*gz**2*vnu*anu*(2.d0*b1f(qsq,m0,mZ)+1.d0)&
		-g**2/4.d0*(2.d0*b1f(qsq,mmu,mW)+1.d0)&
		-mmu**2/vev**2*b1f(qsq,mmu,mw)&
		-(mmu*xil_A(alpha,beta,n))**2/vev**2*b1f(qsq,mmu,mch))
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Pimumu_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	Pimumu_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*b1f(qsq,mmu,mZ)+1.d0)&
	-g**2/4.d0*(2.d0*b1f(qsq,m0,mW)+1.d0)&
	+mmu**2/vev**2*b1f(qsq,m0,mw)+(mmu**2*(-xil_A(alpha,beta,n))**2)/vev**2*b1f(qsq,m0,mch)&	
	)
	
	end function
!===================================================
	complex (kind(0d0)) function dPitt_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitt_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mt,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mt,mZ))&
	+mt**2/vev**2*(db0f(qsq,mt,mz)+xiu_A(alpha,beta,n)**2*db0f(qsq,mt,mA)&
	-xiu(alpha,beta,n)**2*db0f(qsq,mt,mh)-xiu_H(alpha,beta,n)**2*db0f(qsq,mt,mbH)&
	+2.d0*mb**2/mt**2*db0f(qsq,mb,mw)-2.d0*mb**2/mt**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*db0f(qsq,mb,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPicc_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qt**2*(2.d0*db0f(qsq,mc,mphoton))&
	+2.d0*gz**2*(vt**2-at**2)*(2.d0*db0f(qsq,mc,mZ))&
	+mc**2/vev**2*(db0f(qsq,mc,mz)+xiu_A(alpha,beta,n)**2*db0f(qsq,mc,mA)&
	-xiu(alpha,beta,n)**2*db0f(qsq,mc,mh)-xiu_H(alpha,beta,n)**2*db0f(qsq,mc,mbH)&
	+2.d0*ms**2/mc**2*db0f(qsq,ms,mw)-2.d0*ms**2/mc**2*xiu_A(alpha,beta,n)*(-xid_A(alpha,beta,n))*db0f(qsq,ms,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPibb_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qb**2*(2.d0*db0f(qsq,mb,mphoton))&
	+2.d0*gz**2*(vb**2-ab**2)*(2.d0*db0f(qsq,mb,mZ))&
	+mb**2/vev**2*(db0f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*db0f(qsq,mb,mA)&
	-xid(alpha,beta,n)**2*db0f(qsq,mb,mh)-xid_H(alpha,beta,n)**2*db0f(qsq,mb,mbH)&
	+2.d0*mt**2/mb**2*db0f(qsq,mt,mw)-2.d0*mt**2/mb**2*(-xid_A(alpha,beta,n))*xiu_A(alpha,beta,n)*db0f(qsq,mt,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiss_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPiss_S= -1.d0/(16.d0*pi**2)*(&
		+QED*2.d0*(g*sw)**2*Qb**2*(2.d0*db0f(qsq,ms,mphoton))&
		+2.d0*gz**2*(vb**2-ab**2)*(2.d0*db0f(qsq,ms,mZ))&
		+ms**2/vev**2*(db0f(qsq,ms,mz)+(-xid_A(alpha,beta,n))**2*db0f(qsq,ms,mA)&
			-xid(alpha,beta,n)**2*db0f(qsq,ms,mh)-xid_H(alpha,beta,n)**2*db0f(qsq,ms,mbH))&
		+2.d0*mc**2/vev**2*db0f(qsq,mc,mw)&
		-2.d0*mc**2/vev**2*(-xid_A(alpha,beta,n))*xiu_A(alpha,beta,n)*db0f(qsq,mc,mch)&	
		)
	 
		end function 
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitautau_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qe**2*(2.d0*db0f(qsq,mtau,mphoton))&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*db0f(qsq,mtau,mZ))&
	+mtau**2/vev**2*(db0f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*db0f(qsq,mtau,mA)&
	-xil(alpha,beta,n)**2*db0f(qsq,mtau,mh)-xil_H(alpha,beta,n)**2*db0f(qsq,mtau,mbH)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPimumu_S(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPimumu_S= -1.d0/(16.d0*pi**2)*(&
	QED*2.d0*(g*sw)**2*Qe**2*(2.d0*db0f(qsq,mmu,mphoton))&
	+2.d0*gz**2*(ve**2-ae**2)*(2.d0*db0f(qsq,mmu,mZ))&
	+mmu**2/vev**2*(db0f(qsq,mmu,mz)+(-xil_A(alpha,beta,n))**2*db0f(qsq,mmu,mA)&
	-xil(alpha,beta,n)**2*db0f(qsq,mmu,mh)-xil_H(alpha,beta,n)**2*db0f(qsq,mmu,mbH)&	
	            )&
	)
	
	end function

!---------------------------------------------
	complex (kind(0d0)) function dPitt_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitt_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mt,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mt,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+mt**2/vev**2*(xiu(alpha,beta,n)**2*db1f(qsq,mt,mh)+xiu_H(alpha,beta,n)**2*db1f(qsq,mt,mbH)&
	+db1f(qsq,mt,mz)+xiu_A(alpha,beta,n)**2*db1f(qsq,mt,mA)&
	+(mb**2+mt**2)/mt**2*db1f(qsq,mb,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mt**2*db1f(qsq,mb,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPicc_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qt**2*(2.d0*db1f(qsq,mc,mphoton))&
	+gz**2*(vt**2+at**2)*(2.d0*db1f(qsq,mc,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+mc**2/vev**2*(xiu(alpha,beta,n)**2*db1f(qsq,mc,mh)+xiu_H(alpha,beta,n)**2*db1f(qsq,mc,mbH)&
	+db1f(qsq,mc,mz)+xiu_A(alpha,beta,n)**2*db1f(qsq,mc,mA)&
	+(ms**2+mc**2)/mc**2*db1f(qsq,ms,mw)+(mc**2*xiu_A(alpha,beta,n)**2+ms**2*(-xid_A(alpha,beta,n))**2)/mc**2*db1f(qsq,ms,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPibb_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qb**2*(2.d0*db1f(qsq,mb,mphoton))&
	+gz**2*(vb**2+ab**2)*(2.d0*db1f(qsq,mb,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+mb**2/vev**2*(xid(alpha,beta,n)**2*db1f(qsq,mb,mh)+xid_H(alpha,beta,n)**2*db1f(qsq,mb,mbH)&
	+db1f(qsq,mb,mz)+(-xid_A(alpha,beta,n))**2*db1f(qsq,mb,mA)&
	+(mb**2+mt**2)/mb**2*db1f(qsq,mt,mw)+(mt**2*xiu_A(alpha,beta,n)**2+mb**2*(-xid_A(alpha,beta,n))**2)/mb**2*db1f(qsq,mt,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiss_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n
 
	dPiss_V= -1.d0/(16.d0*pi**2)*(&
		+QED*(g*sw)**2*Qb**2*(2.d0*db1f(qsq,ms,mphoton))&
		+gz**2*(vb**2+ab**2)*(2.d0*db1f(qsq,ms,mZ))&
		+g**2/4.d0*(2.d0*db1f(qsq,mc,mW))&
		+ms**2/vev**2*(xid(alpha,beta,n)**2*db1f(qsq,ms,mh)+xid_H(alpha,beta,n)**2*db1f(qsq,ms,mbH)&
			+db1f(qsq,ms,mz)+(-xid_A(alpha,beta,n))**2*db1f(qsq,ms,mA))&
		+(ms**2+mc**2)/vev**2*db1f(qsq,mc,mw)&
		+(mc**2*xiu_A(alpha,beta,n)**2+ms**2*(-xid_A(alpha,beta,n))**2)/vev**2*db1f(qsq,mc,mch)&	
		)
	 
		end function 
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitautau_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qe**2*(2.d0*db1f(qsq,mtau,mphoton))&
	+gz**2*(ve**2+ae**2)*(2.d0*db1f(qsq,mtau,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*(xil(alpha,beta,n)**2*db1f(qsq,mtau,mh)+xil_H(alpha,beta,n)**2*db1f(qsq,mtau,mbH)&
	+db1f(qsq,mtau,mz)+(-xil_A(alpha,beta,n))**2*db1f(qsq,mtau,mA)&
	+db1f(qsq,m0,mw)+(-xil_A(alpha,beta,n))**2*db1f(qsq,m0,mch)&	
	            )&
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPimumu_V(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPimumu_V= -1.d0/(16.d0*pi**2)*(&
	QED*(g*sw)**2*Qe**2*(2.d0*db1f(qsq,mmu,mphoton))&
	+gz**2*(ve**2+ae**2)*(2.d0*db1f(qsq,mmu,mZ))&
	+g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mmu**2/vev**2*(xil(alpha,beta,n)**2*db1f(qsq,mmu,mh)+xil_H(alpha,beta,n)**2*db1f(qsq,mmu,mbH)&
	+db1f(qsq,mmu,mz)+(-xil_A(alpha,beta,n))**2*db1f(qsq,mmu,mA)&
	+db1f(qsq,m0,mw)+(-xil_A(alpha,beta,n))**2*db1f(qsq,m0,mch)&	
	            )&
	)
	
	end function

!---------------------------------------------
	complex (kind(0d0)) function dPitt_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitt_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mt,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mb,mW))&
	+(mt**2-mb**2)/vev**2*db1f(qsq,mb,mw)+(mt**2*xiu_A(alpha,beta,n)**2-mb**2*(-xid_A(alpha,beta,n))**2)/vev**2*db1f(qsq,mb,mch)&	
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPicc_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPicc_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vt*at*(2.d0*db1f(qsq,mc,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,ms,mW))&
	+(mc**2-ms**2)/vev**2*db1f(qsq,ms,mw)+(mc**2*xiu_A(alpha,beta,n)**2-ms**2*(-xid_A(alpha,beta,n))**2)/vev**2*db1f(qsq,ms,mch)&	
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPibb_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPibb_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*vb*ab*(2.d0*db1f(qsq,mb,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,mt,mW))&
	+(mb**2-mt**2)/vev**2*db1f(qsq,mt,mw)+(mb**2*(-xid_A(alpha,beta,n))**2-mt**2*xiu_A(alpha,beta,n)**2)/vev**2*db1f(qsq,mt,mch)&	
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPiss_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n
 
	dPiss_A= 1.d0/(16.d0*pi**2)*(&
		-2.d0*gz**2*vb*ab*(2.d0*db1f(qsq,ms,mZ))&
		-g**2/4.d0*(2.d0*db1f(qsq,mc,mW))&
		+(ms**2-mc**2)/vev**2*db1f(qsq,mc,mw)&
		+(ms**2*(-xid_A(alpha,beta,n))**2-mc**2*xiu_A(alpha,beta,n)**2)/vev**2*db1f(qsq,mc,mch)&	
		)
 
	end function 
!---------------------------------------------
	complex (kind(0d0)) function dPitautau_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPitautau_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*db1f(qsq,mtau,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mtau**2/vev**2*db1f(qsq,m0,mw)+mtau**2*(-xil_A(alpha,beta,n))**2/vev**2*db1f(qsq,m0,mch)&	
	)
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function dPimumu_A(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq
	integer, intent(in):: n

	dPimumu_A= 1.d0/(16.d0*pi**2)*(&
	-2.d0*gz**2*ve*ae*(2.d0*db1f(qsq,mmu,mZ))&
	-g**2/4.d0*(2.d0*db1f(qsq,m0,mW))&
	+mmu**2/vev**2*db1f(qsq,m0,mw)+mmu**2*(-xil_A(alpha,beta,n))**2/vev**2*db1f(qsq,m0,mch)&	
	)
	
	end function
!=========================================================
!     Pinch-Term
!=========================================================
	complex (kind(0d0)) function PibHh_PT(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

   PibHh_PT=&
	+g**2/(32.d0*pi**2)*(2.d0*qsq-mh**2-mbH**2)*sin(beta-alpha)*cos(beta-alpha)&
		*(B0f(qsq,mch,mW) - B0f(qsq,mW,mW) ) &
	+gz**2/(64.d0*pi**2)*(2.d0*qsq-mh**2-mbH**2)*sin(beta-alpha)*cos(beta-alpha)&
		*(B0f(qsq,mA,mZ) - B0f(qsq,mZ,mZ) )
   end function
!---------------------------------------------------------
	complex (kind(0d0)) function PiAG_PT(qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,qsq

	PiAG_PT=&
	+gz**2/(64.d0*pi**2)*(2.d0*qsq-ma**2)*sin(beta-alpha)*cos(beta-alpha)&
		*(B0f(qsq,mz,mbH)-B0f(qsq,mz,mh)) 
	
	end function
!---------------------------------------------------------
	complex (kind(0d0)) function del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
 
	 del_alpha_PT = 1.d0/2.d0/(mbH**2-mh**2)*(&
	 +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
	 )

	end function
!---------------------------------------------------------
	complex (kind(0d0)) function del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
  
	del_beta_PT = -1.d0/(2.d0*mA**2)*(&
	 +PiAG_PT(mA**2,mch,mA,mbH,bmsq,alpha,beta)+PiAG_PT(m0**2,mch,mA,mbH,bmsq,alpha,beta)&
	 )
  
	end function  
!====== hff 1PI  ========================================
	complex (kind(0d0)) function Fhff_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt; af = at; qf = qt; mfp = mb; xiA=xiu_A(alpha,beta,n); xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n); xihp=xid(alpha,beta,n); xibH=xiu_H(alpha,beta,n); xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt; af = at; qf = qt; mfp = ms; xiA=xiu_A(alpha,beta,n); xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n); xihp=xid(alpha,beta,n); xibH=xiu_H(alpha,beta,n); xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb; af = ab; qf = qb; mfp = mt; xiA=xid_A(alpha,beta,n); xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n); xihp=xiu(alpha,beta,n); xibH=xid_H(alpha,beta,n); xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then
		vf = ve; af = ae; qf = qe; mfp = 0.d0
		xih=xil(alpha,beta,n); xiA=xil_A(alpha,beta,n); xibH=xil_H(alpha,beta,n)
		xihp=0.d0; xiAp=0.d0; xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve; af = ae; qf = qe; mfp = 0.d0
		xih=xil(alpha,beta,n); xiA=xil_A(alpha,beta,n); xibH=xil_H(alpha,beta,n)
		xihp=0.d0; xiAp=0.d0; xibHp=0.d0
	endif

	Fhff_S =&
	1.d0/(16.d0*pi**2)*mf/vev*(&
		-4.d0*xih*gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mZ)&
		-QED*4.d0*xih*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
		+xih**3*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
		+xih*xibH**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mbH)&
		-xih*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
		-xih*xiA**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mA)&
		-xihp*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
		-xihp*xiA*xiAp*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mch)&
		!!
		-2.d0*sin(beta-alpha)*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
		-6.d0*xih**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
		-2.d0*xibH**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
		-2.d0*xih*xibH*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev*&
			(c0f(p1sq,p2sq,qsq,mbH,mf,mh) + c0f(p1sq,p2sq,qsq,mh,mf,mbH))&
		+2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
		+2.d0*xiA**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mA,mf,mA)&
		+xiA*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev*&
			(c0f(p1sq,p2sq,qsq,mA,mf,mz)+c0f(p1sq,p2sq,qsq,mz,mf,mA))&
		+lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*2.d0*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
		!!
		+xiA*xiAp*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*2.d0*mfp**2/vev*c0f(p1sq,p2sq,qsq,mch,mfp,mch)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*mfp**2/vev*(xiA+xiAp)*&
			(c0f(p1sq,p2sq,qsq,mw,mfp,mch)+c0f(p1sq,p2sq,qsq,mch,mfp,mw))&
		!!
		-g**2/4.d0*sin(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
		-g**2/4.d0*xiA*cos(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mch)&
		-g**2/4.d0*sin(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
		-g**2/4.d0*xiA*cos(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mch,mfp,mW)&
		-gz**2/8.d0*sin(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
		-gz**2/8.d0*xiA*cos(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mA)&
		-gz**2/8.d0*sin(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
		-gz**2/8.d0*xiA*cos(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mA,mf,mZ)&
	)
	
	end function
!===============================================================================================
	complex (kind(0d0)) function Fhff_P(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then 
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then 
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then 
	vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
	xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then 
	vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
	xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	elseif (mf == mmu) then  ! added from v2
	vf = ve;af = ae;qf = qe;mfp = 0.d0
	xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

    Fhff_P = -1.d0/(16.d0*pi**2)*mf/vev*sin(beta-alpha)*(& 
           -g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW))&
           -2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ))&              
                                       )&
         +1.d0/(16.d0*pi**2)*mf/vev*cos(beta-alpha)*xiA*(& 
           -g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -Chff_SFV(p1sq,p2sq,qsq,mch,mfp,mW))&
           -2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -Chff_SFV(p1sq,p2sq,qsq,mA,mf,mZ))&              
                                       )

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then 
	vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then 
	vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
	xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then 
	vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
	xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	elseif (mf == mmu) then  ! added from v2
	vf = ve;af = ae;qf = qe;mfp = 0.d0
	xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

    Fhff_V1 = -1.d0/(16.d0*pi**2)*(& 
             xih*2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +QED*xih*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
!
             +xih**3*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf))&
             +xih*xibH**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mbH,mf))&
             +xih*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf))&
             +xih*xiA**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mA,mf)&
                             +2.d0*c11f(p1sq,p2sq,qsq,mf,mA,mf))&
             +xihp*mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                              +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
             +xihp*mfp**2/vev**3*(mf**2*xiA**2+mfp**2*xiAp**2)*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                              +2.d0*c11f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
             -sin(beta-alpha)*gz**4*vev*(vf**2 + af**2)*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ) + c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
             -sin(beta-alpha)*g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW) + c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
             +6.d0*xih**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mh,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mh,mf,mh))&
             +2.d0*xibH**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
                            +c11f(p1sq,p2sq,qsq,mbH,mf,mbH))&
             +2.d0*xih*xibH*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mbH,mf,mh)&
                            +c11f(p1sq,p2sq,qsq,mbH,mf,mh) + c0f(p1sq,p2sq,qsq,mh,mf,mbH) + c11f(p1sq,p2sq,qsq,mh,mf,mbH))&
             +2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mz,mf,mz)&
                            +c11f(p1sq,p2sq,qsq,mz,mf,mz))&
             +2.d0*xiA**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mA,mf,mA)&
                            +c11f(p1sq,p2sq,qsq,mA,mf,mA))&
             +1.d0*xiA*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mA,mf,mz)&
                            +c11f(p1sq,p2sq,qsq,mA,mf,mz))&
             +1.d0*xiA*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c0f(p1sq,p2sq,qsq,mz,mf,mA)&
                            +c11f(p1sq,p2sq,qsq,mz,mf,mA))&
             +1.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2+mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                            +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +1.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(xiA**2*mf**2+xiAp**2*mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mch)&
                            +c11f(p1sq,p2sq,qsq,mch,mfp,mch))&
             +1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mw)&
                            +c11f(p1sq,p2sq,qsq,mch,mfp,mw))&
             +1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mch)&
                            +c11f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
             -sin(beta-alpha)*g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -cos(beta-alpha)*g**2/4.d0*mfp**2*xiAp/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                        +c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                   -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   +c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   )&
             -sin(beta-alpha)*gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
             -cos(beta-alpha)*gz**2/8.d0*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                        +c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                   -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   +c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   )&
                                       )

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then 
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then 
	vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then 
	vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
	xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then 
	vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
	xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	elseif (mf == mmu) then  ! added from v2
	vf = ve;af = ae;qf = qe;mfp = 0.d0
	xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

    Fhff_V2 = -1.d0/(16.d0*pi**2)*(& 
             xih*2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                              +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&
            +QED*xih*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mphoton,mf)&
                                      +2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf))&
            +xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                            +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
!
             +xih**3*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mh,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf))&
             +xih*xibH**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
             +xih*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mz,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf))&
             +xih*xiA**2*mf**4/vev**3*(c0f(p1sq,p2sq,qsq,mf,mA,mf)&
                             +2.d0*c12f(p1sq,p2sq,qsq,mf,mA,mf))&
             +xihp*mfp**2/vev**3*(mf**2+mfp**2)*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                              +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
             +xihp*mfp**2/vev**3*(mf**2*xiA**2+mfp**2*xiAp**2)*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                              +2.d0*c12f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
             -sin(beta-alpha)*gz**4*vev*(vf**2 + af**2)*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
             -sin(beta-alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
             +6.d0*xih**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mh,mf,mh))&
             +2.d0*xibH**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mbH,mf,mbH))&
             +2.d0*xih*xibH*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mbH,mf,mh) &
                                                                             + c12f(p1sq,p2sq,qsq,mh,mf,mbH))&
             +2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mz))&
             +2.d0*xiA**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mA,mf,mA))&
             +1.d0*xiA*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mA,mf,mz))&
             +1.d0*xiA*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mA))&
             +1.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2+mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
             +1.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(xiA**2*mf**2+xiAp**2*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mch,mfp,mch))&
             +1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mch,mfp,mw))&
             +1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
             -sin(beta-alpha)*g**2/4.d0*mfp**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                        +c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                   -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                   )&
             -cos(beta-alpha)*g**2/4.d0*mfp**2*xiAp/vev*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                        +c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                   -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   +c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                   )&
             -sin(beta-alpha)*gz**2/8.d0*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                        +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                   -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                   )&
             -cos(beta-alpha)*gz**2/8.d0*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                        +c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                   -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   +c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                   )&
                                       )

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_A1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then 
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then 
	vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then 
	vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
	xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then 
	vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
	xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	elseif (mf == mmu) then  ! added from v2
	vf = ve;af = ae;qf = qe;mfp = 0.d0
	xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

     Fhff_A1 = -1.d0/(16.d0*pi**2)*(& 
             -xih*4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +xihp*mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                    +2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp))&
               +xihp*mfp**2*(mf**2*xiA**2 - mfp**2*xiAp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                                      +2.d0*c11f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
               +sin(beta-alpha)*2.d0*gz**4*vf*af*vev*(c0f(p1sq,p2sq,qsq,mZ,mf,mZ) + c11f(p1sq,p2sq,qsq,mZ,mf,mZ))&
               +sin(beta-alpha)*g**4/4.d0*vev*(c0f(p1sq,p2sq,qsq,mW,mfp,mW) + c11f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
               +lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2-mfp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
                                    +c11f(p1sq,p2sq,qsq,mw,mfp,mw))&
               +lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mch)&
                                     +c11f(p1sq,p2sq,qsq,mch,mfp,mch))&
               +lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(c0f(p1sq,p2sq,qsq,mch,mfp,mw)&
                                     +c11f(p1sq,p2sq,qsq,mch,mfp,mw))&
               +lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(c0f(p1sq,p2sq,qsq,mw,mfp,mch)&
                                     +c11f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
              +sin(beta-alpha)*g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       +c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                        +c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       )&
              +cos(beta-alpha)*g**2*mfp**2*xiAp/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       +c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                        +c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                       )&
              +sin(beta-alpha)*2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       +c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                        +c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       )&
              +cos(beta-alpha)*2.d0*gz**2*vf*af*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       +c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                        +c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                       )&
         )

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_A2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then 
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then 
	vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then 
	vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
	xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then 
	vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
	xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	elseif (mf == mmu) then  ! added from v2
	vf = ve;af = ae;qf = qe;mfp = 0.d0
	xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

     Fhff_A2 = -1.d0/(16.d0*pi**2)*(& 
             -xih*4.d0*gz**2*vf*af*mf**2/vev*(c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf))&   
             -xihp*g**2/2.d0*mfp**2/vev*(c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp))&
              +xihp*mfp**2*(mf**2 - mfp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
                                    +2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
               +xihp*mfp**2*(mf**2*xiA**2 - mfp**2*xiAp**2)/vev**3*(c0f(p1sq,p2sq,qsq,mfp,mch,mfp)&
                                      +2.d0*c12f(p1sq,p2sq,qsq,mfp,mch,mfp))&
!
               +sin(beta-alpha)*2.d0*gz**4*vf*af*vev*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
               +sin(beta-alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
!
               +lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2-mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
               +lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**2*(&
                                     +c12f(p1sq,p2sq,qsq,mch,mfp,mch))&
               +lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(&
                                     +c12f(p1sq,p2sq,qsq,mch,mfp,mw))&
               +lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(&
                                     +c12f(p1sq,p2sq,qsq,mw,mfp,mch))&
!
              +sin(beta-alpha)*g**2*mfp**2/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       +c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                                       -c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                        +c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
                                       )&
              +cos(beta-alpha)*g**2*mfp**2*xiAp/(4.d0*vev)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       +c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                                       -c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                        +c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
                                       )&
              +sin(beta-alpha)*2.d0*gz**2*vf*af*mf**2/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       +c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                                       -c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                        +c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                                       )&
              +cos(beta-alpha)*2.d0*gz**2*vf*af*mf**2*xiA/vev*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       +c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                                       -c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                        +c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                                       )&
         )

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then 
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then 
	vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then 
	vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
	xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then 
	vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
	xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	elseif (mf == mmu) then  ! added from v2
	vf = ve;af = ae;qf = qe;mfp = 0.d0
	xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif


       Fhff_T = -1.d0/(16.d0*pi**2)*(mf/vev)*(&
            xih**3*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf))&
            +xih*xibH**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mbH,mf)-c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
           -xih*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf))&
           -xih*xiA**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mA,mf)-c12f(p1sq,p2sq,qsq,mf,mA,mf))&
           -xihp*2.d0*mfp**2/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
           -xihp*2.d0*mfp**2*xiAp*xiA/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mch,mfp)-c12f(p1sq,p2sq,qsq,mfp,mch,mfp))&
           +sin(beta-alpha)*g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +cos(beta-alpha)*xiA*g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW) )&
           +sin(beta-alpha)*gz**2/8.d0*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
           +cos(beta-alpha)*gz**2*xiA/8.d0*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      +1.d0*c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      +1.d0*c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      -2.d0*c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      )&
                      )
 
	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function Fhff_PT(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
	vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then 
	vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
	xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then 
	vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
	xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == mtau) then 
	vf = ve;af = ae;qf = qe;mfp = 0.d0;xiA=xil_A(alpha,beta,n)
	xih=xil(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	elseif (mf == mmu) then  ! added from v2
	vf = ve;af = ae;qf = qe;mfp = 0.d0
	xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
	xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

    Fhff_PT = 1.d0/(16.d0*pi**2)*(mf/vev)*sin(beta-alpha)*(&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW) )&
           +2.d0*gz**2*af*vf*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
                      )&
                      )&
!
           +1.d0/(16.d0*pi**2)*(mf/vev)*cos(beta-alpha)*xiA*(&
           +g**2/4.d0*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW) )&
           +2.d0*gz**2*af*vf*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      +2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
                      -1.d0*c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      -1.d0*c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      +2.d0*c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
                      )&
                      )

 
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam_hhh_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n
	double precision:: p12
	p12 = 1.d0/2.d0*(qsq-p1sq-p2sq)

	Gam_hhh_F = &
      -xiu(alpha,beta,n)**3*8.d0*mt**4*nc/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
      +(&
         ( 4.d0*mt**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mt,mt,mt)&
        )&
      )&
! 
      -xiu(alpha,beta,n)**3*8.d0*mc**4*nc/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
      +(&
         ( 4.d0*mc**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mc,mc,mc)&
        )&
      )&
!
      -xid(alpha,beta,n)**3*8.d0*mb**4*nc/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
      +(&
         ( 4.d0*mb**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mb,mb,mb)&
      )&
      )&
! 
      -xil(alpha,beta,n)**3*8.d0*mtau**4/(16.d0*pi**2)/vev**3*&
      (&
       b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
      +(&
         ( 4.d0*mtau**2-qsq+(qsq-p1sq-p2sq)/2.d0 )*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau)&
      )&
      )
	
	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hhh_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	Gam_hhh_B = &
      1.d0/(16.d0*pi**2)*(&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
 	+8.d0*g**3*mw**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mW,mW,mW)&
 	+4.d0*gz**3*mZ**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mZ,mZ,mZ)&
 	-1.d0/2.d0*g**3*mW**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
 	-1.d0/4.d0*gz**3*mZ**3*sin(beta-alpha)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&	
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       -1.d0/2.d0*sin(beta-alpha)**3*g**3*mw*Chhh_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
       -1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)**2*g**3*mw*Chhh_SVV(p1sq,p2sq,qsq,mch,mW,mW)&
       -1.d0/4.d0*sin(beta-alpha)**3*gz**3*mz*Chhh_SVV(p1sq,p2sq,qsq,mz,mZ,mZ)&
       -1.d0/4.d0*sin(beta-alpha)*cos(beta-alpha)**2*gz**3*mz*Chhh_SVV(p1sq,p2sq,qsq,mA,mZ,mZ)&
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       +1.d0/2.d0*sin(beta-alpha)**2*g**2*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
       +1.d0/2.d0*cos(beta-alpha)**2*g**2*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mW,mch,mch)&
       +1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*&
 		(Chhh_VSS(p1sq,p2sq,qsq,mW,mw,mch) + Chhh_VSS(p1sq,p2sq,qsq,mW,mch,mw) )&
       +1.d0/2.d0*sin(beta-alpha)**2*gz**2*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mZ,mz,mz)&
       +1.d0/2.d0*cos(beta-alpha)**2*gz**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*Chhh_VSS(p1sq,p2sq,qsq,mZ,mA,mA)&
       +1.d0/4.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*&
 		( Chhh_VSS(p1sq,p2sq,qsq,mZ,mz,mA) + Chhh_VSS(p1sq,p2sq,qsq,mZ,mA,mz) )&
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       -2.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
       -2.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mch,mch,mch)&
       -8.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
       -8.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mA,mA,mA)&
       -8.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mbH,mbH,mbH)&
       -216.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
       -2.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mw,mch,mch)+c0f(p1sq,p2sq,qsq,mch,mw,mch)+c0f(p1sq,p2sq,qsq,mch,mch,mw) )&
       -2.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mch,mw,mw)+c0f(p1sq,p2sq,qsq,mw,mch,mw)+c0f(p1sq,p2sq,qsq,mw,mw,mch) )&
       -2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mz,mA,mA)+c0f(p1sq,p2sq,qsq,mA,mz,mA)+c0f(p1sq,p2sq,qsq,mA,mA,mz) )&
       -2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mA,mz,mz)+c0f(p1sq,p2sq,qsq,mz,mA,mz)+c0f(p1sq,p2sq,qsq,mz,mz,mA) )&
       -8.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mh,mbH,mbH)+c0f(p1sq,p2sq,qsq,mbH,mbH,mh)+c0f(p1sq,p2sq,qsq,mbH,mh,mbH) )&
       -24.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)**2*(&
 	c0f(p1sq,p2sq,qsq,mh,mh,mbH)+c0f(p1sq,p2sq,qsq,mh,mbH,mh)+c0f(p1sq,p2sq,qsq,mbH,mh,mh) )&
!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
       +2.d0*sin(beta-alpha)*g**3*mw*(b0f(p1sq,mW,mW)+b0f(p2sq,mW,mW)+b0f(qsq,mW,mW))-3.d0*g**3*mW*sin(beta-alpha)&
       +sin(beta-alpha)*gz**3*mz*(b0f(p1sq,mZ,mZ)+b0f(p2sq,mZ,mZ)+b0f(qsq,mZ,mZ))-3.d0/2.d0*gz**3*mZ*sin(beta-alpha)&
       +2.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_GpGmhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw)+b0f(qsq,mw,mw)  )&
       +2.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mch,mch)+b0f(p2sq,mch,mch)+b0f(qsq,mch,mch)  )&
       +4.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mch,mw)+b0f(p2sq,mch,mw)+b0f(qsq,mch,mw)  )&
       +4.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*lam_GGhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz)+b0f(qsq,mz,mz)  )&
       +4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mA,mA)+b0f(p2sq,mA,mA)+b0f(qsq,mA,mA)  )&
       +2.d0*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mA,mz)+b0f(p2sq,mA,mz)+b0f(qsq,mA,mz)  )&
       +4.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mbH,mbH)+b0f(p2sq,mbH,mbH)+b0f(qsq,mbH,mbH)  )&
       +12.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHhhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mh,mbH)+b0f(p2sq,mh,mbH)+b0f(qsq,mh,mbH)  )&
       +72.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*lam_hhhh(mch,mA,mbH,bmsq,alpha,beta)*&
        ( b0f(p1sq,mh,mh)+b0f(p2sq,mh,mh)+b0f(qsq,mh,mh)  )&
        )

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam1_hZZ_F = xiu(alpha,beta,n)*nc*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mt)&
                   +xiu(alpha,beta,n)*nc*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mb)&
                   +xil(alpha,beta,n)*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mtau)
	
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam2_hZZ_F =  xiu(alpha,beta,n)*nc*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mt)&
                   +xiu(alpha,beta,n)*nc*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mb)&
                   +xil(alpha,beta,n)*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mtau)
	
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam3_hZZ_F = xiu(alpha,beta,n)*nc*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mt)&
                   +xiu(alpha,beta,n)*nc*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mb)&
                   +xil(alpha,beta,n)*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mtau)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam1_hZZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)  
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam1_hZZ_B =1.d0/(16.d0*pi**2)*(&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +sin(beta-alpha)*2.d0*g**3*mw*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&		! W-W-W
	 -2.d0*sin(beta-alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mw,mw)&		! c+-c+-c+
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +sin(beta-alpha)*g**3*mw*sw**2*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)&		! G+-W-W
	 +sin(beta-alpha)*g**3*mw*sw**2*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&	 	! W-W-G+
	 -sin(beta-alpha)*2.d0*g**3*mw**3/cw**2*sw**4*c0f(p1sq,p2sq,qsq,mW,mw,mW)&	! W-G+-W
	 -sin(beta-alpha)**3*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mh,mZ)&			! Z-h-Z
	 -sin(beta-alpha)*cos(beta-alpha)**2*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mbH,mZ)&	! Z-H-Z
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*g**3*mw/cw**2*(cw**2-sw**2)*sw**2*&
	   ( c24f(p1sq,p2sq,qsq,mW,mw,mw)+c24f(p1sq,p2sq,qsq,mw,mw,mW) )&		! G+-G+-W + W-G+-G+
	 +sin(beta-alpha)**3*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mz,mh,mZ)+c24f(p1sq,p2sq,qsq,mZ,mh,mz))&			! G0-h-Z + Z-h-G0
	 +sin(beta-alpha)*cos(beta-alpha)**2*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mA,mh,mZ)+c24f(p1sq,p2sq,qsq,mZ,mh,mA))&	                ! A-h-Z + Z-h-A
	 +sin(beta-alpha)*cos(beta-alpha)**2*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mz,mbH,mZ)+c24f(p1sq,p2sq,qsq,mZ,mbH,mz))&               ! G0-H-Z + Z-H-G0
	 -sin(beta-alpha)*cos(beta-alpha)**2*gz**3/2.d0*mz*&
	   (c24f(p1sq,p2sq,qsq,mA,mbH,mZ)+c24f(p1sq,p2sq,qsq,mZ,mbH,mA))&               ! A-H-Z + Z-H-A
	 +2.d0*gz**2*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*&
	    mw**2*sw**4*c0f(p1sq,p2sq,qsq,mw,mW,mw)&					! G+-W-G+
	 +6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*&
	    gz**2*mz**2*c0f(p1sq,p2sq,qsq,mh,mZ,mh)&					! h-Z-h
	 +2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*&
	    gz**2*mz**2*c0f(p1sq,p2sq,qsq,mbH,mZ,mbH)&					! H-Z-H
	 +2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*&
	    gz**2*mz**2*(c0f(p1sq,p2sq,qsq,mbH,mZ,mh)+c0f(p1sq,p2sq,qsq,mh,mZ,mbH))&	! H-Z-h + h-Z-H
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -2.d0*gz**2*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*&
	   (cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mw,mw,mw)&				! G+-G+-G+
	 -2.d0*gz**2*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*&
	   (cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mch,mch,mch)&				! H+-H+-H+
	 -sin(beta-alpha)**2*6.d0*gz**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mh,mz,mh)&						! h-G0-h
	 -cos(beta-alpha)**2*2.d0*gz**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mbH,mz,mbH)&						! H-G0-H
	 -cos(beta-alpha)*sin(beta-alpha)*2.d0*gz**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mh,mz,mbH)+c24f(p1sq,p2sq,qsq,mbH,mz,mh) )&	! h-G0-H + H-G0-h
	 -cos(beta-alpha)**2*6.d0*gz**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mh,mA,mh)&						! h-A-h
	 -sin(beta-alpha)**2*2.d0*gz**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mbH,mA,mbH)&						! H-A-H
	 +cos(beta-alpha)*sin(beta-alpha)*2.d0*gz**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mh,mA,mbH)+c24f(p1sq,p2sq,qsq,mbH,mA,mh) )&	! h-A-H + H-A-h
!
	 -sin(beta-alpha)**2*2.d0*gz**2*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mz,mh,mz)&						! G0-h-G0
	 -cos(beta-alpha)**2*2.d0*gz**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mA,mh,mA)&						! A-h-A
	 -cos(beta-alpha)*sin(beta-alpha)*gz**2*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mA,mh,mz)+c24f(p1sq,p2sq,qsq,mz,mh,mA) )&		! A-h-G0 + G0-h-A
!
	 -cos(beta-alpha)**2*2.d0*gz**2*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mz,mbH,mz)&						! G0-H-G0
	 -sin(beta-alpha)**2*2.d0*gz**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*&
		c24f(p1sq,p2sq,qsq,mA,mbH,mA)&						! A-H-A
	 +cos(beta-alpha)*sin(beta-alpha)*gz**2*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*&
		( c24f(p1sq,p2sq,qsq,mA,mbH,mz)+c24f(p1sq,p2sq,qsq,mz,mbH,mA) )&	! A-H-G0 + G0-H-A
!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*6.d0*g**3*cw**2*mW*b0f(qsq,mW,mW)&
	 +sin(beta-alpha)*4.d0*g**3*cw**2*mW&						! W-W
	 +1.d0/2.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*gz**2*(cw**2-sw**2)**2*b0f(qsq,mw,mw)&	! G+-G+
	 +1.d0/2.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*gz**2*(cw**2-sw**2)**2*b0f(qsq,mch,mch)&	! H+-H+
	 +1.d0/2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mz,mz)&			! G0-G0
	 +1.d0/2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mA,mA)&			! A-A
	 +1.d0/2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mbH,mbH)&			! H-H
	 +3.d0/2.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mh,mh)&			! h-h
	 -sin(beta-alpha)*g**3/cw**2*mw*sw**4*( b0f(p2sq,mW,mw)+b0f(p1sq,mw,mW) )&	! G+-W
	 -sin(beta-alpha)*1.d0/2.d0*gz**3*mz*( b0f(p1sq,mh,mZ)+b0f(p2sq,mh,mZ))&	! h-Z
	 )

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hZZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hZZ_B = gz**2/(16.d0*pi**2)*mz**2*(&
                   +sin(beta-alpha)*2.d0*g*mw*cw**4*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW) - C1223(p1sq,p2sq,qsq,mw,mw,mw)) &
!
                     +sin(beta-alpha)*g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
                     +sin(beta-alpha)*g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
!
                     -sin(beta-alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
                     -sin(beta-alpha)*g*mw*(cw**2-sw**2)*sw**2*ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
                     +sin(beta-alpha)**3*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz)&
                     +sin(beta-alpha)**3*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mz)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mz,mbH,mZ)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mA)&
                     +sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mA,mh,mZ)&
                     -sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mA)&
                     -sin(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz*ChVV2_SSV(p1sq,p2sq,qsq,mA,mbH,mZ)&
! 
                     -2.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&  
                     -2.d0*sin(beta-alpha)**2*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
                     -2.d0*cos(beta-alpha)**2*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mbH,mz)&

                    -2.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mch,mch,mch)&
                    -2.d0*cos(beta-alpha)**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mh,mA)&
                    -2.d0*sin(beta-alpha)**2*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mbH,mA)&
                    -6.d0*sin(beta-alpha)**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
                    -6.d0*cos(beta-alpha)**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mA,mh)&
                     -2.d0*cos(beta-alpha)**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mz,mbH)&
                     -2.d0*sin(beta-alpha)**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mA,mbH)&
                     -2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mz,mh)&
                     -2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mz,mbH)&
                     +2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mA,mh)&
                     +2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mA,mbH)&
                     -1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mh,mz)&
                     -1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mh,mA)&
                     +1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mbH,mz)&
                     +1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mbH,mA)&
                    )

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam1_hWW_F = xiu(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,mt)&
                   +xid(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,mb)&
                   +xiu(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam1_hWW_fermion(p1sq,p2sq,qsq,ms)&
                   +xil(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,mtau)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam2_hWW_F = xiu(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,mt)&
                   +xid(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,mb)&
                   +xiu(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam2_hWW_fermion(p1sq,p2sq,qsq,ms)&
                   +xil(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,mtau)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam3_hWW_F = xiu(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,mt)&
                   +xid(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,mb)&
                   +xiu(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,mc)&
                   +xid(alpha,beta,n)*nc*Gam3_hWW_fermion(p1sq,p2sq,qsq,ms)&
                   +xil(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,mtau)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_hWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta) 
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0
!
	Gam1_hWW_B =1.d0/(16.d0*pi**2)*&
	 (&
!~~~~~~~~~~~ 3-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +sin(beta-alpha)*g**3*cw*mz*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
	 +sin(beta-alpha)*g**3*cw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
	 +sin(beta-alpha)*g**3*sw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
	 -sin(beta-alpha)*g**3*sw**2*mw*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)& ! Ghost
	 -sin(beta-alpha)*g**3*cw*mz*c24f(p1sq,p2sq,qsq,mz,mw,mz)&     ! Ghost
	 -sin(beta-alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mz,mw)&  ! Ghost
!~~~~~~~~~~~ 2-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))& 
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*sw**2*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))& 
	 -sin(beta-alpha)*g**3/cw**3*mw**2*mZ*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
	 -sin(beta-alpha)**3*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mh,mW)&
	 -sin(beta-alpha)*cos(beta-alpha)**2*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mbH,mW)&
!~~~~~~~~~~~ 1-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 +lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*mw**2*sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
	 +lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*sw**2*mw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
	 +sin(beta-alpha)**2*6.d0*g**2*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*mw**2*c0f(p1sq,p2sq,qsq,mh,mW,mh)& 
	 +cos(beta-alpha)**2*2.d0*g**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*mw**2*c0f(p1sq,p2sq,qsq,mbH,mW,mbH)& 
	 +cos(beta-alpha)*sin(beta-alpha)*2.d0*g**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*&
	   mw**2*(c0f(p1sq,p2sq,qsq,mh,mW,mbH)+c0f(p1sq,p2sq,qsq,mbH,mW,mh))& 
	 +sin(beta-alpha)**3*1.d0/2.d0*g**3*mw*( c24f(p1sq,p2sq,qsq,mW,mh,mw) + c24f(p1sq,p2sq,qsq,mw,mh,mW) )&
	 +sin(beta-alpha)*cos(beta-alpha)**2*1.d0/2.d0*g**3*mw*&
	    ( c24f(p1sq,p2sq,qsq,mW,mbH,mw) + c24f(p1sq,p2sq,qsq,mw,mbH,mW) )&
	 +sin(beta-alpha)*cos(beta-alpha)**2*1.d0/2.d0*g**3*mw*&
	    ( c24f(p1sq,p2sq,qsq,mW,mh,mch) + c24f(p1sq,p2sq,qsq,mch,mh,mW) )&
	 -sin(beta-alpha)*cos(beta-alpha)**2*1.d0/2.d0*g**3*mw*&
	    ( c24f(p1sq,p2sq,qsq,mW,mbH,mch) + c24f(p1sq,p2sq,qsq,mch,mbH,mW) )&
	 +sin(beta-alpha)*1.d0/2.d0*g**3*sw**2/cw**2*mw*&
	    ( c24f(p1sq,p2sq,qsq,mz,mw,mZ) + c24f(p1sq,p2sq,qsq,mZ,mw,mz) )&
!~~~~~~~~~~~ 0-Gauge ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)**2*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mw,mh,mw) )&
	 -cos(beta-alpha)**2*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mw,mbH,mw) )&
	 -lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mw,mz,mw) )&
	 -cos(beta-alpha)**2*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mch,mh,mch) )&
	 -sin(beta-alpha)**2*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mch,mbH,mch) )&
	 -lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*( c24f(p1sq,p2sq,qsq,mch,mA,mch) )&
!
	 -sin(beta-alpha)*cos(beta-alpha)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*&
	    ( c24f(p1sq,p2sq,qsq,mw,mh,mch)+c24f(p1sq,p2sq,qsq,mch,mh,mw) )&
	 +sin(beta-alpha)*cos(beta-alpha)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*&
	    ( c24f(p1sq,p2sq,qsq,mw,mbH,mch)+c24f(p1sq,p2sq,qsq,mch,mbH,mw) )&
	 -sin(beta-alpha)**2*6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mh,mw,mh) )&
	 -cos(beta-alpha)**2*2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mbH,mw,mbH) )&
	 -cos(beta-alpha)*sin(beta-alpha)*2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*&
	    (c24f(p1sq,p2sq,qsq,mh,mw,mbH)+c24f(p1sq,p2sq,qsq,mbH,mw,mh))&
!
	 -cos(beta-alpha)**2*6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mh,mch,mh) )&
	 -sin(beta-alpha)**2*2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*g**2*(c24f(p1sq,p2sq,qsq,mbH,mch,mbH) )&
	 +cos(beta-alpha)*sin(beta-alpha)*2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*&
	    (c24f(p1sq,p2sq,qsq,mh,mch,mbH)+c24f(p1sq,p2sq,qsq,mbH,mch,mh))&
!
	 -2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
	 -2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mA,mch,mA)&
!~~~~~~~~~~~ B function-like ~~~~~~~~~~~~~~~~~~~~~~!
	 -sin(beta-alpha)*3.d0*g**3*mw*b0f(qsq,mW,mW)+sin(beta-alpha)*2.d0*g**3*mW&
	 -sin(beta-alpha)*3.d0*g**3*cw*mz*b0f(qsq,mZ,mZ)+sin(beta-alpha)*2.d0*g**3*cw*mZ&
	 +1.d0/2.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mw,mw)&
	 +1.d0/2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mz,mz)&
	 +3.d0/2.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mh,mh)&
	 +1.d0/2.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mch,mch)&
	 +1.d0/2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mA,mA)&
	 +1.d0/2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mbH,mbH)&
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*( b0f(p1sq,mW,mh) + b0f(p2sq,mW,mh) )&
	 -sin(beta-alpha)*1.d0/2.d0*g**3*mw*sw**4/cw**2*( b0f(p1sq,mZ,mw) + b0f(p2sq,mZ,mw) )&
	 -sin(beta-alpha)*1.d0/2.d0*g**3*sw**2*mw*( b0f(p1sq,mphoton,mw) + b0f(p2sq,mphoton,mw) )&
	 )

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_hWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	double precision:: p12
	p12=(qsq-p1sq-p2sq)/2.d0

	Gam2_hWW_B = g**2/(16.d0*pi**2)*mw**2*(&
                    +sin(beta-alpha)*g*cw*mz*(ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ) - c1223(p1sq,p2sq,qsq,mz,mw,mz)) &
                    +sin(beta-alpha)*g*mw*cw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)-c1223(p1sq,p2sq,qsq,mw,mz,mw))& 
                    +sin(beta-alpha)*g*mw*sw**2*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)-c1223(p1sq,p2sq,qsq,mw,mphoton,mw)) &
!
          -sin(beta-alpha)*g/2.d0*mw*(sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW) - sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
          -sin(beta-alpha)*g/2.d0*mw*(sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw) - sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
!
                   +sin(beta-alpha)**3*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw)&
                   +sin(beta-alpha)**3*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mw)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mw,mbH,mW)&
                   +sin(beta-alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz)&
                   +sin(beta-alpha)*g/2.d0*mw*sw**2/cw**2*ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mch)&
                   +sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mch,mh,mW)&
                   -sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mch)&
                   -sin(beta-alpha)*cos(beta-alpha)**2*g/2.d0*mw*ChVV2_SSV(p1sq,p2sq,qsq,mch,mbH,mW)&
!
                   -2.d0*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
                   -1.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
                   -1.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mw,mbH,mw)&
                   -1.d0*lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
                   -2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mch,mA)&
                   -1.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mch,mh,mch)&
                   -1.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mch,mbH,mch)&
                   -1.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mch,mA,mch)&
                   -6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
                   -6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mh,mch,mh)&
                   -2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mw,mbH)&
                   -2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mch,mbH)&
                   -2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mbH,mw,mh)&
                   -2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mh,mw,mbH)&
                   +2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mbH,mch,mh)&
                   +2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mh,mch,mbH)&
!
                    -1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mw,mh,mch)&
                    -1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mch,mh,mw)&
                    +1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mw,mbH,mch)&
                    +1.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mch,mbH,mw)&
                    )

	end function
!========================================================
!    SECTION IV COUNTER TERMS
!========================================================
	 double precision function del_mWsq_F(alpha,beta,n)
	 integer, intent(in):: n
	 double precision, intent(in):: alpha,beta
 
	 del_mWsq_F = dble(PiWW_F(mw**2))
 
	end function
 !--------------------------------------------
	 double precision function del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)
	 double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	 
	 del_mWsq_B = dble(PiWW_B(mw**2,mch,mA,mbH,bmsq,alpha,beta))
 
	end function
 !----------------------------------------------
	 double precision function del_mZsq_F(alpha,beta,n)
	 integer, intent(in):: n
	 double precision, intent(in):: alpha,beta
	 
	 del_mZsq_F = dble(PiZZ_F(mz**2))
 
	end function
 !--------------------------------------------
	 double precision function del_mZsq_B(mch,mA,mbH,bmsq,alpha,beta)
	 double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	 
	 del_mZsq_B = dble(PiZZ_B(mz**2,mch,mA,mbH,bmsq,alpha,beta))
 
	end function
 !--------------------------------------------
	double precision function del_swsq_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	! del_swsq_F = cw**2*(PiZZ_F(mz**2)/mz**2-PiWW_F(mw**2)/mw**2)

	del_swsq_F =&
		cw**2*(&
			+del_mZsq_F(alpha,beta,n)/mz**2&
			-del_mWsq_F(alpha,beta,n)/mw**2&
		)

	end function
!---------------------------------------------
	double precision function del_swsq_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	! del_swsq_B = cw**2*(PiZZ_B(mz**2,mch,mA,mbH,bmsq,alpha,beta)/mz**2-PiWW_B(mw**2,mch,mA,mbH,bmsq,alpha,beta)/mw**2)

	del_swsq_B =&
		cw**2*(&
			del_mZsq_B(mch,mA,mbH,bmsq,alpha,beta)/mz**2&
			-del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/mw**2&
		)

	end function
!---------------------------------------------
	double precision function del_swsq(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n

	del_swsq =&
		+del_swsq_F(alpha,beta,n)&
		+del_swsq_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_v_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_v_F =&
		vev/2.d0*dble(&
			PiWW_F(mw**2)/mw**2&
			+del_swsq_F(alpha,beta,n)/sw**2&
			-delta_alpha &
			-(PiGG_F(mz**2)/mZ**2&
   		      +dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2 )&
			-2.d0*sw/cw*PiZG_F(0.d0)/mz**2&
		)

	end function
!---------------------------------------------
	double precision function del_v_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_v_B=&
		vev/2.d0*dble(&
			+PiWW_B(mw**2,mch,mA,mbH,bmsq,alpha,beta)/mw**2&
			+del_swsq_B(mch,mA,mbH,bmsq,alpha,beta)/sw**2&
			-dPiGG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)&
			-2.d0*sw/cw*PiZG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)/mz**2&
		)

	end function
!---------------------------------------------
	double precision function del_v(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n

	del_v =&
		+del_v_F(alpha,beta,n)&
		+del_v_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!--------------------------------------------
	double precision function del_ZZ_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_ZZ_F =& 
	 -delta_alpha-(PiGG_F(mz**2)/mZ**2&
          +dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
	   -2.d0*(cw**2-sw**2)/(cw*sw)*PiZG_F(0.d0)/mz**2&
	 +(cw**2-sw**2)/cw**2*&
	 del_swsq_F(alpha,beta,n)/sw**2

	end function
!--------------------------------------------
	double precision function del_ZZ_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_ZZ_B = -(dPiGG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)-dPiGG_pinch(0.d0))&
	   +2.d0*(cw**2-sw**2)/(cw*sw)*( PiZG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)-PiZG_pinch(0.d0) )/mz**2&
	 +(cw**2-sw**2)/cw**2*&
	 del_swsq_B(mch,mA,mbH,bmsq,alpha,beta)/sw**2

	end function
!--------------------------------------------
	double precision function del_ZW_F(alpha,beta,n)
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta

	del_ZW_F =&
	 -delta_alpha-(PiGG_F(mz**2)/mZ**2&
          +dPiGG_top(0.d0)-PiGG_top(mz**2)/mZ**2)&
	   +2.d0*cw/sw*&
	 PiZG_F(0.d0)/mz**2&
	 +del_swsq_F(alpha,beta,n)/sw**2

	end function
!--------------------------------------------
	double precision function del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	
	del_ZW_B =&
	   -(dPiGG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta) -dPiGG_pinch(0.d0))&
	   +2.d0*cw/sw*(PiZG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)-PiZG_pinch(0.d0))/mz**2&
	   +del_swsq_B(mch,mA,mbH,bmsq,alpha,beta)/sw**2

	end function
!=========================================================
	double precision function del_mt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_mt =&
		mt*dble(&
			+Pitt_V(mt**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+Pitt_S(mt**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_mc(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_mc =&
		mc*dble(&
			+Picc_V(mc**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+Picc_S(mc**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_mb(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_mb =&
		mb*dble(&
			+Pibb_V(mb**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+Pibb_S(mb**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_ms(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_ms =&
		ms*dble(&
			+Piss_V(ms**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+Piss_S(ms**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_mtau(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_mtau =&
		mtau*dble(&
			+Pitautau_V(mtau**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+Pitautau_S(mtau**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_mmu(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_mmu =&
		mmu*dble(&
			+Pimumu_V(mmu**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+Pimumu_S(mmu**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_ZVt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZVt =&
		-Pitt_V(mt**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		-2.d0*mt**2*(&
			+dPitt_V(mt**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+dPitt_S(mt**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)
 
	end function
!---------------------------------------------
	double precision function del_ZAt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	
	del_ZAt =&
		-Pitt_A(mt**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		+2.d0*mt**2*dPitt_A(mt**2,mch,mA,mbH,bmsq,alpha,beta,n)
	
	end function
!---------------------------------------------
	double precision function del_ZLt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLt =&
		+del_ZVt(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAt(mch,mA,mbH,bmsq,alpha,beta,n)
	 
	end function
!---------------------------------------------
	double precision function del_ZRt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRt =&
		+del_ZVt(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAt(mch,mA,mbH,bmsq,alpha,beta,n)
	 
	end function
!---------------------------------------------
	double precision function del_ZVb(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	 
	del_ZVb =&
		-Pibb_V(mb**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		-2.d0*mb**2*(&
			+dPibb_V(mb**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+dPibb_S(mb**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_ZAb(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	 
	del_ZAb =&
		-Pibb_A(mb**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		+2.d0*mb**2*dPibb_A(mb**2,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZLb(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLb =&
		+del_ZVb(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAb(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZRb(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRb =&
		+del_ZVb(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAb(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZVc(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZVc =&
		-Picc_V(mc**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		-2.d0*mc**2*(&
			+dPicc_V(mc**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+dPicc_S(mc**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_ZAc(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	 
	del_ZAc =&
		-Picc_A(mc**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		+2.d0*mc**2*dPicc_A(mc**2,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZLc(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLc =&
		+del_ZVc(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAc(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZRc(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRc =&
		+del_ZVc(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAc(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZVs(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	 
	del_ZVs =&
		-Piss_V(ms**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		-2.d0*ms**2*(&
			+dPiss_V(ms**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+dPiss_S(ms**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_ZAs(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	 
	del_ZAs =&
		-Piss_A(ms**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		+2.d0*ms**2*dPiss_A(ms**2,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZLs(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLs =&
		+del_ZVs(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAs(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZRs(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRs =&
		+del_ZVs(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAs(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZVnt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZVnt = -Pintnt_V(m0**2,mch,mA,mbH,bmsq,alpha,beta,n) 

	end function
!---------------------------------------------
	double precision function del_ZAnt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	
	del_ZAnt = -Pintnt_A(m0**2,mch,mA,mbH,bmsq,alpha,beta,n)
	
	end function
!---------------------------------------------
	double precision function del_ZLnt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLnt =&
		+del_ZVnt(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAnt(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZRnt(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRnt =&
		+del_ZVnt(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAnt(mch,mA,mbH,bmsq,alpha,beta,n)
	 
	end function
!----------------------------------------------
	double precision function del_ZVtau(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZVtau =&
		-Pitautau_V(mtau**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		-2.d0*mtau**2*(&
			+dPitautau_V(mtau**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+dPitautau_S(mtau**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_ZAtau(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
		
	del_ZAtau =&
		-Pitautau_A(mtau**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		+2.d0*mtau**2*dPitautau_A(mtau**2,mch,mA,mbH,bmsq,alpha,beta,n)
 
	end function
!---------------------------------------------
	double precision function del_ZLtau(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLtau =&
		+del_ZVtau(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAtau(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZRtau(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRtau =&
		+del_ZVtau(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAtau(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZVnm(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZVnm = -Pinmnm_V(m0**2,mch,mA,mbH,bmsq,alpha,beta,n) 

	end function
!---------------------------------------------
	double precision function del_ZAnm(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZAnm = -Pinmnm_A(m0**2,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZLnm(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLnm =&
		+del_ZVnm(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAnm(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZRnm(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRnm =&
		+del_ZVnm(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAnm(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!----------------------------------------------
	double precision function del_ZVmu(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZVmu =&
		-Pimumu_V(mmu**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		-2.d0*mmu**2*(&
			+dPimumu_V(mmu**2,mch,mA,mbH,bmsq,alpha,beta,n)&
			+dPimumu_S(mmu**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		)

	end function
!---------------------------------------------
	double precision function del_ZAmu(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
		
	del_ZAmu =&
		-Pimumu_A(mmu**2,mch,mA,mbH,bmsq,alpha,beta,n)&
		+2.d0*mmu**2*dPimumu_A(mmu**2,mch,mA,mbH,bmsq,alpha,beta,n)
 
	end function
!---------------------------------------------
	double precision function del_ZLmu(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZLmu =&
		+del_ZVmu(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_ZAmu(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZRmu(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
 
	del_ZRmu =&
		+del_ZVmu(mch,mA,mbH,bmsq,alpha,beta,n)&
		-del_ZAmu(mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_T1_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_T1_F = -cos(alpha)*TbH_F(alpha,beta,n)+sin(alpha)*Th_F(alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_T1_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_T1_B = -cos(alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)+sin(alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_T1(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_T1 = del_T1_F(alpha,beta,n)+del_T1_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_T2_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_T2_F = -sin(alpha)*TbH_F(alpha,beta,n)-cos(alpha)*Th_F(alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_T2_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_T2_B = -sin(alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)-cos(alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_T2(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_T2 = del_T2_F(alpha,beta,n)+del_T2_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_Zh_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_Zh_F = -dPihh_F(mh**2,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_Zh_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_Zh_B = -dPihh_B(mh**2,mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_Zh(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_Zh = del_Zh_F(alpha,beta,n)+del_Zh_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_mhsq_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_mhsq_F = dble(Pihh_F(mh**2,alpha,beta,n)&
		+sin(alpha)**2*del_T1_F(alpha,beta,n)/(cos(beta)*vev)&
		+cos(alpha)**2*del_T2_F(alpha,beta,n)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_mhsq_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_mhsq_B = dble(Pihh_B(mh**2,mch,mA,mbH,bmsq,alpha,beta)&
		+sin(alpha)**2*del_T1_B(mch,mA,mbH,bmsq,alpha,beta)/(cos(beta)*vev)&
		+cos(alpha)**2*del_T2_B(mch,mA,mbH,bmsq,alpha,beta)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_ZbH_F(mbH,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mbH,alpha,beta

	del_ZbH_F = -dPibHbH_F(mbH**2,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_ZbH_B = -dPibHbH_B(mbH**2,mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_ZbH(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	del_ZbH = del_ZbH_F(mbH,alpha,beta,n)+del_ZbH_B(mch,mA,mbh,bmsq,alpha,beta)
	
	end function
!---------------------------------------------
	double precision function del_mbHsq_F(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_mbHsq_F = dble(PibHbH_F(mbH**2,alpha,beta,n)&
		+cos(alpha)**2*del_T1_F(alpha,beta,n)/(cos(beta)*vev)&
		+sin(alpha)**2*del_T2_F(alpha,beta,n)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_mbHsq_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_mbHsq_B = dble(PibHbH_B(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
		+cos(alpha)**2*del_T1_B(mch,mA,mbH,bmsq,alpha,beta)/(cos(beta)*vev)&
		+sin(alpha)**2*del_T2_B(mch,mA,mbH,bmsq,alpha,beta)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_mbHsq(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_mbHsq = &
		+del_mbHsq_F(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_mbHsq_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_ZA_F(mA,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mA,alpha,beta

	del_ZA_F = -dPiAA_F(mA**2,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_ZA_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_ZA_B = -dPiAA_B(mA**2,mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_ZA(mch,mA,mbH,bmsq,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
 
	del_ZA = del_ZA_F(mA,alpha,beta,n)+del_ZA_B(mch,mA,mbH,bmsq,alpha,beta)
 
	end function
!---------------------------------------------
	double precision function del_mAsq_F(mch,mA,mbH,bmsq,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_mAsq_F = dble(PiAA_F(mA**2,alpha,beta,n)&
		+sin(beta)**2*del_T1_F(alpha,beta,n)/(cos(beta)*vev)&
		+cos(beta)**2*del_T2_F(alpha,beta,n)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_mAsq_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_mAsq_B = dble(PiAA_B(mA**2,mch,mA,mbH,bmsq,alpha,beta)&
		+sin(beta)**2*del_T1_B(mch,mA,mbH,bmsq,alpha,beta)/(cos(beta)*vev)&
		+cos(beta)**2*del_T2_B(mch,mA,mbH,bmsq,alpha,beta)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_mAsq(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_mAsq =&
		+del_mAsq_F(mch,mA,mbH,bmsq,alpha,beta,n)&
		+del_mAsq_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_ZHpm_F(mch,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mch,alpha,beta
 
	del_ZHpm_F = -dPiHpHm_F(mch**2,alpha,beta,n)
 
	end function
!---------------------------------------------
	double precision function del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
 
	del_ZHpm_B = -dPiHpHm_B(mch**2,mch,mA,mbH,bmsq,alpha,beta)
 
	end function
!---------------------------------------------
	double precision function del_ZHpm(mch,mA,mbH,bmsq,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
 
	del_ZHpm = del_ZHpm_F(mch,alpha,beta,n)+del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)
 
	end function
!---------------------------------------------
	double precision function del_mchsq_F(mch,mA,mbH,bmsq,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_mchsq_F = dble(PiHpHm_F(mch**2,alpha,beta,n)&
		+sin(beta)**2*del_T1_F(alpha,beta,n)/(cos(beta)*vev)&
		+cos(beta)**2*del_T2_F(alpha,beta,n)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_mchsq_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_mchsq_B = dble(PiHpHm_B(mch**2,mch,mA,mbH,bmsq,alpha,beta)&
		+sin(beta)**2*del_T1_B(mch,mA,mbH,bmsq,alpha,beta)/(cos(beta)*vev)&
		+cos(beta)**2*del_T2_B(mch,mA,mbH,bmsq,alpha,beta)/(sin(beta)*vev))

	end function
!---------------------------------------------
	double precision function del_alpha_F(mbH,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mbH,alpha,beta

	del_alpha_F = 1.d0/2.d0/(mbH**2-mh**2)*(&
		+PibHh_F(mh**2,alpha,beta,n)&
		+PibHh_F(mbH**2,alpha,beta,n)&
		-2.d0*sin(alpha)*cos(alpha)*(&
			+del_T1_F(alpha,beta,n)/(cos(beta)*vev)&
			-del_T2_F(alpha,beta,n)/(sin(beta)*vev)&
		)&
	)

	end function
!---------------------------------------------
	double precision function del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_alpha_B = 1.d0/2.d0/(mbH**2-mh**2)*(&
		+PibHh_B(mh**2,mch,mA,mbH,bmsq,alpha,beta)&
		+PibHh_B(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
		-2.d0*sin(alpha)*cos(alpha)*(&
			+del_T1_B(mch,mA,mbH,bmsq,alpha,beta)/(cos(beta)*vev)&
			-del_T2_B(mch,mA,mbH,bmsq,alpha,beta)/(sin(beta)*vev)&
		)&
	)

	end function
!---------------------------------------------
	double precision function del_alpha(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_alpha = del_alpha_F(mbH,alpha,beta,n)+del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_Ch_F(mbH,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mbH,alpha,beta

	del_Ch_F = 1.d0/2.d0/(mbH**2-mh**2)*(&
		+PibHh_F(mh**2,alpha,beta,n)-PibHh_F(mbH**2,alpha,beta,n)&
	)

	end function
!---------------------------------------------
	double precision function del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_Ch_B = 1.d0/2.d0/(mbH**2-mh**2)*(&
		+PibHh_B(mh**2,mch,mA,mbH,bmsq,alpha,beta)&
		-PibHh_B(mbH**2,mch,mA,mbH,bmsq,alpha,beta))

	end function
!---------------------------------------------
	double precision function del_Ch(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_Ch = del_Ch_F(mbH,alpha,beta,n)+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_beta_F(mA,alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: mA,alpha,beta

	del_beta_F =&
		-(&
			tildePiAG_F(mA**2,alpha,beta,n)&
			+tildePiAG_F(0.d0,alpha,beta,n)&
		)/(2.d0*mA**2)

	end function
!---------------------------------------------
	double precision function del_beta_F_div(mA,alpha,beta,n)
   integer, intent(in)::n
   double precision, intent(in):: mA,alpha,beta
 
   del_beta_F_div =&
		-(&
			tildePiAG_F_div(mA**2,alpha,beta,n)&
			+tildePiAG_F_div(0.d0,alpha,beta,n)&
		)/(2.d0*mA**2)
 
   end function
!---------------------------------------------
	double precision function del_beta_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_beta_B =&
		-(&
			tildePiAG_B(mA**2,mch,mA,mbH,bmsq,alpha,beta)&
			+tildePiAG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)&
		)/(2.d0*mA**2)

	end function
!---------------------------------------------
	double precision function del_beta_B_div(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	
	del_beta_B_div =&
		-(&
			tildePiAG_B_div(mA**2,mch,mA,mbH,bmsq,alpha,beta)&
			+tildePiAG_B_div(0.d0,mch,mA,mbH,bmsq,alpha,beta)&
		)/(2.d0*mA**2)
	
	end function
!---------------------------------------------
	double precision function del_beta(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_beta = del_beta_F(mA,alpha,beta,n)+del_beta_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_CA_F(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_CA_F = -1.d0/2.d0/mA**2*(&
		+PiAG_F(mA**2,alpha,beta,n)-PiAG_F(0.d0,alpha,beta,n)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_CA_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_CA_B = -1.d0/2.d0/mA**2*(&
		+PiAG_B(mA**2,mch,mA,mbH,bmsq,alpha,beta)-PiAG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)&
	)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_CA(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_CA = del_CA_F(mch,mA,mbH,bmsq,alpha,beta,n)+del_CA_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_CHpm_F(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_CHpm_F = del_beta_F(mA,alpha,beta,n)&
				+tildePiHpGm_F(0.d0,alpha,beta,n)/mch**2

	end function
!---------------------------------------------
	double precision function del_CHpm_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_CHpm_B = del_beta_B(mch,mA,mbH,bmsq,alpha,beta)&
				+tildePiHpGm_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)/mch**2

	end function
!---------------------------------------------
	double precision function del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_CHpm = del_CHpm_F(mch,mA,mbH,bmsq,alpha,beta,n)&
				+del_CHpm_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	double precision function del_xiu(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	if (n==1) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==2) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==3) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==4) then
	del_xiu = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	else
	del_xiu=0.00000000000001d0
	end if

	end function
!---------------------------------------------
	double precision function del_xid(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	if (n==1) then
	del_xid = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==2) then
	del_xid = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==3) then
	del_xid = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==4) then
	del_xid = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	else
	del_xid=0.00000000000001d0
	end if

	end function
!---------------------------------------------
	double precision function del_xil(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	if (n==1) then
	del_xil = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==2) then
	del_xil = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==3) then
	del_xil = -sin(alpha)/cos(beta)*&
	(tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	elseif (n==4) then
	del_xil = -cos(alpha)/sin(beta)*&
	(1.d0/tan(beta)*del_beta(mch,mA,mbH,bmsq,alpha,beta,n) + tan(alpha)*del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))
	else
	del_xil = 0.00000000000001d0
	end if

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_xiu_H(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	! if (n==1) then
	! del_xiu_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==2) then
	! del_xiu_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==3) then
	! del_xiu_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==4) then
	! del_xiu_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! else
	! del_xiu_H=0.00000000000001d0
	! end if

	! write(*,*) "del_xiu_H =", del_xiu_H

	del_xiu_H =&
		+xiu(alpha,beta,n)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n)&
		-xiu_H(alpha,beta,n)*xiu_A(alpha,beta,n)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_xid_H(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	! if (n==1) then
	! del_xid_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==2) then
	! del_xid_H = cos(alpha)/cos(beta)*&
	! (tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) - tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==3) then
	! del_xid_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==4) then
	! del_xid_H = cos(alpha)/cos(beta)*&
	! (tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) - tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! else
	! del_xid_H=0.00000000000001d0
	! end if

	! write(*,*) "del_xid_H =", del_xid_H

	del_xid_H =&
		+xid(alpha,beta,n)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n)&
		-xid_H(alpha,beta,n)*xid_A(alpha,beta,n)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function del_xil_H(mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in)::n

	! if (n==1) then
	! del_xil_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==2) then
	! del_xil_H = cos(alpha)/cos(beta)*&
	! (tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) - tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==3) then
	! del_xil_H = cos(alpha)/cos(beta)*&
	! (tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) - tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! elseif (n==4) then
	! del_xil_H = sin(alpha)/sin(beta)*&
	! (-1.d0/tan(beta)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n) + 1.d0/tan(alpha)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n))
	! else
	! del_xil_H = 0.00000000000001d0
	! end if

	! write(*,*) "del_xil_H =", del_xil_H

	del_xil_H =&
		+xil(alpha,beta,n)*del_alpha(mch,mA,mbh,bmsq,alpha,beta,n)&
		-xil_H(alpha,beta,n)*xil_A(alpha,beta,n)*del_beta(mch,mA,mbh,bmsq,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_bar_bmsq_F(alpha,beta,n)  ! Defined as del_M^2/M^2
	integer, intent(in):: n
	double precision, intent(in):: alpha,beta
	double precision:: del_bar_bmsq_F_ST

	del_bar_bmsq_F_ST =&
		1.d0/(16.d0*pi**2*vev**2)*(&
			Nc*(&
				2.d0*mt**2*xiu_A(alpha,beta,n)**2&
				+2.d0*mc**2*xiu_A(alpha,beta,n)**2&
				+2.d0*mb**2*(-xid_A(alpha,beta,n))**2&
				+2.d0*ms**2*(-xid_A(alpha,beta,n))**2&
			)&
			+2.d0*mtau**2*(-xil_A(alpha,beta,n))**2&
			+2.d0*mmu**2*(-xil_A(alpha,beta,n))**2&
		)*div

	if (SCHEME == 0) then
		del_bar_bmsq_F =&
			del_bar_bmsq_F_ST&
			+2.d0/vev*cos(2.d0*beta)/sin(2.d0*beta)*(&
				+Th_F_div(alpha,beta,n)/mh**2*cos(beta-alpha)&
				-TbH_F_div(alpha,beta,n)/mbH**2*sin(beta-alpha)&
			)
	else if (SCHEME ==1) then
		del_bar_bmsq_F = del_bar_bmsq_F_ST 
	end if

	end function
!---------------------------------------------
	double precision function del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)   ! Defined as del_M^2/M^2
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	double precision :: del_bar_bmsq_B_ST

	del_bar_bmsq_B_ST =&
	 	1.d0/(16.d0*pi**2*vev**2)*(&
			4.d0*bmsq-2.d0*mch**2-mA**2+sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2)&
			-3.d0*(2.d0*mw**2+mz**2)&
		)*div

	if (SCHEME == 0) then
		del_bar_bmsq_B =&
			del_bar_bmsq_B_ST&
			+2.d0*cos(2.d0*beta)/(vev*sin(2.d0*beta))*(&
				+Th_B_div(mch,mA,mbH,bmsq,alpha,beta)/mh**2*cos(beta-alpha)&
				-TbH_B_div(mch,mA,mbH,bmsq,alpha,beta)/mbH**2*sin(beta-alpha)&
			)
	else if (SCHEME == 1) then 
		del_bar_bmsq_B =del_bar_bmsq_B_ST 
	end if

	end function
!---------------------------------------------
	double precision function del_bar_m12sq_F(mA,alpha,beta,n)   ! Defined as del_m_12^2/M^2
	integer, intent(in)::n
	double precision, intent(in):: mA, alpha,beta
	double precision :: del_bar_bmsq_F_ST

	del_bar_bmsq_F_ST =&
		1.d0/(16.d0*pi**2*vev**2)*(&
			2.d0*Nc*(&
				mt**2*xiu_A(alpha,beta,n)**2&
				+mc**2*xiu_A(alpha,beta,n)**2&
				+mb**2*(-xid_A(alpha,beta,n))**2&
				+ms**2*(-xid_A(alpha,beta,n))**2&
			)&
			+2.d0*mtau**2*(-xil_A(alpha,beta,n))**2&
			+2.d0*mmu**2*(-xil_A(alpha,beta,n))**2&
		)*div

	del_bar_m12sq_F =&
		del_bar_bmsq_F_ST&
		+2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_F_div(mA,alpha,beta,n)

	end function
!---------------------------------------------
	double precision function del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)   ! Defined as del_m12^2/M^2
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	double precision :: del_bar_bmsq_B_ST

	del_bar_bmsq_B_ST =&
		1.d0/(16.d0*pi**2*vev**2)*(&
			4.d0*bmsq -2.d0*mch**2-mA**2&
			+sin(2.d0*alpha)/sin(2.d0*beta)*(mbH**2-mh**2)&
			-3.d0*(2.d0*mw**2+mz**2)&
		)*div 

	del_bar_m12sq_B =&
		del_bar_bmsq_B_ST&
		+2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_B_div(mch,mA,mbH,bmsq,alpha,beta)

	end function
!==============================================
	double precision function del_lam_hhh_F(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	double precision :: del_lam_hhh_F_wo_CTbm

	del_lam_hhh_F_wo_CTbm =&
		-lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*del_v_F(alpha,beta,n)/vev&
		-1.d0/(4.d0*vev*sin(2.d0*beta))*(cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*del_mhsq_F(alpha,beta,n)&
		+cos(beta-alpha)/(2.d0*vev)*(3.d0*sin(2.d0*alpha)/sin(2.d0*beta)*(mh**2-bmsq)+bmsq)*del_alpha_F(mbH,alpha,beta,n)&
		+cos(beta-alpha)/(4.d0*vev*sin(2.d0*beta)**2)*(&
			(4.d0+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*mh**2&
			-(5.d0-cos(4.d0*beta)+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*bmsq&
		)*del_beta_F(mA,alpha,beta,n)

	if (SCHEME == 0 .or. SCHEME == 1) then
		del_lam_hhh_F =&
			del_lam_hhh_F_wo_CTbm&
			+cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*del_bar_bmsq_F(alpha,beta,n)*bmsq
	else if (SCHEME == 2) then 
		del_lam_hhh_F =&
			del_lam_hhh_F_wo_CTbm&
			+cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*(&
				del_bar_m12sq_F(mA,alpha,beta,n)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_F(mA,alpha,beta,n)&
			)*bmsq    
	end if

	end function
!---------------------------------------------------------------------
	double precision function del_lam_hhh_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	double precision :: del_beta_bar ! del_beta_bar = delta_beta_WF + delta_beta_PT
	double precision :: del_lam_hhh_B_wo_CTbm

	del_lam_hhh_B_wo_CTbm =&
		-lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		-1.d0/(4.d0*vev*sin(2.d0*beta))*(cos(3.d0*alpha-beta)+3.d0*cos(alpha+beta))*del_mhsq_B(mch,mA,mbH,bmsq,alpha,beta)&
		+cos(beta-alpha)/(2.d0*vev)*(3.d0*sin(2.d0*alpha)/sin(2.d0*beta)*(mh**2-bmsq)+bmsq)*(&
			del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+cos(beta-alpha)/(4.d0*vev*sin(2.d0*beta)**2)*(&
			(4.d0+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*mh**2&
			-(5.d0-cos(4.d0*beta)+4.d0*cos(2.d0*alpha)*cos(2.d0*beta)-2.d0*sin(2.d0*alpha)*sin(2.d0*beta))*bmsq&
		)*(del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))

	if (SCHEME == 0 .or. SCHEME == 1) then 
		del_lam_hhh_B =&
			del_lam_hhh_B_wo_CTbm&
			+cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*(&
				del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)&
			)*bmsq
	else if (SCHEME == 2) then
		del_beta_bar =&
			del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)

		del_lam_hhh_B =&
			del_lam_hhh_B_wo_CTbm&
			+cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*(&
				del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_bar&
			)*bmsq
	end if

	end function
!---------------------------------------------------------------------
	double precision function del_Gam_hhh_F(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	del_Gam_hhh_F =&
		6.d0*(&
			+del_lam_hhh_F(mch,mA,mbH,bmsq,alpha,beta,n)&
			+3.d0/2.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*del_Zh_F(alpha,beta,n)&
			+lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*(&
				del_alpha_F(mbH,alpha,beta,n)+del_Ch_F(mbH,alpha,beta,n)&
			)&
		)	

	end function
!---------------------------------------------------------------------
	double precision function del_Gam_hhh_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_Gam_hhh_B =&
		6.d0*(&
			del_lam_hhh_B(mch,mA,mbH,bmsq,alpha,beta)&
			+3.d0/2.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*del_Zh_B(mch,mA,mbH,bmsq,alpha,beta)&
			+lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*(&
				del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
			)&
		)

	end function
!==============================================
	double precision function del_Gam1_hZZ_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_Gam1_hZZ_F =&
		2.d0*mz**2/vev*sin(beta-alpha)*(&
			+del_mZsq_F(alpha,beta,n)/mz**2&
			+1.d0/2.d0*(del_Zh_F(alpha,beta,n)+2.d0*del_ZZ_F(alpha,beta,n))&
			-del_v_F(alpha,beta,n)/vev&
		)&
		+2.d0*mz**2/vev*cos(beta-alpha)*(&
			del_beta_F(mA,alpha,beta,n)+del_Ch_F(mbH,alpha,beta,n)&
		)
	
	end function
!--------------------------------------------
	double precision function del_Gam1_hZZ_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_Gam1_hZZ_B =&
		2.d0*mz**2/vev*sin(beta-alpha)*(&
			+del_mZsq_B(mch,mA,mbH,bmsq,alpha,beta)/mz**2&
			+1.d0/2.d0*(del_Zh_B(mch,mA,mbH,bmsq,alpha,beta)+2.d0*del_ZZ_B(mch,mA,mbH,bmsq,alpha,beta))&
			-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		)&
		+2.d0*mz**2/vev*cos(beta-alpha)*(&
			del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
		)

	end function
!--------------------------------------------
	double precision function del_Gam1_hWW_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	del_Gam1_hWW_F =&
		2.d0*mW**2/vev*sin(beta-alpha)*(&
			+del_mWsq_F(alpha,beta,n)/mW**2&
			+1.d0/2.d0*(del_Zh_F(alpha,beta,n)+2.d0*del_ZW_F(alpha,beta,n))&
			-del_v_F(alpha,beta,n)/vev&
		)&
		+2.d0*mW**2/vev*cos(beta-alpha)*(&
			del_beta_F(mA,alpha,beta,n)+del_Ch_F(mbH,alpha,beta,n)&
		)

	end function
!--------------------------------------------
	double precision function del_Gam1_hWW_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta

	del_Gam1_hWW_B =&
		2.d0*mW**2/vev*sin(beta-alpha)*(&
	      +del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/mW**2&
	      +1.d0/2.d0*(del_Zh_B(mch,mA,mbH,bmsq,alpha,beta)+2.d0*del_ZW_B(mch,mA,mbH,bmsq,alpha,beta))&
	      -del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		)&
		+2.d0*mW**2/vev*cos(beta-alpha)*(&
			del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
		)
	
	end function
!================================================
!    SECTION V RENORMALIZED HIGGS COUPLINGS     !
!================================================
!==========================================================================================
  	complex (kind(0d0)) function Gam1_hZZ_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
  	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	
	Gam1_hZZ_loop = &
	 +Gam1_hZZ_F(p1sq,p2sq,qsq,alpha,beta,n)&
	 +del_Gam1_hZZ_F(alpha,beta,n)&
	 +Gam1_hZZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
	 +del_Gam1_hZZ_B(mch,mA,mbH,bmsq,alpha,beta)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mz**2/(vev*mA**2)*cos(beta-alpha)*(PiAG_PT(ma**2,mch,mA,mbH,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbH,bmsq,alpha,beta) )&
!
         +2.d0*mZ**2/vev*cos(beta-alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
         +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
         )

	end function
!--------------------------------------------
  	complex (kind(0d0)) function rGam1_hZZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
  	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	
	rGam1_hZZ =2.d0*mZ**2/vev*sin(beta-alpha) + Gam1_hZZ_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!--------------------------------------------
	complex (kind(0d0)) function rGam2_hZZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

        rGam2_hZZ = Gam2_hzz_F(p1sq,p2sq,qsq,alpha,beta,n) + Gam2_hzz_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta) 

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam3_hZZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

        rGam3_hZZ = Gam3_hzz_F(p1sq,p2sq,qsq,alpha,beta,n) 

	end function
!=========================================================================================
  	complex (kind(0d0)) function Gam1_hWW_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
!
 	 Gam1_hWW_loop = &
	 +Gam1_hWW_F(p1sq,p2sq,qsq,alpha,beta,n)&
	 +del_Gam1_hWW_F(alpha,beta,n)&
	 +Gam1_hWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
	 +del_Gam1_hWW_B(mch,mA,mbH,bmsq,alpha,beta)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mw**2/(vev*mA**2)*cos(beta-alpha)*(PiAG_PT(ma**2,mch,mA,mbH,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbH,bmsq,alpha,beta) )&
!
         +2.d0*mW**2/vev*cos(beta-alpha)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
         +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
         )

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam1_hWW(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam1_hWW = 2.d0*mw**2/vev*sin(beta-alpha) + Gam1_hww_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam2_hWW(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

        rGam2_hWW = Gam2_hWW_F(p1sq,p2sq,qsq,alpha,beta,n) + Gam2_hWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta) 

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam3_hWW(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

        rGam3_hWW = Gam3_hWW_F(p1sq,p2sq,qsq,alpha,beta,n) 

	end function
!======================================
	complex (kind(0d0)) function hbb_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	hbb_tree = -mb/vev*xid(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hbb_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_hbb_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mb)&
	-mb/vev*xid(alpha,beta,n)*(&
	del_mb(mch,mA,mbH,bmsq,alpha,beta,n)/mb-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
	+del_ZVb(mch,mA,mbH,bmsq,alpha,beta,n)+1.d0/2.d0*del_Zh(mch,mA,mbH,bmsq,alpha,beta,n)&
	+del_xid(mch,mA,mbH,bmsq,alpha,beta,n)/xid(alpha,beta,n)&
	+xid_H(alpha,beta,n)/xid(alpha,beta,n)*(del_Ch(mch,mA,mbH,bmsq,alpha,beta,n)+del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mb/(2.d0*vev*mA**2)*xid(alpha,beta,n)*xid_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbH,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbH,bmsq,alpha,beta) )&
!
         -mb/vev*xid(alpha,beta,n)*xid_H(alpha,beta,n)/xid(alpha,beta,n)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
         +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
         )

	end function
!---------------------------------------------
	complex (kind(0d0)) function rGamS_hbb(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_hbb = hbb_tree(alpha,beta,n) + Gam_hbb_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!======================================================================================
	complex (kind(0d0)) function hcc_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	hcc_tree = -mc/vev*xiu(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_hcc_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_hcc_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mc)&
	-mc/vev*xiu(alpha,beta,n)*(&
	del_mc(mch,mA,mbH,bmsq,alpha,beta,n)/mc-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
	+del_ZVc(mch,mA,mbH,bmsq,alpha,beta,n)+1.d0/2.d0*del_Zh(mch,mA,mbH,bmsq,alpha,beta,n)&
	+del_xiu(mch,mA,mbH,bmsq,alpha,beta,n)/xiu(alpha,beta,n)&
	+xiu_H(alpha,beta,n)/xiu(alpha,beta,n)*(del_Ch(mch,mA,mbH,bmsq,alpha,beta,n)+del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mc/(2.d0*vev*mA**2)*xiu(alpha,beta,n)*xiu_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbH,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbH,bmsq,alpha,beta) )&
!  
         -mc/vev*xiu(alpha,beta,n)*xiu_H(alpha,beta,n)/xiu(alpha,beta,n)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
         +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
         )
	end function
!---------------------------------------------
	complex (kind(0d0)) function rGamS_hcc(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_hcc = hcc_tree(alpha,beta,n) + Gam_hcc_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!====================================================================================================
	complex (kind(0d0)) function htt_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	htt_tree = -mt/vev*xiu(alpha,beta,n)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_htt_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_htt_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mt)&
	-mt/vev*xiu(alpha,beta,n)*(&
	del_mt(mch,mA,mbH,bmsq,alpha,beta,n)/mt-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
	+del_ZVt(mch,mA,mbH,bmsq,alpha,beta,n)+1.d0/2.d0*del_Zh(mch,mA,mbH,bmsq,alpha,beta,n)&
	+del_xiu(mch,mA,mbH,bmsq,alpha,beta,n)/xiu(alpha,beta,n)&
	+xiu_H(alpha,beta,n)/xiu(alpha,beta,n)*(del_Ch(mch,mA,mbH,bmsq,alpha,beta,n)+del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
       -mt/(2.d0*vev*mA**2)*xiu(alpha,beta,n)*xiu_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbH,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbH,bmsq,alpha,beta) )&
!
         -mt/vev*xiu(alpha,beta,n)*xiu_H(alpha,beta,n)/xiu(alpha,beta,n)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
         +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
         )
	end function
!-----------------------------------------------------------------------------------
	complex (kind(0d0)) function rGamS_htt(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_htt = htt_tree(alpha,beta,n) + Gam_htt_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!==================================================================================
	complex (kind(0d0)) function GamS_htautau_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	GamS_htautau_tree = -mtau/vev*xil(alpha,beta,n)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function Gam_htautau_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_htautau_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mtau)&
	-mtau/vev*xil(alpha,beta,n)*(&
	del_mtau(mch,mA,mbH,bmsq,alpha,beta,n)/mtau&
	-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
	+del_ZVtau(mch,mA,mbH,bmsq,alpha,beta,n)&
	+1.d0/2.d0*del_Zh(mch,mA,mbH,bmsq,alpha,beta,n)&
	+del_xil(mch,mA,mbH,bmsq,alpha,beta,n)/xil(alpha,beta,n)&
	+xil_H(alpha,beta,n)/xil(alpha,beta,n)*(del_Ch(mch,mA,mbH,bmsq,alpha,beta,n)&
	+del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mtau/(2.d0*vev*mA**2)*xil(alpha,beta,n)*xil_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbH,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbH,bmsq,alpha,beta) )&
!
         -mtau/vev*xil(alpha,beta,n)*xil_H(alpha,beta,n)/xil(alpha,beta,n)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
         +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
         )
	end function
!--------------------------------------------
	complex (kind(0d0)) function rGamS_htautau(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_htautau = GamS_htautau_tree(alpha,beta,n) + Gam_htautau_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!================================================================================== ! added from v2
	complex (kind(0d0)) function hmumu_tree(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta

	hmumu_tree = -mmu/vev*xil(alpha,beta,n)

	end function
!----------------------------------------------------------------------------------
	complex (kind(0d0)) function Gam_hmumu_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	Gam_hmumu_loop =&
	+Fhff_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mmu)&
	-mmu/vev*xil(alpha,beta,n)*(&
	del_mmu(mch,mA,mbH,bmsq,alpha,beta,n)/mmu&
	-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
	+del_ZVmu(mch,mA,mbH,bmsq,alpha,beta,n)&
	+1.d0/2.d0*del_Zh(mch,mA,mbH,bmsq,alpha,beta,n)&
	+del_xil(mch,mA,mbH,bmsq,alpha,beta,n)/xil(alpha,beta,n)&
	+xil_H(alpha,beta,n)/xil(alpha,beta,n)*(del_Ch(mch,mA,mbH,bmsq,alpha,beta,n)&
	+del_alpha(mch,mA,mbH,bmsq,alpha,beta,n))&
	)&
!........ Add the difference between the KOSY scheme and the PT scheme ................
        -mmu/(2.d0*vev*mA**2)*xil(alpha,beta,n)*xil_A(alpha,beta,n)*(&
         PiAG_PT(ma**2,mch,mA,mbH,bmsq,alpha,beta) + PiAG_PT(0.d0,mch,mA,mbH,bmsq,alpha,beta) )&
!
         -mmu/vev*xil(alpha,beta,n)*xil_H(alpha,beta,n)/xil(alpha,beta,n)*(-1.d0/2.d0)/(mbH**2-mh**2)*(&
         +PibHh_PT(mh**2,mch,mA,mbH,bmsq,alpha,beta)+PibHh_PT(mbH**2,mch,mA,mbH,bmsq,alpha,beta)&
         )
	end function
!--------------------------------------------
	complex (kind(0d0)) function rGamS_hmumu(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGamS_hmumu = hmumu_tree(alpha,beta,n) + Gam_hmumu_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!==========================================================================================
	complex (kind(0d0)) function Gam_hhh_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n
	complex (kind(0d0)) ::Gam_hhh_loop_ST_wPT

	Gam_hhh_loop_ST_wPT=&
		Gam_hhh_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+del_Gam_hhh_F(mch,mA,mbH,bmsq,alpha,beta,n)&
		+Gam_hhh_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+del_Gam_hhh_B(mch,mA,mbH,bmsq,alpha,beta)

	if (SCHEME == 0) then
		Gam_hhh_loop =&
			Gam_hhh_loop_ST_wPT&
			!====== differences between the standanrd tadpole and alternative tadpole schemes ======
         -12.d0*bmsq/vev**2*(cos(2.d0*beta)*cos(alpha+beta)*cos(beta-alpha)**2)/sin(2.d0*beta)**2*(&
				cos(beta-alpha)/mh**2*(Th_F(alpha,beta,n)+Th_B(mch,mA,mbH,bmsq,alpha,beta))&
				-sin(beta-alpha)/mbH**2*(TbH_F(alpha,beta,n)+TbH_B(mch,mA,mbH,bmsq,alpha,beta))&
			)&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*(&
				del_bar_bmsq_F(alpha,beta,n)+del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)&
			)*bmsq*log(mu_r**2)
	else if (SCHEME == 1) then 
		Gam_hhh_loop =&
			Gam_hhh_loop_ST_wPT&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*(&
				del_bar_bmsq_F(alpha,beta,n)+del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)&
			)*bmsq*log(mu_r**2)
	else if (SCHEME == 2) then 
		Gam_hhh_loop =&
			Gam_hhh_loop_ST_wPT&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)**2*cos(alpha+beta)/(vev*sin(2.d0*beta))*(&
				del_bar_m12sq_F(mA,alpha,beta,n)&
				+del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)&
			)*bmsq*log(mu_r**2)
	end if

	end function
!--------------------------------------------
	complex (kind(0d0)) function rGam_hhh(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n

	rGam_hhh =&
		6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)&
		+Gam_hhh_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)

	end function
!=============================================================================
	double precision function decay_hgamgam(mch,mA,mbH,bmsq,alpha,beta,n,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n,ORQCD
	doubleprecision:: S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mh**2; mu=mh/2.d0

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	! call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	! decay_hgamgam=alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3*&
	! ABS(&
   !      xiu(alpha,beta,n)*Nc*Qt**2*I_f(mh,mt)*(&
   !      +1.d0&
   !      -1.d0*alphas(lam_QCD5,mh/2.d0,5.d0)/pi*S_NLOQCD&
   !      -(alphas(lam_QCD5,mh/2.d0,5.d0)/pi)**2&
   !       *(31.d0/24.d0+7.d0/4.d0*log((mh/2.d0)**2/mt**2) )*S_NNLOQCD)& 
	! +xid(alpha,beta,n)*Nc*Qb**2*I_f(mh,mb)&
	! +xil(alpha,beta,n)*Qe**2*I_f(mh,mtau)&
	! +I_W(mh)*dsin(beta-alpha)&
	! -I_S(mh,mch)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev&
	! )**2

	if (ORQCD == -1) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				xiu(alpha,beta,n)*Nc*Qt**2*I_f(mh,mt)&
            +xid(alpha,beta,n)*Nc*Qb**2*I_f(mh,mb)&
   			+xil(alpha,beta,n)*Qe**2*I_f(mh,mtau)&
   			+sin(beta-alpha)*I_W(mh)&
				-I_S(mh,mch)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev&
   		)**2
	else if (ORQCD == 0) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				xiu(alpha,beta,n)*Nc*Qt**2*(&
					rmt/mt*I_f(mh,mt)&
				)&
            +xid(alpha,beta,n)*Nc*Qb**2*(&
					rmb/mb*I_f(mh,mb)&
				)&
   			+xil(alpha,beta,n)*Qe**2*I_f(mh,mtau)&
   			+sin(beta-alpha)*I_W(mh)&
				-I_S(mh,mch)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev&
   		)**2
	else if (ORQCD == 1) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				xiu(alpha,beta,n)*Nc*Qt**2*rmt/mt*(&
					I_f(mh,mt)&
   				! NLO QCD
               -alphas(lam_QCD,mu,nf)/pi*C_H(mh,mt,mu)&
				)&
            +xid(alpha,beta,n)*Nc*Qb**2*rmb/mb*(&
					I_f(mh,mb)&
               ! NLO QCD
               -alphas(lam_QCD,mu,nf)/pi*C_H(mh,mb,mu)&
				)&
   			+xil(alpha,beta,n)*Qe**2*I_f(mh,mtau)&
   			+sin(beta-alpha)*I_W(mh)&
				-I_S(mh,mch)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev&
   		)**2
   else if (ORQCD == 2) then
      decay_hgamgam =&
   		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mh**3&
   		*abs(&
				xiu(alpha,beta,n)*Nc*Qt**2*rmt/mt*(&
					I_f(mh,mt)&
   				! NLO QCD
               -alphas(lam_QCD,mu,nf)/pi*C_H(mh,mt,mu)&
   				! NNLO QCD
   				-I_f(mh,mt)*(alphas(lam_QCD5,mh/2.d0,5.d0)/pi)**2*(&
   					31.d0/24.d0+7.d0/4.d0*log((mh/2.d0)**2/mt**2)&
					)&
				)&
            +xid(alpha,beta,n)*Nc*Qb**2*rmb/mb*(&
					I_f(mh,mb)&
               ! NLO QCD
               -alphas(lam_QCD,mu,nf)/pi*C_H(mh,mb,mu)&
				)&
   			+xil(alpha,beta,n)*Qe**2*I_f(mh,mtau)&
   			+sin(beta-alpha)*I_W(mh)&
				-I_S(mh,mch)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev&
   		)**2
   endif

	end function
!----------------------------------------
	double precision function decay_hZgam(mch,mA,mbH,bmsq,alpha,beta,n,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n,ORQCD
	double precision:: S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: g_HpHmZ
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mh**2; mu=mh/2.d0
	g_HpHmZ=gz/2.d0*(cw**2-sw**2)

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	! call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	! decay_hZgam=dsqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)*&
	! (1.d0-mz**2/mh**2)**3*&
	! abs(&
	! +xiu(alpha,beta,n)*Nc*Qt*vt*J_f(mh,mt)*(&
	! 	+1.d0&
	! 	-1.d0*alphas(lam_QCD5,mh/2.d0,5.d0)/pi*S_NLOQCD&
	! 	+0.d0*S_NNLOQCD)&
	! +xid(alpha,beta,n)*Nc*Qb*vb*J_f(mh,mb)&
	! +xil(alpha,beta,n)*Qe*ve*J_f(mh,mtau)&
	! +sin(beta-alpha)*J_W(mh)&
	! -lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev*g_HpHmZ*J_S(mh,mch)&
	! )**2

	if (ORQCD == -1) then
   	decay_hZgam =&
   		sqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)&
   		*(1.d0-mz**2/mh**2)**3&
   		*abs(&
				xiu(alpha,beta,n)*Nc*Qt*vt*J_f(mh,mt)&
   			+xid(alpha,beta,n)*Nc*Qb*vb*J_f(mh,mb)&
   			+xil(alpha,beta,n)*Qe*ve*J_f(mh,mtau)&
   			+sin(beta-alpha)*J_W(mh)&
				-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev*g_HpHmZ*J_S(mh,mch)&
   		)**2
   else if (ORQCD == 0) then
   	decay_hZgam =&
   		sqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)&
   		*(1.d0-mz**2/mh**2)**3&
   		*abs(&
				xiu(alpha,beta,n)*Nc*Qt*vt&
					*rmt/mt*J_f(mh,mt)&
   			+xid(alpha,beta,n)*Nc*Qb*vb&
					*rmb/mb*J_f(mh,mb)&
   			+xil(alpha,beta,n)*Qe*ve*J_f(mh,mtau)&
   			+sin(beta-alpha)*J_W(mh)&
				-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev*g_HpHmZ*J_S(mh,mch)&
   		)**2
	else if (1 <= ORQCD) then
   	decay_hZgam =&
   		sqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)&
   		*(1.d0-mz**2/mh**2)**3&
   		*abs(&
				xiu(alpha,beta,n)*Nc*Qt*vt*rmt/mt*J_f(mh,mt)*(&
					1.d0&
					! NLO QCD
               -alphas(lam_QCD,mu,nf)/pi&
				)&
   			+xid(alpha,beta,n)*Nc*Qb*vb*rmb/mb*J_f(mh,mb)&
   			+xil(alpha,beta,n)*Qe*ve*J_f(mh,mtau)&
   			+sin(beta-alpha)*J_W(mh)&
				-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)/vev*g_HpHmZ*J_S(mh,mch)&
   		)**2
   endif

	end function 
!----------------------------------------
	double precision function decay_hgg(mch,mA,mbH,bmsq,alpha,beta,n,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n,ORQCD
	doubleprecision:: S_NLOQCD,S_NNLOQCD,S_RMSM,AS
	double precision:: p1sq,p2sq,qsq
	double precision:: E_H1,dE_H1,E_H2,mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mh**2; mu=mh

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	! call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)
	! AS = alpha_s+(alphas(lam_QCD5,mh,5.d0)-alpha_s)*S_RMSM

	! decay_hgg=sqrt(2.d0)*G_F*AS**2*mh**3/(128.d0*pi**3)*&
	! ABS(xiu(alpha,beta,n)*I_f(mh,mt)+xid(alpha,beta,n)*I_f(mh,mb))**2&
   !       *(1.d0&
   !         +alphas(lam_QCD5,mh,5.d0)/pi*(95.d0/4.d0-7.d0/6.d0*5.d0&
   !         +(33.d0-2.d0*5.d0)/6.d0*log(mh**2/mh**2) )*S_NLOQCD&  ! NLO QCD
   !         +(156.808d0-5.708d0*log(mt**2/mh**2))*(alphas(lam_QCD5,mh,5.d0)/pi)**2*S_NNLOQCD) !NNLO QCD

	E_H1 = 0.d0; dE_H1 = 0.d0
	if(1 <= ORQCD) then
      if(mh < mt) then
   		E_H1 = 95.d0/4.d0-7.d0/6.d0*nf+(33.d0-2.d0*nf)/6.d0*log(mu**2/mh**2)
      else if(mt <= mh) then
         E_H1 = 11.d0/2.d0+(33.d0-2.d0*nf)/6.d0*log(mu**2/mh**2)
      endif
		dE_H1 =&
			dble(&
				(&
					xiu(alpha,beta,n)&
					*(B1_H(mh**2/(4.d0*mt**2))+(2.d0*C2_H(mh**2/(4.d0*mt**2)))*log(mu**2/mt**2))&
					+xid(alpha,beta,n)&
					*(B1_H(mh**2/(4.d0*mb**2))+(2.d0*C2_H(mh**2/(4.d0*mb**2)))*log(mu**2/mb**2))&
				)&
				/(&
					xiu(alpha,beta,n)*F0_H(mh**2/(4.d0*mt**2))&
					 +xid(alpha,beta,n)*F0_H(mh**2/(4.d0*mb**2))&
				)&
			)&
			-11.d0/2.d0
	endif

	E_H2 = 0.d0
	if(2 <= ORQCD .and. mh < mt) then
		E_H2 =&
			149533.d0/288.d0-363.d0/8.d0*zeta2-495.d0/8.d0*zeta3-19.d0/8.d0*log(mt**2/mh**2)&
			+nf*(-4157.d0/72.d0+11.d0/2.d0*zeta2+5.d0/4.d0*zeta3-2.d0/3.d0*log(mt**2/mh**2))&
			+nf**2*(127.d0/108.d0-1.d0/6.d0*zeta2)
	endif

	if (ORQCD == -1) then
   	decay_hgg =&
   		sqrt(2.d0)*G_F*alphas(lam_QCD,mu,nf)**2*mh**3/(128.d0*pi**3)&
   		*abs(&
				xiu(alpha,beta,n)*I_f(mh,mt)&
            +xid(alpha,beta,n)*I_f(mh,mb)&
         )**2
	else if (0 <= ORQCD) then
   	decay_hgg =&
			sqrt(2.d0)*G_F*alphas(lam_QCD,mh,nf)**2*mh**3/(128.d0*pi**3)&
			*abs(&
				rmt/mt*xiu(alpha,beta,n)*I_f(mh,mt)&
				+rmb/mb*xid(alpha,beta,n)*I_f(mh,mb)&
			)**2&
			*(&
				!LO
				+1.d0&
				!NLO QCD
				+alphas(lam_QCD,mu,nf)/pi*(E_H1+dE_H1)&
				!NNLO QCD
				+(alphas(lam_QCD,mu,nf)/pi)**2*E_H2&
			)
	endif

	end function 
!================================================
!    SECTION VI RGE                             !
!================================================
!--------- g1 ------------------
	double precision function g1(t0,t)
	double precision, intent(in)::  t0,t
	double precision c1
	c1= 20.d0/9.d0*ng+1.d0/6.d0*nh

	g1= gp/sqrt(1.d0-2.d0*c1*gp**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g2 ------------------
	double precision function g2(t0,t)
	double precision, intent(in)::  t0,t
	double precision c2
	c2=(-22.d0/3.d0+4.d0/3.d0*ng+1.d0/6.d0*nh)

	g2=g/sqrt(1.d0-2.d0*c2*g**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- g3 ------------------
	double precision function g3(t0,t)
	double precision, intent(in)::  t0,t
	double precision c3
	c3=(-11.d0+4.d0/3.d0*ng)

	g3=gs/sqrt(1.d0-2.d0*c3*gs**2*(t-t0)/(16.d0*pi**2))

	end function
!--------- beta(lam1) ------------------
	double precision function beta_lam1(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam1=1.d0/(16.d0*pi**2)*(&
                    12.d0*vlam1**2&
                    +4.d0*vlam3**2&
                    +2.d0*vlam4**2&
                    +4.d0*vlam3*vlam4&
                    +2.d0*vlam5**2&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    +3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam1*(3.d0*g2(t0,t)**2+g1(t0,t)**2)&
                   )

	end function
!--------- beta(lam2) ------------------
	double precision function beta_lam2(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

	beta_lam2=1.d0/(16.d0*pi**2)*(&
                    12.d0*vlam2**2&
                    +4.d0*vlam3**2&
                    +2.d0*vlam4**2&
                    +4.d0*vlam3*vlam4&
                    +2.d0*vlam5**2&
                    -12.d0*vyt**4&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    +3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam2*(3.d0*g2(t0,t)**2+g1(t0,t)**2-4.d0*vyt**2)&
                   )

	end function
!--------- beta(lam3) ------------------
	double precision function beta_lam3(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam3 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*(vlam1+vlam2)*(3.d0*vlam3+vlam4)&
                    +4.d0*vlam3**2+2.d0*vlam4**2+2.d0*vlam5**2&
                    +9.d0/4.d0*g2(t0,t)**4&
                    +3.d0/4.d0*g1(t0,t)**4&
                    -3.d0/2.d0*g1(t0,t)**2*g2(t0,t)**2&       
                    -3.d0*vlam3*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(lam4) ------------------
	double precision function beta_lam4(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam4 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*vlam4*(vlam1+vlam2+4.d0*vlam3+2.d0*vlam4)&
                    +8.d0*vlam5**2&
                    +3.d0*g1(t0,t)**2*g2(t0,t)**2&
                    -3.d0*vlam4*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(lam5) ------------------
	double precision function beta_lam5(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_lam5 = 1.d0/(16.d0*pi**2)*(&
                    2.d0*vlam5*(vlam1+vlam2+4.d0*vlam3+6.d0*vlam4)&
                    -3.d0*vlam5*(3.d0*g2(t0,t)**2 +g1(t0,t)**2-2.d0*vyt**2)&
                    )

	end function
!--------- beta(yt) ------------------
	double precision function beta_yt(t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision, intent(in)::  t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt

        beta_yt = 1.d0/(16.d0*pi**2)*(&
                  +9.d0/2.d0*vyt**3&
                 -vyt*(8.d0*g3(t0,t)**2+9.d0/4.d0*g2(t0,t)**2+17.d0/12.d0*g1(t0,t)**2)&
                 )

	end function
!================================================
!    SECTION VI SUBROUTINES                     !
!================================================
	subroutine RGE(t0,tfin,h,t,no,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
	double precision:: rk_lam1(4),rk_lam2(4), rk_lam3(4), rk_lam4(4), rk_lam5(4),rk_yt(4) 
	double precision, intent(in):: t0,tfin,t,h
	double precision :: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
	integer, intent(in):: no
! ----------------------------------------------------------------------------------
           rk_lam1(1)   = beta_lam1  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam2(1)   = beta_lam2  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam3(1)   = beta_lam3  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam4(1)   = beta_lam4  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_lam5(1)   = beta_lam5  (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
           rk_yt(1)     = beta_yt    (t0,t,vlam1,vlam2,vlam3,vlam4,vlam5,vyt)
!--------------- STEP 2 ----------------------------------------------------------------------------------
           rk_lam1(2)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam2(2)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam3(2)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam4(2)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_lam5(2)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
           rk_yt  (2)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(1)/2.d0,vlam2+h*rk_lam2(1)/2.d0,vlam3+h*rk_lam3(1)/2.d0,vlam4+h*rk_lam4(1)/2.d0,&
           vlam5+h*rk_lam5(1)/2.d0,vyt+h*rk_yt(1)/2.d0)
!--------------- STEP 3 ----------------------------------------------------------------------------------
           rk_lam1(3)   = beta_lam1  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam2(3)   = beta_lam2  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam3(3)   = beta_lam3  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam4(3)   = beta_lam4  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_lam5(3)   = beta_lam5  &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
           rk_yt  (3)   = beta_yt    &
           (t0,t+h/2.d0,vlam1+h*rk_lam1(2)/2.d0,vlam2+h*rk_lam2(2)/2.d0,vlam3+h*rk_lam3(2)/2.d0,vlam4+h*rk_lam4(2)/2.d0,&
           vlam5+h*rk_lam5(2)/2.d0,vyt+h*rk_yt(2)/2.d0)
!--------------- STEP 4 ----------------------------------------------------------------------------------
           rk_lam1(4)   = beta_lam1  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam2(4)   = beta_lam2  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam3(4)   = beta_lam3  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam4(4)   = beta_lam4  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_lam5(4)   = beta_lam5  &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
           rk_yt(4)     = beta_yt    &
           (t0,t+h,vlam1+h*rk_lam1(3),vlam2+h*rk_lam2(3),vlam3+h*rk_lam3(3),vlam4+h*rk_lam4(3),vlam5+h*rk_lam5(3),vyt+h*rk_yt(3))
!--------------- SUM ----------------------------------------------------------------------------------
           vlam1   = vlam1   + h/6.d0*(rk_lam1(1)   +2.d0*rk_lam1(2)   +2.d0*rk_lam1(3)   + rk_lam1(4))
           vlam2   = vlam2   + h/6.d0*(rk_lam2(1)   +2.d0*rk_lam2(2)   +2.d0*rk_lam2(3)   + rk_lam2(4))
           vlam3   = vlam3   + h/6.d0*(rk_lam3(1)   +2.d0*rk_lam3(2)   +2.d0*rk_lam3(3)   + rk_lam3(4))
           vlam4   = vlam4   + h/6.d0*(rk_lam4(1)   +2.d0*rk_lam4(2)   +2.d0*rk_lam4(3)   + rk_lam4(4))
           vlam5   = vlam5   + h/6.d0*(rk_lam5(1)   +2.d0*rk_lam5(2)   +2.d0*rk_lam5(3)   + rk_lam5(4))
           vyt     = vyt     + h/6.d0*(rk_yt  (1)   +2.d0*rk_yt  (2)   +2.d0*rk_yt  (3)   + rk_yt  (4))
	end subroutine 
!--------------------------------------------------------- 
        subroutine RGE_sm(t0,tfin,h,t,no,vlam2,vyt)
        double precision:: rk_lam1(4),rk_lam2(4), rk_lam3(4), rk_lam4(4), rk_lam5(4),rk_yt(4) 
        double precision, intent(in):: t0,tfin,t,h
        double precision :: vlam1,vlam2,vlam3,vlam4,vlam5,vyt
        integer, intent(in):: no
! ---------------------------------------------------------------------------------- 
           rk_lam2(1)   = beta_lam2  (t0,t,0.d0,vlam2,0.d0,0.d0,0.d0,vyt)
           rk_yt(1)     = beta_yt    (t0,t,0.d0,vlam2,0.d0,0.d0,0.d0,vyt)
!--------------- STEP 2 ----------------------------------------------------------------------------------  
           rk_lam2(2)   = beta_lam2 (t0,t+h/2.d0,0.d0,vlam2+h*rk_lam2(1)/2.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(1)/2.d0)
           rk_yt  (2)   = beta_yt   (t0,t+h/2.d0,0.d0,vlam2+h*rk_lam2(1)/2.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(1)/2.d0)
!--------------- STEP 3 ----------------------------------------------------------------------------------
           rk_lam2(3)   = beta_lam2 (t0,t+h/2.d0,0.d0,vlam2+h*rk_lam2(2)/2.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(2)/2.d0)
           rk_yt  (3)   = beta_yt   (t0,t+h/2.d0,0.d0,vlam2+h*rk_lam2(2)/2.d0,0.d0,0.d0,0.d0,vyt+h*rk_yt(2)/2.d0)
!--------------- STEP 4 ---------------------------------------------------------------------------------- 
           rk_lam2(4)   = beta_lam2  (t0,t+h,0.d0,vlam2+h*rk_lam2(3),0.d0,0.d0,0.d0,vyt+h*rk_yt(3))
           rk_yt(4)     = beta_yt    (t0,t+h,0.d0,vlam2+h*rk_lam2(3),0.d0,0.d0,0.d0,vyt+h*rk_yt(3))
!--------------- SUM ---------------------------------------------------------------------------------- 
            vlam2   = vlam2   + h/6.d0*(rk_lam2(1)   +2.d0*rk_lam2(2)   +2.d0*rk_lam2(3)   + rk_lam2(4))
            vyt     = vyt     + h/6.d0*(rk_yt  (1)   +2.d0*rk_yt  (2)   +2.d0*rk_yt  (3)   + rk_yt  (4))
        end subroutine

!---------------------------------------------------------
!    Decay of lightest CP even scalar: h(125)            !
!---------------------------------------------------------
! 	double precision function decay_hbb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
! 	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
! 	integer, intent(in):: n
! 	integer, intent(in):: OREW,ORQCD
	
! 	doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
! 	double precision:: p1sq,p2sq,qsq,CF,mu,rmb

! 	p1sq=mb**2; p2sq=mb**2; qsq=mh**2
! 	CF = 4.d0/3.d0
! 	mu = mh
! 	rmb = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD5,mb_MS,5.d0),mb_MS)
! 	call Switch_HOEW(OREW,S_NLOEW)
! 	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

! 	decay_hbb=&
! 		+3.d0*mh/8.d0/pi*(1.d0-4.d0*mb**2/mh**2)**(3.d0/2.d0)*&
!  			((mb+S_RMSM*(rmb-mb))/vev*xid(alpha,beta,n))**2*(&
! ! LO
! 			+1.d0&
! ! NLO Weak correction
! 		+(-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
! 			+2.d0*(1.d0/hbb_tree(alpha,beta,n))&
! 			*real(&
! 				+Gam_hbb_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
! 				+mb*(Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mb)&
!     		-Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mb))&
!     		+mh**2*(1.d0-mb**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mb)&
!    	))*S_NLOEW&
! ! NLO QED correction
! 		+alpha_em/pi*Qb**2*(&
! 	 		+17.d0/4.d0&
!  			+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
! 			+9.d0/4.d0*log(mu**2/mh**2)**2&
! 		)*S_NLOEW&           
! ! NLO QCD correction
! 		+alphas(lam_QCD5,mh,5.d0)/pi*CF*(&
! 	 		+17.d0/4.d0&
! 			+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
! 			+9.d0/4.d0*log(mu**2/mh**2)**2&
! 		)*S_NLOQCD&           
! ! NNLO QCD correction
! 	 	+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
! 		+xiu(alpha,beta,n)/xid(alpha,beta,n)&
! 			*(alphas(lam_QCD5,mh,5.d0)/pi)**2*(1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
! 			+1.d0/9.d0*(log(rmb**2/mh**2))**2)*S_NNLOQCD&          
! 	)

!  	end function
! !-------------------------------------------------------------------
!         double precision function decay_hcc(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
!         double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
!         integer, intent(in):: n
!         integer, intent(in):: OREW,ORQCD
!         doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
!         double precision:: p1sq,p2sq,qsq,CF,mu,rmc
!         p1sq=mc**2; p2sq=mc**2; qsq=mh**2
!         CF = 4.d0/3.d0; mu = mh
!         rmc = mq_bar(mh,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD4,mc_MS,4.d0),mc_MS)
!         call Switch_HOEW(OREW,S_NLOEW)
!         call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)


!         decay_hcc=&
!            3.d0*mh/8.d0/pi*(1.d0-4.d0*mc**2/mh**2)**(3.d0/2.d0)*&
!             ( (mc+S_RMSM*(rmc-mc))/vev*xiu(alpha,beta,n))**2*(&
! ! LO
!              1.d0&
! ! NLO Weak correction
!             +(-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
!             +2.d0*(1.d0/hcc_tree(alpha,beta,n))*real(&
!               Gam_hcc_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
!             +mc*(Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mc)&
!                    -Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mc) )&
!             +mh**2*(1.d0-mc**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mc)&
!                ) )*S_NLOEW&
! ! NLO  QED correction
!                    +alpha_em/pi*Qt**2*(17.d0/4.d0&
!                          +3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
!                         +9.d0/4.d0*log(mu**2/mh**2)**2 )*S_NLOEW&
! ! NLO QCD correction
!                     +alphas(lam_QCD5,mh,5.d0)/pi*CF*(17.d0/4.d0&
!                           +3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
!                           +9.d0/4.d0*log(mu**2/mh**2)**2 )*S_NLOQCD&
! ! NNLO QCD correction                          
!             +(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
!             +(alphas(lam_QCD5,mh,5.d0)/pi)**2*(1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
!             +1.d0/9.d0*(log(rmc**2/mh**2) )**2 )*S_NNLOQCD&
!                  )


!              end function

! ! !-------------------------------------------------------------------------  
!          double precision function decay_htautau(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
!          double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
!          integer, intent(in):: n, OREW
!          doubleprecision:: S_NLOEW
!          double precision:: p1sq,p2sq,qsq
!          p1sq=mtau**2; p2sq=mtau**2; qsq=mh**2
!          call Switch_HOEW(OREW,S_NLOEW)

!          decay_htautau=&
!          mh/8.d0/pi*(1.d0-4.d0*mtau**2/mh**2)**(3.d0/2.d0)*&
!          htautau_tree(alpha,beta,n)**2*(&
! ! LO
!           1.d0&
! ! NLO Weak correction
!            +(-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
!            +2.d0*(1.d0/htautau_tree(alpha,beta,n))*real(&
!              Gam_htautau_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
!               +mtau*(Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mtau)&
!                      -Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mtau) )&
!               +mh**2*(1.d0-mtau**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mtau)&
!               ) )*S_NLOEW&
! ! NLO QED correction
!               +Del_QED_hff(mtau)*S_NLOEW&  ! NLO QED correction (exaxt formula)
!              )

!          end function
! ! !-------------------------------------------------------------------------  
!          double precision function decay_hmumu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
!          double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
!          integer, intent(in):: n, OREW
!          doubleprecision:: S_NLOEW
!          double precision:: p1sq,p2sq,qsq
!          p1sq=mmu**2; p2sq=mmu**2; qsq=mh**2
!          call Switch_HOEW(OREW,S_NLOEW)

!          decay_hmumu=&
!          mh/8.d0/pi*(1.d0-4.d0*mmu**2/mh**2)**(3.d0/2.d0)*&
!          hmumu_tree(alpha,beta,n)**2*(&
! ! LO
!           1.d0&
! ! NLO Weak correction
!            +(-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
!            +2.d0*(1.d0/hmumu_tree(alpha,beta,n))*real(&
!              Gam_hmumu_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
!               +mmu*(Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mmu)&
!                      -Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mmu) )&
!               +mh**2*(1.d0-mmu**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mmu)&
!               ) )*S_NLOEW&
! ! NLO QED correction
!               +Del_QED_hff(mmu)*S_NLOEW&  ! NLO QED correction (exaxt formula)
!              )

!          end function
!-------------------------------------------------------------------------  
	double precision function decay_hbb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,CF,mu,rmb
	p1sq=mb**2; p2sq=mb**2; qsq=mh**2; mu = mh
	CF = 4.d0/3.d0
	
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	rmb = mq_bar(mu,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD5,mb_MS,5.d0),mb_MS)

	decay_hbb=&
		+3.d0*mh/8.d0/pi*(1.d0-4.d0*mb**2/mh**2)**(3.d0/2.d0)&
		*((mb+S_RMSM*(rmb-mb))/vev*xid(alpha,beta,n))**2&
		*(&
			! LO
			+1.d0&
			! NLO Weak correction
			+(&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
				+2.d0*(1.d0/hbb_tree(alpha,beta,n))&
				*real(&
					+Gam_hbb_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
						+mb*Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mb)&
						-mb*Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mb)&
					+mh**2*(1.d0-mb**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mb)&
				)&
			)*S_NLOEW&
			! ! NLO QED correction (MS bar sceme)
			! +alpha_em/pi*Qb**2*(&
			! 	17.d0/4.d0&
			! 	+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
			! 	+9.d0/4.d0*log(mu**2/mh**2)**2&
			! )*S_NLOEW&
			! NLO QCD correction
			+alphas(lam_QCD5,mh,5.d0)/pi*CF*(&
				+17.d0/4.d0&
				+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
				+9.d0/4.d0*log(mu**2/mh**2)**2&
			)*S_NLOQCD&
			! NNLO QCD correction
			+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
			+xiu(alpha,beta,n)/xid(alpha,beta,n)&
			*(alphas(lam_QCD5,mh,5.d0)/pi)**2*(&
				1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
				+1.d0/9.d0*(log(rmb**2/mh**2))**2&
			)*S_NNLOQCD&
		)&
		+3.d0*((mb+S_RMSM*(rmb-mb))**2/mb**2)*xid(alpha,beta,n)**2*decay_h_ffgam_sm(mb)*S_NLOEW

	end function
!-------------------------------------------------------------------
	double precision function decay_hcc(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	doubleprecision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,CF,mu,rmc
	p1sq=mc**2; p2sq=mc**2; qsq=mh**2; mu = mh
	CF = 4.d0/3.d0

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	rmc = mq_bar(mu,alphas(lam_QCD5,mh,5.d0),alphas(lam_QCD4,mc_MS,4.d0),mc_MS)

	decay_hcc=&
		3.d0*mh/8.d0/pi*(1.d0-4.d0*mc**2/mh**2)**(3.d0/2.d0)&
		*((mc+S_RMSM*(rmc-mc))/vev*xiu(alpha,beta,n))**2&
		*(&
			! LO
			1.d0&
			! NLO Weak correction
			+(&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
				+2.d0*(1.d0/hcc_tree(alpha,beta,n))*real(&
					Gam_hcc_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
					+mc*Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mc)&
					-mc*Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mc)&
					+mh**2*(1.d0-mc**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mc)&
				)&
			)*S_NLOEW&
			! ! NLO  QED correction (MS bar scheme)
			! +alpha_em/pi*Qt**2*(&
			! 	17.d0/4.d0&
			! 	+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
			! 	+9.d0/4.d0*log(mu**2/mh**2)**2&
			! )*S_NLOEW&
			! NLO QCD correction
			+alphas(lam_QCD5,mh,5.d0)/pi*CF*(&
				17.d0/4.d0&
				+3.d0/2.d0*log(mu**2/mh**2)+23.d0/2.d0*log(mu**2/mh**2)&
				+9.d0/4.d0*log(mu**2/mh**2)**2&
			)*S_NLOQCD&
			! NNLO QCD correction
			+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(35.94d0-1.36d0*5.d0)*S_NNLOQCD&
			+(alphas(lam_QCD5,mh,5.d0)/pi)**2*(&
				1.57d0-2.d0/3.d0*log(mh**2/mt**2)&
				+1.d0/9.d0*(log(rmc**2/mh**2) )**2&
			)*S_NNLOQCD&
		)&
		+3.d0*((mc+S_RMSM*(rmc-mc))**2/mc**2)*xiu(alpha,beta,n)**2*decay_h_ffgam_sm(mc)*S_NLOEW

	end function
!-------------------------------------------------------------------------  
	double precision function decay_htautau(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	doubleprecision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq
	p1sq=mtau**2; p2sq=mtau**2; qsq=mh**2

	call Switch_HOEW(OREW,S_NLOEW)

	decay_htautau=&
		mh/8.d0/pi*(1.d0-4.d0*mtau**2/mh**2)**(3.d0/2.d0)&
		*GamS_htautau_tree(alpha,beta,n)**2&
		*(&
			! LO
			1.d0&
			! NLO Weak correction
			+(&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
				+2.d0*(1.d0/GamS_htautau_tree(alpha,beta,n))*real(&
					Gam_htautau_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
					+mtau*Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mtau)&
					-mtau*Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mtau)&
					+mh**2*(1.d0-mtau**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mtau)&
				)&
			)*S_NLOEW&
			! ! NLO QED correction (exaxt formula)
			! +Del_QED_hff(mtau)*S_NLOEW&
		)&
		+xil(alpha,beta,n)**2*decay_h_ffgam_sm(mtau)*S_NLOEW

	end function
!-------------------------------------------------------------------------
	double precision function decay_hmumu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	doubleprecision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq
	p1sq=mmu**2; p2sq=mmu**2; qsq=mh**2

	call Switch_HOEW(OREW,S_NLOEW)

	decay_hmumu=&
		mh/8.d0/pi*(1.d0-4.d0*mmu**2/mh**2)**(3.d0/2.d0)&
		*hmumu_tree(alpha,beta,n)**2&
		*(&
			! LO
			1.d0&
			! NLO Weak correction
			+(&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
				+2.d0*(1.d0/hmumu_tree(alpha,beta,n))*real(&
					Gam_hmumu_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
					+mmu*Fhff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mmu)&
					-mmu*Fhff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mmu)&
					+mh**2*(1.d0-mmu**2/mh**2)*Fhff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mmu)&
				)&
			)*S_NLOEW&
			! ! NLO QED correction (exaxt formula)
			! +Del_QED_hff(mmu)*S_NLOEW&
		)&
		+xil(alpha,beta,n)**2*decay_h_ffgam_sm(mmu)*S_NLOEW

	end function
!-------- hZgam hgamgam vertex function at the 1-loop level --------------                                           
       complex (kind(0d0)) function rGam1_hZgam_F(p1sq,p2sq,qsq,alpha,beta,n)
       double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
       integer, intent(in)::n
       rGam1_hZgam_F=&
            xiu(alpha,beta,n)*nc*rGam1_hZgam_fermion(p1sq,p2sq,qsq,mt)&
           +xid(alpha,beta,n)*nc*rGam1_hZgam_fermion(p1sq,p2sq,qsq,mb)&
           +xiu(alpha,beta,n)*nc*rGam1_hZgam_fermion(p1sq,p2sq,qsq,mc)&
           +xil(alpha,beta,n)*rGam1_hZgam_fermion(p1sq,p2sq,qsq,mtau)
       end function
!-----------------------------------------------------------------     
       complex (kind(0d0)) function rGam2_hZgam_F(p1sq,p2sq,qsq,alpha,beta,n)
       double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
       integer, intent(in)::n
       rGam2_hZgam_F=&
            xiu(alpha,beta,n)*nc*rGam2_hZgam_fermion(p1sq,p2sq,qsq,mt)&
           +xid(alpha,beta,n)*nc*rGam2_hZgam_fermion(p1sq,p2sq,qsq,mb)&
           +xiu(alpha,beta,n)*nc*rGam2_hZgam_fermion(p1sq,p2sq,qsq,mc)&
           +xil(alpha,beta,n)*rGam2_hZgam_fermion(p1sq,p2sq,qsq,mtau)
       end function
!-----------------------------------------------------------------                         
       complex (kind(0d0)) function rGam1_hZgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

       rGam1_hZgam_S=&
            -4.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(g*sw)*gz*(cw**2-sw**2)*1.d0/16.d0/pi**2*&
            ( c24f(p1sq,p2sq,qsq,mch,mch,mch)-1.d0/4.d0*b0f(qsq,mch,mch))
        end function
!-----------------------------------------------------------------   
       complex (kind(0d0)) function rGam2_hZgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

       rGam2_hZgam_S=&
            -4.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(g*sw)*gz*(cw**2-sw**2)*1.d0/16.d0/pi**2*&
            ( c23f(p1sq,p2sq,qsq,mch,mch,mch)+c12f(p1sq,p2sq,qsq,mch,mch,mch))
        end function
!-----------------------------------------------------------------                                    
       complex (kind(0d0)) function rGam1_hZgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       rGam1_hZgam=&
            rGam1_hZgam_F(p1sq,p2sq,qsq,alpha,beta,n)&
           +sin(beta-alpha)*rGam1_hZgam_W_SM(p1sq,p2sq,qsq)&
           + rGam1_hZgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

       end function
!-----------------------------------------------------------------         
       complex (kind(0d0)) function rGam2_hZgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       rGam2_hZgam=&
            rGam2_hZgam_F(p1sq,p2sq,qsq,alpha,beta,n)&
           +sin(beta-alpha)*rGam2_hZgam_W_SM(p1sq,p2sq,qsq)&
           + rGam2_hZgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
       end function


!-----------------------------------------------------------------


       complex (kind(0d0)) function rGam1_hgamgam_F(p1sq,p2sq,qsq,alpha,beta,n)
       double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
       integer, intent(in)::n
       rGam1_hgamgam_F=&
            xiu(alpha,beta,n)*nc*rGam1_hgamgam_fermion(p1sq,p2sq,qsq,mt)&
           +xid(alpha,beta,n)*nc*rGam1_hgamgam_fermion(p1sq,p2sq,qsq,mb)&
           +xiu(alpha,beta,n)*nc*rGam1_hgamgam_fermion(p1sq,p2sq,qsq,mc)&
           +xil(alpha,beta,n)*rGam1_hgamgam_fermion(p1sq,p2sq,qsq,mtau)
       end function
!-----------------------------------------------------------------                                                                                       
       complex (kind(0d0)) function rGam2_hgamgam_F(p1sq,p2sq,qsq,alpha,beta,n)
       double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
       integer, intent(in)::n
       rGam2_hgamgam_F=&
            xiu(alpha,beta,n)*nc*rGam2_hgamgam_fermion(p1sq,p2sq,qsq,mt)&
           +xid(alpha,beta,n)*nc*rGam2_hgamgam_fermion(p1sq,p2sq,qsq,mb)&
           +xiu(alpha,beta,n)*nc*rGam2_hgamgam_fermion(p1sq,p2sq,qsq,mc)&
           +xil(alpha,beta,n)*rGam2_hgamgam_fermion(p1sq,p2sq,qsq,mtau)
       end function
!-----------------------------------------------------------------                
       complex (kind(0d0)) function rGam1_hgamgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

       rGam1_hgamgam_S=&
            -8.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(g*sw)**2*1.d0/16.d0/pi**2*&
            ( c24f(p1sq,p2sq,qsq,mch,mch,mch)-1.d0/4.d0*b0f(qsq,mch,mch))
        end function
!-----------------------------------------------------------------                                    
       complex (kind(0d0)) function rGam2_hgamgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

       rGam2_hgamgam_S=&
            -8.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(g*sw)**2*1.d0/16.d0/pi**2*&
            ( c23f(p1sq,p2sq,qsq,mch,mch,mch)+c12f(p1sq,p2sq,qsq,mch,mch,mch))
        end function
!-----------------------------------------------------------------                                                 
       complex (kind(0d0)) function rGam1_hgamgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       rGam1_hgamgam=&
            rGam1_hgamgam_F(p1sq,p2sq,qsq,alpha,beta,n)&
           +sin(beta-alpha)*rGam1_hgamgam_W_SM(p1sq,p2sq,qsq)&
           + rGam1_hgamgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

       end function
!-----------------------------------------------------------------         
       complex (kind(0d0)) function rGam2_hgamgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       rGam2_hgamgam=&
            rGam2_hgamgam_F(p1sq,p2sq,qsq,alpha,beta,n)&
           +sin(beta-alpha)*rGam2_hgamgam_W_SM(p1sq,p2sq,qsq)&
           + rGam2_hgamgam_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
       end function



!------------------ dGamma( h-->Zff )/dqsq  at NLO ------------------     
       double precision function dGam_dqsq_hZZ_NLO(qsq,vf,af,Iff,Qf,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,vf,af,Iff,Qf
       double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       double precision:: epsZ,epsQ,x1,x2,ckin_a,ckin_b,s24,s23
       epsZ=mZ**2/mh**2
       epsQ=qsq/mh**2
       x1=1.d0+epsZ-epsQ
       ckin_a=sqrt(x1**2-4.d0*epsZ)*((x1-6.d0*epsZ)**2+8.d0*epsZ*(1.d0-3.d0*epsZ))
       ckin_b=(x1**2-4.d0*epsZ)**(3.d0/2.d0)*(x1-2.d0*epsZ)*mh**2/2.d0
! note: this calcration is not included contributuion from hff vertex corrections and box diagrams  
       dGam_dqsq_hZZ_NLO=&
            sin(beta-alpha)**2*mh**3*gz**4/384.d0/pi**3*(vf**2+af**2)/(qsq-mz**2)**2*ckin_a*(&
            1.d0/2.d0&                                                                                    ! Tree cont.
                 -(Del_r(mch,mA,mbH,bmsq,alpha,beta,n))&                                              ! Delta_r
                     -1.d0/2.d0*real(rdPiZZ(mZ**2,mch,mA,mbH,bmsq,alpha,beta,n))&                         ! dPiZZ 
                      +1.d0/(sin(beta-alpha)*2.d0*mZ**2/vev)*(&
                     +real(Gam1_hZZ_loop(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n)) &                 ! hZZ Gam1 NLO cont.
                     +ckin_b/ckin_a*real(rGam2_hZZ(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))/mZ**2)& ! hZZ Gam2 NLO cont.
                     -real(rPiZZ(qsq,mch,mA,mbH,bmsq,alpha,beta,n))/(qsq-mZ**2)&                          ! PiZZ cont. 
                     +1.d0/(vf**2+af**2)*(&
                       (qsq-mZ**2)/(qsq)*vf*Qf*cw*sw*(& 
                       1.d0/(sin(beta-alpha)*2.d0*mZ**2/vev)*(&
                       +real(rGam1_hZgam(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))&                  ! hZGam Gam1
                       +ckin_b/ckin_a*real(rGam2_hZgam(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n)) )&  ! hZGam Gam2
                       -real(rPiZG(qsq,mch,mA,mbH,bmsq,alpha,beta,n))/(qsq-mZ**2)&                        ! PiZG cont.
                     )&
                      -1.d0/(gz)*(&
                             +vf*real(rGamV_Zff_loop_SM(qsq,vf,af,Iff))&                                  ! ZffV NLO cont. 
                            -af*real(rGamA_Zff_loop_SM(qsq,vf,af,Iff))&                                   ! ZffA NLO cont.
                                              )&
                       )&
!           
                      ) 

       end function

!------------------ dGamma( h-->Zff )/dqsqdcos  at NLO ------------------ 
       double precision function dGam_dqsqdcos_hZZ_NLO(qsq,cos_the,vf,af,Iff,Qf,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,cos_the,vf,af,Iff,Qf
       double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       double precision:: epsZ,epsQ,x1,x2,ckin1,ckin2,s24,s23

       epsZ=mZ**2/mh**2
       epsQ=qsq/mh**2
       x1=1.d0+epsZ-epsQ
       x2=1.d0/2.d0*(2.d0-x1+sqrt(x1**2-4.d0*mZ**2/mh**2)*cos_the)
       s24=mh**2*(1.d0-x2)
       s23=mh**2+mZ**2-qsq-s24
       ckin1=4.d0*qsq+2.d0/mZ**2*(s24*s23-mh**2*mZ**2)
       ckin2=1.d0/mZ**2*(s24*s23-mh**2*mZ**2)*(mh**2-mZ**2-qsq)

       dGam_dqsqdcos_hZZ_NLO= 1.d0/(256.d0*pi**3*mh)*&
            sin(beta-alpha)**2*8.d0*(mZ**4/vev**2)*gz**2*(vf**2+af**2)&
            *(1.d0/2.d0)*sqrt(x1**2-4.d0*epsZ)/(qsq-mZ**2)**2*ckin1*(&
           1.d0/2.d0&                                                                            ! Tree cont.
              -(Del_r(mch,mA,mbH,bmsq,alpha,beta,n))&                                        ! Delta_r
              -1.d0/2.d0*real(rdPiZZ(mZ**2,mch,mA,mbH,bmsq,alpha,beta,n))&                       ! dPiZZ 
              +1.d0/(sin(beta-alpha)*2.d0*mZ**2/vev)*(&
              +real(Gam1_hZZ_loop(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))&                ! hZZ Gam1 NLO cont.
              +ckin2/ckin1*real(rGam2_hZZ(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))/mZ**2)& ! hZZ Gam2 NLO cont.
              -real(rPiZZ(qsq,mch,mA,mbH,bmsq,alpha,beta,n))/(qsq-mZ**2)&                        ! PiZZ cont.
               +1.d0/(vf**2+af**2)*(&
                 (qsq-mZ**2)/(qsq)*vf*Qf*cw*sw*(&
                 1.d0/(sin(beta-alpha)*2.d0*mZ**2/vev)*(&
                 +real(rGam1_hZgam(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))&               ! hZGam Gam1
                 +ckin2/ckin1*real(rGam2_hZgam(mZ**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n)) )& ! hZGam Gam2                           
                 -real(rPiZG(qsq,mch,mA,mbH,bmsq,alpha,beta,n))/(qsq-mZ**2)&                     ! PiZG cont.
               )&
               -1.d0/(gz)*(&
                      +vf*real(rGamV_Zff_loop_SM(qsq,vf,af,Iff))&                                ! ZffV NLO cont.
                     -af*real(rGamA_Zff_loop_SM(qsq,vf,af,Iff))&                                 ! ZffA NLO cont.
                                       )&

                 +(qsq-mZ**2)*Thff_Z_SM(vf,af,qsq,cos_the)&                                      ! hff NLO cont.
                 +(qsq-mZ**2)*B_Z_box(vf,af,qsq,cos_the)/ckin1&                                  ! Box NLO cont.
                 )&
 
                 +Qf**2*(1.d0/2.d0)*3.d0/4.d0/pi*alpha_em&                                       ! QED correction
                 )

       end function

!dqsq ---------------------------------------------------
!h->Znunu
       double precision function TyI_dGam_dqsq_hZnunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyI_dGam_dqsq_hZnunu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vnu,anu,It,0.d0,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
!------------------------------------------------------------------ 
       double precision function TyII_dGam_dqsq_hZnunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyII_dGam_dqsq_hZnunu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vnu,anu,It,0.d0,mch,mA,mbH,bmsq,alpha,beta,2)
       end function
!------------------------------------------------------------------ 
       double precision function TyX_dGam_dqsq_hZnunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyX_dGam_dqsq_hZnunu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vnu,anu,It,0.d0,mch,mA,mbH,bmsq,alpha,beta,3)
       end function
!------------------------------------------------------------------ 
       double precision function TyY_dGam_dqsq_hZnunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyY_dGam_dqsq_hZnunu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vnu,anu,It,0.d0,mch,mA,mbH,bmsq,alpha,beta,4)
       end function
!------------------------------------------------------------------ 
!h->Zee
       double precision function TyI_dGam_dqsq_hZee_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyI_dGam_dqsq_hZee_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,ve,ae,Ie,Qe,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
!------------------------------------------------------------------ 
       double precision function TyII_dGam_dqsq_hZee_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyII_dGam_dqsq_hZee_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,ve,ae,Ie,Qe,mch,mA,mbH,bmsq,alpha,beta,2)
       end function
!------------------------------------------------------------------ 
       double precision function TyX_dGam_dqsq_hZee_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyX_dGam_dqsq_hZee_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,ve,ae,Ie,Qe,mch,mA,mbH,bmsq,alpha,beta,3)
       end function
!------------------------------------------------------------------ 
       double precision function TyY_dGam_dqsq_hZee_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyY_dGam_dqsq_hZee_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,ve,ae,Ie,Qe,mch,mA,mbH,bmsq,alpha,beta,4)
       end function
! ---------------------------------------------------
!h->Zuu
       double precision function TyI_dGam_dqsq_hZuu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyI_dGam_dqsq_hZuu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vt,at,It,Qt,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
! ---------------------------------------------------
       double precision function TyII_dGam_dqsq_hZuu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyII_dGam_dqsq_hZuu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vt,at,It,Qt,mch,mA,mbH,bmsq,alpha,beta,2)
       end function
! ---------------------------------------------------
       double precision function TyX_dGam_dqsq_hZuu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyX_dGam_dqsq_hZuu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vt,at,It,Qt,mch,mA,mbH,bmsq,alpha,beta,3)
       end function
! ---------------------------------------------------
       double precision function TyY_dGam_dqsq_hZuu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyY_dGam_dqsq_hZuu_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vt,at,It,Qt,mch,mA,mbH,bmsq,alpha,beta,4)
       end function
!------------------------------------------------------------------ 
!h->Zdd
       double precision function TyI_dGam_dqsq_hZdd_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyI_dGam_dqsq_hZdd_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vb,ab,Ib,Qb,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
!------------------------------------------------------------------ 
       double precision function TyII_dGam_dqsq_hZdd_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyII_dGam_dqsq_hZdd_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vb,ab,Ib,Qb,mch,mA,mbH,bmsq,alpha,beta,2)
       end function
!------------------------------------------------------------------ 
       double precision function TyX_dGam_dqsq_hZdd_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyX_dGam_dqsq_hZdd_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vb,ab,Ib,Qb,mch,mA,mbH,bmsq,alpha,beta,3)
       end function
!------------------------------------------------------------------ 
       double precision function TyY_dGam_dqsq_hZdd_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyY_dGam_dqsq_hZdd_NLOEW= &
              dGam_dqsq_hZZ_NLO(qsq,vb,ab,Ib,Qb,mch,mA,mbH,bmsq,alpha,beta,4)
       end function

! dqsq, dcosθ ---------------------------------------------------------
!h->Znunu
       double precision function TyI_dGam_dqsqdcos_hZnunu_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyI_dGam_dqsqdcos_hZnunu_NLOEW= &
              dGam_dqsqdcos_hZZ_NLO(qsq,cos_the,vnu,anu,It,0.d0,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
!------------------------------------------------------------------   
       double precision function TyII_dGam_dqsqdcos_hZnunu_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyII_dGam_dqsqdcos_hZnunu_NLOEW= &
              dGam_dqsqdcos_hZZ_NLO(qsq,cos_the,vnu,anu,It,0.d0,mch,mA,mbH,bmsq,alpha,beta,2)
       end function
!------------------------------------------------------------------       
!h->Zee
       double precision function TyI_dGam_dqsqdcos_hZee_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyI_dGam_dqsqdcos_hZee_NLOEW= &
              dGam_dqsqdcos_hZZ_NLO(qsq,cos_the,ve,ae,Ie,Qe,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
!------------------------------------------------------------------       
       double precision function TyII_dGam_dqsqdcos_hZee_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyII_dGam_dqsqdcos_hZee_NLOEW= &
              dGam_dqsqdcos_hZZ_NLO(qsq,cos_the,ve,ae,Ie,Qe,mch,mA,mbH,bmsq,alpha,beta,2)
       end function

!------------------ dGamma( h-->Wffp )/dqsq  at NLO ------------------       
       double precision function dGam_dqsq_hWW_NLO(qsq,mf,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,mf,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       double precision:: epsW,epsQ,x1,ckin_a,ckin_b
       epsW=mW**2/mh**2
       epsQ=qsq/mh**2
       x1=1.d0+epsW-epsQ
       ckin_a=sqrt(x1**2-4.d0*epsW)*((x1-6.d0*epsW)**2+8.d0*epsW*(1.d0-3.d0*epsW))
       ckin_b=(x1**2-4.d0*epsW)**(3.d0/2.d0)*(x1-2.d0*epsW)*mh**2/2.d0
! note: this calcration is not included contributuion from hff vertex corrections and box diagrams
       dGam_dqsq_hWW_NLO= &
           sin(beta-alpha)**2*mh**3*(2.d0*mW**2/vev)**2/384.d0/pi**3/vev**2/(qsq-mW**2)**2*ckin_a*(&
           1.d0/2.d0&                                                                                         ! Tree cont.  
               -(Del_r(mch,mA,mbH,bmsq,alpha,beta,n) )&                                                   ! Delta_r      
               -1.d0/2.d0*real(rdPiWW(mW**2,mch,mA,mbH,bmsq,alpha,beta,n))&                                   ! rdPiWW    
               +1.d0/(sin(beta-alpha)*2.d0*mW**2/vev)*(&
                        +real(Gam1_hWW_loop(mW**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))&                   ! hWW Gam1 NLO cont.   
                        +ckin_b/ckin_a*real(rGam2_hWW(mW**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))/mW**2)&  ! hWW Gam2 NLO cont. 
               -real(rPiWW(qsq,mch,mA,mbH,bmsq,alpha,beta,n))/(qsq-mW**2)&                                    ! PiWW cont.  
               -sqrt(2.d0)/g*real(rGam_Wffp_loop_SM(qsq,mf)) &                                                ! Wff NLO cont.  
            )

       end function


!------------------ dGamma( h-->Wffp )/dqsqdcos  at NLO ------------------  
       double precision function dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mf,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,cos_the,mf,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
       double precision:: epsW,epsQ,x1,x2,ckin1,ckin2,ckin3,s24,s23,vf,vfp,Qf,Qfp,af,afp
! Be careful, if fermion masses digenerate, the bellow if sentence does not work.  
        if (mf == mc) then
        vf = vt ; af = at ; Qf = Qt
        vfp = vb ; afp = ab ; Qfp = Qb
        elseif (mf == msir) then
        vf = vb ; af = ab ; Qf = Qb
        vfp  = vt ; afp  = at ; Qfp  = Qt
        elseif (mf == mtau) then
        vf = ve ; af = ae ; Qf = Qe
        vfp = vnu ; afp = anu ; Qfp = 0.d0
        elseif (mf == mmu) then
        vf = ve ; af = ae ; Qf = Qe
        vfp = vnu ; afp = anu ; Qfp = 0.d0
        endif
       epsW=mW**2/mh**2
       epsQ=qsq/mh**2
       x1=1.d0+epsW-epsQ
       x2=1.d0/2.d0*(2.d0-x1+sqrt(x1**2-4.d0*mW**2/mh**2)*cos_the)
       s24=mh**2*(1.d0-x2)
       s23=mh**2+mW**2-qsq-s24
       ckin1=4.d0*qsq+2.d0/mW**2*(s24*s23-mh**2*mW**2)
       ckin2=1.d0/mW**2*(s24*s23-mh**2*mW**2)*(mh**2-mW**2-qsq)
       ckin3=2.d0*qsq*(s24-s23)

       dGam_dqsqdcos_hWW_NLO= 1.d0/(256.d0*pi**3*mh)*&
            sin(beta-alpha)**2*2.d0*g**2*(mW**2/vev)**2&
            *(1.d0/2.d0)*sqrt(x1**2-4.d0*epsW)/(qsq-mW**2)**2*ckin1*(&
            1.d0/2.d0&                                                                                   ! Tree cont.
                    -(Del_r(mch,mA,mbH,bmsq,alpha,beta,n) )&                                         ! Delta_r 
                    -1.d0/2.d0*real(rdPiWW(mW**2,mch,mA,mbH,bmsq,alpha,beta,n) )&                        ! rdPiWW 
                      +1.d0/(sin(beta-alpha)*2.d0*mW**2/vev)*(&
                      +real(Gam1_hWW_loop(mW**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))&                ! hWW Gam1 NLO cont.
                      +ckin2/ckin1*real(rGam2_hWW(mW**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))/mW**2&  ! hWW Gam2 NLO cont.
                      +ckin3/ckin1*real(rGam3_hWW(mW**2,qsq,mh**2,mch,mA,mbH,bmsq,alpha,beta,n))/mW**2)& ! hWW Gam3 NLO cont.  
                      -real(rPiWW(qsq,mch,mA,mbH,bmsq,alpha,beta,n) )/(qsq-mW**2)&                       ! PiWW cont.
                      -sqrt(2.d0)/g*real(rGam_Wffp_loop_SM(qsq,mf))&
                    +(qsq-mW**2)*Thff_W_SM(vf,af,qsq,cos_the)&                                           ! hff NLO cont.
                    +(qsq-mW**2)*B_W_box(qsq,cos_the,mf)/ckin1&                                          ! Box NLO cont. 
!
                   +1.d0/2.d0*Del_soft_Wffp(qsq,cos_the,mf,0.1d0)&                                       ! soft photon contriburion  !final valuables in the argument is delE  
                )
       end function

! dqsq ------------------------------------------------------------------    
! h->Wnumu
       double precision function TyI_dGam_dqsq_hWmunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyI_dGam_dqsq_hWmunu_NLOEW= &
            dGam_dqsq_hWW_NLO(qsq,mmu,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
!------------------------------------------------------------------    
       double precision function TyII_dGam_dqsq_hWmunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyII_dGam_dqsq_hWmunu_NLOEW= &
            dGam_dqsq_hWW_NLO(qsq,mmu,mch,mA,mbH,bmsq,alpha,beta,2)
       end function
!------------------------------------------------------------------    
       double precision function TyX_dGam_dqsq_hWmunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyX_dGam_dqsq_hWmunu_NLOEW= &
            dGam_dqsq_hWW_NLO(qsq,mmu,mch,mA,mbH,bmsq,alpha,beta,3)
       end function
!------------------------------------------------------------------    
       double precision function TyY_dGam_dqsq_hWmunu_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyY_dGam_dqsq_hWmunu_NLOEW= &
            dGam_dqsq_hWW_NLO(qsq,mmu,mch,mA,mbH,bmsq,alpha,beta,4)
       end function
!------------------------------------------------------------------    
! h->Wcs
       double precision function TyI_dGam_dqsq_hWcs_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyI_dGam_dqsq_hWcs_NLOEW= &
            3.d0*dGam_dqsq_hWW_NLO(qsq,mc,mch,mA,mbH,bmsq,alpha,beta,1) ! 3 is color factor!!!
       end function
!------------------------------------------------------------------    
       double precision function TyII_dGam_dqsq_hWcs_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyII_dGam_dqsq_hWcs_NLOEW= &
            3.d0*dGam_dqsq_hWW_NLO(qsq,mc,mch,mA,mbH,bmsq,alpha,beta,2) ! 3 is color factor!!!
       end function
!------------------------------------------------------------------    
       double precision function TyX_dGam_dqsq_hWcs_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyX_dGam_dqsq_hWcs_NLOEW= &
            3.d0*dGam_dqsq_hWW_NLO(qsq,mc,mch,mA,mbH,bmsq,alpha,beta,3) ! 3 is color factor!!!
       end function
!------------------------------------------------------------------    
       double precision function TyY_dGam_dqsq_hWcs_NLOEW(qsq)
       double precision, intent(in):: qsq
       TyY_dGam_dqsq_hWcs_NLOEW= &
            3.d0*dGam_dqsq_hWW_NLO(qsq,mc,mch,mA,mbH,bmsq,alpha,beta,4) ! 3 is color factor!!!
       end function
!dqsq, dcos------------------------------------------------------------------    
! h -> Wnumu
       double precision function TyI_dGam_dqsqdcos_hWmunu_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyI_dGam_dqsqdcos_hWmunu_NLOEW= &
            dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mmu,mch,mA,mbH,bmsq,alpha,beta,1)
       end function
!------------------------------------------------------------------    
       double precision function TyII_dGam_dqsqdcos_hWmunu_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyII_dGam_dqsqdcos_hWmunu_NLOEW= &
            dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mmu,mch,mA,mbH,bmsq,alpha,beta,2)
       end function
!------------------------------------------------------------------    
       double precision function TyX_dGam_dqsqdcos_hWmunu_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyX_dGam_dqsqdcos_hWmunu_NLOEW= &
            dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mmu,mch,mA,mbH,bmsq,alpha,beta,3)
       end function
!------------------------------------------------------------------    
       double precision function TyY_dGam_dqsqdcos_hWmunu_NLOEW(qsq,cos_the)
       double precision, intent(in):: qsq,cos_the
       TyY_dGam_dqsqdcos_hWmunu_NLOEW= &
            dGam_dqsqdcos_hWW_NLO(qsq,cos_the,mmu,mch,mA,mbH,bmsq,alpha,beta,4)
       end function

!------------------------------------------------------------------ 
       subroutine decay_hZZstar(vhZZstar,vhZnunu_TB,vhZee_TB,vhZuu_TB,vhZdd_TB,OREW,ORQCD,alpha,beta,n)
       double precision, intent(out):: vhZZstar
       double precision, intent(in):: alpha,beta,vhZnunu_TB,vhZee_TB,vhZuu_TB,vhZdd_TB
       integer, intent(in):: n,OREW,ORQCD
       double precision:: vhZnunu,vhZee,vhZuu,vhZdd,dummy
       double precision,parameter:: epsi=0.0001d0, mm = 0.1d0
       vhZZstar=0.d0
       vhZnunu=0.d0;vhZee=0.d0;vhZuu=0.d0;vhZdd=0.d0;dummy=0.d0
![EW=NLO, QCD=NNLO,NLO,LO], Type-I ~~~~~~~~~~~~~~~
        if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==1) then
        call romberg(vhZnunu,TyI_dGam_dqsq_hZnunu_NLOEW,0.d0+epsi,(mh-mZ)**2-epsi) ! h->Znunu 
        vhZnunu=vhZnunu + sin(beta-alpha)**2*vhZnunu_TB
        call romberg(vhZee,TyI_dGam_dqsq_hZee_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)  !h->Zee 
        vhZee = vhZee+sin(beta-alpha)**2*vhZee_TB
        call romberg(vhZuu,TyI_dGam_dqsq_hZuu_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi) ! h->Zuu
        vhZuu=vhZuu+sin(beta-alpha)**2*vhZuu_TB
        call romberg(vhZdd,TyI_dGam_dqsq_hZdd_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)! h->Zdd
        vhZdd = vhZdd+ sin(beta-alpha)**2*vhZdd_TB
        vhZZstar=3.d0*vhZnunu+3.d0*vhZee +6.d0*vhZuu+9.d0*vhZdd
![EW=NLO, QCD=NNLO,NLO,LO], Type-II ~~~~~~~~~~~~~~~
        else if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==2) then
        call romberg(vhZnunu,TyII_dGam_dqsq_hZnunu_NLOEW,0.d0+epsi,(mh-mZ)**2-epsi) ! h->Znunu 
        vhZnunu=vhZnunu + sin(beta-alpha)**2*vhZnunu_TB
        call romberg(vhZee,TyII_dGam_dqsq_hZee_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)  !h->Zee 
        vhZee = vhZee+sin(beta-alpha)**2*vhZee_TB
        call romberg(vhZuu,TyII_dGam_dqsq_hZuu_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi) ! h->Zuu
        vhZuu=vhZuu+sin(beta-alpha)**2*vhZuu_TB
        call romberg(vhZdd,TyII_dGam_dqsq_hZdd_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)! h->Zdd
        vhZdd = vhZdd+ sin(beta-alpha)**2*vhZdd_TB
        vhZZstar=3.d0*vhZnunu+3.d0*vhZee +6.d0*vhZuu+9.d0*vhZdd
![EW=NLO, QCD=NNLO,NLO,LO], Type-X ~~~~~~~~~~~~~~~
        else if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==3) then
        call romberg(vhZnunu,TyX_dGam_dqsq_hZnunu_NLOEW,0.d0+epsi,(mh-mZ)**2-epsi) ! h->Znunu 
        vhZnunu=vhZnunu + sin(beta-alpha)**2*vhZnunu_TB
        call romberg(vhZee,TyX_dGam_dqsq_hZee_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)  !h->Zee 
        vhZee = vhZee+sin(beta-alpha)**2*vhZee_TB
        call romberg(vhZuu,TyX_dGam_dqsq_hZuu_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi) ! h->Zuu
        vhZuu=vhZuu+sin(beta-alpha)**2*vhZuu_TB
        call romberg(vhZdd,TyX_dGam_dqsq_hZdd_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)! h->Zdd
        vhZdd = vhZdd+ sin(beta-alpha)**2*vhZdd_TB
        vhZZstar=3.d0*vhZnunu+3.d0*vhZee +6.d0*vhZuu+9.d0*vhZdd
![EW=NLO, QCD=NNLO,NLO,LO], Type-Y ~~~~~~~~~~~~~~~
        else if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==4) then
        call romberg(vhZnunu,TyY_dGam_dqsq_hZnunu_NLOEW,0.d0+epsi,(mh-mZ)**2-epsi) ! h->Znunu 
        vhZnunu=vhZnunu + sin(beta-alpha)**2*vhZnunu_TB
        call romberg(vhZee,TyY_dGam_dqsq_hZee_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)  !h->Zee 
        vhZee = vhZee+sin(beta-alpha)**2*vhZee_TB
        call romberg(vhZuu,TyY_dGam_dqsq_hZuu_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi) ! h->Zuu
        vhZuu=vhZuu+sin(beta-alpha)**2*vhZuu_TB
        call romberg(vhZdd,TyY_dGam_dqsq_hZdd_NLOEW,(2.d0*mm)**2+epsi,(mh-mZ)**2-epsi)! h->Zdd
        vhZdd = vhZdd+ sin(beta-alpha)**2*vhZdd_TB
        vhZZstar=3.d0*vhZnunu+3.d0*vhZee +6.d0*vhZuu+9.d0*vhZdd
![EW=LO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~~~~~~~~~
        else if (OREW == 0 .and. ORQCD .ge.-1 .and. ORQCD .le.2 ) then 
        call decay_hZZstar_sm(vhZZstar,dummy,dummy,dummy,dummy,OREW,ORQCD)
        vhZZstar = sin(beta-alpha)**2*vhZZstar
        else
        vhZZstar = 0.d0

        end if
        end subroutine
!------------------------------------------------------------------ 
	subroutine decay_hWWstar(vhWWstar,vhWcs_TBSH,vhWmunu_TBSH,OREW,ORQCD,alpha,beta,n)
	double precision, intent(out):: vhWWstar
	double precision, intent(in):: vhWcs_TBSH,vhWmunu_TBSH,alpha,beta
	Integer, intent(in)::n,OREW,ORQCD
	double precision:: vhWcs,vhWmunu,dummy
	double precision,parameter:: epsi=0.0001d0,epsics=0.1d0 !comment:if epsics = epsi,the cancellation of div parameter doesn't happen for h->Wcs 
	vhWWstar=0.d0
	vhWcs=0.d0;vhWmunu=0.d0;dummy=0.d0

	![EW=NLO, QCD=NNLO,NLO,LO], Type-I ~~~~~~~~~~~~~~~ 
	if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==1) then
		call romberg(vhWcs,TyI_dGam_dqsq_hWcs_NLOEW,(mc+msir)**2+epsics,(mh-mW)**2-epsics) ! h->W-cs~ 
		vhWcs= vhWcs+sin(beta-alpha)**2*vhWcs_TBSH
		call romberg(vhWmunu,TyI_dGam_dqsq_hWmunu_NLOEW,(2.d0*mmu)**2+epsi,(mh-mW)**2-epsi)! h->W+mu-n
		vhWmunu=vhWmunu+sin(beta-alpha)**2*vhWmunu_TBSH
		vhWWstar =  2.d0*(3.d0*vhWmunu+2.d0*vhWcs)
	![EW=NLO, QCD=NNLO,NLO,LO], Type-II ~~~~~~~~~~~~~~~
	else if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==2) then
		call romberg(vhWcs,TyII_dGam_dqsq_hWcs_NLOEW,(mc+msir)**2+epsics,(mh-mW)**2-epsics) ! h->W-cs~ 
		vhWcs= vhWcs+sin(beta-alpha)**2*vhWcs_TBSH
		call romberg(vhWmunu,TyII_dGam_dqsq_hWmunu_NLOEW,(2.d0*mmu)**2+epsi,(mh-mW)**2-epsi)! h->W+mu-n
		vhWmunu=vhWmunu+sin(beta-alpha)**2*vhWmunu_TBSH
		vhWWstar =  2.d0*(3.d0*vhWmunu+2.d0*vhWcs)
	![EW=NLO, QCD=NNLO,NLO,LO], Type-X ~~~~~~~~~~~~~~~
	else if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==3) then
		call romberg(vhWcs,TyX_dGam_dqsq_hWcs_NLOEW,(mc+msir)**2+epsics,(mh-mW)**2-epsics) ! h->W-cs~ 
		vhWcs= vhWcs+sin(beta-alpha)**2*vhWcs_TBSH
		call romberg(vhWmunu,TyX_dGam_dqsq_hWmunu_NLOEW,(2.d0*mmu)**2+epsi,(mh-mW)**2-epsi)! h->W+mu-n
		vhWmunu=vhWmunu+sin(beta-alpha)**2*vhWmunu_TBSH
		vhWWstar =  2.d0*(3.d0*vhWmunu+2.d0*vhWcs)
	![EW=NLO, QCD=NNLO,NLO,LO], Type-Y ~~~~~~~~~~~~~~~
	else if (OREW == 1 .and. ORQCD .ge.-1 .and. ORQCD.le.2 .and.n ==4) then
		call romberg(vhWcs,TyY_dGam_dqsq_hWcs_NLOEW,(mc+msir)**2+epsics,(mh-mW)**2-epsics) ! h->W-cs~ 
		vhWcs= vhWcs+sin(beta-alpha)**2*vhWcs_TBSH
		call romberg(vhWmunu,TyY_dGam_dqsq_hWmunu_NLOEW,(2.d0*mmu)**2+epsi,(mh-mW)**2-epsi)! h->W+mu-n
		vhWmunu=vhWmunu+sin(beta-alpha)**2*vhWmunu_TBSH
		vhWWstar =  2.d0*(3.d0*vhWmunu+2.d0*vhWcs)
	![EW=LO, QCD=NNLO,NLO,LO] ~~~~~~~~~~~~~~~~~~~~~~~
	else if (OREW == 0 .and. ORQCD .ge.-1 .and. ORQCD .le.2 ) then     
		call decay_hWWstar_sm(vhWWstar,dummy,dummy,OREW,ORQCD)
		vhWWstar = sin(beta-alpha)**2*vhWWstar
	else
		vhWWstar = 0.d0
	end if

	end subroutine
!#########################################################
!#
!#     Decay of additional CP even scalar: bH
!#
!#########################################################
!======================================================
!     Partial decay width (Fermionic decay)
!======================================================
	double precision function Gam_bHtt(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mt <= mbH) then
		Gam_bHtt = decay_bHtt(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mt+mW < mbH) then
		Gam_bHtt = decay_bHtts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_bHtt = 0.d0
	endif

	if (Gam_bHtt < 0.d0) then
		write(*,*) 'Gam_bHtt is negative'
	endif

	end function
!----- Gam(A -> q q~) except for q = t -----------------------------------------
	double precision function Gam_bHqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mf < mbH) then
		Gam_bHqq = decay_bHqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	else
		Gam_bHqq = 0.d0
	endif

	if (Gam_bHqq < 0.d0) then
		write(*,*) 'Gam_bHqq is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHll(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mf < mbH) then
		Gam_bHll = decay_bHll(mch,mA,mbH,bmsq,alpha,beta,n,OREW,mf)
	else
		Gam_bHll = 0.d0
	endif

	if (Gam_bHll < 0.d0) then
		write(*,*) 'Gam_bHll is negative'
	endif

	end function
!====================================================
!  Partial decay width (Bosonic decay)
!====================================================
	double precision function Gam_bHZZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mZ <= mbH) then
		Gam_bHZZ = decay_bHZZ(mch,mA,mbh,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mZ < mbH) then
		Gam_bHZZ = cos(beta-alpha)**2*decay_hZZstar_tree(mbH)
	else
		Gam_bHZZ = 0.d0
	endif

	if (Gam_bHZZ < 0.d0) then
		write(*,*) 'Gam_bHZZ is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHWW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mW <= mbH) then
		Gam_bHWW = decay_bHWW(mch,mA,mbh,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mW < mbH) then
		Gam_bHWW = cos(beta-alpha)**2*decay_hWWstar_tree(mbH)
	else
		Gam_bHWW = 0.d0
	endif

	if (Gam_bHWW < 0.d0) then
		write(*,*) 'Gam_bHWW is negative'
	endif

	end function
!====================================================
!     Partial decay width (Bosonic decay)
!====================================================
	double precision function Gam_bHAZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mZ+mA <= mbH) then
		Gam_bHAZ = decay_bHAZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mA < mbH) then
		Gam_bHAZ = Gam_bHZstarA(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_bHAZ = 0.d0
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHchW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mW+mch <= mbH) then
		Gam_bHchW = decay_bHchW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mch < mbH) then
		Gam_bHchW = Gam_bHWstarch(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_bHchW = 0.d0
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHhh(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: kh

	if(2.d0*mh <= mbH) then
		Gam_bHhh = decay_bHhh(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	else if(mh < mbH) then
		kh = (mh/mbH)**2
		Gam_bHhh =&
			3.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)**2*&
			G_F*mb**2*xid(alpha,beta,n)**2/(16.d0*sqrt(2.d0)*pi**3*mbH)*(&
				(kh-1.d0)*(2.d0-1.d0/2.d0*log(kh))&
				+(1.d0-5.d0*kh)/sqrt(4.d0*kh-1.d0)*&
				(atan((2.d0*kh-1.d0)/sqrt(4.d0*kh-1.d0))&
				-atan(1.d0/sqrt(4.d0*kh-1.d0)))&
			)
	else
		Gam_bHhh = 0.d0
	endif

	if (Gam_bHhh < 0.d0) then
		write(*,*) 'Gam_bHhh is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHAA(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mA <= mbH) then
		Gam_bHAA = decay_bHAA(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	else
		Gam_bHAA = 0.d0
	endif

	if (Gam_bHAA < 0.d0) then
		write(*,*) 'Gam_bHAA is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHchch(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mch <= mbH) then
		Gam_bHchch = decay_bHchch(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	else
		Gam_bHchch = 0.d0
	endif

	if (Gam_bHchch < 0.d0) then
		write(*,*) 'Gam_bHchch is negative'
	endif

	end function
!====================================================
!  Partial decay width (loop-induced decay)
!====================================================
	double precision function Gam_bHgg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	Gam_bHgg = decay_bHgg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

	if (Gam_bHgg < 0.d0) then
		write(*,*) 'Gam_bHgg is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHgamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	Gam_bHgamgam = decay_bHgamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

	if (Gam_bHgamgam < 0.d0) then
		write(*,*) 'Gam_bHgamgam is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_bHZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mZ <= mbH) then
		Gam_bHZgam = decay_bHZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_bHZgam = 0.d0
	endif

	if (Gam_bHZgam < 0.d0) then
		write(*,*) 'Gam_bHZgam is negative'
	endif

	end function
!=====================================================
!     Two body functions (Fermionic decay)
!=====================================================
	double precision function decay_bHtt(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmf
	double precision:: R,mf,xf,If3,xif
	double precision:: Gam_S_LO_pole,Gam_S_LO_MSbar
	double precision:: decay_LO_pole,decay_LO_MSbar
	double precision:: decay_EWNLO_pole,decay_EWNLO_MSbar
	double precision:: QCD_pole,QCD_MSbar
	double precision:: decay_LO,decay_QCD,decay_EWNLO
	complex (kind(0d0)):: Gam_S_NLO
	double precision:: Delta_qq1,Delta_qq2
	mf = mt;	xf = mf/mbH
	p1sq=mf**2; p2sq=mf**2; qsq=mbH**2; mu=mbH
	R=2.d0*mf/mbH

	!--- mbH >= 2.d0*mt ---
	nf=6.d0; lam_QCD=lam_QCD6
	rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,nf),mt_MS)

	!===================
	!     LO
	!===================
	Gam_S_LO_pole = -mf/vev*xiu_H(alpha,beta,n)
	decay_LO_pole = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_pole**2

	if(OREW==0 .and. ORQCD==-1) then
		decay_bHtt = decay_LO_pole
		return
	endif

	Gam_S_LO_MSbar = -rmf/vev*xiu_H(alpha,beta,n)
	decay_LO_MSbar = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_MSbar**2

	!----- Interpolation -----
	decay_LO = R**2*decay_LO_pole+(1.d0-R**2)*decay_LO_MSbar

	if(OREW==0 .and. ORQCD==0) then
		decay_bHtt = decay_LO
		return
	endif

	!=========================
	!     QCD corrections
	!=========================
	if(ORQCD > 0) then
		!----- on-shell -----
		QCD_pole  = decay_LO_pole*Delta_t_H(mu)
	
		!----- MSbar -----
		if(ORQCD == 1) then
			Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
			QCD_MSbar = decay_LO_MSbar*(Delta_qq1)
		else if(ORQCD == 2) then
			Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
			Delta_qq2 = (alphas(lam_QCD,mu,nf)/pi)**2*(&
								+10801.d0/144.d0-39.d0/2.d0*zeta3-(65.d0/24.d0-2.d0/3.d0*zeta3)*nf&
								-pi**2*(19.d0/12.d0-1.d0/18.d0*nf)&
							)
			QCD_MSbar = decay_LO_MSbar*(Delta_qq1+Delta_qq2)
		endif

		!----- Interpolation -----
		decay_QCD = R**2*QCD_pole+(1.d0-R**2)*QCD_MSbar

		if(OREW == 0) then
			decay_bHtt = decay_LO+decay_QCD
			return
		endif
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S_NLO =&
			Gam_bHff_S_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			+mf*FbHff_V1(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)&
			-mf*FbHff_V2(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)&
			+(qsq-p1sq-p2sq+mf**2)*FbHff_T(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)

		Gam_S_NLO =	Gam_S_NLO-Gam_S_LO_pole*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		decay_EWNLO_pole =&
			Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_S_LO_pole*conjg(Gam_S_NLO))&
			)&
			!----- real photon emission -----
			+Nc*decay_bH_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)

		decay_EWNLO_MSbar = (rmf/mf)**2*decay_EWNLO_pole

		!----- Interpolation -----
		decay_EWNLO = R**2*decay_EWNLO_pole+(1.d0-R**2)*decay_EWNLO_MSbar

		if(ORQCD == -1) then
			decay_bHtt = decay_LO_pole+decay_EWNLO_pole
			return
		else if(ORQCD == 0) then
			decay_bHtt = decay_LO+decay_EWNLO
			return
		else if(ORQCD > 0) then
			decay_bHtt = decay_LO+decay_EWNLO+decay_QCD
			return
		endif
	endif
	
	end function
!----- bH -> q q~ except for q = t -----------------------------------------
	double precision function decay_bHqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmf
	double precision:: xf,xif_bH
	double precision:: Gam_S_LO_pole,Gam_S_LO_MSbar
	double precision:: decay_LO_pole,decay_LO_MSbar
	double precision:: Delta_qq1,Delta_qq2,Delta_bH
	double precision:: decay_LO,decay_QCD,decay_EWNLO
	complex (kind(0d0)):: Gam_S_NLO
	p1sq=mf**2; p2sq=mf**2; qsq=mbH**2;
	xf = mf/mbH; mu=mbH

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if(mf == mb) then
		xif_bH = xid_H(alpha,beta,n)
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)
	else if(mf == mc) then
		xif_bH = xiu_H(alpha,beta,n)
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD4,mc,4.d0),mc_MS)
	else if(mf == ms) then
		xif_bH = xid_H(alpha,beta,n)
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD3,ms,3.d0),ms_MS)
	endif

	!===================
	!     LO
	!===================
	Gam_S_LO_pole = -mf/vev*xif_bH
	decay_LO_pole = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_pole**2

	if(OREW==0 .and. ORQCD==-1) then
		decay_bHqq = decay_LO_pole
		return
	endif

	Gam_S_LO_MSbar = -rmf/vev*xif_bH
	decay_LO_MSbar = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO_MSbar**2

	if(OREW==0 .and. ORQCD==0) then
		decay_bHqq = decay_LO_MSbar
		return
	endif

	!=========================
	!     QCD corrections
	!=========================
	decay_QCD = 0.d0
	Delta_qq1 = 0.d0; Delta_qq2 = 0.d0; Delta_bH = 0.d0

	if(ORQCD == 1) then
		Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
		decay_QCD = decay_LO_MSbar*Delta_qq1
	else if(ORQCD == 2) then
		Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))
		Delta_qq2 = (alphas(lam_QCD,mu,nf)/pi)**2*(&
							10801.d0/144.d0-39.d0/2.d0*zeta3-(65.d0/24.d0-2.d0/3.d0*zeta3)*nf&
							-pi**2*(19.d0/12.d0-1.d0/18.d0*nf)&
						)
		if (mbH < mt) then
			Delta_bH  = (alphas(lam_QCD,mu,nf)/pi)**2*xiu_H(alpha,beta,n)/xif_bH*(&
							+1.57d0-2.d0/3.d0*log(mbH**2/mt**2)&
							+1.d0/9.d0*(log(rmf**2/mbH**2))**2&
						)
		endif
		decay_QCD = decay_LO_MSbar*(Delta_qq1+Delta_qq2+Delta_bH)
	endif

	if(OREW == 0) then
		decay_bHqq = decay_LO_MSbar+decay_QCD
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S_NLO =&
			Gam_bHff_S_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			+mf*FbHff_V1(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)&
			-mf*FbHff_V2(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)&
			+(qsq-p1sq-p2sq+mf**2)*FbHff_T(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)

		Gam_S_NLO =	Gam_S_NLO-Gam_S_LO_pole*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		decay_EWNLO =&
			Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_S_LO_pole*conjg(Gam_S_NLO))&
			)&
			!----- real photon emission -----
			+Nc*decay_bH_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)

		if(ORQCD == -1) then
			decay_bHqq = decay_LO_pole+decay_EWNLO
			return
		else if(ORQCD == 0) then
			decay_bHqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO
			return
		else if(ORQCD == 1) then
			decay_bHqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO+decay_QCD
			return
		else if(ORQCD == 2) then
			decay_bHqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO+decay_QCD
			return
		endif
	endif
	
	end function
!---------------------------------------------------------------------------
	double precision function decay_bHll(mch,mA,mbH,bmsq,alpha,beta,n,OREW,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW
	double precision:: p1sq,p2sq,qsq
	double precision:: xf
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_S_LO,Gam_S_NLO
	p1sq=mf**2; p2sq=mf**2; qsq=mbH**2;
	xf = mf/mbH

	!===================
	!     LO
	!===================
	Gam_S_LO = Gam_bHff_S_tree(alpha,beta,n,mf)
	decay_LO = mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO**2

	if(OREW==0) then
		decay_bHll = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S_NLO =&
			Gam_bHff_S_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			+mf*FbHff_V1(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)&
			-mf*FbHff_V2(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)&
			+(qsq-p1sq-p2sq+mf**2)*FbHff_T(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)

		Gam_S_NLO =	Gam_S_NLO-Gam_S_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		decay_EWNLO =&
			mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)&
				*(2.d0*dble(Gam_S_LO*conjg(Gam_S_NLO)))&
			!----- real photon emission -----
			+decay_bH_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)

		decay_bHll = decay_LO+decay_EWNLO
		return
	endif
	
	end function
! !--------------------------------------------------------------------------
! 	double precision function decay_bH_qqgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)
! 	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
! 	integer, intent(in):: n
! 	double precision:: xf,Qf,mu,Gam_S_LO,decay_LO
! 	double precision:: Delta_QED
! 	xf = mf/mbH; mu = mbH

! 	if (mf == mt .or. mf == mc) then
! 		Qf = Qt
! 	elseif (mf == mb .or. mf == ms) then
! 		Qf = Qb
! 	endif

! 	Gam_S_LO = Gam_bHff_S_tree(alpha,beta,n,mf)
! 	decay_LO = Nc*mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO**2

! 	decay_bH_qqgam = decay_LO*(&
! 		+alpha_em/pi*Qf**2*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mbH**2))&
! 	)

! 	end function
! !--------------------------------------------------------------------------
! 	double precision function decay_bH_llgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)
! 	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
! 	integer, intent(in):: n
! 	double precision:: xf,Qf,Gam_S_LO,decay_LO
! 	xf = mf/mbH; Qf = Qe

! 	Gam_S_LO = Gam_bHff_S_tree(alpha,beta,n,mf)
! 	decay_LO = mbH/(8.d0*pi)*lambda(xf**2,xf**2)**(3.d0/2.d0)*Gam_S_LO**2

! 	decay_bH_llgam = decay_LO*(&
! 		+alpha_em/pi*Qf**2*(9.d0/4.d0+3.d0/2.d0*log(mf**2/mbH**2))&
! 	)

! 	end function
!--------------------------------------------------------------------------
	double precision function decay_bH_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: Qf,xi_bH

	if (mf == mt .or. mf == mc) then
		Qf = Qt; xi_bH = xiu_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		Qf = Qb; xi_bH = xid_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		Qf = Qe; xi_bH = xil_H(alpha,beta,n)
	endif

	decay_bH_ffgam =&
		2.d0*Qf**2*alpha_em/(16.d0*pi**2*mbH)*(mf/vev*xi_bH)**2*(&
			+OmegaLL_11(mbH,mf,mf)+OmegaLR_11(mbH,mf,mf)&
			+OmegaLL_22(mbH,mf,mf)+OmegaLR_22(mbH,mf,mf)&
			+OmegaLL_12(mbH,mf,mf)+OmegaLR_12(mbH,mf,mf)&
		)

	end function
!=====================================================
!     Two body functions (Bosonic decay)
!=====================================================
	double precision function decay_bHWW(mch,mA,mbh,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq,mu,xV
	double precision:: Gam1_bHWW_tree
	double precision:: decay_LO,decay_EWNLO
	p1sq=mW**2; p2sq=mW**2; qsq=mbH**2; mu = mbH
	xV = mW/mbH

	Gam1_bHWW_tree = 2.d0*mW**2/vev*cos(beta-alpha)

	!===================
	!     LO
	!===================
	decay_LO = mbH**3/(64.d0*pi*mW**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)&
					*(1.d0-4.d0*xV**2+12.d0*xV**4)*abs(Gam1_bHWW_tree)**2

	if(OREW == 0) then
		decay_bHWW = decay_LO
		return
	endif

	if(OREW == 1) then
		decay_EWNLO =&
			mbH**3/(64.d0*pi*mW**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)*(&
				+(1.d0-4.d0*xV**2+12.d0*xV**4)&
				*2.d0*Gam1_bHWW_tree*(&
					+dble(Gam1_bHWW_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n))&
					+Gam1_bHWW_tree*(&
						-dble(rdPiWW(mW**2,mch,mA,mbh,bmsq,alpha,beta,n))&
						-1.d0/2.d0*Del_r(mch,mA,mbh,bmsq,alpha,beta,n)&
					)&
				)&
				+(1.d0-6.d0*xV**2+8.d0*xV**4)/xV**2*Gam1_bHWW_tree*(&
					+dble(rGam2_bHWW(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n))&
				)&
			)	

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_bH_WWgam(mch,mA,mbH,bmsq,alpha,beta,n)

		decay_bHWW = decay_LO+decay_EWNLO
		return
	endif
 
	end function
!--------------------------------------------------------------------------
	double precision function decay_bH_WWgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n

	decay_bH_WWgam =&
		alpha_em**2/(4.d0*pi*mbH*mW**2*sw**2)*cos(beta-alpha)**2*(&
			2.d0*mW**2*Ibrems22_11(mbH,mW,mW)&
			-mW**2*(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_11(mbH,mW,mW)&
			+2.d0*mW**2*Ibrems11_22(mbH,mW,mW)&
			-mW**2*(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_22(mbH,mW,mW)&
			+(mbH**6-6.d0*mbH**4*mW**2+20.d0*mbH**2*mW**4-24.d0*mW**6)*Ibrems_12(mbH,mW,mW)&
			+4.d0*mW**2*Ibrems2_1(mbH,mW,mW)&
			-(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_1(mbH,mW,mW)&
			+4.d0*mW**2*Ibrems1_2(mbH,mW,mW)&
			-(mbH**4-4.d0*mbH**2*mW**2+12.d0*mW**4)*Ibrems_2(mbH,mW,mW)&
			+4.d0*mW**2*Ibrems(mbH,mW,mW)&
		)

	end function
!------------------------------------------------------------------
	double precision function decay_bHZZ(mch,mA,mbh,bmsq,alpha,beta,n,OREW,ORQCD) 
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq,mu,xV
	double precision:: Gam1_bHZZ_tree
	double precision:: decay_LO,decay_EWNLO
	p1sq=mZ**2; p2sq=mZ**2; qsq=mbH**2; mu = mbH
	xV = mZ/mbH

	Gam1_bHZZ_tree = 2.d0*mZ**2/vev*cos(beta-alpha)

	!===================
	!     LO
	!===================
	decay_LO  = mbH**3/(128.d0*pi*mZ**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)&
					*(1.d0-4.d0*xV**2+12.d0*xV**4)&
					*abs(Gam1_bHZZ_tree)**2

	if(OREW == 0) then
		decay_bHZZ = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		decay_EWNLO =&
			mbH**3/(128.d0*pi*mZ**4)*lambda(xV**2,xV**2)**(1.d0/2.d0)*(&
				+(1.d0-4.d0*xV**2+12.d0*xV**4)&
				*2.d0*Gam1_bHZZ_tree*(&
					+real(Gam1_bHZZ_loop(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n))&
					+Gam1_bHZZ_tree*(&
						-real(rdPiZZ(mZ**2,mch,mA,mbh,bmsq,alpha,beta,n))&
						-1.d0/2.d0*Del_r(mch,mA,mbh,bmsq,alpha,beta,n)&
					)&
				)&
				+(1.d0-6.d0*xV**2+8.d0*xV**4)/xV**2&
				*Gam1_bHZZ_tree*(&
					+real(rGam2_bHZZ(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n))&
				)&
			)

		decay_bHZZ = decay_LO+decay_EWNLO
		return
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHAZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW,ORQCD
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mA**2; p2sq=mZ**2; qsq=mbH**2
	xphi = mA/mbH; xV = mZ/mbH

	call Switch_HOEW(OREW,S_NLOEW)

	!===================
	!     LO
	!===================
	decay_LO = sqrt(2.d0)*G_F*mbH**3*sin(beta-alpha)**2/(16.d0*pi)*lambda(xphi**2,xV**2)**(3.d0/2.d0)

	if(OREW==0) then
		decay_bHAZ = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_LO = ii*mZ/vev*sin(beta-alpha)
		Gam_NLO = -rGam_AZbH(qsq,p2sq,p1sq,mch,mA,mbH,bmsq,alpha,beta,n)
		!pbH = p1, pZ = p2, pA = q by definition

		decay_EWNLO = mbH**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
							+2.d0*dble(Gam_LO*conjg(Gam_NLO))&
						  )
		decay_EWNLO = decay_EWNLO&
						  +decay_LO*(&
							  -dble(rdPiZZ(mZ**2,mch,mA,mbH,bmsq,alpha,beta,n))&
							  -Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&			
						  )

		decay_bHAZ = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHchW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
 	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW,ORQCD
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mch**2; p2sq=mW**2; qsq=mbH**2
	xphi = mch/mbH; xV = mw/mbH

	call Switch_HOEW(OREW,S_NLOEW)

	!===================
	!     LO
	!===================
	decay_LO = sqrt(2.d0)*G_F*mbH**3*sin(beta-alpha)**2/(8.d0*pi)&
					*lambda(xphi**2,xV**2)**(3.d0/2.d0)

	if(OREW==0) then
		decay_bHchW = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_LO = -mW/vev*sin(beta-alpha)
		Gam_NLO = -rGam_bHWHp(qsq,p2sq,p1sq,mch,mA,mbH,bmsq,alpha,beta,n)
		!pbH = p1, pW = p2, pcH = q by definition

		decay_EWNLO =&
			2.d0*mbH**3/(16.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_LO*conjg(Gam_NLO))&
			)
		decay_EWNLO =&
			decay_EWNLO&
			+decay_LO*(&
				-dble(rdPiWW(mW**2,mch,mA,mbH,bmsq,alpha,beta,n))&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
				-2.d0*(mW/vev*cos(beta-alpha))/Gam_LO&
					*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			)

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_bH_chWgam(mch,mA,mbH,bmsq,alpha,beta,n)*QED

		decay_bHchW = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bH_chWgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	double precision:: xch,xw
	xch = mch/mbH; xw = mw/mbH

	decay_bH_chWgam =&
		-sqrt(2.d0)*G_F*mw**2*alpha_em/(2.d0*pi**2)*mbH**3*sin(beta-alpha)**2*(&
			lambda(xch**2,xw**2)*(&
				Ibrems_22(mbH,mch,mW)&
				+mch**2/mW**2*Ibrems_11(mbH,mch,mW)&
				+(1.d0+(mch**2-mbH**2)/mW**2)*Ibrems_12(mbH,mch,mW)&
				+1.d0/mW**2*(Ibrems_1(mbH,mch,mW)+Ibrems_2(mbH,mch,mW))&
			)&
			-2.d0/mbH**4*(&
				+Ibrems(mbH,mch,mW)+2.d0*Ibrems1_2(mbH,mch,mW)+Ibrems11_22(mbH,mch,mW)&
			)&
		)

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHhh(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq,xphi
	double precision:: decay_LO,decay_EWNLO,decay_EWNNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mh**2; p2sq=mh**2; qsq=mbH**2
	xphi = mh/mbH

	!===================
	!     LO
	!===================
	Gam_LO = 2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)
	decay_LO = Gam_LO**2/(32.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)

	if(OREW == 0) then
		decay_bHhh = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	Gam_NLO = Gam_bHhh_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)&
				 -Gam_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

	decay_EWNLO = 1.d0/(32.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)*(&
			+2.d0*dble(Gam_LO*conjg(Gam_NLO)))

	if(OREW == 1) then
		decay_bHhh = decay_LO+decay_EWNLO
		return
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHAA(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi
	double precision:: decay_LO,decay_EWNLO,decay_EWNNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mA**2; p2sq=mA**2; qsq=mbH**2
	xphi = mA/mbH

	!===================
	!     LO
	!===================
	Gam_LO  = 2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)
	decay_LO = Gam_LO**2/(32.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)

	if(OREW == 0) then
		decay_bHAA = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	Gam_NLO =&
		Gam_bHAA_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)&
		-Gam_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

	decay_EWNLO =&
		1.d0/(32.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)*(&
			2.d0*dble(Gam_LO*conjg(Gam_NLO))&
		)

	if(OREW == 1) then
		decay_bHAA = decay_LO+decay_EWNLO
		return
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHchch(mch,mA,mbH,bmsq,alpha,beta,mu_r,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi
	double precision:: decay_LO,decay_EWNLO,decay_EWNNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mch**2; p2sq=mch**2; qsq=mbH**2
	xphi = mch/mbH

	!===================
	!     LO
	!===================
	Gam_LO  = lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)
	decay_LO = Gam_LO**2/(16.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)

	if(OREW == 0) then
		decay_bHchch = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	Gam_NLO =&
		Gam_bHHpHm_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)&
		-2.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
		-Gam_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

	decay_EWNLO =&
		1.d0/(16.d0*pi*mbH)*lambda(xphi**2,xphi**2)**(1.d0/2.d0)*(&
			2.d0*dble(Gam_LO*conjg(Gam_NLO))&
		)&
		!----- real photon emission -----
		+decay_bH_chchgam(mch,mA,mbH,bmsq,alpha,beta,n)

	if(OREW == 1) then
		decay_bHchch = decay_LO+decay_EWNLO
		return
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bH_chchgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	double precision:: xch
	xch = mch/mbH

	decay_bH_chchgam =&
		-alpha_em*(lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta))**2/(4.d0*pi**2)/mbH*(&
			mch**2*(Ibrems_11(mbH,mch,mch)+Ibrems_22(mbH,mch,mch))&
			-(mbH**2-2.d0*mch**2)*Ibrems_12(mbH,mch,mch)&
			+Ibrems_1(mbH,mch,mch)+Ibrems_2(mbH,mch,mch)&		
		)

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHgamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mbH**2; mu=mbH/2.d0

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	if (ORQCD == -1) then
		decay_bHgamgam=&
		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
		*abs(&
			xiu_H(alpha,beta,n)*Nc*Qt**2*I_f(mbH,mt)&
			+xid_H(alpha,beta,n)*Nc*Qb**2*I_f(mbH,mb)&
			+xil_H(alpha,beta,n)*Qe**2*I_f(mbH,mtau)&
			+I_W(mbH)*cos(beta-alpha)&
			-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*I_S(mbH,mch)&
		)**2
	endif

	if (ORQCD == 0) then
		decay_bHgamgam=&
		alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
		*abs(&
			xiu_H(alpha,beta,n)*Nc*Qt**2*rmt/mt*I_f(mbH,mt)&
			+xid_H(alpha,beta,n)*Nc*Qb**2*rmb/mb*I_f(mbH,mb)&
			+xil_H(alpha,beta,n)*Qe**2*I_f(mbH,mtau)&
			+I_W(mbH)*cos(beta-alpha)&
			-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*I_S(mbH,mch)&
		)**2
	endif

	if (ORQCD == 1) then
		decay_bHgamgam=&
			alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
			*abs(&
				xiu_H(alpha,beta,n)*Nc*Qt**2*rmt/mt*(&
					I_f(mbH,mt)&
					! NLO QCD
					-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mt,mu)&
				)&
				+xid_H(alpha,beta,n)*Nc*Qb**2*rmb/mb*(&
					I_f(mbH,mb)&
					! NLO QCD
					-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mb,mu)&
				)&
				+xil_H(alpha,beta,n)*Qe**2*I_f(mbH,mtau)&
				+cos(beta-alpha)*I_W(mbH)&
				-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*I_S(mbH,mch)&
			)**2
	endif
	
	if (ORQCD == 2) then
		if (mbH < mt) then
			decay_bHgamgam=&
				alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
				*abs(&
					xiu_H(alpha,beta,n)*Nc*Qt**2*rmt/mt*(&
						I_f(mbH,mt)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mt,mu)&
						! NNLO QCD (heavy-top limit)
	   				-I_f(mbH,mt)*(alphas(lam_QCD,mu,nf)/pi)**2*(&
	   					31.d0/24.d0+7.d0/4.d0*log(mu**2/mt**2)&
	   				)&
					)&
					+xid_H(alpha,beta,n)*Nc*Qb**2*rmb/mb*(&
						I_f(mbH,mb)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mb,mu)&
					)&
					+xil_H(alpha,beta,n)*Qe**2*I_f(mbH,mtau)&
					+cos(beta-alpha)*I_W(mbH)&
					-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*I_S(mbH,mch)&
				)**2
		else if (mt <= mbH) then
			decay_bHgamgam=&
				alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mbH**3&
				*abs(&
					xiu_H(alpha,beta,n)*Nc*Qt**2*rmt/mt*(&
						I_f(mbH,mt)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mt,mu)&
					)&
					+xid_H(alpha,beta,n)*Nc*Qb**2*rmb/mb*(&
						I_f(mbH,mb)&
						! NLO QCD
						-alphas(lam_QCD,mu,nf)/pi*C_H(mbH,mb,mu)&
					)&
					+xil_H(alpha,beta,n)*Qe**2*I_f(mbH,mtau)&
					+cos(beta-alpha)*I_W(mbH)&
					-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*I_S(mbH,mch)&
				)**2
		endif
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=mZ**2; p2sq=0.d0; qsq=mbH**2; mu=mbH/2.d0

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	if (ORQCD == -1) then
		decay_bHZgam=&
			sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
			*abs(&
				xiu_H(alpha,beta,n)*Nc*Qt*vt*J_f(mbH,mt)&
				+xid_H(alpha,beta,n)*Nc*Qb*vb*J_f(mbH,mb)&
				+xil_H(alpha,beta,n)*Qe*ve*J_f(mbH,mtau)&
				+cos(beta-alpha)*J_W(mbH)&
				-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*(gz/2.d0*(cw**2-sw**2))*J_S(mbH,mch)&
			)**2
	endif

	if (ORQCD == 0) then
		decay_bHZgam=&
			sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
			*abs(&
				xiu_H(alpha,beta,n)*Nc*Qt*vt*rmt/mt*J_f(mbH,mt)&
				+xid_H(alpha,beta,n)*Nc*Qb*vb*rmb/mb*J_f(mbH,mb)&
				+xil_H(alpha,beta,n)*Qe*ve*J_f(mbH,mtau)&
				+cos(beta-alpha)*J_W(mbH)&
				-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*(gz/2.d0*(cw**2-sw**2))*J_S(mbH,mch)&
			)**2
	endif

	if (1 <= ORQCD) then
		if (mbH < mt) then
			decay_bHZgam=&
				sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
				*abs(&
					xiu_H(alpha,beta,n)*Nc*Qt*vt*rmt/mt*J_f(mbH,mt)*(&
						1.d0&
						! NLO QCD (heavy-top limit)
						-alphas(lam_QCD,mu,nf)/pi&
					)&
					+xid_H(alpha,beta,n)*Nc*Qb*vb*rmb/mb*J_f(mbH,mb)&
					+xil_H(alpha,beta,n)*Qe*ve*J_f(mbH,mtau)&
					+cos(beta-alpha)*J_W(mbH)&
					-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*(gz/2.d0*(cw**2-sw**2))*J_S(mbH,mch)&
				)**2
		else if (mt <= mbH) then
			decay_bHZgam=&
				sqrt(2.d0)*G_F*alpha_em**2*mbH**3/(128.d0*pi**3)*(1.d0-mZ**2/mbH**2)**3&
				*abs(&
					xiu_H(alpha,beta,n)*Nc*Qt*vt*rmt/mt*J_f(mbH,mt)&
					+xid_H(alpha,beta,n)*Nc*Qb*vb*rmb/mb*J_f(mbH,mb)&
					+xil_H(alpha,beta,n)*Qe*ve*J_f(mbH,mtau)&
					+cos(beta-alpha)*J_W(mbH)&
					-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)/vev*(gz/2.d0*(cw**2-sw**2))*J_S(mbH,mch)&
				)**2
		endif
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_bHgg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: E_H1,dE_H1,E_H2,mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mbH**2; mu=mbH

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	E_H1 = 0.d0; dE_H1 = 0.d0
	if (1 <= ORQCD) then
      if(mbH < mt) then
			E_H1 = 95.d0/4.d0-7.d0/6.d0*nf+(33.d0-2.d0*nf)/6.d0*log(mu**2/mbH**2)
      else if(mt <= mbH) then
         E_H1 = 11.d0/2.d0+(33.d0-2.d0*nf)/6.d0*log(mu**2/mbH**2)
      endif
		dE_H1 =&
			dble(&
				(&
					xiu_H(alpha,beta,n)&
					*(B1_H(mbH**2/(4.d0*mt**2))+(2.d0*C2_H(mbH**2/(4.d0*mt**2)))*log(mu**2/mt**2))&
					+xid_H(alpha,beta,n)&
					*(B1_H(mbH**2/(4.d0*mb**2))+(2.d0*C2_H(mbH**2/(4.d0*mb**2)))*log(mu**2/mb**2))&
				)&
				/(&
					xiu_H(alpha,beta,n)*F0_H(mbH**2/(4.d0*mt**2))&
					 +xid_H(alpha,beta,n)*F0_H(mbH**2/(4.d0*mb**2))&
				)&
			)&
			-11.d0/2.d0
	endif

	E_H2 = 0.d0	
	if (2 <= ORQCD .and. mbH < mt) then
		E_H2 =&
			+149533.d0/288.d0-363.d0/8.d0*zeta2-495.d0/8.d0*zeta3-19.d0/8.d0*log(mt**2/mbH**2)&
			+nf*(-4157.d0/72.d0+11.d0/2.d0*zeta2+5.d0/4.d0*zeta3-2.d0/3.d0*log(mt**2/mbH**2))&
			+nf**2*(127.d0/108.d0-1.d0/6.d0*zeta2)
	endif

	if (ORQCD == -1) then
		decay_bHgg=&
			sqrt(2.d0)*G_F*alphas(lam_QCD,mbH,nf)**2*mbH**3/(128.d0*pi**3)&
			*abs(&
				xiu_H(alpha,beta,n)*I_f(mbH,mt)&
				+xid_H(alpha,beta,n)*I_f(mbH,mb)&
			)**2
	else if (ORQCD == 0 .or. ORQCD == 1 .or. ORQCD == 2) then
		decay_bHgg=&
			sqrt(2.d0)*G_F*alphas(lam_QCD,mbH,nf)**2*mbH**3/(128.d0*pi**3)&
			*abs(&
				rmt/mt*xiu_H(alpha,beta,n)*I_f(mbH,mt)&
				+rmb/mb*xid_H(alpha,beta,n)*I_f(mbH,mb)&
			)**2&
			*(&
				!LO
				+1.d0&
				!NLO QCD
				+alphas(lam_QCD,mbH,nf)/pi*(E_H1+dE_H1)&
				!NNLO QCD (heavy-top limit)
				+(alphas(lam_QCD,mbH,nf)/pi)**2*E_H2&
			)
	endif

	end function
!=====Three body decay=====
	double precision function dGam_dy1dy2_bHtts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,yt,yb
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,kt,kw,gamt,KbHtts
	! p1sq=mt**2; p2sq=mb**2; qsq=mA**2
	kt = mt**2/mbH**2
	kw = mW**2/mbH**2
	gamt = (1.42d0/mbH)**2
	KbHtts = 3*G_F**2*mt**2*xiu_H(alpha,beta,n)**2/32.d0/pi**3*mbH**3
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	dGam_dy1dy2_bHtts=&
		KbHtts/(yt**2+kt*gamt)*(&
			-yt**3+(1.d0-5.d0*kt+kw-yb)*yt**2&
			+((2.d0*kw-kt)*yb+2.d0*kt*(1.d0-2.d0*kw-4.d0*kt))*yt&
			+(1.d0-4.d0*kt)*(kt-kw)*(kt+2.d0*kw)&
		)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			!	*S_NLOEW&
			! NLO  QED correction
			!	*S_NLOEW&
			! NLO  QCD correction
			!	*S_NLOQCD&
			! NNLO  QCD correction
			!	*S_NNLOQCD&
		)

	end function
!-------------------------------------------------------------------
	double precision function decay_bHtts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	integer:: i,j,div_width
	double precision:: yt,yb,xt,xb,xw,ddecay_bHtts
	xt = mt/mbH
	xb = mb/mbH
	xw = mw/mbH

	div_width=200; decay_bHtts=0.d0

	do i = 0, div_width
		ddecay_bHtts=0.d0
		yt = (xb+xw)**2-xt**2+((1.d0-xt)**2-(xb+xw)**2)/dble(div_width)*dble(i)
		do j = 0, div_width
			yb =&
				xt**2+xw**2-xb**2&
				+(1.d0-2.d0*xt**2-yt)*(yt+xt**2+xw**2-xb**2)/(2.d0*(yt+xt**2))&
				-abs(lambda(yt+xt**2,xt**2)*lambda(xb**2/(yt+xt**2),xw**2/(yt+xt**2)))**(1.d0/2.d0)/2.d0&
				*(1.d0-2.d0*dble(j)/dble(div_width))
			if(j==0 .or. j==div_width) then
				ddecay_bHtts =&
					ddecay_bHtts&
					+dGam_dy1dy2_bHtts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
			else if(mod(j,2)==1) then
				ddecay_bHtts =&
					ddecay_bHtts&
					+4.d0*dGam_dy1dy2_bHtts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
			else if(mod(j,2)==0) then
				ddecay_bHtts =&
					ddecay_bHtts&
					+2.d0*dGam_dy1dy2_bHtts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
			endif
		enddo
		ddecay_bHtts =&
			ddecay_bHtts*sqrt(abs(lambda(yt+xt**2,xt**2)*lambda(xb**2/(yt+xt**2),xw**2/(yt+xt**2))))&
			/dble(div_width)/3.d0
		if(i==0 .or. i==div_width) then
			decay_bHtts = decay_bHtts+ddecay_bHtts
		else if(mod(i,2)==1) then
			decay_bHtts = decay_bHtts+4.d0*ddecay_bHtts
		else if(mod(i,2)==0) then
			decay_bHtts = decay_bHtts+2.d0*ddecay_bHtts
		endif
	enddo
	decay_bHtts = decay_bHtts*((1.d0-xt)**2-(xb+xw)**2)/dble(div_width)/3.d0

	end function
!-------------------------------------------------------------------
	double precision function Gam_bHZstarA(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,KbHZA
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	
	KbHZA = 9.d0*G_F**2*mZ**4*mbH/16.d0/pi**3*sin(beta-alpha)**2&
		*(7.d0/12.d0-10.d0/9.d0*sw**2+40.d0/27.d0*sw**4)

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	Gam_bHZstarA =&
		KbHZA*SSpV3body(mbH,mA,mZ)&
		*(&
			! LO
			+1.d0&
			! NLO Weak correction
			!	*S_NLOEW&
			! NLO  QED correction
			!	*S_NLOQCD&
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD5,mZ,5.d0)*S_NLOQCD&
			! NNLO  QCD correction
			!	*S_NNLOQCD
		)

	end function
!-------------------------------------------------------------------
	double precision function Gam_bHWstarch(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD) !Sum up W+H- and W-H+
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,KbHWch
	double precision:: mu,nf,lam_QCD
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2

	KbHWch = 2.d0*9.d0*G_F**2*mW**4*mbH/16.d0/pi**3*sin(beta-alpha)**2

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	Gam_bHWstarch =&
		KbHWch*SSpV3body(mbH,mch,mW)&
		*(&
			! LO
			+1.d0&
			! NLO Weak correction
			!	*S_NLOEW&
			! NLO  QED correction
			!	*S_NLOQCD&
			! NLO QCD correctio
			+CF*3.d0/4.d0/pi*alphas(lam_QCD5,mW,5.d0)*S_NLOQCD&
			! NNLO  QCD correction
			!	*S_NNLOQCD
		)

	end function
!=====================================
!     1PI vertex functions
!=====================================
!-------------------------------------------------------------
!     bHff 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function FbHff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: mch,mA,mbh,bmsq,alpha,beta,p1sq,p2sq,qsq,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then 
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

	FbHff_S = 1.d0/(16.d0*pi**2)*mf/vev*(&
		!FVF
		-4.d0*xibH*gz**2*(vf**2-af**2)*Chff_FVF(p1sq,p2sq,qsq,mf,mZ)&
		-QED*4.d0*xibH*(g*sw)**2*Qf**2*Chff_FVF(p1sq,p2sq,qsq,mf,mphoton)&
		!FSF
		+xibH*xih**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mh)&
		+xibH*xibH**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mbH)&
		-xibH*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mz)&
		-xibH*xiA**2*mf**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mf,mA)&
		-xibHp*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mw)&
		-xibHp*xiA*xiAp*2.d0*mfp**2/vev**2*Chff_FSF(p1sq,p2sq,qsq,mfp,mch)&
		!SFS
		-2.d0*cos(beta-alpha)*gz**4*vev**2*(vf**2-af**2)*c0f(p1sq,p2sq,qsq,mZ,mf,mZ)&
		-2.d0*xih**2*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mh,mf,mh)&
		-6.d0*xibH**2*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mbH,mf,mbH)&
		-2.d0*xih*xibH*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*(&
			c0f(p1sq,p2sq,qsq,mbH,mf,mh)+c0f(p1sq,p2sq,qsq,mh,mf,mbH)&
		)&
		+2.d0*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mz,mf,mz)&
		+2.d0*xiA**2*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*c0f(p1sq,p2sq,qsq,mA,mf,mA)&
		+xiA*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev*(&
			c0f(p1sq,p2sq,qsq,mA,mf,mz)+c0f(p1sq,p2sq,qsq,mz,mf,mA)&
		)&
		+lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*2.d0*mfp**2/vev*c0f(p1sq,p2sq,qsq,mw,mfp,mw)&
		+xiA*xiAp*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*2.d0*mfp**2/vev*c0f(p1sq,p2sq,qsq,mch,mfp,mch)&
		+lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*mfp**2/vev*(xiA+xiAp)*(&
			c0f(p1sq,p2sq,qsq,mw,mfp,mch)+c0f(p1sq,p2sq,qsq,mch,mfp,mw)&
		)&
		!VFS
		-g**2/4.d0*cos(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)&
		+g**2/4.d0*xiA*sin(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mch)&
		-gz**2/8.d0*cos(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)&
		+gz**2/8.d0*xiA*sin(beta-alpha)*Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mA)&
		!SFV
		-g**2/4.d0*cos(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW)&
		+g**2/4.d0*xiA*sin(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mch,mfp,mW)&
		-gz**2/8.d0*cos(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ)&
		+gz**2/8.d0*xiA*sin(beta-alpha)*Chff_SFV(p1sq,p2sq,qsq,mA,mf,mZ)&
	)

	end function
!===============================================================================================
	complex (kind(0d0)) function FbHff_P(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

	FbHff_P =&
		+1.d0/(16.d0*pi**2)*mf/vev*cos(beta-alpha)*(& 
			+g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mw)-Chff_SFV(p1sq,p2sq,qsq,mw,mfp,mW))&
			+2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mz)-Chff_SFV(p1sq,p2sq,qsq,mz,mf,mZ))&
		)&
		+1.d0/(16.d0*pi**2)*mf/vev*sin(beta-alpha)*xiA*(&
			-g**2/4.d0*(Chff_VFS(p1sq,p2sq,qsq,mW,mfp,mch)-Chff_SFV(p1sq,p2sq,qsq,mch,mfp,mW))&
			-2.d0*gz**2*vf*af*(Chff_VFS(p1sq,p2sq,qsq,mZ,mf,mA)-Chff_SFV(p1sq,p2sq,qsq,mA,mf,mZ))&              
		)

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function FbHff_V1(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

	FbHff_V1 = 1.d0/(16.d0*pi**2)*(&
		!FVF
		-xibH*2.d0*gz**2*(vf**2+af**2)*mf**2/vev*(&
			c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf)&
		)&
		-QED*xibH*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(&
			c0f(p1sq,p2sq,qsq,mf,mphoton,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mphoton,mf)&
		)&
		-xibHp*g**2/2.d0*mfp**2/vev*(&
			c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp)&
		)&
		!FSF
		-xibH*xih**2*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mh,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mh,mf)&
		)&
		-xibH*xibH**2*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mbH,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mbH,mf)&
		)&
		-xibH*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mz,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mz,mf)&
		)&
		-xibH*xiA**2*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mA,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mA,mf)&
		)&
		-xibHp*mfp**2/vev**3*(mf**2+mfp**2)*(&
			c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp)&
		)&
		-xibHp*mfp**2/vev**3*(mf**2*xiA**2+mfp**2*xiAp**2)*(&
			c0f(p1sq,p2sq,qsq,mfp,mch,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mch,mfp)&
		)&
		!VFV
		+cos(beta-alpha)*gz**4*vev*(vf**2+af**2)*(&
			c0f(p1sq,p2sq,qsq,mZ,mf,mZ)+c11f(p1sq,p2sq,qsq,mZ,mf,mZ)&
		)&
		+cos(beta-alpha)*g**4/4.d0*vev*(&
			c0f(p1sq,p2sq,qsq,mW,mfp,mW)+c11f(p1sq,p2sq,qsq,mW,mfp,mW)&
		)&
		!SFS
		-2.d0*xih**2*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c0f(p1sq,p2sq,qsq,mh,mf,mh)+c11f(p1sq,p2sq,qsq,mh,mf,mh)&
		)&
		-6.d0*xibH**2*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c0f(p1sq,p2sq,qsq,mbH,mf,mbH)+c11f(p1sq,p2sq,qsq,mbH,mf,mbH)&
		)&
		-2.d0*xih*xibH*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c0f(p1sq,p2sq,qsq,mbH,mf,mh)+c11f(p1sq,p2sq,qsq,mbH,mf,mh)&
			+c0f(p1sq,p2sq,qsq,mh,mf,mbH)+c11f(p1sq,p2sq,qsq,mh,mf,mbH)&
		)&
		-2.d0*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c0f(p1sq,p2sq,qsq,mz,mf,mz)+c11f(p1sq,p2sq,qsq,mz,mf,mz)&
		)&
		-2.d0*xiA**2*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c0f(p1sq,p2sq,qsq,mA,mf,mA)+c11f(p1sq,p2sq,qsq,mA,mf,mA)&
		)&
		-1.d0*xiA*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c0f(p1sq,p2sq,qsq,mA,mf,mz)+c11f(p1sq,p2sq,qsq,mA,mf,mz)&
		)&
		-1.d0*xiA*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c0f(p1sq,p2sq,qsq,mz,mf,mA)+c11f(p1sq,p2sq,qsq,mz,mf,mA)&
		)&
		-1.d0*lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2+mfp**2)/vev**2*(&
			c0f(p1sq,p2sq,qsq,mw,mfp,mw)+c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
		)&
		-1.d0*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*(xiA**2*mf**2+xiAp**2*mfp**2)/vev**2*(&
			c0f(p1sq,p2sq,qsq,mch,mfp,mch)+c11f(p1sq,p2sq,qsq,mch,mfp,mch)&
		)&
		-1.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(&
			c0f(p1sq,p2sq,qsq,mch,mfp,mw)+c11f(p1sq,p2sq,qsq,mch,mfp,mw)&
		)&
		-1.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(&
			c0f(p1sq,p2sq,qsq,mw,mfp,mch)+c11f(p1sq,p2sq,qsq,mw,mfp,mch)&
		)&
		!VFS+SFV
		+cos(beta-alpha)*g**2/4.d0*mfp**2/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
      	-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
		)&
		-sin(beta-alpha)*g**2/4.d0*mfp**2*xiAp/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)+c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
			-c0f(p1sq,p2sq,qsq,mch,mfp,mW)+c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
		)&
		+cos(beta-alpha)*gz**2/8.d0*mf**2/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
			-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
		)&
		-sin(beta-alpha)*gz**2/8.d0*mf**2*xiA/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)+c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
			-c0f(p1sq,p2sq,qsq,mA,mf,mZ)+c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
		)&
	)

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function FbHff_V2(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

	FbHff_V2 = 1.d0/(16.d0*pi**2)*(&
		!FVF
		-xibH*2.d0*gz**2*(vf**2 + af**2)*mf**2/vev*(&
			c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf)&
		)&
		-QED*xibH*2.d0*(g*sw)**2*Qf**2*mf**2/vev*(&
			c0f(p1sq,p2sq,qsq,mf,mphoton,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mphoton,mf)&
		)&
		-xibHp*g**2/2.d0*mfp**2/vev*(&
			c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp)&
		)&
		!FSF
		-xibH*xih**2*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mh,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mh,mf)&
		)&
		-xibH*xibH**2*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mbH,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mbH,mf)&
		)&
		-xibH*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mz,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mz,mf)&
		)&
		-xibH*xiA**2*mf**4/vev**3*(&
			c0f(p1sq,p2sq,qsq,mf,mA,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mA,mf)&
		)&
		-xibHp*mfp**2/vev**3*(mf**2+mfp**2)*(&
			c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp)&
		)&
		-xibHp*mfp**2/vev**3*(mf**2*xiA**2+mfp**2*xiAp**2)*(&
			c0f(p1sq,p2sq,qsq,mfp,mch,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mch,mfp)&
		)&
		!VFV
		+cos(beta-alpha)*gz**4*vev*(vf**2+af**2)*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
		+cos(beta-alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
		!SFS
		-2.d0*xih**2*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mh,mf,mh))&
		-6.d0*xibH**2*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mbH,mf,mbH))&
		-2.d0*xih*xibH*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(&
			c12f(p1sq,p2sq,qsq,mbH,mf,mh)+c12f(p1sq,p2sq,qsq,mh,mf,mbH)&
		)&
		-2.d0*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mz))&
		-2.d0*xiA**2*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mA,mf,mA))&
		-1.d0*xiA*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mA,mf,mz))&
		-1.d0*xiA*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*mf**2/vev**2*(c12f(p1sq,p2sq,qsq,mz,mf,mA))&
		-1.d0*lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2+mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
		-1.d0*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*(xiA**2*mf**2+xiAp**2*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mch,mfp,mch))&
		-1.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mch,mfp,mw))&
		-1.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(xiA*mf**2+xiAp*mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mch))&
		!VFS+SFV
		+cos(beta-alpha)*g**2/4.d0*mfp**2/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)+c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
			-c0f(p1sq,p2sq,qsq,mw,mfp,mW)+c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
		)&
		-sin(beta-alpha)*g**2/4.d0*mfp**2*xiAp/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)+c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
			-c0f(p1sq,p2sq,qsq,mch,mfp,mW)+c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
		)&
		+cos(beta-alpha)*gz**2/8.d0*mf**2/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)+c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
			-c0f(p1sq,p2sq,qsq,mz,mf,mZ)+c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
		)&
		-sin(beta-alpha)*gz**2/8.d0*mf**2*xiA/vev*(&
			2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)+c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
			-c0f(p1sq,p2sq,qsq,mA,mf,mZ)+c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
		)&
	)

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function FbHff_A1(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

! Modified by mariko (2020/04/22)
	FbHff_A1 =&
		1.d0/(16.d0*pi**2)*(& 
			xibH*4.d0*gz**2*vf*af*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c11f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+xibHp*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			-xibHp*mfp**2*(mf**2-mfp**2)/vev**3*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			-xibHp*mfp**2*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**3*(&
				c0f(p1sq,p2sq,qsq,mfp,mch,mfp)+2.d0*c11f(p1sq,p2sq,qsq,mfp,mch,mfp)&
			)&
			!
			-cos(beta-alpha)*2.d0*gz**4*vf*af*vev*(&
				c0f(p1sq,p2sq,qsq,mZ,mf,mZ)+c11f(p1sq,p2sq,qsq,mZ,mf,mZ)&
			)&
			-cos(beta-alpha)*g**4/4.d0*vev*(&
				c0f(p1sq,p2sq,qsq,mW,mfp,mW)+c11f(p1sq,p2sq,qsq,mW,mfp,mW)&
			)&
			!
			-lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2-mfp**2)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mw,mfp,mw)+c11f(p1sq,p2sq,qsq,mw,mfp,mw)&
			)&
			-lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mch,mfp,mch)+c11f(p1sq,p2sq,qsq,mch,mfp,mch)&
			)&
			-lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mch,mfp,mw)+c11f(p1sq,p2sq,qsq,mch,mfp,mw)&
			)&
			-lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2*(&
				c0f(p1sq,p2sq,qsq,mw,mfp,mch)+c11f(p1sq,p2sq,qsq,mw,mfp,mch)&
			)&
			!
			-cos(beta-alpha)*g**2*mfp**2/(4.d0*vev)*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
				+c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+sin(beta-alpha)*g**2*mfp**2*xiAp/(4.d0*vev)*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
				+c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
				-c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
				+c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
			)&
			-cos(beta-alpha)*2.d0*gz**2*vf*af*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
				+c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
			+sin(beta-alpha)*2.d0*gz**2*vf*af*mf**2*xiA/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
				+c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
				-c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
				+c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function FbHff_A2(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

	FbHff_A2 =&
		1.d0/(16.d0*pi**2)*(& 
			xibH*4.d0*gz**2*vf*af*mf**2/vev*(&
				c0f(p1sq,p2sq,qsq,mf,mZ,mf)+2.d0*c12f(p1sq,p2sq,qsq,mf,mZ,mf)&
			)&
			+xibHp*g**2/2.d0*mfp**2/vev*(&
				c0f(p1sq,p2sq,qsq,mfp,mW,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mW,mfp)&
			)&
			-xibHp*mfp**2*(mf**2-mfp**2)/vev**3*(&
				c0f(p1sq,p2sq,qsq,mfp,mw,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			)&
			-xibHp*mfp**2*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**3*(&
				c0f(p1sq,p2sq,qsq,mfp,mch,mfp)+2.d0*c12f(p1sq,p2sq,qsq,mfp,mch,mfp)&
			)&
			!
			-cos(beta-alpha)*2.d0*gz**4*vf*af*vev*(c12f(p1sq,p2sq,qsq,mZ,mf,mZ))&
			-cos(beta-alpha)*g**4/4.d0*vev*(c12f(p1sq,p2sq,qsq,mW,mfp,mW))&
			!
			-lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2-mfp**2)/vev**2*(c12f(p1sq,p2sq,qsq,mw,mfp,mw))&
			-lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA**2-mfp**2*xiAp**2)/vev**2&
				*c12f(p1sq,p2sq,qsq,mch,mfp,mch)&
			-lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2&
				*c12f(p1sq,p2sq,qsq,mch,mfp,mw)&
			-lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*(mf**2*xiA-mfp**2*xiAp)/vev**2&
				*c12f(p1sq,p2sq,qsq,mw,mfp,mch)&
			!
			-cos(beta-alpha)*g**2*mfp**2/(4.d0*vev)*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
				+c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+sin(beta-alpha)*g**2*mfp**2*xiAp/(4.d0*vev)*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
				+c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
				-c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
				+c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
			)&
			-cos(beta-alpha)*2.d0*gz**2*vf*af*mf**2/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
				+c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
			+sin(beta-alpha)*2.d0*gz**2*vf*af*mf**2*xiA/vev*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
				+c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
				-c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
				+c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
			)&
		)

	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function FbHff_T(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

	FbHff_T =&
		1.d0/(16.d0*pi**2)*(mf/vev)*(&
			-xibH*xih**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mh,mf)-c12f(p1sq,p2sq,qsq,mf,mh,mf))&
			-xibH*xibH**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mbH,mf)-c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
			+xibH*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mz,mf)-c12f(p1sq,p2sq,qsq,mf,mz,mf))&
			+xibH*xiA**2*mf**2/vev**2*(c11f(p1sq,p2sq,qsq,mf,mA,mf)-c12f(p1sq,p2sq,qsq,mf,mA,mf))&
			+xibHp*2.d0*mfp**2/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mw,mfp)-c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
			+xibHp*2.d0*mfp**2*xiAp*xiA/vev**2*(c11f(p1sq,p2sq,qsq,mfp,mch,mfp)-c12f(p1sq,p2sq,qsq,mfp,mch,mfp))&
			!
			-cos(beta-alpha)*g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
				+1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
				-2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+sin(beta-alpha)*xiA*g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
				-1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
				+1.d0*c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
				+1.d0*c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
				-2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
			)&
			-cos(beta-alpha)*gz**2/8.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
				+1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
				-2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
			+sin(beta-alpha)*gz**2*xiA/8.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
				+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
				-1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
				+1.d0*c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
				+1.d0*c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
				-2.d0*c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
			)&
		)
 
	end function
!------------------------------------------------------------
 	complex (kind(0d0)) function FbHff_PT(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
 	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	double precision:: vf,af,qf,mfp,xiA,xiAp,xih,xihp,xibH,xibHp
	integer, intent(in):: n

	if (mf == mt) then
		vf = vt;af = at;qf = qt;mfp = mb;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mc) then
		vf = vt;af = at;qf = qt;mfp = ms;xiA=xiu_A(alpha,beta,n);xiAp=xid_A(alpha,beta,n)
		xih=xiu(alpha,beta,n);xihp=xid(alpha,beta,n);xibH=xiu_H(alpha,beta,n);xibHp=xid_H(alpha,beta,n)
	elseif (mf == mb) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)
	elseif (mf == ms) then
		vf = vb;af = ab;qf = qb;mfp = mt;xiA=xid_A(alpha,beta,n);xiAp=xiu_A(alpha,beta,n)
		xih=xid(alpha,beta,n);xihp=xiu(alpha,beta,n);xibH=xid_H(alpha,beta,n);xibHp=xiu_H(alpha,beta,n)	
	elseif (mf == mtau) then 
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	elseif (mf == mmu) then
		vf = ve;af = ae;qf = qe;mfp = 0.d0
		xih=xil(alpha,beta,n);xiA=xil_A(alpha,beta,n);xibH=xil_H(alpha,beta,n)
		xihp=0.d0;xiAp=0.d0;xibHp=0.d0
	endif

	FbHff_PT =&
		1.d0/(16.d0*pi**2)*(mf/vev)*cos(beta-alpha)*(&
			g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mw)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mw)&
				-1.d0*c0f(p1sq,p2sq,qsq,mw,mfp,mW)&
				-1.d0*c11f(p1sq,p2sq,qsq,mw,mfp,mW)&
				+2.d0*c12f(p1sq,p2sq,qsq,mw,mfp,mW)&
			)&
			+2.d0*gz**2*af*vf*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mz)&
				+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mz)&
				-1.d0*c0f(p1sq,p2sq,qsq,mz,mf,mZ)&
				-1.d0*c11f(p1sq,p2sq,qsq,mz,mf,mZ)&
				+2.d0*c12f(p1sq,p2sq,qsq,mz,mf,mZ)&
			)&
		)&
		!
		+1.d0/(16.d0*pi**2)*(mf/vev)*sin(beta-alpha)*xiA*(&
			-g**2/4.d0*(&
				2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)&
				-1.d0*c12f(p1sq,p2sq,qsq,mW,mfp,mch)&
				-1.d0*c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
				-1.d0*c11f(p1sq,p2sq,qsq,mch,mfp,mW)&
				+2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
			)&
			-2.d0*gz**2*af*vf*(&
				2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mA)&
				+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mA)&
				-1.d0*c12f(p1sq,p2sq,qsq,mZ,mf,mA)&
				-1.d0*c0f(p1sq,p2sq,qsq,mA,mf,mZ)&
				-1.d0*c11f(p1sq,p2sq,qsq,mA,mf,mZ)&
				+2.d0*c12f(p1sq,p2sq,qsq,mA,mf,mZ)&
			)&
		)
 
	end function
!-------------------------------------------------------------
!  bHff renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_hff_S_tree_SM(mf)
	double precision, intent(in):: mf
 
	Gam_hff_S_tree_SM = -mf/vev
 
	end function
 !--------------------------------------------- 
	complex (kind(0d0)) function Gam_hff_S_tree(alpha,beta,n,mf)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta,mf
	double precision:: xif_h

	if (mf == mt .or. mf == mc) then
		xif_h = xiu(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		xif_h = xid(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		xif_h = xil(alpha,beta,n)
	endif

	Gam_hff_S_tree = -mf/vev*xif_h

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_bHff_S_tree(alpha,beta,n,mf)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta,mf
	double precision:: xif_H

	if (mf == mt .or. mf == mc) then
		xif_H = xiu_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		xif_H = xid_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		xif_H = xil_H(alpha,beta,n)
	endif

	Gam_bHff_S_tree = -mf/vev*xif_H

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_bHff_S_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: xif_h,xif_bH,xif_A
	double precision:: del_mf,del_ZVf,del_xif_bH

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			del_mf  = del_mt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVt(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mf == mc) then
			del_mf  = del_mc(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVc(mch,mA,mbH,bmsq,alpha,beta,n)
		endif
		xif_h = xiu(alpha,beta,n); xif_bH = xiu_H(alpha,beta,n)
		xif_A = xiu_A(alpha,beta,n)
		del_xif_bH = del_xiu_H(mch,mA,mbh,bmsq,alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			del_mf  = del_mb(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVb(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mf == ms) then
			del_mf  = del_ms(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVs(mch,mA,mbH,bmsq,alpha,beta,n)
		endif
		xif_h = xid(alpha,beta,n); xif_bH = xid_H(alpha,beta,n)
		xif_A = xid_A(alpha,beta,n)
		del_xif_bH = del_xid_H(mch,mA,mbh,bmsq,alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		if(mf == mtau) then
			del_mf  = del_mtau(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVtau(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mf == mmu) then
			del_mf  = del_mmu(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVmu(mch,mA,mbH,bmsq,alpha,beta,n)
		endif
		xif_h = xil(alpha,beta,n); xif_bH = xil_H(alpha,beta,n)
		xif_A = xil_A(alpha,beta,n)
		del_xif_bH = del_xil_H(mch,mA,mbh,bmsq,alpha,beta,n)
	endif

	Gam_bHff_S_loop=&
		FbHff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)&
		+Gam_bHff_S_tree(alpha,beta,n,mf)*(&
			+del_mf/mf&
			-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
			+del_ZVf&
			+del_ZbH(mch,mA,mbh,bmsq,alpha,beta,n)/2.d0&
		)&
		+Gam_hff_S_tree_SM(mf)*del_xif_bH&
		+Gam_hff_S_tree(alpha,beta,n,mf)*(&
			+del_Ch(mch,mA,mbh,bmsq,alpha,beta,n)&
			-del_alpha(mch,mA,mbh,bmsq,alpha,beta,n)&
		)&
		!----- Add the difference between the KOSY scheme and the PT scheme -----
		+Gam_hff_S_tree(alpha,beta,n,mf)*del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta)&
		-Gam_bHff_S_tree(alpha,beta,n,mf)*xif_A*del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)

	end function
!---------------------------------------------
	complex (kind(0d0)) function rGam_bHff_S(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,mf
	integer, intent(in)::n
 
	rGam_bHff_S =&
		+Gam_bHff_S_tree(alpha,beta,n,mf)&
		+Gam_bHff_S_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)

	end function
!-------------------------------------------------------------
!     bHZZ 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam1_bHZZ_F =&
		+Nc*xiu_H(alpha,beta,n)*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mt)&
      +Nc*xiu_H(alpha,beta,n)*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mc)&
      +Nc*xid_H(alpha,beta,n)*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mb)&
      +xil_H(alpha,beta,n)*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mtau)&
      +xil_H(alpha,beta,n)*Gam1_hZZ_fermion(p1sq,p2sq,qsq,mmu)
	
	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam2_bHZZ_F =&
		+Nc*xiu_H(alpha,beta,n)*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mt)&
      +Nc*xiu_H(alpha,beta,n)*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mc)&
      +Nc*xid_H(alpha,beta,n)*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mb)&
      +xil_H(alpha,beta,n)*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mtau)&
      +xil_H(alpha,beta,n)*Gam2_hZZ_fermion(p1sq,p2sq,qsq,mmu)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_bHZZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam3_bHZZ_F =&
		+Nc*xiu_H(alpha,beta,n)*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mt)&
      +Nc*xiu_H(alpha,beta,n)*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mc)&
      +Nc*xid_H(alpha,beta,n)*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mb)&
      +xil_H(alpha,beta,n)*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mtau)&
      +xil_H(alpha,beta,n)*Gam3_hZZ_fermion(p1sq,p2sq,qsq,mmu)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	Gam1_bHZZ_B = 1.d0/(16.d0*pi**2)*(&
		!VVV
		+cos(beta-alpha)*2.d0*g**3*mw*cw**2*ChVV1_VVV(p1sq,p2sq,qsq,mW,mW,mW)&
		!ccc
		-2.d0*cos(beta-alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mw,mw)&
		!SVV
		+cos(beta-alpha)*g**3*mw*sw**2*ChVV1_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
		!VVS
		+cos(beta-alpha)*g**3*mw*sw**2*ChVV1_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
		!VSV
		-cos(beta-alpha)*2.d0*g**3*mw**3/cw**2*sw**4*c0f(p1sq,p2sq,qsq,mW,mw,mW)&
		-cos(beta-alpha)*sin(beta-alpha)**2*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mh,mZ)&
		-cos(beta-alpha)*cos(beta-alpha)**2*gz**3*mz**3*c0f(p1sq,p2sq,qsq,mZ,mbH,mZ)&
		!SSV+VSS
		-cos(beta-alpha)*g**3*mw/cw**2*(cw**2-sw**2)*sw**2*&
			(c24f(p1sq,p2sq,qsq,mw,mw,mW)+c24f(p1sq,p2sq,qsq,mW,mw,mw))&
		+cos(beta-alpha)*sin(beta-alpha)**2*gz**3/2.d0*mz*&
 			(c24f(p1sq,p2sq,qsq,mz,mh,mZ)+c24f(p1sq,p2sq,qsq,mZ,mh,mz))&
		-sin(beta-alpha)**2*cos(beta-alpha)*gz**3/2.d0*mz*&
			(c24f(p1sq,p2sq,qsq,mA,mh,mZ)+c24f(p1sq,p2sq,qsq,mZ,mh,mA))&
		+cos(beta-alpha)*cos(beta-alpha)**2*gz**3/2.d0*mz*&
			(c24f(p1sq,p2sq,qsq,mz,mbH,mZ)+c24f(p1sq,p2sq,qsq,mZ,mbH,mz))&
		+sin(beta-alpha)**2*cos(beta-alpha)*gz**3/2.d0*mz*&
			(c24f(p1sq,p2sq,qsq,mA,mbH,mZ)+c24f(p1sq,p2sq,qsq,mZ,mbH,mA))&
		!SVS
		+2.d0*gz**2*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*&
			mw**2*sw**4*c0f(p1sq,p2sq,qsq,mw,mW,mw)&
		+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*&
			gz**2*mz**2*c0f(p1sq,p2sq,qsq,mh,mZ,mh)&
		+6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*&
			gz**2*mz**2*c0f(p1sq,p2sq,qsq,mbH,mZ,mbH)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*&
			gz**2*mz**2*(c0f(p1sq,p2sq,qsq,mbH,mZ,mh)+c0f(p1sq,p2sq,qsq,mh,mZ,mbH))&
		!SSS
		-2.d0*gz**2*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*&
			(cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mw,mw,mw)&
		-2.d0*gz**2*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*&
			(cw**2-sw**2)**2*c24f(p1sq,p2sq,qsq,mch,mch,mch)&
		-sin(beta-alpha)**2*2.d0*gz**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mh,mz,mh)&
		-cos(beta-alpha)**2*6.d0*gz**2*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mbH,mz,mbH)&
		-cos(beta-alpha)*sin(beta-alpha)*2.d0*gz**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*&
			(c24f(p1sq,p2sq,qsq,mh,mz,mbH)+c24f(p1sq,p2sq,qsq,mbH,mz,mh))&
		-cos(beta-alpha)**2*2.d0*gz**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mh,mA,mh)&
		-sin(beta-alpha)**2*6.d0*gz**2*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mbH,mA,mbH)&
		+cos(beta-alpha)*sin(beta-alpha)*2.d0*gz**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*&
			(c24f(p1sq,p2sq,qsq,mh,mA,mbH)+c24f(p1sq,p2sq,qsq,mbH,mA,mh))&
		-sin(beta-alpha)**2*2.d0*gz**2*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mz,mh,mz)&
		-cos(beta-alpha)**2*2.d0*gz**2*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mA,mh,mA)&
		-cos(beta-alpha)*sin(beta-alpha)*gz**2*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*&
			(c24f(p1sq,p2sq,qsq,mA,mh,mz)+c24f(p1sq,p2sq,qsq,mz,mh,mA))&
		-cos(beta-alpha)**2*2.d0*gz**2*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mz,mbH,mz)&
		-sin(beta-alpha)**2*2.d0*gz**2*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*&
			c24f(p1sq,p2sq,qsq,mA,mbH,mA)&
		+cos(beta-alpha)*sin(beta-alpha)*gz**2*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*&
			(c24f(p1sq,p2sq,qsq,mA,mbH,mz)+c24f(p1sq,p2sq,qsq,mz,mbH,mA))&
		!VV
		-cos(beta-alpha)*6.d0*g**3*cw**2*mW*(b0f(qsq,mW,mW)-2.d0/3.d0)&
		!SV
		-cos(beta-alpha)*g**3/cw**2*mw*sw**4*( b0f(p2sq,mW,mw)+b0f(p1sq,mw,mW) )&
		-cos(beta-alpha)*1.d0/2.d0*gz**3*mz*( b0f(p1sq,mbH,mZ)+b0f(p2sq,mbH,mZ))&
		!SS
		+1.d0/2.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gz**2*(cw**2-sw**2)**2*b0f(qsq,mw,mw)&
		+1.d0/2.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gz**2*(cw**2-sw**2)**2*b0f(qsq,mch,mch)&
		+1.d0/2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mz,mz)&
		+1.d0/2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mA,mA)&
		+3.d0/2.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mbH,mbH)&
		+1.d0/2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*gz**2*b0f(qsq,mh,mh)&
	)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHZZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	Gam2_bHZZ_B = gz**2/(16.d0*pi**2)*mz**2*(&
		!VVV+ccc
		+cos(beta-alpha)*2.d0*g*mw*cw**4&
			*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mW,mW)-C1223(p1sq,p2sq,qsq,mw,mw,mw))&
		!SVV
		+cos(beta-alpha)*g*mw*sw**2*cw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
		!VVS
		+cos(beta-alpha)*g*mw*sw**2*cw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
		!SSV+VSS
		-cos(beta-alpha)*g*mw*(cw**2-sw**2)*sw**2&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mw,mw,mW)+ChVV2_VSS(p1sq,p2sq,qsq,mW,mw,mw))&
		+cos(beta-alpha)*sin(beta-alpha)**2*gz/2.d0*mz&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mz,mh,mZ)+ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mz))&
		+cos(beta-alpha)*cos(beta-alpha)**2*gz/2.d0*mz&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mz,mbH,mZ)+ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mz))&
		-sin(beta-alpha)**2*cos(beta-alpha)*gz/2.d0*mz&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mA,mh,mZ)+ChVV2_VSS(p1sq,p2sq,qsq,mZ,mh,mA))&
		+sin(beta-alpha)**2*cos(beta-alpha)*gz/2.d0*mz&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mA,mbH,mZ)+ChVV2_VSS(p1sq,p2sq,qsq,mZ,mbH,mA))&
		!SSS
		-2.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mw,mw,mw)&
		-2.d0*sin(beta-alpha)**2*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mh,mz)&
		-2.d0*cos(beta-alpha)**2*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mbH,mz)&
		-2.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*(cw**2-sw**2)**2*c1223(p1sq,p2sq,qsq,mch,mch,mch)&
		-2.d0*cos(beta-alpha)**2*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mh,mA)&
		-2.d0*sin(beta-alpha)**2*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mbH,mA)&
		-2.d0*sin(beta-alpha)**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mz,mh)&
		-2.d0*cos(beta-alpha)**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mA,mh)&
		-6.d0*cos(beta-alpha)**2*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mz,mbH)&
		-6.d0*sin(beta-alpha)**2*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mA,mbH)&
		-2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mz,mh)&
		-2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mz,mbH)&
		+2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mbH,mA,mh)&
		+2.d0*cos(beta-alpha)*sin(beta-alpha)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mh,mA,mbH)&
		-1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mh,mz)&
		-1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mh,mA)&
		+1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mbH,mz)&
		+1.d0*sin(beta-alpha)*cos(beta-alpha)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mbH,mA)&
	)

	end function
!-------------------------------------------------------------
!   bHZZ counter-terms
!-------------------------------------------------------------
	complex (kind(0d0)) function del_Gam1_bHZZ_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta
	double precision:: Gam1_bHZZ_tree,Gam1_hZZ_tree

	Gam1_bHZZ_tree = 2.d0*mZ**2/vev*cos(beta-alpha)
	Gam1_hZZ_tree  = 2.d0*mZ**2/vev*sin(beta-alpha)

	del_Gam1_bHZZ_F =&
		+Gam1_bHZZ_tree*(&
	      +del_mZsq_F(alpha,beta,n)/mz**2&
	      +1.d0/2.d0*del_ZbH_F(mbH,alpha,beta,n)&
			+del_ZZ_F(alpha,beta,n)&
	      -del_v_F(alpha,beta,n)/vev&
		)&
		+Gam1_hZZ_tree*(&
			-del_beta_F(mA,alpha,beta,n)&
			+del_alpha_F(mA,alpha,beta,n)&
		)&
		+Gam1_hZZ_tree*(&
			+del_Ch_F(mbH,alpha,beta,n)&
			-del_alpha_F(mA,alpha,beta,n)&
		)
	
	end function
!--------------------------------------------
  	complex (kind(0d0)) function del_Gam1_bHZZ_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	double precision:: Gam1_bHZZ_tree,Gam1_hZZ_tree

	Gam1_bHZZ_tree = 2.d0*mZ**2/vev*cos(beta-alpha)
	Gam1_hZZ_tree  = 2.d0*mZ**2/vev*sin(beta-alpha)

	del_Gam1_bHZZ_B=&
		+Gam1_bHZZ_tree*(&
			+del_mZsq_B(mch,mA,mbH,bmsq,alpha,beta)/mZ**2&
			+1.d0/2.d0*del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta)&
			+del_ZZ_B(mch,mA,mbH,bmsq,alpha,beta)&
			-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		)&
		+Gam1_hZZ_tree*(&
			-del_beta_B(mch,mA,mbH,bmsq,alpha,beta)&
			-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
			+del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
			+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+Gam1_hZZ_tree*(&
			+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
			-del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
		)

	end function
!-------------------------------------------------------------
!   bHZZ renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_loop_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n
 
	Gam1_bHZZ_loop_F =&
		+Gam1_bHZZ_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+del_Gam1_bHZZ_F(alpha,beta,n)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
  	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	
	Gam1_bHZZ_loop_B =&
		+Gam1_bHZZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+del_Gam1_bHZZ_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_bHZZ_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
  	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	
	Gam1_bHZZ_loop =&
		+Gam1_bHZZ_loop_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+Gam1_bHZZ_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!--------------------------------------------
  	complex (kind(0d0)) function rGam1_bHZZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
  	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n
	
	rGam1_bHZZ = 2.d0*mZ**2/vev*cos(beta-alpha)+Gam1_bHZZ_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function
!--------------------------------------------
	complex (kind(0d0)) function rGam2_bHZZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam2_bHZZ = Gam2_bHZZ_F(p1sq,p2sq,qsq,alpha,beta,n)+Gam2_bHZZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam3_bHZZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam3_bHZZ = Gam3_bHZZ_F(p1sq,p2sq,qsq,alpha,beta,n) 

	end function
!-------------------------------------------------------------
!     bHWW 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam1_bHWW_F =&
		+Nc*xiu_H(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,mt)&
      +Nc*xid_H(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,mb)&
      +Nc*xiu_H(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,mc)&
      +Nc*xid_H(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,ms)&
      +xil_H(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,mtau)&
      +xil_H(alpha,beta,n)*Gam1_hWW_fermion(p1sq,p2sq,qsq,mmu)

	end function Gam1_bHWW_F
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam2_bHWW_F =&
		+Nc*xiu_H(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,mt)&
		+Nc*xid_H(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,mb)&
		+Nc*xiu_H(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,mc)&
		+Nc*xid_H(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,ms)&
		+xil_H(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,mtau)&
		+xil_H(alpha,beta,n)*Gam2_hWW_fermion(p1sq,p2sq,qsq,mmu)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam3_bHWW_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	Gam3_bHWW_F =&
		+Nc*xiu_H(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,mt)&
		+Nc*xid_H(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,mb)&
		+Nc*xiu_H(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,mc)&
		+Nc*xid_H(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,ms)&
		+xil_H(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,mtau)&
		+xil_H(alpha,beta,n)*Gam3_hWW_fermion(p1sq,p2sq,qsq,mmu)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	Gam1_bHWW_B = 1.d0/(16.d0*pi**2)*(&
		!VVV
		+cos(beta-alpha)*g**3*cw*mz*ChVV1_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)&
		+cos(beta-alpha)*g**3*cw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mZ,mW)&
		+cos(beta-alpha)*g**3*sw**2*mw*ChVV1_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)&
	  !ccc
		-cos(beta-alpha)*g**3*sw**2*mw*c24f(p1sq,p2sq,qsq,mw,mphoton,mw)&
		-cos(beta-alpha)*g**3*cw*mz*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
		-cos(beta-alpha)*g**3*cw**2*mw*c24f(p1sq,p2sq,qsq,mw,mz,mw)&
		!SVV
		-cos(beta-alpha)*1.d0/2.d0*g**3*mw*sw**2&
			*(ChVV1_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-ChVV1_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
		!VVS
		-cos(beta-alpha)*1.d0/2.d0*g**3*mw*sw**2&
			*(ChVV1_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-ChVV1_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
		!VSV
		-cos(beta-alpha)*g**3/cw**3*mw**2*mZ*sw**4*c0f(p1sq,p2sq,qsq,mZ,mw,mZ)&
		-sin(beta-alpha)**2*cos(beta-alpha)*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mh,mW)&
		-cos(beta-alpha)**3*g**3*mw**3*c0f(p1sq,p2sq,qsq,mW,mbH,mW)&  
		!SVS
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*mw**2*sw**4/cw**2*c0f(p1sq,p2sq,qsq,mw,mZ,mw)&
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*sw**2*mw**2*c0f(p1sq,p2sq,qsq,mw,mphoton,mw)&
		+sin(beta-alpha)**2*2.d0*g**2*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*mw**2*c0f(p1sq,p2sq,qsq,mh,mW,mh)& 
		+cos(beta-alpha)**2*6.d0*g**2*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*mw**2*c0f(p1sq,p2sq,qsq,mbH,mW,mbH)& 
		+cos(beta-alpha)*sin(beta-alpha)*2.d0*g**2*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*mw**2&
			*(c0f(p1sq,p2sq,qsq,mh,mW,mbH)+c0f(p1sq,p2sq,qsq,mbH,mW,mh))&
		!SSV+VSS
		+cos(beta-alpha)*1.d0/2.d0*g**3*mw*(&
			+sin(beta-alpha)**2*(&
				+c24f(p1sq,p2sq,qsq,mW,mh,mw)+c24f(p1sq,p2sq,qsq,mw,mh,mW)&
				-c24f(p1sq,p2sq,qsq,mW,mh,mch)-c24f(p1sq,p2sq,qsq,mch,mh,mW)&
				+c24f(p1sq,p2sq,qsq,mW,mbH,mch)+c24f(p1sq,p2sq,qsq,mch,mbH,mW))&
			+cos(beta-alpha)**2*(&
				c24f(p1sq,p2sq,qsq,mW,mbH,mw)+c24f(p1sq,p2sq,qsq,mw,mbH,mW))&
		)&
		+cos(beta-alpha)*1.d0/2.d0*g**3*mw*sw**2/cw**2&
			*(c24f(p1sq,p2sq,qsq,mz,mw,mZ)+c24f(p1sq,p2sq,qsq,mZ,mw,mz))&
		!SSS
		-sin(beta-alpha)**2*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mw,mh,mw)&
		-cos(beta-alpha)**2*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mw,mbH,mw)&
		-lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mw,mz,mw)&
		-cos(beta-alpha)**2*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mch,mh,mch)&
		-sin(beta-alpha)**2*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mch,mbH,mch)&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mch,mA,mch)&
		-sin(beta-alpha)*cos(beta-alpha)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2&
			*(c24f(p1sq,p2sq,qsq,mw,mh,mch)+c24f(p1sq,p2sq,qsq,mch,mh,mw))&
		+sin(beta-alpha)*cos(beta-alpha)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2&
			*(c24f(p1sq,p2sq,qsq,mw,mbH,mch)+c24f(p1sq,p2sq,qsq,mch,mbH,mw))&
		-sin(beta-alpha)**2*2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mh,mw,mh)&
		-cos(beta-alpha)**2*6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mbH,mw,mbH)&
		-cos(beta-alpha)*sin(beta-alpha)*2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*g**2&
			*(c24f(p1sq,p2sq,qsq,mh,mw,mbH)+c24f(p1sq,p2sq,qsq,mbH,mw,mh))&
		-cos(beta-alpha)**2*2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mh,mch,mh)&
		-sin(beta-alpha)**2*6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mbH,mch,mbH)&
		+cos(beta-alpha)*sin(beta-alpha)*2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*g**2&
			*(c24f(p1sq,p2sq,qsq,mh,mch,mbH)+c24f(p1sq,p2sq,qsq,mbH,mch,mh))&
		-2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mz,mw,mz)&
		-2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*c24f(p1sq,p2sq,qsq,mA,mch,mA)&
		!VV
		-cos(beta-alpha)*3.d0*g**3*mw*(b0f(qsq,mW,mW)-2.d0/3.d0)&
		-cos(beta-alpha)*3.d0*g**3*cw*mz*(b0f(qsq,mZ,mZ)-2.d0/3.d0)&
		!VS
		-cos(beta-alpha)*1.d0/2.d0*g**3*mw*(b0f(p1sq,mW,mbH)+b0f(p2sq,mW,mbH))&
		-cos(beta-alpha)*1.d0/2.d0*g**3*mw*sw**4/cw**2*(b0f(p1sq,mZ,mw)+b0f(p2sq,mZ,mw))&
		-cos(beta-alpha)*1.d0/2.d0*g**3*sw**2*mw*(b0f(p1sq,mphoton,mw)+b0f(p2sq,mphoton,mw))&
 		!SS
		+1.d0/2.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mw,mw)&
		+1.d0/2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mz,mz)&
		+1.d0/2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mh,mh)&
		+1.d0/2.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mch,mch)&
		+1.d0/2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mA,mA)&
		+3.d0/2.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*g**2*b0f(qsq,mbH,mbH)& 
	)

	end function
!--------------------------------------------
	complex (kind(0d0)) function Gam2_bHWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	Gam2_bHWW_B = g**2/(16.d0*pi**2)*mw**2*(&
		!VVV+ccc
		+cos(beta-alpha)*g*mw&
			*(ChVV2_VVV(p1sq,p2sq,qsq,mZ,mW,mZ)-c1223(p1sq,p2sq,qsq,mz,mw,mz))&
		+cos(beta-alpha)*g*mw*cw**2&
			*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mZ,mW)-c1223(p1sq,p2sq,qsq,mw,mz,mw))& 
		+cos(beta-alpha)*g*mw*sw**2&
			*(ChVV2_VVV(p1sq,p2sq,qsq,mW,mphoton,mW)-c1223(p1sq,p2sq,qsq,mw,mphoton,mw))&
		!SVV
		-cos(beta-alpha)*g/2.d0*mw&
			*(sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mZ,mW)-sw**2*ChVV2_SVV(p1sq,p2sq,qsq,mw,mphoton,mW))&
		!VVS
		-cos(beta-alpha)*g/2.d0*mw&
			*(sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mZ,mw)-sw**2*ChVV2_VVS(p1sq,p2sq,qsq,mW,mphoton,mw))&
		!SSV+VSS
		+sin(beta-alpha)**2*cos(beta-alpha)*g/2.d0*mw&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mw,mh,mW)+ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mw))&
		+cos(beta-alpha)**3*g/2.d0*mw&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mw,mbH,mW)+ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mw))&
		+cos(beta-alpha)*g/2.d0*mw*sw**2/cw**2&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mz,mw,mZ)+ChVV2_VSS(p1sq,p2sq,qsq,mZ,mw,mz))&
		-sin(beta-alpha)**2*cos(beta-alpha)*g/2.d0*mw&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mch,mh,mW)+ChVV2_VSS(p1sq,p2sq,qsq,mW,mh,mch))&
		+sin(beta-alpha)**2*cos(beta-alpha)*g/2.d0*mw&
			*(ChVV2_SSV(p1sq,p2sq,qsq,mch,mbH,mW)+ChVV2_VSS(p1sq,p2sq,qsq,mW,mbH,mch))&
		!SSS
		-2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mz,mw,mz)&
		-1.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mw,mh,mw)&
		-1.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mw,mbH,mw)&
		-1.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mw,mz,mw)&
		-2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mA,mch,mA)&
		-1.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mch,mh,mch)&
		-1.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mch,mbH,mch)&
		-1.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*c1223(p1sq,p2sq,qsq,mch,mA,mch)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mh,mw,mh)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mh,mch,mh)&
		-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mw,mbH)&
		-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*c1223(p1sq,p2sq,qsq,mbH,mch,mbH)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mbH,mw,mh)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mh,mw,mbH)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mbH,mch,mh)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mh,mch,mbH)&
		-1.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mw,mh,mch)&
		-1.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mch,mh,mw)&
		+1.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mw,mbH,mch)&
		+1.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*c1223(p1sq,p2sq,qsq,mch,mbH,mw)&
	)

	end function Gam2_bHWW_B
!-------------------------------------------------------------
!   bHWW counter-terms
!-------------------------------------------------------------
	complex (kind(0d0)) function del_Gam1_bHWW_F(alpha,beta,n)
	integer, intent(in)::n
	double precision, intent(in):: alpha,beta
	double precision:: Gam1_bHWW_tree,Gam1_hWW_tree

	Gam1_bHWW_tree = 2.d0*mW**2/vev*cos(beta-alpha)
	Gam1_hWW_tree  = 2.d0*mW**2/vev*sin(beta-alpha)

	del_Gam1_bHWW_F =&
		+Gam1_bHWW_tree*(&
			+del_mWsq_F(alpha,beta,n)/mW**2&
			+1.d0/2.d0*del_ZbH_F(mbH,alpha,beta,n)&
			+del_ZW_F(alpha,beta,n)&
			-del_v_F(alpha,beta,n)/vev&
		)&
		+Gam1_hWW_tree*(&
			-del_beta_F(mA,alpha,beta,n)&
			+del_alpha_F(mA,alpha,beta,n)&
		)&
		+Gam1_hWW_tree*(&
			+del_Ch_F(mbH,alpha,beta,n)&
			-del_alpha_F(mA,alpha,beta,n)&
		)
	
	end function
!--------------------------------------------
  	complex (kind(0d0)) function del_Gam1_bHWW_B(mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	double precision:: Gam1_bHWW_tree,Gam1_hWW_tree

	Gam1_bHWW_tree = 2.d0*mW**2/vev*cos(beta-alpha)
	Gam1_hWW_tree  = 2.d0*mW**2/vev*sin(beta-alpha)

	del_Gam1_bHWW_B = &
		+2.d0*mW**2/vev*cos(beta-alpha)*(&
			+del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/mW**2&
         +1.d0/2.d0*del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta)&
			+del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)&
			-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev)&
		+Gam1_hWW_tree*(&
			-del_beta_B(mch,mA,mbH,bmsq,alpha,beta)&
			-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
			+del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
			+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+Gam1_hWW_tree*(&
			+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
			-del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
		)

	end function 
!-------------------------------------------------------------
!   bHZZ renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_loop_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

 	 Gam1_bHWW_loop_F =&
		+Gam1_bHWW_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+del_Gam1_bHWW_F(alpha,beta,n)

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

 	 Gam1_bHWW_loop_B =&
		+Gam1_bHWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+del_Gam1_bHWW_B(mch,mA,mbH,bmsq,alpha,beta)

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function Gam1_bHWW_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

 	 Gam1_bHWW_loop =&
		+Gam1_bHWW_loop_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+Gam1_bHWW_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam1_bHWW(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam1_bHWW = 2.d0*mw**2/vev*cos(beta-alpha) + Gam1_bHWW_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)

	end function rGam1_bHWW
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam2_bHWW(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam2_bHWW = Gam2_bHWW_F(p1sq,p2sq,qsq,alpha,beta,n)+Gam2_bHWW_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function rGam2_bHWW
!------------------------------------------------------------------------------------------
	complex (kind(0d0)) function rGam3_bHWW(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam3_bHWW = Gam3_bHWW_F(p1sq,p2sq,qsq,alpha,beta,n) 

	end function rGam3_bHWW
!-------------------------------------------------------------
!     bHHpHm 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHHpHm_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in):: n
	double precision:: gHp_L,gHp_R,gHm_L,gHm_R,gbHuu,gbHdd

	if (mu == mt .or. mu == mc) then
		gHp_L = sqrt(2.d0)*mu*xiu_A(alpha,beta,n)/vev
		gHm_R = sqrt(2.d0)*mu*xiu_A(alpha,beta,n)/vev
		gbHuu = -mu*xiu_H(alpha,beta,n)/vev
	elseif (mu == m0) then
		gHp_L = 0.d0; gHm_R = 0.d0
		gbHuu = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = -sqrt(2.d0)*md*xid_A(alpha,beta,n)/vev
		gHm_L = -sqrt(2.d0)*md*xid_A(alpha,beta,n)/vev
		gbHdd = -md*xid_H(alpha,beta,n)/vev
	elseif (md == mtau .or. md == mmu) then
		gHp_R = -sqrt(2.d0)*md*xil_A(alpha,beta,n)/vev
		gHm_L = -sqrt(2.d0)*md*xil_A(alpha,beta,n)/vev
		gbHdd = -md*xil_H(alpha,beta,n)/vev
	endif

	Gam_bHHpHm_fermion=&
		+gbHuu/(16.d0*pi**2)*(&
			+2.d0*mu*(gHp_L*gHm_R+gHp_R*gHm_L)*(&
				+b0f(p1sq,mu,md)/2.d0+b0f(p2sq,md,mu)/2.d0+b0f(qsq,mu,mu)&
				+(mu**2+md**2-(p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mu,md,mu)&
			)&
			+2.d0*md*(gHp_L*gHm_L+gHp_R*gHm_R)*(&
				+b0f(p1sq,mu,md)/2.d0+b0f(p2sq,md,mu)/2.d0&
				+(2.d0*mu**2-qsq/2.d0)*c0f(p1sq,p2sq,qsq,mu,md,mu)&
			)&
		)&
!
		+gbHdd/(16.d0*pi**2)*(&
			+2.d0*md*(gHp_L*gHm_R+gHp_R*gHm_L)*(&
				+b0f(p1sq,md,mu)/2.d0+b0f(p2sq,mu,md)/2.d0+b0f(qsq,md,md)&
				+(md**2+mu**2-(p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,md,mu,md)&
			)&
			+2.d0*mu*(gHp_L*gHm_L+gHp_R*gHm_R)*(&
				+b0f(p1sq,md,mu)/2.d0+b0f(p2sq,mu,md)/2.d0&
				+(2.d0*md**2-qsq/2.d0)*c0f(p1sq,p2sq,qsq,md,mu,md)&
			)&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHHpHm_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam_bHHpHm_F=&
		+Nc*Gam_bHHpHm_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam_bHHpHm_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam_bHHpHm_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mtau)&
		+Gam_bHHpHm_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHHpHm_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam_bHHpHm_B=&
		1.d0/(16.d0*pi**2)*(& 
		!SVS
		+(g*sw)**2*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mch,mphoton,mch)&
		+(gZ*(cw**2-sw**2))**2/4.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mch,mZ,mch)&
		+g**2*cos(beta-alpha)**2/2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mh,mW,mh)&
		-g**2*cos(beta-alpha)*sin(beta-alpha)/2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SVS(p1sq,p2sq,qsq,mh,mW,mbH)+CSSS_SVS(p1sq,p2sq,qsq,mbH,mW,mh))&
		+3.d0*g**2*sin(beta-alpha)**2/2.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mbH,mW,mbH)&
		+g**2/2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mA,mW,mA)&
   	!SSV+VSS
		+g**2*sin(beta-alpha)*cos(beta-alpha)/4.d0*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mch,mh,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,mh,mch))&
		-g**2*sin(beta-alpha)**2/4.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mch,mbH,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,mbH,mch))&
		-g**2*cos(beta-alpha)**2/4.d0*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mw,mh,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,mh,mw))&
		+g**2*cos(beta-alpha)*sin(beta-alpha)/4.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mw,mbH,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,mbH,mw))&
		+g**2*cos(beta-alpha)/4.d0*ii*lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mw,mA,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,mA,mw))&
		!VSV
		-g**4*vev/8.d0*cos(beta-alpha)*(&
			+cos(beta-alpha)**2*CSSS_VSV(p1sq,p2sq,qsq,mW,mh,mW)&
			+sin(beta-alpha)**2*CSSS_VSV(p1sq,p2sq,qsq,mW,mbH,mW)&
			+CSSS_VSV(p1sq,p2sq,qsq,mW,mA,mW)&
		)&
		-gZ**4*(cw**2-sw**2)**2*vev/8.d0*cos(beta-alpha)&
			*CSSS_VSV(p1sq,p2sq,qsq,mZ,mch,mZ)&
		!VV
		+gZ**4*(cw**2-sw**2)**2*vev/8.d0*cos(beta-alpha)&
			*(4.d0*b0f(qsq,mZ,mZ)-2.d0)&
		+g**4*vev/4.d0*cos(beta-alpha)&
			*(4.d0*b0f(qsq,mW,mW)-2.d0)&
		!SS_qsq
		+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmhh(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mh,mh)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mh,mbH)&
		+6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mbH,mbH)&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmAA(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mA,mA)&
		+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmAG(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mA,mz)&
		+2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmGG(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mz,mz)&
		+4.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmHpHm(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mch,mch)&
		+4.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmHpHm(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mch,mw)&
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmGpGm(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mw,mw)&
		!SS_p1sq and SS_p2sq
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mch,mh)+b0f(p2sq,mch,mh))&
		+2.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mch,mbH)+b0f(p2sq,mch,mbH))&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mw,mh)+b0f(p2sq,mw,mh))&
		+2.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mw,mbH)+b0f(p2sq,mw,mbH))&
		+lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmAbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mw,mA)+b0f(p2sq,mw,mA))&
		!SSS
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mh,mch,mh)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(c0f(p1sq,p2sq,qsq,mh,mch,mbH)+c0f(p1sq,p2sq,qsq,mbH,mch,mh))&
		-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mbH,mch,mbH)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mh,mw,mh)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(c0f(p1sq,p2sq,qsq,mh,mw,mbH)+c0f(p1sq,p2sq,qsq,mbH,mw,mh))&
		-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mbH,mw,mbH)&
		-2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*abs(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))**2&
			*c0f(p1sq,p2sq,qsq,mA,mw,mA)&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mch,mh,mch)&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mch,mbH,mch)&
		)&
		-lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)&
				*(c0f(p1sq,p2sq,qsq,mch,mh,mw)+c0f(p1sq,p2sq,qsq,mw,mh,mch))&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)&
				*(c0f(p1sq,p2sq,qsq,mch,mbH,mw)+c0f(p1sq,p2sq,qsq,mw,mbH,mch))&
		)&
		-lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mw,mh,mw)&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mw,mbH,mw)&
		)&
		-lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*abs(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))**2&
			*c0f(p1sq,p2sq,qsq,mw,mA,mw)&
	 	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHHpHm_loop_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n
	complex (kind(0d0)):: del_lam_HpHmbH_F
	complex (kind(0d0)):: del_lam_HpHmbH_F_wo_CTbm,Gam_bHHpHm_loop_F_ST_wPT

	del_lam_HpHmbH_F_wo_CTbm=&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*del_v_F(alpha,beta,n)/vev&
		+(&
			-2.d0*cos(beta-alpha)*del_mchsq_F(mch,mA,mbH,bmsq,alpha,beta,n)&
			-(cos(beta-alpha)-2.d0*sin(beta-alpha)/tan(2.d0*beta))&
				*del_mbHsq_F(mch,mA,mbH,bmsq,alpha,beta,n)&
			+(&
				(2.d0*mch**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)&
            +2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta)&
            -4.d0*(mbH**2-bmsq)*sin(beta-alpha)/sin(2.d0*beta)**2&
			)*del_beta_F(mA,alpha,beta,n)&
			-(&
				(2.d0*mch**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)&
            +2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta)&
			)*del_alpha_F(mbH,alpha,beta,n))/vev

	if (SCHEME == 0 .or. SCHEME == 1) then
		del_lam_HpHmbH_F =&
			del_lam_HpHmbH_F_wo_CTbm&
			+2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_bmsq_F(alpha,beta,n)*bmsq
	else if (SCHEME == 2) then
		del_lam_HpHmbH_F =&
			del_lam_HpHmbH_F_wo_CTbm&
			+2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev*(&
				del_bar_m12sq_F(mA,alpha,beta,n)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_F(mA,alpha,beta,n)&
			)*bmsq
	end if

	Gam_bHHpHm_loop_F_ST_wPT =&
		Gam_bHHpHm_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+del_lam_HpHmbH_F&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			del_ZbH_F(mbH,alpha,beta,n)/2.d0+del_ZHpm_F(mch,alpha,beta,n)&
		)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(&
			del_Ch_F(mbH,alpha,beta,n)-del_alpha_F(mbH,alpha,beta,n)&
		)&
		+2.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			del_CHpm_F(mch,mA,mbH,bmsq,alpha,beta,n)+del_beta_F(mA,alpha,beta,n)&
		)

	if (SCHEME == 0) then
		Gam_bHHpHm_loop_F =&
			Gam_bHHpHm_loop_F_ST_wPT&
			!====== differences between the KOSY scheme and the PT scheme ======
			-4.d0*bmsq*cos(2.d0*beta)*sin(beta+alpha)/(vev*sin(2.d0*beta))**2*(&
				+cos(beta-alpha)*Th_F(alpha,beta,n)/mh**2&
				-sin(beta-alpha)*TbH_F(alpha,beta,n)/mbH**2&
			)&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_bmsq_F(alpha,beta,n)*bmsq*log(mu_r**2)
	else if (SCHEME == 1) then
		Gam_bHHpHm_loop_F =&
			Gam_bHHpHm_loop_F_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_bmsq_F(alpha,beta,n)*bmsq*log(mu_r**2)
	else if (SCHEME == 2) then
		Gam_bHHpHm_loop_F =&
			Gam_bHHpHm_loop_F_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_m12sq_F(mA,alpha,beta,n)*bmsq*log(mu_r**2)
	end if

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHHpHm_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	complex (kind(0d0)):: del_lam_HpHmbH_B
	complex (kind(0d0)):: del_lam_HpHmbH_B_wo_CTbm,Gam_bHHpHm_loop_B_ST_wPT
	double precision :: del_beta_bar ! =delta beta + delta beta^PT

	del_lam_HpHmbH_B_wo_CTbm =&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		+(&
			-2.d0*cos(beta-alpha)*del_mchsq_B(mch,mA,mbH,bmsq,alpha,beta)&
			-(cos(beta-alpha)-2.d0*sin(beta-alpha)/tan(2.d0*beta))&
				*del_mbHsq_B(mch,mA,mbH,bmsq,alpha,beta)&
			+(&
				(2.d0*mch**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)&
            +2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta)&
            -4.d0*(mbH**2-bmsq)*sin(beta-alpha)/sin(2.d0*beta)**2&
			)*(del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
			-(&
				(2.d0*mch**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)&
            +2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta)&
			)*(del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta))&
		)/vev

	if (SCHEME == 0 .or. SCHEME == 1) then
		del_lam_HpHmbH_B =&
			del_lam_HpHmbH_B_wo_CTbm&
			+2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq
	else if (SCHEME == 2) then
		del_beta_bar =&
			del_beta_B(mch,mA,mbH,bmsq,alpha,beta)&
			+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)
    
		del_lam_HpHmbH_B =&
			del_lam_HpHmbH_B_wo_CTbm&
			+2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev*(&
				del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_bar&
			)*bmsq
	end if 

	Gam_bHHpHm_loop_B_ST_wPT =&
		Gam_bHHpHm_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+del_lam_HpHmbH_B&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0+del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*(&
			del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)-del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+2.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			del_CHpm_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_B(mch,mA,mbH,bmsq,alpha,beta)&
		)

	if (SCHEME == 0) then
		Gam_bHHpHm_loop_B =&
			Gam_bHHpHm_loop_B_ST_wPT&
	    	!====== differences between the KOSY scheme and the PT scheme ======
			-4.d0*bmsq*cos(2.d0*beta)*sin(beta+alpha)/(vev*sin(2.d0*beta))**2*(&
				+cos(beta-alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)/mh**2&
				-sin(beta-alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)/mbH**2&
			)&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	else if (SCHEME == 1) then
		Gam_bHHpHm_loop_B =&
			Gam_bHHpHm_loop_B_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	else if (SCHEME == 2) then
		Gam_bHHpHm_loop_B =&
			Gam_bHHpHm_loop_B_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	end if

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHHpHm_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n

	Gam_bHHpHm_loop =&
		Gam_bHHpHm_loop_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)&
		+Gam_bHHpHm_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_bHHpHm(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n

	rGam_bHHpHm =&
		lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)&
		+Gam_bHHpHm_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)

	end function
!-------------------------------------------------------------
!     bHAA 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHAA_fermion(p1sq,p2sq,qsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: If3,xi_A,xi_bH,gbHff
	complex (kind(0d0)):: gAff

	if (mf == mt .or. mf == mc) then
		If3 = It; xi_A = xiu_A(alpha,beta,n); xi_bH = xiu_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then 
		If3 = Ib; xi_A = xid_A(alpha,beta,n); xi_bH = xid_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then 
		If3 = Ie; xi_A = xil_A(alpha,beta,n); xi_bH = xil_H(alpha,beta,n)
	endif

	gbHff = -mf*xi_bH/vev; gAff = +ii*2.d0*If3*mf*xi_A/vev

	Gam_bHAA_fermion=&
		-8.d0*mf*gbHff*gAff**2/(16.d0*pi**2)*(&
			+b0f(qsq,mf,mf)&
			+(qsq-p1sq-p2sq)/2.d0*c0f(p1sq,p2sq,qsq,mf,mf,mf)&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHAA_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam_bHAA_F=&
		+Nc*Gam_bHAA_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
		+Nc*Gam_bHAA_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
		+Nc*Gam_bHAA_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc)&
		+Nc*Gam_bHAA_fermion(p1sq,p2sq,qsq,alpha,beta,n,ms)&
		+Gam_bHAA_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)&
		+Gam_bHAA_fermion(p1sq,p2sq,qsq,alpha,beta,n,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHAA_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam_bHAA_B=&
		1.d0/(16.d0*pi**2)*(& 
		!SVS
		+gZ**2*cos(beta-alpha)**2/2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mh,mZ,mh)&
		-gZ**2*cos(beta-alpha)*sin(beta-alpha)/2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SVS(p1sq,p2sq,qsq,mh,mZ,mbH)+CSSS_SVS(p1sq,p2sq,qsq,mbH,mZ,mh))&
		+3.d0*gZ**2*sin(beta-alpha)**2/2.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mbH,mZ,mbH)&
		+g**2/2.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)&
			*CSSS_SVS(p1sq,p2sq,qsq,mch,mW,mch)&
		!SSV+VSS
		+gZ**2*sin(beta-alpha)*cos(beta-alpha)/2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mA,mh,mZ)+CSSS_VSS(p1sq,p2sq,qsq,mZ,mh,mA))&
		-gZ**2*sin(beta-alpha)**2/2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mA,mbH,mZ)+CSSS_VSS(p1sq,p2sq,qsq,mZ,mbH,mA))&
		-gZ**2*cos(beta-alpha)**2/4.d0*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mz,mh,mZ)+CSSS_VSS(p1sq,p2sq,qsq,mZ,mh,mz))&
		+gZ**2*cos(beta-alpha)*sin(beta-alpha)/4.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mz,mbH,mZ)+CSSS_VSS(p1sq,p2sq,qsq,mZ,mbH,mz))&
		+g**2*cos(beta-alpha)/2.d0*ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)&
			*(CSSS_SSV(p1sq,p2sq,qsq,mw,mch,mW)+CSSS_VSS(p1sq,p2sq,qsq,mW,mch,mw))&
		!VSV
		-gZ**4*vev/8.d0*(&
			+cos(beta-alpha)**3*CSSS_VSV(p1sq,p2sq,qsq,mZ,mh,mZ)&
			+cos(beta-alpha)*sin(beta-alpha)**2*CSSS_VSV(p1sq,p2sq,qsq,mZ,mbH,mZ)&
		)&
		-g**4*vev/4.d0&
			*cos(beta-alpha)*CSSS_VSV(p1sq,p2sq,qsq,mW,mch,mW)&
		!VV
		+gZ**4*vev*cos(beta-alpha)/8.d0&
			*(4.d0*b0f(qsq,mZ,mZ)-2.d0)&
		+g**4*vev*cos(beta-alpha)/4.d0&
			*(4.d0*b0f(qsq,mW,mW)-2.d0)&
		!SS_qsq
		+4.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAhh(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mh,mh)&
		+4.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mh,mbH)&
		+12.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mbH,mbH)&
		+24.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AAAA(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mA,mA)&
		+6.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AAAG(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mA,mz)&
		+4.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_GGAA(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mz,mz)&
		+2.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmAA(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mch,mch)&
		+4.d0*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmAA(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mch,mw)&
		+2.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_GpGmAA(mch,mA,mbH,bmsq,alpha,beta)&
			*b0f(qsq,mw,mw)&
		!SS_p1sq and SS_p2sq
		+4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mA,mh)+b0f(p2sq,mA,mh))&
		+8.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mA,mbH)+b0f(p2sq,mA,mbH))&
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbHh(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mz,mh)+b0f(p2sq,mz,mh))&
		+2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbHbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mz,mbH)+b0f(p2sq,mz,mbH))&
		+2.d0*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HmGpAbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(b0f(p1sq,mw,mch)+b0f(p2sq,mw,mch))&
		!SSS
		-8.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mh,mA,mh)&
		-8.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(c0f(p1sq,p2sq,qsq,mh,mA,mbH)+c0f(p1sq,p2sq,qsq,mbH,mA,mh))&
		-24.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mbH,mA,mbH)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mh,mz,mh)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)&
			*(c0f(p1sq,p2sq,qsq,mh,mz,mbH)+c0f(p1sq,p2sq,qsq,mbH,mz,mh))&
		-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)**2&
			*c0f(p1sq,p2sq,qsq,mbH,mz,mbH)&
		-8.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			+lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mA,mh,mA)&
			+lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mA,mbH,mA)&
		)&
		-2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			+lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)&
				*(c0f(p1sq,p2sq,qsq,mA,mh,mz)+c0f(p1sq,p2sq,qsq,mz,mh,mA))&
			+lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)&
				*(c0f(p1sq,p2sq,qsq,mA,mbH,mz)+c0f(p1sq,p2sq,qsq,mz,mbH,mA))&
		)&
		-2.d0*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*(&
			+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mz,mh,mz)&
			+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mz,mbH,mz)&
		)&
		-2.d0*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*abs(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))**2&
			*c0f(p1sq,p2sq,qsq,mch,mw,mch)&
		-2.d0*lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*abs(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))**2&
			*c0f(p1sq,p2sq,qsq,mw,mch,mw)&
		)

	end function
!-----------------------------------------------------------------
   complex (kind(0d0)) function Gam_bHAA_loop_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n
	complex (kind(0d0)):: del_lam_AAbH_F
	complex (kind(0d0)):: del_lam_AAbH_F_wo_CTbm,Gam_bHAA_loop_F_ST_wPT

	del_lam_AAbH_F_wo_CTbm =&
		-lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*del_v_F(alpha,beta,n)/vev&
		-cos(beta-alpha)/vev*del_mAsq_F(mch,mA,mbH,bmsq,alpha,beta,n)&
		-(cos(beta-alpha)-2.d0*sin(beta-alpha)/tan(2.d0*beta))/(2.d0*vev)&
		*del_mbHsq_F(mch,mA,mbH,bmsq,alpha,beta,n)&
		+(&
			(2.d0*mA**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)&
        	+2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta)&
        	-4.d0*(mbH**2-bmsq)*sin(beta-alpha)/sin(2.d0*beta)**2&
		)/(2.d0*vev)*del_beta_F(mA,alpha,beta,n)&
		-((2.d0*mA**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)+2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta))&
		/(2.d0*vev)*del_alpha_F(mbH,alpha,beta,n)

	if (SCHEME == 0 .or. SCHEME == 1) then
		del_lam_AAbH_F =&
			del_lam_AAbH_F_wo_CTbm&
			+(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
			*del_bar_bmsq_F(alpha,beta,n)*bmsq
    else if (SCHEME == 2) then
		del_lam_AAbH_F =&
			del_lam_AAbH_F_wo_CTbm&
			+(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev*(&
				+del_bar_m12sq_F(mA,alpha,beta,n)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_F(mA,alpha,beta,n)&
			)*bmsq
    end if

	 Gam_bHAA_loop_F_ST_wPT =&
			Gam_bHAA_F(p1sq,p2sq,qsq,alpha,beta,n)&
			+2.d0*(&
				+del_lam_AAbH_F&
            +lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*(&
					del_ZbH_F(mbH,alpha,beta,n)/2.d0+del_ZA_F(mA,alpha,beta,n)&
				)&
            +lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*(&
					del_Ch_F(mbH,alpha,beta,n)-del_alpha_F(mbH,alpha,beta,n)&
				)&
            +lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*(&
					del_CA_F(mch,mA,mbH,bmsq,alpha,beta,n)+del_beta_F(mA,alpha,beta,n)&
				)&
			)

	if (SCHEME == 0) then 
		Gam_bHAA_loop_F =&
			Gam_bHAA_loop_F_ST_wPT&
			!====== differences between the KOSY scheme and the PT scheme ======
			-4.d0*bmsq*cos(2.d0*beta)*sin(beta+alpha)/(vev*sin(2.d0*beta))**2*(&
				cos(beta-alpha)*Th_F(alpha,beta,n)/mh**2&
            -sin(beta-alpha)*TbH_F(alpha,beta,n)/mbH**2&
			)&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
			*del_bar_bmsq_F(alpha,beta,n)*bmsq*log(mu_r**2)
	else if (SCHEME == 1) then
		Gam_bHAA_loop_F =&
			Gam_bHAA_loop_F_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
			*del_bar_bmsq_F(alpha,beta,n)*bmsq*log(mu_r**2)
	else if (SCHEME == 2) then
		Gam_bHAA_loop_F =&
			Gam_bHAA_loop_F_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_m12sq_F(mA,alpha,beta,n)*bmsq*log(mu_r**2)
	end if

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHAA_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	complex (kind(0d0)):: del_lam_AAbH_B
	complex (kind(0d0)):: del_lam_AAbH_B_wo_CTbm,Gam_bHAA_loop_B_ST_wPT
	double precision :: del_beta_bar ! =delta beta + delta beta^PT

	del_lam_AAbH_B_wo_CTbm =&
		-lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		-cos(beta-alpha)/vev*del_mAsq_B(mch,mA,mbH,bmsq,alpha,beta)&
		-(cos(beta-alpha)-2.d0*sin(beta-alpha)/tan(2.d0*beta))/(2.d0*vev)&
			*del_mbHsq_B(mch,mA,mbH,bmsq,alpha,beta)&
		+(&
			(2.d0*mA**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)&
			+2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta)&
			-4.d0*(mbH**2-bmsq)*sin(beta-alpha)/sin(2.d0*beta)**2&
		)/(2.d0*vev)*(del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
		-((2.d0*mA**2+mbH**2-2.d0*bmsq)*sin(beta-alpha)+2.d0*(mbH**2-bmsq)*cos(beta-alpha)/tan(2.d0*beta))&
		/(2.d0*vev)*(del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta))

	if (SCHEME == 0 .or. SCHEME == 1) then
		del_lam_AAbH_B =&
			del_lam_AAbH_B_wo_CTbm&
			+(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
			*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq
	else if (SCHEME == 2) then
		del_beta_bar =&
			del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)

		del_lam_AAbH_B =&
			del_lam_AAbH_B_wo_CTbm&
			+(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev*(&
				+del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_bar&
			)*bmsq
	end if
	
	Gam_bHAA_loop_B_ST_wPT =&
		Gam_bHAA_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+2.d0*(&
			+del_lam_AAbH_B&
			+lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*(&
				del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0+del_ZA_B(mch,mA,mbH,bmsq,alpha,beta)&
			)&
			+lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*(&
				del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)-del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
			)&
			+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*(&
				del_CA_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_B(mch,mA,mbH,bmsq,alpha,beta)&
			)&
		)

	if (SCHEME == 0) then
		Gam_bHAA_loop_B =&
			Gam_bHAA_loop_B_ST_wPT&
			!====== differences between the KOSY scheme and the PT scheme ======
			-4.d0*bmsq*cos(2.d0*beta)*sin(beta+alpha)/(vev*sin(2.d0*beta))**2*(&
				cos(beta-alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)/mh**2&
				-sin(beta-alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)/mbH**2&
			)&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
			*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	else if (SCHEME == 1) then
		Gam_bHAA_loop_B =&
			Gam_bHAA_loop_B_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
			*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	else if (SCHEME == 2) then
		Gam_bHAA_loop_B =&
			Gam_bHAA_loop_B_ST_wPT&
			!===== mu-dependent part =====
			-2.d0*(cos(beta-alpha)-sin(beta-alpha)/tan(2.d0*beta))/vev&
				*del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	end if

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHAA_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n

	Gam_bHAA_loop =&
		Gam_bHAA_loop_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)&
		+Gam_bHAA_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_bHAA(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n

	rGam_bHAA =&
		lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)&
		+Gam_bHAA_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)

	end function
!-------------------------------------------------------------
!     bHhh 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: xi_h,xi_bH,ghff,gbHff

	if (mf == mt .or. mf == mc) then
		xi_h = xiu(alpha,beta,n); xi_bH = xiu_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then 
		xi_h = xid(alpha,beta,n); xi_bH = xid_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then 
		xi_h = xil(alpha,beta,n); xi_bH = xil_H(alpha,beta,n)
	endif

	gbHff = -mf*xi_bH/vev; ghff = -mf*xi_h/vev

	Gam_bHhh_fermion=&
		+8.d0*mf*gbHff*ghff**2/(16.d0*pi**2)*(&
			+b0f(p1sq,mf,mf)+b0f(p2sq,mf,mf)+b0f(qsq,mf,mf)&
			+(4.d0*mf**2-(qsq+p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mf,mf,mf)&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in):: n

	! Gam_bHhh_F =&
   !    -xiu(alpha,beta,n)**2*xiu_H(alpha,beta,n)*8.d0*mt**4*Nc/(16.d0*pi**2)/vev**3*(&
   !    	+b0f(p1sq,mt,mt)+b0f(p2sq,mt,mt)+b0f(qsq,mt,mt)&
   !       +(4.d0*mt**2-(qsq+p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mt,mt,mt)&
   !    )&
	! 	!
   !    -xiu(alpha,beta,n)**2*xiu_H(alpha,beta,n)*8.d0*mc**4*Nc/(16.d0*pi**2)/vev**3*(&
   !    	+b0f(p1sq,mc,mc)+b0f(p2sq,mc,mc)+b0f(qsq,mc,mc)&
   !       +(4.d0*mc**2-(qsq+p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mc,mc,mc)&
   !    )&
	! 	!
   !    -xid(alpha,beta,n)**2*xid_H(alpha,beta,n)*8.d0*mb**4*Nc/(16.d0*pi**2)/vev**3*(&
   !    	+b0f(p1sq,mb,mb)+b0f(p2sq,mb,mb)+b0f(qsq,mb,mb)&
   !    	+(4.d0*mb**2-(qsq+p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mb,mb,mb)&
   !    )&
	! 	!
   !    -xid(alpha,beta,n)**2*xid_H(alpha,beta,n)*8.d0*ms**4*Nc/(16.d0*pi**2)/vev**3*(&
   !    	+b0f(p1sq,ms,ms)+b0f(p2sq,ms,ms)+b0f(qsq,ms,ms)&
   !    	+(4.d0*ms**2-(qsq+p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,ms,ms,ms)&
   !    )&
	! 	!
   !    -xil(alpha,beta,n)**2*xil_H(alpha,beta,n)*8.d0*mtau**4/(16.d0*pi**2)/vev**3*(&
   !    	+b0f(p1sq,mtau,mtau)+b0f(p2sq,mtau,mtau)+b0f(qsq,mtau,mtau)&
   !    	+(4.d0*mtau**2-(qsq+p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mtau,mtau,mtau)&
   !    )&
	! 	!
   !    -xil(alpha,beta,n)**2*xil_H(alpha,beta,n)*8.d0*mmu**4/(16.d0*pi**2)/vev**3*(&
   !    	+b0f(p1sq,mmu,mmu)+b0f(p2sq,mmu,mmu)+b0f(qsq,mmu,mmu)&
   !    	+(4.d0*mmu**2-(qsq+p1sq+p2sq)/2.d0)*c0f(p1sq,p2sq,qsq,mmu,mmu,mmu)&
   !    )

	! write(*,*) 'Gam_bHhh_F =',Gam_bHhh_F

	Gam_bHhh_F=&
		+Nc*Gam_bHhh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
		+Nc*Gam_bHhh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
		+Nc*Gam_bHhh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc)&
		+Nc*Gam_bHhh_fermion(p1sq,p2sq,qsq,alpha,beta,n,ms)&
		+Gam_bHhh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)&
		+Gam_bHhh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mmu)

	end function
!---------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta

	Gam_bHhh_B =&
		1.d0/(16.d0*pi**2)*(&
		!VVV
		+8.d0*g**3*mw**3*sin(beta-alpha)**2*cos(beta-alpha)*c0f(p1sq,p2sq,qsq,mW,mW,mW)&
		+4.d0*gz**3*mZ**3*sin(beta-alpha)**2*cos(beta-alpha)*c0f(p1sq,p2sq,qsq,mZ,mZ,mZ)&
		!ccc
		-1.d0/2.d0*g**3*mW**3*sin(beta-alpha)**2*cos(beta-alpha)*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
		-1.d0/4.d0*gz**3*mZ**3*sin(beta-alpha)**2*cos(beta-alpha)*c0f(p1sq,p2sq,qsq,mz,mz,mz)&	
		!VVS
		-1.d0/2.d0*sin(beta-alpha)**2*cos(beta-alpha)*g**3*mw*CSSS_VVS(p1sq,p2sq,qsq,mW,mW,mw)&
		+1.d0/2.d0*sin(beta-alpha)**2*cos(beta-alpha)*g**3*mw*CSSS_VVS(p1sq,p2sq,qsq,mW,mW,mch)&
		-1.d0/4.d0*sin(beta-alpha)**2*cos(beta-alpha)*gz**3*mz*CSSS_VVS(p1sq,p2sq,qsq,mZ,mZ,mz)&
		+1.d0/4.d0*sin(beta-alpha)**2*cos(beta-alpha)*gz**3*mz*CSSS_VVS(p1sq,p2sq,qsq,mZ,mZ,mA)&
		!VSV
		-1.d0/2.d0*sin(beta-alpha)**2*cos(beta-alpha)*g**3*mw*CSSS_VSV(p1sq,p2sq,qsq,mW,mw,mW)&
		-1.d0/2.d0*cos(beta-alpha)**3*g**3*mw*CSSS_VSV(p1sq,p2sq,qsq,mW,mch,mW)&
		-1.d0/4.d0*sin(beta-alpha)**2*cos(beta-alpha)*gz**3*mz*CSSS_VSV(p1sq,p2sq,qsq,mZ,mz,mZ)&
		-1.d0/4.d0*cos(beta-alpha)**3*gz**3*mz*CSSS_VSV(p1sq,p2sq,qsq,mZ,mA,mZ)&
		!SVV
		-1.d0/2.d0*sin(beta-alpha)**2*cos(beta-alpha)*g**3*mw*CSSS_SVV(p1sq,p2sq,qsq,mw,mW,mW)&
		+1.d0/2.d0*sin(beta-alpha)**2*cos(beta-alpha)*g**3*mw*CSSS_SVV(p1sq,p2sq,qsq,mch,mW,mW)&
		-1.d0/4.d0*sin(beta-alpha)**2*cos(beta-alpha)*gz**3*mz*CSSS_SVV(p1sq,p2sq,qsq,mz,mZ,mZ)&
		+1.d0/4.d0*sin(beta-alpha)**2*cos(beta-alpha)*gz**3*mz*CSSS_SVV(p1sq,p2sq,qsq,mA,mZ,mZ)&
		!VSS
		+1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mW,mw,mw)&
		-1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mW,mch,mch)&
		+1.d0/2.d0*cos(beta-alpha)**2*g**2*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mW,mch,mw)&
		-1.d0/2.d0*sin(beta-alpha)**2*g**2*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mW,mw,mch)&
		+1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mZ,mz,mz)&
		-1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mZ,mA,mA)&
		+1.d0/4.d0*cos(beta-alpha)**2*gz**2*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mZ,mA,mz)&
		-1.d0/4.d0*sin(beta-alpha)**2*gz**2*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_VSS(p1sq,p2sq,qsq,mZ,mz,mA)&
		!SVS
		+1.d0/2.d0*sin(beta-alpha)**2*g**2*lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mw,mW,mw)&
		+1.d0/2.d0*cos(beta-alpha)**2*g**2*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mch,mW,mch)&
		+1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mch,mW,mw)&
		+1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mw,mW,mch)&
		+1.d0/2.d0*sin(beta-alpha)**2*gz**2*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mz,mZ,mz)&
		+1.d0/2.d0*cos(beta-alpha)**2*gz**2*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mA,mZ,mA)&
		+1.d0/4.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mA,mZ,mz)&
		+1.d0/4.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SVS(p1sq,p2sq,qsq,mz,mZ,mA)&
		!SSV
		+1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mw,mw,mW)&
		-1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*g**2*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mch,mch,mW)&
		-1.d0/2.d0*sin(beta-alpha)**2*g**2*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mch,mw,mW)&
		+1.d0/2.d0*cos(beta-alpha)**2*g**2*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mw,mch,mW)&
		+1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mz,mz,mZ)&
		-1.d0/2.d0*sin(beta-alpha)*cos(beta-alpha)*gz**2*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mA,mA,mZ)&
		-1.d0/4.d0*sin(beta-alpha)**2*gz**2*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mA,mz,mZ)&
		+1.d0/4.d0*cos(beta-alpha)**2*gz**2*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*CSSS_SSV(p1sq,p2sq,qsq,mz,mA,mZ)&
		!SSS
		-2.d0*lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mw,mw,mw)&
		-2.d0*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mch,mch,mch)&
		-8.d0*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mz,mz,mz)&
		-8.d0*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mA,mA,mA)&
		-24.d0*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mbH,mbH,mbH)&
		-72.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mh,mh,mh)&
		-2.d0*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mch,mw,mch)&
		-2.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*(&
			c0f(p1sq,p2sq,qsq,mw,mch,mch)+c0f(p1sq,p2sq,qsq,mch,mch,mw))&
		-2.d0*lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mw,mch,mw)&
		-2.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*(&
			c0f(p1sq,p2sq,qsq,mch,mw,mw)+c0f(p1sq,p2sq,qsq,mw,mw,mch))&
		-2.d0*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mA,mz,mA)&
		-2.d0*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*(&
			c0f(p1sq,p2sq,qsq,mz,mA,mA)+c0f(p1sq,p2sq,qsq,mA,mA,mz))&
		-2.d0*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mz,mA,mz)&
		-2.d0*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*(&
			c0f(p1sq,p2sq,qsq,mA,mz,mz)+c0f(p1sq,p2sq,qsq,mz,mz,mA))&
		-24.d0*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)**2*c0f(p1sq,p2sq,qsq,mbH,mh,mbH)&
		-8.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)**2*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*(&
			c0f(p1sq,p2sq,qsq,mh,mbH,mbH)+c0f(p1sq,p2sq,qsq,mbH,mbH,mh))&
		-8.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)**3*c0f(p1sq,p2sq,qsq,mh,mbH,mh)&
		-24.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*(&
			c0f(p1sq,p2sq,qsq,mh,mh,mbH)+c0f(p1sq,p2sq,qsq,mbH,mh,mh))&
		!VV_qsq
		+2.d0*cos(beta-alpha)*g**3*mw*(b0f(qsq,mW,mW)-1.d0/2.d0)&
		+cos(beta-alpha)*gz**3*mz*(b0f(qsq,mZ,mZ)-1.d0/2.d0)&
		!SS_qsq
		+2.d0*lam_GpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_GpGmhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mw,mw)&
		+2.d0*lam_HpHmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpHmhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mch,mch)&
		+4.d0*lam_HpGmbH(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mch,mw)&
		+4.d0*lam_GGbH(mch,mA,mbh,bmsq,alpha,beta)*lam_GGhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mz,mz)&
		+4.d0*lam_AAbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AAhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mA,mA)&
		+2.d0*lam_AGbH(mch,mA,mbh,bmsq,alpha,beta)*lam_AGhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mz,mA)&
		+12.d0*lam_bHbHbH(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mbH,mbH)&
		+12.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHhhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mbH,mh)&
		+24.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*lam_hhhh(mch,mA,mbh,bmsq,alpha,beta)*b0f(qsq,mh,mh)&
		!SS_p1sq and SS_p2sq
		+lam_GpGmh(mch,mA,mbh,bmsq,alpha,beta)*lam_GpGmbHh(mch,mA,mbh,bmsq,alpha,beta)*(b0f(p1sq,mw,mw)+b0f(p2sq,mw,mw))&
		+lam_HpHmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpHmbHh(mch,mA,mbh,bmsq,alpha,beta)*(b0f(p1sq,mch,mch)+b0f(p2sq,mch,mch))&
		+2.d0*lam_HpGmh(mch,mA,mbh,bmsq,alpha,beta)*lam_HpGmbHh(mch,mA,mbh,bmsq,alpha,beta)*(b0f(p1sq,mch,mw)+b0f(p2sq,mch,mw))&
		+2.d0*lam_GGh(mch,mA,mbh,bmsq,alpha,beta)*lam_GGbHh(mch,mA,mbh,bmsq,alpha,beta)*(b0f(p1sq,mz,mz)+b0f(p2sq,mz,mz))&
		+2.d0*lam_AAh(mch,mA,mbh,bmsq,alpha,beta)*lam_AAbHh(mch,mA,mbh,bmsq,alpha,beta)*(b0f(p1sq,mA,mA)+b0f(p2sq,mA,mA))&
		+lam_AGh(mch,mA,mbh,bmsq,alpha,beta)*lam_AGbHh(mch,mA,mbh,bmsq,alpha,beta)*(b0f(p1sq,mA,mz)+b0f(p2sq,mA,mz))&
		+6.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHbHh(mch,mA,mbh,bmsq,alpha,beta)*(&
			b0f(p1sq,mbH,mbH)+b0f(p2sq,mbH,mbH))&
      +8.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)*(&
			b0f(p1sq,mh,mbH)+b0f(p2sq,mh,mbH))&
		+18.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*lam_bHhhh(mch,mA,mbh,bmsq,alpha,beta)*(&
			b0f(p1sq,mh,mh)+b0f(p2sq,mh,mh))&
      )

	end function
!----------------------------------------------------------------------
!  bHhh Tadpole inserted vertex functions at EW 1-loop level
!----------------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_Tad_F(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n

	Gam_bHhh_Tad_F =&
		+6.d0*lam_bHhhh(mch,mA,mbh,bmsq,alpha,beta)/mh**2*Th_F(alpha,beta,n)&
		+4.d0*lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)/mbH**2*TbH_F(alpha,beta,n)

	end function
!-------------------------------------------- 
	complex (kind(0d0)) function Gam_bHhh_Tad_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta
	integer, intent(in):: n

	Gam_bHhh_Tad_B =&
		+6.d0*lam_bHhhh(mch,mA,mbh,bmsq,alpha,beta)/mh**2*Th_B(mch,mA,mbh,bmsq,alpha,beta)&
		+4.d0*lam_bHbHhh(mch,mA,mbh,bmsq,alpha,beta)/mbH**2*TbH_B(mch,mA,mbh,bmsq,alpha,beta)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_loop_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n
	complex (kind(0d0)):: del_lam_bHhh_F_wo_CTbm,del_lam_bHhh_F
	complex (kind(0d0)):: Gam_bHhh_loop_F_ST_wPT
	double precision:: G_alpha,G_beta

	G_alpha =&
		tan(beta-alpha)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)&
		-cos(2.d0*alpha)*cos(beta-alpha)/(vev*sin(2.d0*beta))*(2.d0*mh**2+mbH**2-3.d0*bmsq)
 
	G_beta =&
		sin(2.d0*alpha)/vev/(sin(2.d0*beta))**2*(&
			cos(alpha)*(cos(beta))**3-sin(alpha)*sin(beta)**3&
		)*(2.d0*mh**2+mbH**2)&
		+bmsq/2.d0/vev/(sin(2.d0*beta))**2*(&
			sin(2.d0*beta)**2*sin(beta-alpha)&
			-6.d0*sin(2.d0*alpha)*(cos(alpha)*(cos(beta))**3-sin(alpha)*(sin(beta))**3)&
		)

	del_lam_bHhh_F_wo_CTbm =&
		-lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*del_v_F(alpha,beta,n)/vev&
		-sin(2.d0*alpha)*cos(beta-alpha)/(2.d0*vev*sin(2.d0*beta))*(&
			+2.d0*del_mhsq_F(alpha,beta,n)&
			+del_mbHsq_F(mch,mA,mbH,bmsq,alpha,beta,n)&
		)&
		+G_alpha*del_alpha_F(mbH,alpha,beta,n)&
		+G_beta*del_beta_F(mA,alpha,beta,n)
	 
	if (SCHEME == 0 .or. SCHEME == 1) then
		del_lam_bHhh_F =&
			del_lam_bHhh_F_wo_CTbm&
			+3.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
			*del_bar_bmsq_F(alpha,beta,n)*bmsq
	elseif (SCHEME == 2) then
		del_lam_bHhh_F =&
			del_lam_bHhh_F_wo_CTbm&
			+3.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)*(&
				+del_bar_m12sq_F(mA,alpha,beta,n)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*del_beta_F(mA,alpha,beta,n)&
			)*bmsq
	endif

	Gam_bHhh_loop_F_ST_wPT=&
		Gam_bHhh_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+2.d0*(&
			+del_lam_bHhh_F&
			+lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*(&
				del_ZbH_F(mbH,alpha,beta,n)/2.d0+del_Zh_F(alpha,beta,n)&
			)&
			+3.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*(&
				del_Ch_F(mbh,alpha,beta,n)-del_alpha_F(mbh,alpha,beta,n)&
			)&
			+2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*(&
				del_Ch_F(mbh,alpha,beta,n)+del_alpha_F(mbh,alpha,beta,n)&
			)&
		)

	if (SCHEME == 0) then
		Gam_bHhh_loop_F =&
			Gam_bHhh_loop_F_ST_wPT&
			!====== differences between the Standanrd Tadpole and Alternative Tadpole schemes ======
			-4.d0*bmsq*cos(2.d0*beta)*cos(beta-alpha)/(vev*sin(2.d0*beta))**2&
			*(3.d0*sin(alpha)*cos(alpha)-sin(beta)*cos(beta))*(&
				+cos(beta-alpha)*Th_F(alpha,beta,n)/mh**2&
				-sin(beta-alpha)*TbH_F(alpha,beta,n)/mbH**2&
			)&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
			*del_bar_bmsq_F(alpha,beta,n)*bmsq*log(mu_r**2)
	else if (SCHEME == 1) then 
		Gam_bHhh_loop_F =&
			Gam_bHhh_loop_F_ST_wPT&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
			*del_bar_bmsq_F(alpha,beta,n)*bmsq*log(mu_r**2)
	else if (SCHEME == 2) then 
		Gam_bHhh_loop_F =&
			Gam_bHhh_loop_F_ST_wPT&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
				*del_bar_m12sq_F(mA,alpha,beta,n)*bmsq*log(mu_r**2)
	end if

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	complex (kind(0d0)):: del_lam_bHhh_B_wo_CTbm,del_lam_bHhh_B
	complex (kind(0d0)):: Gam_bHhh_loop_B_ST_wPT
	double precision:: G_alpha,G_beta

	G_alpha =&
		tan(beta-alpha)*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)&
		-cos(2.d0*alpha)*cos(beta-alpha)/(vev*sin(2.d0*beta))*(2.d0*mh**2+mbH**2-3.d0*bmsq)
	
	G_beta =&
		sin(2.d0*alpha)/vev/(sin(2.d0*beta))**2*(&
		cos(alpha)*(cos(beta))**3-sin(alpha)*sin(beta)**3)*(2.d0*mh**2+mbH**2)&
		+bmsq/2.d0/vev/(sin(2.d0*beta))**2*(&
			sin(2.d0*beta)**2*sin(beta-alpha)&
			-6.d0*sin(2.d0*alpha)*(cos(alpha)*(cos(beta))**3-sin(alpha)*(sin(beta))**3)&
		)

	del_lam_bHhh_B_wo_CTbm =&
		-lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
		-sin(2.d0*alpha)*cos(beta-alpha)/(2.d0*vev*sin(2.d0*beta))*(&
			+2.d0*del_mhsq_B(mch,mA,mbH,bmsq,alpha,beta)&
			+del_mbHsq_B(mch,mA,mbH,bmsq,alpha,beta)&
		)&
		+G_alpha*(del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta))&
		+G_beta*(del_beta_B(mch,mA,mbH,bmsq,alpha,beta)+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))

	if (SCHEME == 0 .or. SCHEME == 1) then
		del_lam_bHhh_B =&
			del_lam_bHhh_B_wo_CTbm&
			+3.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
				*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq
	elseif (SCHEME == 2) then
		del_lam_bHhh_B =&
			del_lam_bHhh_B_wo_CTbm&
			+3.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)*(&
				+del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)&
				-2.d0*cos(2.d0*beta)/sin(2.d0*beta)*(&
					+del_beta_B(mch,mA,mbH,bmsq,alpha,beta)&
					+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
				)&
			)*bmsq
	endif

	Gam_bHhh_loop_B_ST_wPT =&
		Gam_bHhh_B(p1sq,p2sq,qsq,mch,mA,mbh,bmsq,alpha,beta)&
		+2.d0*(&
			+del_lam_bHhh_B&
			+lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)*(&
				+del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0&
				+del_Zh_B(mch,mA,mbH,bmsq,alpha,beta)&
			)&
			+3.d0*lam_hhh(mch,mA,mbh,bmsq,alpha,beta)*(&
				+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
				-del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
			)&
			+2.d0*lam_bHbHh(mch,mA,mbh,bmsq,alpha,beta)*(&
				+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
				+del_alpha_B(mch,mA,mbH,bmsq,alpha,beta)&
			)&
		)

	if (SCHEME == 0) then
		Gam_bHhh_loop_B =&
			Gam_bHhh_loop_B_ST_wPT&
			!====== differences between the Standanrd Tadpole and Alternative Tadpole schemes ======
			-4.d0*bmsq*cos(2.d0*beta)*cos(beta-alpha)/(vev*sin(2.d0*beta))**2&
			*(3.d0*sin(alpha)*cos(alpha)-sin(beta)*cos(beta))*(&
				cos(beta-alpha)*Th_B(mch,mA,mbH,bmsq,alpha,beta)/mh**2&
				-sin(beta-alpha)*TbH_B(mch,mA,mbH,bmsq,alpha,beta)/mbH**2&
			)&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
				*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	else if (SCHEME == 1) then
		Gam_bHhh_loop_B =&
			Gam_bHhh_loop_B_ST_wPT&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
				*del_bar_bmsq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	else if (SCHEME == 2) then
		Gam_bHhh_loop_B =&
			Gam_bHhh_loop_B_ST_wPT&
			!===== mu-dependent part =====
			-6.d0*cos(beta-alpha)/(2.d0*vev)*(sin(2.d0*alpha)/sin(2.d0*beta)-1.d0/3.d0)&
				*del_bar_m12sq_B(mch,mA,mbH,bmsq,alpha,beta)*bmsq*log(mu_r**2)
	end if

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHhh_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n

	Gam_bHhh_loop =&
		Gam_bHhh_loop_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)&
		+Gam_bHhh_loop_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_bHhh(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta,mu_r
	integer, intent(in)::n

	rGam_bHhh =&
		+2.d0*lam_bHhh(mch,mA,mbh,bmsq,alpha,beta)&
		+Gam_bHhh_loop(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mu_r,n)

	end function
!#########################################################
!#
!#     Decay of CP odd scalar: A
!#
!#########################################################
!======================================================
!     Partial decay width (Fermionic decay)
!======================================================
	double precision function Gam_Att(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mt < mA) then
		Gam_Att = decay_Att(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mt+mW < mA .and. mA <= 2.d0*mt) then
		Gam_Att = decay_Atts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_Att = 0.d0
	endif

	if (Gam_Att < 0.d0) then
		write(*,*) 'Gam_Att is negative'
	endif

	end function
!----- Gam(A -> q q~) except for q = t -----------------------------------------
	double precision function Gam_Aqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mf < mA) then
		Gam_Aqq = decay_Aqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	else
		Gam_Aqq = 0.d0
	endif

	if (Gam_Aqq < 0.d0) then
		write(*,*) 'Gam_Aqq is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_All(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mf < mA) then
		Gam_All = decay_All(mch,mA,mbH,bmsq,alpha,beta,n,OREW,mf)
	else
		Gam_All = 0.d0
	endif

	if (Gam_All < 0.d0) then
		write(*,*) 'Gam_All is negative'
	endif

	end function
!====================================================
!     Partial decay width (Bosonic decay)
!====================================================
	double precision function Gam_AZh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mZ+mh < mA) then
		Gam_AZh = decay_AZh(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	else if(mh < mA .and. mA <= mZ+mh) then
		Gam_AZh = decay_AZstarh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_AZh = 0.d0
	endif

	if (Gam_AZh < 0.d0) then
		write(*,*) 'Gam_AZh is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_AZbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mZ+mbH < mA) then
		Gam_AZbH = decay_AZbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	else if(mbH < mA .and. mA <= mZ+mbH) then
		Gam_AZbH = decay_AZstarbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_AZbH = 0.d0
	endif

	if (Gam_AZbH < 0.d0) then
		write(*,*) 'Gam_AZbH is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_AWch(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mW+mch < mA) then
		Gam_AWch = decay_AWch(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	else if(mch < mA .and. mA <= mW+mch) then
		Gam_AWch = decay_AWstarch(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_AWch = 0.d0
	endif

	if (Gam_AWch < 0.d0) then
		write(*,*) 'Gam_AWch is negative'
	endif

	end function
!====================================================
!     Partial decay width (loop-induced decay)
!====================================================
	double precision function Gam_Agg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	Gam_Agg = decay_Agg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

	if (Gam_Agg < 0.d0) then
		write(*,*) 'Gam_Agg is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_Agamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	Gam_Agamgam = decay_Agamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)

	if (Gam_Agamgam < 0.d0) then
		write(*,*) 'Gam_Agamgam is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_AZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mZ < mA) then
		Gam_AZgam = decay_AZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_AZgam = 0.d0
	endif

	if (Gam_AZgam < 0.d0) then
		write(*,*) 'Gam_AZgam is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_AZZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mZ < mA) then
		Gam_AZZ = decay_AZZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_AZZ = 0.d0
	endif

	if (Gam_AZZ < 0.d0) then
		write(*,*) 'Gam_AZZ is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_AWW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mW < mA) then
		Gam_AWW = decay_AWW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_AWW = 0.d0
	endif

	if (Gam_AWW < 0.d0) then
		write(*,*) 'Gam_AWW is negative'
	endif

	end function
!=====================================================
!  Two body functions (Fermionic decay)
!=====================================================
	double precision function decay_Att(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmf
	double precision:: R,mf,xf,If3,xif
	double precision:: decay_LO_pole,decay_LO_MSbar
	double precision:: decay_EWNLO_pole,decay_EWNLO_MSbar
	double precision:: QCD_pole,QCD_MSbar
	double precision:: decay_LO,decay_QCD,decay_EWNLO	
	complex (kind(0d0)):: Gam_P_LO,Gam_P_NLO
	double precision:: Delta_qq1,Delta_qq2
	mf = mt;	xf = mt/mA; If3 = It; xif = xiu_A(alpha,beta,n)
	p1sq=mf**2; p2sq=mf**2; qsq=mA**2; mu=mA
	R=2.d0*mf/mA

	!----- mA >= 2.d0*mt -----
	nf=6.d0; lam_QCD=lam_QCD6
	rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,nf),mt_MS)

	!===================
	!     LO
	!===================
	!----- LO pole -----
	decay_LO_pole =&
		Nc*G_F*mA/(4.d0*sqrt(2.d0)*pi)*sqrt(1.d0-4.d0*xf**2)&
		*mf**2*xiu_A(alpha,beta,n)**2

	if(OREW == 0 .and. ORQCD == -1) then
		decay_Att = decay_LO_pole
		return
	endif
	
	!----- LO MS_bar -----
	decay_LO_MSbar =&
		Nc*G_F*mA/(4.d0*sqrt(2.d0)*pi)*sqrt(1.d0-4.d0*xf**2)&
		*rmf**2*xiu_A(alpha,beta,n)**2

	!----- Interpolation -----
	decay_LO = R**2*decay_LO_pole+(1.d0-R**2)*decay_LO_MSbar

	if(OREW == 0 .and. ORQCD == 0) then
		decay_Att = decay_LO
		return
	endif

	!=========================
	!     QCD corrections
	!=========================
	if(ORQCD > 0) then
		!----- on-shell -----
		QCD_pole  = decay_LO_pole*Delta_t_A(mu)

		!----- MSbar -----
		if(ORQCD == 1) then
			Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mA**2))
			QCD_MSbar = decay_LO_MSbar*(Delta_qq1)
		else if(ORQCD == 2) then
			Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mA**2))
			Delta_qq2 = (alphas(lam_QCD,mu,nf)/pi)**2*(&
								+10801.d0/144.d0-39.d0/2.d0*zeta3-(65.d0/24.d0-2.d0/3.d0*zeta3)*nf&
								-pi**2*(19.d0/12.d0-1.d0/18.d0*nf)&
							)
			QCD_MSbar = decay_LO_MSbar*(Delta_qq1+Delta_qq2)
		endif

		!----- Interpolation -----
		decay_QCD = R**2*QCD_pole+(1.d0-R**2)*QCD_MSbar

		if(OREW == 0) then
			decay_Att = decay_LO+decay_QCD
			return
		endif
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_P_LO = ii*2.d0*If3*mf*xif/vev

		Gam_P_NLO =&
			rGam_Aff_P(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			-mf*Gam_Aff_A1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			-mf*Gam_Aff_A2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			+(qsq-p1sq-p2sq-mf**2)*Gam_Aff_PT(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)

		Gam_P_NLO =	Gam_P_NLO-Gam_P_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		decay_EWNLO_pole =&
			Nc*mA/(8.d0*pi)*sqrt(lambda(xf**2,xf**2))*(&
				+2.d0*dble(Gam_P_LO*conjg(Gam_P_NLO))&
			)&
			!----- real photon emission -----
			+Nc*decay_A_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)

		decay_EWNLO_MSbar = (rmf/mf)**2*decay_EWNLO_pole

		!----- Interpolation -----
		decay_EWNLO = R**2*decay_EWNLO_pole+(1.d0-R**2)*decay_EWNLO_MSbar
		
		if(ORQCD == -1) then
			decay_Att = decay_LO_pole+decay_EWNLO_pole
			return
		else if(ORQCD == 0) then
			decay_Att = decay_LO+decay_EWNLO
			return
		else if(ORQCD > 0) then
			decay_Att = decay_LO+decay_EWNLO+decay_QCD
			return
		endif
	endif
	
	end function
!----- A -> q q~ except for q = t -----------------------------------------
	double precision function decay_Aqq(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmf
	double precision:: xf,If3,xif
	double precision:: decay_LO_pole,decay_LO_MSbar
	double precision:: Delta_qq1,Delta_qq2,Delta_A
	double precision:: decay_LO,decay_QCD,decay_EWNLO
	complex (kind(0d0)):: Gam_P_LO,Gam_P_NLO
	p1sq=mf**2; p2sq=mf**2; qsq=mA**2;
	xf = mf/mA; mu=mA

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if(mf == mb) then
		If3 = Ib; xif = xid_A(alpha,beta,n)
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)
	else if(mf == mc) then
		If3 = It; xif = xiu_A(alpha,beta,n)
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD4,mc,4.d0),mc_MS)
	else if(mf == ms) then
		If3 = Ib; xif = xid_A(alpha,beta,n)
		rmf = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD3,ms,3.d0),ms_MS)
	endif

	!===================
	!     LO
	!===================
	decay_LO_pole  = Nc*G_F*mA/(4.d0*sqrt(2.d0)*pi)*sqrt(lambda(xf**2,xf**2))*mf**2*xif**2

	if(OREW==0 .and. ORQCD==-1) then
		decay_Aqq = decay_LO_pole
		return
	endif

	decay_LO_MSbar = Nc*G_F*mA/(4.d0*sqrt(2.d0)*pi)*sqrt(lambda(xf**2,xf**2))*rmf**2*xif**2

	if(OREW==0 .and. ORQCD==0) then
		decay_Aqq = decay_LO_MSbar
		return
	endif

	!=========================
	!     QCD corrections
	!=========================
	decay_QCD = 0.d0
	Delta_qq1 = 0.d0; Delta_qq2 = 0.d0; Delta_A = 0.d0

	if(ORQCD == 1) then
		Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mA**2))
		decay_QCD = decay_LO_MSbar*Delta_qq1
	else if(ORQCD == 2) then
		Delta_qq1 = alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0+3.d0/2.d0*log(mu**2/mA**2))
		Delta_qq2 = (alphas(lam_QCD,mu,nf)/pi)**2&
						*(10801.d0/144.d0-39.d0/2.d0*zeta3-(65.d0/24.d0-2.d0/3.d0*zeta3)*nf&
						  -pi**2*(19.d0/12.d0-1.d0/18.d0*nf))
		if (mA < mt) then
			Delta_A   = (alphas(lam_QCD,mu,nf)/pi)**2&
							*(2.d0*It*xiu_A(alpha,beta,n))/(2.d0*If3*xif)&
							*(23.d0/6.d0+log(mt**2/mA**2)+1.d0/6.d0*log(rmf**2/mA**2)**2)
		endif
		decay_QCD = decay_LO_MSbar*(Delta_qq1+Delta_qq2+Delta_A)
	endif

	if(OREW == 0) then
		decay_Aqq = decay_LO_MSbar+decay_QCD
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_P_LO  = ii*2.d0*If3*mf*xif/vev

		Gam_P_NLO =&
			rGam_Aff_P(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			-mf*Gam_Aff_A1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			-mf*Gam_Aff_A2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			+(qsq-p1sq-p2sq-mf**2)*Gam_Aff_PT(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)

		Gam_P_NLO =	Gam_P_NLO-Gam_P_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		decay_EWNLO =&
			Nc*mA/(8.d0*pi)*sqrt(lambda(xf**2,xf**2))*(&
				2.d0*dble(Gam_P_LO*conjg(Gam_P_NLO))&
			)&
			!----- real photon emission -----
			+Nc*decay_A_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)

		if(ORQCD == -1) then
			decay_Aqq = decay_LO_pole+decay_EWNLO
			return
		else if(ORQCD == 0) then
			decay_Aqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO
			return
		else if(ORQCD == 1) then
			decay_Aqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO+decay_QCD
			return
		else if(ORQCD == 2) then
			decay_Aqq = decay_LO_MSbar+(rmf/mf)**2*decay_EWNLO+decay_QCD
			return
		endif
	endif
	
	end function
!----- A -> l l~ ----------------------------------------------------------
	double precision function decay_All(mch,mA,mbH,bmsq,alpha,beta,n,OREW,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW
	double precision:: p1sq,p2sq,qsq
	double precision:: xf,If3,xif
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_P_LO,Gam_P_NLO
	p1sq=mf**2; p2sq=mf**2; qsq=mA**2;
	xf = mf/mA

	If3 = Ie; xif = xil_A(alpha,beta,n)

	!===================
	!     LO
	!===================
	decay_LO = G_F*mA/(4.d0*sqrt(2.d0)*pi)*sqrt(lambda(xf**2,xf**2))*mf**2*xif**2

	if(OREW == 0) then
		decay_All = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_P_LO  = ii*2.d0*If3*mf*xif/vev

		Gam_P_NLO = rGam_Aff_P(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			-mf*Gam_Aff_A1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			-mf*Gam_Aff_A2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
			+(qsq-p1sq-p2sq-mf**2)*Gam_Aff_PT(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)

		Gam_P_NLO =	Gam_P_NLO-Gam_P_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		decay_EWNLO =&
			mA/(8.d0*pi)*sqrt(lambda(xf**2,xf**2))*(&
				2.d0*dble(Gam_P_LO*conjg(Gam_P_NLO))&
			)&
			!----- real photon emission -----
			+decay_A_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)

		decay_All = decay_LO+decay_EWNLO
	endif
	
	end function
!--------------------------------------------------------------------------
	double precision function decay_A_ffgam(mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: If3,Qf,xif

	if (mf == mt .or. mf == mc) then
		If3 = It; Qf = Qt; xif  = xiu_A(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		If3 = Ib; Qf = Qb; xif  = xid_A(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		If3 = Ie; Qf = Qe; xif  = xil_A(alpha,beta,n)
	endif
			
	decay_A_ffgam =&
		2.d0*Qf**2*alpha_em/(16.d0*pi**2*mA)*(2.d0*If3*mf*xif/vev)**2*(&
			+OmegaLL_11(mA,mf,mf)-OmegaLR_11(mA,mf,mf)&
			+OmegaLL_22(mA,mf,mf)-OmegaLR_22(mA,mf,mf)&
			+OmegaLL_12(mA,mf,mf)-OmegaLR_12(mA,mf,mf)&
		)

	end function
!===================================================
!     Two body functions (Bosonic decay)
!===================================================
	double precision function decay_AWW(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=mW**2; p2sq=mW**2; qsq=mA**2; mu=mA

	decay_AWW =&
		mA**3/(32.d0*pi)*lambda(mW**2/mA**2,mW**2/mA**2)**(3.d0/2.d0)&
		*abs(Gam3_AWW(p1sq,p2sq,qsq,alpha,beta,n))**2

	end function
!--------------------------------------------------------------------------
	double precision function decay_AZZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=mZ**2; p2sq=mZ**2; qsq=mA**2; mu=mA

	decay_AZZ =&
		mA**3/(64.d0*pi)*lambda(mZ**2/mA**2,mZ**2/mA**2)**(3.d0/2.d0)&
		*abs(Gam3_AZZ(p1sq,p2sq,qsq,alpha,beta,n))**2

	end function
!--------------------------------------------------------------------------
	double precision function decay_Agamgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mA**2; mu=mA/2.d0

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	if (ORQCD == -1) then
		decay_Agamgam =&
			alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mA**3*&
			abs(&
				2.d0*It*xiu_A(alpha,beta,n)*Nc*Qt**2*I_A(mA,mt)&
				+2.d0*Ib*xid_A(alpha,beta,n)*Nc*Qb**2*I_A(mA,mb)&
				+2.d0*Ie*xil_A(alpha,beta,n)*Qe**2*I_A(mA,mtau)&
			)**2
	endif

	if (ORQCD == 0) then
		decay_Agamgam =&
			alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mA**3*&
			abs(&
				2.d0*It*xiu_A(alpha,beta,n)*Nc*Qt**2*rmt/mt*I_A(mA,mt)&
				+2.d0*Ib*xid_A(alpha,beta,n)*Nc*Qb**2*rmb/mb*I_A(mA,mb)&
				+2.d0*Ie*xil_A(alpha,beta,n)*Qe**2*I_A(mA,mtau)&
			)**2
	endif

	if (1 <= ORQCD) then
		! decay_Agamgam =&
		! 	alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mA**3&
		! 	*abs(&
		! 		2.d0*It*xiu_A(alpha,beta,n)*Nc*Qt**2*rmt/mt*(&
		! 			I_A(mA,mt)&
		! 			! NLO QCD
		! 			+alphas(lam_QCD,mu,nf)/pi*C_A(mA**2/(4.d0*mt**2),mu,mA)/2.d0&
		! 		)&
		! 		+2.d0*Ib*xid_A(alpha,beta,n)*Nc*Qb**2*rmb/mb*(&
		! 			I_A(mA,mb)&
		! 			! NLO QCD
		! 			+alphas(lam_QCD,mu,nf)/pi*C_A(mA**2/(4.d0*mb**2),mu,mA)/2.d0&
		! 		)&
		! 		+2.d0*Ie*xil_A(alpha,beta,n)*Qe**2*I_A(mA,mtau)&
		! 	)**2
		decay_Agamgam =&
			alpha_em**2*G_F/(128.d0*sqrt(2.d0)*pi**3)*mA**3&
			*abs(&
				2.d0*It*xiu_A(alpha,beta,n)*Nc*Qt**2*rmt/mt*(&
					I_A(mA,mt)&
					! NLO QCD
					+alphas(lam_QCD,mu,nf)/pi*C_A(mA,mt,mu)/2.d0&
				)&
				+2.d0*Ib*xid_A(alpha,beta,n)*Nc*Qb**2*rmb/mb*(&
					I_A(mA,mb)&
					! NLO QCD
					+alphas(lam_QCD,mu,nf)/pi*C_A(mA,mb,mu)/2.d0&
				)&
				+2.d0*Ie*xil_A(alpha,beta,n)*Qe**2*I_A(mA,mtau)&
			)**2
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_AZgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb,kz
	p1sq=mZ**2; p2sq=0.d0; qsq=mA**2; mu=mA
	kz=mZ**2/mA**2

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	if (ORQCD == -1) then
		decay_AZgam =&
			mA**3/(32.d0*pi)*lambda(mZ**2/mA**2,m0**2/mA**2)**(3.d0/2.d0)&
			*abs(&
				Nc*Gam3_AZgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
				+Nc*Gam3_AZgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
				+Gam3_AZgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)&
			)**2
	else if (0 <= ORQCD) then
		decay_AZgam =&
			mA**3/(32.d0*pi)*lambda(mZ**2/mA**2,m0**2/mA**2)**(3.d0/2.d0)&
			*abs(&
				Nc*rmt/mt*Gam3_AZgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
				+Nc*rmb/mb*Gam3_AZgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
				+Gam3_AZgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)&
			)**2
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_Agg(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: E_A1,dE_A1,E_A2,mu,nf,lam_QCD,rmt,rmb
	p1sq=0.d0; p2sq=0.d0; qsq=mA**2; mu=mA

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mA
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mA<=mt
	endif

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	if (mt < mu) then
		rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	else if (mu <= mt) then
		rmt = mt
	endif
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	E_A1 = 0.d0; dE_A1 = 0.d0; E_A2 = 0.d0
	if(1 <= ORQCD) then
      if(mA < mt) then
			E_A1 = 97.d0/4.d0-7.d0/6.d0*nf+(33.d0-2.d0*nf)/6.d0*log(mu**2/mA**2)
      else if(mt <= mA) then
         E_A1 = 6.d0+(33.d0-2.d0*nf)/6.d0*log(mu**2/mA**2)
      endif
		dE_A1 =&
			dble(&
				(&
					2.d0*It*xiu_A(alpha,beta,n)&
						*(B1_A(mA**2/(4.d0*mt**2))+(2.d0*C2_A(mA**2/(4.d0*mt**2)))*log(mu**2/mt**2))&
					+2.d0*Ib*xid_A(alpha,beta,n)&
						*(B1_A(mA**2/(4.d0*mb**2))+(2.d0*C2_A(mA**2/(4.d0*mb**2)))*log(mu**2/mb**2))&
				)&
				/(&
					2.d0*It*xiu_A(alpha,beta,n)*F0_A(mA**2/(4.d0*mt**2))&
					+2.d0*Ib*xid_A(alpha,beta,n)*F0_A(mA**2/(4.d0*mb**2))&
				)&
			)&
			-6.d0
	endif

	if(2 <= ORQCD .and. mA < mt) then
		E_A2 =&
			51959.d0/96.d0-363.d0/8.d0*zeta2-495.d0/8.d0*zeta3&
			+nf*(-473.d0/8.d0+11.d0/2.d0*zeta2+5.d0/4.d0*zeta3-log(mt**2/mA**2))&
			+nf**2*(251.d0/216.d0-zeta2/6.d0)
	endif

	if (ORQCD == -1) then
		decay_Agg =&
			sqrt(2.d0)*G_F*alphas(lam_QCD,mA,nf)**2*mA**3/(128.d0*pi**3)&
			*abs(&
				2.d0*It*xiu_A(alpha,beta,n)*I_A(mA,mt)&
				+2.d0*Ib*xid_A(alpha,beta,n)*I_A(mA,mb)&
			)**2
	else if (ORQCD == 0 .or. ORQCD == 1 .or. ORQCD == 2) then
		decay_Agg =&
			sqrt(2.d0)*G_F*alphas(lam_QCD,mA,nf)**2*mA**3/(128.d0*pi**3)&
			*abs(&
				2.d0*It*xiu_A(alpha,beta,n)*rmt/mt*I_A(mA,mt)&
				+2.d0*Ib*xid_A(alpha,beta,n)*rmb/mb*I_A(mA,mb)&
			)**2*(&
			!LO
			+1.d0&
			!NLO QCD
			+alphas(lam_QCD,mA,nf)/pi*(E_A1+dE_A1)*S_NLOQCD&
			!NNLO QCD
			+(alphas(lam_QCD,mA,nf)/pi)**2*E_A2*S_NNLOQCD&
			)
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_AZh(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
 	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO,decay_EWNNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mh**2; p2sq=mZ**2; qsq=mA**2
	xphi = mh/mA; xV = mZ/mA

	!===================
	!     LO
	!===================
	decay_LO = sqrt(2.d0)*G_F*mA**3*cos(beta-alpha)**2/(16.d0*pi)*lambda(xphi**2,xV**2)**(3.d0/2.d0)

	if(OREW == 0) then
		decay_AZh = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	Gam_LO  = ii*mZ/vev*cos(beta-alpha)
	Gam_NLO = rGam_AZh(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
				 -Gam_LO*dble(rdPiZZ(mZ**2,mch,mA,mbH,bmsq,alpha,beta,n))/2.d0&
				 -Gam_LO*dble(Del_r(mch,mA,mbH,bmsq,alpha,beta,n))/2.d0

	decay_EWNLO =&
		mA**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
			2.d0*dble(Gam_LO*conjg(Gam_NLO))&
		)

	if(OREW == 1) then
		decay_AZh = decay_LO+decay_EWNLO
	elseif(OREW == 2) then
		decay_EWNNLO =&
			mA**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
				+Gam_NLO*conjg(Gam_NLO)&
			)
		decay_AZh = decay_LO+decay_EWNLO+decay_EWNNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_AZbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
 	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mbH**2; p2sq=mZ**2; qsq=mA**2
	xphi = mbH/mA; xV = mZ/mA

	!===================
	!     LO
	!===================
	decay_LO = sqrt(2.d0)*G_F*mA**3*sin(beta-alpha)**2/(16.d0*pi)*lambda(xphi**2,xV**2)**(3.d0/2.d0)

	if(OREW==0) then
		decay_AZbH = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_LO  = -ii*mZ/vev*sin(beta-alpha)
		Gam_NLO = rGam_AZbH(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
					 -Gam_LO*dble(rdPiZZ(mZ**2,mch,mA,mbH,bmsq,alpha,beta,n))/2.d0&
					 -Gam_LO*dble(Del_r(mch,mA,mbH,bmsq,alpha,beta,n))/2.d0

		decay_EWNLO =&
			mA**3/(16.d0*pi*mZ**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_LO*conjg(Gam_NLO))&
			)

		decay_AZbH = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_AWch(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
 	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq
	double precision:: xphi,xV
	double precision:: decay_LO,decay_EWNLO
	complex (kind(0d0)):: Gam_LO,Gam_NLO
	p1sq=mch**2; p2sq=mW**2; qsq=mA**2
	xphi = mch/mA; xV = mw/mA

	call Switch_HOEW(OREW,S_NLOEW)

	!===================
	!     LO
	!===================
	decay_LO = sqrt(2.d0)*G_F*mA**3/(8.d0*pi)*lambda(xphi**2,xV**2)**(3.d0/2.d0)

	if(OREW==0) then
		decay_AWch = decay_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_LO = -ii*mW/vev
		!pA = p1, pW = p2, pcH = q by definition
		Gam_NLO = -rGam_AWHp(qsq,p2sq,p1sq,mch,mA,mbH,bmsq,alpha,beta,n)
		Gam_NLO = +Gam_NLO&
					 -Gam_LO*dble(rdPiWW(mW**2,mch,mA,mbH,bmsq,alpha,beta,n))/2.d0&
					 -Gam_LO*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		decay_EWNLO =&
			mA**3/(8.d0*pi*mW**2)*lambda(xphi**2,xV**2)**(3.d0/2.d0)*(&
				2.d0*dble(Gam_LO*conjg(Gam_NLO))&
			)

		!===== QED NLO =====
		decay_EWNLO = decay_EWNLO+decay_A_chWgam(mch,mA,mbH,bmsq,alpha,beta,n)*QED

		decay_AWch = decay_LO+decay_EWNLO
	endif

	end function
!--------------------------------------------------------------------------
	double precision function decay_A_chWgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	double precision:: xch,xw
	xch = mch/mA; xw = mw/mA

	decay_A_chWgam =&
		-sqrt(2.d0)*G_F*mw**2*alpha_em/(2.d0*pi**2)*mA**3*(&
			+lambda(xch**2,xw**2)*(&
				+Ibrems_22(mA,mch,mW)&
				+mch**2/mW**2*Ibrems_11(mA,mch,mW)&
				+(1.d0+(mch**2-mA**2)/mW**2)*Ibrems_12(mA,mch,mW)&
				+1.d0/mW**2*(Ibrems_1(mA,mch,mW)+Ibrems_2(mA,mch,mW))&
			)&
			-2.d0/mA**4*(&
				+Ibrems(mA,mch,mW)+2.d0*Ibrems1_2(mA,mch,mW)+Ibrems11_22(mA,mch,mW)&
			)&
		)

	end function
!===================================================
!     Three body functions
!===================================================
	double precision function ddecay_dy1dy2_Atts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,yt,yb
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,kt,kw,gamt,KAtts
!	p1sq=mt**2; p2sq=mb**2; qsq=mA**2
	kt = mt**2/mA**2
	kw = mW**2/mA**2
	gamt = (1.42d0/mA)**2
	KAtts = 3*G_F**2*mt**2*xiu_A(alpha,beta,n)**2/32.d0/pi**3*mA**3
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	ddecay_dy1dy2_Atts=&
	KAtts/(yt**2+kt*gamt)*(&
		-yt**3+(1.d0-kt+kw-yb)*yt**2+(2.d0*kt-yb*(kt-2.d0*kw))*yt&
		+(kt-kw)*(kt+2.d0*kw)&
	)*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&
		! NLO  QCD correction
		!	*S_NLOQCD&
		! NNLO  QCD correction
		!	*S_NNLOQCD&
	)

	end function

!-------------------------------------------------------------------
	double precision function decay_Atts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	integer:: i,j,div_width
	double precision:: yt,yb,xt,xb,xw,ddecay_Atts
	xt = mt/mA
	xb = mb/mA
	xw = mw/mA

	div_width=200; decay_Atts=0.d0

	do i = 0, div_width
		ddecay_Atts=0.d0
		yt = (xb+xw)**2-xt**2+((1.d0-xt)**2-(xb+xw)**2)/dble(div_width)*dble(i)
		do j = 0, div_width
			yb = xt**2+xw**2-xb**2&
				+(1.d0-2.d0*xt**2-yt)*(yt+xt**2+xw**2-xb**2)/(2.d0*(yt+xt**2))&
				-abs(lambda(yt+xt**2,xt**2)*lambda(xb**2/(yt+xt**2),xw**2/(yt+xt**2)))**(1.d0/2.d0)/2.d0&
				*(1.d0-2.d0*dble(j)/dble(div_width))
			if(j==0 .or. j==div_width) then
				ddecay_Atts = ddecay_Atts+ddecay_dy1dy2_Atts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
			else if(mod(j,2)==1) then
				ddecay_Atts = ddecay_Atts+4.d0*ddecay_dy1dy2_Atts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
			else if(mod(j,2)==0) then
				ddecay_Atts = ddecay_Atts+2.d0*ddecay_dy1dy2_Atts(mch,mA,mbH,bmsq,alpha,beta,n,yt,yb,OREW,ORQCD)
			endif
		enddo
		ddecay_Atts = ddecay_Atts*sqrt(abs(lambda(yt+xt**2,xt**2)*lambda(xb**2/(yt+xt**2),xw**2/(yt+xt**2))))&
					/dble(div_width)/3.d0
		if(i==0 .or. i==div_width) then
			decay_Atts = decay_Atts+ddecay_Atts
		else if(mod(i,2)==1) then
			decay_Atts = decay_Atts+4.d0*ddecay_Atts
		else if(mod(i,2)==0) then
			decay_Atts = decay_Atts+2.d0*ddecay_Atts
		endif
	enddo
	decay_Atts = decay_Atts*((1.d0-xt)**2-(xb+xw)**2)/dble(div_width)/3.d0

	end function
!-------------------------------------------------------------------
	double precision function decay_AZstarh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,KAZh
	double precision:: mu,nf,lam_QCD
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	mu = mA
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif
	KAZh = 9.d0*G_F**2*mZ**4*mA/16.d0/pi**3*cos(beta-alpha)**2&
		*(7.d0/12.d0-10.d0/9.d0*sw**2+40.d0/27.d0*sw**4)
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_AZstarh = &
		KAZh*SSpV3body(mA,mh,mZ)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			!	*S_NLOEW&
			! NLO  QED correction
			!	*S_NLOQCD&
			! NLO QCD correctio
			!	+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)*S_NLOQCD&
			! NNLO  QCD correction
			!	*S_NNLOQCD
		)

	end function
!-------------------------------------------------------------------
	double precision function decay_AZstarbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,KAZbH
	double precision:: mu,nf,lam_QCD
	p1sq=mt**2; p2sq=md**2; qsq=mch**2
	mu = mA
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif
	KAZbH = 9.d0*G_F**2*mZ**4*mA/16.d0/pi**3*sin(beta-alpha)**2&
		*(7.d0/12.d0-10.d0/9.d0*sw**2+40.d0/27.d0*sw**4)
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_AZstarbH =&
		KAZbH*SSpV3body(mA,mbH,mZ)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			!	*S_NLOEW&
			! NLO  QED correction
			!	*S_NLOQCD&
			! NLO QCD correctio
			!	+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)*S_NLOQCD&
			! NNLO  QCD correction
			!	*S_NNLOQCD
		)

	end function
!-------------------------------------------------------------------
	double precision function decay_AWstarch(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD) !Sum up W+H- and W-H+
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,KAWch
	double precision:: mu,nf,lam_QCD
!	p1sq=mt**2; p2sq=md**2; qsq=mch**2
	mu = mA
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif
	KAWch = 2.d0*9.d0*G_F**2*mW**4*mA/16.d0/pi**3

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_AWstarch =&
		KAWch*SSpV3body(mA,mch,mW)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			!	*S_NLOEW&
			! NLO  QED correction
			!	*S_NLOQCD&
			! NLO QCD correctio
			!	+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)*S_NLOQCD&
			! NNLO  QCD correction
			!	*S_NNLOQCD
		)

	end function
!=====================================
!     1PI vertex functions
!=====================================
!-------------------------------------------------------------
!     Aff 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_S(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_S=&
	+ii/(16.d0*pi**2)*(&
		!SFS
		-ii*2.d0*If3*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*mf*mfp**2/vev**2*(xif+xifp)*(&
		c0f(p1sq,p2sq,qsq,mch,mfp,mw)-c0f(p1sq,p2sq,qsq,mw,mfp,mch))&
		!SFV
		+gz**2*cos(beta-alpha)/2.d0*vf*(mf*xih/vev)*CSFV_Aff(p1sq,p2sq,qsq,mh,mf,mZ)&
		-gz**2*sin(beta-alpha)/2.d0*vf*(mf*xibH/vev)*CSFV_Aff(p1sq,p2sq,qsq,mbH,mf,mZ)&
		+g**2/2.d0*(If3*mf*xif/vev)*CSFV_Aff(p1sq,p2sq,qsq,mch,mfp,mW)&
		!VFS
		-gz**2*cos(beta-alpha)/2.d0*vf*(mf*xih/vev)*CVFS_Aff(p1sq,p2sq,qsq,mZ,mf,mh)&
		+gz**2*sin(beta-alpha)/2.d0*vf*(mf*xibH/vev)*CVFS_Aff(p1sq,p2sq,qsq,mZ,mf,mbH)&
		-g**2/2.d0*(If3*mf*xif/vev)*CVFS_Aff(p1sq,p2sq,qsq,mW,mfp,mch)&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_P(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_P=&
	+ii/(16.d0*pi**2)*(&
		!FVF
		+gz**2*(vf**2-af**2)*(2.d0*If3*mf*xif/vev)*CFVF_Aff(p1sq,p2sq,qsq,mf,mZ,mf)&
		!FSF
		+(mf*xih/vev)**2*(2.d0*If3*mf*xif/vev)*CFSF_Aff(p1sq,p2sq,qsq,mf,mh,mf)&
		+(mf*xibH/vev)**2*(2.d0*If3*mf*xif/vev)*CFSF_Aff(p1sq,p2sq,qsq,mf,mbH,mf)&
		-(2.d0*If3*mf/vev)**2*(2.d0*If3*mf*xif/vev)*CFSF_Aff(p1sq,p2sq,qsq,mf,mz,mf)&
		-(2.d0*If3*mf*xif/vev)**3*CFSF_Aff(p1sq,p2sq,qsq,mf,mA,mf)&
		-(2.d0*mf*mfp/vev**2)*(2.d0*Ifp3*mfp*xifp/vev)*CFSF_Aff(p1sq,p2sq,qsq,mfp,mw,mfp)&
		-(2.d0*mf*xif*mfp*xifp/vev**2)*(2.d0*Ifp3*mfp*xifp/vev)*CFSF_Aff(p1sq,p2sq,qsq,mfp,mch,mfp)&
		!SFV
		+gz**2*af*cos(beta-alpha)/2.d0*(mf*xih/vev)*CSFV_Aff(p1sq,p2sq,qsq,mh,mf,mZ)&
		-gz**2*af*sin(beta-alpha)/2.d0*(mf*xibH/vev)*CSFV_Aff(p1sq,p2sq,qsq,mbH,mf,mZ)&
		+g**2/2.d0*(If3*mf*xif/vev)*CSFV_Aff(p1sq,p2sq,qsq,mch,mfp,mW)&
		!VFS
		+gz**2*af*cos(beta-alpha)/2.d0*(mf*xih/vev)*CVFS_Aff(p1sq,p2sq,qsq,mZ,mf,mh)&
		-gz**2*af*sin(beta-alpha)/2.d0*(mf*xibH/vev)*CVFS_Aff(p1sq,p2sq,qsq,mZ,mf,mbH)&
		+g**2/2.d0*(If3*mf*xif/vev)*CVFS_Aff(p1sq,p2sq,qsq,mW,mfp,mch)&
		!SFS
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*(mf*xih/vev)*(2.d0*If3*mf**2/vev)*(&
			c0f(p1sq,p2sq,qsq,mh,mf,mz)+c0f(p1sq,p2sq,qsq,mz,mf,mh))&
		+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*(mf*xibH/vev)*(2.d0*If3*mf**2/vev)*(&
			c0f(p1sq,p2sq,qsq,mbH,mf,mz)+c0f(p1sq,p2sq,qsq,mz,mf,mbH))&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*(mf*xih/vev)*(2.d0*If3*mf**2*xif/vev)*(&
			c0f(p1sq,p2sq,qsq,mh,mf,mA)+c0f(p1sq,p2sq,qsq,mA,mf,mh))&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*(mf*xibH/vev)*(2.d0*If3*mf**2*xif/vev)*(&
			c0f(p1sq,p2sq,qsq,mbH,mf,mA)+c0f(p1sq,p2sq,qsq,mA,mf,mbH))&
		-ii*2.d0*If3*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*mf*mfp**2/vev**2*(xif-xifp)*(&
			c0f(p1sq,p2sq,qsq,mch,mfp,mw)+c0f(p1sq,p2sq,qsq,mw,mfp,mch))&
		!--- QED ---
		!FVF
		+QED*(g*sw)**2*Qf**2*(2.d0*If3*mf*xif/vev)*CFVF_Aff(p1sq,p2sq,qsq,mf,mphoton,mf)&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_V1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_V1=&
	+ii/(16.d0*pi**2)*(&
		!FVF
		+4.d0*gz**2*vf*af*(2.d0*If3*mf**2*xif)/vev*c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
		+g**2/2.d0*(2.d0*Ifp3*mfp**2*xifp)/vev*c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
		!FSF
		+(2.d0*Ifp3*mfp**2*xifp/vev)*(&
			+(mf**2-mfp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			+(mf**2*xif**2-mfp**2*xifp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mch,mfp))&
		!SFS
		-2.d0*If3*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xif+mfp**2*xifp)/vev**2*(&
			+c0f(p1sq,p2sq,qsq,mch,mfp,mw)+c11f(p1sq,p2sq,qsq,mch,mfp,mw)&
			-(c0f(p1sq,p2sq,qsq,mw,mfp,mch)+c11f(p1sq,p2sq,qsq,mw,mfp,mch)))&
		!SFV+VFS
		+gz**2*cos(beta-alpha)/2.d0*vf*(mf**2*xih/vev)*(&
			+c11f(p1sq,p2sq,qsq,mh,mf,mZ)-c0f(p1sq,p2sq,qsq,mh,mf,mZ)&
			-(c11f(p1sq,p2sq,qsq,mZ,mf,mh)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mh)))&
		-gz**2*sin(beta-alpha)/2.d0*vf*(mf**2*xibH/vev)*(&
			+c11f(p1sq,p2sq,qsq,mbH,mf,mZ)-c0f(p1sq,p2sq,qsq,mbH,mf,mZ)&
			-(c11f(p1sq,p2sq,qsq,mZ,mf,mbH)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mbH)))&
		+g**2/2.d0*(Ifp3*mfp**2*xifp/vev)*(&
			+c11f(p1sq,p2sq,qsq,mch,mfp,mW)-c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
			-(c11f(p1sq,p2sq,qsq,mW,mfp,mch)+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)))&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_V2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_V2=&
	+ii/(16.d0*pi**2)*(&
		!FVF
		+4.d0*gz**2*vf*af*(2.d0*If3*mf**2*xif)/vev*c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
		+g**2/2.d0*(2.d0*Ifp3*mfp**2*xifp)/vev*c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
		!FSF
		+(2.d0*Ifp3*mfp**2*xifp/vev)*(&
			+(mf**2-mfp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			+(mf**2*xif**2-mfp**2*xifp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mch,mfp))&
		!SFS
		-2.d0*If3*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xif+mfp**2*xifp)/vev**2*(&
			+c12f(p1sq,p2sq,qsq,mch,mfp,mw)-c12f(p1sq,p2sq,qsq,mw,mfp,mch))&
		!SFV+VFS
		+gz**2*cos(beta-alpha)/2.d0*vf*(mf**2*xih/vev)*(&
			+c12f(p1sq,p2sq,qsq,mh,mf,mZ)-c0f(p1sq,p2sq,qsq,mh,mf,mZ)&
			-(c12f(p1sq,p2sq,qsq,mZ,mf,mh)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mh)))&
		-gz**2*sin(beta-alpha)/2.d0*vf*(mf**2*xibH/vev)*(&
			+c12f(p1sq,p2sq,qsq,mbH,mf,mZ)-c0f(p1sq,p2sq,qsq,mbH,mf,mZ)&
			-(c12f(p1sq,p2sq,qsq,mZ,mf,mbH)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mbH)))&
		+g**2/2.d0*(Ifp3*mfp**2*xifp/vev)*(&
			+c12f(p1sq,p2sq,qsq,mch,mfp,mW)-c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
			-(c12f(p1sq,p2sq,qsq,mW,mfp,mch)+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)))&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_A1(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_A1=&
	+ii/(16.d0*pi**2)*(&
		!FVF
		-(2.d0*If3*mf**2*xif)/vev*(&
			+2.d0*gz**2*(vf**2+af**2)*c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
			+QED*2.d0*(g*sw)**2*Qf**2*c0f(p1sq,p2sq,qsq,mf,mphoton,mf))&
		-g**2/2.d0*(2.d0*Ifp3*mfp**2*xifp)/vev*c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
		!FSF
		+(2.d0*If3*mf**2*xif/vev)*(&
			+(mf*xih/vev)**2*c0f(p1sq,p2sq,qsq,mf,mh,mf)&
			+(mf*xibH/vev)**2*c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
			+(mf/vev)**2*c0f(p1sq,p2sq,qsq,mf,mz,mf)&
			+(mf*xif/vev)**2*c0f(p1sq,p2sq,qsq,mf,mA,mf))&
		+(2.d0*Ifp3*mfp**2*xifp/vev)*(&
			+(mf**2+mfp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			+(mf**2*xif**2+mfp**2*xifp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mch,mfp))&
		!SFS
		-lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*(mf*xih/vev)*(2.d0*If3*mf/vev)*(&
			+c0f(p1sq,p2sq,qsq,mh,mf,mz)+c11f(p1sq,p2sq,qsq,mh,mf,mz)&
			-(c0f(p1sq,p2sq,qsq,mz,mf,mh)+c11f(p1sq,p2sq,qsq,mz,mf,mh)))&
		-lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*(mf*xibH/vev)*(2.d0*If3*mf/vev)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mf,mz)+c11f(p1sq,p2sq,qsq,mbH,mf,mz)&
			-(c0f(p1sq,p2sq,qsq,mz,mf,mbH)+c11f(p1sq,p2sq,qsq,mz,mf,mbH)))&
		-2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*(mf*xih/vev)*(2.d0*If3*mf*xif/vev)*(&
			+c0f(p1sq,p2sq,qsq,mh,mf,mA)+c11f(p1sq,p2sq,qsq,mh,mf,mA)&
			-(c0f(p1sq,p2sq,qsq,mA,mf,mh)+c11f(p1sq,p2sq,qsq,mA,mf,mh)))&
		-2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*(mf*xibH/vev)*(2.d0*If3*mf*xif/vev)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mf,mA)+c11f(p1sq,p2sq,qsq,mbH,mf,mA)&
			-(c0f(p1sq,p2sq,qsq,mA,mf,mbH)+c11f(p1sq,p2sq,qsq,mA,mf,mbH)))&
		+ii*2.d0*If3*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xif-mfp**2*xifp)/vev**2*(&
			+c0f(p1sq,p2sq,qsq,mch,mfp,mw)+c11f(p1sq,p2sq,qsq,mch,mfp,mw)&
			-(c0f(p1sq,p2sq,qsq,mw,mfp,mch)+c11f(p1sq,p2sq,qsq,mw,mfp,mch)))&
		!SFV+VFS
		+gz**2*cos(beta-alpha)/2.d0*af*(mf**2*xih/vev)*(&
			-c11f(p1sq,p2sq,qsq,mh,mf,mZ)+c0f(p1sq,p2sq,qsq,mh,mf,mZ)&
			+c11f(p1sq,p2sq,qsq,mZ,mf,mh)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mh))&
		-gz**2*sin(beta-alpha)/2.d0*af*(mf**2*xibH/vev)*(&
			-c11f(p1sq,p2sq,qsq,mbH,mf,mZ)+c0f(p1sq,p2sq,qsq,mbH,mf,mZ)&
			+c11f(p1sq,p2sq,qsq,mZ,mf,mbH)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mbH))&
		+g**2/2.d0*(Ifp3*mfp**2*xifp/vev)*(&
			-c11f(p1sq,p2sq,qsq,mch,mfp,mW)+c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
			+c11f(p1sq,p2sq,qsq,mW,mfp,mch)+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch))&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_A2(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_A2=&
	+ii/(16.d0*pi**2)*(&
		!FVF
		-(2.d0*If3*mf**2*xif)/vev*(&
			+2.d0*gz**2*(vf**2+af**2)*c0f(p1sq,p2sq,qsq,mf,mZ,mf)&
			+QED*2.d0*(g*sw)**2*Qf**2*c0f(p1sq,p2sq,qsq,mf,mphoton,mf))&
		-g**2/2.d0*(2.d0*Ifp3*mfp**2*xifp)/vev*c0f(p1sq,p2sq,qsq,mfp,mW,mfp)&
		!FSF
		+(2.d0*If3*mf**2*xif/vev)*(&
			+(mf**2*xih**2)/vev**2*c0f(p1sq,p2sq,qsq,mf,mh,mf)&
			+(mf**2*xibH**2)/vev**2*c0f(p1sq,p2sq,qsq,mf,mbH,mf)&
			+(mf**2)/vev**2*c0f(p1sq,p2sq,qsq,mf,mz,mf)&
			+(mf**2*xif**2)/vev**2*c0f(p1sq,p2sq,qsq,mf,mA,mf))&
		+(2.d0*Ifp3*mfp**2*xifp/vev)*(&
			+(mf**2+mfp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mw,mfp)&
			+(mf**2*xif**2+mfp**2*xifp**2)/vev**2*c0f(p1sq,p2sq,qsq,mfp,mch,mfp))&
		!SFS
		-lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*(mf*xih/vev)*(2.d0*If3*mf/vev)*(&
			+c12f(p1sq,p2sq,qsq,mh,mf,mz)-c12f(p1sq,p2sq,qsq,mz,mf,mh))&
		-lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*(mf*xibH/vev)*(2.d0*If3*mf/vev)*(&
			+c12f(p1sq,p2sq,qsq,mbH,mf,mz)-c12f(p1sq,p2sq,qsq,mz,mf,mbH))&
		-2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*(mf*xih/vev)*(2.d0*If3*mf*xif/vev)*(&
			+c12f(p1sq,p2sq,qsq,mh,mf,mA)-c12f(p1sq,p2sq,qsq,mA,mf,mh))&
		-2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*(mf*xibH/vev)*(2.d0*If3*mf*xif/vev)*(&
			+c12f(p1sq,p2sq,qsq,mbH,mf,mA)-c12f(p1sq,p2sq,qsq,mA,mf,mbH))&
		+ii*2.d0*If3*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*(mf**2*xif-mfp**2*xifp)/vev**2*(&
			c12f(p1sq,p2sq,qsq,mch,mfp,mw)-c12f(p1sq,p2sq,qsq,mw,mfp,mch))&
		!SFV+VFS
		+gz**2*cos(beta-alpha)/2.d0*af*(mf**2*xih/vev)*(&
			-c12f(p1sq,p2sq,qsq,mh,mf,mZ)+c0f(p1sq,p2sq,qsq,mh,mf,mZ)&
			+c12f(p1sq,p2sq,qsq,mZ,mf,mh)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mh))&
		-gz**2*sin(beta-alpha)/2.d0*af*(mf**2*xibH/vev)*(&
			-c12f(p1sq,p2sq,qsq,mbH,mf,mZ)+c0f(p1sq,p2sq,qsq,mbH,mf,mZ)&
			+c12f(p1sq,p2sq,qsq,mZ,mf,mbH)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mbH))&
		+g**2/2.d0*(Ifp3*mfp**2*xifp/vev)*(&
			-c12f(p1sq,p2sq,qsq,mch,mfp,mW)+c0f(p1sq,p2sq,qsq,mch,mfp,mW)&
			+c12f(p1sq,p2sq,qsq,mW,mfp,mch)+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch))&
	)

	end function

!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_T(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_T=&
	+ii/(16.d0*pi**2)*(&
		!SFV+VFS
		+gz**2*cos(beta-alpha)/2.d0*vf*(mf*xih/vev)*(&
			+c0f(p1sq,p2sq,qsq,mh,mf,mZ)+c11f(p1sq,p2sq,qsq,mh,mf,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mh,mf,mZ)&
			-(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mh)+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mh)-c12f(p1sq,p2sq,qsq,mZ,mf,mh)))&
		-gz**2*sin(beta-alpha)/2.d0*vf*(mf*xibH/vev)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mf,mZ)+c11f(p1sq,p2sq,qsq,mbH,mf,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mbH,mf,mZ)&
			-(2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mbH)+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mbH)-c12f(p1sq,p2sq,qsq,mZ,mf,mbH)))&
		+g**2/2.d0*(If3*mf*xif/vev)*(&
			+c0f(p1sq,p2sq,qsq,mch,mfp,mW)+c11f(p1sq,p2sq,qsq,mch,mfp,mW)-2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
			-(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)-c12f(p1sq,p2sq,qsq,mW,mfp,mch)))&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Aff_PT(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: mfp,If3,Ifp3,vf,af,Qf,xif,xifp,xih,xihp,xibH,xibHp

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			mfp = mb
		else if(mf == mc) then
			mfp = ms
		endif
		If3 = It; Ifp3 = Ib; vf = vt; af = at; Qf = Qt;
		xif  = xiu_A(alpha,beta,n); xifp  = xid_A(alpha,beta,n)
		xih  = xiu(alpha,beta,n);   xihp  = xid(alpha,beta,n)
		xibH = xiu_H(alpha,beta,n); xibHp = xid_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			mfp = mt
		else if(mf == ms) then
			mfp = mc
		endif
		If3 = Ib; Ifp3 = It; vf = vb; af = ab; Qf = Qb;
		xif  = xid_A(alpha,beta,n); xifp  = xiu_A(alpha,beta,n)
		xih  = xid(alpha,beta,n);   xihp  = xiu(alpha,beta,n)
		xibH = xid_H(alpha,beta,n); xibHp = xiu_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		mfp = 0.d0
		If3 = Ie; Ifp3 = In; vf = ve; af = ae; Qf = Qe;
		xif  = xil_A(alpha,beta,n); xifp  = 0.d0
		xih  = xil(alpha,beta,n);   xihp  = 0.d0
		xibH = xil_H(alpha,beta,n); xibHp = 0.d0
	endif

	Gam_Aff_PT=&
	+ii/(16.d0*pi**2)*(&
		!FSF
		+(2.d0*If3*mf*xif/vev)*(&
			+(mf*xih/vev)**2*(-c11f(p1sq,p2sq,qsq,mf,mh,mf)+c12f(p1sq,p2sq,qsq,mf,mh,mf))&
			+(mf*xibH/vev)**2*(-c11f(p1sq,p2sq,qsq,mf,mbH,mf)+c12f(p1sq,p2sq,qsq,mf,mbH,mf))&
			-(mf/vev)**2*(-c11f(p1sq,p2sq,qsq,mf,mz,mf)+c12f(p1sq,p2sq,qsq,mf,mz,mf))&
			-(mf*xif/vev)**2*(-c11f(p1sq,p2sq,qsq,mf,mA,mf)+c12f(p1sq,p2sq,qsq,mf,mA,mf)))&
		-(2.d0*Ifp3*mfp*xifp/vev)*(&
			+2.d0*mf*mfp/vev**2*(-c11f(p1sq,p2sq,qsq,mfp,mw,mfp)+c12f(p1sq,p2sq,qsq,mfp,mw,mfp))&
			+2.d0*mf*xif*mfp*xifp/vev**2*(-c11f(p1sq,p2sq,qsq,mfp,mch,mfp)+c12f(p1sq,p2sq,qsq,mfp,mch,mfp)))&
		!SFV+VFS
		+gz**2*cos(beta-alpha)/2.d0*af*(mf*xih/vev)*(&
			+c0f(p1sq,p2sq,qsq,mh,mf,mZ)+c11f(p1sq,p2sq,qsq,mh,mf,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mh,mf,mZ)&
			+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mh)+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mh)-c12f(p1sq,p2sq,qsq,mZ,mf,mh))&
		-gz**2*sin(beta-alpha)/2.d0*af*(mf*xibH/vev)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mf,mZ)+c11f(p1sq,p2sq,qsq,mbH,mf,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mbH,mf,mZ)&
			+2.d0*c0f(p1sq,p2sq,qsq,mZ,mf,mbH)+2.d0*c11f(p1sq,p2sq,qsq,mZ,mf,mbH)-c12f(p1sq,p2sq,qsq,mZ,mf,mbH))&
		+g**2/2.d0*(If3*mf*xif/vev)*(&
			+c0f(p1sq,p2sq,qsq,mch,mfp,mW)+c11f(p1sq,p2sq,qsq,mch,mfp,mW)-2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mW)&
			+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mch)+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mch)-c12f(p1sq,p2sq,qsq,mW,mfp,mch))&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSFV_Aff(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSFV_Aff=&
		+b0f(p2sq,m2,m3)&
		+(m1**2-qsq+p2sq)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		-(qsq-p1sq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(qsq-p1sq-2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CVFS_Aff(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CVFS_Aff=&
		+b0f(p2sq,m2,m3)&
		+(m1**2+2.d0*p1sq)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		+3.d0*p1sq*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq-p1sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CFVF_Aff(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CFVF_Aff=&
		+4.d0*b0f(p2sq,m2,m3)-2.d0&
		+4.d0*(m1**2-m1*m3)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq+p1sq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq-p1sq+p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CFSF_Aff(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CFSF_Aff=&
		+b0f(p2sq,m2,m3)&
		+(m1**2-m1*m3)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(qsq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+p2sq*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-------------------------------------------------------------
!     Aff renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function rGam_Aff_P(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: If3,xif
	double precision:: del_mf,del_ZVf

	if (mf == mt .or. mf == mc) then
		if(mf == mt) then
			del_mf  = del_mt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVt(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mf == mc) then
			del_mf  = del_mc(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVc(mch,mA,mbH,bmsq,alpha,beta,n)
		endif
		If3 = It; xif  = xiu_A(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then
		if(mf == mb) then
			del_mf  = del_mb(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVb(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mf == ms) then
			del_mf  = del_ms(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVs(mch,mA,mbH,bmsq,alpha,beta,n)
		endif
		If3 = Ib; xif  = xid_A(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then
		if(mf == mtau) then
			del_mf  = del_mtau(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVtau(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mf == mmu) then
			del_mf  = del_mmu(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZVf = del_ZVmu(mch,mA,mbH,bmsq,alpha,beta,n)
		endif
		If3 = Ie; xif  = xil_A(alpha,beta,n)
	endif
	
	rGam_Aff_P=&
		+Gam_Aff_P(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n,mf)&
		+ii*2.d0*If3*mf*xif/vev*(&
			+del_mf/mf&
			-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
			-xif*del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
			+del_ZVf&
			+del_ZA(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0&
			+del_CA(mch,mA,mbH,bmsq,alpha,beta,n)/xif&
			-(1.d0/xif+xif)*del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
		)

	end function
!-------------------------------------------------------------
!     AZh 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: vf,af,If3,xiA,xih

	if (mf == mt .or. mf==mc) then
		vf = vt; af = at; If3 = It
		xiA=xiu_A(alpha,beta,n); xih=xiu(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then 
		vf = vb; af = ab; If3 = Ib
		xiA=xid_A(alpha,beta,n); xih=xid(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve; af = ae; If3 = Ie
		xiA=xil_A(alpha,beta,n); xih=xil(alpha,beta,n)
	endif

	Gam_AZh_fermion=&
		ii*8.d0*If3*gz*af*mf**2*xiA*xih/vev**2/(16.d0*pi**2)*(&
			+b0f(p2sq,mf,mf)+2.d0*mf**2*c0f(p1sq,p2sq,qsq,mf,mf,mf)&
			+p1sq*c11f(p1sq,p2sq,qsq,mf,mf,mf)&
			+(qsq-p1sq)*c12f(p1sq,p2sq,qsq,mf,mf,mf)&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZh_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam_AZh_F=&
		+Nc*Gam_AZh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
		+Nc*Gam_AZh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
		+Nc*Gam_AZh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc)&
		+Nc*Gam_AZh_fermion(p1sq,p2sq,qsq,alpha,beta,n,ms)&
		+Gam_AZh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)&
		+Gam_AZh_fermion(p1sq,p2sq,qsq,alpha,beta,n,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZh_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	Gam_AZh_B=&
		ii/(16.d0*pi**2)*(&
		!SVV
		+g**3*cw*cos(beta-alpha)/2.d0*CSVV_AZS(p1sq,p2sq,qsq,mch,mW,mW)&
   	!VSS
		+gz**3/8.d0*cos(beta-alpha)*(&
		+cos(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mA,mh)&
		+sin(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mA,mbH)&
		+sin(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mz,mh)&
		-sin(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mz,mbH)&
		-2.d0*cw**2*(cw**2-sw**2)*CVSS_AZS(p1sq,p2sq,qsq,mW,mch,mch))&
   	!SV
		-gz**3*cos(beta-alpha)/8.d0*(&
		+b0f(qsq,mh,mZ)-b1f(qsq,mh,mZ)&
		+2.d0*sw**2*cw**2*(b0f(qsq,mch,mW)-b1f(qsq,mch,mW))&
		+b0f(p1sq,mA,mZ)-b1f(p1sq,mA,mZ)&
		+2.d0*sw**2*cw**2*(b0f(p1sq,mch,mW)-b1f(p1sq,mch,mW)))&
		!VVS
		+gz**3*mZ**2*sin(beta-alpha)**2*cos(beta-alpha)/4.d0*(&
		-c11f(p1sq,p2sq,qsq,mZ,mZ,mh)-2.d0*c0f(p1sq,p2sq,qsq,mZ,mZ,mh)&
		+c11f(p1sq,p2sq,qsq,mZ,mZ,mbH)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mZ,mbH))&
		!SSV
		+gz**2*mZ/4.d0*(&
		+6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mh,mh,mZ)-c11f(p1sq,p2sq,qsq,mh,mh,mZ))&
		+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*(&
			+c0f(p1sq,p2sq,qsq,mh,mbH,mZ)-c11f(p1sq,p2sq,qsq,mh,mbH,mZ))&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*(&
			+c0f(p1sq,p2sq,qsq,mbH,mh,mZ)-c11f(p1sq,p2sq,qsq,mbH,mh,mZ))&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mbH,mZ)-c11f(p1sq,p2sq,qsq,mbH,mbH,mZ))&
		+2.d0*sw**2*cw**2*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(&
			+c0f(p1sq,p2sq,qsq,mch,mw,mW)-c11f(p1sq,p2sq,qsq,mch,mw,mW)))&
		!SVS
		+gz**2*mZ/4.d0*(&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mA,mZ,mh)-c11f(p1sq,p2sq,qsq,mA,mZ,mh))&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*(&
			+c0f(p1sq,p2sq,qsq,mA,mZ,mbH)-c11f(p1sq,p2sq,qsq,mA,mZ,mbH))&
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*(&
			+c0f(p1sq,p2sq,qsq,mz,mZ,mh)-c11f(p1sq,p2sq,qsq,mz,mZ,mh))&
		+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mz,mZ,mbH)-c11f(p1sq,p2sq,qsq,mz,mZ,mbH))&
		-ii*sw**2*cw**2*lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mch,mW,mw)-c11f(p1sq,p2sq,qsq,mch,mW,mw))&
		+ii*sw**2*cw**2*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mch,mW,mw)-c11f(p1sq,p2sq,qsq,mch,mW,mw)))&
		!SSS
		+gz/2.d0*(&
		-12.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mh,mh,mA)+c11f(p1sq,p2sq,qsq,mh,mh,mA))&
		+4.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mh,mbH,mA)+c11f(p1sq,p2sq,qsq,mh,mbH,mA))&
		-4.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mh,mA)+c11f(p1sq,p2sq,qsq,mbH,mh,mA))&
		+4.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mbH,mA)+c11f(p1sq,p2sq,qsq,mbH,mbH,mA))&
		+4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)**2*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mA,mA,mh)+c11f(p1sq,p2sq,qsq,mA,mA,mh))&
		-4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mA,mA,mbH)+c11f(p1sq,p2sq,qsq,mA,mA,mbH))&
		-6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mh,mh,mz)+c11f(p1sq,p2sq,qsq,mh,mh,mz))&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mh,mbH,mz)+c11f(p1sq,p2sq,qsq,mh,mbH,mz))&
		-2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mh,mz)+c11f(p1sq,p2sq,qsq,mbH,mh,mz))&
		-2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mbH,mbH,mz)+c11f(p1sq,p2sq,qsq,mbH,mbH,mz))&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mA,mz,mh)+c11f(p1sq,p2sq,qsq,mA,mz,mh))&
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)**2*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mz,mA,mh)+c11f(p1sq,p2sq,qsq,mz,mA,mh))&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mA,mz,mbH)+c11f(p1sq,p2sq,qsq,mA,mz,mbH))&
		-lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mz,mA,mbH)+c11f(p1sq,p2sq,qsq,mz,mA,mbH))&
		+2.d0*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mz,mz,mh)+c11f(p1sq,p2sq,qsq,mz,mz,mh))&
		+2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_GGh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
			+c0f(p1sq,p2sq,qsq,mz,mz,mbH)+c11f(p1sq,p2sq,qsq,mz,mz,mbH))&
		+ii*(cw**2-sw**2)*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(&
			+c0f(p1sq,p2sq,qsq,mw,mch,mch)+c11f(p1sq,p2sq,qsq,mw,mch,mch))&
		-ii*(cw**2-sw**2)*lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(&
			+c0f(p1sq,p2sq,qsq,mw,mch,mch)+c11f(p1sq,p2sq,qsq,mw,mch,mch))&
		+ii*(cw**2-sw**2)*lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(&
			+c0f(p1sq,p2sq,qsq,mch,mw,mw)+c11f(p1sq,p2sq,qsq,mch,mw,mw))&
		-ii*(cw**2-sw**2)*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*(&
			+c0f(p1sq,p2sq,qsq,mch,mw,mw)+c11f(p1sq,p2sq,qsq,mch,mw,mw)))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSVV_AZS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CSVV_AZS=&
		+2.d0*b0f(p2sq,m2,m3)&
		-(3.d0*p1sq-p2sq+qsq)/2.d0*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(p1sq-qsq)*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		-2.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(-p1sq-2.d0*p2sq+qsq)/2.d0*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(p1sq-qsq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(p2sq+4.d0*m1**2)/2.d0*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CVSS_AZS(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: p1sq,p2sq,qsq,m1,m2,m3

	CVSS_AZS=&
		+(qsq+3.d0*p1sq-p2sq)*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq-p1sq)*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(3.d0*qsq+5.d0*p1sq-3.d0*p2sq+m1**2)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq-p1sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(2.d0*qsq+2.d0*p1sq-2.d0*p2sq+m1**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-------------------------------------------------------------
!     AZh renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function rGam_AZh_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_AZh_F=&
		+Gam_AZh_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+ii*mZ/vev*cos(beta-alpha)*(&
			+del_mZsq_F(alpha,beta,n)/(2.d0*mZ**2)&
			-del_v_F(alpha,beta,n)/vev&
			+del_ZZ_F(alpha,beta,n)/2.d0&
			+del_ZA_F(mA,alpha,beta,n)/2.d0&
			+del_Zh_F(alpha,beta,n)/2.d0&
			+tan(beta-alpha)*(&
				+del_CA_F(mch,mA,mbH,bmsq,alpha,beta,n)&
				-del_Ch_F(mbH,alpha,beta,n))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_AZh_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	rGam_AZh_B=&
		+Gam_AZh_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+ii*mZ/vev*cos(beta-alpha)*(&
			+del_mZsq_B(mch,mA,mbH,bmsq,alpha,beta)/(2.d0*mZ**2)&
			-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
			+del_ZZ_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0&
			+del_ZA_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0&
			+del_Zh_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0&
			+tan(beta-alpha)*(&
				+del_CA_B(mch,mA,mbH,bmsq,alpha,beta)&
				-del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
				+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_AZh(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_AZh = +rGam_AZh_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
				  +rGam_AZh_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!-------------------------------------------------------------
!     AZbH 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZbH_fermion(p1sq,p2sq,qsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mf
	integer, intent(in):: n
	double precision:: vf,af,If3,xiA,xibH

	if (mf == mt .or. mf == mc) then
		vf = vt; af = at; If3 = It
		xiA=xiu_A(alpha,beta,n); xibH=xiu_H(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then 
		vf = vb; af = ab; If3 = Ib
		xiA=xid_A(alpha,beta,n); xibH=xid_H(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve; af = ae; If3 = Ie
		xiA=xil_A(alpha,beta,n); xibH=xil_H(alpha,beta,n)
	endif

	Gam_AZbH_fermion=&
		ii*8.d0*If3*gz*af*mf**2*xiA*xibH/vev**2/(16.d0*pi**2)*(&
			+b0f(p2sq,mf,mf)+2.d0*mf**2*c0f(p1sq,p2sq,qsq,mf,mf,mf)&
			+p1sq*c11f(p1sq,p2sq,qsq,mf,mf,mf)&
			+(qsq-p1sq)*c12f(p1sq,p2sq,qsq,mf,mf,mf)&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZbH_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam_AZbH_F=&
		+Nc*Gam_AZbH_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
		+Nc*Gam_AZbH_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
		+Nc*Gam_AZbH_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc)&
		+Nc*Gam_AZbH_fermion(p1sq,p2sq,qsq,alpha,beta,n,ms)&
		+Gam_AZbH_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)&
		+Gam_AZbH_fermion(p1sq,p2sq,qsq,alpha,beta,n,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AZbH_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	Gam_AZbH_B=&
	ii/(16.d0*pi**2)*(&
	!SVV
	-g**3*cw*sin(beta-alpha)/2.d0*CSVV_AZS(p1sq,p2sq,qsq,mch,mW,mW)&
	!VSS
	+gz**3/8.d0*sin(beta-alpha)*(&
	-cos(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mA,mh)&
	-sin(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mA,mbH)&
	+cos(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mz,mh)&
	-cos(beta-alpha)**2*CVSS_AZS(p1sq,p2sq,qsq,mZ,mz,mbH)&
	+2.d0*cw**2*(cw**2-sw**2)*CVSS_AZS(p1sq,p2sq,qsq,mW,mch,mch))&
	!SV
	+gz**3*sin(beta-alpha)/8.d0*(&
	+b0f(qsq,mbH,mZ)-b1f(qsq,mbH,mZ)&
	+2.d0*sw**2*cw**2*(b0f(qsq,mch,mW)-b1f(qsq,mch,mW))&
	+b0f(p1sq,mA,mZ)-b1f(p1sq,mA,mZ)&
	+2.d0*sw**2*cw**2*(b0f(p1sq,mch,mW)-b1f(p1sq,mch,mW)))&
	!VVS
	+gz**3*mZ**2*sin(beta-alpha)*cos(beta-alpha)**2/4.d0*(&
	-c11f(p1sq,p2sq,qsq,mZ,mZ,mh)-2.d0*c0f(p1sq,p2sq,qsq,mZ,mZ,mh)&
	+c11f(p1sq,p2sq,qsq,mZ,mZ,mbH)+2.d0*c0f(p1sq,p2sq,qsq,mZ,mZ,mbH))&
	!SSV
	+gz**2*mZ/4.d0*(&
	+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mh,mh,mZ)-c11f(p1sq,p2sq,qsq,mh,mh,mZ))&
	+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*(&
		+c0f(p1sq,p2sq,qsq,mh,mbH,mZ)-c11f(p1sq,p2sq,qsq,mh,mbH,mZ))&
	-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*(&
		+c0f(p1sq,p2sq,qsq,mbH,mh,mZ)-c11f(p1sq,p2sq,qsq,mbH,mh,mZ))&
	-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mbH,mbH,mZ)-c11f(p1sq,p2sq,qsq,mbH,mbH,mZ))&
	+2.d0*sw**2*cw**2*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
		+c0f(p1sq,p2sq,qsq,mch,mw,mW)-c11f(p1sq,p2sq,qsq,mch,mw,mW)))&
	!SVS
	-gz**2*mZ/4.d0*(&
	+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*(&
		+c0f(p1sq,p2sq,qsq,mA,mZ,mh)-c11f(p1sq,p2sq,qsq,mA,mZ,mh))&
	+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mA,mZ,mbH)-c11f(p1sq,p2sq,qsq,mA,mZ,mbH))&
	-lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mz,mZ,mh)-c11f(p1sq,p2sq,qsq,mz,mZ,mh))&
	-lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*(&
		+c0f(p1sq,p2sq,qsq,mz,mZ,mbH)-c11f(p1sq,p2sq,qsq,mz,mZ,mbH))&
	-ii*sw**2*cw**2*lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mch,mW,mw)-c11f(p1sq,p2sq,qsq,mch,mW,mw))&
	+ii*sw**2*cw**2*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mch,mW,mw)-c11f(p1sq,p2sq,qsq,mch,mW,mw)))&
	!SSS
	+gz/2.d0*(&
	-4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mh,mh,mA)+c11f(p1sq,p2sq,qsq,mh,mh,mA))&
	+4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mh,mbH,mA)+c11f(p1sq,p2sq,qsq,mh,mbH,mA))&
	-4.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mbH,mh,mA)+c11f(p1sq,p2sq,qsq,mbH,mh,mA))&
	+12.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mbH,mbH,mA)+c11f(p1sq,p2sq,qsq,mbH,mbH,mA))&
	+4.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mA,mA,mh)+c11f(p1sq,p2sq,qsq,mA,mA,mh))&
	-4.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)**2*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mA,mA,mbH)+c11f(p1sq,p2sq,qsq,mA,mA,mbH))&
	-2.d0*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mh,mh,mz)+c11f(p1sq,p2sq,qsq,mh,mh,mz))&
	-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mh,mbH,mz)+c11f(p1sq,p2sq,qsq,mh,mbH,mz))&
	-2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mbH,mh,mz)+c11f(p1sq,p2sq,qsq,mbH,mh,mz))&
	-6.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mbH,mbH,mz)+c11f(p1sq,p2sq,qsq,mbH,mbH,mz))&
	+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mA,mz,mh)+c11f(p1sq,p2sq,qsq,mA,mz,mh))&
	+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mz,mA,mh)+c11f(p1sq,p2sq,qsq,mz,mA,mh))&
	+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mA,mz,mbH)+c11f(p1sq,p2sq,qsq,mA,mz,mbH))&
	-lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)**2*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mz,mA,mbH)+c11f(p1sq,p2sq,qsq,mz,mA,mbH))&
	+2.d0*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mz,mz,mh)+c11f(p1sq,p2sq,qsq,mz,mz,mh))&
	+2.d0*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_GGbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*(&
		+c0f(p1sq,p2sq,qsq,mz,mz,mbH)+c11f(p1sq,p2sq,qsq,mz,mz,mbH))&
	+ii*(cw**2-sw**2)*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
		+c0f(p1sq,p2sq,qsq,mw,mch,mch)+c11f(p1sq,p2sq,qsq,mw,mch,mch))&
	-ii*(cw**2-sw**2)*lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
		+c0f(p1sq,p2sq,qsq,mw,mch,mch)+c11f(p1sq,p2sq,qsq,mw,mch,mch))&
	+ii*(cw**2-sw**2)*lam_HmGpA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
		+c0f(p1sq,p2sq,qsq,mch,mw,mw)+c11f(p1sq,p2sq,qsq,mch,mw,mw))&
	-ii*(cw**2-sw**2)*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*(&
		+c0f(p1sq,p2sq,qsq,mch,mw,mw)+c11f(p1sq,p2sq,qsq,mch,mw,mw)))&
	)

	end function
!-------------------------------------------------------------
!     AZbH renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function rGam_AZbH_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_AZbH_F=&
		+Gam_AZbH_F(p1sq,p2sq,qsq,alpha,beta,n)&
		-ii*mZ/vev*sin(beta-alpha)*(&
			+del_mZsq_F(alpha,beta,n)/(2.d0*mZ**2)-del_v_F(alpha,beta,n)/vev&
			+(del_ZZ_F(alpha,beta,n)+del_ZA_F(mA,alpha,beta,n)+del_ZbH_F(mbH,alpha,beta,n))/2.d0&
			-1.d0/tan(beta-alpha)*(&
				+del_CA_F(mch,mA,mbH,bmsq,alpha,beta,n)&
				+del_Ch_F(mbH,alpha,beta,n)&
			)&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_AZbH_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	rGam_AZbH_B=&
		+Gam_AZbH_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		-ii*mZ/vev*sin(beta-alpha)*(&
			+del_mZsq_B(mch,mA,mbH,bmsq,alpha,beta)/(2.d0*mZ**2)&
			-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
			+del_ZZ_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0&
			+del_ZA_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0&
			+del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta)/2.d0&
			-1.d0/tan(beta-alpha)*(&
				+del_CA_B(mch,mA,mbH,bmsq,alpha,beta)&
				+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
				+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function rGam_AZbH(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_AZbH =  rGam_AZbH_F(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
				   +rGam_AZbH_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!-------------------------------------------------------------
!     AWW 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam3_AWW_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in)::n

	if (mu == mt .and. md == mb) then
		Gam3_AWW_fermion =&
			+ii/(16.d0*pi**2)*g**2*(&
				+2.d0*It*mu**2*xiu_A(alpha,beta,n)/vev*(&
					+c0f(p1sq,p2sq,qsq,mu,md,mu)&
					+c11f(p1sq,p2sq,qsq,mu,md,mu)&
					-c12f(p1sq,p2sq,qsq,mu,md,mu)&
				)&
				+2.d0*Ib*md**2*xid_A(alpha,beta,n)/vev*(&
					+c0f(p1sq,p2sq,qsq,md,mu,md)&
					+c11f(p1sq,p2sq,qsq,md,mu,md)&
					-c12f(p1sq,p2sq,qsq,md,mu,md)&
				)&
			)
	elseif (mu == m0 .and. md == mtau) then 
		Gam3_AWW_fermion =&
			+ii/(16.d0*pi**2)*g**2*(&
				+2.d0*Ie*md**2*xil_A(alpha,beta,n)/vev*(&
					+c0f(p1sq,p2sq,qsq,md,mu,md)&
					+c11f(p1sq,p2sq,qsq,md,mu,md)&
					-c12f(p1sq,p2sq,qsq,md,mu,md)&
				)&
			)
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam3_AWW(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam3_AWW=&
		+Nc*Gam3_AWW_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Gam3_AWW_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mtau)

	end function
!-------------------------------------------------------------
!     AZZ 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam3_AZZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mf
	integer, intent(in)::n
	double precision:: vf,af,If3,xiA

	if (mf == mt .or. mf == mc) then
		vf = vt; af = at; If3 = It
		xiA=xiu_A(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then 
		vf = vb; af = ab; If3 = Ib
		xiA=xid_A(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve; af = ae; If3 = Ie
		xiA=xil_A(alpha,beta,n)
	endif

	Gam3_AZZ_fermion =&
		+ii/(16.d0*pi**2)*gz**2&
			*2.d0*If3*8.d0*mf**2*xiA/vev*(&
				+vf**2*c0f(p1sq,p2sq,qsq,mf,mf,mf)&
				+af**2*(&
					+c0f(p1sq,p2sq,qsq,mf,mf,mf)&
					+2.d0*c11f(p1sq,p2sq,qsq,mf,mf,mf)&
					-2.d0*c12f(p1sq,p2sq,qsq,mf,mf,mf)&
				)&
			)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam3_AZZ(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam3_AZZ=&
		+Nc*Gam3_AZZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
		+Nc*Gam3_AZZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
		+Gam3_AZZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)

	end function
!-------------------------------------------------------------
!     AZgam 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam3_AZgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mf
	integer, intent(in)::n
	double precision:: vf,af,If3,Qf,xiA

	if (mf == mt .or. mf == mc) then
		vf = vt; af = at; If3 = It; Qf=Qt
		xiA=xiu_A(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then 
		vf = vb; af = ab; If3 = Ib; Qf=Qb
		xiA=xid_A(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then 
		vf = ve; af = ae; If3 = Ie; Qf=Qe
		xiA=xil_A(alpha,beta,n)
	endif

	Gam3_AZgam_fermion =&
		+ii/(16.d0*pi**2)*(2.d0*If3)*Qf*(g*sw)*gz*(8.d0*mf**2*xiA/vev)&
		*vf*c0f(p1sq,p2sq,qsq,mf,mf,mf)

	end function
!-------------------------------------------------------------
!     Agamgam 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam3_Agamgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mf)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mf
	integer, intent(in)::n
	double precision:: If3,Qf,xiA

	if (mf == mt .or. mf == mc) then
		If3 = It; Qf=Qt
		xiA=xiu_A(alpha,beta,n)
	elseif (mf == mb .or. mf == ms) then 
		If3 = Ib; Qf=Qb
		xiA=xid_A(alpha,beta,n)
	elseif (mf == mtau .or. mf == mmu) then 
		If3 = Ie; Qf=Qe
		xiA=xil_A(alpha,beta,n)
	endif

	Gam3_Agamgam_fermion =&
		+ii/(16.d0*pi**2)*(2.d0*If3)*Qf**2*(g*sw)**2*(8.d0*mf**2*xiA/vev)*(&
			+c0f(p1sq,p2sq,qsq,mf,mf,mf)&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam3_Agamgam(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam3_Agamgam=&
		+Nc*Gam3_Agamgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt)&
		+Nc*Gam3_Agamgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mb)&
		+Gam3_Agamgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mtau)

	end function
!#########################################################
!#
!#     Decay of charged scalar : H±
!#
!#########################################################
!======================================================
!     Partial decay width (Fermionic decay)
!======================================================
	double precision function Gam_chtb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mt+mb) then
		Gam_chtb = decay_chtb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mch .ge. mw) then
		Gam_chtb = decay_chtstarb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chtb = 0.d0
	endif

	if (Gam_chtb < 0.d0) then
		write(*,*) 'Gam_chtb is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mt+ms) then
		Gam_chts = decay_chts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mch .ge. mw) then
		Gam_chts = decay_chtstars(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chts = 0.d0
	endif

	if (Gam_chts < 0.d0) then
		write(*,*) 'Gam_chts is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chtd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mt+md) then
		Gam_chtd = decay_chtd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else if(mch .ge. mw) then
		Gam_chtd = decay_chtstard(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chtd = 0.d0
	endif

	if (Gam_chtd < 0.d0) then
		write(*,*) 'Gam_chtd is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chcb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mc+mb) then
		Gam_chcb = decay_chcb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chcb = 0.d0
	endif

	if (Gam_chcb < 0.d0) then
		write(*,*) 'Gam_chcb is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chcs(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mc+ms) then
		Gam_chcs = decay_chcs(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chcs = 0.d0
	endif

	if (Gam_chcs < 0.d0) then
		write(*,*) 'Gam_chcs is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chcd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mc+md) then
		Gam_chcd = decay_chcd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chcd = 0.d0
	endif

	if (Gam_chcd < 0.d0) then
		write(*,*) 'Gam_chcd is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chub(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mup+mb) then
		Gam_chub = decay_chub(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chub = 0.d0
	endif

	if (Gam_chub < 0.d0) then
		write(*,*) 'Gam_chub is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chus(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mup+ms) then
		Gam_chus = decay_chus(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chus = 0.d0
	endif

	if (Gam_chus < 0.d0) then
		write(*,*) 'Gam_chus is negative'
	endif

	end function
!--------------------------------------------------------------------------
	double precision function Gam_chlnu(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD,mf)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mf
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(2.d0*mf < mA) then
		if(mf == mtau) then
			Gam_chlnu = decay_chtaunu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
		else if(mf == mmu) then
			Gam_chlnu = decay_chmunu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
		else if(mf == me) then
			Gam_chlnu = decay_chenu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
		endif
	else
		Gam_chlnu = 0.d0
	endif

	if (Gam_chlnu < 0.d0) then
		write(*,*) 'Gam_chlnu is negative'
	endif

	end function
!====================================================
!     Partial decay width (Bosonic decay)
!====================================================
	double precision function Gam_chWh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mw+mh) then
		Gam_chwh = decay_chwh(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	else if(mch .gt. mh) then
		Gam_chwh = decay_chwstarh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chwh = 0.d0
	endif

	if (Gam_chwh < 0.d0) then
		write(*,*) 'Gam_chwh is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chwbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mw+mbH) then
		Gam_chwbH = decay_chwbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	else if(mch .gt. mbH) then
		Gam_chwbH = decay_chwstarbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chwbH = 0.d0
	endif

	if (Gam_chwbH < 0.d0) then
		write(*,*) 'Gam_chwbH is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chwA(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mw+mA) then
		Gam_chwA = decay_chwA(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	else if(mch .gt. mA) then
		Gam_chwA = decay_chwstarA(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	else
		Gam_chwA = 0.d0
	endif

	if (Gam_chwA < 0.d0) then
		write(*,*) 'Gam_chwA is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chWZ(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mW+mZ) then
		Gam_chWZ = decay_chWZ(mch,mA,mbH,bmsq,alpha,beta,n)
	else
		Gam_chWZ = 0.d0
	endif

	if (Gam_chWZ < 0.d0) then
		write(*,*) 'Gam_chWZ is negative'
	endif

	end function
!-------------------------------------------------------------------
	double precision function Gam_chWgam(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD

	if(mch .ge. mW) then
		Gam_chWgam = decay_chWgam(mch,mA,mbH,bmsq,alpha,beta,n)
	else
		Gam_chWgam = 0.d0
	endif

	if (Gam_chWgam < 0.d0) then
		write(*,*) 'Gam_chWgam is negative'
	endif

	end function
!=====================================================
!     Two body functions (Fermionic decay)
!=====================================================
	double precision function decay_chtb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xt,xb,mfp,mfm
	double precision:: Csch,Cpch,CL,CR
	double precision:: Gam_S,Gam_P
	double precision:: Gam_S_pole,Gam_P_pole
	double precision:: Gam_S_MSbar,Gam_P_MSbar
	double precision:: GamGp_S,GamGp_P
	complex (kind(0d0)):: Gam_S_NLO,Gam_P_NLO
	double precision:: mu,nf,lam_QCD,rmt,rmb
	double precision:: R
	double precision:: Gam_LO,Gam_LO_pole,Gam_LO_MSbar
	double precision:: QCD_pole,QCD_MSbar
	double precision:: Gam_QCD
	double precision:: Gam_EWNLO_pole,Gam_EWNLO_MSbar,Gam_EWNLO
	p1sq=mb**2; p2sq=mt**2; qsq=mch**2; mu=mch
	xt=mt/mch; xb=mb/mch
	mfp = mt; mfm = mb

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	rmt= mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	rmb= mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	Gam_S_pole = (mt*xiu_A(alpha,beta,n)-mb*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_pole = -(mt*xiu_A(alpha,beta,n)+mb*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	Gam_S_MSbar = (rmt*xiu_A(alpha,beta,n)-rmb*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_MSbar = -(rmt*xiu_A(alpha,beta,n)+rmb*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	!===================
	!     LO
	!===================
	Gam_LO_pole =&
		Nc*mch/8.d0/pi*Vtb**2*sqrt(llambda(1.d0,xt**2,xb**2))&
		*((1.d0-(xt+xb)**2)*Gam_S_pole**2+(1.d0-(xt-xb)**2)*Gam_P_pole**2)

	Gam_LO_MSbar =&
		Nc*mch/8.d0/pi*Vtb**2*sqrt(llambda(1.d0,xt**2,xb**2))&
		*((1.d0-(xt+xb)**2)*Gam_S_Msbar**2+(1.d0-(xt-xb)**2)*Gam_P_MSbar**2)

	!----- Interpolation -----
	R=(mt+mb)/mch
	Gam_LO = R**2*Gam_LO_pole+(1.d0-R**2)*Gam_LO_MSbar

	if(OREW==0 .and. ORQCD==-1) then
		decay_chtb = Gam_LO_pole
		return
	else if(OREW==0 .and. ORQCD==0) then
		decay_chtb = Gam_LO
		return
	endif

	!=========================
	!     QCD corrections
	!=========================
	if(ORQCD /= 0) then
		!----- NLO on-shell -----
		QCD_pole=&
			Nc*mch/(8.d0*pi)*Vtb**2&
			*sqrt(llambda(1.d0,xt**2,xb**2))*(&
				(1.d0-xt**2-xb**2)*(&
					(mt/vev*xiu_A(alpha,beta,n))**2&
					*alphas(lam_QCD,mu,nf)/pi*CF*deltaHpm_qcd(xt**2,xb**2,1)&
					+(mb/vev*xid_A(alpha,beta,n))**2&
					*alphas(lam_QCD,mu,nf)/pi*CF*deltaHpm_qcd(xb**2,xt**2,1)&
				)&
				+4.d0*(mt*mb/vev**2)*xt*xb*xid_A(alpha,beta,n)*xiu_A(alpha,beta,n)&
				*alphas(lam_QCD,mu,nf)/pi*CF*deltaHpm_qcd(xt**2,xb**2,-1)&
			)*S_NLOQCD

		!----- NLO MS_bar -----
		Csch = (rmb*xid_A(alpha,beta,n)-rmt*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)
		Cpch = (rmb*xid_A(alpha,beta,n)+rmt*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)

		QCD_MSbar =&
			Nc*mch/(8.d0*pi)*Vtb**2&
			*sqrt(llambda(1.d0,xt**2,xb**2))&
			*((1.d0-(xt+xb)**2)*Csch**2+(1.d0-(xt-xb)**2)*Cpch**2)*(&
				+alphas(lam_QCD,mch,nf)/pi*CF*(17.d0/4.d0)*S_NLOQCD&
				+(alphas(lam_QCD,mch,nf)/pi)**2*(35.94d0-1.36d0*nf)*S_NNLOQCD&
			)

		!----- Interpolation -----
		R=(mt+mb)/mch
		Gam_QCD = R**2*QCD_pole+(1.d0-R**2)*QCD_MSbar

		if(OREW==0) then
			decay_chtb = Gam_LO+Gam_QCD
			return
		endif
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S = (mt*xiu_A(alpha,beta,n)-mb*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
		Gam_P = -(mt*xiu_A(alpha,beta,n)+mb*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
		CL = Gam_S-Gam_P; CR = Gam_S+Gam_P
		GamGp_S = (mt-mb)/(vev*sqrt(2.d0))
		GamGp_P = -(mt+mb)/(vev*sqrt(2.d0))

		Gam_S_NLO =&
			rGam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+mfm*Gam_Hpffp_V1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfp*Gam_Hpffp_V2(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfp**2-mfm**2+mfp*mfm)*Gam_Hpffp_T(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
		Gam_P_NLO =&
			rGam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfm*Gam_Hpffp_A1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfp*Gam_Hpffp_A2(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfp**2-mfm**2-mfp*mfm)*Gam_Hpffp_PT(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)

		Gam_S_NLO =&
			Gam_S_NLO&
			-GamGp_S*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_S*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0
		Gam_P_NLO =&
			Gam_P_NLO&
			-GamGp_P*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_P*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		Gam_EWNLO =&
			Nc*mch/8.d0/pi*sqrt(llambda(1.d0,xt**2,xb**2))*(&
				+(1.d0-(xt+xb)**2)*(2.d0*dble(Gam_S*Gam_S_NLO))&
				+(1.d0-(xt-xb)**2)*(2.d0*dble(Gam_P*Gam_P_NLO))&
			)

		!===== QED NLO =====
		Gam_EWNLO_pole  = Gam_EWNLO+decay_ch_udgam(mch,mA,mbH,bmsq,alpha,beta,n,mt,mb)

		Gam_EWNLO_MSbar = Gam_LO_MSbar/Gam_LO_pole*Gam_EWNLO_pole

		!----- Interpolation -----
		Gam_EWNLO = R**2*Gam_EWNLO_pole+(1.d0-R**2)*Gam_EWNLO_MSbar

		if(ORQCD == -1) then
			decay_chtb = Gam_LO_pole+Gam_EWNLO
			return
		else if(ORQCD == 0) then
			decay_chtb = Gam_LO+Gam_EWNLO
			return
		else if(1 <= ORQCD) then
			decay_chtb = Gam_LO+Gam_EWNLO+Gam_QCD
			return
		endif
	endif

	end function
!-------------------------------------------------------------------
	double precision function decay_chts(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xt,xs,mfp,mfm
	double precision:: Csch,Cpch,CL,CR
	double precision:: Gam_S,Gam_P
	double precision:: Gam_S_pole,Gam_P_pole
	double precision:: Gam_S_MSbar,Gam_P_MSbar
	double precision:: GamGp_S,GamGp_P
	complex (kind(0d0)):: Gam_S_NLO,Gam_P_NLO
	double precision:: mu,nf,lam_QCD,rmt,rms
	double precision:: R
	double precision:: Gam_LO,Gam_LO_pole,Gam_LO_MSbar
	double precision:: QCD_pole,QCD_MSbar
	double precision:: Gam_QCD
	double precision:: Gam_EWNLO
	mfp = mt; mfm = ms
	p1sq=mfp**2; p2sq=mfm**2; qsq=mch**2; mu=mch
	xt=mfp/mch; xs=mfm/mch

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	if(ms==0.d0) then
		rms = 0.d0
	else
		rms = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD3,ms,3.d0),ms_MS)
	endif

	Gam_S_pole = (mt*xiu_A(alpha,beta,n)-ms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_pole = -(mt*xiu_A(alpha,beta,n)+ms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	Gam_S_MSbar = (rmt*xiu_A(alpha,beta,n)-rms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_MSbar = -(rmt*xiu_A(alpha,beta,n)+rms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	!===================
	!     LO
	!===================
	Gam_LO_pole = Nc*mch/8.d0/pi*Vts**2*sqrt(llambda(1.d0,xt**2,xs**2))&
		*((1.d0-(xt+xs)**2)*Gam_S_pole**2+(1.d0-(xt-xs)**2)*Gam_P_pole**2)

	Gam_LO_MSbar = Nc*mch/8.d0/pi*Vts**2*sqrt(llambda(1.d0,xt**2,xs**2))&
		*((1.d0-(xt+xs)**2)*Gam_S_MSbar**2+(1.d0-(xt-xs)**2)*Gam_P_MSbar**2)

	!----- Interpolation -----
	R=(mt+ms)/mch
	Gam_LO = R**2*Gam_LO_pole+(1.d0-R**2)*Gam_LO_MSbar

	if(OREW==0 .and. ORQCD==-1) then
		decay_chts=Gam_LO_pole
		return
	else if(OREW==0 .and. ORQCD==0) then
		decay_chts=Gam_LO
		return	
	endif

	!=========================
	!     QCD corrections
	!=========================
	if(ORQCD /= 0) then
		!----- NLO on-shell -----
		QCD_pole = Nc*mch/(8.d0*pi)*Vts**2&
			*(1.d0-xt**2)**2&
			*(mt/vev*xiu_A(alpha,beta,n))**2&
			*alphas(lam_QCD,mu,nf)/pi*CF*deltaHpm_qcd(xt**2,0.d0,1)*S_NLOQCD

		!----- NLO MS_bar -----
		Csch=(rms*xid_A(alpha,beta,n)-rmt*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)
		Cpch=(rms*xid_A(alpha,beta,n)+rmt*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)

		QCD_MSbar = Nc*mch/(8.d0*pi)*Vts**2&
			*(1.d0+xt**4+xs**4-2.d0*xt**2-2.d0*xs**2-2.d0*xt**2*xs**2)**(1.d0/2.d0)&
			*((1.d0-(xt+xs)**2)*Csch**2+(1.d0-(xt-xs)**2)*Cpch**2)*(&
				alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0)*S_NLOQCD&
			)

		if(ORQCD == 2) then
			QCD_MSbar = QCD_MSbar&
				+Nc*mch/(8.d0*pi)*Vts**2&
				*(1.d0+xt**4+xs**4-2.d0*xt**2-2.d0*xs**2-2.d0*xt**2*xs**2)**(1.d0/2.d0)&
				*((1.d0-(xt+xs)**2)*Csch**2+(1.d0-(xt-xs)**2)*Cpch**2)*(&
					(alphas(lam_QCD,mu,nf)/pi)**2*(35.94d0-1.36d0*nf)*S_NNLOQCD&
				)
		endif

		!----- Interpolation -----
		R=(mt+ms)/mch
		Gam_QCD = R**2*QCD_pole+(1.d0-R**2)*QCD_MSbar

		if(OREW==0) then
			decay_chts=Gam_LO+Gam_QCD
			return
		endif
	endif

	if(OREW == 1) then
		Gam_EWNLO = 0.d0

		if(ORQCD == 0) then
			decay_chts = Gam_LO+Gam_EWNLO
			return
		else if(1 <= ORQCD) then
			decay_chts = Gam_LO+Gam_EWNLO+Gam_QCD
			return
		endif
	endif

	end function
!-------------------------------------------------------------------
	double precision function decay_chtd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xt,xd,mfp,mfm
	double precision:: Csch,Cpch,CL,CR
	double precision:: Gam_S,Gam_P
	double precision:: Gam_S_pole,Gam_P_pole
	double precision:: Gam_S_MSbar,Gam_P_MSbar
	double precision:: GamGp_S,GamGp_P
	complex (kind(0d0)):: Gam_S_NLO,Gam_P_NLO
	double precision:: mu,nf,lam_QCD,rmt,rmd
	double precision:: R
	double precision:: Gam_LO,Gam_LO_pole,Gam_LO_MSbar
	double precision:: QCD_pole,QCD_MSbar
	double precision:: Gam_QCD
	double precision:: Gam_EWNLO
	mfp = mt; mfm = md
	p1sq=mfp**2; p2sq=mfm**2; qsq=mch**2; mu=mch
	xt=mfp/mch; xd=mfm/mch

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD6,mt,6.d0),mt_MS)
	rmd = 0.d0

	Gam_S_pole = (mt*xiu_A(alpha,beta,n)-md*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_pole = -(mt*xiu_A(alpha,beta,n)+md*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	Gam_S_MSbar = (rmt*xiu_A(alpha,beta,n)-rmd*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_MSbar = -(rmt*xiu_A(alpha,beta,n)+rmd*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	!===================
	!     LO
	!===================
	Gam_LO_pole = Nc*mch/8.d0/pi*Vtd**2*sqrt(llambda(1.d0,xt**2,xd**2))&
		*((1.d0-(xt+xd)**2)*Gam_S_pole**2+(1.d0-(xt-xd)**2)*Gam_P_pole**2)

	Gam_LO_MSbar = Nc*mch/8.d0/pi*Vtd**2*sqrt(llambda(1.d0,xt**2,xd**2))&
		*((1.d0-(xt+xd)**2)*Gam_S_Msbar**2+(1.d0-(xt-xd)**2)*Gam_P_MSbar**2)

	!----- Interpolation -----
	R=(mt+md)/mch
	Gam_LO = R**2*Gam_LO_pole+(1.d0-R**2)*Gam_LO_MSbar

	if(OREW==0 .and. ORQCD==0) then
		decay_chtd=Gam_LO
		return
	endif

	!=========================
	!     QCD corrections
	!=========================
	if(ORQCD /= 0) then
		!----- NLO on-shell -----
		QCD_pole= Nc*mch/(8.d0*pi)*Vtd**2&
			*(1.d0-xt**2)**2&
			*(mt/vev*xiu_A(alpha,beta,n))**2&
			*alphas(lam_QCD,mu,nf)/pi*CF*deltaHpm_qcd(xt**2,0.d0,1)*S_NLOQCD

		!----- NLO MS_bar -----
		Csch=(rmd*xid_A(alpha,beta,n)-rmt*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)
		Cpch=(rmd*xid_A(alpha,beta,n)+rmt*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)

		QCD_MSbar= Nc*mch/(8.d0*pi)*Vtd**2&
			*(1.d0+xt**4+xd**4-2.d0*xt**2-2.d0*xd**2-2.d0*xt**2*xd**2)**(1.d0/2.d0)&
			*((1.d0-(xt+xd)**2)*Csch**2+(1.d0-(xt-xd)**2)*Cpch**2)*(&
				alphas(lam_QCD,mu,nf)/pi*CF*(17.d0/4.d0)*S_NLOQCD&
			)

		if(ORQCD == 2) then
			QCD_MSbar = QCD_MSbar&
				+Nc*mch/(8.d0*pi)*Vtd**2&
				*(1.d0+xt**4+xd**4-2.d0*xt**2-2.d0*xd**2-2.d0*xt**2*xd**2)**(1.d0/2.d0)&
				*((1.d0-(xt+xd)**2)*Csch**2+(1.d0-(xt-xd)**2)*Cpch**2)*(&
					(alphas(lam_QCD,mu,nf)/pi)**2*(35.94d0-1.36d0*nf)*S_NNLOQCD&
				)
		endif
	
		!----- Interpolation -----
		R=(mt+md)/mch
		Gam_QCD = R**2*QCD_pole+(1.d0-R**2)*QCD_MSbar

		if(OREW==0) then
			decay_chtd=Gam_LO+Gam_QCD
			return
		endif
	endif

	if(OREW == 1) then
		Gam_EWNLO = 0.d0

		if(ORQCD == 0) then
			decay_chtd = Gam_LO+Gam_EWNLO
			return
		else if(1 <= ORQCD) then
			decay_chtd = Gam_LO+Gam_EWNLO+Gam_QCD
			return
		endif
	endif

	end function
!-------------------------------------------------------------------
	double precision function decay_chcb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xc,xb,Csch,Cpch
	double precision:: mu,nf,lam_QCD,rmb,rmc
	p1sq=mc**2; p2sq=mb**2; qsq=mch**2; mu = mch

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)
	rmc = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD4,mc,4.d0),mc_MS)

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	xc = mc/mch
	xb = mb/mch
	Csch = ((mb+S_RMSM*(rmb-mb))*xid_A(alpha,beta,n)&
			-(mc+S_RMSM*(rmc-mc))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Cpch = ((mb+S_RMSM*(rmb-mb))*xid_A(alpha,beta,n)&
			+(mc+S_RMSM*(rmc-mc))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))

	decay_chcb =&
	Nc*mch/8.d0/pi*Vcb**2&
	*(1.d0+xc**4+xb**4-2.d0*xc**2-2.d0*xb**2-2.d0*xc**2*xb**2)**(1.d0/2.d0)&
	*((1.d0-(xc+xb)**2)*Csch**2+(1.d0-(xc-xb)**2)*Cpch**2)&
	*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&
		! NLO  QCD correction
		+alphas(lam_QCD,mch,nf)/pi*CF*(17.d0/4.d0)*S_NLOQCD&
		! NNLO  QCD correction
		+(alphas(lam_QCD,mch,nf)/pi)**2*(35.94d0-1.36d0*nf)*S_NNLOQCD&
	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chcs(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xc,xs,mfp,mfm
	double precision:: Gam_S,Gam_P
	double precision:: Gam_S_pole,Gam_P_pole
	double precision:: Gam_S_MSbar,Gam_P_MSbar
	complex (kind(0d0)):: Gam_S_NLO,Gam_P_NLO
	double precision:: GamGp_S,GamGp_P
	double precision:: mu,nf,lam_QCD,rms,rmc
	double precision:: CL,CR
	double precision:: Gam_LO,Gam_LO_pole,Gam_LO_MSbar
	double precision:: Gam_QCDNLO,Gam_QCDNNLO,Gam_EWNLO
	p1sq = ms**2; p2sq = mc**2; qsq = mch**2; mu = mch
	mfp = mc; mfm = ms
	xc = mc/mch; xs = ms/mch

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	rmc = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD4,mc,4.d0),mc_MS)
	if(ms==0.d0) then
		rms = 0.d0
	else
		rms = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD3,ms,3.d0),ms_MS)
	endif

	Gam_S_pole = (mc*xiu_A(alpha,beta,n)-ms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_pole = -(mc*xiu_A(alpha,beta,n)+ms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	Gam_S_MSbar = (rmc*xiu_A(alpha,beta,n)-rms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Gam_P_MSbar = -(rmc*xiu_A(alpha,beta,n)+rms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))

	!===================
	!     LO
	!===================
	Gam_LO_pole =&
		Nc*mch/8.d0/pi*Vcs**2*sqrt(llambda(1.d0,xc**2,xs**2))&
		*((1.d0-(xc+xs)**2)*abs(Gam_S_pole)**2+(1.d0-(xc-xs)**2)*abs(Gam_P_pole)**2)

	Gam_LO_MSbar =&
		Nc*mch/8.d0/pi*Vcs**2*sqrt(llambda(1.d0,xc**2,xs**2))&
		*((1.d0-(xc+xs)**2)*abs(Gam_S_MSbar)**2+(1.d0-(xc-xs)**2)*abs(Gam_P_MSbar)**2)

	if(OREW == 0 .and. ORQCD == -1) then
		decay_chcs = Gam_LO_pole
		return
	else if(OREW == 0 .and. ORQCD == 0) then
		decay_chcs = Gam_LO_MSbar
		return
	endif
	
	!=========================
	!     QCD corrections
	!=========================
	if(ORQCD /= 0) then
		!----- NLO MS_bar -----
		Gam_QCDNLO = Gam_LO_MSbar*(alphas(lam_QCD,mch,nf)/pi*CF*(17.d0/4.d0))
		if(OREW == 0 .and. ORQCD == 1) then
			decay_chcs = Gam_LO_MSbar+Gam_QCDNLO
			return
		endif
		!----- NNLO MS_bar -----
		Gam_QCDNNLO = Gam_LO_MSbar*(alphas(lam_QCD,mch,nf)/pi)**2*(35.94d0-1.36d0*nf)
		if(OREW == 0 .and. ORQCD == 2) then
			decay_chcs = Gam_LO_MSbar+Gam_QCDNLO+Gam_QCDNNLO
			return
		endif
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S = (mc*xiu_A(alpha,beta,n)-ms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
		Gam_P = -(mc*xiu_A(alpha,beta,n)+ms*xid_A(alpha,beta,n))/(vev*sqrt(2.d0))
		CL = Gam_S-Gam_P; CR = Gam_S+Gam_P
		GamGp_S = (mc-ms)/(vev*sqrt(2.d0))
		GamGp_P = -(mc+ms)/(vev*sqrt(2.d0))

		Gam_S_NLO =&
			rGam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+mfm*Gam_Hpffp_V1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfp*Gam_Hpffp_V2(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfp**2-mfm**2+mfp*mfm)*Gam_Hpffp_T(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
		Gam_P_NLO =&
			rGam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfm*Gam_Hpffp_A1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfp*Gam_Hpffp_A2(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfp**2-mfm**2-mfp*mfm)*Gam_Hpffp_PT(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)

		Gam_S_NLO =&
			Gam_S_NLO-GamGp_S*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_S*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0
		Gam_P_NLO =&
			Gam_P_NLO-GamGp_P*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_P*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		Gam_EWNLO =&
			Nc*mch/8.d0/pi*sqrt(llambda(1.d0,xc**2,xs**2))*(&
				(1.d0-(xc+xs)**2)*2.d0*dble(Gam_S*Gam_S_NLO)&
				+(1.d0-(xc-xs)**2)*2.d0*dble(Gam_P*Gam_P_NLO)&
			)

		!===== QED NLO =====
		Gam_EWNLO = Gam_EWNLO+decay_ch_udgam(mch,mA,mbH,bmsq,alpha,beta,n,mfp,mfm)

		if(ORQCD == 0) then
			decay_chcs = Gam_LO_pole+Gam_EWNLO
			return
		else if(ORQCD == 1) then
			decay_chcs = Gam_LO_MSbar+Gam_LO_MSbar/Gam_LO_pole*Gam_EWNLO+Gam_QCDNLO
			return
		else if(ORQCD == 2) then
			decay_chcs = Gam_LO_MSbar+Gam_LO_MSbar/Gam_LO_pole*Gam_EWNLO+Gam_QCDNLO+Gam_QCDNNLO
			return
		endif
	endif

	end function
!-------------------------------------------------------------------
	double precision function decay_chcd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xc,xd,Csch,Cpch
	double precision:: mu,nf,lam_QCD,rmd,rmc
	p1sq=mc**2; p2sq=md**2; qsq=mch**2; mu = mch

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	rmc = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD4,mc,4.d0),mc_MS)
	rmd = 0.d0

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	xc = mc/mch
	xd = md/mch

	Csch = ((md+S_RMSM*(rmd-md))*xid_A(alpha,beta,n)&
			-(mc+S_RMSM*(rmc-mc))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Cpch = ((md+S_RMSM*(rmd-md))*xid_A(alpha,beta,n)&
			+(mc+S_RMSM*(rmc-mc))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))

	decay_chcd =&
	Nc*mch/8.d0/pi*Vcd**2&
	*(1.d0+xc**4+xd**4-2.d0*xc**2-2.d0*xd**2-2.d0*xc**2*xd**2)**(1.d0/2.d0)&
	*((1.d0-(xc+xd)**2)*Csch**2+(1.d0-(xc-xd)**2)*Cpch**2)&
	*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!   *S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&           
		! NLO  QCD correction
		+alphas(lam_QCD,mch,nf)/pi*CF*(17.d0/4.d0)*S_NLOQCD&
		! NNLO  QCD correction
		+(alphas(lam_QCD,mch,nf)/pi)**2*(35.94d0-1.36d0*nf)*S_NNLOQCD&
 	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chub(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xu,xb,Csch,Cpch
	double precision:: mu,nf,lam_QCD,rmb,rmu
	p1sq=mup**2; p2sq=mb**2; qsq=mch**2; mu = mch

	if(mt < mu) then
		nf=6.d0; lam_QCD=lam_QCD6
	else if(mu <= mt) then
		nf=5.d0; lam_QCD=lam_QCD5
	endif

	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)
	rmu = 0.d0

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	xu = mup/mch
	xb = mb/mch
	Csch = ((mb+S_RMSM*(rmb-mb))*xid_A(alpha,beta,n)&
			-(mup+S_RMSM*(rmu-mup))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Cpch = ((mb+S_RMSM*(rmb-mb))*xid_A(alpha,beta,n)&
			+(mup+S_RMSM*(rmu-mup))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))

	decay_chub=nc*mch/8.d0/pi*Vub**2&
	*(1.d0+xu**4+xb**4-2.d0*xu**2-2.d0*xb**2-2.d0*xu**2*xb**2)**(1.d0/2.d0)&
	*((1.d0-(xu+xb)**2)*Csch**2+(1.d0-(xu-xb)**2)*Cpch**2)&
	*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&           
		! NLO  QCD correction
		+alphas(lam_QCD,mch,nf)/pi*CF*(17.d0/4.d0)*S_NLOQCD&
		! NNLO  QCD correction
		+(alphas(lam_QCD,mch,nf)/pi)**2*(35.94d0-1.36d0*nf)*S_NNLOQCD&
	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chus(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,xu,xs,Csch,Cpch
	double precision:: mu,nf,lam_QCD,rms,rmu
	p1sq=mup**2; p2sq=ms**2; qsq=mch**2; mu = mch

	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif

	if(ms==0.d0) then
		rms = 0.d0
	else
		rms = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD3,ms,3.d0),ms_MS)
	endif
	rmu = 0.d0

	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	xu = mup/mch
	xs = ms/mch
	Csch = ((ms+S_RMSM*(rms-ms))*xid_A(alpha,beta,n)&
			-(mup+S_RMSM*(rmu-mup))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))
	Cpch = ((ms+S_RMSM*(rms-ms))*xid_A(alpha,beta,n)&
			+(mup+S_RMSM*(rmu-mup))*xiu_A(alpha,beta,n))/(vev*sqrt(2.d0))

	decay_chus=nc*mch/8.d0/pi*Vus**2&
	*(1.d0+xu**4+xs**4-2.d0*xu**2-2.d0*xs**2-2.d0*xu**2*xs**2)**(1.d0/2.d0)&
	*((1.d0-(xu+xs)**2)*Csch**2+(1.d0-(xu-xs)**2)*Cpch**2)&
	*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&           
		! NLO  QCD correction
		+alphas(lam_QCD,mch,nf)/pi*CF*(17.d0/4.d0)*S_NLOQCD&
		! NNLO  QCD correction
		+(alphas(lam_QCD,mch,nf)/pi)**2*(35.94d0-1.36d0*nf)*S_NNLOQCD&
	)

	end function
!-------------------------------------------------------------------------
	double precision function decay_ch_udgam(mch,mA,mbH,bmsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Gam_L,Gam_R

	Gam_L = sqrt(2.d0)*mfp*xiu_A(alpha,beta,n)/vev
	Gam_R = -sqrt(2.d0)*mfm*xid_A(alpha,beta,n)/vev

	decay_ch_udgam =&
		Nc*alpha_em/(16.d0*pi**2*mch)*(&
			(abs(Gam_L)**2+abs(Gam_R)**2)*(&
				OmegaLL_00(mch,mfp,mfm)+Qt**2*OmegaLL_11(mch,mfp,mfm)+Qb**2*OmegaLL_22(mch,mfp,mfm)&
				+Qt*OmegaLL_01(mch,mfp,mfm)+Qb*OmegaLL_02(mch,mfp,mfm)+Qt*Qb*OmegaLL_12(mch,mfp,mfm)&
			)&
			+(Gam_L*Gam_R+Gam_L*Gam_R)*(&
				OmegaLR_00(mch,mfp,mfm)+Qt**2*OmegaLR_11(mch,mfp,mfm)+Qb**2*OmegaLR_22(mch,mfp,mfm)&
				+Qt*OmegaLR_01(mch,mfp,mfm)+Qb*OmegaLR_02(mch,mfp,mfm)+Qt*Qb*OmegaLR_12(mch,mfp,mfm)&
			)&
		)

	end function
!-------------------------------------------------------------------------  
	double precision function decay_chtaunu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: p1sq,p2sq,qsq,mfp,mfm,xtau
	double precision:: Gam_LO,Gam_EWNLO
	double precision:: Gam_S,Gam_P,CL,CR
	complex (kind(0d0)):: Gam_S_NLO,Gam_P_NLO
	double precision:: GamGp_S,GamGp_P
	p1sq=mtau**2; p2sq=m0**2; qsq=mch**2
	mfp=m0; mfm=mtau; xtau = mtau/mch

	!===================
	!     LO
	!===================
	Gam_LO = mch/8.d0/pi*(1.d0-xtau**2)**2*(mfm*xil_A(alpha,beta,n)/vev)**2

	if(OREW == 0) then
		decay_chtaunu = Gam_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW /= 0) then
		Gam_S = -mfm*xil_A(alpha,beta,n)/(vev*sqrt(2.d0))
		Gam_P = -mfm*xil_A(alpha,beta,n)/(vev*sqrt(2.d0))
		CL = Gam_S-Gam_P; CR = Gam_S+Gam_P
		GamGp_S = -mfm/(vev*sqrt(2.d0))
		GamGp_P = -mfm/(vev*sqrt(2.d0))

		Gam_S_NLO =&
			rGam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+mfm*Gam_Hpffp_V1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfm**2)*Gam_Hpffp_T(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
		Gam_P_NLO =&
			rGam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfm*Gam_Hpffp_A1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfm**2)*Gam_Hpffp_PT(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)

		Gam_S_NLO =&
			Gam_S_NLO&
			-GamGp_S*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_S*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0
		Gam_P_NLO =&
			Gam_P_NLO&
			-GamGp_P*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_P*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		Gam_EWNLO =&
			mch/8.d0/pi*sqrt(llambda(1.d0,0.d0,xtau**2))*(&
				+(1.d0-xtau**2)*(2.d0*dble(Gam_S*Gam_S_NLO))&
				+(1.d0-xtau**2)*(2.d0*dble(Gam_P*Gam_P_NLO))&
			)

		!===== QED NLO =====
		Gam_EWNLO = Gam_EWNLO+decay_ch_nlgam(mch,mA,mbH,bmsq,alpha,beta,n,mfp,mfm)

		decay_chtaunu = Gam_LO+Gam_EWNLO
		return
	endif

	end function
!-------------------------------------------------------------------------  
	double precision function decay_chmunu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW

	double precision:: p1sq,p2sq,qsq,mfp,mfm,xfm
	double precision:: Gam_LO,Gam_EWNLO
	double precision:: Gam_S,Gam_P,CL,CR
	complex (kind(0d0)):: Gam_S_NLO,Gam_P_NLO
	double precision:: GamGp_S,GamGp_P

	mfp=m0; mfm=mmu
	xfm = mfm/mch
	p1sq=mfm**2; p2sq=mfp**2; qsq=mch**2

	!===================
	!     LO
	!===================
	Gam_LO = mch/8.d0/pi*(1.d0-xfm**2)**2*(mfm*xil_A(alpha,beta,n)/vev)**2

	if(OREW == 0) then
		decay_chmunu = Gam_LO
		return
	endif

	!====================
	!     NLO EW
	!====================
	if(OREW == 1) then
		Gam_S = -mfm*xil_A(alpha,beta,n)/(vev*sqrt(2.d0))
		Gam_P = -mfm*xil_A(alpha,beta,n)/(vev*sqrt(2.d0))
		CL = Gam_S-Gam_P; CR = Gam_S+Gam_P
		GamGp_S = -mfm/(vev*sqrt(2.d0))
		GamGp_P = -mfm/(vev*sqrt(2.d0))

		Gam_S_NLO =&
			rGam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+mfm*Gam_Hpffp_V1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfm**2)*Gam_Hpffp_T(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
		Gam_P_NLO =&
			rGam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-mfm*Gam_Hpffp_A1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(qsq-mfm**2)*Gam_Hpffp_PT(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)

		Gam_S_NLO =&
			Gam_S_NLO&
			-GamGp_S*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_S*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0
		Gam_P_NLO =&
			Gam_P_NLO&
			-GamGp_P*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			-Gam_P*Del_r(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0

		Gam_EWNLO =&
			mch/8.d0/pi*sqrt(llambda(1.d0,0.d0,xfm**2))*(&
				+(1.d0-xfm**2)*(2.d0*dble(Gam_S*Gam_S_NLO))&
				+(1.d0-xfm**2)*(2.d0*dble(Gam_P*Gam_P_NLO))&
			)

		!===== QED NLO =====
		Gam_EWNLO = Gam_EWNLO+decay_ch_nlgam(mch,mA,mbH,bmsq,alpha,beta,n,mfp,mfm)

		decay_chmunu = Gam_LO+Gam_EWNLO
		return
	endif

	end function
!-------------------------------------------------------------------------  
	double precision function decay_chenu(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,xe
	p1sq=0.d0; p2sq=me**2; qsq=mch**2
	xe = me/mch
	call Switch_HOEW(OREW,S_NLOEW)

	decay_chenu=mch/8.d0/pi*(1.d0-xe**2)**2&
	*(me*xil_A(alpha,beta,n)/vev)**2*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO QED correction
		!	*S_NLOEW&
	)

	end function
!-------------------------------------------------------------------------
	double precision function decay_ch_nlgam(mch,mA,mbH,bmsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,mfp,mfm
	integer, intent(in):: n
	double precision:: Gam_L,Gam_R

	Gam_L = 0.d0
	Gam_R = -sqrt(2.d0)*mfm*xil_A(alpha,beta,n)/vev

	decay_ch_nlgam =&
		+alpha_em/(16.d0*pi**2*mch)*abs(Gam_R)**2*(&
			+OmegaLL_00(mch,mfp,mfm)+Qe**2*OmegaLL_22(mch,mfp,mfm)&
			+Qe*OmegaLL_02(mch,mfp,mfm)&
		)

	end function
!===================================================
!     Two body functions (Bosonic decay)
!===================================================
	double precision function decay_chwh(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,xw,xh,Gam_hHpW_tree
	p1sq=mh**2; p2sq=mW**2; qsq=mch**2
	xw = mw/mch
	xh = mh/mch
	Gam_hHpW_tree = -mw/vev*cos(beta-alpha)

	if(sin(beta-alpha) == 1.d0) then
		decay_chwh=0.d0
	endif		

	if (OREW == 0) then
		decay_chwh =&
			cos(beta-alpha)**2/vev**2/16.d0/pi*mch**3&
			*(1.d0+xw**4+xh**4-2.d0*xw**2-2.d0*xh**2-2.d0*xw**2*xh**2)**(3.d0/2.d0)
	endif
	
	if (OREW == 1) then
		decay_chwh=&
		cos(beta-alpha)**2/vev**2/16.d0/pi*mch**3&
		*(1.d0+xw**4+xh**4-2.d0*xw**2-2.d0*xh**2-2.d0*xw**2*xh**2)**(3.d0/2.d0)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			+(&
				+2.d0*dble(Gam_hHpW_tree*conjg(rGam_hWHp(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)))&
				/abs(Gam_hHpW_tree)**2&
				-dble(rdPiWW(mW**2,mch,mA,mbH,bmsq,alpha,beta,n))&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
				-2.d0*sin(beta-alpha)/cos(beta-alpha)*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			)&
	   )&
		! real photon emission
		+decay_chWhgam(mch,mA,mbH,bmsq,alpha,beta,n)
	endif

	end function
!-------------------------------------------------------------------------
	double precision function decay_chwhgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n

	decay_chWhGam=&
		-g**4*sw**2*cos(beta-alpha)**2/(64.d0*pi**3*mch)*(&
			+llambda(mch**2,mh**2,mW**2)*(&
				Ibrems_22(mch,mh,mW)+mch**2/mW**2*Ibrems_00(mch,mh,mW)&
				+(1.d0+(mch**2-mh**2)/mW**2)*Ibrems_02(mch,mh,mW)&
			)&
			+llambda(mch**2,mh**2,mW**2)/mW**2*(Ibrems_2(mch,mh,mW)+Ibrems_0(mch,mh,mW))&
			-2.d0*Ibrems11_22(mch,mh,mW)&
		)

	end function
!-------------------------------------------------------------------------
	double precision function decay_chwbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,xw,xbH,Gam_bHHpW_tree
	p1sq=mbH**2; p2sq=mW**2; qsq=mch**2
	xw = mw/mch; xbH = mbH/mch
	Gam_bHHpW_tree = mw/vev*sin(beta-alpha)

	if(sin(beta-alpha) == 0.d0) then
		decay_chwbH=0.d0
	endif		

	if (OREW == 0) then
		decay_chwbH=&
		sin(beta-alpha)**2/vev**2/16.d0/pi*mch**3&
		*(1.d0+xw**4+xbH**4-2.d0*xw**2-2.d0*xbH**2-2.d0*xw**2*xbH**2)**(3.d0/2.d0)
	endif

	if (OREW == 1) then
		decay_chwbH=&
		sin(beta-alpha)**2/vev**2/16.d0/pi*mch**3&
		*(1.d0+xw**4+xbH**4-2.d0*xw**2-2.d0*xbH**2-2.d0*xw**2*xbH**2)**(3.d0/2.d0)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			+(&
				2.d0*dble(Gam_bHHpW_tree*conjg(rGam_bHWHp(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)))&
				/abs(Gam_bHHpW_tree)**2&
				-dble(rdPiWW(mW**2,mch,mA,mbH,bmsq,alpha,beta,n))&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
				+2.d0*cos(beta-alpha)/sin(beta-alpha)*rPiHpGm(mch**2,mch,mA,mbH,bmsq,alpha,beta,n)/mch**2&
			)&
		)&
		! real photon emission
		+decay_chwbHgam(mch,mA,mbH,bmsq,alpha,beta,n)
	endif

	end function
!-------------------------------------------------------------------------
	double precision function decay_chwbHgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n

	decay_chWbHGam=&
		-g**4*sw**2*sin(beta-alpha)**2/(64.d0*pi**3*mch)*(&
	 		+llambda(mch**2,mbH**2,mW**2)*(&
				Ibrems_22(mch,mbH,mW)+mch**2/mW**2*Ibrems_00(mch,mbH,mW)&
				+(1.d0+(mch**2-mbH**2)/mW**2)*Ibrems_02(mch,mbH,mW)&
			)&
			+llambda(mch**2,mbH**2,mW**2)/mW**2*(&
				Ibrems_2(mch,mbH,mW)+Ibrems_0(mch,mbH,mW)&
			)&
			-2.d0*Ibrems11_22(mch,mbH,mW)&
		)

	end function
!-------------------------------------------------------------------------  
	double precision function decay_chwA(mch,mA,mbH,bmsq,alpha,beta,n,OREW)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n, OREW
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,xw,xA
	complex (kind(0d0))::Gam_AHpW_tree
	p1sq=mA**2; p2sq=mw**2; qsq=mch**2
	xw = mw/mch
	xA = mA/mch
	Gam_AHpW_tree = ii*mW/vev

	if (OREW == 0) then
		decay_chwA =&
		1.d0/vev**2/16.d0/pi*mch**3&
		*(1+xw**4+xA**4-2.d0*xw**2-2.d0*xA**2-2.d0*xw**2*xA**2)**(3.d0/2.d0)
	endif

	if (OREW == 1) then
		decay_chwA =&
		1.d0/vev**2/16.d0/pi*mch**3&
		*(1+xw**4+xA**4-2.d0*xw**2-2.d0*xA**2-2.d0*xw**2*xA**2)**(3.d0/2.d0)*(&
			! LO
			+1.d0&
			! NLO Weak correction
			+(&
				+2.d0*dble(Gam_AHpW_tree*conjg(rGam_AWHp(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)))&
					/abs(Gam_AHpW_tree)**2&
				-dble(rdPiWW(mW**2,mch,mA,mbH,bmsq,alpha,beta,n))&
				-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)&
			)&
		)&
		! real photon emission
		+decay_chwAgam(mch,mA,mbH,bmsq,alpha,beta,n)
	endif

	end function
!-------------------------------------------------------------------------
	double precision function decay_chwAgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n

	decay_chWAgam =&
	-g**4*sw**2/(64.d0*pi**3*mch)*(&
		+llambda(mch**2,mA**2,mW**2)*(&
			Ibrems_22(mch,mA,mW)&
			+mch**2/mW**2*Ibrems_00(mch,mA,mW)&
			+(1.d0+(mch**2-mA**2)/mW**2)*Ibrems_02(mch,mA,mW)&
		)&
		+llambda(mch**2,mA**2,mW**2)/mW**2*(&
			Ibrems_2(mch,mA,mW)+Ibrems_0(mch,mA,mW)&
		)&
		-2.d0*Ibrems11_22(mch,mA,mW)&
	)

	end function
!-------------------------------------------------------------------------  
	double precision function decay_chWZ(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,xW,xZ,klam,MLLsq,MTTsq
	p1sq=mW**2; p2sq=mZ**2; qsq=mch**2
	xW = mW/mch
	xZ = mZ/mch
	klam = 1.d0+xW**4+xZ**4-2.d0*xW**2-2.d0*xZ**2-2.d0*xW**2*xZ**2

	MLLsq =&
	1.d0/(4.d0*xZ**2*xW**2)*abs(&
		(1.d0-xW**2-xZ**2)*rGam1_HpWZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
		+klam/2.d0*mch**2*rGam2_HpWZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)&
	)**2
	MTTsq =&
	2.d0*(&
		abs(rGam1_HpWZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n))**2&
		+mch**4*klam/4.d0*abs(rGam3_HpWZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n))**2&
	)

	decay_chWZ=1.d0/(16.d0*pi*mch)*sqrt(klam)*(MTTsq+MLLsq)

	end function
!-------------------------------------------------------------------------  
	double precision function decay_chWgam(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	double precision:: S_NLOEW
	double precision:: p1sq,p2sq,qsq,xW,klam,MTTsq
	p1sq=mW**2; p2sq=0.d0; qsq=mch**2
	xW = mW/mch
	klam = (1.d0-xW**2)**2

	MTTsq =&
	2.d0*(&
		abs(rGam1_HpWGam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n))**2&
		+mch**4*klam/4.d0*abs(rGam3_HpWgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n))**2&
	)

	decay_chWgam=1.d0/(16.d0*pi*mch)*sqrt(klam)*MTTsq

	end function
!=====================================================
!     Three body functions
!=====================================================
	double precision function ddecay_dx1dx2_chtstarb(mch,mA,mbH,bmsq,alpha,beta,n,xb,xbbar,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,xb,xbbar
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,kt,kw,gamt,Kchtb
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	kt = mt**2/mch**2
	kw = mW**2/mch**2
	gamt = (1.42d0/mch)**2
	Kchtb = 3*G_F**2*mt**4*xiu_A(alpha,beta,n)**2*mW**2/32.d0/pi**3/mch*Vtb**2
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	ddecay_dx1dx2_chtstarb=&
	Kchtb*((1-xbbar)*(1-xb)+kw*(2.d0*xb+2.d0*xbbar-3.d0+2.d0*kw))&
	/kw/((1-xbbar-kt)**2+kt*gamt)*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&           
		! NLO  QCD correction
		!	*S_NLOQCD&           
		! NNLO  QCD correction
		!	*S_NNLOQCD&          
	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chtstarb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	integer:: i,j,div_width
	double precision:: xb,xbbar,kw,ddecay_chtstarb
	kw = mw**2/mch**2

	div_width=100; decay_chtstarb=0.d0

	do i = 0, div_width
		ddecay_chtstarb=0.d0
		xbbar = dble(i)*(1.d0-kw)/dble(div_width)
		do j = 0, div_width
			xb = 1.d0-xbbar-kw+(1.d0-kw/(1.d0-xbbar))*xbbar/dble(div_width)*dble(j)
			if(j==0 .or. j==div_width) then
				ddecay_chtstarb =&
					ddecay_chtstarb&
					+ddecay_dx1dx2_chtstarb(mch,mA,mbH,bmsq,alpha,beta,n,xb,xbbar,OREW,ORQCD)
			else if(mod(j,2)==1) then
				ddecay_chtstarb =&
					ddecay_chtstarb&
					+4.d0*ddecay_dx1dx2_chtstarb(mch,mA,mbH,bmsq,alpha,beta,n,xb,xbbar,OREW,ORQCD)
			else if(mod(j,2)==0) then
				ddecay_chtstarb =&
					ddecay_chtstarb&
					+2.d0*ddecay_dx1dx2_chtstarb(mch,mA,mbH,bmsq,alpha,beta,n,xb,xbbar,OREW,ORQCD)
			endif
		enddo
		ddecay_chtstarb = ddecay_chtstarb*(1.d0-kw/(1.d0-xbbar))*xbbar/dble(div_width)/3.d0
		if(i==0 .or. i==div_width) then
			decay_chtstarb = decay_chtstarb+ddecay_chtstarb
		else if(mod(i,2)==1) then
			decay_chtstarb = decay_chtstarb+4.d0*ddecay_chtstarb
		else if(mod(i,2)==0) then
			decay_chtstarb = decay_chtstarb+2.d0*ddecay_chtstarb
		endif	
	enddo
	decay_chtstarb = decay_chtstarb*(1.d0-kw)/dble(div_width)/3.d0

	end function
!-------------------------------------------------------------------
	double precision function ddecay_dx1dx2_chtstars(mch,mA,mbH,bmsq,alpha,beta,n,xb,xsbar,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,xb,xsbar
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,kt,kw,gamt,Kchts
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	kt = mt**2/mch**2
	kw = mW**2/mch**2
	gamt = (1.42d0/mch)**2
	Kchts = 3.d0*G_F**2*mt**4*xiu_A(alpha,beta,n)**2*mW**2/32.d0/pi**3/mch*Vtb*Vts
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	ddecay_dx1dx2_chtstars=&
	Kchts*((1-xsbar)*(1-xb)+kw*(2.d0*xb+2.d0*xsbar-3.d0+2.d0*kw))&
	/kw/((1-xsbar-kt)**2+kt*gamt)*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&           
		! NLO  QCD correction
		!	*S_NLOQCD&           
		! NNLO  QCD correction
		!	*S_NNLOQCD&          
	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chtstars(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	integer:: i,j,div_width
	double precision:: xb,xsbar,kw,ddecay_chtstars
	kw = mw**2/mch**2

	div_width=100; decay_chtstars=0.d0

	do i = 0, div_width
		ddecay_chtstars=0.d0
		xsbar = dble(i)*(1.d0-kw)/dble(div_width)
		do j = 0, div_width
			xb = 1.d0-xsbar-kw+(1.d0-kw/(1.d0-xsbar))*xsbar/dble(div_width)*dble(j)
			if(j==0 .or. j==div_width) then
				ddecay_chtstars =&
					ddecay_chtstars&
					+ddecay_dx1dx2_chtstars(mch,mA,mbH,bmsq,alpha,beta,n,xb,xsbar,OREW,ORQCD)
			else if(mod(j,2)==1) then
				ddecay_chtstars =&
					ddecay_chtstars&
					+4.d0*ddecay_dx1dx2_chtstars(mch,mA,mbH,bmsq,alpha,beta,n,xb,xsbar,OREW,ORQCD)
			else if(mod(j,2)==0) then
				ddecay_chtstars =&
					ddecay_chtstars&
					+2.d0*ddecay_dx1dx2_chtstars(mch,mA,mbH,bmsq,alpha,beta,n,xb,xsbar,OREW,ORQCD)
			endif
		enddo
		ddecay_chtstars = ddecay_chtstars*(1.d0-kw/(1.d0-xsbar))*xsbar/dble(div_width)/3.d0
		if(i==0 .or. i==div_width) then
			decay_chtstars = decay_chtstars+ddecay_chtstars
		else if(mod(i,2)==1) then
			decay_chtstars = decay_chtstars+4.d0*ddecay_chtstars
		else if(mod(i,2)==0) then
			decay_chtstars = decay_chtstars+2.d0*ddecay_chtstars
		endif	
	enddo
	decay_chtstars = decay_chtstars*(1.d0-kw)/dble(div_width)/3.d0

	end function
!-------------------------------------------------------------------
	double precision function ddecay_dx1dx2_chtstard(mch,mA,mbH,bmsq,alpha,beta,n,xb,xdbar,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta,xb,xdbar
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,kt,kw,gamt,Kchts
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	kt = mt**2/mch**2
	kw = mW**2/mch**2
	gamt = (1.42d0/mch)**2
	Kchts = 3*G_F**2*mt**4*xiu_A(alpha,beta,n)**2*mW**2/32.d0/pi**3/mch*Vtb*Vtd
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	ddecay_dx1dx2_chtstard=&
	Kchts*((1-xdbar)*(1-xb)+kw*(2.d0*xb+2.d0*xdbar-3.d0+2.d0*kw))&
	/kw/((1-xdbar-kt)**2+kt*gamt)*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&           
		! NLO  QCD correction
		!	*S_NLOQCD&           
		! NNLO  QCD correction
		!	*S_NNLOQCD&
	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chtstard(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	integer:: i,j,div_width
	double precision:: xb,xdbar,kw,ddecay_chtstard
	kw = mw**2/mch**2

	div_width=100; decay_chtstard=0.d0

	do i = 0, div_width
		ddecay_chtstard=0.d0
		xdbar = dble(i)*(1.d0-kw)/dble(div_width)
		do j = 0, div_width
			xb = 1.d0-xdbar-kw+(1.d0-kw/(1.d0-xdbar))*xdbar/dble(div_width)*dble(j)
			if(j==0 .or. j==div_width) then
				ddecay_chtstard =&
					ddecay_chtstard&
					+ddecay_dx1dx2_chtstard(mch,mA,mbH,bmsq,alpha,beta,n,xb,xdbar,OREW,ORQCD)
			else if(mod(j,2)==1) then
				ddecay_chtstard =&
					ddecay_chtstard&
					+4.d0*ddecay_dx1dx2_chtstard(mch,mA,mbH,bmsq,alpha,beta,n,xb,xdbar,OREW,ORQCD)
			else if(mod(j,2)==0) then
				ddecay_chtstard =&
					ddecay_chtstard&
					+2.d0*ddecay_dx1dx2_chtstard(mch,mA,mbH,bmsq,alpha,beta,n,xb,xdbar,OREW,ORQCD)
			endif
		enddo
		ddecay_chtstard = ddecay_chtstard*(1.d0-kw/(1.d0-xdbar))*xdbar/dble(div_width)/3.d0
		if(i==0 .or. i==div_width) then
			decay_chtstard = decay_chtstard+ddecay_chtstard
		else if(mod(i,2)==1) then
			decay_chtstard = decay_chtstard+4.d0*ddecay_chtstard
		else if(mod(i,2)==0) then
			decay_chtstard = decay_chtstard+2.d0*ddecay_chtstard
		endif
	enddo
	decay_chtstard = decay_chtstard*(1.d0-kw)/dble(div_width)/3.d0

	end function
!-------------------------------------------------------------------
	double precision function decay_chwstarh(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,kh,kw,gamw,Kchwh
	double precision:: mu,nf,lam_QCD
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	mu = mw
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif
	Kchwh = 9.d0*G_F**2*mw**4*mch/(16.d0*pi**3)*cos(beta-alpha)**2
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_chwstarh =&
	Kchwh*SSpV3body(mch,mh,mW)*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&
		! NLO  QCD correction
		+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)*S_NLOQCD&
		! NNLO  QCD correction
		!	*S_NNLOQCD&
	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chwstarbH(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,KchwbH
	double precision:: mu,nf,lam_QCD
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	mu = mw
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif
	KchwbH = 9.d0*G_F**2*mw**4*mch/16.d0/pi**3*sin(beta-alpha)**2
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_chwstarbH =&
	KchwbH*SSpV3body(mch,mbH,mW)*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOQCD&
		! NLO QCD correctio
		+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)*S_NLOQCD&
		! NNLO  QCD correction
		!	*S_NNLOQCD
	)

	end function
!-------------------------------------------------------------------
	double precision function decay_chwstarA(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq,KchwA
	double precision:: mu,nf,lam_QCD
	! p1sq=mt**2; p2sq=md**2; qsq=mch**2
	mu = mw
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif
	KchwA = 9.d0*G_F**2*mw**4*mch/16.d0/pi**3
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	decay_chwstarA =&
	KchwA*SSpV3body(mch,mA,mW)*(&
		! LO
		+1.d0&
		! NLO Weak correction
		!	*S_NLOEW&
		! NLO  QED correction
		!	*S_NLOEW&
		! NLO  QCD correction
		+CF*3.d0/4.d0/pi*alphas(lam_QCD,mu,nf)*S_NLOQCD&
		! NNLO  QCD correction
		!	*S_NNLOQCD
	)

	end function
!=====================================
!     1PI vertex functions
!=====================================
!-------------------------------------------------------------
!     Hpffp 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_S=&
	+1.d0/(16.d0*pi**2)*(&
		+gz**2*(gHp_S*(vfp*vfm-afp*afm)*CFVF_plus(p1sq,p2sq,qsq,mfm,mZ,mfp,mfp,mfm)&
			+gHp_P*(afp*vfm-vfp*afm)*CFVF_minus(p1sq,p2sq,qsq,mfm,mZ,mfp,mfp,mfm))&
		+g**2/4.d0/sqrt(2.d0)*(&
	  		-ghfp*cos(beta-alpha)*CVFS_S(p1sq,p2sq,qsq,mW,mfp,mh)&
			+gbHfp*sin(beta-alpha)*CVFS_S(p1sq,p2sq,qsq,mW,mfp,mbH)&
			-ii*gAfp*CVFS_S(p1sq,p2sq,qsq,mW,mfp,mA))&
		-g**2/4.d0/sqrt(2.d0)*(&
	  		-ghfm*cos(beta-alpha)*CSFV_S(p1sq,p2sq,qsq,mh,mfm,mW)&
			+gbHfm*sin(beta-alpha)*CSFV_S(p1sq,p2sq,qsq,mbH,mfm,mW)&
			+ii*gAfm*CSFV_S(p1sq,p2sq,qsq,mA,mfm,mW))&
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+(vfp*gHp_S+afp*gHp_P)*CSFV_S(p1sq,p2sq,qsq,mch,mfp,mZ)&
			-(vfm*gHp_S-afm*gHp_P)*CVFS_S(p1sq,p2sq,qsq,mZ,mfm,mch))&
		-gHp_S*(&
			+ghfp*ghfm*CFSF_S(p1sq,p2sq,qsq,mfm,mh,mfp,mfp,mfm)&
			+gbHfp*gbHfm*CFSF_S(p1sq,p2sq,qsq,mfm,mbH,mfp,mfp,mfm)&
			+gAfp*gAfm*CFSF_S(p1sq,p2sq,qsq,mfm,mA,mfp,mfp,mfm)&
			+gGfp*gGfm*CFSF_S(p1sq,p2sq,qsq,mfm,mz,mfp,mfp,mfm))&
		-mfp*(&
			+gGp_S*(lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c0f(p1sq,p2sq,qsq,mw,mfp,mh)&
				+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c0f(p1sq,p2sq,qsq,mw,mfp,mbH))&
			+gHp_S*(lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c0f(p1sq,p2sq,qsq,mch,mfp,mh)&
				+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c0f(p1sq,p2sq,qsq,mch,mfp,mbH))&
			+gGp_P*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfp*c0f(p1sq,p2sq,qsq,mw,mfp,mA))&
		-mfm*(&
			+gGp_S*(lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c0f(p1sq,p2sq,qsq,mh,mfm,mw)&
				+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c0f(p1sq,p2sq,qsq,mbH,mfm,mw))&
			+gHp_S*(lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c0f(p1sq,p2sq,qsq,mh,mfm,mch)&
				+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c0f(p1sq,p2sq,qsq,mbH,mfm,mch))&
			+gGp_P*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfm*c0f(p1sq,p2sq,qsq,mA,mfm,mw))&
	)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_S = Gam_Hpffp_S&
		+1.d0/(16.d0*pi**2)*(&
			+(g*sw)**2*Qfp*Qfm*gHp_S*CFVF_plus(p1sq,p2sq,qsq,mfm,mphoton,mfp,mfp,mfm)&
			+(g*sw)**2*gHp_S*(&
				+Qfp*CSFV_S(p1sq,p2sq,qsq,mch,mfp,mphoton)&
				-Qfm*CVFS_S(p1sq,p2sq,qsq,mphoton,mfm,mch)))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_S = Gam_Hpffp_S&
		+1.d0/(16.d0*pi**2)*(-(g*sw)**2*gHp_S*Qfm*CVFS_S(p1sq,p2sq,qsq,mphoton,mfm,mch))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_P=&
	+1.d0/(16.d0*pi**2)*(&
		+gz**2*(gHp_S*(afp*vfm-vfp*afm)*CFVF_plus(p1sq,p2sq,qsq,mfm,mZ,mfp,mfp,mfm)&
			+gHp_P*(vfp*vfm-afp*afm)*CFVF_minus(p1sq,p2sq,qsq,mfm,mZ,mfp,mfp,mfm))&
!
		-g**2/4.d0/sqrt(2.d0)*(&
			-ghfp*cos(beta-alpha)*CVFS_S(p1sq,p2sq,qsq,mW,mfp,mh)&
			+gbHfp*sin(beta-alpha)*CVFS_S(p1sq,p2sq,qsq,mW,mfp,mbH)&
			-ii*gAfp*CVFS_S(p1sq,p2sq,qsq,mW,mfp,mA))&
		-g**2/4.d0/sqrt(2.d0)*(&
	  		-ghfm*cos(beta-alpha)*CSFV_S(p1sq,p2sq,qsq,mh,mfm,mW)&
			+gbHfm*sin(beta-alpha)*CSFV_S(p1sq,p2sq,qsq,mbH,mfm,mW)&
			+ii*gAfm*CSFV_S(p1sq,p2sq,qsq,mA,mfm,mW))&
!
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+(afp*gHp_S+vfp*gHp_P)*CSFV_S(p1sq,p2sq,qsq,mch,mfp,mZ)&
			-(vfm*gHp_P-afm*gHp_S)*CVFS_S(p1sq,p2sq,qsq,mZ,mfm,mch))&
!
		+gHp_P*(&
			+ghfp*ghfm*CFSF_P(p1sq,p2sq,qsq,mfm,mh,mfp,mfp,mfm)&
			+gbHfp*gbHfm*CFSF_P(p1sq,p2sq,qsq,mfm,mbH,mfp,mfp,mfm)&
			+gAfp*gAfm*CFSF_P(p1sq,p2sq,qsq,mfm,mA,mfp,mfp,mfm)&
			+gGfp*gGfm*CFSF_P(p1sq,p2sq,qsq,mfm,mz,mfp,mfp,mfm))&
		-mfp*(&
			+gGp_P*(lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c0f(p1sq,p2sq,qsq,mw,mfp,mh)&
				+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c0f(p1sq,p2sq,qsq,mw,mfp,mbH))&
			+gHp_P*(lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c0f(p1sq,p2sq,qsq,mch,mfp,mh)&
				+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c0f(p1sq,p2sq,qsq,mch,mfp,mbH))&
			+gGp_S*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfp*c0f(p1sq,p2sq,qsq,mw,mfp,mA))&
		-mfm*(&
		  +gGp_P*(lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c0f(p1sq,p2sq,qsq,mh,mfm,mw)&
				+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c0f(p1sq,p2sq,qsq,mbH,mfm,mw))&
			+gHp_P*(lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c0f(p1sq,p2sq,qsq,mh,mfm,mch)&
				+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c0f(p1sq,p2sq,qsq,mbH,mfm,mch))&
			+gGp_S*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfm*c0f(p1sq,p2sq,qsq,mA,mfm,mw))&
		)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_P = Gam_Hpffp_P&
		+1.d0/(16.d0*pi**2)*(&
			+(g*sw)**2*Qfp*Qfm*gHp_P*CFVF_minus(p1sq,p2sq,qsq,mfm,mphoton,mfp,mfp,mfm)&
			+(g*sw)**2*gHp_P*(&
				+Qfp*CSFV_S(p1sq,p2sq,qsq,mch,mfp,mphoton)&
				-Qfm*CVFS_S(p1sq,p2sq,qsq,mphoton,mfm,mch)))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_P = Gam_Hpffp_P&
		+1.d0/(16.d0*pi**2)*(-Qfm*(g*sw)**2*gHp_P*CVFS_S(p1sq,p2sq,qsq,mphoton,mfm,mch))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_V1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_V1=&
	+1.d0/(16.d0*pi**2)*(&
		+2.d0*gz**2*(&
			+gHp_S*(vfp*vfm+afp*afm)*(mfp*c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
			-gHp_P*(vfp*afm+afp*vfm)*(mfp*c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				-mfm*(c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
		)&
!
		+g**2*mfp/4.d0/sqrt(2.d0)*(&
			-ghfp*cos(beta-alpha)*(c11f(p1sq,p2sq,qsq,mW,mfp,mh)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mh))&
			+gbHfp*sin(beta-alpha)*(c11f(p1sq,p2sq,qsq,mW,mfp,mbH)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mbH))&
			+ii*gAfp*(c11f(p1sq,p2sq,qsq,mW,mfp,mA)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mA))&
		)&
		-g**2*mfm/4.d0/sqrt(2.d0)*(&
  			-ghfm*cos(beta-alpha)*(c11f(p1sq,p2sq,qsq,mh,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mh,mfm,mW))&
			+gbHfm*sin(beta-alpha)*(c11f(p1sq,p2sq,qsq,mbH,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mbH,mfm,mW))&
			-ii*gAfm*(c11f(p1sq,p2sq,qsq,mA,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mA,mfm,mW))&
		)&
!
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+mfp*(vfp*gHp_S-afp*gHp_P)*(c11f(p1sq,p2sq,qsq,mch,mfp,mZ)&
				-c0f(p1sq,p2sq,qsq,mch,mfp,mZ))&
			-mfm*(vfm*gHp_S+afm*gHp_P)*(c11f(p1sq,p2sq,qsq,mZ,mfm,mch)&
				+2.d0*c0f(p1sq,p2sq,qsq,mZ,mfm,mch))&
		)&
!
		+gHp_S*(&
			+ghfp*ghfm*(mfp*c11f(p1sq,p2sq,qsq,mfm,mh,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mh,mfp)+c0f(p1sq,p2sq,qsq,mfm,mh,mfp)))&
			+gbHfp*gbHfm*(mfp*c11f(p1sq,p2sq,qsq,mfm,mbH,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mbH,mfp)+c0f(p1sq,p2sq,qsq,mfm,mbH,mfp)))&
			-gAfp*gAfm*(mfp*c11f(p1sq,p2sq,qsq,mfm,mA,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mA,mfp)+c0f(p1sq,p2sq,qsq,mfm,mA,mfp)))&
			-gGfp*gGfm*(mfp*c11f(p1sq,p2sq,qsq,mfm,mz,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mz,mfp)+c0f(p1sq,p2sq,qsq,mfm,mz,mfp)))&
		)&
!
		-gGp_S*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp&
				*(c0f(p1sq,p2sq,qsq,mw,mfp,mh)+c11f(p1sq,p2sq,qsq,mw,mfp,mh))&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp&
				*(c0f(p1sq,p2sq,qsq,mw,mfp,mbH)+c11f(p1sq,p2sq,qsq,mw,mfp,mbH)))&
		-gHp_S*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp&
				*(c0f(p1sq,p2sq,qsq,mch,mfp,mh)+c11f(p1sq,p2sq,qsq,mch,mfp,mh))&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp&
				*(c0f(p1sq,p2sq,qsq,mch,mfp,mbH)+c11f(p1sq,p2sq,qsq,mch,mfp,mbH)))&
		+gGp_P*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfp&
			*(c0f(p1sq,p2sq,qsq,mw,mfp,mA)+c11f(p1sq,p2sq,qsq,mw,mfp,mA))&
!
		-gGp_S*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm&
			*(c0f(p1sq,p2sq,qsq,mh,mfm,mw)+c11f(p1sq,p2sq,qsq,mh,mfm,mw))&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm&
			*(c0f(p1sq,p2sq,qsq,mbH,mfm,mw)+c11f(p1sq,p2sq,qsq,mbH,mfm,mw)))&
		-gHp_S*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm&
			*(c0f(p1sq,p2sq,qsq,mh,mfm,mch)+c11f(p1sq,p2sq,qsq,mh,mfm,mch))&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm&
			*(c0f(p1sq,p2sq,qsq,mbH,mfm,mch)+c11f(p1sq,p2sq,qsq,mbH,mfm,mch)))&
		+gGp_P*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfm&
			*(c0f(p1sq,p2sq,qsq,mA,mfm,mw)+c11f(p1sq,p2sq,qsq,mA,mfm,mw))&
	)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_V1 = Gam_Hpffp_V1&
		+1.d0/(16.d0*pi**2)*(&
			+2.d0*(g*sw)**2*Qfp*Qfm*gHp_S*(mfp*c11f(p1sq,p2sq,qsq,mfm,mphoton,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mphoton,mfp)+c0f(p1sq,p2sq,qsq,mfm,mphoton,mfp)))&
			+(g*sw)**2*gHp_S*(&
				+Qfp*mfp*(c11f(p1sq,p2sq,qsq,mch,mfp,mphoton)-c0f(p1sq,p2sq,qsq,mch,mfp,mphoton))&
				-Qfm*mfm*(c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_V1 = Gam_Hpffp_V1&
		+1.d0/(16.d0*pi**2)*(&
			-Qfm*mfm*(g*sw)**2*gHp_S*(&
				+c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_A1(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_A1=&
	+1.d0/(16.d0*pi**2)*(&
		-gz**2*(&
			+2.d0*gHp_S*(afp*vfm+vfp*afm)*(mfp*c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
			-2.d0*gHp_P*(vfp*vfm+afp*afm)*(mfp*c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				-mfm*(c11f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
		)&
!
		-g**2*mfp/4.d0/sqrt(2.d0)*(&
			-ghfp*cos(beta-alpha)*(c11f(p1sq,p2sq,qsq,mW,mfp,mh)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mh))&
			+gbHfp*sin(beta-alpha)*(c11f(p1sq,p2sq,qsq,mW,mfp,mbH)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mbH))&
			+ii*gAfp*(c11f(p1sq,p2sq,qsq,mW,mfp,mA)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mA))&
		)&
!
		+g**2*mfm/4.d0/sqrt(2.d0)*(&
  			-ghfm*cos(beta-alpha)*(c11f(p1sq,p2sq,qsq,mh,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mh,mfm,mW))&
			+gbHfm*sin(beta-alpha)*(c11f(p1sq,p2sq,qsq,mbH,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mbH,mfm,mW))&
			-ii*gAfm*(c11f(p1sq,p2sq,qsq,mA,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mA,mfm,mW))&
		)&
!
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+mfp*(vfp*gHp_P-afp*gHp_S)*(c11f(p1sq,p2sq,qsq,mch,mfp,mZ)&
				-c0f(p1sq,p2sq,qsq,mch,mfp,mZ))&
			+mfm*(vfm*gHp_P+afm*gHp_S)*(c11f(p1sq,p2sq,qsq,mZ,mfm,mch)&
				+2.d0*c0f(p1sq,p2sq,qsq,mZ,mfm,mch))&
		)&
!
		+gHp_P*(&
			+ghfp*ghfm*(-mfp*c11f(p1sq,p2sq,qsq,mfm,mh,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mh,mfp)+c0f(p1sq,p2sq,qsq,mfm,mh,mfp)))&
			+gbHfp*gbHfm*(-mfp*c11f(p1sq,p2sq,qsq,mfm,mbH,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mbH,mfp)+c0f(p1sq,p2sq,qsq,mfm,mbH,mfp)))&
			-gAfp*gAfm*(-mfp*c11f(p1sq,p2sq,qsq,mfm,mA,mfp)&
				+mfm*(c11f(p1sq,p2sq,qsq,mfm,mA,mfp)+c0f(p1sq,p2sq,qsq,mfm,mA,mfp)))&
			-gGfp*gGfm*(-mfp*c11f(p1sq,p2sq,qsq,mfm,mz,mfp)&
			 +mfm*(c11f(p1sq,p2sq,qsq,mfm,mz,mfp)+c0f(p1sq,p2sq,qsq,mfm,mz,mfp)))&
		)&
!
		-gGp_P*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp&
				*(c0f(p1sq,p2sq,qsq,mw,mfp,mh)+c11f(p1sq,p2sq,qsq,mw,mfp,mh))&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp&
				*(c0f(p1sq,p2sq,qsq,mw,mfp,mbH)+c11f(p1sq,p2sq,qsq,mw,mfp,mbH)))&
		-gHp_P*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp&
				*(c0f(p1sq,p2sq,qsq,mch,mfp,mh)+c11f(p1sq,p2sq,qsq,mch,mfp,mh))&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp&
				*(c0f(p1sq,p2sq,qsq,mch,mfp,mbH)+c11f(p1sq,p2sq,qsq,mch,mfp,mbH)))&
		+gGp_S*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfp&
				*(c0f(p1sq,p2sq,qsq,mw,mfp,mA)+c11f(p1sq,p2sq,qsq,mw,mfp,mA))&
!
		+gGp_P*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm&
				*(c0f(p1sq,p2sq,qsq,mh,mfm,mw)+c11f(p1sq,p2sq,qsq,mh,mfm,mw))&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm&
				*(c0f(p1sq,p2sq,qsq,mbH,mfm,mw)+c11f(p1sq,p2sq,qsq,mbH,mfm,mw)))&
		+gHp_P*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm&
				*(c0f(p1sq,p2sq,qsq,mh,mfm,mch)+c11f(p1sq,p2sq,qsq,mh,mfm,mch))&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm&
				*(c0f(p1sq,p2sq,qsq,mbH,mfm,mch)+c11f(p1sq,p2sq,qsq,mbH,mfm,mch)))&
		-gGp_S*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfm&
			*(c0f(p1sq,p2sq,qsq,mA,mfm,mw)+c11f(p1sq,p2sq,qsq,mA,mfm,mw))&
	)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_A1 = Gam_Hpffp_A1&
		+1.d0/(16.d0*pi**2)*(&
			+2.d0*(g*sw)**2*Qfp*Qfm*gHp_P*(mfp*c11f(p1sq,p2sq,qsq,mfm,mphoton,mfp)&
				-mfm*(c11f(p1sq,p2sq,qsq,mfm,mphoton,mfp)+c0f(p1sq,p2sq,qsq,mfm,mphoton,mfp)))&
			+(g*sw)**2*gHp_P*(&
				+Qfp*mfp*(c11f(p1sq,p2sq,qsq,mch,mfp,mphoton)-c0f(p1sq,p2sq,qsq,mch,mfp,mphoton))&
				+Qfm*mfm*(c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_A1 = Gam_Hpffp_A1&
		+1.d0/(16.d0*pi**2)*(&
			+Qfm*mfm*(g*sw)**2*gHp_P*(c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_V2(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_V2=&
	+1.d0/(16.d0*pi**2)*(&
		+gz**2*(&
			+2.d0*gHp_S*(vfp*vfm+afp*afm)*(mfp*c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
			-2.d0*gHp_P*(vfp*afm+afp*vfm)*(mfp*c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				-mfm*(c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
		)&
!
		+g**2*mfp/4.d0/sqrt(2.d0)*(&
			-ghfp*cos(beta-alpha)*(c12f(p1sq,p2sq,qsq,mW,mfp,mh)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mh))&
			+gbHfp*sin(beta-alpha)*(c12f(p1sq,p2sq,qsq,mW,mfp,mbH)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mbH))&
			+ii*gAfp*(c12f(p1sq,p2sq,qsq,mW,mfp,mA)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mA))&
		)&
		-g**2*mfm/4.d0/sqrt(2.d0)*(&
  			-ghfm*cos(beta-alpha)*(c12f(p1sq,p2sq,qsq,mh,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mh,mfm,mW))&
			+gbHfm*sin(beta-alpha)*(c12f(p1sq,p2sq,qsq,mbH,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mbH,mfm,mW))&
			-ii*gAfm*(c12f(p1sq,p2sq,qsq,mA,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mA,mfm,mW))&
		)&
!
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+mfp*(vfp*gHp_S-afp*gHp_P)*(c12f(p1sq,p2sq,qsq,mch,mfp,mZ)&
				-c0f(p1sq,p2sq,qsq,mch,mfp,mZ))&
			-mfm*(vfm*gHp_S+afm*gHp_P)*(c12f(p1sq,p2sq,qsq,mZ,mfm,mch)&
				+2.d0*c0f(p1sq,p2sq,qsq,mZ,mfm,mch))&
		)&
!
		+gHp_S*(&
			+ghfp*ghfm*(mfp*c12f(p1sq,p2sq,qsq,mfm,mh,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mh,mfp)+c0f(p1sq,p2sq,qsq,mfm,mh,mfp)))&
			+gbHfp*gbHfm*(mfp*c12f(p1sq,p2sq,qsq,mfm,mbH,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mbH,mfp)+c0f(p1sq,p2sq,qsq,mfm,mbH,mfp)))&
			-gAfp*gAfm*(mfp*c12f(p1sq,p2sq,qsq,mfm,mA,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mA,mfp)+c0f(p1sq,p2sq,qsq,mfm,mA,mfp)))&
			-gGfp*gGfm*(mfp*c12f(p1sq,p2sq,qsq,mfm,mz,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mz,mfp)+c0f(p1sq,p2sq,qsq,mfm,mz,mfp)))&
		)&
!
		-gGp_S*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c12f(p1sq,p2sq,qsq,mw,mfp,mh)&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c12f(p1sq,p2sq,qsq,mw,mfp,mbH))&
		-gHp_S*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c12f(p1sq,p2sq,qsq,mch,mfp,mh)&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c12f(p1sq,p2sq,qsq,mch,mfp,mbH))&
		+gGp_P*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfp*c12f(p1sq,p2sq,qsq,mw,mfp,mA)&
!
		-gGp_S*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c12f(p1sq,p2sq,qsq,mh,mfm,mw)&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c12f(p1sq,p2sq,qsq,mbH,mfm,mw))&
		-gHp_S*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c12f(p1sq,p2sq,qsq,mh,mfm,mch)&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c12f(p1sq,p2sq,qsq,mbH,mfm,mch))&
		+gGp_P*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfm*c12f(p1sq,p2sq,qsq,mA,mfm,mw)&
	)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_V2 = Gam_Hpffp_V2&
		+1.d0/(16.d0*pi**2)*(&
			+2.d0*(g*sw)**2*Qfp*Qfm*gHp_S*(mfp*c12f(p1sq,p2sq,qsq,mfm,mphoton,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mphoton,mfp)+c0f(p1sq,p2sq,qsq,mfm,mphoton,mfp)))&
			+(g*sw)**2*gHp_S*(&
				+Qfp*mfp*(c12f(p1sq,p2sq,qsq,mch,mfp,mphoton)-c0f(p1sq,p2sq,qsq,mch,mfp,mphoton))&
				-Qfm*mfm*(c12f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_V2 = Gam_Hpffp_V2&
		+1.d0/(16.d0*pi**2)*(&
			-Qfm*mfm*(g*sw)**2*gHp_S*(c12f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_A2(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_A2=&
	+1.d0/(16.d0*pi**2)*(&
		-gz**2*(&
			+2.d0*gHp_S*(afp*vfm+vfp*afm)*(mfp*c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
			-2.d0*gHp_P*(vfp*vfm+afp*afm)*(mfp*c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)&
				-mfm*(c12f(p1sq,p2sq,qsq,mfm,mZ,mfp)+c0f(p1sq,p2sq,qsq,mfm,mZ,mfp)))&
		)&
!
		-g**2*mfp/4.d0/sqrt(2.d0)*(&
			-ghfp*cos(beta-alpha)*(c12f(p1sq,p2sq,qsq,mW,mfp,mh)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mh))&
			+gbHfp*sin(beta-alpha)*(c12f(p1sq,p2sq,qsq,mW,mfp,mbH)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mbH))&
			+ii*gAfp*(c12f(p1sq,p2sq,qsq,mW,mfp,mA)&
				+2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mA))&
		)&
!
		+g**2*mfm/4.d0/sqrt(2.d0)*(&
  			-ghfm*cos(beta-alpha)*(c12f(p1sq,p2sq,qsq,mh,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mh,mfm,mW))&
			+gbHfm*sin(beta-alpha)*(c12f(p1sq,p2sq,qsq,mbH,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mbH,mfm,mW))&
			-ii*gAfm*(c12f(p1sq,p2sq,qsq,mA,mfm,mW)&
				-c0f(p1sq,p2sq,qsq,mA,mfm,mW))&
		)&
!
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+mfp*(vfp*gHp_P-afp*gHp_S)*(c12f(p1sq,p2sq,qsq,mch,mfp,mZ)&
				-c0f(p1sq,p2sq,qsq,mch,mfp,mZ))&
			+mfm*(vfm*gHp_P+afm*gHp_S)*(c12f(p1sq,p2sq,qsq,mZ,mfm,mch)&
				+2.d0*c0f(p1sq,p2sq,qsq,mZ,mfm,mch))&
		)&
!
		+gHp_P*(&
			+ghfp*ghfm*(-mfp*c12f(p1sq,p2sq,qsq,mfm,mh,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mh,mfp)+c0f(p1sq,p2sq,qsq,mfm,mh,mfp)))&
			+gbHfp*gbHfm*(-mfp*c12f(p1sq,p2sq,qsq,mfm,mbH,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mbH,mfp)+c0f(p1sq,p2sq,qsq,mfm,mbH,mfp)))&
			-gAfp*gAfm*(-mfp*c12f(p1sq,p2sq,qsq,mfm,mA,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mA,mfp)+c0f(p1sq,p2sq,qsq,mfm,mA,mfp)))&
			-gGfp*gGfm*(-mfp*c12f(p1sq,p2sq,qsq,mfm,mz,mfp)&
				+mfm*(c12f(p1sq,p2sq,qsq,mfm,mz,mfp)+c0f(p1sq,p2sq,qsq,mfm,mz,mfp)))&
		)&
!
		-gGp_P*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c12f(p1sq,p2sq,qsq,mw,mfp,mh)&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c12f(p1sq,p2sq,qsq,mw,mfp,mbH))&
		-gHp_P*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfp*c12f(p1sq,p2sq,qsq,mch,mfp,mh)&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfp*c12f(p1sq,p2sq,qsq,mch,mfp,mbH))&
		+gGp_S*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfp*c12f(p1sq,p2sq,qsq,mw,mfp,mA)&
!
		+gGp_P*(&
			+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c12f(p1sq,p2sq,qsq,mh,mfm,mw)&
			+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c12f(p1sq,p2sq,qsq,mbH,mfm,mw))&
		+gHp_P*(&
			+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*ghfm*c12f(p1sq,p2sq,qsq,mh,mfm,mch)&
			+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*gbHfm*c12f(p1sq,p2sq,qsq,mbH,mfm,mch))&
		-gGp_S*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*gAfm*c12f(p1sq,p2sq,qsq,mA,mfm,mw)&
		)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_A2 = Gam_Hpffp_A2&
		+1.d0/(16.d0*pi**2)*(&
			+2.d0*(g*sw)**2*Qfp*Qfm*gHp_P*(mfp*c12f(p1sq,p2sq,qsq,mfm,mphoton,mfp)&
				-mfm*(c12f(p1sq,p2sq,qsq,mfm,mphoton,mfp)+c0f(p1sq,p2sq,qsq,mfm,mphoton,mfp)))&
		+(g*sw)**2*gHp_P*(&
			+Qfp*mfp*(c12f(p1sq,p2sq,qsq,mch,mfp,mphoton)-c0f(p1sq,p2sq,qsq,mch,mfp,mphoton))&
			+Qfm*mfm*(c12f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_A2 = Gam_Hpffp_A2&
		+1.d0/(16.d0*pi**2)*(&
			+Qfm*mfm*(g*sw)**2*gHp_P*(c12f(p1sq,p2sq,qsq,mphoton,mfm,mch)+2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_T(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_T=&
	+1.d0/(16.d0*pi**2)*(&
		+g**2/4.d0/sqrt(2.d0)*(&
			-ghfp*cos(beta-alpha)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mh)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mh)-c12f(p1sq,p2sq,qsq,mW,mfp,mh))&
			+gbHfp*sin(beta-alpha)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mbH)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mbH)-c12f(p1sq,p2sq,qsq,mW,mfp,mbH))&
			-ii*gAfp*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mA)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mA)-c12f(p1sq,p2sq,qsq,mW,mfp,mA))&
		)&
!
		-g**2/4.d0/sqrt(2.d0)*(&
  			-ghfm*cos(beta-alpha)*(c0f(p1sq,p2sq,qsq,mh,mfm,mW)&
				+c11f(p1sq,p2sq,qsq,mh,mfm,mW)-2.d0*c12f(p1sq,p2sq,qsq,mh,mfm,mW))&
			+gbHfm*sin(beta-alpha)*(c0f(p1sq,p2sq,qsq,mbH,mfm,mW)&
				+c11f(p1sq,p2sq,qsq,mbH,mfm,mW)-2.d0*c12f(p1sq,p2sq,qsq,mbH,mfm,mW))&
			+ii*gAfm*(c0f(p1sq,p2sq,qsq,mA,mfm,mW)&
				+c11f(p1sq,p2sq,qsq,mA,mfm,mW)-2.d0*c12f(p1sq,p2sq,qsq,mA,mfm,mW))&
		)&
!
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+(vfp*gHp_S+afp*gHp_P)*(c0f(p1sq,p2sq,qsq,mch,mfp,mZ)&
			 +c11f(p1sq,p2sq,qsq,mch,mfp,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mZ))&
			-(vfm*gHp_S-afm*gHp_P)*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mfm,mch)&
			 +2.d0*c11f(p1sq,p2sq,qsq,mZ,mfm,mch)-c12f(p1sq,p2sq,qsq,mZ,mfm,mch))&
		)&
!
		+gHp_S*(&
			+ghfp*ghfm*(c11f(p1sq,p2sq,qsq,mfm,mh,mfp)-c12f(p1sq,p2sq,qsq,mfm,mh,mfp))&
			+gbHfp*gbHfm*(c11f(p1sq,p2sq,qsq,mfm,mbH,mfp)-c12f(p1sq,p2sq,qsq,mfm,mbH,mfp))&
			+gAfp*gAfm*(c11f(p1sq,p2sq,qsq,mfm,mA,mfp)-c12f(p1sq,p2sq,qsq,mfm,mA,mfp))&
			+gGfp*gGfm*(c11f(p1sq,p2sq,qsq,mfm,mz,mfp)-c12f(p1sq,p2sq,qsq,mfm,mz,mfp)))&
		)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_T = Gam_Hpffp_T&
		+1.d0/(16.d0*pi**2)*(&
			+(g*sw)**2*gHp_S*(&
				+Qfp*(c0f(p1sq,p2sq,qsq,mch,mfp,mphoton)&
			 		+c11f(p1sq,p2sq,qsq,mch,mfp,mphoton)-2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mphoton))&
				-Qfm*(2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)&
			 		+2.d0*c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)-c12f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_T = Gam_Hpffp_T&
		+1.d0/(16.d0*pi**2)*(&
			+(g*sw)**2*gHp_S*(&
				-Qfm*(2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)&
			 		+2.d0*c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)-c12f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_Hpffp_PT(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm
	double precision:: gGp_S,gGp_P,gHp_S,gHp_P,ghfp,ghfm,gbHfp,gbHfm
	complex (kind(0d0)):: gAfp,gAfm,gGfp,gGfm

	gGp_S = (mfp-mfm)/sqrt(2.d0)/vev; gGp_P = -(mfp+mfm)/sqrt(2.d0)/vev
	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		ghfp  = -mfp*xiu(alpha,beta,n)/vev
		ghfm  = -mfm*xid(alpha,beta,n)/vev
		gbHfp = -mfp*xiu_H(alpha,beta,n)/vev
		gbHfm = -mfm*xid_H(alpha,beta,n)/vev
		gAfp  = 2.d0*ii*It*mfp*xiu_A(alpha,beta,n)/vev
		gAfm  = 2.d0*ii*Ib*mfm*xid_A(alpha,beta,n)/vev
		gGfp  = 2.d0*ii*It*mfp/vev
		gGfm  = 2.d0*ii*Ib*mfm/vev
	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		gHp_S = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		gHp_P = -mfm*xil_A(alpha,beta,n)/sqrt(2.d0)/vev
		ghfp  = 0.d0
		ghfm  = -mfm*xil(alpha,beta,n)/vev
		gbHfp = 0.d0
		gbHfm = -mfm*xil_H(alpha,beta,n)/vev
		gAfp  = 0.d0
		gAfm  = 2.d0*ii*Ie*mfm*xil_A(alpha,beta,n)/vev
		gGfp  = 0.d0
		gGfm  = 2.d0*ii*Ie*mfm/vev
	endif

	Gam_Hpffp_PT=&
	+1.d0/(16.d0*pi**2)*(&
		-g**2/4.d0/sqrt(2.d0)*(&
			-ghfp*cos(beta-alpha)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mh)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mh)-c12f(p1sq,p2sq,qsq,mW,mfp,mh))&
			+gbHfp*sin(beta-alpha)*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mbH)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mbH)-c12f(p1sq,p2sq,qsq,mW,mfp,mbH))&
			-ii*gAfp*(2.d0*c0f(p1sq,p2sq,qsq,mW,mfp,mA)&
				+2.d0*c11f(p1sq,p2sq,qsq,mW,mfp,mA)-c12f(p1sq,p2sq,qsq,mW,mfp,mA))&
		)&
!
		-g**2/4.d0/sqrt(2.d0)*(&
  			-ghfm*cos(beta-alpha)*(c0f(p1sq,p2sq,qsq,mh,mfm,mW)&
				+c11f(p1sq,p2sq,qsq,mh,mfm,mW)-2.d0*c12f(p1sq,p2sq,qsq,mh,mfm,mW))&
			+gbHfm*sin(beta-alpha)*(c0f(p1sq,p2sq,qsq,mbH,mfm,mW)&
				+c11f(p1sq,p2sq,qsq,mbH,mfm,mW)-2.d0*c12f(p1sq,p2sq,qsq,mbH,mfm,mW))&
			+ii*gAfm*(c0f(p1sq,p2sq,qsq,mA,mfm,mW)&
				+c11f(p1sq,p2sq,qsq,mA,mfm,mW)-2.d0*c12f(p1sq,p2sq,qsq,mA,mfm,mW))&
		)&
!
		+gz**2*(cw**2-sw**2)/2.d0*(&
			+(vfp*gHp_P+afp*gHp_S)*(c0f(p1sq,p2sq,qsq,mch,mfp,mZ)&
				+c11f(p1sq,p2sq,qsq,mch,mfp,mZ)-2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mZ))&
			-(vfm*gHp_P-afm*gHp_S)*(2.d0*c0f(p1sq,p2sq,qsq,mZ,mfm,mch)&
				+2.d0*c11f(p1sq,p2sq,qsq,mZ,mfm,mch)-c12f(p1sq,p2sq,qsq,mZ,mfm,mch))&
		)&
!
		-gHp_P*(&
			+ghfp*ghfm*(c11f(p1sq,p2sq,qsq,mfm,mh,mfp)-c12f(p1sq,p2sq,qsq,mfm,mh,mfp))&
			+gbHfp*gbHfm*(c11f(p1sq,p2sq,qsq,mfm,mbH,mfp)-c12f(p1sq,p2sq,qsq,mfm,mbH,mfp))&
			+gAfp*gAfm*(c11f(p1sq,p2sq,qsq,mfm,mA,mfp)-c12f(p1sq,p2sq,qsq,mfm,mA,mfp))&
			+gGfp*gGfm*(c11f(p1sq,p2sq,qsq,mfm,mz,mfp)-c12f(p1sq,p2sq,qsq,mfm,mz,mfp)))&
		)

	if(Qfp /= 0.d0) then
		Gam_Hpffp_PT = Gam_Hpffp_PT&
		+1.d0/(16.d0*pi**2)*(&
			+(g*sw)**2*gHp_P*(&
				+Qfp*(c0f(p1sq,p2sq,qsq,mch,mfp,mphoton)&
					 +c11f(p1sq,p2sq,qsq,mch,mfp,mphoton)-2.d0*c12f(p1sq,p2sq,qsq,mch,mfp,mphoton))&
				-Qfm*(2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)&
					 +2.d0*c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)-c12f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	else if(Qfp == 0.d0) then
		Gam_Hpffp_PT = Gam_Hpffp_PT&
		+1.d0/(16.d0*pi**2)*(&
			+(g*sw)**2*gHp_P*(&
				-Qfm*(2.d0*c0f(p1sq,p2sq,qsq,mphoton,mfm,mch)&
					 +2.d0*c11f(p1sq,p2sq,qsq,mphoton,mfm,mch)-c12f(p1sq,p2sq,qsq,mphoton,mfm,mch))))
	endif

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSFV_S(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSFV_S=&
		+b0f(p2sq,m2,m3)&
		+(m1**2-qsq+p2sq)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		-(qsq-p1sq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(qsq-p1sq-2.d0*p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CVFS_S(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CVFS_S=&
		+b0f(p2sq,m2,m3)&
		+(m1**2+2.d0*p1sq)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		+3.d0*p1sq*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq-p1sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CFSF_S(p1sq,p2sq,qsq,m1,m2,m3,mf,mfp)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3,mf,mfp

	CFSF_S=&
		+b0f(p2sq,m2,m3)&
		+(m1**2+mf*mfp)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(qsq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+p2sq*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CFSF_P(p1sq,p2sq,qsq,m1,m2,m3,mf,mfp)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3,mf,mfp

	CFSF_P=&
		+b0f(p2sq,m2,m3)&
		+(m1**2-mf*mfp)*c0f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(qsq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+p2sq*c12f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CFVF_plus(p1sq,p2sq,qsq,m1,m2,m3,mf,mfp)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3,mf,mfp

	CFVF_plus=&
		+4.d0*p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*(qsq-p1sq-p2sq)*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		+16.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-4.d0&
		+2.d0*(qsq+p1sq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq-p1sq+p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*mf*mfp*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CFVF_minus(p1sq,p2sq,qsq,m1,m2,m3,mf,mfp)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3,mf,mfp

	CFVF_minus=&
		+4.d0*p1sq*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*p2sq*c22f(p1sq,p2sq,qsq,m1,m2,m3)&
		+4.d0*(qsq-p1sq-p2sq)*c23f(p1sq,p2sq,qsq,m1,m2,m3)&
		+16.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)-4.d0&
		+2.d0*(qsq+p1sq-p2sq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(qsq-p1sq+p2sq)*c12f(p1sq,p2sq,qsq,m1,m2,m3)&
		-4.d0*mf*mfp*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-------------------------------------------------------------
!   Hpffp renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function rGam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm,xi_fp,xi_fm
	double precision:: gHp_S,gHp_P
	double precision:: del_mfp,del_mfm,del_ZRfp,del_ZLfp,del_ZRfm,del_ZLfm

	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		xi_fp = xiu_A(alpha,beta,n); xi_fm = xid_A(alpha,beta,n)
		gHp_S = (mfp*xi_fp-mfm*xi_fm)/sqrt(2.d0)/vev
		gHp_P = -(mfp*xi_fp+mfm*xi_fm)/sqrt(2.d0)/vev

		if(mfp == mt) then
			del_mfp = del_mt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfp = del_ZRt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLt(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mfp == mc) then
			del_mfp = del_mc(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfp = del_ZRc(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLc(mch,mA,mbH,bmsq,alpha,beta,n)
		endif

		if(mfm == mb) then
			del_mfm = del_mb(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRb(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLb(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mfm == ms) then
			del_mfm = del_ms(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRs(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLs(mch,mA,mbH,bmsq,alpha,beta,n)
		endif

		rGam_Hpffp_S=&
		  +Gam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(gHp_S-gHp_P)/2.d0*(&
			  	+del_mfp/mfp&
			  	-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
			  	-xi_fp*(del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
					+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)/xi_fp&
				+del_ZRfp/2.d0&
				+del_ZLfm/2.d0&
				+del_ZHpm(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0&
				+del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)/xi_fp)&
			+(gHp_S+gHp_P)/2.d0*(&
			  +del_mfm/mfm&
			  -del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
			  -xi_fm*(del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
					+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)/xi_fm&
				+del_ZRfm/2.d0&
				+del_ZLfp/2.d0&
			  +del_ZHpm(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0&
		 		+del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)/xi_fm)

	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		xi_fm = xil_A(alpha,beta,n)
		gHp_S = -mfm*xi_fm/sqrt(2.d0)/vev
		gHp_P = -mfm*xi_fm/sqrt(2.d0)/vev

		if(mfm == mtau) then
			del_ZRfp = del_ZRnt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLnt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_mfm  = del_mtau(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRtau(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLtau(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mfm == mmu) then
			del_ZRfp = del_ZRnm(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLnm(mch,mA,mbH,bmsq,alpha,beta,n)
			del_mfm  = del_mmu(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRmu(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLmu(mch,mA,mbH,bmsq,alpha,beta,n)
		endif

		rGam_Hpffp_S=&
			+Gam_Hpffp_S(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(gHp_S+gHp_P)/2.d0*(&
				+del_mfm/mfm&
				-del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
				-xi_fm*(del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
				+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)/xi_fm&
				+del_ZRfm/2.d0&
				+del_ZLfp/2.d0&
				+del_ZHpm(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0&
				+del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)/xi_fm)
	endif

	end function
!-------------------------------------------------------------
	complex (kind(0d0)) function rGam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfp,mfm
	integer, intent(in):: n

	double precision:: Qfp,Qfm,vfp,afp,vfm,afm,xi_fp,xi_fm
	double precision:: gHp_S,gHp_P
	double precision:: del_mfp,del_mfm,del_ZRfp,del_ZLfp,del_ZRfm,del_ZLfm

	if (mfm == mb .or. mfm == ms) then
		Qfp = Qt; Qfm = Qb
		vfp = vt; afp = at; vfm = vb; afm = ab
		xi_fp = xiu_A(alpha,beta,n); xi_fm = xid_A(alpha,beta,n)
		gHp_S = (mfp*xiu_A(alpha,beta,n)-mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev
		gHp_P = -(mfp*xiu_A(alpha,beta,n)+mfm*xid_A(alpha,beta,n))/sqrt(2.d0)/vev

		if(mfp == mt) then
			del_mfp = del_mt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfp = del_ZRt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLt(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mfp == mc) then
			del_mfp = del_mc(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfp = del_ZRc(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLc(mch,mA,mbH,bmsq,alpha,beta,n)
		endif

		if(mfm == mb) then
			del_mfm = del_mb(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRb(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLb(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mfm == ms) then
			del_mfm = del_ms(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRs(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLs(mch,mA,mbH,bmsq,alpha,beta,n)
		endif

		rGam_Hpffp_P=&
		  +Gam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			-(gHp_S-gHp_P)/2.d0*(&
			  +del_mfp/mfp&
			  -del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
			  -xi_fp*(del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
					+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)/xi_fp&
				+del_ZRfp/2.d0&
				+del_ZLfm/2.d0&
				+del_ZHpm(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0&
				+del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)/xi_fp)&
			+(gHp_S+gHp_P)/2.d0*(&
			  +del_mfm/mfm&
			  -del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
			  -xi_fm*(del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
					+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)/xi_fm&
				+del_ZRfm/2.d0&
				+del_ZLfp/2.d0&
		  	+del_ZHpm(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0&
		 		+del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)/xi_fm)

	elseif (mfm == mtau .or. mfm == mmu) then
		Qfp = 0.d0; Qfm = Qe
		vfp = vnu; afp = anu; vfm = ve; afm = ae
		xi_fm = xil_A(alpha,beta,n)
		gHp_S = -mfm*xi_fm/sqrt(2.d0)/vev
		gHp_P = -mfm*xi_fm/sqrt(2.d0)/vev

		if(mfm == mtau) then
			del_ZRfp = del_ZRnt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLnt(mch,mA,mbH,bmsq,alpha,beta,n)
			del_mfm = del_mtau(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRtau(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLtau(mch,mA,mbH,bmsq,alpha,beta,n)
		else if(mfm == mmu) then
			del_ZRfp = del_ZRnm(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfp = del_ZLnm(mch,mA,mbH,bmsq,alpha,beta,n)
			del_mfm  = del_mmu(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZRfm = del_ZRmu(mch,mA,mbH,bmsq,alpha,beta,n)
			del_ZLfm = del_ZLmu(mch,mA,mbH,bmsq,alpha,beta,n)
		endif

		rGam_Hpffp_P=&
		  +Gam_Hpffp_P(p1sq,p2sq,qsq,alpha,beta,n,mfp,mfm)&
			+(gHp_S+gHp_P)/2.d0*(&
			  +del_mfm/mfm&
			  -del_v(mch,mA,mbH,bmsq,alpha,beta,n)/vev&
			  -xi_fm*(del_beta(mch,mA,mbH,bmsq,alpha,beta,n)&
					+del_beta_PT(mch,mA,mbH,bmsq,alpha,beta))&
				-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)/xi_fm&
				+del_ZRfm/2.d0&
				+del_ZLfp/2.d0&
		  	+del_ZHpm(mch,mA,mbH,bmsq,alpha,beta,n)/2.d0&
			 	+del_CHpm(mch,mA,mbH,bmsq,alpha,beta,n)/xi_fm)
	endif

	end function
!-------------------------------------------------------------
!     hWHp 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_hWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in):: n
	double precision:: gHp_L,gHp_R,ghuu,ghdd

	if (mu == mt .or. mu == mc) then
		gHp_L = -sqrt(2.d0)*mu*xiu_A(alpha,beta,n)/vev
		ghuu  = mu*xiu(alpha,beta,n)/vev
	elseif (mu == m0) then
		gHp_L = 0.d0
		ghuu  = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = sqrt(2.d0)*md*xid_A(alpha,beta,n)/vev
		ghdd  = md*xid(alpha,beta,n)/vev
	elseif (md == mtau .or. md == mmu) then
		gHp_R = sqrt(2.d0)*md*xil_A(alpha,beta,n)/vev
		ghdd  = md*xil(alpha,beta,n)/vev
	endif

	Gam_hWHp_fermion=&
		-g/sqrt(2.d0)/(16.d0*pi**2)*(&
		-ghuu*(gHp_L*(b0f(p2sq,mu,md)+mu**2*(2.d0*c11f(p1sq,p2sq,qsq,mu,mu,md)+3.d0*c0f(p1sq,p2sq,qsq,mu,mu,md))&
		+p1sq*(c11f(p1sq,p2sq,qsq,mu,mu,md)-c12f(p1sq,p2sq,qsq,mu,mu,md))+qsq*c12f(p1sq,p2sq,qsq,mu,mu,md))&
		+mu*md*gHp_R*(2.d0*c11f(p1sq,p2sq,qsq,mu,mu,md)+c0f(p1sq,p2sq,qsq,mu,mu,md)))&
		!
		+ghdd*(gHp_R*(b0f(p2sq,md,mu)+md**2*(2.d0*c11f(p1sq,p2sq,qsq,md,md,mu)+3.d0*c0f(p1sq,p2sq,qsq,md,md,mu))&
		+p1sq*(c11f(p1sq,p2sq,qsq,md,md,mu)-c12f(p1sq,p2sq,qsq,md,md,mu))+qsq*c12f(p1sq,p2sq,qsq,md,md,mu))&
		+mu*md*gHp_L*(2.d0*c11f(p1sq,p2sq,qsq,md,md,mu)+c0f(p1sq,p2sq,qsq,md,md,mu)))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hWHp_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam_hWHp_F=&
		+Nc*Gam_hWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam_hWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam_hWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mtau)&
		+Gam_hWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_hWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam_hWHp_B=&
		1.d0/(16.d0*pi**2)*(&
		!SVV
		-g**3*cos(beta-alpha)/8.d0*(&
		+CSVV_SWHp(p1sq,p2sq,qsq,mA,mZ,mW)&
		+(cw**2-sw**2)*CSVV_SWHp(p1sq,p2sq,qsq,mch,mW,mZ)&
		+2.d0*sw**2*CSVV_SWHp(p1sq,p2sq,qsq,mch,mW,mphoton))&
   	!VSS
		-g**3/8.d0*cos(beta-alpha)*(&
		+cos(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mh)&
		+sin(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mw,mh)&
		+sin(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mbH)&
		-sin(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mw,mbH)&
		-CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mA)&
		-(cw**2-sw**2)/cw**2*CVSS_SWHp(p1sq,p2sq,qsq,mZ,mA,mch))&
   	!SV
		+g**3*cos(beta-alpha)/8.d0*(&
		+b0f(qsq,mh,mW)-b1f(qsq,mh,mW)&
		-sw**2/cw**2*(cw**2-sw**2)*(b0f(qsq,mch,mZ)-b1f(qsq,mch,mZ))&
		+2.d0*sw**2*(b0f(qsq,mch,mphoton)-b1f(qsq,mch,mphoton))&
		!----- modified 2023/9/1 -----
		! +b0f(qsq,mch,mW)-b1f(qsq,mch,mW)&
		+b0f(p1sq,mch,mW)-b1f(p1sq,mch,mW)&
		!-----------------------------
		+sw**2/cw**2*(b0f(p1sq,mA,mZ)-b1f(p1sq,mA,mZ)))&
		!VVS
		+g**3*mw**2*sin(beta-alpha)**2*cos(beta-alpha)/4.d0*(&
		+c11f(p1sq,p2sq,qsq,mW,mW,mh)+2.d0*c0f(p1sq,p2sq,qsq,mW,mW,mh)&
		-c11f(p1sq,p2sq,qsq,mW,mW,mbH)-2.d0*c0f(p1sq,p2sq,qsq,mW,mW,mbH))&
		!SSV
		-g**2*mW/4.d0*(&
		+sw**2/cw**2*ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mA,mZ,mw)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mw,mW,mh)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mW,mh)&
		+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mw,mW,mbH)&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mch,mW,mbH)&
		+6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mh,mh,mW)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mbH,mh,mW)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mbH,mbH,mW)&
		+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mh,mbH,mW)&
		-sw**2/cw**2*(cw**2-sw**2)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mw,mZ)&
		+2.d0*sw**2*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mw,mphoton))&
		!SSS
		-g/2.d0*(&
		-6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mh,mch)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mh,mch)&
		+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mbH,mch)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mbH,mch)&
		-6.d0*lam_hhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mh,mw)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mh,mw)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mbH,mw)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mbH,mw)&
		!---- added 2023/9/1 ----
		+(ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))*lam_AGh(mch,mA,mbH,bmsq,alpha,beta)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mA,mz,mw)&
		!------------------------
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)**2*cos(beta-alpha)*CSSS_SWHp(p1sq,p2sq,qsq,mch,mch,mh)&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mch,mch,mbH)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)**2*cos(beta-alpha)*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mh)&
		-lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mbH)&
		-ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mA)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*CSSS_SWHp(p1sq,p2sq,qsq,mch,mw,mh)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*CSSS_SWHp(p1sq,p2sq,qsq,mch,mw,mbH)&
		+lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*CSSS_SWHp(p1sq,p2sq,qsq,mw,mw,mh)&
		+lam_GpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*CSSS_SWHp(p1sq,p2sq,qsq,mw,mw,mbH))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSVV_SWHp(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSVV_SWHp=&
		+4.d0*b0f(p2sq,m2,m3)-4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)&
		-(3.d0*p1sq-p2sq+qsq)*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		+2.d0*(p1sq-qsq)*(c12f(p1sq,p2sq,qsq,m1,m2,m3)+c23f(p1sq,p2sq,qsq,m1,m2,m3))&
		-(p1sq+2.d0*p2sq-qsq)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(p2sq+4.d0*m1**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CVSS_SWHp(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CVSS_SWHp=&
		+4.d0*c24f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(3.d0*p1sq-p2sq+qsq)*c21f(p1sq,p2sq,qsq,m1,m2,m3)&
		-2.d0*(p1sq-qsq)*(c12f(p1sq,p2sq,qsq,m1,m2,m3)+c23f(p1sq,p2sq,qsq,m1,m2,m3))&
		+(5.d0*p1sq-3.d0*p2sq+3.d0*qsq+m1**2)*c11f(p1sq,p2sq,qsq,m1,m2,m3)&
		+(2.d0*p1sq-2.d0*p2sq+2.d0*qsq+m1**2)*c0f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSVS_SWHp(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSVS_SWHp=c0f(p1sq,p2sq,qsq,m1,m2,m3)-c11f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSSV_SWHp(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSSV_SWHp=c0f(p1sq,p2sq,qsq,m1,m2,m3)-c11f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function CSSS_SWHp(p1sq,p2sq,qsq,m1,m2,m3)
	double precision, intent(in):: qsq,p1sq,p2sq,m1,m2,m3

	CSSS_SWHp=c0f(p1sq,p2sq,qsq,m1,m2,m3)+c11f(p1sq,p2sq,qsq,m1,m2,m3)

	end function
!-------------------------------------------------------------
!     hWHp renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function rGam_hWHp_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	rGam_hWHp_F=&
		Gam_hWHp_F(p1sq,p2sq,qsq,alpha,beta,n)&
		-mw/vev*cos(beta-alpha)*(&
		del_mWsq_F(alpha,beta,n)/(2.d0*mw**2)-del_v_F(alpha,beta,n)/vev&
			+(del_ZW_F(alpha,beta,n)+del_ZHpm_F(mch,alpha,beta,n)+del_Zh_F(alpha,beta,n))/2.d0&
			+tan(beta-alpha)*(del_CHpm_F(mch,mA,mbH,bmsq,alpha,beta,n)-del_Ch_F(mbH,alpha,beta,n))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function	rGam_hWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	! rGam_hWHp_B=&
	! 	+Gam_hWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
	! 	-mw/vev*cos(beta-alpha)*(&
	! 		+del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/(2.d0*mw**2)&
	! 		-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
	! 	  +(del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)+del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)+del_Zh_B(mch,mA,mbH,bmsq,alpha,beta))/2.d0&
	! 	  +tan(beta-alpha)*(del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)-del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta)&
	! 		+del_CHpm_B(mch,mA,mbH,bmsq,alpha,beta)-del_Ch_B(mch,mA,mbH,bmsq,alpha,beta))&
	! 	)

	rGam_hWHp_B=&
		+Gam_hWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		-mW/vev*cos(beta-alpha)*(&
			+del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/(2.d0*mw**2)&
			-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
			+(del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)+del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)+del_Zh_B(mch,mA,mbH,bmsq,alpha,beta))/2.d0&
			+tan(beta-alpha)*(del_CHpm_B(mch,mA,mbH,bmsq,alpha,beta)-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
			-del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function	rGam_hWHp(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_hWHp=rGam_hWHp_F(p1sq,p2sq,qsq,alpha,beta,n)+rGam_hWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!-------------------------------------------------------------
!     bHWHp 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in):: n
	double precision:: gHp_L,gHp_R,gbHuu,gbHdd

	if (mu == mt .or. mu == mc) then
		gHp_L = -sqrt(2.d0)*mu*xiu_A(alpha,beta,n)/vev
		gbHuu  = mu*xiu_H(alpha,beta,n)/vev
	elseif (mu == m0) then
		gHp_L = 0.d0
		gbHuu  = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = sqrt(2.d0)*md*xid_A(alpha,beta,n)/vev
		gbHdd  = md*xid_H(alpha,beta,n)/vev
	elseif (md == mtau .or. md == mmu) then
		gHp_R = sqrt(2.d0)*md*xil_A(alpha,beta,n)/vev
		gbHdd  = md*xil_H(alpha,beta,n)/vev
	endif

	Gam_bHWHp_fermion=&
		-g/sqrt(2.d0)/(16.d0*pi**2)*(&
		-gbHuu*(gHp_L*(b0f(p2sq,mu,md)+mu**2*(2.d0*c11f(p1sq,p2sq,qsq,mu,mu,md)+3.d0*c0f(p1sq,p2sq,qsq,mu,mu,md))&
		+p1sq*(c11f(p1sq,p2sq,qsq,mu,mu,md)-c12f(p1sq,p2sq,qsq,mu,mu,md))+qsq*c12f(p1sq,p2sq,qsq,mu,mu,md))&
		+mu*md*gHp_R*(2.d0*c11f(p1sq,p2sq,qsq,mu,mu,md)+c0f(p1sq,p2sq,qsq,mu,mu,md)))&
!
		+gbHdd*(gHp_R*(b0f(p2sq,md,mu)+md**2*(2.d0*c11f(p1sq,p2sq,qsq,md,md,mu)+3.d0*c0f(p1sq,p2sq,qsq,md,md,mu))&
		+p1sq*(c11f(p1sq,p2sq,qsq,md,md,mu)-c12f(p1sq,p2sq,qsq,md,md,mu))+qsq*c12f(p1sq,p2sq,qsq,md,md,mu))&
		+mu*md*gHp_L*(2.d0*c11f(p1sq,p2sq,qsq,md,md,mu)+c0f(p1sq,p2sq,qsq,md,md,mu)))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHWHp_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam_bHWHp_F=&
		+Nc*Gam_bHWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam_bHWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam_bHWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mtau)&
		+Gam_bHWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_bHWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam_bHWHp_B=&
		1.d0/(16.d0*pi**2)*(& 
		!SVV
		+g**3*sin(beta-alpha)/8.d0*(&
		+CSVV_SWHp(p1sq,p2sq,qsq,mA,mZ,mW)&
		+(cw**2-sw**2)*CSVV_SWHp(p1sq,p2sq,qsq,mch,mW,mZ)&
		+2.d0*sw**2*CSVV_SWHp(p1sq,p2sq,qsq,mch,mW,mphoton))&
   	!VSS
		+g**3/8.d0*sin(beta-alpha)*(&
		+cos(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mh)&
		-cos(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mw,mh)&
		+sin(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mbH)&
		+cos(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mw,mbH)&
		-CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mA)&
		-(cw**2-sw**2)/cw**2*CVSS_SWHp(p1sq,p2sq,qsq,mZ,mA,mch))&
   	!SV
		-g**3*sin(beta-alpha)/8.d0*(&
		+b0f(qsq,mbH,mW)-b1f(qsq,mbH,mW)&
		-sw**2/cw**2*(cw**2-sw**2)*(b0f(qsq,mch,mZ)-b1f(qsq,mch,mZ))&
		+2.d0*sw**2*(b0f(qsq,mch,mphoton)-b1f(qsq,mch,mphoton))&
		!----- modified 2023/9/1 -----
		! +b0f(qsq,mch,mW)-b1f(qsq,mch,mW)&
		+b0f(p1sq,mch,mW)-b1f(p1sq,mch,mW)&
		!-----------------------------
		+sw**2/cw**2*(b0f(p1sq,mA,mZ)-b1f(p1sq,mA,mZ)))&
		!VVS
		+g**3*mw**2*sin(beta-alpha)*cos(beta-alpha)**2/4.d0*(&
		+c11f(p1sq,p2sq,qsq,mW,mW,mh)+2.d0*c0f(p1sq,p2sq,qsq,mW,mW,mh)&
		-c11f(p1sq,p2sq,qsq,mW,mW,mbH)-2.d0*c0f(p1sq,p2sq,qsq,mW,mW,mbH))&
		!SSV
		-g**2*mW/4.d0*(&
		-sw**2/cw**2*ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mA,mZ,mw)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mw,mW,mh)&
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mch,mW,mh)&
		+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mw,mW,mbH)&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mW,mbH)&
		+2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mh,mh,mW)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mbH,mh,mW)&
		-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mbH,mbH,mW)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)**2*CSSV_SWHp(p1sq,p2sq,qsq,mh,mbH,mW)&
		-sw**2/cw**2*(cw**2-sw**2)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mw,mZ)&
		+2.d0*sw**2*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mw,mphoton))&
   	!SSS
		-g/2.d0*(&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mh,mch)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mh,mch)&
		+2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mbH,mch)&
		+6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mbH,mch)&
		-2.d0*lam_bHhh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mh,mw)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mh,mw)&
		-2.d0*lam_bHbHh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mbH,mw)&
		-6.d0*lam_bHbHbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mbH,mw)&
		!---- added 2023/9/1 ----
		+(ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))*lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mA,mz,mw)&
		!------------------------
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mch,mch,mh)&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)**2*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mch,mch,mbH)&
		+lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mh)&
		-lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)**2*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mbH)&
		-ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mA)&
		+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mch,mw,mh)&
		+lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mch,mw,mbH)&
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mw,mh)&
		+lam_GpGmbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mw,mbH))&
		)

	end function
!-------------------------------------------------------------
!     bHWHp renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function	rGam_bHWHp_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	rGam_bHWHp_F=&
		Gam_bHWHp_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+mw/vev*sin(beta-alpha)&
		 *(del_mWsq_F(alpha,beta,n)/(2.d0*mw**2)-del_v_F(alpha,beta,n)/vev&
		  +(del_ZW_F(alpha,beta,n)+del_ZHpm_F(mch,alpha,beta,n)+del_ZbH_F(mbH,alpha,beta,n))/2.d0&
		  -1.d0/tan(beta-alpha)*(del_CHpm_F(mch,mA,mbH,bmsq,alpha,beta,n)+del_Ch_F(mbH,alpha,beta,n))&
		 )

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function	rGam_bHWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	! rGam_bHWHp_B=&
	! 	Gam_bHWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
	! 	+mw/vev*sin(beta-alpha)&
	! 	 *(del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/(2.d0*mw**2)-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
	! 		+(del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)+del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)&
	! 			+del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta))/2.d0&
	! 	  +1.d0/tan(beta-alpha)*(del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta)&
	! 		-del_CHpm_B(mch,mA,mbH,bmsq,alpha,beta)-del_Ch_B(mch,mA,mbH,bmsq,alpha,beta))&
	! 	 )

	rGam_bHWHp_B=&
		Gam_bHWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+mw/vev*sin(beta-alpha)&
		 *(del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/(2.d0*mw**2)-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
			+(del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)+del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)&
				+del_ZbH_B(mch,mA,mbH,bmsq,alpha,beta))/2.d0&
		  -1.d0/tan(beta-alpha)*(del_CHpm_B(mch,mA,mbH,bmsq,alpha,beta)-del_beta_PT(mch,mA,mbH,bmsq,alpha,beta)&
			+del_Ch_B(mch,mA,mbH,bmsq,alpha,beta)+del_alpha_PT(mch,mA,mbH,bmsq,alpha,beta))&
		 )

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function	rGam_bHWHp(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_bHWHp=rGam_bHWHp_F(p1sq,p2sq,qsq,alpha,beta,n)+rGam_bHWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!-------------------------------------------------------------
!     AWHp 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam_AWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mfu,mfd)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mfu,mfd
	integer, intent(in):: n
	double precision:: gHp_L,gHp_R
	complex (kind(0d0)):: gSfu,gSfd

	if (mfu == mt .or. mfu == mc) then
		gHp_L = -sqrt(2.d0)*mfu*xiu_A(alpha,beta,n)/vev
		gSfu  = -ii*mfu*xiu_A(alpha,beta,n)/vev
	elseif (mfu == m0) then
		gHp_L = 0.d0
		gSfu  = 0.d0
	endif

	if (mfd == mb .or. mfd == ms) then
		gHp_R = sqrt(2.d0)*mfd*xid_A(alpha,beta,n)/vev
		gSfd  = ii*mfd*xid_A(alpha,beta,n)/vev
	elseif (mfd == mtau .or. mfd == mmu) then
		gHp_R = sqrt(2.d0)*mfd*xil_A(alpha,beta,n)/vev
		gSfd  = ii*mfd*xil_A(alpha,beta,n)/vev
	endif

	Gam_AWHp_fermion=&
		g/sqrt(2.d0)/(16.d0*pi**2)*(&
		+gSfu*(gHp_L*(b0f(p2sq,mfu,mfd)+mfu**2*c0f(p1sq,p2sq,qsq,mfu,mfu,mfd)&
		+p1sq*(c11f(p1sq,p2sq,qsq,mfu,mfu,mfd)-c12f(p1sq,p2sq,qsq,mfu,mfu,mfd))&
		+qsq*c12f(p1sq,p2sq,qsq,mfu,mfu,mfd))&
		+mfu*mfd*gHp_R*c0f(p1sq,p2sq,qsq,mfu,mfu,mfd))&
!
		+gSfd*(gHp_R*(b0f(p2sq,mfd,mfu)+mfd**2*c0f(p1sq,p2sq,qsq,mfd,mfd,mfu)&
		+p1sq*(c11f(p1sq,p2sq,qsq,mfd,mfd,mfu)-c12f(p1sq,p2sq,qsq,mfd,mfd,mfu))&
		+qsq*c12f(p1sq,p2sq,qsq,mfd,mfd,mfu))&
		+mfu*mfd*gHp_L*c0f(p1sq,p2sq,qsq,mfd,mfd,mfu))&
		)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AWHp_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam_AWHp_F=&
		+Nc*Gam_AWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam_AWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam_AWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mtau)&
		+Gam_AWHp_fermion(p1sq,p2sq,qsq,alpha,beta,n,m0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam_AWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam_AWHp_B=&
		ii/(16.d0*pi**2)*(&
		!SVV
		+g**3/8.d0*(&
		+cos(beta-alpha)**2*CSVV_SWHp(p1sq,p2sq,qsq,mh,mZ,mW)&
		+sin(beta-alpha)**2*CSVV_SWHp(p1sq,p2sq,qsq,mbH,mZ,mW)&
		+(cw**2-sw**2)*CSVV_SWHp(p1sq,p2sq,qsq,mch,mW,mZ)&
		+2.d0*sw**2*CSVV_SWHp(p1sq,p2sq,qsq,mch,mW,mphoton)*QED)&
   	!VSS
		-g**3/8.d0*(&
		+cos(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mh)&
		+sin(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mbH)&
		-CVSS_SWHp(p1sq,p2sq,qsq,mW,mch,mA)&
		+(cw**2-sw**2)/cw**2*cos(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mZ,mh,mch)&
		+(cw**2-sw**2)/cw**2*sin(beta-alpha)**2*CVSS_SWHp(p1sq,p2sq,qsq,mZ,mbH,mch))&
		!SV
		-g**3/8.d0*(&
		+b0f(qsq,mA,mW)-b1f(qsq,mA,mW)&
		-sw**2/cw**2*(cw**2-sw**2)*(b0f(qsq,mch,mZ)-b1f(qsq,mch,mZ))&
		+2.d0*sw**2*(b0f(qsq,mch,mphoton)-b1f(qsq,mch,mphoton))*QED&
		+b0f(p1sq,mch,mW)-b1f(p1sq,mch,mW)&
		+sw**2/cw**2*cos(beta-alpha)**2*(b0f(p1sq,mh,mZ)-b1f(p1sq,mh,mZ))&
		+sw**2/cw**2*sin(beta-alpha)**2*(b0f(p1sq,mbH,mZ)-b1f(p1sq,mbH,mZ)))&
		!SVS
		+g**2*mW/4.d0*(&
		+sw**2/cw**2*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*CSVS_SWHp(p1sq,p2sq,qsq,mh,mZ,mw)&
		-sw**2/cw**2*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*CSVS_SWHp(p1sq,p2sq,qsq,mbH,mZ,mw)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*CSVS_SWHp(p1sq,p2sq,qsq,mch,mW,mh)&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*CSVS_SWHp(p1sq,p2sq,qsq,mch,mW,mbH))&
		!SSV
		+g**2*mW/4.d0*(&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mA,mh,mW)&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)*CSSV_SWHp(p1sq,p2sq,qsq,mA,mbH,mW)&
		-ii*sw**2/cw**2*(cw**2-sw**2)*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mw,mZ)&
		+2.d0*ii*sw**2*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*CSSV_SWHp(p1sq,p2sq,qsq,mch,mw,mphoton)*QED)&
   	!SSS
		-g/2.d0*(&
		+2.d0*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mA,mch)&
		+2.d0*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mA,mch)&
		+2.d0*ii*lam_AAh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mA,mh,mw)&
		+2.d0*ii*lam_AAbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mA,mbH,mw)&
		-ii*conjg(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mh)&
		+ii*conjg(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mbH)&
		-lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*conjg(lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta))&
		*CSSS_SWHp(p1sq,p2sq,qsq,mw,mch,mA)&
		+lam_AGh(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmh(mch,mA,mbH,bmsq,alpha,beta)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mh,mz,mw)&
		+lam_AGbH(mch,mA,mbH,bmsq,alpha,beta)*lam_HpGmbH(mch,mA,mbH,bmsq,alpha,beta)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mbH,mz,mw)&
		-ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*sin(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mch,mw,mh)&
		-ii*lam_HpGmA(mch,mA,mbH,bmsq,alpha,beta)*lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*cos(beta-alpha)&
		*CSSS_SWHp(p1sq,p2sq,qsq,mch,mw,mbH))&
		)

	end function
!-------------------------------------------------------------
!     AWHp renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function	rGam_AWHp_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	rGam_AWHp_F=&
		Gam_AWHp_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+ii*mw/vev&
		 *(del_mWsq_F(alpha,beta,n)/(2.d0*mw**2)-del_v_F(alpha,beta,n)/vev&
		  +(del_ZW_F(alpha,beta,n)+del_ZHpm_F(mch,alpha,beta,n)+del_ZA_F(mA,alpha,beta,n))/2.d0&
		 )

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function	rGam_AWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta

	rGam_AWHp_B=&
		Gam_AWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+ii*mw/vev&
		 *(del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)/(2.d0*mw**2)-del_v_B(mch,mA,mbH,bmsq,alpha,beta)/vev&
			+(del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)+del_ZHpm_B(mch,mA,mbH,bmsq,alpha,beta)&
				+del_ZA_B(mch,mA,mbH,bmsq,alpha,beta))/2.d0&
		 )

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function	rGam_AWHp(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam_AWHp=rGam_AWHp_F(p1sq,p2sq,qsq,alpha,beta,n)+rGam_AWHp_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!-------------------------------------------------------------
!     HpWZ 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam1_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in)::n
	double precision:: gHp_L,gHp_R,gu_L,gu_R,gd_L,gd_R

	if (mu == mt .or. mu == mc) then
		gHp_L = mu*xiu_A(alpha,beta,n)/mW
		gu_L  = vt+at
		gu_R  = vt-at
	elseif (mu == 0.d0) then
		gHp_L = 0.d0
		gu_L  = 0.5d0
		gu_R  = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = -md*xid_A(alpha,beta,n)/mW
		gd_L  = vb+ab
		gd_R  = vb-ab
	elseif (md == mtau .or. md == mmu) then
		gHp_R = -md*xil_A(alpha,beta,n)/mW
		gd_L  = ve+ae
		gd_R  = ve-ae
	endif

	Gam1_HpWZ_fermion=&
		g**2*gz/(16.d0*pi**2)*(&
		-mu*gHp_L*gd_L*(b0f(p2sq,md,md)-2.d0*c24f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq+p1sq-p2sq+2.d0*mu**2)/2.d0*c0f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq+3.d0*p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq-p1sq)*c12f(p1sq,p2sq,qsq,mu,md,md))&
		+mu*md**2*gHp_L*gd_R*c0f(p1sq,p2sq,qsq,mu,md,md)&
		-md*gHp_R*gd_L*(b0f(p2sq,md,md)-2.d0*c24f(p1sq,p2sq,qsq,mu,md,md)&
			+mu**2*c0f(p1sq,p2sq,qsq,mu,md,md)&
			+p1sq*c11f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq-p1sq-p2sq)/2.d0*c12f(p1sq,p2sq,qsq,mu,md,md))&
		+md*gHp_R*gd_R*(b0f(p2sq,md,md)+mu**2*c0f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq+p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq-p1sq+p2sq)/2.d0*c12f(p1sq,p2sq,qsq,mu,md,md))&
		!
		-md*gHp_R*gu_L*(b0f(p2sq,mu,mu)-2.d0*c24f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq+p1sq-p2sq+2.d0*md**2)/2.d0*c0f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq+3.d0*p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq-p1sq)*c12f(p1sq,p2sq,qsq,md,mu,mu))&
		+md*mu**2*gHp_R*gu_R*c0f(p1sq,p2sq,qsq,md,mu,mu)&
		-mu*gHp_L*gu_L*(b0f(p2sq,mu,mu)-2.d0*c24f(p1sq,p2sq,qsq,md,mu,mu)&
			+md**2*c0f(p1sq,p2sq,qsq,md,mu,mu)&
			+p1sq*c11f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq-p1sq-p2sq)/2.d0*c12f(p1sq,p2sq,qsq,md,mu,mu))&
		+mu*gHp_L*gu_R*(b0f(p2sq,mu,mu)+md**2*c0f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq+p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq-p1sq+p2sq)/2.d0*c12f(p1sq,p2sq,qsq,md,mu,mu))&
		)

	end function
!-----------------------------------------------------------------     
	complex (kind(0d0)) function Gam2_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in)::n
	double precision:: gHp_L,gHp_R,gu_L,gu_R,gd_L,gd_R

	if (mu == mt .or. mu == mc) then
		gHp_L = mu*xiu_A(alpha,beta,n)/mW
		gu_L  = vt+at
		gu_R  = vt-at
	elseif (mu == 0.d0) then
		gHp_L = 0.d0
		gu_L  = 0.5d0
		gu_R  = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = -md*xid_A(alpha,beta,n)/mW
		gd_L  = vb+ab
		gd_R  = vb-ab
	elseif (md == mtau .or. md == mmu) then
		gHp_R = -md*xil_A(alpha,beta,n)/mW
		gd_L  = ve+ae
		gd_R  = ve-ae
	endif

	Gam2_HpWZ_fermion=&
		g**2*gz/16.d0/pi**2*(&
		+mu*gHp_L*gd_L*(c11f(p1sq,p2sq,qsq,mu,md,md)&
			+2.d0*c12f(p1sq,p2sq,qsq,mu,md,md)+c0f(p1sq,p2sq,qsq,mu,md,md)&
			+2.d0*c23f(p1sq,p2sq,qsq,mu,md,md))&
		+md*gHp_R*gd_L*(c12f(p1sq,p2sq,qsq,mu,md,md)&
			+2.d0*c23f(p1sq,p2sq,qsq,mu,md,md))&
		-md*gHp_R*gd_R*(c11f(p1sq,p2sq,qsq,mu,md,md)&
			-c12f(p1sq,p2sq,qsq,mu,md,md))&
		!
		+md*gHp_R*gu_L*(c11f(p1sq,p2sq,qsq,md,mu,mu)&
			+2.d0*c12f(p1sq,p2sq,qsq,md,mu,mu)+c0f(p1sq,p2sq,qsq,md,mu,mu)&
			+2.d0*c23f(p1sq,p2sq,qsq,md,mu,mu))&
		+mu*gHp_L*gu_L*(c12f(p1sq,p2sq,qsq,md,mu,mu)&
			+2.d0*c23f(p1sq,p2sq,qsq,md,mu,mu))&
		-mu*gHp_L*gu_R*(c11f(p1sq,p2sq,qsq,md,mu,mu)&
			-c12f(p1sq,p2sq,qsq,md,mu,mu))&
		)

	end function
!-----------------------------------------------------------------     
	complex (kind(0d0)) function Gam3_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in)::n
	double precision:: gHp_L,gHp_R,gu_L,gu_R,gd_L,gd_R

	if (mu == mt .or. mu == mc) then
		gHp_L = mu*xiu_A(alpha,beta,n)/mW
		gu_L  = vt+at
		gu_R  = vt-at
	elseif (mu == 0.d0) then
		gHp_L = 0.d0
		gu_L  = 0.5d0
		gu_R  = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = -md*xid_A(alpha,beta,n)/mW
		gd_L  = vb+ab
		gd_R  = vb-ab
	elseif (md == mtau .or. md == mmu) then
		gHp_R = -md*xil_A(alpha,beta,n)/mW
		gd_L  = ve+ae
		gd_R  = ve-ae
	endif

	Gam3_HpWZ_fermion=&
		-g**2*gz/16.d0/pi**2*(&
		+mu*gHp_L*gd_L*(c0f(p1sq,p2sq,qsq,mu,md,md)+c11f(p1sq,p2sq,qsq,mu,md,md))&
		+md*gHp_R*gd_L*c12f(p1sq,p2sq,qsq,mu,md,md)&
		+md*gHp_R*gd_R*(c11f(p1sq,p2sq,qsq,mu,md,md)-c12f(p1sq,p2sq,qsq,mu,md,md))&
		!
		-md*gHp_R*gu_L*(c0f(p1sq,p2sq,qsq,md,mu,mu)+c11f(p1sq,p2sq,qsq,md,mu,mu))&
		-mu*gHp_L*gu_L*c12f(p1sq,p2sq,qsq,md,mu,mu)&
		-mu*gHp_L*gu_R*(c11f(p1sq,p2sq,qsq,md,mu,mu)-c12f(p1sq,p2sq,qsq,md,mu,mu))&
	)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam1_HpWZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam1_HpWZ_F=&
		+Nc*Gam1_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam1_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam1_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mtau)&
		+Gam1_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam2_HpWZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam2_HpWZ_F=&
		+Nc*Gam2_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam2_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam2_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mtau)&
		+Gam2_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam3_HpWZ_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam3_HpWZ_F=&
		+Nc*Gam3_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam3_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam3_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mtau)&
		+Gam3_HpWZ_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam1_HpWZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam1_HpWZ_B=&
		g*gz/vev/(16.d0*pi**2)*(&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)&
			*c24f(p1sq,p2sq,qsq,mch,mA,mbH)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)&
			*c24f(p1sq,p2sq,qsq,mch,mA,mh)&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)&
			*(cw**2-sw**2)*c24f(p1sq,p2sq,qsq,mbH,mch,mch)&
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)&
			*(cw**2-sw**2)*c24f(p1sq,p2sq,qsq,mh,mch,mch)&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mA**2)&
			*c24f(p1sq,p2sq,qsq,mw,mh,mA)&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mA**2)&
			*c24f(p1sq,p2sq,qsq,mw,mbH,mA)&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)&
			*c24f(p1sq,p2sq,qsq,mw,mz,mh)&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)&
			*c24f(p1sq,p2sq,qsq,mw,mz,mbH)&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)&
			*(cw**2-sw**2)*c24f(p1sq,p2sq,qsq,mh,mw,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)&
			*(cw**2-sw**2)*c24f(p1sq,p2sq,qsq,mbH,mw,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*c24f(p1sq,p2sq,qsq,mW,mbH,mA)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*c24f(p1sq,p2sq,qsq,mW,mh,mA)&
		+sin(beta-alpha)*cos(beta-alpha)*(cw**2-sw**2)*mZ**2&
	  		*c24f(p1sq,p2sq,qsq,mch,mh,mZ)&
		-sin(beta-alpha)*cos(beta-alpha)*(cw**2-sw**2)*mZ**2&
	  		*c24f(p1sq,p2sq,qsq,mch,mbH,mZ)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2&
	  		*c24f(p1sq,p2sq,qsq,mh,mw,mW)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2&
	  		*c24f(p1sq,p2sq,qsq,mbH,mw,mW)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2*(mch**2-mh**2)&
	  		*c0f(p1sq,p2sq,qsq,mh,mW,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2*(mch**2-mbH**2)&
	  		*c0f(p1sq,p2sq,qsq,mbH,mW,mw)&
		-sin(beta-alpha)*cos(beta-alpha)*mZ**2*sw**2*(mch**2-mh**2)&
	  		*c0f(p1sq,p2sq,qsq,mw,mZ,mh)&
		+sin(beta-alpha)*cos(beta-alpha)*mZ**2*sw**2*(mch**2-mbH**2)&
	  		*c0f(p1sq,p2sq,qsq,mw,mZ,mbH)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*(-b0f(p2sq,mZ,mbH)+c24f(p1sq,p2sq,qsq,mW,mZ,mbH)&
			-(qsq+3.d0*p1sq-p2sq)*c11f(p1sq,p2sq,qsq,mW,mZ,mbH)&
			-2.d0*(qsq-p1sq)*c12f(p1sq,p2sq,qsq,mW,mZ,mbH)&
			-(2.d0*qsq+2.d0*p1sq-2.d0*p2sq+mW**2)*c0f(p1sq,p2sq,qsq,mW,mZ,mbH))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*(-b0f(p2sq,mZ,mh)+c24f(p1sq,p2sq,qsq,mW,mZ,mh)&
			-(qsq+3.d0*p1sq-p2sq)*c11f(p1sq,p2sq,qsq,mW,mZ,mh)&
			-2.d0*(qsq-p1sq)*c12f(p1sq,p2sq,qsq,mW,mZ,mh)&
			-(2.d0*qsq+2.d0*p1sq-2.d0*p2sq+mW**2)*c0f(p1sq,p2sq,qsq,mW,mZ,mh))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2*cw**2&
			*(-b0f(p2sq,mW,mW)+c24f(p1sq,p2sq,qsq,mbH,mW,mW)&
			+(qsq-p1sq-p2sq)*c11f(p1sq,p2sq,qsq,mbH,mW,mW)&
			+2.d0*p2sq*c12f(p1sq,p2sq,qsq,mbH,mW,mW)&
			+(p1sq-p2sq-mbH**2)*c0f(p1sq,p2sq,qsq,mbH,mW,mW))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2*cw**2&
			*(-b0f(p2sq,mW,mW)+c24f(p1sq,p2sq,qsq,mh,mW,mW)&
			+(qsq-p1sq-p2sq)*c11f(p1sq,p2sq,qsq,mh,mW,mW)&
			+2.d0*p2sq*c12f(p1sq,p2sq,qsq,mh,mW,mW)&
			+(p1sq-p2sq-mh**2)*c0f(p1sq,p2sq,qsq,mh,mW,mW))&
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)*sw**2/2.d0&
			*b0f(mch**2,mh,mch)&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)*sw**2/2.d0&
			*b0f(mch**2,mbH,mch)&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)*sw**2/2.d0&
			*b0f(mch**2,mh,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)*sw**2/2.d0&
			*b0f(mch**2,mbH,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2&
			*b0f(mW**2,mW,mh)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2&
			*b0f(mW**2,mW,mbH)&
		+sin(beta-alpha)*cos(beta-alpha)*mZ**2*sw**2&
			*b0f(mZ**2,mZ,mh)&
		-sin(beta-alpha)*cos(beta-alpha)*mZ**2*sw**2&
			*b0f(mZ**2,mZ,mbH)&
		)

	end function
!-----------------------------------------------------------------     
	complex (kind(0d0)) function Gam2_HpWZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam2_HpWZ_B=&
		g*gz/vev/(16.d0*pi**2)*(&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)&
			*(c12f(p1sq,p2sq,qsq,mch,mA,mbH)+c23f(p1sq,p2sq,qsq,mch,mA,mbH))&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)&
			*(c12f(p1sq,p2sq,qsq,mch,mA,mh)+c23f(p1sq,p2sq,qsq,mch,mA,mh))&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)&
			*(cw**2-sw**2)*(c12f(p1sq,p2sq,qsq,mbH,mch,mch)&
			+c23f(p1sq,p2sq,qsq,mbH,mch,mch))&
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)&
			*(cw**2-sw**2)*(c12f(p1sq,p2sq,qsq,mh,mch,mch)&
			+c23f(p1sq,p2sq,qsq,mh,mch,mch))&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mA**2)&
			*(c12f(p1sq,p2sq,qsq,mw,mh,mA)+c23f(p1sq,p2sq,qsq,mw,mh,mA))&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mA**2)&
			*(c12f(p1sq,p2sq,qsq,mw,mbH,mA)+c23f(p1sq,p2sq,qsq,mw,mbH,mA))&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)&
			*(c12f(p1sq,p2sq,qsq,mw,mz,mh)+c23f(p1sq,p2sq,qsq,mw,mz,mh))&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)&
			*(c12f(p1sq,p2sq,qsq,mw,mz,mbH)+c23f(p1sq,p2sq,qsq,mw,mz,mbH))&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)*(cw**2-sw**2)&
			*(c12f(p1sq,p2sq,qsq,mh,mw,mw)+c23f(p1sq,p2sq,qsq,mh,mw,mw))&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)&
			*(cw**2-sw**2)*(c12f(p1sq,p2sq,qsq,mbH,mw,mw)&
			+c23f(p1sq,p2sq,qsq,mbH,mw,mw))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*(2.d0*c0f(p1sq,p2sq,qsq,mW,mbH,mA)&
			+2.d0*c11f(p1sq,p2sq,qsq,mW,mbH,mA)+c12f(p1sq,p2sq,qsq,mW,mbH,mA)&
			+c23f(p1sq,p2sq,qsq,mW,mbH,mA))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*(2.d0*c0f(p1sq,p2sq,qsq,mW,mh,mA)&
			+2.d0*c11f(p1sq,p2sq,qsq,mW,mh,mA)+c12f(p1sq,p2sq,qsq,mW,mh,mA)&
			+c23f(p1sq,p2sq,qsq,mW,mh,mA))&
		-sin(beta-alpha)*cos(beta-alpha)*mZ**2*(cw**2-sw**2)&
			*(c23f(p1sq,p2sq,qsq,mch,mbH,mZ)-c12f(p1sq,p2sq,qsq,mch,mbH,mZ))&
		+sin(beta-alpha)*cos(beta-alpha)*mZ**2*(cw**2-sw**2)&
			*(c23f(p1sq,p2sq,qsq,mch,mh,mZ)-c12f(p1sq,p2sq,qsq,mch,mh,mZ))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2&
	  		*(c23f(p1sq,p2sq,qsq,mh,mw,mW)-c12f(p1sq,p2sq,qsq,mh,mw,mW))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2*sw**2&
	  		*(c23f(p1sq,p2sq,qsq,mbH,mw,mW)-c12f(p1sq,p2sq,qsq,mbH,mw,mW))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*(2.d0*c0f(p1sq,p2sq,qsq,mW,mZ,mbH)&
			-2.d0*c11f(p1sq,p2sq,qsq,mW,mZ,mbH)&
			+5.d0*c12f(p1sq,p2sq,qsq,mW,mZ,mbH)&
			+c23f(p1sq,p2sq,qsq,mW,mZ,mbH))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2&
			*(2.d0*c0f(p1sq,p2sq,qsq,mW,mZ,mh)&
			-2.d0*c11f(p1sq,p2sq,qsq,mW,mZ,mh)&
			+5.d0*c12f(p1sq,p2sq,qsq,mW,mZ,mh)&
			+c23f(p1sq,p2sq,qsq,mW,mZ,mh))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2*cw**2&
			*(c23f(p1sq,p2sq,qsq,mbH,mW,mW)&
			+3.d0*c12f(p1sq,p2sq,qsq,mbH,mW,mW)&
			-4.d0*c11f(p1sq,p2sq,qsq,mbH,mW,mW))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2*cw**2&
			*(c23f(p1sq,p2sq,qsq,mh,mW,mW)&
			+3.d0*c12f(p1sq,p2sq,qsq,mh,mW,mW)&
			-4.d0*c11f(p1sq,p2sq,qsq,mh,mW,mW))&
		)

	end function
!-----------------------------------------------------------------     
	complex (kind(0d0)) function Gam3_HpWZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam3_HpWZ_B = 0.d0

	end function
!---------------------------------------------------------------
!     HpWZ renormalized vertex functions at EW 1-loop level
!---------------------------------------------------------------
	complex (kind(0d0)) function	rGam1_HpWZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam1_HpWZ=&
		+Gam1_HpWZ_F(mW**2,mZ**2,mch**2,alpha,beta,n)&
		+g*gz*vev*sw**2*tildePiHpGm_F(mch**2,alpha,beta,n)/2.d0/mch**2&

		+Gam1_HpWZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		+g*gz*vev*sw**2*tildePiHpGm_B(mch**2,mch,mA,mbH,bmsq,alpha,beta)/2.d0/mch**2

   end function
!-----------------------------------------------------------------                                    
	complex (kind(0d0)) function	rGam2_HpWZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam2_HpWZ=&
		+Gam2_HpWZ_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+Gam2_HpWZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

   end function
!-----------------------------------------------------------------                                    
	complex (kind(0d0)) function	rGam3_HpWZ(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam3_HpWZ=&
		+Gam3_HpWZ_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+Gam3_HpWZ_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	
	end function
!-------------------------------------------------------------
!     HpWgam 1PI vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function Gam1_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in)::n
	double precision:: gHp_L,gHp_R,Qu,Qd

	if (mu == mt .or. mu == mc) then
		gHp_L = mu*xiu_A(alpha,beta,n)/mW
		Qu = Qt
	elseif (mu == 0.d0) then
		gHp_L = 0.d0
		Qu = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = -md*xid_A(alpha,beta,n)/mW
		Qd = Qb
	elseif (md == mtau .or. md == mmu) then
		gHp_R = -md*xil_A(alpha,beta,n)/mW
		Qd = Qe
	endif

	Gam1_HpWgam_fermion=&
		Qd*g**3*sw/(16.d0*pi**2)*(&
		-mu*gHp_L*(b0f(p2sq,md,md)-2.d0*c24f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq+p1sq-p2sq+2.d0*mu**2-2.d0*md**2)/2.d0*c0f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq+3.d0*p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,mu,md,md)&
			+(qsq-p1sq)*c12f(p1sq,p2sq,qsq,mu,md,md))&
		-md*gHp_R*(-2.d0*c24f(p1sq,p2sq,qsq,mu,md,md)&
			-(qsq-p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,mu,md,md)))&
!
		+Qu*g**3*sw/(16.d0*pi**2)*(&
		-md*gHp_R*(b0f(p2sq,mu,mu)-2.d0*c24f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq+p1sq-p2sq+2.d0*md**2-2.d0*mu**2)/2.d0*c0f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq+3.d0*p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,md,mu,mu)&
			+(qsq-p1sq)*c12f(p1sq,p2sq,qsq,md,mu,mu))&
		-mu*gHp_L*(-2.d0*c24f(p1sq,p2sq,qsq,md,mu,mu)&
			-(qsq-p1sq-p2sq)/2.d0*c11f(p1sq,p2sq,qsq,md,mu,mu)))

	end function
!-----------------------------------------------------------------     
	complex (kind(0d0)) function Gam2_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in)::n
	double precision:: gHp_L,gHp_R,Qu,Qd

	if (mu == mt .or. mu == mc) then
		gHp_L = mu*xiu_A(alpha,beta,n)/mW
		Qu = Qt
	elseif (mu == 0.d0) then
		gHp_L = 0.d0
		Qu = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = -md*xid_A(alpha,beta,n)/mW
		Qd = Qb
	elseif (md == mtau .or. md == mmu) then
		gHp_R = -md*xil_A(alpha,beta,n)/mW
		Qd = Qe
	endif

	Gam2_HpWgam_fermion=&
		Qd*g**3*sw/(16.d0*pi**2)*(&
		+mu*gHp_L*(c11f(p1sq,p2sq,qsq,mu,md,md)&
			+2.d0*c12f(p1sq,p2sq,qsq,mu,md,md)+c0f(p1sq,p2sq,qsq,mu,md,md)&
			+2.d0*c23f(p1sq,p2sq,qsq,mu,md,md))&
		-md*gHp_R*(c11f(p1sq,p2sq,qsq,mu,md,md)&
			-2.d0*c12f(p1sq,p2sq,qsq,mu,md,md)&
			-2.d0*c23f(p1sq,p2sq,qsq,mu,md,md)))&
!
		+Qu*g**3*sw/(16.d0*pi**2)*(&
		+md*gHp_R*(c11f(p1sq,p2sq,qsq,md,mu,mu)&
			+2.d0*c12f(p1sq,p2sq,qsq,md,mu,mu)+c0f(p1sq,p2sq,qsq,md,mu,mu)&
			+2.d0*c23f(p1sq,p2sq,qsq,md,mu,mu))&
		-mu*gHp_L*(c11f(p1sq,p2sq,qsq,md,mu,mu)&
			-2.d0*c12f(p1sq,p2sq,qsq,md,mu,mu)&
			-2.d0*c23f(p1sq,p2sq,qsq,md,mu,mu)))

	end function
!-----------------------------------------------------------------  
	complex (kind(0d0)) function Gam3_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mu,md)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta,mu,md
	integer, intent(in)::n
	double precision:: gHp_L,gHp_R,Qu,Qd

	if (mu == mt .or. mu == mc) then
		gHp_L = mu*xiu_A(alpha,beta,n)/mW
		Qu = Qt
	elseif (mu == 0.d0) then
		gHp_L = 0.d0
		Qu = 0.d0
	endif

	if (md == mb .or. md == ms) then
		gHp_R = -md*xid_A(alpha,beta,n)/mW
		Qd = Qb
	elseif (md == mtau .or. md == mmu) then
		gHp_R = -md*xil_A(alpha,beta,n)/mW
		Qd = Qe
	endif

	Gam3_HpWgam_fermion=&
		-Qd*g**3*sw/(16.d0*pi**2)*(&
		mu*gHp_L*(c0f(p1sq,p2sq,qsq,mu,md,md)+c11f(p1sq,p2sq,qsq,mu,md,md))&
		+md*gHp_R*c11f(p1sq,p2sq,qsq,mu,md,md))&
!
		+Qu*g**3*sw/(16.d0*pi**2)*(&
		md*gHp_R*(c0f(p1sq,p2sq,qsq,md,mu,mu)+c11f(p1sq,p2sq,qsq,md,mu,mu))&
		+mu*gHp_L*c11f(p1sq,p2sq,qsq,md,mu,mu))

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam1_HpWgam_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam1_HpWgam_F=&
		+Nc*Gam1_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+Nc*Gam1_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam1_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mtau)&
		+Gam1_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam2_HpWgam_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam2_HpWgam_F=&
		nc*Gam2_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+nc*Gam2_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam2_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mtau)&
		+Gam2_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam3_HpWgam_F(p1sq,p2sq,qsq,alpha,beta,n)
	double precision, intent(in):: p1sq,p2sq,qsq,alpha,beta
	integer, intent(in)::n

	Gam3_HpWgam_F=&
		nc*Gam3_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mt,mb)&
		+nc*Gam3_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,mc,ms)&
		+Gam3_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mtau)&
		+Gam3_HpWgam_fermion(p1sq,p2sq,qsq,alpha,beta,n,0.d0,mmu)

	end function
!-----------------------------------------------------------------
	complex (kind(0d0)) function Gam1_HpWgam_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam1_HpWgam_B=&
		2.d0*g**2*sw/vev/(16.d0*pi**2)*(&
		+lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)&
			*c24f(p1sq,p2sq,qsq,mbH,mch,mch)&
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)&
			*c24f(p1sq,p2sq,qsq,mh,mch,mch)&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)&
			*c24f(p1sq,p2sq,qsq,mbH,mw,mw)&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)&
			*c24f(p1sq,p2sq,qsq,mh,mw,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*c24f(p1sq,p2sq,qsq,mbH,mw,mW)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*c24f(p1sq,p2sq,qsq,mh,mw,mW)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2*(mch**2-mbH**2)/2.d0&
	  		*c0f(p1sq,p2sq,qsq,mbH,mW,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2*(mch**2-mh**2)/2.d0&
	  		*c0f(p1sq,p2sq,qsq,mh,mW,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*(-b0f(p2sq,mW,mW)+c24f(p1sq,p2sq,qsq,mbH,mW,mW)&
			+(qsq-p1sq-p2sq)*c11f(p1sq,p2sq,qsq,mbH,mW,mW)&
			+2.d0*p2sq*c12f(p1sq,p2sq,qsq,mbH,mW,mW)&
			+(p1sq-p2sq-mbH**2)*c0f(p1sq,p2sq,qsq,mbH,mW,mW))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*(-b0f(p2sq,mW,mW)+c24f(p1sq,p2sq,qsq,mh,mW,mW)&
			+(qsq-p1sq-p2sq)*c11f(p1sq,p2sq,qsq,mh,mW,mW)&
			+2.d0*p2sq*c12f(p1sq,p2sq,qsq,mh,mW,mW)&
			+(p1sq-p2sq-mh**2)*c0f(p1sq,p2sq,qsq,mh,mW,mW))&
		-lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)/4.d0&
			*b0f(mch**2,mbH,mch)&
		+lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)/4.d0&
			*b0f(mch**2,mh,mch)&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)/4.d0&
			*b0f(mch**2,mbH,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)/4.d0&
			*b0f(mch**2,mh,mw)&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*b0f(mW**2,mW,mbH)&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*b0f(mW**2,mW,mh)&
		)

	end function
!-----------------------------------------------------------------     
	complex (kind(0d0)) function Gam2_HpWgam_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam2_HpWgam_B=&
		2.d0*g**2*sw/vev/(16.d0*pi**2)*(&
		lam_HpHmbH(mch,mA,mbH,bmsq,alpha,beta)*vev*sin(beta-alpha)&
			*(c12f(p1sq,p2sq,qsq,mbH,mch,mch)+c23f(p1sq,p2sq,qsq,mbH,mch,mch))&
		-lam_HpHmh(mch,mA,mbH,bmsq,alpha,beta)*vev*cos(beta-alpha)&
			*(c12f(p1sq,p2sq,qsq,mh,mch,mch)+c23f(p1sq,p2sq,qsq,mh,mch,mch))&
		+sin(beta-alpha)*cos(beta-alpha)*(mch**2-mbH**2)&
			*(c12f(p1sq,p2sq,qsq,mbH,mw,mw)+c23f(p1sq,p2sq,qsq,mbH,mw,mw))&
		-sin(beta-alpha)*cos(beta-alpha)*(mch**2-mh**2)&
			*(c12f(p1sq,p2sq,qsq,mh,mw,mw)+c23f(p1sq,p2sq,qsq,mh,mw,mw))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
	  		*(c23f(p1sq,p2sq,qsq,mbH,mw,mW)-c12f(p1sq,p2sq,qsq,mbH,mw,mW))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
	  		*(c23f(p1sq,p2sq,qsq,mh,mw,mW)-c12f(p1sq,p2sq,qsq,mh,mw,mW))&
		-sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*(4.d0*c11f(p1sq,p2sq,qsq,mbH,mW,mW)&
			-3.d0*c12f(p1sq,p2sq,qsq,mbH,mW,mW)&
			-c23f(p1sq,p2sq,qsq,mbH,mW,mW))&
		+sin(beta-alpha)*cos(beta-alpha)*mW**2/2.d0&
			*(4.d0*c11f(p1sq,p2sq,qsq,mh,mW,mW)&
			-3.d0*c12f(p1sq,p2sq,qsq,mh,mW,mW)&
			-c23f(p1sq,p2sq,qsq,mh,mW,mW))&
		)

	end function
!-----------------------------------------------------------------     
	complex (kind(0d0)) function Gam3_HpWgam_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta

	Gam3_HpWgam_B = 0.d0

	end function
!-------------------------------------------------------------
!     HpWgam renormalized vertex functions at EW 1-loop level
!-------------------------------------------------------------
	complex (kind(0d0)) function	rGam1_HpWgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam1_HpWgam=&
		+Gam1_HpWgam_F(p1sq,p2sq,qsq,alpha,beta,n)&
		-g*sw*mW/mch**2*tildePiHpGm_F(mch**2,alpha,beta,n)&
		!
		+Gam1_HpWgam_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)&
		-g*sw*mW/mch**2*tildePiHpGm_B(mch**2,mch,mA,mbH,bmsq,alpha,beta)

	end function
!-----------------------------------------------------------------                                    
	complex (kind(0d0)) function	rGam2_HpWgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam2_HpWgam=&
		+Gam2_HpWgam_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+Gam2_HpWgam_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!-----------------------------------------------------------------                                    
	complex (kind(0d0)) function	rGam3_HpWgam(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in):: qsq,p1sq,p2sq,mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rGam3_HpWgam=&
		+Gam3_HpWgam_F(p1sq,p2sq,qsq,alpha,beta,n)&
		+Gam3_HpWgam_B(p1sq,p2sq,qsq,mch,mA,mbH,bmsq,alpha,beta)

	end function
!#########################################################
!#
!#     Decay of top quark
!#
!#########################################################
!=====Two body decay=====
	double precision function gam_tchb(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmb
	double precision:: Csch,Cpch
	p1sq=mch**2; p2sq=mb**2; qsq=mt**2
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	if(mt .lt. mch+mb) then
		gam_tchb=0.d0
		return
	endif

	mu = mt
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif

	nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt

	rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mt,5.d0),mt_MS)
	rmb = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mb,5.d0),mb_MS)

	Csch=((mb+S_RMSM*(rmb-mb))*xid_A(alpha,beta,n)-(mt+S_RMSM*(rmt-mt))*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)
	Cpch=((mb+S_RMSM*(rmb-mb))*xid_A(alpha,beta,n)+(mt+S_RMSM*(rmt-mt))*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)

	gam_tchb=mt/(16.d0*pi)*Vtb**2*(1.d0-mch**2/mt**2)**2*(Csch**2+Cpch**2)*(&
! LO
	+1.d0&
! NLO Weak correction
!	*S_NLOEW&
! NLO  QED correction
!	*S_NLOEW&
! NLO  QCD correction
!	*S_NLOQCD&
! NNLO  QCD correction
!	*S_NNLOQCD
	)

	end function
!-------------------------------------------------------------------
	double precision function gam_tchs(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rms
	double precision:: Csch,Cpch
	p1sq=mch**2; p2sq=ms**2; qsq=mt**2
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	if(mt .lt. mch+ms) then
		gam_tchs=0.d0
		return
	endif

	mu = mt
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif

	nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt

	rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mt,5.d0),mt_MS)
	rms = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD3,ms,3.d0),ms_MS)

	Csch=((ms+S_RMSM*(rms-ms))*xid_A(alpha,beta,n)-(mt+S_RMSM*(rmt-mt))*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)
	Cpch=((ms+S_RMSM*(rms-ms))*xid_A(alpha,beta,n)+(mt+S_RMSM*(rmt-mt))*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)

	gam_tchs=mt/(16.d0*pi)*Vts**2*(1.d0-mch**2/mt**2)**2*(Csch**2+Cpch**2)*(&
! LO
	+1.d0&
! NLO Weak correction
!	*S_NLOEW&
! NLO  QED correction
!	*S_NLOEW&
! NLO  QCD correction
!	*S_NLOQCD&
! NNLO  QCD correction
!	*S_NNLOQCD
	)

	end function
!-------------------------------------------------------------------
	double precision function gam_tchd(mch,mA,mbH,bmsq,alpha,beta,n,OREW,ORQCD)
	double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in):: n
	integer, intent(in):: OREW,ORQCD
	double precision:: S_NLOEW,S_NLOQCD,S_NNLOQCD,S_RMSM
	double precision:: p1sq,p2sq,qsq
	double precision:: mu,nf,lam_QCD,rmt,rmd
	double precision:: Csch,Cpch
	p1sq=mch**2; p2sq=md**2; qsq=mt**2
	call Switch_HOEW(OREW,S_NLOEW)
	call Switch_HOQCD(ORQCD,S_NLOQCD,S_NNLOQCD,S_RMSM)

	if(mt .lt. mch+md) then
		gam_tchd=0.d0
		return
	endif

	mu = mt
	if(mt .lt. mu) then
		nf=6.d0; lam_QCD=lam_QCD6 !When mt<mch
	else if(mu .le. mt) then
		nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt
	endif

	nf=5.d0; lam_QCD=lam_QCD5 !When mb<mch<=mt

	rmt = mq_bar(mu,alphas(lam_QCD,mu,nf),alphas(lam_QCD5,mt,5.d0),mt_MS)
	rmd = 0.d0

	Csch=((md+S_RMSM*(rmd-md))*xid_A(alpha,beta,n)-(mt+S_RMSM*(rmt-mt))*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)
	Cpch=((md+S_RMSM*(rmd-md))*xid_A(alpha,beta,n)+(mt+S_RMSM*(rmt-mt))*xiu_A(alpha,beta,n))/(sqrt(2.d0)*vev)

	gam_tchd=mt/(16.d0*pi)*Vtd**2*(1.d0-mch**2/mt**2)**2*(Csch**2+Cpch**2)*(&
! LO
	+1.d0&
! NLO Weak correction
!	*S_NLOEW&
! NLO  QED correction
!	*S_NLOEW&
! NLO  QCD correction
!	*S_NLOQCD&
! NNLO  QCD correction
!	*S_NNLOQCD
	)

	end function
!########################################################## 
!                
!    SECTION VI OTHER QUANTITIES  
! 
!##########################################################
!--------------------------------------------  
       complex (kind(0d0)) function rPiWW(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq
       double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n

        rPiWW = PiWW_F(qsq) + PiWW_B(qsq,mch,mA,mbH,bmsq,alpha,beta)- PiWW_pinch(qsq) &
              - (del_mWsq_F(alpha,beta,n)+del_mWsq_B(mch,mA,mbH,bmsq,alpha,beta)) &
              + (qsq-mW**2)*(del_ZW_F(alpha,beta,n)+del_ZW_B(mch,mA,mbH,bmsq,alpha,beta) )

         end function
!-------------------------------------------- 
       complex (kind(0d0)) function rdPiZZ(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq
       double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n

        rdPiZZ = &
                  dPiZZ_F(qsq)+dPiZZ_B(qsq,mch,mA,mbH,bmsq,alpha,beta)-dPiZZ_pinch(qsq)&
                  + del_ZZ_F(alpha,beta,n)+del_ZZ_B(mch,mA,mbH,bmsq,alpha,beta)

         end function
!----------- renormalized dPiWW function ---------- 
       complex (kind(0d0)) function rdPiWW(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n
        rdPiWW = dPiWW_F(qsq)+dPiWW_B(qsq,mch,mA,mbH,bmsq,alpha,beta)-dPiWW_pinch(qsq) &
                   +del_ZW_F(alpha,beta,n)+del_ZW_B(mch,mA,mbH,bmsq,alpha,beta)

         end function
!-------------------------------------------- 
       double precision function Del_r(mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n

        Del_r = rPiWW(0.d0,mch,mA,mbH,bmsq,alpha,beta,n)/mW**2 &
                 + alpha_em/(4.d0*pi*sw**2)*(6.d0 + (7.d0-4.d0*sw**2)/(2.d0*sw**2)*log(cw**2))

         end function
!-------------------------------------------- 
       complex (kind(0d0)) function rPiZZ(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n

       rPiZZ= PiZZ_F(qsq)+PiZZ_B(qsq,mch,mA,mbH,bmsq,alpha,beta)-PiZZ_pinch(qsq)&
            -del_mZsq_F(alpha,beta,n)-del_mZsq_B(mch,mA,mbH,bmsq,alpha,beta)&
       +(del_ZZ_F(alpha,beta,n)+del_ZZ_B(mch,mA,mbH,bmsq,alpha,beta))*(qsq-mZ**2)
       end function
!-------------------------------------------------------------- 
       complex (kind(0d0)) function rPiZG(qsq,mch,mA,mbH,bmsq,alpha,beta,n)
       double precision, intent(in):: qsq,mch,mA,mbH,bmsq,alpha,beta
       integer, intent(in)::n


        rPiZG= PiZG_F(qsq)+PiZG_B(qsq,mch,mA,mbH,bmsq,alpha,beta)-PiZG_pinch(qsq)& 
              -PiZG_F(0.d0)-PiZG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)+PiZG_pinch(0.d0)& 
              +qsq*(del_swsq(mch,mA,mbH,bmsq,alpha,beta,n)/(sw*cw)&
              +2.d0/mZ**2*(PiZG_F(0.d0)+PiZG_B(0.d0,mch,mA,mbH,bmsq,alpha,beta)-PiZG_pinch(0.d0)) )

       end function
!--------------------------------- 
	double precision function rmW(mch,mA,mbH,bmsq,alpha,beta,n)
	double precision, intent(in)::mch,mA,mbH,bmsq,alpha,beta
	integer, intent(in)::n

	rmW =&
		sqrt(&
			mZ**2/2.d0*(&
				1.d0+sqrt(&
					1.d0-4.d0*pi*alpha_em/(sqrt(2.d0)*G_f*mZ**2*(1.d0-Del_r(mch,mA,mbH,bmsq,alpha,beta,n)))&
				)&
			)&
		)

	end function

end subroutine HCOUP_THDM